25 March 2008, eaton

Running gnumake in this directory will create an executable named
"interpic".  Its function is to take an input CAM history or initial file
and interpolate all time samples to a new horizontal and/or vertical
resolution.

The output resolution is determined by the coordinates in a template netcdf
file ("-t template_file").  Previously made coordinate files are located in 
inputdata/atm/cam/coords.  If a coordinate for a field in the input file
exists in the template file (the coordinate must have the same name in both
files), then the field that appears in the output file will be interpolated
from the input file coordinate to the template file coordinate.  By default
all fields contained in the input file are interpolated and written to the
output file.

Certain variable names are hardwired into the interpic code and are
automatically recognized as variables that contain coordinate information.
The variable names are: rlon, nlon, wnummax, hyai, hybi, hyam, hybm, gw,
w_stag, lat, lon, slat, slon, lev, ilev.

The code assumes that the netCDF conventions for coordinate variables have
been followed, i.e., the dimension of a 1D coordinate variable has the same
name as the associated variable.  This means that the following dimension
names which are hardwired into the code are also treated specially: lon,
slon, lat, slat, lev, ilev, time.  In addition, the extension of the code
to treat unstructured grids added the dimension name "ncol" to identify the
dimension of the global column indices.


This code will eventually replace the original version of interpic.  It is,
however, still missing some functionality:

. If interpolating to a staggered grid, the input dataset must be on a
  staggered grid.  The original code had hardwired logic to allow
  interpolating from a Gauss grid to a staggered grid.  The current code
  assumes the dimension names of the output grid are the same as the input
  grid.  It's missing the special logic to allow the lat dimension of V to
  become the slat dimension of VS (and similar for U --> US).

It has been generalized as follows:

. Can produce non-rectangular grids for output, e.g. cubed sphere grid.

. No longer requires separate steps to produce a template file containing
  the desired fields declared on the desire output grid.  The user just
  supplies a template file containing the desired output grid.

. The output precision may optionally be reduced to real*4 when the input
  data is real*8 (see commandline option -p).  The precision override does
  not apply to the coordinate variables which are always output as real*8.

. Fields from the input file may optionally be excluded from the output
  file (see commandline option -e).

. Fields from the template file may optionally be included on the output
  file (see commandline option -i).


There are round-off level differences with the original interpic code due
to changes in the interpolation routine.


SE Note: 

If a CAM-SE file doesn't already exist for the desired output grid, a
template file can be constructed as follows:

Start with an output file from a SE test case at the resolution that you
want.

Create the template file by extracting the lat,lon and ncol variables from
the test case file:

% ncks -v lat,lon baroclinic1.nc SE_temp.nc

Convert the lat and lon variables from radians to degrees

% ncap -O  -s "lat=lat*90./asin(1.0);lon=lon*90./asin(1.0)" SE_temp.nc SE_template.nc

Add the vertical coordinates (from another cam input file)

% ncks -vhyai,hyam,hybi,hybm cami_0000-09-01_64x128_L30_c031210.nc  SE_template.nc


Then run interpic:

% interpic -t SE_template.nc inputfile.nc outputfile.nc

Finally if you started with an FV based initial file you will need to rename US and VS to
U and V.    

# cesmGUITools

cesmGUITools is a collection of python GUI applications meant to help edit geophysical fields used for the CESM model.

## Requirements
The python applications are written to make use of standard python packages as well as some widely used libraries. The following are python third-party libraries are the requirements for cesmGUITools:

1. Numpy 1.9.2
2. Matplotlib 1.4.3
3. Basemap 1.0.7
4. netcdf4-python 1.1.7
5. PyQt4

## Installation
There is no specific installation process required to use the scripts.

## Usage
All scripts are executable and meant to be called from the command-line with required and optional arguments. Calling help on any of the executable scripts on the command line by typing `./thisscript.py --help` will print the required and optional arguments that program accepts.

## Editors presently available
The following graphical editors are currently available:

1. TopoEditor

  This is used for editing a topography dataset.

2. KMTEditor

  This is used for editing the POP Ocean model's KMT levels.

## NOTE
If you get an error an error like this:
```
TypeError: 'PySide.QtGui.QWidget.setParent' called with wrong argument types:
  PySide.QtGui.QWidget.setParent(QWidget)
Supported signatures:
  PySide.QtGui.QWidget.setParent(PySide.QtGui.QWidget)
  PySide.QtGui.QWidget.setParent(PySide.QtGui.QWidget, PySide.QtCore.Qt.WindowFlags)
```
then it is because your ```matplotlibrc``` file is configured to use PySide backend for Qt4Agg. You have to change it to use the PyQt4 backend since that is the API that is being used in cesmGUITools editors. Basically you need to make sure that these two lines (uncommented) are in your ```matplotlibrc``` file:
```
backend      : Qt4Agg
backend.qt4 : PyQt4
```
See [this page](http://matplotlib.org/users/customizing.html) for information on where you can find ```matplotlibrc``` on your system.

acknowledgment:
Deepak Chandan, PhD Candidate
Earth Atmosphere and Planetary Physics Group
Department of Physics, University of Toronto
https://github.com/dchandan

subroutine area_ave (nlat_i , nlon_i , numlon_i, fld_i , &
                     nlat_o , nlon_o , numlon_o, fld_o , &
                     i_ovr  , j_ovr  , w_ovr   , nmax  )

  use shr_kind_mod, only: r8 => shr_kind_r8

  implicit none
! ------------------------ code history ---------------------------
! source file:       area_ave.F
! purpose:           area averaging of field from input to output grids
! date last revised: November 1996
! author:            Gordon Bonan
! standardized:
! reviewed:
! -----------------------------------------------------------------

! ------------------- input variables -----------------------------
  integer nlat_i   ! number of latitude points for input grid
  integer nlat_o   ! number of latitude points for output grid
  integer nlon_i   ! maximum number of longitude points for input grid
  integer nlon_o   ! maximum number of longitude points for output grid
  integer nmax     ! maximum number of overlapping cells
  integer numlon_i(nlat_i)  ! input grid number of lon points at each lat
  integer numlon_o(nlat_o)  ! input grid number of lon points at each lat
  integer i_ovr(nlon_o,nlat_o,nmax)  ! lon index, overlapping input cell
  integer j_ovr(nlon_o,nlat_o,nmax)  ! lat index, overlapping input cell

  real(r8) fld_i(nlon_i,nlat_i) !field for input grid
  real(r8) w_ovr(nlon_o,nlat_o,nmax)  ! overlap weights for input cells
! -----------------------------------------------------------------

! ------------------- output variables ----------------------------
  real(r8) fld_o(nlon_o,nlat_o) !field for output grid
! -----------------------------------------------------------------

! ------------------- local variables -----------------------------
  integer jo,ji             !latitude index for output,input grids
  integer io,ii             !longitude index for output,input grids
  integer n                 !overlapping cell index
! -----------------------------------------------------------------

  do jo = 1, nlat_o
    do io =1, numlon_o(jo)
      fld_o(io,jo) = 0.
    end do
  end do

  do n = 1, nmax
    do jo = 1, nlat_o
      do io =1, numlon_o(jo)
        ii = i_ovr(io,jo,n)
        ji = j_ovr(io,jo,n)
        fld_o(io,jo) = fld_o(io,jo) + w_ovr(io,jo,n)*fld_i(ii,ji)
      end do
    end do
  end do

  return
end subroutine area_ave

program topo2rdirc

  implicit none
  include 'netcdf.inc'

! Notes
! -------------------------------------------------------------------
! This program is a check to make sure all inifinte loops have
! been corrected in fort.10 (generated by topo2rdirc.F90).
! Use this programs as many times as necessary on fort.10 to
! verify that all infinite loops are removed.
!
! The output one ascii files: fort.11.
!
! fort.10 :
! is the river directions map in the format required by CLM.
! fort.11 :
! lists all grid cells involved in infinite river loops.
!
! The user must redirect rivers in the vicinity of infinite loops.
! Alternatively, the user may start with topography which always slopes to
! the ocean, doesn't have internal basins, and doesn't contain completely
! flat plateaus.
!
! slevis, feb 2003, cshields, may2003
! -------------------------------------------------------------------
! Variable declarations
! -------------------------------------------------------------------

  integer, parameter :: r8 = selected_real_kind(12)

! IF YOU CHOOSE A DIFFERENT RESOLUTION (nlon, nlat),
! YOU MUST ALSO READ A DIFFERENT INPUT FILE (filei).
! 2x2 degree
  integer, parameter :: nlon = 180        !input grid : longitude points
  integer, parameter :: nlat =  90        !input grid : latitude  points

! 05x05 degree
! integer, parameter :: nlon = 720        !input grid : longitude points
! integer, parameter :: nlat = 360        !input grid : latitude  points

! 1x1 degree
! integer, parameter :: nlon = 360        !input grid : longitude points
! integer, parameter :: nlat = 180        !input grid : latitude  points
  integer, parameter :: maxsecpass = 1000 !max # of infinite loops

! input file
  character(len=80) :: filei              !input filename
  integer :: ncid                         !netCDF file id for filei
  integer :: lat_id                       !netCDF latitude id
  integer :: lon_id                       !netCDF longitude id
  integer :: topo_id                      !netCDF topography id

! input variables from filei
  real(r8) :: lon(nlon)                   !longitude dimension array
  real(r8) :: lat(nlat)                   !latitude dimension array
  real(r8) :: topo(nlon,nlat)             !topography array

! output related variables
  integer  :: nowat(maxsecpass,2)         !'now at' index
  integer  :: rdirc(nlon,nlat)            !river directions
  integer  :: intbasin(nlon,nlat)         !internal basins
  integer  :: source(nlon,nlat)           !river sources
  real(r8) :: temp(nlon*nlat,3)           !temporary
  real(r8) :: tempo(maxsecpass,4)         !temporary
  real(r8) :: tmpo(4)                     !temporary
  real(r8) :: tmp(nlon*nlat,5)            !temporary

  logical :: dontcount                    !index related to next variable
  integer :: csecpass                     !count 2nd passes => inf. loops
  integer :: secondpass, ocean, ret       !indices
  integer :: ii, jj, i, j, count, line    !indices
  integer :: sort                         !index and
  integer :: locsmallest                  !variables
  integer, dimension(1) :: minlocarray    !used in the
  real(r8) :: smallest                    !sorting loops
  real(r8) :: topomin(8)     !surrounding topography in ascending order

! -------------------------------------------------------------------
! Read in ascii rdirc file
! -------------------------------------------------------------------

  filei = 'fort.10' 
  open (unit = 10, file = filei, status = "old", form='formatted' )

  line = 0
  do j = 1,nlat
  do i = nlon/2+1,nlon      ! ie, 361 to 720 at half degree
    line = line + 1
    read(10,*) temp(line,:)
    lat(j) = temp(line,1) 
    lon(i) = temp(line,2) 
    rdirc(i,j) = temp(line,3)
  end do
  do i = 1,nlon/2           ! ie, 1 to 360 at half degree
   line = line + 1
   read(10,*) temp(line,:)
   lat(j) =   temp(line,1) 
   lon(i) =   temp(line,2)
   rdirc(i,j) = temp(line,3) 
  end do
  end do
	print *, 'lat = ',lat
	print *,' lon = ',lon
!	print *,' rdirc = ',rdirc


write(*,*) 'begin error checks'

! Error checks
! Look for arrows pointing at each other.
! Don't worry about the first and last rows (j=1 and j=360 at half degree),
! because they have been hardwired to point north and south respectively.

do i = 2,nlon-1
  do j = 2,nlat-1
    if     (rdirc(i,j) == 1 .and. rdirc(i,j+1) == 5) then
      pause 'error1'
    elseif (rdirc(i,j) == 2 .and. rdirc(i+1,j+1) == 6) then
      pause 'error2'
    elseif (rdirc(i,j) == 3 .and. rdirc(i+1,j) == 7) then
      pause 'error3'
    elseif (rdirc(i,j) == 4 .and. rdirc(i+1,j-1) == 8) then
      pause 'error4'
    elseif (rdirc(i,j) == 5 .and. rdirc(i,j-1) == 1) then
      pause 'error5'
    elseif (rdirc(i,j) == 6 .and. rdirc(i-1,j-1) == 2) then
      pause 'error6'
    elseif (rdirc(i,j) == 7 .and. rdirc(i-1,j) == 3) then
      pause 'error7'
    elseif (rdirc(i,j) == 8 .and. rdirc(i-1,j+1) == 4) then
      pause 'error8'
    end if
  end do
end do

do j = 2,nlat-1
  if    (rdirc(1,j) == 1 .and. rdirc(1,j+1) == 5) then
      pause 'error9'
  elseif (rdirc(1,j) == 2 .and. rdirc(2,j+1) == 6) then
      pause 'error10'
  elseif (rdirc(1,j) == 3 .and. rdirc(2,j) == 7) then
      pause 'error11'
  elseif (rdirc(1,j) == 4 .and. rdirc(2,j-1) == 8) then
      pause 'error12'
  elseif (rdirc(1,j) == 5 .and. rdirc(1,j-1) == 1) then
      pause 'error13'
  elseif (rdirc(1,j) == 6 .and. rdirc(nlon,j-1) == 2) then
      pause 'error14'
  elseif (rdirc(1,j) == 7 .and. rdirc(nlon,j  ) == 3) then
      pause 'error15'
  elseif (rdirc(1,j) == 8 .and. rdirc(nlon,j+1) == 4) then
      pause 'error16'
  end if
  if     (rdirc(nlon,j) == 1 .and. rdirc(nlon,j+1) == 5) then
      pause 'error17'
  elseif (rdirc(nlon,j) == 2 .and. rdirc(1,j+1) == 6) then
      pause 'error18'
  elseif (rdirc(nlon,j) == 3 .and. rdirc(1,j  ) == 7) then
      pause 'error19'
  elseif (rdirc(nlon,j) == 4 .and. rdirc(1,j-1) == 8) then
      pause 'error20'
  elseif (rdirc(nlon,j) == 5 .and. rdirc(nlon,j-1) == 1) then
      pause 'error21'
  elseif (rdirc(nlon,j) == 6 .and. rdirc(nlon-1,j-1) == 2) then
      pause 'error22'
  elseif (rdirc(nlon,j) == 7 .and. rdirc(nlon-1,j  ) == 3) then
      pause 'error23'
  elseif (rdirc(nlon,j) == 8 .and. rdirc(nlon-1,j+1) == 4) then
      pause 'error24'
  end if
end do

write(*,*) 'end error checks'



source = 0              ! initialize
csecpass = 0            ! variables
                        ! ***           TO ALL USERS                ***
do i = 2,nlon-1         ! *** Pls check manually for infinite loops ***
  do j = 2,nlat-1       ! ***      at the edges of the domain       ***
    if (rdirc(i,j) > 0) then
      if (rdirc(i,j+1) /= 5 .and. rdirc(i+1,j+1) /= 6 .and. &
          rdirc(i+1,j) /= 7 .and. rdirc(i+1,j-1) /= 8 .and. &
          rdirc(i,j-1) /= 1 .and. rdirc(i-1,j-1) /= 2 .and. &
          rdirc(i-1,j) /= 3 .and. rdirc(i-1,j+1) /= 4) then
        source(i,j) = 1 ! river source
      end if
    end if
  end do
end do

write(*,*) 'Found river sources. Now follow rivers to the ocean.'

do i = 2,nlon-1
  do j = 2,nlat-1
    if (source(i,j) == 1) then
      nowat = 0; jj = j; ii = i; secondpass = 0; ocean = 0; count = 1
      do while (secondpass == 0 .and. ocean == 0)
        if (ii < 1) then
          ii = nlon
        elseif (ii > nlon) then
          ii = 1
        end if
        count = count + 1
        nowat(count,1) = jj
        nowat(count,2) = ii
        if     (rdirc(ii,jj) == 1) then
          jj = jj + 1;
        elseif (rdirc(ii,jj) == 2) then
          jj = jj + 1;
          ii = ii + 1;
        elseif (rdirc(ii,jj) == 3) then
          ii = ii + 1;
        elseif (rdirc(ii,jj) == 4) then
          ii = ii + 1;
          jj = jj - 1;
        elseif (rdirc(ii,jj) == 5) then
          jj = jj - 1;
        elseif (rdirc(ii,jj) == 6) then
          jj = jj - 1;
          ii = ii - 1;
        elseif (rdirc(ii,jj) == 7) then
          ii = ii - 1;
        elseif (rdirc(ii,jj) == 8) then
          jj = jj + 1;
          ii = ii - 1;
        elseif (rdirc(ii,jj) == 0) then
          ocean = 1                       ! reached the ocean
        end if
        do sort = 1,count-1
          if (nowat(sort,1) == nowat(count,1) .and. &
              nowat(sort,2) == nowat(count,2)) then
            secondpass = 1;               ! found an infinite loop
            tmpo(1) = jj
            tmpo(2) = ii
            tmpo(3) = lat(jj)
            tmpo(4) = lon(ii)
            if (csecpass == 0) then       ! first infinite loop to be counted
              tempo(1,1) = 0
              tempo(1,2) = 0
              tempo(1,3) = 0
              tempo(1,4) = 0
            end if
            dontcount = .false.
            do line = 1,maxsecpass
              if (tempo(line,1)==tmpo(1) .and. tempo(line,2)==tmpo(2) .and. &
                  tempo(line,3)==tmpo(3) .and. tempo(line,4)==tmpo(4)) then
                dontcount = .true.        ! avoid double counting
              end if
            end do
            if (.not. dontcount) then
              csecpass = csecpass + 1;    !count infinite loops
              tempo(csecpass,1) = jj      !NB: I have shifted ii & lon(ii)
              tempo(csecpass,2) = ii      !in fort.10 (not fort.11) to go from
              tempo(csecpass,3) = lat(jj) !-180 to 180 degrees (see comment
              tempo(csecpass,4) = lon(ii) !after 'end error checks')
              write(11,*) tempo(csecpass,:)
            end if
          end if
        end do
      end do                              ! while secondpass = 0 AND ocean = 0
    end if                                ! source
  end do                                  ! j loop
end do                                    ! i loop


end program topo2rdirc

!===============================================================================

subroutine handle_error(ret)
  implicit none
  include 'netcdf.inc'
  integer :: ret
  if (ret .ne. nf_noerr) then
     write(6,*) 'NCDERR: ERROR: ',nf_strerror(ret)
     call abort
  endif
end subroutine handle_error

!==============================================================================

subroutine wrap_inq_varid (nfid, varname, varid)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  character*(*) varname

  integer ret

  ret = nf_inq_varid (nfid, varname, varid)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_inq_varid

!=============================================================================

subroutine wrap_get_var8 (nfid, varid, arr)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  real*8 arr(*)

  integer ret

  ret = nf_get_var_double (nfid, varid, arr)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_get_var8

!==============================================================================

subroutine endrun
  implicit none
  include 'netcdf.inc'

  call abort
  stop 999
end subroutine endrun


!===============================================================================

module mkurbanparDomMod
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: mkurbanparDom
!
! !DESCRIPTION:
! Make Urban Parameter data, using a dominant type approach
!
! This approach involves determining the dominant urban density class and region for each
! output grid cell, then using these indices along with lookup tables to essentially
! paint-by-number the output urban parameter fields.
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
!-----------------------------------------------------------------------
! !USES:
   use shr_kind_mod, only : r8 => shr_kind_r8
   use shr_sys_mod , only : shr_sys_flush
   implicit none

   private

! !PUBLIC MEMBER FUNCTIONS:
   public :: mkurban
   public :: mkurbanpar

   ! The following could be private, but because there are associated test routines in a
   ! separate module, they need to be public
   public :: mkurban_dominant_density

! !PRIVATE DATA MEMBERS:
   ! flag to indicate nodata for index variables in output file:
   integer, parameter :: index_nodata = 0      
   character(len=*), parameter :: modname = 'mkurbanparDomMod'

   private :: index_nodata
   private :: modname
!EOP

contains

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkurban
!
! !INTERFACE:
subroutine mkurban(ldomain, mapfname, datfname, ndiag, zero_out, urbn_o, dens_o, region_o)
!
! !DESCRIPTION:
! make percent urban, density class and region ID on the output grid
!
! Note: in contrast to mkurban in mkurbanparAvgMod, this routine does NOT handle all_urban
!
! !USES:
   use mkdomainMod , only : domain_type, domain_clean, domain_read
   use mkgridmapMod
   use mkindexmapMod, only : get_dominant_indices
   use mkurbanparCommonMod, only : mkurban_pct, mkurban_pct_diagnostics, MIN_DENS
   use mkvarctl    , only : all_urban
   use mkvarpar
   use mkncdio
!
! !ARGUMENTS:
   implicit none
   type(domain_type), intent(in) :: ldomain
   character(len=*) , intent(in) :: mapfname    ! input mapping file name
   character(len=*) , intent(in) :: datfname    ! input data file name
   integer          , intent(in) :: ndiag       ! unit number for diag out
   logical          , intent(in) :: zero_out    ! if should zero urban out
   real(r8)         , intent(out):: urbn_o(:)   ! output grid: %urban
   integer          , intent(out):: dens_o(:)   ! output grid: urban density class
   integer          , intent(out):: region_o(:) ! output grid: region ID
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
!
! !LOCAL VARIABLES:
!EOP
   type(domain_type) :: tdomain                ! local domain
   type(gridmap_type) :: tgridmap              ! local gridmap
   real(r8), allocatable :: urbn_by_dens_i(:,:)! input grid: percent urban in each density class, at each point
   real(r8), allocatable :: urbn_by_dens_o(:,:)! output grid: percent urban in each density class, at each point
   integer , allocatable :: region_i(:)        ! input grid: region ID
   real(r8), allocatable :: gad_i(:)           ! input grid: global area of each density class
   real(r8), allocatable :: gad_o(:)           ! output grid: global area of each density class
   real(r8), allocatable :: gar_i(:)           ! input grid: global area of each urban region ID
   real(r8), allocatable :: gar_o(:)           ! output grid: global area of each urban region ID
   real(r8) :: sum_i, sum_o                    ! sums of global areas on input & output grids
   integer  :: ni,no,ns,k                      ! indices
   integer  :: ncid,dimid,varid                ! input netCDF id's
   integer  :: dimlen                          ! netCDF dimension length
   integer  :: max_dens                        ! maximum density index
   integer  :: max_region                      ! maximum region index
   integer  :: ier                             ! error status

   character(len=32) :: subname = 'mkurban'
!-----------------------------------------------------------------------
   
   write (6,*) 'Attempting to make %urban and dominant density .....'

   ! Obtain input grid info, read local fields

   call gridmap_mapread(tgridmap, mapfname)
   call domain_read(tdomain, datfname)

   ns = tdomain%ns

   write (6,*) 'Open urban file: ', trim(datfname)
   call check_ret(nf_open(datfname, 0, ncid), subname)
   call check_ret(nf_inq_dimid (ncid, 'density_class', dimid), subname)
   call check_ret(nf_inq_dimlen (ncid, dimid, max_dens), subname)

   allocate(urbn_by_dens_i(ns, 1:max_dens), &
            urbn_by_dens_o(ldomain%ns, 1:max_dens), &
            stat=ier)
   if (ier/=0) call abort()

   call check_ret(nf_inq_varid (ncid, 'PCT_URBAN', varid), subname)
   call check_ret(nf_get_var_double (ncid, varid, urbn_by_dens_i), subname)


   ! Determine % urban by density class on the output grid
   ! Note: in some cases (e.g., zero_out=.true., or a grid cell has < MIN_DENS urban %),
   ! urbn_by_dens_o will be reset to 0 in some / all places. However, we still need the
   ! values of urbn_by_dens_o before it is zeroed, in order to compute the dominant
   ! density class in each grid cell

   do k = 1, max_dens
      ! make % urban for each density class on the output grid
      call mkurban_pct(ldomain, tdomain, tgridmap, urbn_by_dens_i(:,k), urbn_by_dens_o(:,k))
   end do


   ! Determine dominant urban density class and total % urban

   call mkurban_dominant_density(urbn_by_dens_o, index_nodata, dens_o, urbn_o)


   ! Handle special cases and too-small urban density:
   
   if (all_urban) then
      write(6,*) modname//':'//subname//' ERROR: all_urban not handled here'
      call abort()
   else if (zero_out) then
      urbn_o(:) = 0._r8
      urbn_by_dens_o(:,:) = 0._r8
   else
      do no = 1, ldomain%ns
         if (urbn_o(no) < MIN_DENS) then
            urbn_o(no) = 0._r8
            urbn_by_dens_o(no,:) = 0._r8
         end if
      end do
   end if

   ! Print diagnostics

   do k = 1, max_dens
      call mkurban_pct_diagnostics(ldomain, tdomain, tgridmap, &
                                   urbn_by_dens_i(:,k), urbn_by_dens_o(:,k), &
                                   ndiag, dens_class=k)
   end do

   write (6,*) 'Successfully made %urban and dominant density'


   write(6,*) 'Attempting to make urban region .....'

   ! Read in region field
   ! Note: we do this here, rather than with the rest of the reads above, because we
   ! expect the input urban fields to be large, so we're just reading the fields as
   ! they're needed to try to avoid unnecessary memory paging

   allocate(region_i(ns), stat=ier)
   if (ier/=0) call abort()
   call check_ret(nf_inq_varid (ncid, 'REGION_ID', varid), subname)
   call check_ret(nf_get_var_int (ncid, varid, region_i), subname)

   ! Determine max region value, and make sure it doesn't exceed bounds of the lookup tables.
   !
   ! (Note: this check assumes that region_i=1 refers to region(1), region_i=2 refers to
   ! region(2), etc. The alternative would be to use a coordinate variable associated with
   ! the region dimension of the lookup table, which could result in an arbitrary mapping
   ! between region values and the indices of the lookup table; however, this use of
   ! coordinate variables currently isn't supported by lookup_2d_netcdf [as of 2-8-12].)

   max_region = maxval(region_i)
   call check_ret(nf_inq_dimid (ncid, 'region', dimid), subname)
   call check_ret(nf_inq_dimlen (ncid, dimid, dimlen), subname)
   if (max_region > dimlen) then
      write(6,*) modname//':'//subname// &
           ' ERROR: max region value exceeds length of region dimension'
      write(6,*) 'max region value          : ', max_region
      write(6,*) 'length of region dimension: ', dimlen
      call abort()
   end if

   ! Determine dominant region for each output cell

   call get_dominant_indices(tgridmap, region_i, region_o, 1, max_region, index_nodata)

   write (6,*) 'Successfully made urban region'
   write (6,*)

   ! -----------------------------------------------------------------
   ! Error check
   ! Compare relative areas of each density class & region ID on input and output grids
   ! -----------------------------------------------------------------

   allocate(gad_i(1:max_dens),   gad_o(1:max_dens), &
            gar_i(1:max_region), gar_o(1:max_region), &
            stat=ier)
   if (ier/=0) call abort()

   gad_i(:) = 0.
   gar_i(:) = 0.
   do k = 1, max_dens
      do ni = 1,tdomain%ns
         gad_i(k) = gad_i(k) + (urbn_by_dens_i(ni,k)/100._r8)*tgridmap%area_src(ni)*tgridmap%frac_src(ni)*re**2
      end do
   end do
   do ni = 1,tdomain%ns
      k = region_i(ni)
      if (k >= 1 .and. k <= max_region) then
         gar_i(k) = gar_i(k) + tgridmap%area_src(ni)*tgridmap%frac_src(ni)*re**2
      end if
   end do

   gad_o(:) = 0.
   gar_o(:) = 0.
   do no = 1,ldomain%ns
      k = dens_o(no)
      if (k >= 1 .and. k <= max_dens) then
         gad_o(k) = gad_o(k) + tgridmap%area_dst(no)*tgridmap%frac_dst(no)*re**2
      end if
      k = region_o(no)
      if (k >= 1 .and. k <= max_region) then
         gar_o(k) = gar_o(k) + tgridmap%area_dst(no)*tgridmap%frac_dst(no)*re**2
      end if      
   end do
  
   ! relative area comparison
   ! Note: we compare relative areas rather than absolute areas because we expect big
   ! differences in the absolute areas between input & output.
   ! Also note that the relative areas are as a proportion of the area with valid urban data
   
   write (ndiag,*)
   write (ndiag,'(1x,70a1)') ('=',k=1,70)
   write (ndiag,*) 'Urban Density Class Output'
   write (ndiag,'(1x,70a1)') ('=',k=1,70)

   write (ndiag,*)
   write (ndiag,'(1x,70a1)') ('.',k=1,70)
   write (ndiag,1001)
1001 format (1x,'density class input grid area output grid area',/ &
             1x,'                      percent          percent')
   write (ndiag,'(1x,70a1)') ('.',k=1,70)
   write (ndiag,*)

   sum_i = sum(gad_i)
   sum_o = sum(gad_o)
   do k = 1, max_dens
      write (ndiag,1002) k,gad_i(k)/sum_i*100,gad_o(k)/sum_o*100
1002  format (1x,i13,f15.3,'%',f16.3,'%')
   end do

   write (ndiag,*)
   write (ndiag,'(1x,70a1)') ('=',k=1,70)
   write (ndiag,*) 'Urban Region ID Output'
   write (ndiag,'(1x,70a1)') ('=',k=1,70)

   write (ndiag,*)
   write (ndiag,'(1x,70a1)') ('.',k=1,70)
   write (ndiag,1003)
1003 format (1x,'region ID input grid area output grid area',/ &
             1x,'                  percent          percent')
   write (ndiag,'(1x,70a1)') ('.',k=1,70)
   write (ndiag,*)

   sum_i = sum(gar_i)
   sum_o = sum(gar_o)
   do k = 1, max_region
      write (ndiag,1004) k,gar_i(k)/sum_i*100,gar_o(k)/sum_o*100
1004  format (1x,i9,f15.3,'%',f16.3,'%')
   end do


   ! Deallocate dynamic memory & other clean up

   call check_ret(nf_close(ncid), subname)
   call domain_clean(tdomain)
   call gridmap_clean(tgridmap)
   deallocate (urbn_by_dens_i, urbn_by_dens_o, region_i)
   deallocate(gad_i, gad_o, gar_i, gar_o)
  
end subroutine mkurban
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkurbanpar
!
! !INTERFACE:
subroutine mkurbanpar(datfname, ncido, dens_o, region_o)
!
! !DESCRIPTION:
! Make Urban Parameter data
!
! !USES:
   use mkdomainMod  , only : domain_type, domain_clean, domain_read
   use mkindexmapMod, only : dim_slice_type, lookup_2d_netcdf
   use mkvarpar
   use mkncdio
!
! !ARGUMENTS:
   implicit none
   character(len=*)  , intent(in) :: datfname    ! input data file name
   integer           , intent(in) :: ncido       ! output netcdf file id
   integer           , intent(in) :: dens_o(:)   ! output grid: urban density class
   integer           , intent(in) :: region_o(:) ! output grid: region ID
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
!
! !LOCAL VARIABLES:
!EOP
   type param
      character(len=nf_max_name) :: name         ! name in input & output files
      logical                    :: invalid_okay ! are NA values allowed in the input table?
   end type param

   real(r8), allocatable :: data_scalar_o(:)   ! output array for parameters with no extra dimensions
   real(r8), allocatable :: data_rad_o(:,:,:)  ! output array for parameters dimensioned by numrad & numsolar
   real(r8), allocatable :: data_levurb_o(:,:) ! output array for parameters dimensioned by nlevurb
   integer  :: nlevurb_i                       ! input  grid: number of urban vertical levels
   integer  :: numsolar_i                      ! input  grid: number of solar type (DIR/DIF)
   integer  :: numrad_i                        ! input  grid: number of solar bands (VIS/NIR)
   integer  :: m,n,no,ns_o,p                   ! indices
   integer  :: ncidi,dimid,varid               ! netCDF id's
   integer  :: ier                             ! error status
   
   ! information on extra dimensions for lookup tables greater than 2-d:
   type(dim_slice_type), allocatable :: extra_dims(:)  

   ! To add a new urban parameter, simply add an element to one of the below lists
   ! (params_scalar, params_rad or params_levurb)
   
   ! Urban parameters with no extra dimensions
   type(param), parameter :: params_scalar(14) = &
        (/ param('CANYON_HWR', .false.), &
           param('EM_IMPROAD', .false.), &
           param('EM_PERROAD', .false.), &
           param('EM_ROOF', .false.), &
           param('EM_WALL', .false.), &
           param('HT_ROOF', .false.), &
           param('THICK_ROOF', .false.), &
           param('THICK_WALL', .false.), &
           param('T_BUILDING_MAX', .false.), &
           param('T_BUILDING_MIN', .false.), &
           param('WIND_HGT_CANYON', .false.), &
           param('WTLUNIT_ROOF', .false.), &
           param('WTROAD_PERV', .false.), &

           ! Note that NLEV_IMPROAD is written as an integer, meaning that type conversion occurs
           ! by truncation. Thus we expect the values in the NLEV_IMPROAD lookup table to be exact;
           ! e.g., if a value were 1.99999 rather than 2.0000, it would be written as 1 instead of 2
           param('NLEV_IMPROAD', .false.) /)

   ! Urban parameters dimensioned by numrad & numsolar
   type(param), parameter :: params_rad(4) = &
        (/ param('ALB_IMPROAD', .false.), &
           param('ALB_PERROAD', .false.), &
           param('ALB_ROOF', .false.), &
           param('ALB_WALL', .false.) /)
   
   ! Urban parameters dimensioned by nlevurb
   type(param), parameter :: params_levurb(6) = &
        (/ param('TK_ROOF', .false.), &
           param('TK_WALL', .false.), &
           param('CV_ROOF', .false.), &
           param('CV_WALL', .false.), &

           ! Impervious road thermal conductivity and heat capacity have varying levels of
           ! data. Thus, we expect to find some missing values in the lookup table -- we
           ! do not want to treat that as an error -- thus, we set invalid_okay=.true.
           param('CV_IMPROAD', .true.), &
           param('TK_IMPROAD', .true.) /)


   character(len= 32) :: subname = 'mkurbanpar'
!-----------------------------------------------------------------------

   write (6,*) 'Attempting to make Urban Parameters .....'
   call shr_sys_flush(6)

   ! Determine & error-check array sizes
   ns_o = size(dens_o)
   if (ns_o /= size(region_o)) then
      write(6,*) modname//':'//subname//' ERROR: array size mismatch'
      write(6,*) 'size(dens_o)   = ', size(dens_o)
      write(6,*) 'size(region_o) = ', size(region_o)
      call abort()
   end if

   ! Read dimensions from input file

   write (6,*) 'Open urban parameter file: ', trim(datfname)
   call check_ret(nf_open(datfname, 0, ncidi), subname)
   call check_ret(nf_inq_dimid(ncidi, 'nlevurb', dimid), subname)
   call check_ret(nf_inq_dimlen(ncidi, dimid, nlevurb_i), subname)
   call check_ret(nf_inq_dimid(ncidi, 'numsolar', dimid), subname)
   call check_ret(nf_inq_dimlen(ncidi, dimid, numsolar_i), subname)
   call check_ret(nf_inq_dimid(ncidi, 'numrad', dimid), subname)
   call check_ret(nf_inq_dimlen(ncidi, dimid, numrad_i), subname)

   if (nlevurb_i /= nlevurb) then
      write(6,*)'MKURBANPAR: parameter nlevurb= ',nlevurb, &
           'does not equal input dataset nlevurb= ',nlevurb_i
      stop
   endif
   if (numsolar_i /= numsolar) then
      write(6,*)'MKURBANPAR: parameter numsolar= ',numsolar, &
           'does not equal input dataset numsolar= ',numsolar_i
      stop
   endif
   if (numrad_i /= numrad) then
      write(6,*)'MKURBANPAR: parameter numrad= ',numrad, &
           'does not equal input dataset numrad= ',numrad_i
      stop
   endif

   ! Handle urban parameters with no extra dimensions

   allocate(data_scalar_o(ns_o), stat=ier)
   if (ier /= 0) then
      write(6,*)'mkurbanpar allocation error'; call abort()
   end if
   
   do p = 1, size(params_scalar)
      call lookup_and_check_err(params_scalar(p)%name, data_scalar_o, 0, &
                                invalid_okay=params_scalar(p)%invalid_okay)

      call check_ret(nf_inq_varid(ncido, params_scalar(p)%name, varid), subname)
      ! In the following, note that type conversion occurs if we're writing to a variable of type
      ! other than double; e.g., for an integer, conversion occurs by truncation!
      call check_ret(nf_put_var_double(ncido, varid, data_scalar_o), subname)
   end do

   deallocate(data_scalar_o)
      
   ! Handle urban parameters dimensioned by numrad & numsolar

   allocate(data_rad_o(ns_o, numrad, numsolar), stat=ier)
   if (ier /= 0) then
      write(6,*)'mkurbanpar allocation error'; call abort()
   end if

   allocate(extra_dims(2))
   extra_dims(1)%name = 'numrad'
   extra_dims(2)%name = 'numsolar'

   do p = 1, size(params_rad)
      do m = 1,numsolar_i
         extra_dims(2)%val = m
         do n = 1,numrad_i
            extra_dims(1)%val = n

            call lookup_and_check_err(params_rad(p)%name, data_rad_o(:,n,m), 2, extra_dims, &
                                      invalid_okay=params_rad(p)%invalid_okay)
         end do
      end do

      call check_ret(nf_inq_varid(ncido, params_rad(p)%name, varid), subname)
      ! In the following, note that type conversion occurs if we're writing to a variable of type
      ! other than double; e.g., for an integer, conversion occurs by truncation!
      call check_ret(nf_put_var_double(ncido, varid, data_rad_o), subname)
   end do

   deallocate(data_rad_o)
   deallocate(extra_dims)

   ! Handle urban parameters dimensioned by nlevurb

   allocate(data_levurb_o(ns_o, nlevurb), stat=ier)
   if (ier /= 0) then
      write(6,*)'mkurbanpar allocation error'; call abort()
   end if   

   allocate(extra_dims(1))
   extra_dims(1)%name = 'nlevurb'

   do p = 1, size(params_levurb)
      do n = 1,nlevurb
         extra_dims(1)%val = n

         call lookup_and_check_err(params_levurb(p)%name, data_levurb_o(:,n), 1, extra_dims, &
                                   invalid_okay=params_levurb(p)%invalid_okay)
      end do

      call check_ret(nf_inq_varid(ncido, params_levurb(p)%name, varid), subname)
      ! In the following, note that type conversion occurs if we're writing to a variable of type
      ! other than double; e.g., for an integer, conversion occurs by truncation!
      call check_ret(nf_put_var_double(ncido, varid, data_levurb_o), subname)      
   end do

   deallocate(data_levurb_o)
   deallocate(extra_dims)
   

   call check_ret(nf_close(ncidi), subname)
   call check_ret(nf_sync(ncido), subname)

   write (6,*) 'Successfully made Urban Parameters'
   write (6,*)
   call shr_sys_flush(6)

contains
!------------------------------------------------------------------------------
   subroutine lookup_and_check_err(varname, data, n_extra_dims, extra_dims, invalid_okay)
   ! Wrapper to lookup_2d_netcdf: calls that routine with the appropriate arguments,
   ! then checks the error code, aborting if there were errors
   !
   ! Note: inherits a number of variables from the parent routine

      use mkindexmapMod, only : lookup_2d_netcdf

      implicit none
      character(len=*), intent(in) :: varname      ! name of lookup table
      real(r8)        , intent(out):: data(:)      ! output from lookup_2d_netcdf
      integer         , intent(in) :: n_extra_dims ! number of extra dimensions in the lookup table

      ! slice to use if lookup table variable has more than 2 dimensions:
      type(dim_slice_type), intent(in), optional :: extra_dims(:)

      ! if present and true, then we won't abort due to finding _FillValue in the lookup
      ! table -- instead, those places will just have fill_val in the output data
      logical, intent(in), optional :: invalid_okay

      ! Local variables:

      integer :: ierr  ! error return code

      ! value to put where we have no data in output variables
      real(r8), parameter :: fill_val = 0._r8


      call lookup_2d_netcdf(ncidi, varname, .true., &
                            'density_class', 'region', n_extra_dims, &
                            dens_o, region_o, fill_val, data, ierr, &
                            extra_dims=extra_dims, nodata=index_nodata, &
                            invalid_okay=invalid_okay)

      if (ierr /= 0) then
         write(6,*) modname//':'//subname//' ERROR in lookup_2d_netcdf for ', &
              trim(varname), ':', ierr
         call abort()
      end if
   end subroutine lookup_and_check_err

end subroutine mkurbanpar
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkurban_dominant_density
!
! !INTERFACE:
subroutine mkurban_dominant_density(urbn_by_dens_o, nodata, dens_o, urbn_o)
!
! !DESCRIPTION:
! Creates urban density class and total % urban on the output grid
!
! !USES:
   use mkindexmapMod, only : which_max
!
! !ARGUMENTS:
   implicit none
   real(r8), intent(in) :: urbn_by_dens_o(:,:) ! % urban in each density class, output grid
                                               ! (dimensions: (gridmap%nb, ndens))
   integer , intent(in) :: nodata              ! flag to indicate nodata in output arrays
   integer , intent(out):: dens_o(:)           ! urban density class, output grid
   real(r8), intent(out):: urbn_o(:)           ! total % urban, output grid
! 
! !REVISION HISTORY:
! Author: Bill Sacks
!
!
! !LOCAL VARIABLES:
!EOP
   integer  :: n
   integer  :: no
   real(r8) :: maxval
   integer  :: maxindex
   
   character(len=*), parameter :: subName = "mkurban_dominant_density"
!------------------------------------------------------------------------------

   n = size(urbn_by_dens_o, 1)

   ! Error-check inputs

   if (size(dens_o) /= n .or. size(urbn_o) /= n) then
      write(6,*) subName//' ERROR: incorrect array sizes'
      write(6,*) 'n            = ', n
      write(6,*) 'size(dens_o) = ', size(dens_o)
      write(6,*) 'size(urbn_o) = ', size(urbn_o)
      call abort()
   end if


   do no = 1, size(dens_o)
      urbn_o(no) = sum(urbn_by_dens_o(no,:))

      ! Determine dominant density class for each output cell
      ! Note: if all urban density classes have 0 area, then the output value will be nodata
      call which_max(urbn_by_dens_o(no,:), maxval, maxindex)
      if (maxval > 0.) then
         dens_o(no) = maxindex
      else
         dens_o(no) = nodata
      end if
   end do

end subroutine mkurban_dominant_density
!------------------------------------------------------------------------------

end module mkurbanparDomMod

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!     This module defines the F90 kind parameter for common data types.
!
!-----------------------------------------------------------------------
!
!     CVS:$Id: kinds_mod.f,v 1.2 2000/04/19 21:56:25 pwjones Exp $
!
!     Copyright (c) 1997, 1998 the Regents of the University of 
!       California.
!
!     This software and ancillary information (herein called software) 
!     called SCRIP is made available under the terms described here.  
!     The software has been approved for release with associated 
!     LA-CC Number 98-45.
!
!     Unless otherwise indicated, this software has been authored
!     by an employee or employees of the University of California,
!     operator of the Los Alamos National Laboratory under Contract
!     No. W-7405-ENG-36 with the U.S. Department of Energy.  The U.S.
!     Government has rights to use, reproduce, and distribute this
!     software.  The public may copy and use this software without
!     charge, provided that this Notice and any statement of authorship
!     are reproduced on all copies.  Neither the Government nor the
!     University makes any warranty, express or implied, or assumes
!     any liability or responsibility for the use of this software.
!
!     If software is modified to produce derivative works, such modified
!     software should be clearly marked, so as not to confuse it with 
!     the version available from Los Alamos National Laboratory.
!
!***********************************************************************

      module kinds_mod

!-----------------------------------------------------------------------

      implicit none
      save

!-----------------------------------------------------------------------

      integer, parameter :: char_len  = 80,
     &                      int_kind  = kind(1),
     &                      log_kind  = kind(.true.),
     &                      real_kind = selected_real_kind(6),
     &                      dbl_kind  = selected_real_kind(13)

!-----------------------------------------------------------------------

      end module kinds_mod

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program mksurfdat

!-----------------------------------------------------------------------
!BOP
!
! !PROGRAM: mksurfdat
!
! !DESCRIPTION:
! Creates land model surface dataset from original "raw" data files.
! Surface dataset contains model grid, pfts, inland water, glacier,
! soil texture, soil color, LAI and SAI, urban fraction, and urban
! parameters.
!
! !USES:
    use shr_kind_mod , only : r8 => shr_kind_r8, r4 => shr_kind_r4
    use fileutils    , only : opnfil, getavu
    use mklaiMod     , only : mklai
    use mkpftMod     , only : pft_idx, pft_frc, mkpft, mkpftInit, mkpft_parse_oride, &
                              mkirrig
    use mksoilMod    , only : soil_sand, soil_clay, mksoiltex, mksoilInit, &
                              soil_color, mksoilcol, mkorganic, &
                              soil_fmax, mkfmax
    use mkvocefMod   , only : mkvocef
    use mklanwatMod  , only : mklakwat, mkwetlnd
    use mkglcmecMod  , only : nglcec, mkglcmec, mkglcmecInit, mkglacier
    use mkharvestMod , only : mkharvest, mkharvest_init, mkharvest_fieldname, &
                              mkharvest_numtypes, mkharvest_parse_oride
    use mkurbanparCommonMod, only : get_urban_format, mkelev, &
                                    URBAN_FORMAT_AVG, URBAN_FORMAT_DOM
    use mkurbanparAvgMod   , only : mkurbanA => mkurban, mkurbanparA => mkurbanpar
    use mkurbanparDomMod   , only : mkurbanD => mkurban, mkurbanparD => mkurbanpar
    use mkfileMod    , only : mkfile
    use mkvarpar     , only : nlevsoi, elev_thresh
    use mkvarctl
    use nanMod       , only : nan, bigint
    use mkncdio      , only : check_ret
    use mkdomainMod  , only : domain_type, domain_read_map, domain_read, &
                              domain_write
!
! !ARGUMENTS:
    implicit none

    include 'netcdf.inc'
!
! !REVISION HISTORY:
! Authors: Gordon Bonan, Sam Levis and Mariana Vertenstein
! Revised: Nan Rosenbloom to add fmax processing.
! 3/18/08: David Lawrence added organic matter processing
! 1/22/09: Keith Oleson added urban parameter processing
!
!
! !LOCAL VARIABLES:
!EOP
    integer  :: nsoicol                     ! number of model color classes
    integer  :: k,m,n                       ! indices
    integer  :: ni,nj,ns_o                  ! indices
    integer  :: ier                         ! error status
    integer  :: ndiag,nfdyn                 ! unit numbers
    integer  :: ncid                        ! netCDF id
    integer  :: omode                       ! netCDF output mode
    integer  :: varid                       ! netCDF variable id
    integer  :: ndims                       ! netCDF number of dimensions
    integer  :: beg(4),len(4),dimids(4)     ! netCDF dimension sizes 
    integer  :: ret                         ! netCDF return status
    integer  :: ntim                        ! time sample for dynamic land use
    integer  :: year                        ! year for dynamic land use
    integer  :: urban_format                ! code for format of urban file
    logical  :: all_veg                     ! if gridcell will be 100% vegetated land-cover
    real(r8) :: suma                        ! sum for error check
    character(len=256) :: fgrddat           ! grid data file
    character(len=256) :: fsurdat           ! output surface data file name
    character(len=256) :: fsurlog           ! output surface log file name
    character(len=256) :: fdyndat           ! dynamic landuse data file name
    character(len=256) :: fname             ! generic filename
    character(len=256) :: string            ! string read in
    integer  :: t1                          ! timer
    real(r8),parameter :: p5  = 0.5_r8      ! constant
    real(r8),parameter :: p25 = 0.25_r8     ! constant

    real(r8), allocatable  :: landfrac_pft(:)    ! PFT data: % land per gridcell
    real(r8), allocatable  :: pctlnd_pft(:)      ! PFT data: % of gridcell for PFTs
    real(r8), allocatable  :: pctlnd_pft_dyn(:)  ! PFT data: % of gridcell for dyn landuse PFTs
    integer , allocatable  :: pftdata_mask(:)    ! mask indicating real or fake land type
    real(r8), pointer      :: pctpft(:,:)        ! PFT data: land fraction per gridcell
    real(r8), pointer      :: harvest(:,:)       ! harvest data: normalized harvesting
    real(r8), allocatable  :: pctgla(:)          ! percent of grid cell that is glacier  
    real(r8), allocatable  :: pctgla_uncorrected(:)  ! percent of grid cell that is glacier, before any corrections
    real(r8), allocatable  :: pctglc_gic(:)      ! percent of grid cell that is gic (glc)
    real(r8), allocatable  :: pctglc_icesheet(:) ! percent of grid cell that is ice sheet (glc)
    real(r8), allocatable  :: pctglcmec(:,:)     ! glacier_mec pct coverage in each gridcell and class
    real(r8), allocatable  :: topoglcmec(:,:)    ! glacier_mec sfc elevation in each gridcell and class
    real(r8), allocatable  :: pctglcmec_gic(:,:) ! GIC pct coverage in each gridcell and class
    real(r8), allocatable  :: pctglcmec_icesheet(:,:) ! icesheet pct coverage in each gridcell and class
    real(r8), allocatable  :: elevclass(:)       ! glacier_mec elevation classes
    real(r8), allocatable  :: pctlak(:)          ! percent of grid cell that is lake     
    real(r8), allocatable  :: pctwet(:)          ! percent of grid cell that is wetland  
    real(r8), allocatable  :: pctirr(:)          ! percent of grid cell that is irrigated  
    real(r8), allocatable  :: pcturb(:)          ! percent of grid cell that is urbanized
    real(r8), allocatable  :: elev(:)            ! glc elevation (m)
    real(r8), allocatable  :: topo(:)            ! land elevation (m)
    real(r8), allocatable  :: fmax(:)            ! fractional saturated area
    integer , allocatable  :: soicol(:)          ! soil color                            
    real(r8), allocatable  :: pctsand(:,:)       ! soil texture: percent sand            
    real(r8), allocatable  :: pctclay(:,:)       ! soil texture: percent clay            
    real(r8), allocatable  :: ef1_btr(:)         ! Isoprene emission factor for broadleaf
    real(r8), allocatable  :: ef1_fet(:)         ! Isoprene emission factor for fine/everg
    real(r8), allocatable  :: ef1_fdt(:)         ! Isoprene emission factor for fine/dec
    real(r8), allocatable  :: ef1_shr(:)         ! Isoprene emission factor for shrubs
    real(r8), allocatable  :: ef1_grs(:)         ! Isoprene emission factor for grasses
    real(r8), allocatable  :: ef1_crp(:)         ! Isoprene emission factor for crops
    real(r8), allocatable  :: organic(:,:)       ! organic matter density (kg/m3)            
    integer , allocatable  :: urban_dens(:)      ! urban density class
    integer , allocatable  :: urban_region(:)    ! urban region ID

    type(domain_type) :: ldomain

    character(len=32) :: subname = 'mksrfdat'  ! program name

    namelist /clmexp/              &
	 mksrf_fgrid,              &	
	 mksrf_gridtype,           &	
         mksrf_fvegtyp,            &
	 mksrf_fsoitex,            &
         mksrf_forganic,           &
         mksrf_fsoicol,            &
         mksrf_fvocef,             &
         mksrf_flakwat,            &
         mksrf_fwetlnd,            &
         mksrf_fglacier,           &
         mksrf_furbtopo,           &
         mksrf_flndtopo,           &
         mksrf_fmax,               &
         mksrf_furban,             &
         mksrf_flai,               &
         mksrf_firrig,             &
         mksrf_fdynuse,            &
         nglcec,                   &
         numpft,                   &
         soil_color,               &
         soil_sand,                &
         soil_fmax,                &
         soil_clay,                &
         pft_idx,                  &
         pft_frc,                  &
         all_urban,                &
         map_fpft,                 &
         map_flakwat,              &
         map_fwetlnd,              &
         map_fglacier,             &
         map_fsoitex,              &
         map_fsoicol,              &
         map_furban,               &
         map_furbtopo,             &
         map_flndtopo,             &
         map_fmax,                 &
         map_forganic,             &
         map_fvocef,               &
         map_flai,                 &
         map_fharvest,             &
         map_firrig,               &
         outnc_large_files,        &
         outnc_double,             &
         outnc_dims,               &
         fsurdat,                  &
         fdyndat,                  &   
         fsurlog     

!-----------------------------------------------------------------------

    ! ======================================================================
    ! Read input namelist
    ! ======================================
    ! Must specify settings for the output grid:
    ! ======================================
    !    mksrf_fgrid -- Grid dataset
    ! ======================================
    ! Must specify settings for input high resolution datafiles
    ! ======================================
    !    mksrf_fglacier - Glacier dataset
    !    mksrf_flai ----- Leaf Area Index dataset
    !    mksrf_flakwat -- Lake water dataset
    !    mksrf_fwetlnd -- Wetland water dataset
    !    mksrf_forganic - Organic soil carbon dataset
    !    mksrf_fmax ----- Max fractional saturated area dataset
    !    mksrf_fsoicol -- Soil color dataset
    !    mksrf_fsoitex -- Soil texture dataset
    !    mksrf_furbtopo-- Topography dataset (for limiting urban areas)
    !    mksrf_furban --- Urban dataset
    !    mksrf_fvegtyp -- PFT vegetation type dataset
    !    mksrf_fvocef  -- Volatile Organic Compund Emission Factor dataset
    ! ======================================
    ! Must specify mapping file for the different datafiles above
    ! ======================================
    !    map_fpft -------- Mapping for mksrf_fvegtyp
    !    map_flakwat ----- Mapping for mksrf_flakwat
    !    map_fwetlnd ----- Mapping for mksrf_fwetlnd
    !    map_fglacier ---- Mapping for mksrf_fglacier
    !    map_fsoitex ----- Mapping for mksrf_fsoitex
    !    map_fsoicol ----- Mapping for mksrf_fsoicol
    !    map_furban ------ Mapping for mksrf_furban
    !    map_furbtopo ---- Mapping for mksrf_furbtopo
    !    map_flndtopo ---- Mapping for mksrf_flndtopo
    !    map_fmax -------- Mapping for mksrf_fmax
    !    map_forganic ---- Mapping for mksrf_forganic
    !    map_fvocef ------ Mapping for mksrf_fvocef
    !    map_flai -------- Mapping for mksrf_flai
    !    map_fharvest ---- Mapping for mksrf_flai harvesting
    !    map_firrig ------ Mapping for mksrf_firrig (optional)
    ! ======================================
    ! Optionally specify setting for:
    ! ======================================
    !    mksrf_firrig ------ Irrigation dataset
    !    mksrf_fdynuse ----- ASCII text file that lists each year of pft files to use
    !    mksrf_gridtype ---- Type of grid (default is 'global')
    !    outnc_double ------ If output should be in double precision
    !    outnc_large_files - If output should be in NetCDF large file format
    !    nglcec ------------ If you want to change the number of Glacier elevation classes
    ! ======================================
    ! Optional settings to change values for entire area
    ! ======================================
    !    all_urban --------- If entire area is urban
    !    soil_color -------- If you want to change the soil_color to this value everywhere
    !    soil_clay --------- If you want to change the soil_clay % to this value everywhere
    !    soil_fmax --------- If you want to change the soil_fmax  to this value everywhere
    !    soil_sand --------- If you want to change the soil_sand % to this value everywhere
    !    pft_idx ----------- If you want to change to 100% veg covered with given PFT indices
    !    pft_frc ----------- Fractions that correspond to the pft_idx above
    ! ==================
    !    numpft            (if different than default of 16)
    ! ======================================================================

    write(6,*) 'Attempting to initialize control settings .....'

    mksrf_gridtype    = 'global'
    outnc_large_files = .false.
    outnc_double      = .true.
    all_urban         = .false.

    read(5, clmexp, iostat=ier)
    if (ier /= 0) then
       write(6,*)'error: namelist input resulted in error code ',ier
       call abort()
    endif

    write (6,*) 'Attempting to create surface boundary data .....'
    write (6,'(72a1)') ("-",n=1,60)

    ! ----------------------------------------------------------------------
    ! Error check namelist input
    ! ----------------------------------------------------------------------
    
    if (mksrf_fgrid /= ' ')then
       fgrddat = mksrf_fgrid
       write(6,*)'mksrf_fgrid = ',mksrf_fgrid
    else
       write (6,*)'must specify mksrf_fgrid'
       call abort()
    endif

    if (trim(mksrf_gridtype) == 'global' .or. &
        trim(mksrf_gridtype) == 'regional') then
       write(6,*)'mksrf_gridtype = ',trim(mksrf_gridtype)
    else
       write(6,*)'mksrf_gridtype = ',trim(mksrf_gridtype)
       write (6,*)'illegal mksrf_gridtype, must be global or regional '
       call abort()
    endif
    if ( outnc_large_files )then
       write(6,*)'Output file in NetCDF 64-bit large_files format'
    end if
    if ( outnc_double )then
       write(6,*)'Output ALL data in file as 64-bit'
    end if
    if ( all_urban )then
       write(6,*) 'Output ALL data in file as 100% urban'
    end if
    !
    ! Call module initialization routines
    !
    call mksoilInit( )
    call mkpftInit( all_urban, all_veg )
    allocate ( elevclass(nglcec+1) )
    call mkglcmecInit (elevclass)

    if ( all_veg )then
       write(6,*) 'Output ALL data in file as 100% vegetated'
    end if

    ! ----------------------------------------------------------------------
    ! Determine land model grid, fractional land and land mask
    ! ----------------------------------------------------------------------
    
    write(6,*)'calling domain_read'
    if ( .not. domain_read_map(ldomain, fgrddat) )then
        call domain_read(ldomain, fgrddat)
    end if
    write(6,*)'finished domain_read'
    
    ! Invalidate mask and frac for ldomain 

    !ldomain%mask = bigint
    !ldomain%frac = nan

    ! Determine if will have 1d output

    if (ldomain%ni /= -9999 .and. ldomain%nj /= -9999) then
       write(6,*)'fsurdat is 2d lat/lon grid'
       write(6,*)'nlon= ',ldomain%ni,' nlat= ',ldomain%nj
       if (outnc_dims == 1) then
          write(6,*)' writing output file in 1d gridcell format'
       end if
    else
       write(6,*)'fsurdat is 1d gridcell grid'
       outnc_dims = 1
    end if

    outnc_1d = .false.
    if ((ldomain%ni == -9999 .and. ldomain%nj == -9999) .or. outnc_dims==1) then
       outnc_1d = .true.
       write(6,*)'output file will be 1d'
    end if

    ! ----------------------------------------------------------------------
    ! Allocate and initialize dynamic memory
    ! ----------------------------------------------------------------------

    ns_o = ldomain%ns
    allocate ( landfrac_pft(ns_o)      , &
               pctlnd_pft(ns_o)        , & 
               pftdata_mask(ns_o)      , & 
               pctpft(ns_o,0:numpft)   , & 
               pctgla(ns_o)            , & 
               pctgla_uncorrected(ns_o), & 
               pctlak(ns_o)            , & 
               pctwet(ns_o)            , & 
               pcturb(ns_o)            , & 
               pctsand(ns_o,nlevsoi)   , & 
               pctclay(ns_o,nlevsoi)   , & 
               soicol(ns_o)              )
    landfrac_pft(:) = spval 
    pctlnd_pft(:)   = spval
    pftdata_mask(:) = -999
    pctpft(:,:)     = spval
    pctgla(:)       = spval
    pctgla_uncorrected(:) = spval
    pctlak(:)       = spval
    pctwet(:)       = spval
    pcturb(:)       = spval
    pctsand(:,:)    = spval
    pctclay(:,:)    = spval
    soicol(:)       = -999

    ! ----------------------------------------------------------------------
    ! Open diagnostic output log file
    ! ----------------------------------------------------------------------
    
    if (fsurlog == ' ') then
       write(6,*)' must specify fsurlog in namelist'
       stop
    else
       ndiag = getavu(); call opnfil (fsurlog, ndiag, 'f')
    end if
    
    if (mksrf_fgrid /= ' ')then
       write (ndiag,*)'using fractional land data from file= ', &
            trim(mksrf_fgrid),' to create the surface dataset'
    endif

    if (trim(mksrf_gridtype) == 'global' .or. &
        trim(mksrf_gridtype) == 'regional') then
       write(6,*)'mksrf_gridtype = ',trim(mksrf_gridtype)
    endif

    write(ndiag,*) 'PFTs from:                  ',trim(mksrf_fvegtyp)
    write(ndiag,*) 'fmax from:                  ',trim(mksrf_fmax)
    write(ndiag,*) 'glaciers from:              ',trim(mksrf_fglacier)
    write(ndiag,*) '           with:            ', nglcec, ' glacier elevation classes'
    write(ndiag,*) 'urban topography from:      ',trim(mksrf_furbtopo)
    write(ndiag,*) 'land topography from:       ',trim(mksrf_flndtopo)
    write(ndiag,*) 'urban from:                 ',trim(mksrf_furban)
    write(ndiag,*) 'inland lake from:           ',trim(mksrf_flakwat)
    write(ndiag,*) 'inland wetland from:        ',trim(mksrf_fwetlnd)
    write(ndiag,*) 'soil texture from:          ',trim(mksrf_fsoitex)
    write(ndiag,*) 'soil organic from:          ',trim(mksrf_forganic)
    write(ndiag,*) 'soil color from:            ',trim(mksrf_fsoicol)
    write(ndiag,*) 'VOC emission factors from:  ',trim(mksrf_fvocef)
    if (mksrf_firrig /= ' ') then
       write(ndiag,*)&
                   'irrigated area from:        ',trim(mksrf_firrig)
    end if
    write(ndiag,*)' mapping for pft             ',trim(map_fpft)
    write(ndiag,*)' mapping for lake water      ',trim(map_flakwat)
    write(ndiag,*)' mapping for wetland         ',trim(map_fwetlnd)
    write(ndiag,*)' mapping for glacier         ',trim(map_fglacier)
    write(ndiag,*)' mapping for soil texture    ',trim(map_fsoitex)
    write(ndiag,*)' mapping for soil color      ',trim(map_fsoicol)
    write(ndiag,*)' mapping for soil organic    ',trim(map_forganic)
    write(ndiag,*)' mapping for urban           ',trim(map_furban)
    write(ndiag,*)' mapping for fmax            ',trim(map_fmax)
    write(ndiag,*)' mapping for VOC pct emis    ',trim(map_fvocef)
    write(ndiag,*)' mapping for harvest         ',trim(map_fharvest)
    if (mksrf_firrig /= ' ') then
       write(ndiag,*) &
                  ' mapping for irrigation      ',trim(map_firrig)
    end if
    write(ndiag,*)' mapping for lai/sai         ',trim(map_flai)
    write(ndiag,*)' mapping for urb topography  ',trim(map_furbtopo)
    write(ndiag,*)' mapping for land topography ',trim(map_flndtopo)

    if (mksrf_fdynuse /= ' ') then
       write(6,*)'mksrf_fdynuse = ',trim(mksrf_fdynuse)
    end if

    ! ----------------------------------------------------------------------
    ! Make surface dataset fields
    ! ----------------------------------------------------------------------

    ! Make irrigated area fraction [pctirr] from [firrig] dataset if requested in namelist

    allocate ( pctirr(ns_o) )
    pctirr(:) = spval
    if (mksrf_firrig /= ' ') then
       call mkirrig(ldomain, mapfname=map_firrig, datfname=mksrf_firrig,&
            ndiag=ndiag, irrig_o=pctirr)
    endif

    ! Make PFTs [pctpft] from dataset [fvegtyp]

    call mkpft(ldomain, mapfname=map_fpft, fpft=mksrf_fvegtyp, &
         firrig=mksrf_firrig, ndiag=ndiag, pctlnd_o=pctlnd_pft, pctirr_o=pctirr, &
         pctpft_o=pctpft )

    ! Make inland water [pctlak, pctwet] [flakwat] [fwetlnd]

    call mklakwat (ldomain, mapfname=map_flakwat, datfname=mksrf_flakwat, &
         ndiag=ndiag, zero_out=all_urban.or.all_veg, lake_o=pctlak)

    call mkwetlnd (ldomain, mapfname=map_fwetlnd, datfname=mksrf_fwetlnd, &
         ndiag=ndiag, zero_out=all_urban.or.all_veg, swmp_o=pctwet)

    ! Make glacier fraction [pctgla] from [fglacier] dataset

    call mkglacier (ldomain, mapfname=map_fglacier, datfname=mksrf_fglacier, &
         ndiag=ndiag, zero_out=all_urban.or.all_veg, glac_o=pctgla, &
         glac_uncorrected=pctgla_uncorrected)

    ! Make soil texture [pctsand, pctclay]  [fsoitex]

    call mksoiltex (ldomain, mapfname=map_fsoitex, datfname=mksrf_fsoitex, &
         ndiag=ndiag, pctglac_o=pctgla, sand_o=pctsand, clay_o=pctclay)
    ! Make soil color classes [soicol] [fsoicol]

    call mksoilcol (ldomain, mapfname=map_fsoicol, datfname=mksrf_fsoicol, &
         ndiag=ndiag, pctglac_o=pctgla, soil_color_o=soicol, nsoicol=nsoicol)

    ! Make fmax [fmax] from [fmax] dataset

    allocate(fmax(ns_o))
    fmax(:) = spval
    call mkfmax (ldomain, mapfname=map_fmax, datfname=mksrf_fmax, &
         ndiag=ndiag, fmax_o=fmax)

    ! Make urban fraction [pcturb] from [furban] dataset

    call get_urban_format (mksrf_furban, urban_format)

    if (urban_format == URBAN_FORMAT_AVG) then
       call mkurbanA (ldomain, mapfname=map_furban, datfname=mksrf_furban, &
            ndiag=ndiag, zero_out=all_veg, urbn_o=pcturb)
    else if (urban_format == URBAN_FORMAT_DOM) then
       allocate(urban_dens(ns_o)  , &
                urban_region(ns_o))
       urban_dens(:) = -999
       urban_region(:) = -999
       call mkurbanD (ldomain, mapfname=map_furban, datfname=mksrf_furban, &
            ndiag=ndiag, zero_out=all_veg, urbn_o=pcturb, &
            dens_o=urban_dens, region_o=urban_region)
    else
       write(6,*) 'ERROR: unexpected urban format code: ', urban_format
       call abort()
    end if

    ! WJS (9-25-12): Note about topo datasets: Until now, there have been two topography
    ! datasets: flndtopo & fglctopo. flndtopo is used to create the TOPO variable, which I
    ! believe is used to downscale grid cell-level climate to glc_mec columns (10-26-12:
    ! Now I'm not surue about this: I think TOPO might actually come from a different file
    ! in CLM, and TOPO on the surface dataset may be unused). Until now, fglctopo was used
    ! for dividing pct_glacier data into multiple elevation classes in
    ! mkglcmecMod. However, it is no longer needed for this purpose, since elevation data
    ! is now folded into fglacier. fglctopo has also been used to screen urban points (I'm
    ! not sure why fglctopo rather than flndtopo was chosen for that purpose).
    !
    ! For now, I am keeping fglctopo around simply for the urban screening purpose. To
    ! make its purpose clear, I am renaming it to furbtopo. I had planned to switch to a
    ! new topo file that is consistent with the topo data that are implicitly included in
    ! fglacier (i.e., a file that gives the topo that's used for glc purposes, even though
    ! fglctopo itself isn't used for glc purposes any more). However, this caused problems
    ! in coming up with a new elev_thresh. Thus, for now I am continuing to use the old
    ! fglctopo file, which no longer has any meaning with respect to glc (and again, I am
    ! renaming it to furbtopo to make it clear that it is not connected with glc).
    !
    ! In the longer term, a better solution for this urban screening would probably be to
    ! modify the raw urban data. In that case, I believe we could remove furbtopo.
    ! 
    ! Why was TOPO created from flndtopo rather than fglctopo? It seems like, for the
    ! purpose of downscaling, this TOPO variable should ideally represent CAM's
    ! topographic height. For that purpose, flndtopo is more appropriate, because it seems
    ! to have come from CAM's topo dataset. However, I believe that many (all??) CAM
    ! resolutions use some sort of smoothed topography. So the ideal thing to do would be
    ! for CLM to get its grid cell-level topography from CAM at initialization. If that
    ! were done, then I think flndtopo and the TOPO variable on the surface dataset could
    ! go away. (Update 10-26-12: it actually looks to me like CLM's TOPO comes from a
    ! different source entirely (flndtopo in CLM), so it may be that TOPO on the surface
    ! dataset isn't currently used for anything!)


    ! Make elevation [elev] from [ftopo, ffrac] dataset
    ! Used only to screen pcturb  
    ! Screen pcturb by elevation threshold from elev dataset

    if ( .not. all_urban .and. .not. all_veg )then
       allocate(elev(ns_o))
       elev(:) = spval
       call mkelev (ldomain, mapfname=map_furbtopo, datfname=mksrf_furbtopo, &
         varname='TOPO_ICE', ndiag=ndiag, elev_o=elev)

       where (elev .gt. elev_thresh)
         pcturb = 0._r8
       end where
       deallocate(elev)
    end if
    
    ! Determine topography

    allocate(topo(ns_o))
    call mkelev (ldomain, mapfname=map_flndtopo, datfname=mksrf_flndtopo, &
         varname='TOPO', ndiag=ndiag, elev_o=topo)

    ! Make organic matter density [organic] [forganic]
    allocate (organic(ns_o,nlevsoi))
    organic(:,:) = spval
    call mkorganic (ldomain, mapfname=map_forganic, datfname=mksrf_forganic, &
         ndiag=ndiag, organic_o=organic)

    ! Make VOC emission factors for isoprene &
    ! [ef1_btr,ef1_fet,ef1_fdt,ef1_shr,ef1_grs,ef1_crp]

    allocate ( ef1_btr(ns_o) , & 
               ef1_fet(ns_o) , & 
               ef1_fdt(ns_o) , & 
               ef1_shr(ns_o) , & 
               ef1_grs(ns_o) , & 
               ef1_crp(ns_o) )
    ef1_btr(:) = 0._r8
    ef1_fet(:) = 0._r8
    ef1_fdt(:) = 0._r8
    ef1_shr(:) = 0._r8
    ef1_grs(:) = 0._r8
    ef1_crp(:) = 0._r8
    
    call mkvocef (ldomain, mapfname=map_fvocef, datfname=mksrf_fvocef, ndiag=ndiag, &
         ef_btr_o=ef1_btr, ef_fet_o=ef1_fet, ef_fdt_o=ef1_fdt,  &
         ef_shr_o=ef1_shr, ef_grs_o=ef1_grs, ef_crp_o=ef1_crp)


    ! Do landuse changes such as for the poles, etc.

    call change_landuse( ldomain, dynpft=.false. )

    do n = 1,ns_o

       ! Assume wetland and/or lake when dataset landmask implies ocean 
       ! (assume medium soil color (15) and loamy texture).
       ! Also set pftdata_mask here
       
       if (pctlnd_pft(n) < 1.e-6_r8) then
          pftdata_mask(n)  = 0
          soicol(n)        = 15
          pctwet(n)        = 100._r8 - pctlak(n)
          pcturb(n)        = 0._r8
          if (mksrf_firrig /= ' ') pctirr(n) = 0._r8
          pctgla(n)        = 0._r8
          pctpft(n,:)      = 0._r8
          pctsand(n,:)     = 43._r8
          pctclay(n,:)     = 18._r8
          organic(n,:)   = 0._r8
       else
          pftdata_mask(n) = 1
       end if

       ! Truncate all percentage fields on output grid. This is needed to
       ! insure that wt is not nonzero (i.e. a very small number such as
       ! 1e-16) where it really should be zero
       
       do k = 1,nlevsoi
          pctsand(n,k) = float(nint(pctsand(n,k)))
          pctclay(n,k) = float(nint(pctclay(n,k)))
       end do
       pctlak(n) = float(nint(pctlak(n)))
       pctwet(n) = float(nint(pctwet(n)))
       pctgla(n) = float(nint(pctgla(n)))
       if (mksrf_firrig /= ' ') pctirr(n) = float(nint(pctirr(n)))
       
       ! Make sure sum of land cover types does not exceed 100. If it does,
       ! subtract excess from most dominant land cover.
       
       suma = pctlak(n) + pctwet(n) + pcturb(n) + pctgla(n)
       if (suma > 250._r4) then
          write (6,*) subname, ' error: sum of pctlak, pctwet,', &
               'pcturb and pctgla is greater than 250%'
          write (6,*)'n,pctlak,pctwet,pcturb,pctgla= ', &
               n,pctlak(n),pctwet(n),pcturb(n),pctgla(n)
          call abort()
       else if (suma > 100._r4) then
          pctlak(n) = pctlak(n) * 100._r8/suma
          pctwet(n) = pctwet(n) * 100._r8/suma
          pcturb(n) = pcturb(n) * 100._r8/suma
          pctgla(n) = pctgla(n) * 100._r8/suma
       end if
       
    end do

    call normalizencheck_landuse(ldomain)

    ! Write out sum of PFT's

    do k = 0,numpft
       suma = 0._r8
       do n = 1,ns_o
          suma = suma + pctpft(n,k)
       enddo
       write(6,*) 'sum over domain of pft ',k,suma
    enddo
    write(6,*)

    ! Make glacier multiple elevation classes [pctglcmec,topoglcmec] from [fglacier] dataset
    ! This call needs to occur after pctgla has been adjusted for the final time

    if ( nglcec > 0 )then

       allocate (pctglcmec(ns_o,nglcec), &
                 topoglcmec(ns_o,nglcec), &
                 pctglcmec_gic(ns_o,nglcec), &
                 pctglcmec_icesheet(ns_o,nglcec))
       allocate (pctglc_gic(ns_o))
       allocate (pctglc_icesheet(ns_o))

       pctglcmec(:,:)          = spval
       topoglcmec(:,:)         = spval
       pctglcmec_gic(:,:)      = spval
       pctglcmec_icesheet(:,:) = spval
       pctglc_gic(:)           = spval
       pctglc_icesheet(:)      = spval

       call mkglcmec (ldomain, mapfname=map_fglacier, &
                      datfname_fglacier=mksrf_fglacier, ndiag=ndiag, &
                      pctglac_o=pctgla, pctglac_o_uncorrected=pctgla_uncorrected, &
                      pctglcmec_o=pctglcmec, topoglcmec_o=topoglcmec, &
                      pctglcmec_gic_o=pctglcmec_gic, pctglcmec_icesheet_o=pctglcmec_icesheet, &
                      pctglc_gic_o=pctglc_gic, pctglc_icesheet_o=pctglc_icesheet)
    end if

    ! Determine fractional land from pft dataset

    do n = 1,ns_o
       landfrac_pft(n) = pctlnd_pft(n)/100._r8
    end do

    ! ----------------------------------------------------------------------
    ! Create surface dataset
    ! ----------------------------------------------------------------------

    ! Create netCDF surface dataset.  

    if (fsurdat == ' ') then
       write(6,*)' must specify fsurdat in namelist'
       stop
    end if

    call mkfile(ldomain, trim(fsurdat), dynlanduse = .false., urban_format=urban_format)

    call domain_write(ldomain, fsurdat)

    call check_ret(nf_open(trim(fsurdat), nf_write, ncid), subname)
    call check_ret(nf_set_fill (ncid, nf_nofill, omode), subname)

    ! Write fields OTHER THAN lai, sai, heights, and urban parameters to netcdf surface dataset

    call check_ret(nf_inq_varid(ncid, 'PFTDATA_MASK', varid), subname)
    call check_ret(nf_put_var_int(ncid, varid, pftdata_mask), subname)

    call check_ret(nf_inq_varid(ncid, 'LANDFRAC_PFT', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, landfrac_pft), subname)

    call check_ret(nf_inq_varid(ncid, 'mxsoil_color', varid), subname)
    call check_ret(nf_put_var_int(ncid, varid, nsoicol), subname)

    call check_ret(nf_inq_varid(ncid, 'SOIL_COLOR', varid), subname)
    call check_ret(nf_put_var_int(ncid, varid, soicol), subname)

    call check_ret(nf_inq_varid(ncid, 'PCT_SAND', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, pctsand), subname)

    call check_ret(nf_inq_varid(ncid, 'PCT_CLAY', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, pctclay), subname)

    call check_ret(nf_inq_varid(ncid, 'PCT_WETLAND', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, pctwet), subname)

    call check_ret(nf_inq_varid(ncid, 'PCT_LAKE', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, pctlak), subname)

    call check_ret(nf_inq_varid(ncid, 'PCT_GLACIER', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, pctgla), subname)

    if ( nglcec > 0 )then
       call check_ret(nf_inq_varid(ncid, 'PCT_GLC_MEC', varid), subname)
       call check_ret(nf_put_var_double(ncid, varid, pctglcmec), subname)

       call check_ret(nf_inq_varid(ncid, 'GLC_MEC', varid), subname)
       call check_ret(nf_put_var_double(ncid, varid, elevclass), subname)

       call check_ret(nf_inq_varid(ncid, 'TOPO_GLC_MEC', varid), subname)
       call check_ret(nf_put_var_double(ncid, varid, topoglcmec), subname)

       call check_ret(nf_inq_varid(ncid, 'PCT_GLC_MEC_GIC', varid), subname)
       call check_ret(nf_put_var_double(ncid, varid, pctglcmec_gic), subname)

       call check_ret(nf_inq_varid(ncid, 'PCT_GLC_MEC_ICESHEET', varid), subname)
       call check_ret(nf_put_var_double(ncid, varid, pctglcmec_icesheet), subname)

       call check_ret(nf_inq_varid(ncid, 'PCT_GLC_GIC', varid), subname)
       call check_ret(nf_put_var_double(ncid, varid, pctglc_gic), subname)

       call check_ret(nf_inq_varid(ncid, 'PCT_GLC_ICESHEET', varid), subname)
       call check_ret(nf_put_var_double(ncid, varid, pctglc_icesheet), subname)

    end if

    call check_ret(nf_inq_varid(ncid, 'TOPO', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, topo), subname)

    call check_ret(nf_inq_varid(ncid, 'PCT_URBAN', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, pcturb), subname)

    call check_ret(nf_inq_varid(ncid, 'PCT_PFT', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, pctpft), subname)

    call check_ret(nf_inq_varid(ncid, 'FMAX', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, fmax), subname)

    call check_ret(nf_inq_varid(ncid, 'EF1_BTR', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, ef1_btr), subname)

    call check_ret(nf_inq_varid(ncid, 'EF1_FET', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, ef1_fet), subname)

    call check_ret(nf_inq_varid(ncid, 'EF1_FDT', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, ef1_fdt), subname)

    call check_ret(nf_inq_varid(ncid, 'EF1_SHR', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, ef1_shr), subname)

    call check_ret(nf_inq_varid(ncid, 'EF1_GRS', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, ef1_grs), subname)

    call check_ret(nf_inq_varid(ncid, 'EF1_CRP', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, ef1_crp), subname)

    call check_ret(nf_inq_varid(ncid, 'ORGANIC', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, organic), subname)

    if (mksrf_firrig /= ' ') then
       call check_ret(nf_inq_varid(ncid, 'PCT_IRRIG', varid), subname)
       call check_ret(nf_put_var_double(ncid, varid, pctirr), subname)
    endif

    if (urban_format == URBAN_FORMAT_DOM) then
       call check_ret(nf_inq_varid(ncid, 'URBAN_DENSITY_CLASS', varid), subname)
       call check_ret(nf_put_var_int(ncid, varid, urban_dens), subname)

       call check_ret(nf_inq_varid(ncid, 'URBAN_REGION_ID', varid), subname)
       call check_ret(nf_put_var_int(ncid, varid, urban_region), subname)
    end if

    ! Deallocate arrays NOT needed for dynamic-pft section of code

    deallocate ( organic )
    deallocate ( ef1_btr, ef1_fet, ef1_fdt, ef1_shr, ef1_grs, ef1_crp )
    if ( nglcec > 0 ) deallocate ( pctglcmec, topoglcmec)
    if ( nglcec > 0 ) deallocate ( pctglc_gic, pctglc_icesheet)
    deallocate ( elevclass )
    deallocate ( fmax )
    deallocate ( pctsand, pctclay )
    deallocate ( soicol )

    ! Synchronize the disk copy of a netCDF dataset with in-memory buffers

    call check_ret(nf_sync(ncid), subname)

    ! ----------------------------------------------------------------------
    ! Make Urban Parameters from raw input data and write to surface dataset 
    ! Write to netcdf file is done inside mkurbanpar routine
    ! Only call this routine if pcturb is greater than zero somewhere.  Raw urban
    ! datasets will have no associated parameter fields if there is no urban 
    ! (e.g., mksrf_urban.060929.nc).
    ! ----------------------------------------------------------------------

    write(6,*)'calling mkurbanparA'
    if (any(pcturb > 0._r8)) then
       if (urban_format == URBAN_FORMAT_AVG) then
          call mkurbanparA(ldomain, mapfname=map_furban, datfname=mksrf_furban, &
               ndiag=ndiag, ncido=ncid)
       else if (urban_format == URBAN_FORMAT_DOM) then
          call mkurbanparD(datfname=mksrf_furban, ncido=ncid, &
                           dens_o=urban_dens, region_o=urban_region)
       else
          write(6,*) 'ERROR: unexpected urban format code: ', urban_format
          call abort()   
       end if
    else
       write(6,*) 'PCT_URBAN is zero everywhere, no urban parameter fields will be created'
    end if

    ! ----------------------------------------------------------------------
    ! Make LAI and SAI from 1/2 degree data and write to surface dataset 
    ! Write to netcdf file is done inside mklai routine
    ! ----------------------------------------------------------------------

    write(6,*)'calling mklai'
    call mklai(ldomain, mapfname=map_flai, datfname=mksrf_flai, &
         firrig=mksrf_firrig, ndiag=ndiag, ncido=ncid )

    ! Close surface dataset

    call check_ret(nf_close(ncid), subname)

    write (6,'(72a1)') ("-",n=1,60)
    write (6,*)' land model surface data set successfully created for ', &
         'grid of size ',ns_o

    ! ----------------------------------------------------------------------
    ! Create dynamic land use dataset if appropriate
    ! ----------------------------------------------------------------------

    if (mksrf_fdynuse /= ' ') then

       write(6,*)'creating dynamic land use dataset'

       allocate(pctlnd_pft_dyn(ns_o))
       call mkharvest_init( ns_o, spval, harvest, mksrf_fvegtyp )

       if (fdyndat == ' ') then
          write(6,*)' must specify fdyndat in namelist if mksrf_fdynuse is not blank'
          stop
       end if

       ! Define dimensions and global attributes

       call mkfile(ldomain, fdyndat, dynlanduse=.true., urban_format=urban_format)

       ! Write fields other pft to dynamic land use dataset

       call domain_write(ldomain, fdyndat)

       call check_ret(nf_open(trim(fdyndat), nf_write, ncid), subname)
       call check_ret(nf_set_fill (ncid, nf_nofill, omode), subname)

       call check_ret(nf_inq_varid(ncid, 'PFTDATA_MASK', varid), subname)
       call check_ret(nf_put_var_int(ncid, varid, pftdata_mask), subname)

       call check_ret(nf_inq_varid(ncid, 'LANDFRAC_PFT', varid), subname)
       call check_ret(nf_put_var_double(ncid, varid, landfrac_pft), subname)

       call check_ret(nf_inq_varid(ncid, 'PCT_WETLAND', varid), subname)
       call check_ret(nf_put_var_double(ncid, varid, pctwet), subname)

       call check_ret(nf_inq_varid(ncid, 'PCT_LAKE', varid), subname)
       call check_ret(nf_put_var_double(ncid, varid, pctlak), subname)

       call check_ret(nf_inq_varid(ncid, 'PCT_GLACIER', varid), subname)
       call check_ret(nf_put_var_double(ncid, varid, pctgla), subname)

       call check_ret(nf_inq_varid(ncid, 'PCT_URBAN', varid), subname)
       call check_ret(nf_put_var_double(ncid, varid, pcturb), subname)

       ! Synchronize the disk copy of a netCDF dataset with in-memory buffers

       call check_ret(nf_sync(ncid), subname)

       ! Read in each dynamic pft landuse dataset

    nfdyn = getavu(); call opnfil (mksrf_fdynuse, nfdyn, 'f')

       ntim = 0
       do 
          ! Read input pft data

          read(nfdyn, '(A195,1x,I4)', iostat=ier) string, year
          if (ier /= 0) exit
          !
          ! If pft fraction override is set, than intrepret string as PFT and harvesting override values
          !
          if ( any(pft_frc > 0.0_r8 ) )then
             fname = ' '
             call mkpft_parse_oride(string)
             call mkharvest_parse_oride(string)
	     write(6,*)'PFT and harvesting values are ',trim(string),' year is ',year
          !
          ! Otherwise intrepret string as a filename with PFT and harvesting values in it
          !
          else
             fname = string
	     write(6,*)'input pft dynamic dataset is  ',trim(fname),' year is ',year
          end if
          ntim = ntim + 1

          ! Create pctpft data at model resolution

          call mkpft(ldomain, mapfname=map_fpft, fpft=fname, firrig=mksrf_firrig, &
               ndiag=ndiag, pctlnd_o=pctlnd_pft_dyn, pctirr_o=pctirr, &
               pctpft_o=pctpft )

          ! Create harvesting data at model resolution

          call mkharvest( ldomain, mapfname=map_fharvest, datfname=fname, &
               ndiag=ndiag, harv_o=harvest )

          ! Consistency check on input land fraction

          do n = 1,ns_o
             if (pctlnd_pft_dyn(n) /= pctlnd_pft(n)) then
                write(6,*) subname,' error: pctlnd_pft for dynamics data = ',&
                     pctlnd_pft_dyn(n), ' not equal to pctlnd_pft for surface data = ',&
                     pctlnd_pft(n),' at n= ',n
                if ( trim(fname) == ' ' )then
                   write(6,*) ' PFT string = ', string
                else
                   write(6,*) ' PFT file = ', fname
                end if
                call abort()
             end if
          end do

          call change_landuse(ldomain, dynpft=.true.)

          call normalizencheck_landuse(ldomain)

          ! Output pctpft data for current year

          call check_ret(nf_inq_varid(ncid, 'PCT_PFT', varid), subname)
          call check_ret(nf_inq_varndims(ncid, varid, ndims), subname)
          call check_ret(nf_inq_vardimid(ncid, varid, dimids), subname)
          beg(1:ndims-1) = 1
          do n = 1,ndims-1
             call check_ret(nf_inq_dimlen(ncid, dimids(n), len(n)), subname)
          end do
          len(ndims) = 1
          beg(ndims) = ntim
          call check_ret(nf_put_vara_double(ncid, varid, beg, len, pctpft), subname)

          do k = 1, mkharvest_numtypes()
             call check_ret(nf_inq_varid(ncid, trim(mkharvest_fieldname(k)), varid), subname)
             call check_ret(nf_inq_varndims(ncid, varid, ndims), subname)
             call check_ret(nf_inq_vardimid(ncid, varid, dimids), subname)
             beg(1:ndims-1) = 1
             do n = 1,ndims-1
                call check_ret(nf_inq_dimlen(ncid, dimids(n), len(n)), subname)
             end do
             len(ndims) = 1
             beg(ndims) = ntim
             call check_ret(nf_put_vara_double(ncid, varid, beg, len, harvest(:,k)), subname)
          end do

          call check_ret(nf_inq_varid(ncid, 'YEAR', varid), subname)
          call check_ret(nf_put_vara_int(ncid, varid, ntim, 1, year), subname)

          call check_ret(nf_inq_varid(ncid, 'time', varid), subname)
          call check_ret(nf_put_vara_int(ncid, varid, ntim, 1, year), subname)

          call check_ret(nf_inq_varid(ncid, 'input_pftdata_filename', varid), subname)
          call check_ret(nf_put_vara_text(ncid, varid, (/ 1, ntim /), (/ len_trim(string), 1 /), trim(string) ), subname)

	  ! Synchronize the disk copy of a netCDF dataset with in-memory buffers

	  call check_ret(nf_sync(ncid), subname)

       end do   ! end of read loop

       call check_ret(nf_close(ncid), subname)

    end if   ! end of if-create dynamic landust dataset   

    ! ----------------------------------------------------------------------
    ! Close diagnostic dataset
    ! ----------------------------------------------------------------------

    close (ndiag)
    write (6,*)
    write (6,*) 'Surface data output file = ',trim(fsurdat)
    write (6,*) '   This file contains the land model surface data'
    write (6,*) 'Diagnostic log file      = ',trim(fsurlog)
    write (6,*) '   See this file for a summary of the dataset'
    write (6,*)

    write (6,*) 'Successfully created surface dataset'

!-----------------------------------------------------------------------
contains
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: change_landuse
!
! !INTERFACE:
subroutine change_landuse( ldomain, dynpft )
!
! !DESCRIPTION:
!
! Do landuse changes such as for the poles, etc.
!
! !USES:
    implicit none
!
! !ARGUMENTS:
    type(domain_type)   :: ldomain
    logical, intent(in)  :: dynpft   ! if part of the dynpft section of code

!
! !REVISION HISTORY:
! 9/10/09: Erik Kluzek spin off subroutine from original embedded code
!
!EOP
!
! !LOCAL VARIABLES:
    logical  :: first_time = .true.         ! flag if this is the first pass through or not
    integer ,parameter :: bdtroptree = 6    ! Index for broadleaf decidious tropical tree
    integer ,parameter :: bdtemptree = 7    ! Index for broadleaf decidious temperate tree
    integer ,parameter :: bdtempshrub = 10  ! Index for broadleaf decidious temperate shrub
    real(r8),parameter :: troplat = 23.5_r8 ! Latitude to define as tropical
    integer  :: n,ns_o                       ! indices
    character(len=32) :: subname = 'change_landuse'  ! subroutine name
!-----------------------------------------------------------------------

    ns_o = ldomain%ns
    do n = 1,ns_o

       ! Set pfts 7 and 10 to 6 in the tropics to avoid lais > 1000
       ! Using P. Thornton's method found in surfrdMod.F90 in clm3.5
       
       if (abs(ldomain%latc(n))<troplat .and. pctpft(n,bdtemptree)>0._r8) then
          pctpft(n,bdtroptree) = pctpft(n,bdtroptree) + pctpft(n,bdtemptree)
          pctpft(n,bdtemptree) = 0._r8
          if ( first_time ) write (6,*) subname, ' Warning: all wgt of pft ', &
               bdtemptree, ' now added to pft ', bdtroptree
       end if
       if (abs(ldomain%latc(n))<troplat .and. pctpft(n,bdtempshrub)>0._r8) then
          pctpft(n,bdtroptree) = pctpft(n,bdtroptree) + pctpft(n,bdtempshrub)
          pctpft(n,bdtempshrub) = 0._r8
          if ( first_time ) write (6,*) subname, ' Warning: all wgt of pft ', &
               bdtempshrub, ' now added to pft ', bdtroptree
       end if
       first_time = .false.
       
       ! If have pole points on grid - set south pole to glacier
       ! north pole is assumed as non-land
       
       if (abs((ldomain%latc(n) - 90._r8)) < 1.e-6_r8) then
          pctpft(n,:) = 0._r8
          pctlak(n)   = 0._r8
          pctwet(n)   = 0._r8
          pcturb(n)   = 0._r8
          pctgla(n)   = 100._r8
          if ( .not. dynpft )then
             organic(n,:)   = 0._r8
             ef1_btr(n)     = 0._r8
             ef1_fet(n)     = 0._r8
             ef1_fdt(n)     = 0._r8
             ef1_shr(n)     = 0._r8
             ef1_grs(n)     = 0._r8
             ef1_crp(n)     = 0._r8
             soicol(n)      = 0
             if (mksrf_firrig /= ' ') pctirr(n) = 0._r8
             pctsand(n,:)   = 0._r8
             pctclay(n,:)   = 0._r8
          end if
       end if

    end do

end subroutine change_landuse

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: normalizencheck_landuse
!
! !INTERFACE:
subroutine normalizencheck_landuse(ldomain)
!
! !DESCRIPTION:
!
! Normalize land use and make sure things add up to 100% as well as
! checking that things are as they should be.
!
! !USES:
    implicit none
! !ARGUMENTS:
    type(domain_type)   :: ldomain
!
! !REVISION HISTORY:
! 9/10/09: Erik Kluzek spin off subroutine from original embedded code
!
!EOP
!
! !LOCAL VARIABLES:
    integer  :: m,k,n,ns_o                  ! indices
    integer  :: nsmall                      ! number of small PFT values
    real(r8) :: suma                        ! sum for error check
    real(r8) :: bare_urb_diff               ! difference between bare soil and urban %
    real(r8) :: pcturb_excess               ! excess urban % not accounted for by bare soil
    real(r8) :: sumpft                      ! sum of non-baresoil pfts
    real(r8) :: sum8, sum8a                 ! sum for error check
    real(r4) :: sum4a                       ! sum for error check
    real(r8), parameter :: toosmallPFT = 1.e-10_r8            ! tolerance for PFT's to ignore
    character(len=32) :: subname = 'normalizencheck_landuse'  ! subroutine name
!-----------------------------------------------------------------------

    ns_o = ldomain%ns
    nsmall = 0
    do n = 1,ns_o
       if (pcturb(n) .gt. 0._r8) then
          
          ! Replace bare soil preferentially with urban
          suma = pctlak(n)+pctwet(n)+pctgla(n)
          bare_urb_diff = 0.01_r8 * pctpft(n,0) * (100._r8 - suma) - pcturb(n)
          pctpft(n,0) = max(0._r8,bare_urb_diff)
          pcturb_excess = abs(min(0._r8,bare_urb_diff))
          
          ! Normalize pctpft to be the remainder of [100 - (special landunits)]
          ! including any urban not accounted for by bare soil above
          sumpft = sum(pctpft(n,1:numpft))
          if (sumpft > 0._r8) then
             suma = pctlak(n)+pctwet(n)+pctgla(n)
             do m = 1, numpft
                pctpft(n,m) = 0.01_r8 * pctpft(n,m) * (100._r8 - suma) - &
                     pcturb_excess*pctpft(n,m)/sumpft
                if ( pctpft(n,m) < 0.0_r8 )then
                   write (6,*)'pctpft < 0.0 = ', pctpft(n,m), &
                   ' suma, pcturb_excess, sumpft = ',  suma, pcturb_excess, sumpft
                   if ( abs(pctpft(n,m)) > epsilon(pctpft(n,m))*50.0_r8 )then
                      call abort()
                   end if
                   pctpft(n,m) = 0.0_r8
                end if
             end do
          end if

       else
          
          ! Normalize pctpft to be the remainder of [100 - (special landunits)]
          suma = pctlak(n) + pctwet(n) + pcturb(n) + pctgla(n)
          do m = 0, numpft
             pctpft(n,m) = 0.01_r8 * pctpft(n,m) * (100._r8 - suma)
          end do

       end if
       
       suma = pctlak(n) + pctwet(n) + pcturb(n) + pctgla(n)
       do m = 0,numpft
          suma = suma + pctpft(n,m)
       end do
       
       if (suma < 90._r8) then
          write (6,*) subname, ' error: sum of pctlak, pctwet,', &
               'pcturb, pctgla and pctpft is less than 90'
          write (6,*)'n,pctlak,pctwet,pcturb,pctgla,pctpft= ', &
               n,pctlak(n),pctwet(n),pcturb(n),pctgla(n),pctpft(n,:)
          call abort()
       else if (suma > 100._r8 + 1.e-4_r8) then
          write (6,*) subname, ' error: sum of pctlak, pctwet,', &
               'pcturb, pctgla and pctpft is greater than 100'
          write (6,*)'n,pctlak,pctwet,pcturb,pctgla,pctpft,sum= ', &
               n,pctlak(n),pctwet(n),pcturb(n),pctgla(n),pctpft(n,:),suma
          call abort()
       else
          do m = 0, numpft
             if ( pctpft(n,m) > 0.0_r8 .and. pctpft(n,m)*100.0_r8/suma < toosmallPFT )then
                pctpft(n,m) = 0.0_r8
                nsmall = nsmall + 1
             end if
          end do
          if ( nsmall > 1 )then
             suma = pctlak(n) + pctwet(n) + pcturb(n) + pctgla(n)
             do m = 0,numpft
                suma = suma + pctpft(n,m)
             end do
          end if 
          if ( abs(suma - 100.0_r8) > 2.0*epsilon(suma) )then
             pctlak(n)   = pctlak(n)   * 100._r8/suma
             pctwet(n)   = pctwet(n)   * 100._r8/suma
             pcturb(n)   = pcturb(n)   * 100._r8/suma
             pctgla(n)   = pctgla(n)   * 100._r8/suma
             pctpft(n,:) = pctpft(n,:) * 100._r8/suma
          end if
       end if
       
       ! Roundoff error fix
       suma = pctlak(n) + pctwet(n) + pcturb(n) + pctgla(n)
       if ( (suma < 100._r8 .and. suma > (100._r8 - 1.e-6_r8)) .or. &
            (sum(pctpft(n,:)) > 0.0_r8 .and. sum(pctpft(n,:)) <  1.e-6_r8) ) then
          write (6,*) 'Special land units near 100%, but not quite for n,suma =',n,suma
          write (6,*) 'Adjusting special land units to 100%'
          if (pctlak(n) >= 25._r8) then
             pctlak(n) = 100._r8 - (pctwet(n) + pcturb(n) + pctgla(n))
          else if (pctwet(n) >= 25._r8) then
             pctwet(n) = 100._r8 - (pctlak(n) + pcturb(n) + pctgla(n))
          else if (pcturb(n) >= 25._r8) then
             pcturb(n) = 100._r8 - (pctlak(n) + pctwet(n) + pctgla(n))
          else if (pctgla(n) >= 25._r8) then
             pctgla(n) = 100._r8 - (pctlak(n) + pctwet(n) + pcturb(n))
          else
             write (6,*) subname, 'Error: sum of special land units nearly 100% but none is >= 25% at ', &
                  'n,pctlak(n),pctwet(n),pcturb(n),pctgla(n),pctpft(n,:),suma = ', &
                  n,pctlak(n),pctwet(n),pcturb(n),pctgla(n),pctpft(n,:),suma
             call abort()
          end if
          pctpft(n,:) = 0._r8
       end if
       if ( any(pctpft(n,:) > 0.0_r8 .and. pctpft(n,:) < toosmallPFT ) )then
          write (6,*) 'pctpft is small'
          write (6,*) 'pctpft(',n,') = ', pctpft(n,:)
          write (6,*) 'sum(pctpft) = ', sum(pctpft(n,:))
          call abort()
       end if
       
       suma = pctlak(n) + pctwet(n) + pcturb(n) + pctgla(n)
       if (suma < 100._r8-epsilon(suma) .and. suma > (100._r8 - 4._r8*epsilon(suma))) then
          write (6,*) subname, 'n,pctlak,pctwet,pcturb,pctgla,pctpft= ', &
               n,pctlak(n),pctwet(n),pcturb(n),pctgla(n),&
               pctpft(n,:)
          call abort()
       end if
       do m = 0,numpft
          suma = suma + pctpft(n,m)
       end do
       if ( abs(suma-100._r8) > 1.e-10_r8) then
          write (6,*) subname, ' error: sum of pctlak, pctwet,', &
               'pcturb, pctgla and pctpft is NOT equal to 100'
          write (6,*)'n,pctlak,pctwet,pcturb,pctgla,pctpft,sum= ', &
               n,pctlak(n),pctwet(n),pcturb(n),pctgla(n),&
               pctpft(n,:), sum8
          call abort()
       end if
       
    end do

    ! Check that when pctpft identically zero, sum of special landunits is identically 100%

    if ( .not. outnc_double )then
       do n = 1,ns_o
          sum8  =        real(pctlak(n),r4)
          sum8  = sum8 + real(pctwet(n),r4)
          sum8  = sum8 + real(pcturb(n),r4)
          sum8  = sum8 + real(pctgla(n),r4)
          sum4a = 0.0_r4
          do k = 0,numpft
             sum4a = sum4a + real(pctpft(n,k),r4)
          end do
          if ( sum4a==0.0_r4 .and. sum8 < 100._r4-2._r4*epsilon(sum4a) )then
             write (6,*) subname, ' error: sum of pctlak, pctwet,', &
                  'pcturb, pctgla is < 100% when pctpft==0 sum = ', sum8
             write (6,*)'n,pctlak,pctwet,pcturb,pctgla= ', &
                  n,pctlak(n),pctwet(n),pcturb(n),pctgla(n), pctpft(n,:)
             call abort()
          end if
       end do
    else
       do n = 1,ns_o
          sum8  =        pctlak(n)
          sum8  = sum8 + pctwet(n)
          sum8  = sum8 + pcturb(n)
          sum8  = sum8 + pctgla(n)
          sum8a = 0._r8
          do k = 0,numpft
             sum8a = sum8a + pctpft(n,k)
          end do
          if ( sum8a==0._r8 .and. sum8 < (100._r8-4._r8*epsilon(sum8)) )then
             write (6,*) subname, ' error: sum of pctlak, pctwet,', &
                  'pcturb, pctgla is < 100% when pctpft==0 sum = ', sum8
             write (6,*) 'Total error, error/epsilon = ',100._r8-sum8, ((100._r8-sum8)/epsilon(sum8))
             write (6,*)'n,pctlak,pctwet,pcturb,pctgla,pctpft,epsilon= ', &
                  n,pctlak(n),pctwet(n),pcturb(n),pctgla(n), pctpft(n,:), epsilon(sum8)
             call abort()
          end if
       end do
    end if

    do n = 1,ns_o
       do k = 0,numpft
          if ( pctpft(n,k) < 0.0_r8 )then
             write (6,*)'pctpft < 0.0 = ', pctpft(n,k)
             call abort()
          end if
       end do
       if ( (sum(pctpft(n,:)) > 100._r8-4._r8*epsilon(sum8)) .and. &
            (sum(pctpft(n,:)) < 0.5_r8) )then
          write (6,*)'sum(pctpft) < 0.5 = ', sum(pctpft(n,:))
          call abort()
       end if
    end do
    if ( nsmall > 1 )then
       write (6,*)'number of small pft = ', nsmall
    end if

end subroutine normalizencheck_landuse

end program mksurfdat

subroutine cpvar(ncidi, ncido, vi, vo, name, &
                 totsiz, xtype, start, count)

   use shr_kind_mod, only: r8 => shr_kind_r8

   implicit none

   include 'netcdf.inc'

   ! Input arguments
   integer ncidi, ncido
   integer vi, vo
   integer xtype
   integer start(nf_max_var_dims)
   integer count(nf_max_var_dims)
   integer totsiz

   character*(nf_max_name) :: name

   ! Local workspace
   character, allocatable :: cbuf(:)
   real(r8), allocatable :: buf(:)
   integer, allocatable :: ibuf(:)

   if (xtype == NF_FLOAT .or. xtype == NF_DOUBLE) then

      allocate (buf(totsiz))
      call wrap_get_vara_double (ncidi, vi, start, count, buf)
      call wrap_put_vara_double (ncido, vo, start, count, buf)
      deallocate (buf)

   else if (xtype == NF_INT) then

      allocate (ibuf(totsiz))
      call wrap_get_vara_int (ncidi, vi, start, count, ibuf)
      call wrap_put_vara_int (ncido, vo, start, count, ibuf)
      deallocate (ibuf)

   else if (xtype == NF_CHAR) then
    
      allocate (cbuf(totsiz))
      call wrap_get_vara_text (ncidi, vi, start, count, cbuf)
      call wrap_put_vara_text (ncido, vo, start, count, cbuf)
      deallocate (cbuf)
    
   else

      write(6,*)'Unknown type for variable ',name
      stop 999

   end if

end subroutine cpvar

module mkgridmapMod
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: mkgridmapMod
!
! !DESCRIPTION:
! Module containing 2-d global surface boundary data information
!
! !USES:
  use shr_kind_mod, only : r8 => shr_kind_r8

  implicit none
  private

! !PUBLIC TYPES:
  type gridmap_type
     character(len=32) :: set ! If set or not
     character(len=32) :: name
     integer :: na            ! size of source domain
     integer :: nb            ! size of destination domain
     integer :: ni            ! number of row in the matrix
     integer :: nj            ! number of col in the matrix
     integer :: ns            ! number of non-zero elements in matrix
     real(r8), pointer :: yc_src(:)     ! "degrees" 
     real(r8), pointer :: yc_dst(:)     ! "degrees" 
     real(r8), pointer :: xc_src(:)     ! "degrees" 
     real(r8), pointer :: xc_dst(:)     ! "degrees" 
     integer , pointer :: mask_src(:)   ! "unitless" 
     integer , pointer :: mask_dst(:)   ! "unitless" 
     real(R8), pointer :: area_src(:)   ! area of a grid in map (radians)
     real(R8), pointer :: area_dst(:)   ! area of b grid in map (radians)
     real(r8), pointer :: frac_src(:)   ! "unitless" 
     real(r8), pointer :: frac_dst(:)   ! "unitless" 
     integer , pointer :: src_indx(:)   ! correpsonding column index
     integer , pointer :: dst_indx(:)   ! correpsonding row    index
     real(r8), pointer :: wovr(:)       ! wt of overlap input cell
  end type gridmap_type
  public :: gridmap_type
!
! !PUBLIC MEMBER FUNCTIONS:
  public :: gridmap_setptrs   ! Set pointers to gridmap data
  public :: gridmap_mapread   ! Read in gridmap
  public :: gridmap_areaave   ! do area average
  public :: gridmap_clean     ! Clean and deallocate a gridmap structure
!
!
! !REVISION HISTORY:
! Author Mariana Vertenstein

  interface gridmap_areaave
     module procedure gridmap_areaave_default
     module procedure gridmap_areaave_srcmask
     module procedure gridmap_areaave_srcmask2
  end interface

  ! questions - how does the reverse mapping occur 
  ! is mask_dst read in - and what happens if this is very different
  ! from frac_dst which is calculated by mapping frac_src?
  ! in frac - isn't grid1_frac always 1 or 0?

! !PRIVATE MEMBER FUNCTIONS:
  private :: gridmap_checkifset

  character(len=32), parameter :: isSet = "gridmap_IsSet"
  
!
!EOP
!------------------------------------------------------------------------------
contains

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: gridmap_setptrs
!
! !INTERFACE:
  subroutine gridmap_setptrs(gridmap, nsrc, ndst, ns, yc_src, yc_dst, &
                             xc_src, xc_dst, mask_src, mask_dst,      &
                             frac_src, frac_dst, src_indx, dst_indx )
!
! !DESCRIPTION:
! This subroutine assigns pointers to some of the map type data.
!
! !ARGUMENTS:
     implicit none
     type(gridmap_type), intent(in) :: gridmap   ! mapping data
     integer, optional :: nsrc                   ! size of source domain
     integer, optional :: ndst                   ! size of destination domain
     integer, optional :: ns                     ! number of non-zero elements in matrix
     integer,  optional, pointer :: dst_indx(:)  ! Destination index
     integer,  optional, pointer :: src_indx(:)  ! Destination index
     real(r8), optional, pointer :: yc_src(:)    ! "degrees" 
     real(r8), optional, pointer :: yc_dst(:)    ! "degrees" 
     real(r8), optional, pointer :: xc_src(:)    ! "degrees" 
     real(r8), optional, pointer :: xc_dst(:)    ! "degrees" 
     integer , optional, pointer :: mask_src(:)  ! "unitless" 
     integer , optional, pointer :: mask_dst(:)  ! "unitless" 
     real(r8), optional, pointer :: frac_src(:)  ! "unitless" 
     real(r8), optional, pointer :: frac_dst(:)  ! "unitless" 
!
! !REVISION HISTORY:
!   Created by Erik Kluzek
!
! !LOCAL VARIABLES:
!EOP
!------------------------------------------------------------------------------
     character(*),parameter :: subName = '(gridmap_setptrs) '

     call gridmap_checkifset( gridmap, subname )
     if ( present(nsrc)     ) nsrc     = gridmap%na
     if ( present(ndst)     ) ndst     = gridmap%nb
     if ( present(ns)       ) ns       = gridmap%ns
     if ( present(yc_src)   ) yc_src   => gridmap%yc_src
     if ( present(xc_src)   ) xc_src   => gridmap%xc_src
     if ( present(mask_src) ) mask_src => gridmap%mask_src
     if ( present(frac_src) ) frac_src => gridmap%frac_src
     if ( present(yc_dst)   ) yc_dst   => gridmap%yc_dst
     if ( present(xc_dst)   ) xc_dst   => gridmap%xc_dst
     if ( present(mask_dst) ) mask_dst => gridmap%mask_dst
     if ( present(frac_dst) ) frac_dst => gridmap%frac_dst
     if ( present(dst_indx) ) dst_indx => gridmap%dst_indx
     if ( present(src_indx) ) src_indx => gridmap%src_indx
  end subroutine gridmap_setptrs

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: gridmap_mapread
!
! !INTERFACE:
  subroutine gridmap_mapread(gridmap, fileName)
!
! !DESCRIPTION:
! This subroutine reads in the map file
!
! !USES:
    use mkutilsMod, only : convert_latlon
!
! !ARGUMENTS:
    implicit none
    include 'netcdf.inc'
    type(gridmap_type), intent(out) :: gridmap   ! mapping data
    character(len=*)   , intent(in)  :: filename  ! netCDF file to read
!
! !REVISION HISTORY:
!   Created by Mariana Vertenstein
!
! !LOCAL VARIABLES:
    integer :: n       ! generic loop indicies
    integer :: na      ! size of source domain
    integer :: nb      ! size of destination domain
    integer :: igrow   ! aVect index for matrix row
    integer :: igcol   ! aVect index for matrix column
    integer :: iwgt    ! aVect index for matrix element
    integer :: iarea   ! aVect index for area


    character,allocatable :: str(:)  ! variable length char string
    character(len=256)    :: attstr  ! netCDF attribute name string
    integer               :: rcode   ! netCDF routine return code
    integer               :: fid     ! netCDF file      ID
    integer               :: vid     ! netCDF variable  ID
    integer               :: did     ! netCDF dimension ID
    integer               :: ns      ! size of array

    real(r8), parameter   :: tol = 1.0e-5_r8  ! tolerance for checking that mapping data
                                              ! are within expected bounds

    !--- formats ---
    character(*),parameter :: subName = '(gridmap_map_read) '
    character(*),parameter :: F00 = '("(gridmap_map_read) ",4a)'
    character(*),parameter :: F01 = '("(gridmap_map_read) ",2(a,i7))'
!EOP
!------------------------------------------------------------------------------

    !-------------------------------------------------------------------------------
    !
    !-------------------------------------------------------------------------------

    write(6,F00) "reading mapping matrix data..."

    ! open & read the file
    write(6,F00) "* file name                  : ",trim(fileName)

    rcode = nf_open(filename ,NF_NOWRITE, fid)
    if (rcode /= NF_NOERR) write(6,F00) nf_strerror(rcode)

    !--- allocate memory & get matrix data ----------
    rcode = nf_inq_dimid (fid, 'n_s', did)  ! size of sparse matrix
    rcode = nf_inq_dimlen(fid, did  , gridmap%ns)
    rcode = nf_inq_dimid (fid, 'n_a', did)  ! size of  input vector
    rcode = nf_inq_dimlen(fid, did  , gridmap%na)
    rcode = nf_inq_dimid (fid, 'n_b', did)  ! size of output vector
    rcode = nf_inq_dimlen(fid, did  , gridmap%nb)

    write(6,*) "* matrix dimensions rows x cols :",gridmap%na,' x',gridmap%nb
    write(6,*) "* number of non-zero elements: ",gridmap%ns

    ns = gridmap%ns
    na = gridmap%na
    nb = gridmap%nb
    allocate(gridmap%wovr(ns)    , &
             gridmap%src_indx(ns), &
             gridmap%dst_indx(ns), &
             gridmap%mask_src(na), &
             gridmap%area_src(na), &
             gridmap%frac_src(na), &
             gridmap%area_dst(nb), &
             gridmap%frac_dst(nb), &
             gridmap%mask_dst(nb), &
             gridmap%xc_dst(nb),   &
             gridmap%yc_dst(nb),   &
             gridmap%xc_src(na),   &
             gridmap%yc_src(na), stat=rcode)
    if (rcode /= 0) then
       write(6,*) SubName//' ERROR: allocate gridmap'
       call abort()
    endif

    rcode = nf_inq_varid(fid,'S'  ,vid)
    rcode = nf_get_var_double(fid,vid  ,gridmap%wovr)
    if (rcode /= NF_NOERR) write(6,F00) nf_strerror(rcode)

    rcode = nf_inq_varid(fid,'row',vid)
    rcode = nf_get_var_int(fid, vid  ,gridmap%dst_indx)
    if (rcode /= NF_NOERR) write(6,F00) nf_strerror(rcode)

    rcode = nf_inq_varid(fid,'col',vid)
    rcode = nf_get_var_int(fid, vid, gridmap%src_indx)
    if (rcode /= NF_NOERR) write(6,F00) nf_strerror(rcode)

    rcode = nf_inq_varid(fid,'area_a',vid)
    rcode = nf_get_var_double(fid, vid, gridmap%area_src)
    if (rcode /= NF_NOERR) write(6,F00) nf_strerror(rcode)

    rcode = nf_inq_varid(fid,'area_b',vid)
    rcode = nf_get_var_double(fid, vid, gridmap%area_dst)
    if (rcode /= NF_NOERR) write(6,F00) nf_strerror(rcode)

    rcode = nf_inq_varid(fid,'frac_a',vid)
    rcode = nf_get_var_double(fid, vid, gridmap%frac_src)
    if (rcode /= NF_NOERR) write(6,F00) nf_strerror(rcode)
    if ( any(gridmap%frac_src(:) < 0.0_r8 .or. gridmap%frac_src > (1.0_r8 + tol)) )then
       write(6,*) SubName//' ERROR: frac_src out of bounds'
       write(6,*) 'max = ', maxval(gridmap%frac_src), ' min = ', minval(gridmap%frac_src)
       call abort()
    end if

    rcode = nf_inq_varid(fid,'frac_b',vid)
    rcode = nf_get_var_double(fid, vid, gridmap%frac_dst)
    if (rcode /= NF_NOERR) write(6,F00) nf_strerror(rcode)
    if ( any(gridmap%frac_dst(:) < 0.0_r8 .or. gridmap%frac_dst > (1.0_r8 + tol)) )then
       write(6,*) SubName//' ERROR: frac_dst out of bounds'
       write(6,*) 'max = ', maxval(gridmap%frac_dst), ' min = ', minval(gridmap%frac_dst)
       call abort()
    end if

    rcode = nf_inq_varid(fid,'mask_a',vid)
    rcode = nf_get_var_int(fid, vid, gridmap%mask_src)
    if (rcode /= NF_NOERR) write(6,F00) nf_strerror(rcode)
    if ( any(gridmap%mask_src(:) < 0 .or. gridmap%mask_src > 1) )then
       write(6,*) SubName//' ERROR: mask_src out of bounds'
       call abort()
    end if

    rcode = nf_inq_varid(fid,'mask_b',vid)
    rcode = nf_get_var_int(fid, vid, gridmap%mask_dst)
    if (rcode /= NF_NOERR) write(6,F00) nf_strerror(rcode)
    if ( any(gridmap%mask_dst(:) < 0 .or. gridmap%mask_dst > 1) )then
       write(6,*) SubName//' ERROR: mask_dst out of bounds'
       call abort()
    end if

    rcode = nf_inq_varid(fid,'xc_a',vid)
    rcode = nf_get_var_double(fid, vid, gridmap%xc_src)
    if (rcode /= NF_NOERR) write(6,F00) nf_strerror(rcode)
    call convert_latlon(fid, 'xc_a', gridmap%xc_src)

    rcode = nf_inq_varid(fid,'yc_a',vid)
    rcode = nf_get_var_double(fid, vid, gridmap%yc_src)
    if (rcode /= NF_NOERR) write(6,F00) nf_strerror(rcode)
    call convert_latlon(fid, 'yc_a', gridmap%yc_src)

    rcode = nf_inq_varid(fid,'xc_b',vid)
    rcode = nf_get_var_double(fid, vid, gridmap%xc_dst)
    if (rcode /= NF_NOERR) write(6,F00) nf_strerror(rcode)
    call convert_latlon(fid, 'xc_b', gridmap%xc_dst)

    rcode = nf_inq_varid(fid,'yc_b',vid)
    rcode = nf_get_var_double(fid, vid, gridmap%yc_dst)
    if (rcode /= NF_NOERR) write(6,F00) nf_strerror(rcode)
    call convert_latlon(fid, 'yc_b', gridmap%yc_dst)

    rcode = nf_close(fid)

    gridmap%set = IsSet

  end subroutine gridmap_mapread

!==========================================================================

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: gridmap_areaave_default
!
! !INTERFACE:
  subroutine gridmap_areaave_default (gridmap, src_array, dst_array)
!
! !DESCRIPTION:
! This subroutine does a simple area average
!
! !ARGUMENTS:
    implicit none
    type(gridmap_type) , intent(in) :: gridmap   ! gridmap data
    real(r8), intent(in) :: src_array(:)
    real(r8), intent(out):: dst_array(:)
!
! !REVISION HISTORY:
!   Created by Mariana Vertenstein
!
! !LOCAL VARIABLES:
    integer :: n,ns,ni,no
    real(r8):: wt,frac
    character(*),parameter :: subName = '(gridmap_areaave_default) '
!EOP
!------------------------------------------------------------------------------
    call gridmap_checkifset( gridmap, subname )
    dst_array = 0._r8
    do n = 1,gridmap%ns
       ni = gridmap%src_indx(n)
       no = gridmap%dst_indx(n)
       wt = gridmap%wovr(n)
       frac = gridmap%frac_dst(no)
       if (frac > 0.) then  
          dst_array(no) = dst_array(no) + wt * src_array(ni)/frac
       end if
    end do

  end subroutine gridmap_areaave_default

!==========================================================================

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: gridmap_areaave_srcmask
!
! !INTERFACE:
  subroutine gridmap_areaave_srcmask (gridmap, src_array, dst_array, mask_src)
!
! !DESCRIPTION:
! This subroutine does an area average with the source mask
!
! !ARGUMENTS:
     implicit none
    type(gridmap_type) , intent(in) :: gridmap   ! gridmap data
    real(r8), intent(in) :: src_array(:)
    real(r8), intent(out):: dst_array(:)
    real(r8), intent(in) :: mask_src(:)
!
! !REVISION HISTORY:
!   Created by Mariana Vertenstein
!
! !LOCAL VARIABLES:
    integer :: n,ns,ni,no
    real(r8):: wt
    real(r8), allocatable :: wtnorm(:)
    character(*),parameter :: subName = '(gridmap_areaave_srcmask) '
!EOP
!------------------------------------------------------------------------------
    call gridmap_checkifset( gridmap, subname )
    ns = size(dst_array)
    allocate(wtnorm(ns)) 
    wtnorm(:) = 0._r8

    do n = 1,gridmap%ns
       ni = gridmap%src_indx(n)
       no = gridmap%dst_indx(n)
       wt = gridmap%wovr(n)
       if (mask_src(ni) > 0) then
          wtnorm(no) = wtnorm(no) + wt*mask_src(ni)
       end if
    end do

    dst_array = 0._r8
    do n = 1,gridmap%ns
       ni = gridmap%src_indx(n)
       no = gridmap%dst_indx(n)
       wt = gridmap%wovr(n)
       if (mask_src(ni) > 0) then 
          dst_array(no) = dst_array(no) + wt*mask_src(ni)*src_array(ni)/wtnorm(no)
       end if
    end do

    deallocate(wtnorm)

  end subroutine gridmap_areaave_srcmask

!==========================================================================

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: gridmap_areaave_srcmask2
!
! !INTERFACE:
  subroutine gridmap_areaave_srcmask2 (gridmap, src_array, dst_array, mask_src, &
       mask_dst, mask_dst_min)
!
! !DESCRIPTION:
! This subroutine does an area average with the source mask and making sure the
! destination mask is valid as well.
!
! !ARGUMENTS:
    implicit none
    type(gridmap_type) , intent(in) :: gridmap   ! gridmap data
    real(r8), intent(in) :: src_array(:)
    real(r8), intent(out):: dst_array(:)
    real(r8), intent(in) :: mask_src(:)
    real(r8), intent(in) :: mask_dst(:)
    real(r8), intent(in) :: mask_dst_min
!
! !REVISION HISTORY:
!   Created by Mariana Vertenstein
!
! !LOCAL VARIABLES:
    integer :: n,ns,ni,no
    real(r8):: wt
    real(r8), allocatable :: wtnorm(:)
    character(*),parameter :: subName = '(gridmap_areaave_srcmask2) '
!EOP
!------------------------------------------------------------------------------

    call gridmap_checkifset( gridmap, subname )
    ns = size(dst_array)
    allocate(wtnorm(ns)) 
    wtnorm(:) = 0._r8

    do n = 1,gridmap%ns
       ni = gridmap%src_indx(n)
       no = gridmap%dst_indx(n)
       wt = gridmap%wovr(n)
       if (mask_src(ni) > 0) then
          wtnorm(no) = wtnorm(no) + wt*mask_src(ni)
       end if
    end do

    dst_array = 0._r8
    do n = 1,gridmap%ns
       ni = gridmap%src_indx(n)
       no = gridmap%dst_indx(n)
       wt = gridmap%wovr(n)
       if (mask_dst(no) > mask_dst_min) then
          if (mask_src(ni) > 0) then 
             dst_array(no) = dst_array(no) + wt*mask_src(ni)*src_array(ni)/wtnorm(no)
          end if
       end if
    end do

    deallocate(wtnorm)

  end subroutine gridmap_areaave_srcmask2

!==========================================================================

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: gridmap_clean
!
! !INTERFACE:
  subroutine gridmap_clean(gridmap)
!
! !DESCRIPTION:
! This subroutine deallocates the gridmap type
!
! !ARGUMENTS:
    implicit none
    type(gridmap_type), intent(inout)       :: gridmap
!
! !REVISION HISTORY:
!   Created by Mariana Vertenstein
!
! !LOCAL VARIABLES:
    character(len=*), parameter :: subName = "gridmap_clean"
    integer ier    ! error flag
!EOP
!------------------------------------------------------------------------------
    if ( gridmap%set .eq. IsSet )then
       deallocate(gridmap%wovr    , &
                  gridmap%src_indx, &
                  gridmap%dst_indx, &
                  gridmap%mask_src, &
                  gridmap%mask_dst, &
                  gridmap%area_src, &
                  gridmap%area_dst, &
                  gridmap%frac_src, &
                  gridmap%frac_dst, &
                  gridmap%xc_src,   &
                  gridmap%yc_src, stat=ier)
       if (ier /= 0) then
          write(6,*) SubName//' ERROR: deallocate gridmap'
          call abort()
       endif
    else
       write(6,*) SubName//' Warning: calling '//trim(subName)//' on unallocated gridmap'
    end if
    gridmap%set = "NOT-set"

  end subroutine gridmap_clean

!==========================================================================

  subroutine gridmap_checkifset( gridmap, subname )

    implicit none
    type(gridmap_type), intent(in) :: gridmap
    character(len=*),   intent(in) :: subname

    if ( gridmap%set .ne. IsSet )then
       write(6,*) SubName//' ERROR: gridmap NOT set yet, run gridmap_mapread first'
       call abort()
    end if
  end subroutine gridmap_checkifset

end module mkgridmapMod

program fmain

  use shr_kind_mod, only: r8 => shr_kind_r8

  implicit none

  include 'netcdf.inc'
!
! Local workspace
!
  real(r8), parameter :: fillvalue = 1.d36
  real(r8), parameter :: filter_coefficient = 0.25D0

  character(len=128) :: topofile  = ' ' ! input high resolution (10 min) file name
  character(len=128) :: landmfile = ' ' ! input land mask file name
  character(len=128) :: gridfile  = ' ' ! input initial condition file with grid definition
  character(len=128) :: outbcfile = ' ' ! output boundary condition file with PHIS, SGH, etc.
  character(len= 80) :: arg             ! used for parsing command line arguments
  character(len=256) :: cmdline         ! input command line
  character(len=256) :: history         ! history attribute text
  character(len=  8) :: datestring
  character(len= 32) :: z_filter_type   ! type of filter applied to height
  character(len= 32) :: s_filter_type   ! type of filter applied to standard deviations

  logical verbose                       ! Add print statements
  logical make_ross                     ! Make Ross ice shelf south of -79
  logical filter_del2                   ! Execute SJ Lin's del2 terrain filter
  logical filter_remap                  ! Execute SJ Lin's newer remapping terrain filter
  logical filter_sgh                    ! Filter SGH and SGH30 in addition to height
  logical reduced_grid                  ! reduced grid defined
  logical have_sgh30                    ! input topofile has sgh30, output will also

  integer cmdlen                        ! character array lengths
  integer gridid
  integer foutid                        ! output file id
  integer lonid, londimid, rlonid       ! longitude dimension variable ids
  integer latid, latdimid               ! latitude  dimension variable ids
  integer sghid, phisid, landfid, nlonid, landmid, sgh30id ! output variable netcdf ids
  integer start(4), count(4)
  integer plon, nlat
  integer i, j
  integer ret
  integer nargs                        ! input arg
  integer n                            ! index loops thru input args

  integer dim(2)                        ! dimension list for output variables

  integer , allocatable :: nlon(:)
  real(r8), allocatable :: mlatcnts(:)    ! model cell center latitudes
  real(r8), allocatable :: mloncnts(:,:)  ! model cell center longitudes
  real(r8), allocatable :: sgh(:,:)
  real(r8), allocatable :: sgh30(:,:)
  real(r8), allocatable :: phis(:,:)
  real(r8), allocatable :: fland(:,:)
  real(r8), allocatable :: landm(:,:)

  integer iargc
  external iargc
!
! Default settings before parsing argument list
!
  verbose      = .false.
  make_ross    = .true.
  filter_del2  = .false.
  filter_remap = .false.
  filter_sgh   = .false.
  reduced_grid = .false.

! parse input arguments

  nargs = iargc()
  n = 1
  cmdline = char(10) // 'definesurf '
  do while (n .le. nargs)
    arg = ' '
    call getarg (n, arg)
    n = n + 1

    select case (arg)
! topography file name (10')
    case ('-t')
      call getarg (n, arg)
      n = n + 1
      topofile = arg
      cmdline = trim(cmdline) // ' -t ' // trim(topofile)
! grid file name
    case ('-g')
      call getarg (n, arg)
      n = n + 1
      gridfile = arg
      cmdline = trim(cmdline) // ' -g ' // trim(gridfile)
! verbose mode
    case ('-v')
      verbose = .true.
      cmdline = trim(cmdline) // ' -v'
! landmask file name
    case ('-l')
      call getarg (n, arg)
      n = n + 1
      landmfile = arg
      cmdline = trim(cmdline) // ' -l ' // trim(landmfile)
! extend Ross Sea
    case ('-r')
      make_ross = .false.
      cmdline = trim(cmdline) // ' -r'
! use del2 filter on heights
    case ('-del2')
      filter_del2 = .true.
      cmdline = trim(cmdline) // ' -del2'
! use remap filter on heights
    case ('-remap')
      filter_remap = .true.
      cmdline = trim(cmdline) // ' -remap'
! apply filter to sgh (and sgh30) in addition to height
    case ('-sgh')
      filter_sgh = .true.
      cmdline = trim(cmdline) // ' -sgh'
! not one of the above, must be output file name
    case default
      if (outbcfile .eq. ' ') then
        outbcfile = arg
      else
        write (6,*) 'Argument ', arg,' is not known'
        call usage_exit (' ')
      end if
      cmdline = trim(cmdline) // ' ' // trim(arg)
    end select
  end do
  
  if (outbcfile == ' ') then
    call usage_exit ('Must enter an output file name')
  end if
  
  if (gridfile == ' ') then
    call usage_exit ('Must enter gridfile name via -g arg (can use a model history file)')
  end if

  if (topofile == ' ') then
    call usage_exit ('Must enter topofile name via -t arg')
  end if

  if (filter_remap .and. filter_del2) then
     write(6,*)'Both filter_remap and filter_del2 set: using filter_remap'
  end if

  if (.not. filter_remap .and. .not. filter_del2) then
     write(6,*)'No filter being applied to height field'
     if (filter_sgh) call usage_exit ('Must filter height to filter sgh')
  end if

  if (landmfile == ' ') then
    call usage_exit ('Must enter landmfile name via -l arg')
  end if

! Open the grid file 
  ret = nf_open (trim(gridfile), nf_nowrite, gridid) 
  if (ret /= nf_noerr) then
    write(6,*)nf_strerror(ret)
    write(6,*)'Unable to open input file ', trim(gridfile), ' for writing'
    stop 999
  end if

! Get the grid dimensions from the grid file
  call wrap_inq_dimid  (gridid, 'lon',    londimid)
  call wrap_inq_dimlen (gridid, londimid, plon    )
  call wrap_inq_dimid  (gridid, 'lat',    latdimid)
  call wrap_inq_dimlen (gridid, latdimid, nlat    )
!
! Get longitude and latitude arrays for model grid.  
! If reduced grid, 2-d variable containing lon values for each lat is called "rlon".
! First allocate space for dynamic arrays now that sizes are known
!
  allocate (nlon(nlat))
  allocate (mlatcnts(nlat))
  allocate (mloncnts(plon,nlat))

  if (nf_inq_varid (gridid, 'nlon', nlonid) == nf_noerr) then
    if (nf_get_var_int (gridid, nlonid, nlon) /= nf_noerr) then
      write(6,*)'nf_get_var_int() failed for nlon'
      call endrun
    end if
    reduced_grid = .true.
  else
    nlon(:) = plon
  end if
    
  do j=1,nlat 
    if (nlon(j)<1 .or. nlon(j)>plon) then
      write(6,*)'nlon(',j,')=',nlon(j),' is invalid.'
      write(6,*)'Must be between 1 and ',plon
      call endrun
    end if
  end do

  call wrap_inq_varid (gridid, 'lat', latid)
  call wrap_get_var8 (gridid, latid, mlatcnts)

  if (nf_inq_varid (gridid, 'lon', lonid) == nf_noerr) then
     call wrap_get_var8 (gridid, lonid, mloncnts(1,1))
     do j=2,nlat
        mloncnts(:,j) = mloncnts(:,1)
     end do
  else
     call wrap_inq_varid (gridid, 'rlon', rlonid)
     call wrap_get_var8 (gridid, rlonid, mloncnts)
  end if

! Close the grid file
  if (nf_close (gridid) == nf_noerr) then
    write(6,*) 'close grid file ', trim(gridfile)
  else
    write(6,*) 'ERROR CLOSING NETCDF FILE ',trim(gridfile)
  end if
!
! Allocate space for variables
!
  allocate (sgh(plon,nlat))
  allocate (sgh30(plon,nlat))
  allocate (phis(plon,nlat))
  allocate (fland(plon,nlat))
  allocate (landm(plon,nlat))
!
! Determine model topographic height and 2 standard deviations
!
  call sghphis (plon, nlat, nlon, mlatcnts, mloncnts, topofile, &
                verbose, sgh, sgh30, have_sgh30, phis, fland)

! Do the terrain filter.
! Note: not valid if a reduced grid is used.
  if (filter_remap) then
     z_filter_type = 'remap'
     write(6,*)'Remapping terrain filtering'
! 7 and 3 are the recommended mapping accuracy settings 
     call map2f (plon, nlat, phis, 7, 3, .true.)
     if (filter_sgh) then
        s_filter_type = 'remap'
        write(6,*)'Filtering standard deviation'
        call map2f (plon, nlat, sgh, 7, 3, .true.)
        if(have_sgh30) call map2f(plon, nlat, sgh30, 7, 3, .true.)
     else
        s_filter_type = 'none (2x[1-2-1])'
        write(6,*)'Not filtering standard deviation'
     end if
  else if (filter_del2) then
     z_filter_type = 'del2'
     write(6,*) 'Del2 Terrain filtering'
     call sm2(plon, nlat, phis, plon/12, filter_coefficient)
     if (filter_sgh) then
        s_filter_type = 'del2'
        write(6,*)'Filtering standard deviation'
        call sm2(plon, nlat, sgh,  plon/12, filter_coefficient)
        if(have_sgh30) call sm2(plon, nlat, sgh30,  plon/12, filter_coefficient)
     else
        s_filter_type = 'none (2x[1-2-1])'
        write(6,*)'Not filtering standard deviation'
     end if
  else
     z_filter_type = 'none'
     s_filter_type = 'none (2x[1-2-1])'
  endif
!
! Adjustments to land fraction:
! 1. Extend land fraction for Ross Ice shelf
! 2. Set land fractions < .001 to 0.0
! 3. flag regions outside reduced grid
!
  do j=1,nlat
    do i=1,nlon(j)
!
! Overwrite FLAND flag as land for Ross ice shelf
      if (make_ross .and. mlatcnts(j) < -79.) then
        fland(i,j) = 1.
      end if

      if (fland(i,j) < .001_r8) fland(i,j) = 0.0

    end do
!
! Fill region outside reduced grid with flag values
    do i=nlon(j)+1,plon
      sgh(i,j)   = fillvalue
      if(have_sgh30) sgh30(i,j)   = fillvalue
      phis(i,j)  = fillvalue
      fland(i,j)   = fillvalue
      landm(i,j) = fillvalue
    end do
  end do
!
! Calculate LANDM field required by cloud water.  
!
!JR Replace original resolution-dependent calculation with interpolation.
!JR
!JR  call inimland (plon, nlat, nlon, mlatcnts, mloncnts, topofile, &
!JR                 verbose, make_ross, landm)
!
  call interplandm (plon, nlat, nlon, mlatcnts, mloncnts, &
                    landmfile, landm)

! Create NetCDF file for output
  ret = nf_create (outbcfile, NF_CLOBBER, foutid)
  if (ret .ne. NF_NOERR) call handle_error(ret)

! Create dimensions for output
  call wrap_def_dim (foutid, 'lon', plon, lonid)
  call wrap_def_dim (foutid, 'lat', nlat, latid)
  dim(1)=lonid
  dim(2)=latid

! Create latitude dimension variable for output
  ret = nf_def_var (foutid,'lat', NF_DOUBLE, 1, latid, latdimid)
  if (ret .ne. NF_NOERR) call handle_error(ret)
  call wrap_put_att_text (foutid,latdimid,'long_name', 'latitude')
  call wrap_put_att_text (foutid,latdimid,'units'    , 'degrees_north')

! Create longitude dimension variable for output
  if (.not.reduced_grid) then
     ret = nf_def_var (foutid,'lon', NF_DOUBLE, 1, lonid, londimid)
     if (ret .ne. NF_NOERR) call handle_error(ret)
     call wrap_put_att_text (foutid,londimid,'long_name', 'longitude')
     call wrap_put_att_text (foutid,londimid,'units'    , 'degrees_east')

! For reduced grid, add longitude limits (nlon) and lons (rlon)
  else
     ret = nf_def_var (foutid,'nlon', NF_INT, 1, lonid, londimid)
     if (ret .ne. NF_NOERR) call handle_error(ret)
     ret = nf_def_var (foutid,'rlon', NF_DOUBLE, 2, dim, rlonid)
     if (ret .ne. NF_NOERR) call handle_error(ret)
     call wrap_put_att_text (foutid,rlonid,'long_name', 'longitude')
     call wrap_put_att_text (foutid,rlonid,'units'    , 'degrees_east')
  end if

! Create variables for output
  ret = nf_def_var (foutid,'PHIS'        , NF_DOUBLE, 2, dim, phisid)
  if (ret .ne. NF_NOERR) call handle_error(ret)
  call wrap_put_att_double (foutid, phisid, '_FillValue', nf_double, 1, fillvalue)
  call wrap_put_att_double (foutid, phisid, 'missing_value', nf_double, 1, fillvalue)
  call wrap_put_att_text   (foutid, phisid, 'long_name' , 'surface geopotential')
  call wrap_put_att_text   (foutid, phisid, 'units'     , 'm2/s2')
  call wrap_put_att_text   (foutid, phisid, 'from_hires', 'true')
  call wrap_put_att_text   (foutid, phisid, 'filter'    , z_filter_type)

  ret = nf_def_var (foutid,'SGH'         , NF_DOUBLE, 2, dim, sghid)
  if (ret .ne. NF_NOERR) call handle_error(ret)
  call wrap_put_att_double (foutid, sghid, '_FillValue', nf_double, 1, fillvalue)
  call wrap_put_att_double (foutid, sghid, 'missing_value', nf_double, 1, fillvalue)
  call wrap_put_att_text   (foutid, sghid, 'long_name' , 'standard deviation of 10-min elevations')
  call wrap_put_att_text   (foutid, sghid, 'units'     , 'm')
  call wrap_put_att_text   (foutid, sghid, 'from_hires', 'true')
  call wrap_put_att_text   (foutid, sghid, 'filter'    , s_filter_type)

  if (have_sgh30) then
     ret = nf_def_var (foutid,'SGH30'       , NF_DOUBLE, 2, dim, sgh30id)
     if (ret .ne. NF_NOERR) call handle_error(ret)
     call wrap_put_att_double (foutid, sgh30id, '_FillValue', nf_double, 1, fillvalue)
     call wrap_put_att_double (foutid, sgh30id, 'missing_value', nf_double, 1, fillvalue)
     call wrap_put_att_text   (foutid, sgh30id, 'long_name' , 'standard deviation of elevation from 30s to 10m')
     call wrap_put_att_text   (foutid, sgh30id, 'units'     , 'm')
     call wrap_put_att_text   (foutid, sgh30id, 'from_hires', 'true')
     call wrap_put_att_text   (foutid, sgh30id, 'filter'    , s_filter_type)
  endif

  ret = nf_def_var (foutid,'LANDFRAC'    , NF_DOUBLE, 2, dim, landfid)
  if (ret .ne. NF_NOERR) call handle_error(ret)
  call wrap_put_att_double (foutid, landfid, '_FillValue', nf_double, 1, fillvalue)
  call wrap_put_att_double (foutid, landfid, 'missing_value', nf_double, 1, fillvalue)
  call wrap_put_att_text   (foutid, landfid, 'long_name' , 'gridbox land fraction')
  call wrap_put_att_text   (foutid, landfid, 'from_hires', 'true')

  ret = nf_def_var (foutid,'LANDM_COSLAT', NF_DOUBLE, 2, dim, landmid)
  if (ret .ne. NF_NOERR) call handle_error(ret)
  call wrap_put_att_double (foutid, landmid, '_FillValue', nf_double, 1, fillvalue)
  call wrap_put_att_double (foutid, landmid, 'missing_value', nf_double, 1, fillvalue)
  call wrap_put_att_text   (foutid, landmid, 'long_name' , &
                          'land ocean transition mask: ocean (0), continent (1), transition (0-1)')
  call wrap_put_att_text   (foutid, landmid, 'from_hires', 'true')

! Define history attribute.
  call DATE_AND_TIME(DATE=datestring)
  history = 'Written on date: ' // datestring // cmdline
  call wrap_put_att_text (foutid, nf_global, 'history', history)

! Define Ross Sea attribute
  if (make_ross) then
    write (6,*) 'Extending Ross ice shelf south of -79 degrees'
    call wrap_put_att_text (foutid, nf_global, 'make_ross', 'true')
  else
    write (6,*) 'Not doing anything special for Ross ice shelf'
    call wrap_put_att_text (foutid, nf_global, 'make_ross', 'false')
  end if

! Define source file attributes
  call wrap_put_att_text (foutid, nf_global, 'topofile', topofile)
  cmdlen = len_trim (gridfile)
  call wrap_put_att_text (foutid, nf_global, 'gridfile', gridfile)
  cmdlen = len_trim (landmfile)
  call wrap_put_att_text (foutid, nf_global, 'landmask', landmfile)


! End definition of netCDF file
  ret = nf_enddef (foutid)
  if (ret/=NF_NOERR) call handle_error (ret)


! Write data to file
  write(6,*) 'Writing surface quantities'

! Write dimension variables
  call wrap_put_var8 (foutid, latdimid, mlatcnts)
  if (.not.reduced_grid) then
     call wrap_put_var8 (foutid, londimid, mloncnts(:,1))
  else
     ret = nf_put_var_int (foutid, nlonid, nlon)
     if (ret/=NF_NOERR) call handle_error (ret)
     call wrap_put_vara8 (foutid, rlonid, start, count, mloncnts)
  end if

  start(:) = 1
  count(1) = plon
  count(2) = nlat
  count(3:) = 1

  call wrap_put_vara8 (foutid, sghid,   start, count, sgh)
  if(have_sgh30) call wrap_put_vara8 (foutid, sgh30id,   start, count, sgh30)
  call wrap_put_vara8 (foutid, phisid , start, count, phis)
  call wrap_put_vara8 (foutid, landfid, start, count, fland)
  call wrap_put_vara8 (foutid, landmid, start, count, landm)

  if (nf_close (foutid) == nf_noerr) then
    write(6,*) 'Successfully defined surface quantities on ', trim(outbcfile)
  else
    write(6,*) 'ERROR CLOSING NETCDF FILE ',trim(outbcfile)
  end if

  deallocate (nlon)
  deallocate (mlatcnts)
  deallocate (mloncnts)
  deallocate (sgh) 
  deallocate (sgh30)
  deallocate (phis)
  deallocate (fland)
  deallocate (landm)

  stop 0
end program fmain

subroutine usage_exit (arg)
  implicit none
  character*(*) arg
  
  if (arg /= ' ') write (6,*) arg
  write (6,*) 'Usage: definesurf -t topofile -g gridfile -l landmfile [-v] [-r] [-del2] [-remap] outfile'
  write (6,*) '       -v     verbose mode'
  write (6,*) '       -r     Do *not* extend Ross Ice Shelf as land ice'
  write (6,*) '       -del2  use del2 terrain filter (not a valid option for reduced grid)'
  write (6,*) '       -remap use remapping filter (not a valid option for reduced grid)'
  write (6,*) '       -sgh   filter sgh and sgh30 using same terrain filter'
  stop 999
end subroutine usage_exit

subroutine interplandm (plono, nlato, nlono, lato, rlono, &
                        landmfile, landmo) 
!
! Read LANDM_COSLAT from input file and interpolate to output grid.
! The input grid is assumed rectangular, but the output grid may
! be reduced.
!
  use shr_kind_mod, only: r8 => shr_kind_r8

  implicit none

  include 'netcdf.inc'
!
! Input arguments
!
  integer , intent(in) :: plono                ! output longitude dimension
  integer , intent(in) :: nlato                ! number of latitudes
  integer , intent(in) :: nlono(nlato)         ! number of reduced latitudes
  real(r8), intent(in) :: lato(nlato)          ! latitude at center of grid cell
  real(r8), intent(in) :: rlono(plono,nlato)   ! longitude on (potentially reduced) output grid
  character(len=*), intent(in) :: landmfile    ! file containing input LANDM_COSLAT
!
! Output arguments
!
  real(r8), intent(out) :: landmo(plono,nlato) ! landm on reduced grid

! Local variables

  integer :: nloni
  integer :: nlati
  integer :: i,j                    ! spatial indices
  integer :: ret                    ! return code

  integer :: landmfileid                     ! netcdf file id for landm file
  integer :: londimid, latdimid              ! lon, lat dimension ids
  integer :: lonid, latid                    ! lon, lat var ids
  integer :: landmid                         ! landm variable id

  real(r8), allocatable :: landmi(:,:)       ! landm on full grid
  real(r8), allocatable :: lati(:)
  real(r8), allocatable :: loni(:)
  real(r8), allocatable :: xtemp(:,:)        ! temporary for interpolation

  ret = nf_open (landmfile, nf_nowrite, landmfileid)
  if (ret /= nf_noerr) then
     write(6,*)nf_strerror(ret)
     write(6,*)'Unable to open input file ', trim (landmfile)
     stop 999
  end if
!
! Retrieve grid info and LANDM_COSLAT field from from offline file.
!
  call wrap_inq_dimid (landmfileid, 'lat', latdimid)
  call wrap_inq_dimlen (landmfileid, latdimid, nlati)

  call wrap_inq_dimid (landmfileid, 'lon', londimid)
  call wrap_inq_dimlen (landmfileid, londimid, nloni)

  allocate (lati(nlati))
  allocate (loni(nloni))
  allocate (landmi(nloni,nlati))

  call wrap_inq_varid (landmfileid, 'lat', latid)
  call wrap_get_var8 (landmfileid, latid, lati)

  call wrap_inq_varid (landmfileid, 'lon', lonid)
  call wrap_get_var8 (landmfileid, lonid, loni)

  call wrap_inq_varid (landmfileid, 'LANDM_COSLAT', landmid)
  call wrap_get_var8 (landmfileid, landmid, landmi)

  allocate (xtemp(nloni,nlato))
!
! For rectangular -> reduced, interpolate first in latitude, then longitude
!
  do i=1,nloni
     call lininterp (landmi(i,1), nlati, nloni, lati, &
                     xtemp(i,1), nlato, nloni, lato, .false.)
  end do

  do j=1,nlato
    call lininterp (xtemp(1,j), nloni, 1, loni, &
                    landmo(1,j), nlono(j), 1, rlono(1,j), .true.)
  end do

  deallocate (xtemp)
  deallocate (lati)
  deallocate (loni)
  deallocate (landmi)

  return
end subroutine interplandm

subroutine driver(ncidi, ncido, ncidt, ntime)

   use shr_kind_mod,   only: r8 => shr_kind_r8
   use control,        only: verbose, prec_override, prec_out, is_user_skip
   use dimensions,     only: ncoldimid, get_shape
   use fill_positions, only: varspec_t, fillvar
   use interp,         only: interp_driver

   implicit none

   include 'netcdf.inc'

   ! Input arguments

   integer ncidi, ncido, ncidt     ! input, output, template netcdf file ids
   integer ntime                   ! size of unlimited dimension (if present) in "input" file

   ! Local workspace

   character*8 :: shapei                   ! dimension order of variable on input file
   character*8 :: shapeo                   ! dimension order of variable on output file
   character*(nf_max_name) :: name         ! name of variable on input and output file
   character*(nf_max_name) :: dimnamesi(4) ! dimension names of a variable on the input file
   character*(nf_max_name) :: dimnames(4)  ! dimension names for output variable
   character*(nf_max_name) :: attname

   integer :: ndims, nvars, ngatts, unlimdimid

   integer :: natts                        ! number of attributes for a given variable
   integer :: nvdims, nvdimsi              ! number of dimensions for this variable
   integer :: vardids_i(nf_max_var_dims) ! variable dimension id's
   integer :: vardids_o(nf_max_var_dims)   ! variable dimension id's on output file
   integer :: j, k       ! spatial indices
   integer :: n      ! index
   integer :: t      ! index over unlimited dimension
   integer :: v, vi, vo            ! loop index over variable id
   integer :: vidi                 ! variable id on input file
   integer :: vido                 ! returned variable id on output file
   integer :: nxi, nyi, nzi
   integer :: nxo, nyo, nzo
   integer :: xtype, xtypeo            ! variable type (netcdf)
   integer :: tpos                     ! position of unlimited dimension
   integer :: ncp   = 0                ! number of variables to copy from input to output
   integer :: nintp = 0                ! number of variables that require interpolation
   integer :: starti(nf_max_var_dims)
   integer :: starto(nf_max_var_dims)
   integer :: counto(nf_max_var_dims)
   integer :: counti(nf_max_var_dims)
   integer :: totsiz
   integer, allocatable :: indx_cp(:)           ! input file var IDs for variables to be copied
   integer, allocatable :: indx_intp(:)         ! input file var IDs for variables to be interpolated
   integer :: i
   logical :: copy

   real(r8), target, allocatable :: arr3d_i(:,:,:)
   real(r8), pointer     :: arr3d_o(:,:,:)
   real(r8), pointer     :: arrxyzi(:,:,:)
   real(r8), target, allocatable :: arrxyzo(:,:,:)
   real,     allocatable :: arr3d_o_r4(:,:,:)

   type(varspec_t), allocatable :: varspec_i(:)
   type(varspec_t), allocatable :: varspec_o(:)

   logical :: is_special_case
   !-----------------------------------------------------------------------------

   ! loop over variables in "input" dataset
   call wrap_inq(ncidi, ndims, nvars, ngatts, unlimdimid)

   allocate(indx_cp(nvars))
   allocate(indx_intp(nvars))
   allocate(varspec_i(nvars))
   allocate(varspec_o(nvars))
   indx_cp(:)   = -1
   indx_intp(:) = -1

   do vidi = 1, nvars

      copy = .true.
    
      call wrap_inq_var(ncidi, vidi, name, xtype, nvdimsi, vardids_i, natts)

      ! Skip any special case variables: they have already been copied to the output file.
      if (is_special_case(name)) then
         if (verbose) write(6,*)'skipping special case var ',trim(name)
         cycle
      end if

      ! Skip any variables requested by user
      if (is_user_skip(name)) then
         if (verbose) write(6,*)'skipping user requested var ',trim(name)
         cycle
      end if

      ! return name of each dimension (dimnamesi), and the axis ordering (shapei)
      shapei = get_shape(ncidi, vardids_i, nvdimsi, dimnamesi)

      vardids_o = 0
      nvdims    = nvdimsi
      shapeo    = ' '

      ! Set arrays containing information needed to define the variable
      ! in the output file.

      if (ncoldimid > 0 .and. (shapei(1:2)=='xz' .or. shapei(1:2)=='xy')) then

         ! If the template file contains an "ncol" dimension then, then the output
         ! file uses an unstructured grid.  If the input file contains variables on
         ! a rectangular grid, then the 'xy' dimensions need to be compressed to a
         ! single column dimension 'n'.

         if (shapei .eq. 'xzy') then

            dimnames(1)  = 'ncol'
            vardids_o(1) = ncoldimid
            dimnames(2)  = dimnamesi(2)
            vardids_o(2) = get_dimid_o(dimnamesi(2))

            if (nvdimsi > 3) then
               dimnames(3)  = dimnamesi(4)
               vardids_o(3) = get_dimid_o(dimnamesi(4))
            end if

            nvdims = nvdimsi-1
            shapeo = 'nz'

         else if (shapei .eq. 'xyz') then

            dimnames(1)  = 'ncol'
            vardids_o(1) = ncoldimid
            dimnames(2)  = dimnamesi(3)
            vardids_o(2) = get_dimid_o(dimnamesi(3))

            if (nvdimsi > 3) then
               dimnames(3)  = dimnamesi(4)
               vardids_o(3) = get_dimid_o(dimnamesi(4))
            end if

            nvdims = nvdimsi-1
            shapeo = 'nz'

         else if(shapei .eq. 'xy') then

            dimnames(1)  = 'ncol'
            vardids_o(1) = ncoldimid

            if (nvdimsi > 2) then
               dimnames(2)  = dimnamesi(3)
               vardids_o(2) = get_dimid_o(dimnamesi(3))
            end if

            nvdims = nvdimsi - 1
            shapeo = 'n'

         end if

      else

         ! Assume that the dimension names on the output file match the
         ! dimension names on the input file.  Get the dimension ID from the 
         ! output file since that may be different from the ID in the input
         ! file.
         do i = 1, nvdimsi
            vardids_o(i) = get_dimid_o(dimnamesi(i))
         end do

         dimnames = dimnamesi
         nvdims   = nvdimsi
         shapeo   = shapei

      end if

      ! Allow override of real precision for output fields on 2D or 3D spatial grid
      xtypeo = xtype
      if (shapei(1:2) == 'xy' .or. shapei(1:2) == 'xz') then
         if (prec_override) then
            xtypeo = prec_out
         end if
      end if

      ! Define variable on output file with same type and dimension order as variable
      ! on input file
      if (nf_def_var(ncido, name, xtypeo, nvdims, vardids_o, vido) /= nf_noerr) then
         print*, 'driver: ERROR defining variable ', trim(name), ' type=', xtypeo
         print*, 'nvdims=', nvdims, ' dids=',vardids_o(1:nvdims)
         stop
         !      call wrap_def_var (ncido, name, xtypeo, nvdims, vardids_o, vido)
      else
         print*, 'create var ', trim(name), ' ndims=', nvdims, ' dids=', vardids_o(1:nvdims), ' vid=', vido
      end if

      ! Copy variable's attributes from input to output
      do n = 1, natts
         call wrap_inq_attname (ncidi, vidi, n, attname)
         call wrap_copy_att (ncidi, vidi, attname, ncido, vido)
      end do

      if (xtype == NF_FLOAT .or. xtype == NF_DOUBLE) then

         ! Interpolated variables must be of a floating point type and have dimensions
         ! xy, xyz, or xzy.
         ! Assumption: All variables using a horizontal grid need to be interpolated.
         if (shapeo == 'xy' .or. shapeo == 'xyz' .or. shapeo == 'xzy' .or. shapeo == 'n' .or. shapeo =='nz') then

            copy = .false.
            nintp = nintp + 1
            indx_intp(nintp) = vidi
         end if
      end if

      ! Variables to be copied will not be interpolated.
      if (copy) then
         ncp = ncp + 1
         indx_cp(ncp) = vidi
      end if

      ! Set the varspec_i array with coordinate information for each variable
      ! from the input file.
      call fillvar(ncidi, name, xtype, shapei, dimnamesi, &
                   vidi, nvdimsi, vardids_i, varspec_i(vidi))

      
      ! Set the varspec_o array with coordinate information for each variable
      ! from the output file.
      call fillvar(ncido, name, xtypeo, shapeo, dimnames, &
                   vido, nvdims, vardids_o, varspec_o(vidi))

      call compare_var(varspec_i(vidi), varspec_o(vidi))

      shapeo=''
      shapei=''
      dimnames=''

   end do         ! loop over input variables

   ! Take the output file out of define mode
   if (nf_enddef(ncido) /= NF_NOERR) then
      print *,'ERROR:  nf_enddef(ncido) = ',nf_enddef(ncido)
      stop
   endif

   ! Now loop over the time dimension.  First do copies
   if (verbose) write(6,*)'Copy and interpolate from input to output.  ntime=',ntime
   do t = 1, ntime

      if (verbose) write(6,*)'Starting time sample ',t

      do n = 1, ncp
         v           = indx_cp(n)
         name        = varspec_i(v)%name
         totsiz      = varspec_i(v)%totsiz
         xtype       = varspec_i(v)%xtype
         vi          = varspec_i(v)%varid
         vo          = varspec_o(v)%varid
         starti(:)   = 1
         counto(:)    = varspec_i(v)%count(:)

         if (varspec_i(v)%tpos > 0) then
            tpos      = varspec_i(v)%tpos
            starti(tpos) = t
         end if

         if (verbose) then
            write(6,*)'Copying variable ',trim(name), vi, vo
         end if

         call cpvar(ncidi, ncido, vi, vo, name, &
                    totsiz, xtype, starti, counto)
      end do

      ! Now the data which need to be interpolated

      do n = 1, nintp

         v           = indx_intp(n)

         name        = varspec_i(v)%name

         if (verbose) then
            write(6,*) 'Interpolating '//trim(name)
         end if

         vi          = varspec_i(v)%varid
         shapei      = varspec_i(v)%vshape
         nxi         = varspec_i(v)%nx
         nyi         = varspec_i(v)%ny
         nzi         = varspec_i(v)%nz
         counti(:)   = varspec_i(v)%count(:)

         if (verbose) then
            write(6,'(a16,a3,3(a5,i6))') '  input:  shape=', trim(shapei), '  nx=', nxi, '  ny=', nyi, '  nz=', nzi
         end if

         vo          = varspec_o(v)%varid
         shapeo      = varspec_o(v)%vshape
         nxo         = varspec_o(v)%nx
         nyo         = varspec_o(v)%ny
         nzo         = varspec_o(v)%nz
         counto(:)    = varspec_o(v)%count

         if (verbose) then
            write(6,'(a16,a3,3(a5,i6))') '  output: shape=', trim(shapeo), '  nx=', nxo, '  ny=', nyo, '  nz=', nzo
         end if


         starti(:)    = 1
         starto(:)    = 1

         if (varspec_i(v)%tpos > 0) then
            tpos      = varspec_i(v)%tpos
            if(shapeo(1:1).eq.'n') then
               starto(tpos-1) = t
            else
               starto(tpos) = t
            end if
            starti(tpos) = t
         end if

         allocate(arrxyzo(nxo,nyo,nzo))
         if (trim(shapei) == 'xzy') then
            allocate(arr3d_i(nxi,nzi,nyi))
            allocate(arrxyzi(nxi,nyi,nzi))
         else
            allocate(arr3d_i(nxi,nyi,nzi))
         end if

         call wrap_get_vara_double(ncidi, vi, starti, counti, arr3d_i)

         if (trim(shapei) == 'xzy') then
            do k = 1, nzi
               do j = 1, nyi
                  do i = 1, nxi
                     arrxyzi(i,j,k) = arr3d_i(i,k,j)
                  end do
               end do
            end do
         else
            arrxyzi => arr3d_i
         end if

         if (verbose) then
            write(6,*)'  input min, avg, max = ', minval(arrxyzi), &
                      sum(arrxyzi)/real(size(arrxyzi), r8), maxval(arrxyzi)
         end if

         call interp_driver(ncidi, ncido, arrxyzi, arrxyzo, varspec_i(v), varspec_o(v), nxi, &
                            nzi, nyi, nxo, nzo, nyo)

         if (verbose) then
            write(6,*)'  output min, avg, max= ', minval(arrxyzo), &
                      sum(arrxyzo)/real(size(arrxyzo), r8), maxval(arrxyzo)
         end if

         ! Output uses same dimension ordering as input
         if (trim(shapei) == 'xzy') then
            allocate(arr3d_o(nxo,nzo,nyo))
            do k = 1, nzo
               do j = 1, nyo
                  do i = 1, nxo
                     arr3d_o(i,k,j) = arrxyzo(i,j,k)
                  end do
               end do
            end do
         else
            arr3d_o => arrxyzo
         end if

         if (varspec_o(v)%xtype == NF_DOUBLE) then
            call wrap_put_vara_double(ncido, vo, starto, counto, arr3d_o)
         else

            ! Convert to 4-byte reals before output
            if (trim(shapei) == 'xzy') then
               allocate(arr3d_o_r4(nxo,nzo,nyo))
            else
               allocate(arr3d_o_r4(nxo,nyo,nzo))
            end if

            arr3d_o_r4 = arr3d_o
            if (nf_put_vara_real(ncido, vo, starto, counto, arr3d_o_r4) /= NF_NOERR) then
               write(6,*) 'driver: ERROR from nf_put_vara_real'
               stop
            end if
            deallocate(arr3d_o_r4)
         end if

         deallocate(arr3d_i)
         deallocate(arrxyzo)
         if (trim(shapei) == 'xzy') then
            deallocate(arrxyzi)
            deallocate(arr3d_o)
         end if

      end do

   end do

   deallocate(indx_cp)
   deallocate(indx_intp)
   deallocate(varspec_i)
   deallocate(varspec_o)

contains

integer function get_dimid_o(dimname)

! Lookup the dimension ID for the requested name in the output file

   character(len=*), intent(in) :: dimname

   if (nf_inq_dimid(ncido, trim(dimname), get_dimid_o) /= nf_noerr) then
      print *, 'driver: ERROR: input variable ', trim(name), ' has dimension ', trim(dimname), &
               'which is not found in the output file'
      stop
   end if
end function get_dimid_o

end subroutine driver

module mkfileMod

contains

!-----------------------------------------------------------------------
  subroutine mkfile(domain, fname, dynlanduse, urban_format)

    use shr_kind_mod, only : r8 => shr_kind_r8
    use shr_sys_mod , only : shr_sys_getenv
    use fileutils   , only : get_filename
    use mkvarpar    , only : nlevsoi, nlevurb, numsolar, numrad
    use mkvarctl
    use mkglcmecMod , only : nglcec
    use mkpftMod    , only : mkpftAtt
    use mksoilMod   , only : mksoilAtt
    use mkharvestMod, only : mkharvest_fieldname, mkharvest_numtypes, mkharvest_longname
    use mkurbanparCommonMod, only : URBAN_FORMAT_DOM
    use mkncdio     , only : check_ret, ncd_defvar
    use mkdomainMod  

    implicit none
    include 'netcdf.inc'
    type(domain_type) , intent(in) :: domain
    character(len=*)  , intent(in) :: fname
    logical           , intent(in) :: dynlanduse
    integer           , intent(in) :: urban_format  ! code for format of urban file

    integer :: ncid
    integer :: j                    ! index
    integer :: dimid                ! temporary
    integer :: values(8)            ! temporary
    character(len=256) :: str       ! global attribute string
    character(len=256) :: name      ! name of attribute
    character(len=256) :: unit      ! units of attribute
    character(len= 18) :: datetime  ! temporary
    character(len=  8) :: date      ! temporary
    character(len= 10) :: time      ! temporary
    character(len=  5) :: zone      ! temporary
    integer            :: ier       ! error status
    integer            :: omode     ! netCDF output mode
    integer            :: xtype     ! external type
    character(len=32)  :: subname = 'mkfile'  ! subroutine name
!-----------------------------------------------------------------------

    call check_ret(nf_create(trim(fname), ior(nf_clobber,nf_64bit_offset), &
                                ncid), subname)

    call check_ret(nf_set_fill (ncid, nf_nofill, omode), subname)

    ! Define dimensions.

    if (outnc_1d) then
       call check_ret(nf_def_dim (ncid, 'gridcell', domain%ns, dimid), subname)
    else
       call check_ret(nf_def_dim (ncid, 'lsmlon'  , domain%ni, dimid), subname)
       call check_ret(nf_def_dim (ncid, 'lsmlat'  , domain%nj, dimid), subname)
    end if

    if (.not. dynlanduse) then
       if ( nglcec > 0 )then
          call check_ret(nf_def_dim (ncid, 'nglcec'  , nglcec      , dimid), subname)
          call check_ret(nf_def_dim (ncid, 'nglcecp1', nglcec+1    , dimid), subname)
       end if
    end if
    call check_ret(nf_def_dim (ncid, 'nlevurb' , nlevurb     , dimid), subname)
    call check_ret(nf_def_dim (ncid, 'numsolar', numsolar    , dimid), subname)
    call check_ret(nf_def_dim (ncid, 'numrad'  , numrad      , dimid), subname)
    call check_ret(nf_def_dim (ncid, 'nchar'   , 256         , dimid), subname)

    ! Create global attributes.

    str = 'NCAR-CSM'
    call check_ret(nf_put_att_text (ncid, NF_GLOBAL, &
         'Conventions', len_trim(str), trim(str)), subname)

    call date_and_time (date, time, zone, values)
    datetime(1:8) =        date(5:6) // '-' // date(7:8) // '-' // date(3:4)
    datetime(9:)  = ' ' // time(1:2) // ':' // time(3:4) // ':' // time(5:6) // ' '
    str = 'created on: ' // datetime
    call check_ret(nf_put_att_text (ncid, NF_GLOBAL, &
         'History_Log', len_trim(str), trim(str)), subname)

    call shr_sys_getenv ('LOGNAME', str, ier)
    call check_ret(nf_put_att_text (ncid, NF_GLOBAL, &
         'Logname', len_trim(str), trim(str)), subname)

    call shr_sys_getenv ('HOST', str, ier)
    call check_ret(nf_put_att_text (ncid, NF_GLOBAL, &
         'Host', len_trim(str), trim(str)), subname)

    str = 'Community Land Model: CLM4'
    call check_ret(nf_put_att_text (ncid, NF_GLOBAL, &
         'Source', len_trim(str), trim(str)), subname)

    str = &
'$HeadURL: https://svn-ccsm-models.cgd.ucar.edu/clm2/release_tags/cesm1_2_x_n15_clm4_5_10/models/lnd/clm/tools/clm4_0/mksurfdata_map/src/mkfileMod.F90 $'
    call check_ret(nf_put_att_text (ncid, NF_GLOBAL, &
         'Version', len_trim(str), trim(str)), subname)

    str = '$Id: mkfileMod.F90 43810 2013-02-07 06:12:57Z erik $'
    call check_ret(nf_put_att_text (ncid, NF_GLOBAL, &
         'Revision_Id', len_trim(str), trim(str)), subname)

#ifdef OPT
    str = 'TRUE'
#else
    str = 'FALSE'
#endif

    call check_ret(nf_put_att_text (ncid, NF_GLOBAL, &
         'Compiler_Optimized', len_trim(str), trim(str)), subname)

    if ( all_urban )then
       str = 'TRUE'
       call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
            'all_urban', len_trim(str), trim(str)), subname)
    end if

    str = get_filename(mksrf_fgrid)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'Input_grid_dataset', len_trim(str), trim(str)), subname)

    str = trim(mksrf_gridtype)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'Input_gridtype', len_trim(str), trim(str)), subname)

    if (.not. dynlanduse) then
       str = get_filename(mksrf_fvocef)
       call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
            'VOC_EF_raw_data_file_name', len_trim(str), trim(str)), subname)
    end if

    str = get_filename(mksrf_flakwat)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'Inland_lake_raw_data_file_name', len_trim(str), trim(str)), subname)

    str = get_filename(mksrf_fwetlnd)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'Inland_wetland_raw_data_file_name', len_trim(str), trim(str)), subname)

    str = get_filename(mksrf_fglacier)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'Glacier_raw_data_file_name', len_trim(str), trim(str)), subname)

    str = get_filename(mksrf_furbtopo)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'Urban_Topography_raw_data_file_name', len_trim(str), trim(str)), subname)

    str = get_filename(mksrf_flndtopo)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'Land_Topography_raw_data_file_name', len_trim(str), trim(str)), subname)

    str = get_filename(mksrf_furban)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'Urban_raw_data_file_name', len_trim(str), trim(str)), subname)

    str = get_filename(map_fpft)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'map_pft_file_name', len_trim(str), trim(str)), subname)

    str = get_filename(mksrf_firrig)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'Irrig_raw_data_file_name', len_trim(str), trim(str)), subname)

    if (.not. dynlanduse) then
       str = get_filename(mksrf_flai)
       call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
            'Lai_raw_data_file_name', len_trim(str), trim(str)), subname)
    end if

    ! ----------------------------------------------------------------------
    ! Define variables
    ! ----------------------------------------------------------------------
 
    if ( .not. outnc_double )then
       xtype = nf_float
    else
       xtype = nf_double
    end if

    str = get_filename(map_flakwat)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'map_lakwat_file', len_trim(str), trim(str)), subname)

    str = get_filename(map_fwetlnd)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'map_wetlnd_file', len_trim(str), trim(str)), subname)

    str = get_filename(map_fglacier)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'map_glacier_file', len_trim(str), trim(str)), subname)

    str = get_filename(map_fsoitex)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'map_soil_texture_file', len_trim(str), trim(str)), subname)

    str = get_filename(map_fsoicol)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'map_soil_color_file', len_trim(str), trim(str)), subname)

    str = get_filename(map_forganic)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'map_soil_organic_file', len_trim(str), trim(str)), subname)

    str = get_filename(map_furban)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'map_urban_file', len_trim(str), trim(str)), subname)

    str = get_filename(map_fmax)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'map_fmax_file', len_trim(str), trim(str)), subname)

    str = get_filename(map_fvocef)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'map_VOC_EF_file', len_trim(str), trim(str)), subname)

    str = get_filename(map_fharvest)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'map_harvest_file', len_trim(str), trim(str)), subname)

    str = get_filename(map_firrig)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'map_irrigation_file', len_trim(str), trim(str)), subname)

    str = get_filename(map_flai)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'map_lai_sai_file', len_trim(str), trim(str)), subname)

    str = get_filename(map_furbtopo)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'map_urban_topography_file', len_trim(str), trim(str)), subname)

    str = get_filename(map_flndtopo)
    call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
         'map_land_topography_file', len_trim(str), trim(str)), subname)

    ! ----------------------------------------------------------------------
    ! Define variables
    ! ----------------------------------------------------------------------
 
    if ( .not. outnc_double )then
       xtype = nf_float
    else
       xtype = nf_double
    end if

    call mksoilAtt( ncid, dynlanduse, xtype )

    call mkpftAtt(  ncid, dynlanduse, xtype )

    if (outnc_1d) then
       call ncd_defvar(ncid=ncid, varname='AREA' , xtype=nf_double, &
            dim1name='gridcell',&
            long_name='area', units='km^2')
    else
       call ncd_defvar(ncid=ncid, varname='AREA' , xtype=nf_double, &
            dim1name='lsmlon', dim2name='lsmlat', &
            long_name='area', units='km^2')
    end if

    if (outnc_1d) then
       call ncd_defvar(ncid=ncid, varname='LONGXY', xtype=nf_double, &
            dim1name='gridcell',&
            long_name='longitude', units='degrees east')
    else
       call ncd_defvar(ncid=ncid, varname='LONGXY', xtype=nf_double, &
            dim1name='lsmlon', dim2name='lsmlat', &
            long_name='longitude', units='degrees east')
    end if

    if (outnc_1d) then
       call ncd_defvar(ncid=ncid, varname='LATIXY', xtype=nf_double, &
            dim1name='gridcell',&
            long_name='latitude', units='degrees north')
    else
       call ncd_defvar(ncid=ncid, varname='LATIXY', xtype=nf_double, &
            dim1name='lsmlon', dim2name='lsmlat', &
            long_name='latitude', units='degrees north')
    end if

    if (.not. dynlanduse) then
       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='EF1_BTR', xtype=xtype, &
               dim1name='gridcell',&
               long_name='EF btr (isoprene)', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='EF1_BTR', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='EF btr (isoprene)', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='EF1_FET', xtype=xtype, &
               dim1name='gridcell',&
               long_name='EF fet (isoprene)', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='EF1_FET', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='EF fet (isoprene)', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='EF1_FDT', xtype=xtype, &
               dim1name='gridcell',&
               long_name='EF fdt (isoprene)', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='EF1_FDT', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='EF fdt (isoprene)', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='EF1_SHR', xtype=xtype, &
               dim1name='gridcell',&
               long_name='EF shr (isoprene)', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='EF1_SHR', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='EF shr (isoprene)', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='EF1_GRS', xtype=xtype, &
               dim1name='gridcell',&
               long_name='EF grs (isoprene)', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='EF1_GRS', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='EF grs (isoprene)', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='EF1_CRP', xtype=xtype, &
               dim1name='gridcell',&
               long_name='EF crp (isoprene)', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='EF1_CRP', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='EF crp (isoprene)', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='CANYON_HWR', xtype=xtype, &
               dim1name='gridcell',&
               long_name='canyon height to width ratio', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='CANYON_HWR', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='canyon height to width ratio', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='EM_IMPROAD', xtype=xtype, &
               dim1name='gridcell',&
               long_name='emissivity of impervious road', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='EM_IMPROAD', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='emissivity of impervious road', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='EM_PERROAD', xtype=xtype, &
               dim1name='gridcell',&
               long_name='emissivity of pervious road', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='EM_PERROAD', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='emissivity of pervious road', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='EM_ROOF', xtype=xtype, &
               dim1name='gridcell',&
               long_name='emissivity of roof', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='EM_ROOF', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='emissivity of roof', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='EM_WALL', xtype=xtype, &
               dim1name='gridcell',&
               long_name='emissivity of wall', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='EM_WALL', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='emissivity of wall', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='HT_ROOF', xtype=xtype, &
               dim1name='gridcell',&
               long_name='height of roof', units='meters')
       else
          call ncd_defvar(ncid=ncid, varname='HT_ROOF', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='height of roof', units='meters')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='THICK_ROOF', xtype=xtype, &
               dim1name='gridcell',&
               long_name='thickness of roof', units='meters')
       else
          call ncd_defvar(ncid=ncid, varname='THICK_ROOF', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='thickness of roof', units='meters')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='THICK_WALL', xtype=xtype, &
               dim1name='gridcell',&
               long_name='thickness of wall', units='meters')
       else
          call ncd_defvar(ncid=ncid, varname='THICK_WALL', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='thickness of wall', units='meters')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='T_BUILDING_MAX', xtype=xtype, &
               dim1name='gridcell',&
               long_name='maximum interior building temperature', units='K')
       else
          call ncd_defvar(ncid=ncid, varname='T_BUILDING_MAX', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='maximum interior building temperature', units='K')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='T_BUILDING_MIN', xtype=xtype, &
               dim1name='gridcell',&
               long_name='minimum interior building temperature', units='K')
       else
          call ncd_defvar(ncid=ncid, varname='T_BUILDING_MIN', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='minimum interior building temperature', units='K')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='WIND_HGT_CANYON', xtype=xtype, &
               dim1name='gridcell',&
               long_name='height of wind in canyon', units='meters')
       else
          call ncd_defvar(ncid=ncid, varname='WIND_HGT_CANYON', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='height of wind in canyon', units='meters')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='WTLUNIT_ROOF', xtype=xtype, &
               dim1name='gridcell',&
               long_name='fraction of roof', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='WTLUNIT_ROOF', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='fraction of roof', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='WTROAD_PERV', xtype=xtype, &
               dim1name='gridcell',&
               long_name='fraction of pervious road', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='WTROAD_PERV', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='fraction of pervious road', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='ALB_IMPROAD', xtype=xtype, &
               dim1name='gridcell', dim2name='numrad', dim3name='numsolar', &
               long_name='albedo of impervious road', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='ALB_IMPROAD', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', dim3name='numrad', dim4name='numsolar', &
               long_name='albedo of impervious road', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='ALB_PERROAD', xtype=xtype, &
               dim1name='gridcell', dim2name='numrad', dim3name='numsolar', &
               long_name='albedo of pervious road', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='ALB_PERROAD', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', dim3name='numrad', dim4name='numsolar', &
               long_name='albedo of pervious road', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='ALB_ROOF', xtype=xtype, &
               dim1name='gridcell', dim2name='numrad', dim3name='numsolar', &
               long_name='albedo of roof', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='ALB_ROOF', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', dim3name='numrad',dim4name='numsolar', &
               long_name='albedo of roof', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='ALB_WALL', xtype=xtype, &
               dim1name='gridcell', dim2name='numrad', dim3name='numsolar', &
               long_name='albedo of wall', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='ALB_WALL', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', dim3name='numrad', dim4name='numsolar', &
               long_name='albedo of wall', units='unitless')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='TK_ROOF', xtype=xtype, &
               dim1name='gridcell', dim2name='nlevurb', &
               long_name='thermal conductivity of roof', units='W/m*K')
       else
          call ncd_defvar(ncid=ncid, varname='TK_ROOF', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', dim3name='nlevurb', &
               long_name='thermal conductivity of roof', units='W/m*K')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='TK_WALL', xtype=xtype, &
               dim1name='gridcell', dim2name='nlevurb', &
               long_name='thermal conductivity of wall', units='W/m*K')
       else
          call ncd_defvar(ncid=ncid, varname='TK_WALL', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', dim3name='nlevurb', &
               long_name='thermal conductivity of wall', units='W/m*K')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='TK_IMPROAD', xtype=xtype, &
               dim1name='gridcell', dim2name='nlevurb', &
               long_name='thermal conductivity of impervious road', units='W/m*K')
       else
          call ncd_defvar(ncid=ncid, varname='TK_IMPROAD', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', dim3name='nlevurb', &
               long_name='thermal conductivity of impervious road', units='W/m*K')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='CV_ROOF', xtype=xtype, &
               dim1name='gridcell', dim2name='nlevurb', &
               long_name='volumetric heat capacity of roof', units='J/m^3*K')
       else
          call ncd_defvar(ncid=ncid, varname='CV_ROOF', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', dim3name='nlevurb', &
               long_name='volumetric heat capacity of roof', units='J/m^3*K')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='CV_WALL', xtype=xtype, &
               dim1name='gridcell', dim2name='nlevurb', &
               long_name='volumetric heat capacity of wall', units='J/m^3*K')
       else
          call ncd_defvar(ncid=ncid, varname='CV_WALL', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', dim3name='nlevurb', &
               long_name='volumetric heat capacity of wall', units='J/m^3*K')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='CV_IMPROAD', xtype=xtype, &
               dim1name='gridcell', dim2name='nlevurb', &
               long_name='volumetric heat capacity of impervious road', units='J/m^3*K')
       else
          call ncd_defvar(ncid=ncid, varname='CV_IMPROAD', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', dim3name='nlevurb', &
               long_name='volumetric heat capacity of impervious road', units='J/m^3*K')
       end if

       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='NLEV_IMPROAD', xtype=nf_int, &
               dim1name='gridcell',&
               long_name='number of impervious road layers', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='NLEV_IMPROAD', xtype=nf_int, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='number of impervious road layers', units='unitless')
       end if

    endif

    if (outnc_1d) then
       call ncd_defvar(ncid=ncid, varname='PCT_WETLAND', xtype=xtype, &
            dim1name='gridcell',&
            long_name='percent wetland', units='unitless')
    else
       call ncd_defvar(ncid=ncid, varname='PCT_WETLAND', xtype=xtype, &
            dim1name='lsmlon', dim2name='lsmlat', &
            long_name='percent wetland', units='unitless')
    end if

    if (outnc_1d) then
       call ncd_defvar(ncid=ncid, varname='PCT_LAKE', xtype=xtype, &
            dim1name='gridcell',&
            long_name='percent lake', units='unitless')
    else
       call ncd_defvar(ncid=ncid, varname='PCT_LAKE', xtype=xtype, &
            dim1name='lsmlon', dim2name='lsmlat', &
            long_name='percent lake', units='unitless')
    end if

    if (outnc_1d) then
       call ncd_defvar(ncid=ncid, varname='PCT_GLACIER', xtype=xtype, &
            dim1name='gridcell',&
            long_name='percent glacier', units='unitless')
    else
       call ncd_defvar(ncid=ncid, varname='PCT_GLACIER', xtype=xtype, &
            dim1name='lsmlon', dim2name='lsmlat', &
            long_name='percent glacier', units='unitless')
    end if

    if (.not. dynlanduse) then
       if ( nglcec > 0 )then
          call ncd_defvar(ncid=ncid, varname='GLC_MEC', xtype=xtype, &
               dim1name='nglcecp1', long_name='Glacier elevation class', units='m')
          
          if (outnc_1d) then
             call ncd_defvar(ncid=ncid, varname='PCT_GLC_MEC', xtype=xtype, &
                  dim1name='gridcell', dim2name='nglcec', &
                  long_name='percent glacier for each glacier elevation class', units='unitless')
          else
             call ncd_defvar(ncid=ncid, varname='PCT_GLC_MEC', xtype=xtype, &
                  dim1name='lsmlon', dim2name='lsmlat', dim3name='nglcec', &
                  long_name='percent glacier for each glacier elevation class', units='unitless')
          end if
          
          if (outnc_1d) then
             call ncd_defvar(ncid=ncid, varname='PCT_GLC_MEC_GIC', xtype=xtype, &
                  dim1name='gridcell', dim2name='nglcec', &
                  long_name='percent smaller glaciers and ice caps for each glacier elevation class', units='unitless')
          else
             call ncd_defvar(ncid=ncid, varname='PCT_GLC_MEC_GIC', xtype=xtype, &
                  dim1name='lsmlon', dim2name='lsmlat', dim3name='nglcec', &
                  long_name='percent smaller glaciers and ice caps for each glacier elevation class', units='unitless')
          end if
          
          if (outnc_1d) then
             call ncd_defvar(ncid=ncid, varname='PCT_GLC_MEC_ICESHEET', xtype=xtype, &
                  dim1name='gridcell', dim2name='nglcec', &
                  long_name='percent ice sheet for each glacier elevation class', units='unitless')
          else
             call ncd_defvar(ncid=ncid, varname='PCT_GLC_MEC_ICESHEET', xtype=xtype, &
                  dim1name='lsmlon', dim2name='lsmlat', dim3name='nglcec', &
                  long_name='percent ice sheet for each glacier elevation class', units='unitless')
          end if
          
          if (outnc_1d) then
             call ncd_defvar(ncid=ncid, varname='PCT_GLC_GIC', xtype=xtype, &
                  dim1name='gridcell', &
                  long_name='percent ice caps/glaciers', units='unitless')
          else
             call ncd_defvar(ncid=ncid, varname='PCT_GLC_GIC', xtype=xtype, &
                  dim1name='lsmlon', dim2name='lsmlat', &
                  long_name='percent ice caps/glaciers', units='unitless')
          end if
          
          if (outnc_1d) then
             call ncd_defvar(ncid=ncid, varname='PCT_GLC_ICESHEET', xtype=xtype, &
                  dim1name='gridcell', &
                  long_name='percent ice sheet', units='unitless')
          else
             call ncd_defvar(ncid=ncid, varname='PCT_GLC_ICESHEET', xtype=xtype, &
                  dim1name='lsmlon', dim2name='lsmlat', &
                  long_name='percent ice sheet', units='unitless')
          end if
          
          if (outnc_1d) then
             call ncd_defvar(ncid=ncid, varname='TOPO_GLC_MEC', xtype=xtype, &
                  dim1name='gridcell', dim2name='nglcec', &
                  long_name='mean elevation on glacier elevation classes', units='m')
          else
             call ncd_defvar(ncid=ncid, varname='TOPO_GLC_MEC', xtype=xtype, &
                  dim1name='lsmlon', dim2name='lsmlat', dim3name='nglcec', &
                  long_name='mean elevation on glacier elevation classes', units='m')
          end if
          
       end if
    end if

    if (.not. dynlanduse) then
       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='TOPO', xtype=xtype, &
               dim1name='gridcell', &
               long_name='mean elevation on land', units='m')
       else
          call ncd_defvar(ncid=ncid, varname='TOPO', xtype=xtype, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='mean elevation on land', units='m')
       end if
    end if

    if (outnc_1d) then
       call ncd_defvar(ncid=ncid, varname='PCT_URBAN', xtype=xtype, &
            dim1name='gridcell',&
            long_name='percent urban', units='unitless')
    else
       call ncd_defvar(ncid=ncid, varname='PCT_URBAN', xtype=xtype, &
            dim1name='lsmlon', dim2name='lsmlat', &
            long_name='percent urban', units='unitless')
    end if

    if (urban_format == URBAN_FORMAT_DOM) then
       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='URBAN_DENSITY_CLASS', xtype=nf_int, &
               dim1name='gridcell',&
               long_name='urban density class', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='URBAN_DENSITY_CLASS', xtype=nf_int, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='urban density class', units='unitless')
       end if
       if (outnc_1d) then
          call ncd_defvar(ncid=ncid, varname='URBAN_REGION_ID', xtype=nf_int, &
               dim1name='gridcell',&
               long_name='urban region ID', units='unitless')
       else
          call ncd_defvar(ncid=ncid, varname='URBAN_REGION_ID', xtype=nf_int, &
               dim1name='lsmlon', dim2name='lsmlat', &
               long_name='urban region ID', units='unitless')
       end if
    end if

    if (dynlanduse) then
       do j = 1, mkharvest_numtypes()
          if (outnc_1d) then
             call ncd_defvar(ncid=ncid, varname=mkharvest_fieldname(j), xtype=xtype, &
                  dim1name='gridcell', dim2name='time', &
                  long_name=mkharvest_longname(j), units='unitless')
          else
             call ncd_defvar(ncid=ncid, varname=mkharvest_fieldname(j), xtype=xtype, &
                  dim1name='lsmlon', dim2name='lsmlat', dim3name='time', &
                  long_name=mkharvest_longname(j), units='unitless')
          end if
       end do
    end if

    ! End of define mode

    call check_ret(nf_enddef(ncid), subname)
    call check_ret(nf_close(ncid), subname)

  end subroutine mkfile

end module mkfileMod

!===============================================================================
! SVN $Id: shr_const_mod.F90 6749 2007-10-04 20:58:20Z jwolfe $
! SVN $URL: https://svn-ccsm-models.cgd.ucar.edu/csm_share/trunk_tags/share3_100228/shr/shr_const_mod.F90 $
!===============================================================================

MODULE shr_const_mod

   use shr_kind_mod

   integer(SHR_KIND_IN),parameter,private :: R8 = SHR_KIND_R8 ! rename for local readability only

   !----------------------------------------------------------------------------
   ! physical constants (all data public)
   !----------------------------------------------------------------------------
   public

   real(R8),parameter :: SHR_CONST_PI      = 3.14159265358979323846_R8  ! pi
   real(R8),parameter :: SHR_CONST_CDAY    = 86400.0_R8      ! sec in calendar day ~ sec
   real(R8),parameter :: SHR_CONST_SDAY    = 86164.0_R8      ! sec in siderial day ~ sec
   real(R8),parameter :: SHR_CONST_OMEGA   = 2.0_R8*SHR_CONST_PI/SHR_CONST_SDAY ! earth rot ~ rad/sec
   real(R8),parameter :: SHR_CONST_REARTH  = 6.37122e6_R8    ! radius of earth ~ m
   real(R8),parameter :: SHR_CONST_G       = 9.80616_R8      ! acceleration of gravity ~ m/s^2

   real(R8),parameter :: SHR_CONST_STEBOL  = 5.67e-8_R8      ! Stefan-Boltzmann constant ~ W/m^2/K^4
   real(R8),parameter :: SHR_CONST_BOLTZ   = 1.38065e-23_R8  ! Boltzmann's constant ~ J/K/molecule
   real(R8),parameter :: SHR_CONST_AVOGAD  = 6.02214e26_R8   ! Avogadro's number ~ molecules/kmole
   real(R8),parameter :: SHR_CONST_RGAS    = SHR_CONST_AVOGAD*SHR_CONST_BOLTZ       ! Universal gas constant ~ J/K/kmole
   real(R8),parameter :: SHR_CONST_MWDAIR  = 28.966_R8       ! molecular weight dry air ~ kg/kmole
   real(R8),parameter :: SHR_CONST_MWWV    = 18.016_R8       ! molecular weight water vapor
   real(R8),parameter :: SHR_CONST_RDAIR   = SHR_CONST_RGAS/SHR_CONST_MWDAIR        ! Dry air gas constant     ~ J/K/kg
   real(R8),parameter :: SHR_CONST_RWV     = SHR_CONST_RGAS/SHR_CONST_MWWV          ! Water vapor gas constant ~ J/K/kg
   real(R8),parameter :: SHR_CONST_ZVIR    = (SHR_CONST_RWV/SHR_CONST_RDAIR)-1.0_R8 ! RWV/RDAIR - 1.0
   real(R8),parameter :: SHR_CONST_KARMAN  = 0.4_R8          ! Von Karman constant
   real(R8),parameter :: SHR_CONST_PSTD    = 101325.0_R8     ! standard pressure ~ pascals
   real(R8),parameter :: SHR_CONST_PDB     = 0.0112372_R8    ! ratio of 13C/12C in Pee Dee Belemnite (C isotope standard)
 
   real(R8),parameter :: SHR_CONST_TKTRIP  = 273.16_R8       ! triple point of fresh water        ~ K
   real(R8),parameter :: SHR_CONST_TKFRZ   = 273.15_R8       ! freezing T of fresh water          ~ K 
   real(R8),parameter :: SHR_CONST_TKFRZSW = SHR_CONST_TKFRZ - 1.8_R8 ! freezing T of salt water  ~ K

   real(R8),parameter :: SHR_CONST_RHODAIR = &               ! density of dry air at STP  ~ kg/m^3
                         SHR_CONST_PSTD/(SHR_CONST_RDAIR*SHR_CONST_TKFRZ)
   real(R8),parameter :: SHR_CONST_RHOFW   = 1.000e3_R8      ! density of fresh water     ~ kg/m^3
   real(R8),parameter :: SHR_CONST_RHOSW   = 1.026e3_R8      ! density of sea water       ~ kg/m^3
   real(R8),parameter :: SHR_CONST_RHOICE  = 0.917e3_R8      ! density of ice             ~ kg/m^3
   real(R8),parameter :: SHR_CONST_CPDAIR  = 1.00464e3_R8    ! specific heat of dry air   ~ J/kg/K
   real(R8),parameter :: SHR_CONST_CPWV    = 1.810e3_R8      ! specific heat of water vap ~ J/kg/K
   real(R8),parameter :: SHR_CONST_CPVIR   = (SHR_CONST_CPWV/SHR_CONST_CPDAIR)-1.0_R8 ! CPWV/CPDAIR - 1.0
   real(R8),parameter :: SHR_CONST_CPFW    = 4.188e3_R8      ! specific heat of fresh h2o ~ J/kg/K
   real(R8),parameter :: SHR_CONST_CPSW    = 3.996e3_R8      ! specific heat of sea h2o   ~ J/kg/K
   real(R8),parameter :: SHR_CONST_CPICE   = 2.11727e3_R8    ! specific heat of fresh ice ~ J/kg/K
   real(R8),parameter :: SHR_CONST_LATICE  = 3.337e5_R8      ! latent heat of fusion      ~ J/kg
   real(R8),parameter :: SHR_CONST_LATVAP  = 2.501e6_R8      ! latent heat of evaporation ~ J/kg
   real(R8),parameter :: SHR_CONST_LATSUB  = &               ! latent heat of sublimation ~ J/kg
                         SHR_CONST_LATICE + SHR_CONST_LATVAP
   real(R8),parameter :: SHR_CONST_OCN_REF_SAL = 34.7_R8     ! ocn ref salinity (psu)
   real(R8),parameter :: SHR_CONST_ICE_REF_SAL =  4.0_R8     ! ice ref salinity (psu)

   real(R8),parameter :: SHR_CONST_SPVAL   = 1.0e30_R8       ! special missing value

END MODULE shr_const_mod

module mklanwatMod

!-----------------------------------------------------------------------
!BOP
!
! !MODULE: mklanwatMod
!
! !DESCRIPTION:
! make %lake and %wetland from input lake / wetland data
!
! !REVISION HISTORY:
! Author: Mariana Vertenstein
!
!-----------------------------------------------------------------------
!
! !USES:
  use shr_kind_mod, only : r8 => shr_kind_r8
  use shr_sys_mod , only : shr_sys_flush
  use mkdomainMod , only : domain_checksame

  implicit none

  private

! !PUBLIC MEMBER FUNCTIONS:
  public mklakwat
  public mkwetlnd

!EOP
!===============================================================
contains
!===============================================================

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mklakwat
!
! !INTERFACE:
subroutine mklakwat(ldomain, mapfname, datfname, ndiag, zero_out, lake_o)
!
! !DESCRIPTION:
! make %lake
!
! !USES:
  use mkdomainMod, only : domain_type, domain_clean, domain_read
  use mkgridmapMod
  use mkvarpar	
  use mkvarctl    
  use mkncdio
!
! !ARGUMENTS:
  
  implicit none
  type(domain_type), intent(in) :: ldomain
  character(len=*)  , intent(in) :: mapfname  ! input mapping file name
  character(len=*)  , intent(in) :: datfname  ! input data file name
  integer           , intent(in) :: ndiag     ! unit number for diag out
  logical           , intent(in) :: zero_out  ! if should zero glacier out
  real(r8)          , intent(out):: lake_o(:) ! output grid: %lake
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Mariana Vertenstein
!
!
! !LOCAL VARIABLES:
!EOP
  type(gridmap_type)    :: tgridmap
  type(domain_type)    :: tdomain            ! local domain
  real(r8), allocatable :: lake_i(:)          ! input grid: percent lake
  real(r8) :: sum_fldi                        ! global sum of dummy input fld
  real(r8) :: sum_fldo                        ! global sum of dummy output fld
  real(r8) :: glake_i                         ! input  grid: global lake
  real(r8) :: garea_i                         ! input  grid: global area
  real(r8) :: glake_o                         ! output grid: global lake
  real(r8) :: garea_o                         ! output grid: global area
  integer  :: ni,no,k,n,m,ns_i,ns_o           ! indices
  integer  :: ncid,dimid,varid                ! input netCDF id's
  integer  :: ier                             ! error status
  real(r8) :: relerr = 0.00001                ! max error: sum overlap wts ne 1
  character(len=32) :: subname = 'mklakwat'
!-----------------------------------------------------------------------

  write (6,*) 'Attempting to make %lake and %wetland .....'
  call shr_sys_flush(6)

  ! -----------------------------------------------------------------
  ! Read input file
  ! -----------------------------------------------------------------

  ! Obtain input grid info, read local fields

  ns_o = ldomain%ns

  call domain_read(tdomain,datfname)  !todo - put in routine to read in 1d domains 
  ns_i = tdomain%ns

  if ( .not. zero_out )then
     allocate(lake_i(ns_i), stat=ier)
     if (ier/=0) call abort()

     write(6,*)'Open lake file: ', trim(datfname)
     call check_ret(nf_open(datfname, 0, ncid), subname)
     call check_ret(nf_inq_varid (ncid, 'PCT_LAKE', varid), subname)
     call check_ret(nf_get_var_double (ncid, varid, lake_i), subname)
     call check_ret(nf_close(ncid), subname)

     ! Area-average percent cover on input grid to output grid 
     ! and correct according to land landmask
     ! Note that percent cover is in terms of total grid area.

     call gridmap_mapread(tgridmap, mapfname )

     ! Error checks for domain and map consistencies

     call domain_checksame( tdomain, ldomain, tgridmap )

     ! Determine lake_o on output grid

     call gridmap_areaave(tgridmap, lake_i,lake_o)

     do no = 1,ns_o
        if (lake_o(no) < 1.) lake_o(no) = 0.
     enddo

     ! -----------------------------------------------------------------
     ! Error check prep
     ! Global sum of output field -- must multiply by fraction of
     ! output grid that is land as determined by input grid
     ! -----------------------------------------------------------------

     sum_fldi = 0.0_r8
     do ni = 1,ns_i
       sum_fldi = sum_fldi + tgridmap%area_src(ni)*tgridmap%frac_src(ni)*re**2
     enddo

     sum_fldo = 0.
     do no = 1,ns_o
        sum_fldo = sum_fldo + tgridmap%area_dst(no)*tgridmap%frac_dst(no)*re**2
     end do

     ! -----------------------------------------------------------------
     ! Error check1
     ! Compare global sum fld_o to global sum fld_i.
     ! -----------------------------------------------------------------

     if ( .not. zero_out .and. (trim(mksrf_gridtype) == 'global') ) then
        if ( abs(sum_fldo/sum_fldi-1.) > relerr ) then
           write (6,*) 'MKLANWAT error: input field not conserved'
           write (6,'(a30,e20.10)') 'global sum output field = ',sum_fldo
           write (6,'(a30,e20.10)') 'global sum input  field = ',sum_fldi
           stop
        end if
     end if

     ! -----------------------------------------------------------------
     ! Error check2
     ! Compare global areas on input and output grids
     ! -----------------------------------------------------------------

     ! Input grid

     glake_i = 0.
     garea_i = 0.
     do ni = 1,ns_i
        garea_i = garea_i + tgridmap%area_src(ni)*re**2
        glake_i = glake_i + lake_i(ni)*tgridmap%area_src(ni)/100.*re**2
     end do

     ! Output grid

     glake_o = 0.
     garea_o = 0.
     do no = 1,ns_o
        garea_o = garea_o + tgridmap%area_dst(no)*re**2
        glake_o = glake_o + lake_o(no)*tgridmap%area_dst(no)/100.*re**2
     end do

     ! Diagnostic output

     write (ndiag,*)
     write (ndiag,'(1x,70a1)') ('=',k=1,70)
     write (ndiag,*) 'Inland Water Output'
     write (ndiag,'(1x,70a1)') ('=',k=1,70)

     write (ndiag,*)
     write (ndiag,'(1x,70a1)') ('.',k=1,70)
     write (ndiag,2001)
2001 format (1x,'surface type   input grid area  output grid area'/ &
             1x,'                 10**6 km**2      10**6 km**2   ')
     write (ndiag,'(1x,70a1)') ('.',k=1,70)
     write (ndiag,*)
     write (ndiag,2002) glake_i*1.e-06,glake_o*1.e-06
     write (ndiag,2004) garea_i*1.e-06,garea_o*1.e-06
2002 format (1x,'lakes       ',f14.3,f17.3)
2004 format (1x,'all surface ',f14.3,f17.3)
  else
     do no = 1,ns_o
        lake_o(no) = 0.
     enddo
  end if

  ! Deallocate dynamic memory

  call domain_clean(tdomain) 
  if ( .not. zero_out )then
     call gridmap_clean(tgridmap)
     deallocate (lake_i)
  end if

  write (6,*) 'Successfully made %lake'
  write (6,*)
  call shr_sys_flush(6)

end subroutine mklakwat

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkwetlnd
!
! !INTERFACE:
subroutine mkwetlnd(ldomain, mapfname, datfname, ndiag, zero_out, swmp_o)
!
! !DESCRIPTION:
! make %wetland
!
! !USES:
  use mkdomainMod, only : domain_type, domain_clean, domain_read
  use mkgridmapMod
  use mkvarpar	
  use mkvarctl    
  use mkncdio
!
! !ARGUMENTS:
  
  implicit none
  type(domain_type), intent(in) :: ldomain
  character(len=*)  , intent(in) :: mapfname  ! input mapping file name
  character(len=*)  , intent(in) :: datfname  ! input data file name
  integer           , intent(in) :: ndiag     ! unit number for diag out
  logical           , intent(in) :: zero_out  ! if should zero glacier out
  real(r8)          , intent(out):: swmp_o(:) ! output grid: %wetland
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Mariana Vertenstein
!
!
! !LOCAL VARIABLES:
!EOP
  type(gridmap_type)    :: tgridmap
  type(domain_type)    :: tdomain            ! local domain
  real(r8), allocatable :: swmp_i(:)          ! input grid: percent swamp
  real(r8) :: sum_fldi                        ! global sum of dummy input fld
  real(r8) :: sum_fldo                        ! global sum of dummy output fld
  real(r8) :: gswmp_i                         ! input  grid: global swamp
  real(r8) :: garea_i                         ! input  grid: global area
  real(r8) :: gswmp_o                         ! output grid: global swamp
  real(r8) :: garea_o                         ! output grid: global area
  integer  :: ni,no,k,n,m,ns_i,ns_o           ! indices
  integer  :: ncid,dimid,varid                ! input netCDF id's
  integer  :: ier                             ! error status
  real(r8) :: relerr = 0.00001                ! max error: sum overlap wts ne 1
  character(len=32) :: subname = 'mkwetlnd'
!-----------------------------------------------------------------------

  write (6,*) 'Attempting to make %wetland .....'
  call shr_sys_flush(6)

  ! -----------------------------------------------------------------
  ! Read input file
  ! -----------------------------------------------------------------

  ! Obtain input grid info, read local fields

  ns_o = ldomain%ns

  call domain_read(tdomain,datfname)  !todo - put in routine to read in 1d domains 
  ns_i = tdomain%ns

  if ( .not. zero_out )then
     allocate(swmp_i(ns_i), stat=ier)
     if (ier/=0) call abort()

     write(6,*)'Open wetland file: ', trim(datfname)
     call check_ret(nf_open(datfname, 0, ncid), subname)
     call check_ret(nf_inq_varid (ncid, 'PCT_WETLAND', varid), subname)
     call check_ret(nf_get_var_double (ncid, varid, swmp_i), subname)
     call check_ret(nf_close(ncid), subname)

     ! Area-average percent cover on input grid to output grid 
     ! and correct according to land landmask
     ! Note that percent cover is in terms of total grid area.

     call gridmap_mapread(tgridmap, mapfname )

     ! Error checks for domain and map consistencies

     call domain_checksame( tdomain, ldomain, tgridmap )
     ! Determine swmp_o on output grid

     call gridmap_areaave(tgridmap, swmp_i,swmp_o)

     do no = 1,ns_o
        if (swmp_o(no) < 1.) swmp_o(no) = 0.
     enddo

     ! -----------------------------------------------------------------
     ! Error check prep
     ! Global sum of output field -- must multiply by fraction of
     ! output grid that is land as determined by input grid
     ! -----------------------------------------------------------------

     sum_fldi = 0.0_r8
     do ni = 1,ns_i
       sum_fldi = sum_fldi + tgridmap%area_src(ni)*tgridmap%frac_src(ni)*re**2
     enddo

     sum_fldo = 0.
     do no = 1,ns_o
        sum_fldo = sum_fldo + tgridmap%area_dst(no)*tgridmap%frac_dst(no)*re**2
     end do

     ! -----------------------------------------------------------------
     ! Error check1
     ! Compare global sum fld_o to global sum fld_i.
     ! -----------------------------------------------------------------

     if ( .not. zero_out .and. (trim(mksrf_gridtype) == 'global') ) then
        if ( abs(sum_fldo/sum_fldi-1.) > relerr ) then
           write (6,*) 'MKLANWAT error: input field not conserved'
           write (6,'(a30,e20.10)') 'global sum output field = ',sum_fldo
           write (6,'(a30,e20.10)') 'global sum input  field = ',sum_fldi
           stop
        end if
     end if

     ! -----------------------------------------------------------------
     ! Error check2
     ! Compare global areas on input and output grids
     ! -----------------------------------------------------------------

     ! Input grid

     gswmp_i = 0.
     garea_i = 0.
     do ni = 1,ns_i
        garea_i = garea_i + tgridmap%area_src(ni)*re**2
        gswmp_i = gswmp_i + swmp_i(ni)*tgridmap%area_src(ni)/100.*re**2
     end do

     ! Output grid

     gswmp_o = 0.
     garea_o = 0.
     do no = 1,ns_o
        garea_o = garea_o + tgridmap%area_dst(no)*re**2
        gswmp_o = gswmp_o + swmp_o(no)*tgridmap%area_dst(no)/100.*re**2
     end do

     ! Diagnostic output

     write (ndiag,*)
     write (ndiag,'(1x,70a1)') ('=',k=1,70)
     write (ndiag,*) 'Inland Water Output'
     write (ndiag,'(1x,70a1)') ('=',k=1,70)

     write (ndiag,*)
     write (ndiag,'(1x,70a1)') ('.',k=1,70)
     write (ndiag,2001)
2001 format (1x,'surface type   input grid area  output grid area'/ &
             1x,'                 10**6 km**2      10**6 km**2   ')
     write (ndiag,'(1x,70a1)') ('.',k=1,70)
     write (ndiag,*)
     write (ndiag,2003) gswmp_i*1.e-06,gswmp_o*1.e-06
     write (ndiag,2004) garea_i*1.e-06,garea_o*1.e-06
2003 format (1x,'wetlands    ',f14.3,f17.3)
2004 format (1x,'all surface ',f14.3,f17.3)
  else
     do no = 1,ns_o
        swmp_o(no) = 0.
     enddo
  end if

  ! Deallocate dynamic memory

  call domain_clean(tdomain) 
  if ( .not. zero_out )then
     call gridmap_clean(tgridmap)
     deallocate (swmp_i)
  end if

  write (6,*) 'Successfully made %wetland'
  write (6,*)
  call shr_sys_flush(6)

end subroutine mkwetlnd

end module mklanwatMod

module nanMod

!-----------------------------------------------------------------------
!BOP
!
! !MODULE: nanMod
!
! !DESCRIPTION:
! Set parameters for the floating point flags "inf" Infinity
! and "nan" not-a-number. As well as "bigint" the point
! at which integers start to overflow. These values are used
! to initialize arrays with as a way to detect if arrays
! are being used before being set.
! Note that bigint is the largest possible 32-bit integer.
!
! !USES:
  use shr_kind_mod, only: r8 => shr_kind_r8
!
! !PUBLIC TYPES:
  implicit none
  save
#ifdef __PGI
! quiet nan for portland group compilers
  real(r8), parameter :: inf = O'0777600000000000000000'
  real(r8), parameter :: nan = O'0777700000000000000000'
  integer,  parameter :: bigint = O'17777777777'
#else
! signaling nan otherwise
  real(r8), parameter :: inf = O'0777600000000000000000'
  real(r8), parameter :: nan = O'0777610000000000000000'
  integer,  parameter :: bigint = O'17777777777'
#endif
!
! !REVISION HISTORY:
! Created by Mariana Vertenstein based on cam module created by
! CCM core group
!
!EOP
!-----------------------------------------------------------------------

end module nanMod

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!     This file converts a POP grid.dat file to a remapping grid file
!     in netCDF format.
!
!-----------------------------------------------------------------------
!
!     CVS:$Id: convertPOPT.f,v 1.4 2001/08/21 21:22:56 pwjones Exp $
!
!     Copyright (c) 1997, 1998 the Regents of the University of 
!       California.
!
!     Unless otherwise indicated, this software has been authored
!     by an employee or employees of the University of California,
!     operator of the Los Alamos National Laboratory under Contract
!     No. W-7405-ENG-36 with the U.S. Department of Energy.  The U.S.
!     Government has rights to use, reproduce, and distribute this
!     software.  The public may copy and use this software without
!     charge, provided that this Notice and any statement of authorship
!     are reproduced on all copies.  Neither the Government nor the
!     University makes any warranty, express or implied, or assumes
!     any liability or responsibility for the use of this software.
!
!***********************************************************************

      program myconvertPOPT

!-----------------------------------------------------------------------
!
!     This file converts a POP grid.dat file to a remapping grid file.
!
!-----------------------------------------------------------------------

      use kinds_mod
      use constants
      use iounits
      use netcdf_mod

      implicit none

!-----------------------------------------------------------------------
!
!     variables that describe the grid
!       4/3       nx = 192, ny = 128
!       2/3 (mod) nx = 384, ny = 288
!       x3p Greenland DP nx = 100, ny = 116
!       x2p Greenland DP nx = 160, ny = 192
!       x1p Greenland DP nx = 320, ny = 384
!
!-----------------------------------------------------------------------

      integer (kind=int_kind), parameter ::
     &             grid_rank = 2,
     &             grid_corners = 4

      integer (kind=int_kind) ::
     &             nx, ny, grid_size

      integer (kind=int_kind), dimension(2) ::
     &             grid_dims   ! size of each dimension

      character(char_len):: 
     &    grid_name,grid_file_in,grid_topo_in,
     &    grid_file_out

      real (kind=dbl_kind), parameter ::
     &  radius    = 6371.22e5_dbl_kind       ! radius of Earth (cm)
     &, area_norm = one/(radius*radius)

!-----------------------------------------------------------------------
!
!     grid coordinates and masks
!
!-----------------------------------------------------------------------

      integer (kind=int_kind), allocatable ::
     &             grid_imask(:)

      real (kind=dbl_kind), allocatable ::
     &             grid_area(:)      ,  ! area as computed in POP
     &             grid_center_lat(:),  ! lat/lon coordinates for
     &             grid_center_lon(:)   ! each grid center in radians

      real (kind=dbl_kind), allocatable ::
     &             grid_corner_lat(:,:),  ! lat/lon coordinates for
     &             grid_corner_lon(:,:)   ! each grid corner in radians

      real (kind=dbl_kind), allocatable ::
     &             HTN(:,:), HTE(:,:)     ! T-cell grid lengths

!-----------------------------------------------------------------------
!
!     other local variables
!
!-----------------------------------------------------------------------

      integer (kind=int_kind) :: i, j, n, iunit, ocn_add, im1, jm1
      integer (kind=int_kind) :: jp1, jp2
      real (kind=dbl_kind) ::  z1,x1,y1,z2,x2,y2,z3,x3,y3
      real (kind=dbl_kind) ::  z4,x4,y4,tx,ty,tz,da

      integer (kind=int_kind) ::
     &        ncstat,            ! general netCDF status variable
     &        nc_grid_id,        ! netCDF grid dataset id
     &        nc_gridsize_id,    ! netCDF grid size dim id
     &        nc_gridcorn_id,    ! netCDF grid corner dim id
     &        nc_gridrank_id,    ! netCDF grid rank dim id
     &        nc_griddims_id,    ! netCDF grid dimensions id
     &        nc_grdcntrlat_id,  ! netCDF grid center lat id
     &        nc_grdcntrlon_id,  ! netCDF grid center lon id
     &        nc_grdimask_id,    ! netCDF grid mask id
     &        nc_gridarea_id,    ! netCDF grid area id
     &        nc_grdcrnrlat_id,  ! netCDF grid corner lat id
     &        nc_grdcrnrlon_id   ! netCDF grid corner lon id

      integer (kind=int_kind), dimension(2) ::
     &        nc_dims2_id        ! netCDF dim id array for 2-d arrays

      real (kind=dbl_kind) :: tmplon, dxt, dyt, dlat

!-----------------------------------------------------------------------
!
!     read in grid info
!     lat/lon info is on velocity points which correspond
!     to the NE corner (in logical space) of the grid cell.
!
!-----------------------------------------------------------------------
      print *, "enter grid nx, ny"
      read(*,*) nx, ny

      grid_size = nx*ny

      print *, "enter grid_name:"
      read(*,'(a80)') grid_name
      print *, "grid_name:", grid_name
      print *, "enter grid_file_in:"
      read(*,'(a80)') grid_file_in
      print *, "grid_file_in:", grid_file_in
      print *, "enter grid_topo_in:"
      read(*,'(a80)') grid_topo_in
      print *, "grid_file_in:", grid_topo_in
      print *, "enter grid_file_out:"
      read(*,'(a80)') grid_file_out
      print *, "grid_file_in:", grid_file_out

      allocate(grid_imask(grid_size))
      allocate(grid_area(grid_size))
      allocate(grid_center_lat(grid_size))
      allocate(grid_center_lon(grid_size))
      allocate(grid_corner_lat(grid_corners,grid_size))
      allocate(grid_corner_lon(grid_corners,grid_size))
      allocate(HTN(nx,ny))
      allocate(HTE(nx,ny))

      call get_unit(iunit)
      open(unit=iunit, file=grid_topo_in, status='old', 
     &     form='unformatted', access='direct', recl=grid_size*4)
      read (unit=iunit,rec=1) grid_imask
      call release_unit(iunit)

        print *,"first"

      call get_unit(iunit)
      open(unit=iunit, file=grid_file_in, status='old', 
     &     form='unformatted', access='direct', recl=grid_size*8)
      read (unit=iunit, rec=1) grid_corner_lat(3,:)
      read (unit=iunit, rec=2) grid_corner_lon(3,:)
      read (unit=iunit, rec=3) HTN
      read (unit=iunit, rec=4) HTE
      call release_unit(iunit)
        print *,"second"

      grid_dims(1) = nx
      grid_dims(2) = ny

!-----------------------------------------------------------------------
!
!     convert KMT field to integer grid mask
!
!-----------------------------------------------------------------------

      grid_imask = min(grid_imask, 1)

!-----------------------------------------------------------------------
!
!     compute remaining corners
!
!-----------------------------------------------------------------------

      do j=1,ny
        do i=1,nx
          ocn_add = (j-1)*nx + i
          if (i .ne. 1) then
            im1 = ocn_add - 1
          else
            im1 = ocn_add + nx - 1
          endif

          grid_corner_lat(4,ocn_add) = grid_corner_lat(3,im1)
          grid_corner_lon(4,ocn_add) = grid_corner_lon(3,im1)
        end do
      end do

      do j=2,ny
        do i=1,nx
          ocn_add = (j-1)*nx + i
          jm1 = (j-2)*nx + i

          grid_corner_lat(2,ocn_add) = grid_corner_lat(3,jm1)
          grid_corner_lat(1,ocn_add) = grid_corner_lat(4,jm1)

          grid_corner_lon(2,ocn_add) = grid_corner_lon(3,jm1)
          grid_corner_lon(1,ocn_add) = grid_corner_lon(4,jm1)
        end do
      end do

!-----------------------------------------------------------------------
!
!     mock up the lower row boundaries
!
!-----------------------------------------------------------------------

      do i=1,nx
        dlat = grid_corner_lat(1,i+2*nx) - grid_corner_lat(1,i+nx)
        grid_corner_lat(1,i) = grid_corner_lat(1,i+nx) - dlat
        grid_corner_lat(1,i) = max(grid_corner_lat(1,i), -pih + tiny)

        dlat = grid_corner_lat(2,i+2*nx) - grid_corner_lat(2,i+nx)
        grid_corner_lat(2,i) = grid_corner_lat(2,i+nx) - dlat
        grid_corner_lat(2,i) = max(grid_corner_lat(2,i), -pih + tiny)

        grid_corner_lon(1,i) = grid_corner_lon(4,i)
        grid_corner_lon(2,i) = grid_corner_lon(3,i)
      end do

!-----------------------------------------------------------------------
!
!     correct for 0,2pi longitude crossings
!
!-----------------------------------------------------------------------

      do ocn_add=1,grid_size
        if (grid_corner_lon(1,ocn_add) > pi2) 
     &      grid_corner_lon(1,ocn_add) = 
     &      grid_corner_lon(1,ocn_add) - pi2
        if (grid_corner_lon(1,ocn_add) < 0.0) 
     &      grid_corner_lon(1,ocn_add) = 
     &      grid_corner_lon(1,ocn_add) + pi2
        do n=2,grid_corners
          tmplon = grid_corner_lon(n  ,ocn_add) - 
     &             grid_corner_lon(n-1,ocn_add) 
          if (tmplon < -three*pih) grid_corner_lon(n,ocn_add) = 
     &                             grid_corner_lon(n,ocn_add) + pi2
          if (tmplon >  three*pih) grid_corner_lon(n,ocn_add) = 
     &                             grid_corner_lon(n,ocn_add) - pi2
        end do
      end do

!-----------------------------------------------------------------------
!
!     compute ocean cell centers by averaging corner values
!
!-----------------------------------------------------------------------

!     start calc_tpoints stuff

      do j=2,ny
        do i=1,nx
	    ocn_add = (j-1)*nx + i

            z1 = cos(grid_corner_lat(1,ocn_add))
            x1 = cos(grid_corner_lon(1,ocn_add))*z1
            y1 = sin(grid_corner_lon(1,ocn_add))*z1
            z1 = sin(grid_corner_lat(1,ocn_add))

            z2 = cos(grid_corner_lat(2,ocn_add))
            x2 = cos(grid_corner_lon(2,ocn_add))*z2
            y2 = sin(grid_corner_lon(2,ocn_add))*z2
            z2 = sin(grid_corner_lat(2,ocn_add))

            z3 = cos(grid_corner_lat(4,ocn_add))
            x3 = cos(grid_corner_lon(4,ocn_add))*z3
            y3 = sin(grid_corner_lon(4,ocn_add))*z3
            z3 = sin(grid_corner_lat(4,ocn_add))

            z4 = cos(grid_corner_lat(3,ocn_add))
            x4 = cos(grid_corner_lon(3,ocn_add))*z4
            y4 = sin(grid_corner_lon(3,ocn_add))*z4
            z4 = sin(grid_corner_lat(3,ocn_add))

            tx = (x1+x2+x3+x4)/four
            ty = (y1+y2+y3+y4)/four
            tz = (z1+z2+z3+z4)/four
            da = sqrt(tx**2+ty**2+tz**2)

            tz = tz/da
            ! TLONG_G in radians
            grid_center_lon(ocn_add) = zero
            if (tx.ne.zero.or.ty.ne.zero)
     &           grid_center_lon(ocn_add) = atan2(ty,tx)
            ! TLAT_G in radians
            grid_center_lat(ocn_add) = asin(tz)

        end do
      end do

      ! j=1: linear approximation
      do i=1,nx
	 ocn_add = i
	 jp1 = nx + i
	 jp2 = 2*nx + i
         grid_center_lon(ocn_add) = grid_center_lon(jp1)
         grid_center_lat(ocn_add) = two*grid_center_lat(jp1) - 
     &		grid_center_lat(jp2)
      end do

!     end calc_tpoints stuff

      do ocn_add=1,grid_size
        if (grid_center_lon(ocn_add) > pi2) 
     &      grid_center_lon(ocn_add) = grid_center_lon(ocn_add) - pi2
        if (grid_center_lon(ocn_add) < 0.0) 
     &      grid_center_lon(ocn_add) = grid_center_lon(ocn_add) + pi2
      end do

!-----------------------------------------------------------------------
!
!     compute cell areas in same way as POP
!
!-----------------------------------------------------------------------

      n = 0
      do j=1,ny
        if (j > 1) then
          jm1 = j-1
        else
          jm1 = 1
        endif
        do i=1,nx
          if (i > 1) then
            im1 = i-1
          else
            im1 = nx
          endif

          n = n+1

          dxt = half*(HTN(i,j) + HTN(i,jm1))
          dyt = half*(HTE(i,j) + HTE(im1,j))
          if (dxt == zero) dxt=one
          if (dyt == zero) dyt=one

          grid_area(n) = dxt*dyt*area_norm
        end do
      end do

!-----------------------------------------------------------------------
!
!     set up attributes for netCDF file
!
!-----------------------------------------------------------------------

      !***
      !*** create netCDF dataset for this grid
      !***

      ncstat = nf_create (grid_file_out, NF_CLOBBER,
     &                    nc_grid_id)
      call netcdf_error_handler(ncstat)

      ncstat = nf_put_att_text (nc_grid_id, NF_GLOBAL, 'title',
     &                          len_trim(grid_name), grid_name)
      call netcdf_error_handler(ncstat)

      !***
      !*** define grid size dimension
      !***

      ncstat = nf_def_dim (nc_grid_id, 'grid_size', grid_size, 
     &                     nc_gridsize_id)
      call netcdf_error_handler(ncstat)

      !***
      !*** define grid rank dimension
      !***

      ncstat = nf_def_dim (nc_grid_id, 'grid_rank', grid_rank, 
     &                     nc_gridrank_id)
      call netcdf_error_handler(ncstat)

      !***
      !*** define grid corner dimension
      !***

      ncstat = nf_def_dim (nc_grid_id, 'grid_corners', grid_corners, 
     &                     nc_gridcorn_id)
      call netcdf_error_handler(ncstat)

      !***
      !*** define grid dim size array
      !***

      ncstat = nf_def_var (nc_grid_id, 'grid_dims', NF_INT,
     &                     1, nc_gridrank_id, nc_griddims_id)
      call netcdf_error_handler(ncstat)

      !***
      !*** define grid center latitude array
      !***

      ncstat = nf_def_var (nc_grid_id, 'grid_center_lat', NF_DOUBLE,
     &                     1, nc_gridsize_id, nc_grdcntrlat_id)
      call netcdf_error_handler(ncstat)

      ncstat = nf_put_att_text (nc_grid_id, nc_grdcntrlat_id, 'units',
     &                          7, 'radians')
      call netcdf_error_handler(ncstat)

      !***
      !*** define grid center longitude array
      !***

      ncstat = nf_def_var (nc_grid_id, 'grid_center_lon', NF_DOUBLE,
     &                     1, nc_gridsize_id, nc_grdcntrlon_id)
      call netcdf_error_handler(ncstat)

      ncstat = nf_put_att_text (nc_grid_id, nc_grdcntrlon_id, 'units',
     &                          7, 'radians')
      call netcdf_error_handler(ncstat)

      !***
      !*** define grid area array
      !***

      ncstat = nf_def_var (nc_grid_id, 'grid_area', NF_DOUBLE,
     &                     1, nc_gridsize_id, nc_gridarea_id)
      call netcdf_error_handler(ncstat)

      !***
      !*** define grid mask
      !***

      ncstat = nf_def_var (nc_grid_id, 'grid_imask', NF_INT,
     &                     1, nc_gridsize_id, nc_grdimask_id)
      call netcdf_error_handler(ncstat)

      ncstat = nf_put_att_text (nc_grid_id, nc_grdimask_id, 'units',
     &                          8, 'unitless')
      call netcdf_error_handler(ncstat)

      !***
      !*** define grid corner latitude array
      !***

      nc_dims2_id(1) = nc_gridcorn_id
      nc_dims2_id(2) = nc_gridsize_id

      ncstat = nf_def_var (nc_grid_id, 'grid_corner_lat', NF_DOUBLE,
     &                     2, nc_dims2_id, nc_grdcrnrlat_id)
      call netcdf_error_handler(ncstat)

      ncstat = nf_put_att_text (nc_grid_id, nc_grdcrnrlat_id, 'units',
     &                          7, 'radians')
      call netcdf_error_handler(ncstat)

      !***
      !*** define grid corner longitude array
      !***

      ncstat = nf_def_var (nc_grid_id, 'grid_corner_lon', NF_DOUBLE,
     &                     2, nc_dims2_id, nc_grdcrnrlon_id)
      call netcdf_error_handler(ncstat)

      ncstat = nf_put_att_text (nc_grid_id, nc_grdcrnrlon_id, 'units',
     &                          7, 'radians')
      call netcdf_error_handler(ncstat)

      !***
      !*** end definition stage
      !***

      ncstat = nf_enddef(nc_grid_id)
      call netcdf_error_handler(ncstat)

!-----------------------------------------------------------------------
!
!     write grid data
!
!-----------------------------------------------------------------------

      ncstat = nf_put_var_int(nc_grid_id, nc_griddims_id, grid_dims)
      call netcdf_error_handler(ncstat)

      ncstat = nf_put_var_double(nc_grid_id, nc_grdcntrlat_id, 
     &                           grid_center_lat)
      ncstat = nf_put_var_int(nc_grid_id, nc_grdimask_id, grid_imask)
      call netcdf_error_handler(ncstat)

      ncstat = nf_put_var_double(nc_grid_id, nc_gridarea_id, 
     &                           grid_area)
      call netcdf_error_handler(ncstat)

      ncstat = nf_put_var_double(nc_grid_id, nc_grdcntrlat_id, 
     &                           grid_center_lat)
      call netcdf_error_handler(ncstat)

      ncstat = nf_put_var_double(nc_grid_id, nc_grdcntrlon_id, 
     &                           grid_center_lon)
      call netcdf_error_handler(ncstat)

      ncstat = nf_put_var_double(nc_grid_id, nc_grdcrnrlat_id, 
     &                           grid_corner_lat)
      call netcdf_error_handler(ncstat)

      ncstat = nf_put_var_double(nc_grid_id, nc_grdcrnrlon_id, 
     &                           grid_corner_lon)
      call netcdf_error_handler(ncstat)

      ncstat = nf_close(nc_grid_id)

!***********************************************************************

      end program myconvertPOPT

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mkutilsMod
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: mkutils
!
! !DESCRIPTION:
! General-purpose utilities for mksurfdata_map
!
!
! !USES:
   use shr_kind_mod, only : r8 => shr_kind_r8
 
   implicit none
   private
!
! !PUBLIC MEMBER FUNCTIONS:
   public :: slightly_below
   public :: slightly_above
   public :: convert_latlon
!
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
!EOP
!------------------------------------------------------------------------------
contains

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: slightly_below
!
! !INTERFACE:
logical function slightly_below(a, b, eps)
!
! !DESCRIPTION:
! Returns true if a is slightly below b; false if a is significantly below b or if a is
! greater than or equal to b
!
! !USES:
!
! !ARGUMENTS:
   implicit none
   real(r8), intent(in) :: a
   real(r8), intent(in) :: b

   ! if provided, eps gives the relative error allowed for checking the "slightly"
   ! condition; if not provided, the tolerance defaults to the value given by eps_default
   real(r8), intent(in), optional :: eps
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
!
! !LOCAL VARIABLES:
!EOP
   real(r8) :: l_eps
   real(r8), parameter :: eps_default = 1.e-15_r8  ! default relative error tolerance
!------------------------------------------------------------------------------

   if (present(eps)) then
      l_eps = eps
   else
      l_eps = eps_default
   end if

   if (a < b .and. (b - a)/b < l_eps) then
      slightly_below = .true.
   else
      slightly_below = .false.
   end if

end function slightly_below
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: slightly_above
!
! !INTERFACE:
logical function slightly_above(a, b, eps)
!
! !DESCRIPTION:
! Returns true if a is slightly above b; false if a is significantly above b or if a is
! less than or equal to b
!
! !USES:
!
! !ARGUMENTS:
   implicit none
   real(r8), intent(in) :: a
   real(r8), intent(in) :: b

   ! if provided, eps gives the relative error allowed for checking the "slightly"
   ! condition; if not provided, the tolerance defaults to the value given by eps_default
   real(r8), intent(in), optional :: eps
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
!
! !LOCAL VARIABLES:
!EOP
   real(r8) :: l_eps
   real(r8), parameter :: eps_default = 1.e-15_r8  ! default relative error tolerance
!------------------------------------------------------------------------------

   if (present(eps)) then
      l_eps = eps
   else
      l_eps = eps_default
   end if

   if (a > b .and. (a - b)/b < l_eps) then
      slightly_above = .true.
   else
      slightly_above = .false.
   end if

end function slightly_above
!------------------------------------------------------------------------------

!----------------------------------------------------------------------------
!BOP
!
! !IROUTINE: convert_latlon
!
! !INTERFACE:
  subroutine convert_latlon(ncid, varname, data)
!
! !DESCRIPTION:
! Convert a latitude or longitude variable from its units in the input file to degrees E /
! degrees N. Currently, this just handles conversions from radians to degrees.
!
! Assumes that the longitude / latitude variable has already been read from file, into
! the variable given by 'data'. ncid & varname give the file ID and variable name from
! which this variable was read (needed to obtain the variable's units).
!
! !USES:
    use mkncdio
    use shr_const_mod, only : SHR_CONST_PI
!
! !ARGUMENTS:
    implicit none
    integer         , intent(in)   :: ncid      ! ID of open netcdf file
    character(len=*), intent(in)   :: varname   ! name of lat or lon variable that was read into 'data'
    real(r8)        , intent(inout):: data(:)   ! latitude or longitude data
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
!
! !LOCAL VARIABLES:
!EOP
    integer :: ier                             ! error return code
    integer :: varid                           ! netCDF variable id
    integer :: units_len                       ! length of units attribute on file
    character(len=256) :: units                ! units attribute
    character(len= 32) :: subname = 'convert_latlon'
!-----------------------------------------------------------------

    call check_ret(nf_inq_varid (ncid, varname, varid), subname)
    ier = nf_inq_attlen(ncid, varid, 'units', units_len)

    ! Only do the following processing if there is no error; if ier /= NF_NOERR, that
    ! probably means there isn't a units attribute -- in that case, assume units are
    ! degrees and need no conversion
    if (ier == NF_NOERR) then
       if (units_len > len(units)) then
          write(6,*) trim(subname), ' ERROR: units variable not long enough to hold attributue'
          call abort()
       end if

       call check_ret(nf_get_att_text(ncid, varid, 'units', units), subname)
       
       if (units(1:7) == 'radians') then
          ! convert from radians to degrees
          data(:) = data(:) * 180._r8 / SHR_CONST_PI
       end if
    end if

  end subroutine convert_latlon
!------------------------------------------------------------------------------


end module mkutilsMod

!===============================================================================
! SVN $Id: shr_sys_mod.F90 28978 2011-06-27 20:37:05Z jedwards $
! SVN $URL: https://svn-ccsm-models.cgd.ucar.edu/csm_share/trunk_tags/share3_110803/shr/shr_sys_mod.F90 $
!===============================================================================

MODULE shr_sys_mod

   use shr_kind_mod  ! defines real & integer kinds
   use shr_log_mod, only: s_loglev  => shr_log_Level
   use shr_log_mod, only: s_logunit => shr_log_Unit

   implicit none

! PUBLIC: Public interfaces

   private

   public :: shr_sys_system  ! make a system call
   public :: shr_sys_chdir   ! change current working dir
   public :: shr_sys_getenv  ! get an environment variable
   public :: shr_sys_abort   ! abort a program
   public :: shr_sys_irtc    ! returns real-time clock tick
   public :: shr_sys_sleep   ! have program sleep for a while
   public :: shr_sys_flush   ! flush an i/o buffer

!===============================================================================
CONTAINS
!===============================================================================

!===============================================================================
!===============================================================================

SUBROUTINE shr_sys_system(str,rcode)

   IMPLICIT none

   !----- arguments ---
   character(*)        ,intent(in)  :: str    ! system/shell command string
   integer(SHR_KIND_IN),intent(out) :: rcode  ! function return error code

   !----- functions -----
#if (defined CRAY) || (defined UNICOSMP)
   integer(SHR_KIND_IN),external    :: ishell ! function to envoke shell command
#endif
#if (defined OSF1 || defined SUNOS || (defined LINUX && !defined __GFORTRAN__ && !defined CATAMOUNT))
   integer(SHR_KIND_IN),external    :: system ! function to envoke shell command
#endif

   !----- local -----
#if (defined CATAMOUNT)
   character(2*SHR_KIND_CL) :: file1            ! one or two filenames
   character(  SHR_KIND_CL) :: file2            ! 2nd file name
   integer(SHR_KIND_IN)     :: iloc             ! index/location within a string
#endif

   !----- formats -----
   character(*),parameter :: subName =   '(shr_sys_system) '
   character(*),parameter :: F00     = "('(shr_sys_system) ',4a)"

!-------------------------------------------------------------------------------
! PURPOSE: an architecture independant system call
! NOTE: 
! - for Catamount (Cray, pheonix at ORNL) there is no system call -- workarounds 
!   exist only for simple "rm" and "cp" commands
!-------------------------------------------------------------------------------


#if (defined CRAY) || (defined UNICOSMP)

   rcode=ishell(str)

#elif (defined IRIX64 || defined NEC_SX)

   rcode = 0
   call system(str)

#elif (defined AIX)

   call system(str,rcode)

#elif (defined OSF1 || defined SUNOS || defined __GFORTRAN__ || (defined LINUX && !defined CATAMOUNT))

   rcode = system(str)

#elif (defined CATAMOUNT)
   if (str(1:3) == 'rm ') then
      call unlink(str(4:))
      if (s_loglev > 0) write(s_logunit,F00) 'CATAMOUNT unlink ',trim(str(4:))
      rcode = 0
   elseif (str(1:3) == 'mv ') then
      file1 = str(4:)
      iloc = index(file1,' ') + 3
      if (iloc < 6) then
         if (s_loglev > 0) write(s_logunit,*) 'CATAMOUNT mv error ',trim(str),iloc
         rcode = -1
      else
         file1 = str(4:iloc)
         file2 = str(iloc+1:)
         call rename(trim(file1),trim(file2))
         if (s_loglev > 0) write(s_logunit,F00) 'CATAMOUNT rename ',trim(file1)," ",trim(file2)
         rcode = 0
      endif
   else
      rcode = -1
   endif

#else

   write(s_logunit,F00) 'ERROR: no implementation of system call for this architecture'
   call shr_sys_abort(subName//'no implementation of system call for this architecture')

#endif

END SUBROUTINE shr_sys_system

!===============================================================================
!===============================================================================

SUBROUTINE shr_sys_chdir(path, rcode)

   IMPLICIT none

   !----- arguments -----
   character(*)        ,intent(in)  :: path    ! chdir to this dir
   integer(SHR_KIND_IN),intent(out) :: rcode   ! return code

   !----- local -----
   integer(SHR_KIND_IN)             :: lenpath ! length of path
#if (defined AIX || defined OSF1 || defined SUNOS || (defined LINUX && !defined __GFORTRAN__) || defined NEC_SX)
   integer(SHR_KIND_IN),external    :: chdir   ! AIX system call
#endif

   !----- formats -----
   character(*),parameter :: subName =   '(shr_sys_chdir) '
   character(*),parameter :: F00     = "('(shr_sys_chdir) ',4a)"

!-------------------------------------------------------------------------------
! PURPOSE: an architecture independant system call
!-------------------------------------------------------------------------------

   lenpath=len_trim(path)

#if (defined IRIX64 || defined CRAY || defined UNICOSMP)

   call pxfchdir(path, lenpath, rcode)

#elif (defined AIX)

   rcode = chdir(%ref(path(1:lenpath)//'\0'))

#elif (defined OSF1 || defined SUNOS || defined LINUX || defined NEC_SX)

   rcode=chdir(path(1:lenpath))

#else

   write(s_logunit,F00) 'ERROR: no implementation of chdir for this architecture'
   call shr_sys_abort(subname//'no implementation of chdir for this machine')

#endif

END SUBROUTINE shr_sys_chdir

!===============================================================================
!===============================================================================

SUBROUTINE shr_sys_getenv(name, val, rcode)

   IMPLICIT none

   !----- arguments -----
   character(*)        ,intent(in)  :: name    ! env var name
   character(*)        ,intent(out) :: val     ! env var value
   integer(SHR_KIND_IN),intent(out) :: rcode   ! return code

   !----- local -----
   integer(SHR_KIND_IN)             :: lenname ! length of env var name
   integer(SHR_KIND_IN)             :: lenval  ! length of env var value
   character(SHR_KIND_CL)           :: tmpval  ! temporary env var value

   !----- formats -----
   character(*),parameter :: subName =   '(shr_sys_getenv) '
   character(*),parameter :: F00     = "('(shr_sys_getenv) ',4a)"

!-------------------------------------------------------------------------------
! PURPOSE: an architecture independant system call
!-------------------------------------------------------------------------------

   lenname=len_trim(name)

#if (defined IRIX64 || defined CRAY || defined UNICOSMP)

   call pxfgetenv(name, lenname, val, lenval, rcode)

#elif (defined AIX || defined OSF1 || defined SUNOS || defined LINUX || defined NEC_SX)

   call getenv(trim(name),tmpval)
   val=trim(tmpval)
   rcode = 0
   if (len_trim(val) ==  0         ) rcode = 1
   if (len_trim(val) >  SHR_KIND_CL) rcode = 2

#else

   write(s_logunit,F00) 'ERROR: no implementation of getenv for this architecture'
   call shr_sys_abort(subname//'no implementation of getenv for this machine')

#endif

END SUBROUTINE shr_sys_getenv

!===============================================================================
!===============================================================================

SUBROUTINE shr_sys_abort(string,rc)

   IMPLICIT none

   character(*)        ,optional :: string  ! error message string
   integer(SHR_KIND_IN),optional :: rc      ! error code

   !----- formats -----
   character(*),parameter :: subName =   '(shr_sys_abort) '
   character(*),parameter :: F00     = "('(shr_sys_abort) ',4a)"

!-------------------------------------------------------------------------------
! PURPOSE: consistent stopping mechanism
!-------------------------------------------------------------------------------

   call shr_sys_flush(s_logunit)
   if (len_trim(string) > 0) write(s_logunit,F00) 'ERROR: '//trim(string)
   write(s_logunit,F00) 'WARNING: stopping'
   call shr_sys_flush(s_logunit)
   call abort()
   stop

END SUBROUTINE shr_sys_abort

!===============================================================================
!===============================================================================

integer(SHR_KIND_I8) FUNCTION shr_sys_irtc( rate )

   IMPLICIT none

   !----- arguments -----
   integer(SHR_KIND_I8), optional :: rate

   !----- local -----
   integer(SHR_KIND_IN)      :: count
   integer(SHR_KIND_IN)      :: count_rate
   integer(SHR_KIND_IN)      :: count_max
   integer(SHR_KIND_IN),save :: last_count   = -1
   integer(SHR_KIND_I8),save :: count_offset =  0

   !----- formats -----
   character(*),parameter :: subName =   '(shr_sys_irtc) '
   character(*),parameter :: F00     = "('(shr_sys_irtc) ',4a)"

!-------------------------------------------------------------------------------
! emulates Cray/SGI irtc function (returns clock tick since last reboot)
!-------------------------------------------------------------------------------

   call system_clock(count=count,count_rate=count_rate, count_max=count_max)
   if ( present(rate) ) rate = count_rate
   shr_sys_irtc = count

   !--- adjust for clock wrap-around ---
   if ( last_count /= -1 ) then
     if ( count < last_count ) count_offset = count_offset + count_max
   end if
   shr_sys_irtc = shr_sys_irtc + count_offset
   last_count   = count

END FUNCTION shr_sys_irtc

!===============================================================================
!===============================================================================

SUBROUTINE shr_sys_sleep(sec)

   IMPLICIT none

   !----- arguments -----
   real   (SHR_KIND_R8),intent(in) :: sec  ! number of seconds to sleep

   !----- local -----
   integer(SHR_KIND_IN) :: isec   ! integer number of seconds
   integer(SHR_KIND_IN) :: rcode  ! return code
   character(90)        :: str    ! system call string

   !----- formats -----
   character(*),parameter :: subName =   '(shr_sys_sleep) '
   character(*),parameter :: F00     = "('(shr_sys_sleep) ',4a)"
   character(*),parameter :: F10     = "('sleep ',i8 )"

!-------------------------------------------------------------------------------
! PURPOSE: Sleep for approximately sec seconds
!-------------------------------------------------------------------------------

   isec = nint(sec)

   if (isec < 0) then
      if (s_loglev > 0) write(s_logunit,F00) 'ERROR: seconds must be > 0, sec=',sec
   else if (isec == 0) then
      ! Don't consider this an error and don't call system sleep
   else
#if defined(CATAMOUNT)
      call sleep(isec)
#else
      write(str,FMT=F10) isec
      call shr_sys_system( str, rcode )
#endif
   endif

END SUBROUTINE shr_sys_sleep

!===============================================================================
!===============================================================================

SUBROUTINE shr_sys_flush(unit)

   IMPLICIT none

   !----- arguments -----
   integer(SHR_KIND_IN) :: unit  ! flush output buffer for this unit

   !----- formats -----
   character(*),parameter :: subName =   '(shr_sys_flush) '
   character(*),parameter :: F00     = "('(shr_sys_flush) ',4a)"

!-------------------------------------------------------------------------------
! PURPOSE: an architecture independant system call
!-------------------------------------------------------------------------------

#if (defined IRIX64 || defined CRAY || defined OSF1 || defined SUNOS || defined LINUX || defined NEC_SX || defined UNICOSMP)

   call flush(unit)

#elif (defined AIX)

   call flush_(unit)

#else

   if (s_loglev > 0) write(s_logunit,F00) 'WARNING: no implementation of flush for this architecture'

#endif

END SUBROUTINE shr_sys_flush

!===============================================================================
!===============================================================================

END MODULE shr_sys_mod

module mkncdio

!-----------------------------------------------------------------------
!BOP
!
! !MODULE: mkncdio
!
! !DESCRIPTION:
! Generic interfaces to write fields to netcdf files, and other useful netcdf operations
!
! !USES:
  use shr_kind_mod   , only : r8 => shr_kind_r8
  use shr_sys_mod    , only : shr_sys_flush
!
! !PUBLIC TYPES:
  implicit none
  include 'netcdf.inc'
  save

  private

  public :: check_ret       ! checks return status of netcdf calls
  public :: ncd_defvar      ! define netCDF input variable
  public :: get_dim_lengths ! get dimension lengths of a netcdf variable
!
! !REVISION HISTORY:
!
!
! !PRIVATE MEMBER FUNCTIONS:
!
  logical  :: masterproc = .true. ! always use 1 proc
  real(r8) :: spval = 1.e36       ! special value

  public :: nf_open
  public :: nf_close
  public :: nf_write
  public :: nf_sync
  public :: nf_inq_attlen
  public :: nf_inq_dimlen
  public :: nf_inq_dimname
  public :: nf_inq_varid
  public :: nf_inq_varndims 
  public :: nf_inq_vardimid
  public :: nf_get_att_double
  public :: nf_get_att_text
  public :: nf_get_var_double
  public :: nf_get_vara_double
  public :: nf_get_var_int
  public :: nf_get_vara_int
  public :: nf_put_var_double
  public :: nf_put_vara_double
  public :: nf_put_var_int
  public :: nf_put_vara_int
  public :: nf_inq_dimid
  public :: nf_max_name
  public :: nf_max_var_dims
  public :: nf_noerr
!EOP
!-----------------------------------------------------------------------

contains

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: check_ret
!
! !INTERFACE:
  subroutine check_ret(ret, calling)
!
! !DESCRIPTION:
! Check return status from netcdf call
!
! !ARGUMENTS:
    implicit none
    integer, intent(in) :: ret
    character(len=*) :: calling
!
! !REVISION HISTORY:
!
!EOP
!-----------------------------------------------------------------------

    if (ret /= NF_NOERR) then
       write(6,*)'netcdf error from ',trim(calling), ' rcode = ', ret, &
                 ' error = ', NF_STRERROR(ret)
       call abort()
    end if

  end subroutine check_ret

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: ncd_defvar
!
! !INTERFACE:
  subroutine ncd_defvar(ncid, varname, xtype, &
       dim1name, dim2name, dim3name, dim4name, dim5name, &
       long_name, units, cell_method, missing_value, fill_value, &
       imissing_value, ifill_value)
!
! !DESCRIPTION:
!  Define a netcdf variable
!
! !ARGUMENTS:
    implicit none
    integer         , intent(in)  :: ncid                    ! input unit
    character(len=*), intent(in)  :: varname                 ! variable name
    integer         , intent(in)  :: xtype                   ! external type
    character(len=*), intent(in), optional :: dim1name       ! dimension name
    character(len=*), intent(in), optional :: dim2name       ! dimension name
    character(len=*), intent(in), optional :: dim3name       ! dimension name
    character(len=*), intent(in), optional :: dim4name       ! dimension name
    character(len=*), intent(in), optional :: dim5name       ! dimension name
    character(len=*), intent(in), optional :: long_name      ! attribute
    character(len=*), intent(in), optional :: units          ! attribute
    character(len=*), intent(in), optional :: cell_method    ! attribute
    real(r8)        , intent(in), optional :: missing_value  ! attribute for real
    real(r8)        , intent(in), optional :: fill_value     ! attribute for real
    integer         , intent(in), optional :: imissing_value ! attribute for int
    integer         , intent(in), optional :: ifill_value    ! attribute for int
!
! !REVISION HISTORY:
!
!
! !LOCAL VARIABLES:
!EOP
    integer :: n              ! indices
    integer :: ndims          ! dimension counter
    integer :: dimid(5)       ! dimension ids
    integer :: varid          ! variable id
    integer :: itmp           ! temporary
    character(len=256) :: str ! temporary
    character(len=32) :: subname='NCD_DEFVAR_REAL' ! subroutine name
!-----------------------------------------------------------------------

    if (.not. masterproc) return

    ! Determine dimension ids for variable

    dimid(:) = 0

    if (present(dim1name)) then
       call check_ret(nf_inq_dimid(ncid, dim1name, dimid(1)), subname)
    end if
    if (present(dim2name)) then
       call check_ret(nf_inq_dimid(ncid, dim2name, dimid(2)), subname)
    end if
    if (present(dim3name)) then
       call check_ret(nf_inq_dimid(ncid, dim3name, dimid(3)), subname)
    end if
    if (present(dim4name)) then
       call check_ret(nf_inq_dimid(ncid, dim4name, dimid(4)), subname)
    end if
    if (present(dim5name)) then
       call check_ret(nf_inq_dimid(ncid, dim5name, dimid(5)), subname)
    end if

    ! Define variable

    if (present(dim1name)) then
       ndims = 0
       do n = 1, size(dimid)
          if (dimid(n) /= 0) ndims = ndims + 1
       end do
       call check_ret(nf_def_var(ncid, trim(varname), xtype, ndims, dimid(1:ndims), varid), subname)
    else
       call check_ret(nf_def_var(ncid, varname, xtype, 0, 0, varid), subname)
    end if
    if (present(long_name)) then
       call check_ret(nf_put_att_text(ncid, varid, 'long_name', len_trim(long_name), trim(long_name)), subname)
    end if
    if (present(units)) then
       call check_ret(nf_put_att_text(ncid, varid, 'units', len_trim(units), trim(units)), subname)
    end if
    if (present(cell_method)) then
       str = 'time: ' // trim(cell_method)
       call check_ret(nf_put_att_text(ncid, varid, 'cell_method', len_trim(str), trim(str)), subname)
    end if
    if (present(fill_value)) then
       call check_ret(nf_put_att_double(ncid, varid, '_FillValue', xtype, 1, fill_value), subname)
    end if
    if (present(missing_value)) then
       call check_ret(nf_put_att_double(ncid, varid, 'missing_value', xtype, 1, missing_value), subname)
    end if
    if (present(ifill_value)) then
       call check_ret(nf_put_att_int(ncid, varid, '_FillValue', xtype, 1, ifill_value), subname)
    end if
    if (present(imissing_value)) then
       call check_ret(nf_put_att_int(ncid, varid, 'missing_value', xtype, 1, imissing_value), subname)
    end if

  end subroutine ncd_defvar

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: get_dim_lengths
!
! !INTERFACE:
subroutine get_dim_lengths(ncid, varname, ndims, dim_lengths)
!
! !DESCRIPTION:
! Returns the number of dimensions and an array containing the dimension lengths of a
! variable in an open netcdf file.
!
! Entries 1:ndims in the returned dim_lengths array contain the dimension lengths; the
! remaining entries in that vector are meaningless. The dim_lengths array must be large
! enough to hold all ndims values; if not, the code aborts (this can be ensured by passing
! in an array of length nf_max_var_dims).
!
! !USES:
!
! !ARGUMENTS:
   implicit none
   integer         , intent(in) :: ncid           ! netcdf id of an open netcdf file
   character(len=*), intent(in) :: varname        ! name of variable of interest
   integer         , intent(out):: ndims          ! number of dimensions of variable
   integer         , intent(out):: dim_lengths(:) ! lengths of dimensions of variable
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
!
! !LOCAL VARIABLES:
   integer :: varid
   integer :: dimids(size(dim_lengths))
   integer :: i
   character(len=*), parameter :: subname = 'get_dim_lengths'
!EOP
!------------------------------------------------------------------------------
   call check_ret(nf_inq_varid(ncid, varname, varid), subname)
   call check_ret(nf_inq_varndims(ncid, varid, ndims), subname)

   if (ndims > size(dim_lengths)) then
      write(6,*) trim(subname), ' ERROR: dim_lengths too small'
      call abort()
   end if

   call check_ret(nf_inq_vardimid(ncid, varid, dimids), subname)

   dim_lengths(:) = 0  ! pre-fill with 0 so we won't have garbage in elements past ndims
   do i = 1, ndims
      call check_ret(nf_inq_dimlen(ncid, dimids(i), dim_lengths(i)), subname)
   end do
 end subroutine get_dim_lengths

end module mkncdio

subroutine map_i (nlon_i   , nlat_i  , numlon_i, lon_i   , lat_i, &
                  nlon_o   , nlat_o  , numlon_o, lon_o   , lat_o, &
                  mxovr_i2o, iovr_i2o, jovr_i2o, wovr_i2o)

  use shr_kind_mod, only: r8 => shr_kind_r8
  implicit none

! ------------------------ code history ---------------------------
! source file:       map_i.F
! purpose:           driver for area averaging initialization
! date last revised: July 2000
! author:            Mariana Vertenstein
! -----------------------------------------------------------------

! ------------------------ notes ----------------------------------
! o get indices and weights for area-averaging:
!
!   from input surface grid to output model grid
!
! o input surface and output model grids can be any resolution BUT:
!
!   both grids must be oriented south to north, i.e., cell(lat+1)
!   must be north of cell(lat). the southern edge of the first row
!   must be -90 (south pole) and the northern edge of the last row
!   must be +90 (north pole)
!
!   both grids must be oriented eastwards, i.e., cell(lon+1) must be
!   east of cell(lon). but the two grids do not have to start at the
!   same longitude, i.e., one grid can start at dateline and go east;
!   the other grid can start at greenwich and go east. longitudes for
!   the western edge of the cells must increase continuously and span
!   360 degrees. examples
!   dateline            :  -180 to 180         (- longitudes west of greenwich)
!   greenwich           :     0 to 360
!   greenwich (centered): -dx/2 to -dx/2 + 360 (- longitudes west of greenwich)
!
! o field values fld_i on an  input grid with dimensions nlon_i and nlat_i =>
!   field values fld_o on an output grid with dimensions nlon_o and nlat_o as
!
!   fld_o(io,jo) =
!   fld_i(i_ovr(io,jo,     1 ),j_ovr(io,jo,     1 )) * w_ovr(io,jo,     1 ) +
!   fld_i(i_ovr(io,jo,mxovr_i),j_ovr(io,jo,mxovr_i)) * w_ovr(io,jo,mxovr_i)
!
! o error checks:
!   overlap weights of input cells sum to 1 for each output cell
!   global sums of dummy fields are conserved for input => model area-averaging
! -----------------------------------------------------------------

! ------------------- arguments -----------------------------------
  integer , intent(in) :: nlon_i                  !input grid max number of longitude points
  integer , intent(in) :: nlat_i                  !input grid number of latitude  points
  integer , intent(in) :: numlon_i(nlat_i)        !input grid number of longitude points at each lat
  real(r8), intent(in) :: lon_i(nlon_i+1,nlat_i)  !input grid cell longitude, west edge (degrees)
  real(r8), intent(in) :: lat_i(nlat_i+1)         !input grid cell latitude, south edge (degrees)
  integer , intent(in) :: nlon_o                  !model grid max number of longitude points
  integer , intent(in) :: nlat_o                  !model grid number of latitude  points
  integer , intent(in) :: numlon_o(nlat_o)        !model grid number of longitude points at each lat
  real(r8), intent(in) :: lon_o(nlon_o+1,nlat_o)  !model grid cell longitude, west edge  (degrees)
  real(r8), intent(in) :: lat_o(nlat_o+1)         !model grid cell latitude, south edge (degrees)
  integer , intent(in) :: mxovr_i2o               !max number of input cells that overlap model cell
  integer , intent(out):: iovr_i2o(nlon_o,nlat_o,mxovr_i2o) !lon index of overlap input cell
  integer , intent(out):: jovr_i2o(nlon_o,nlat_o,mxovr_i2o) !lat index of overlap input cell
  real(r8), intent(out):: wovr_i2o(nlon_o,nlat_o,mxovr_i2o) !weight    of overlap input cell
! -----------------------------------------------------------------
!
! ------------------- local variables -----------------------------
!
  real(r8) fld_i(nlon_i,nlat_i)   !dummy input grid field
  real(r8) fld_o(nlon_o,nlat_o)   !dummy model grid field
  real(r8) area_i(nlon_i,nlat_i)  !input grid cell area
  real(r8) area_o(nlon_o,nlat_o)  !model grid cell area
  real(r8) re                     !radius of earth
  real(r8) sum_fldo               !global sum of dummy model field
  real(r8) sum_fldi               !global sum of dummy input field
  integer io,ii                   !model and input longitude loop indices
  integer jo,ji                   !model and input latitude  loop indices
  real(r8), parameter :: relerr = 0.000001 !relative error for error checks
! -----------------------------------------------------------------

! -----------------------------------------------------------------
! get cell areas
! -----------------------------------------------------------------

  call cell_area (nlat_i, nlon_i, numlon_i, lon_i, lat_i, re, area_i)
                                                          
  call cell_area (nlat_o, nlon_o, numlon_o, lon_o, lat_o, re, area_o)

! -----------------------------------------------------------------
! get indices and weights for mapping from input grid to model grid
! -----------------------------------------------------------------

  call ao_i (nlon_i   , nlat_i   , numlon_i, lon_i    , lat_i , &
             nlon_o   , nlat_o   , numlon_o, lon_o    , lat_o , &
             mxovr_i2o, iovr_i2o , jovr_i2o, wovr_i2o , re    , &
             area_o   , relerr   )

! -----------------------------------------------------------------
! error check: global sum fld_o = global sum fld_i
! -----------------------------------------------------------------
!
! make dummy input field and sum globally
!
  sum_fldi = 0.
  do ji = 1, nlat_i      
    do ii = 1, numlon_i(ji)
      fld_i(ii,ji) = (ji-1)*nlon_i + ii
      sum_fldi = sum_fldi + area_i(ii,ji)*fld_i(ii,ji)
    end do
  end do
!
! area-average model field from input field
!
  call area_ave (nlat_i   , nlon_i   , numlon_i ,fld_i    , &
                 nlat_o   , nlon_o   , numlon_o ,fld_o    , &
                 iovr_i2o , jovr_i2o , wovr_i2o , mxovr_i2o)
!
! global sum of model field
!
  sum_fldo = 0.
  do jo = 1, nlat_o
    do io = 1, numlon_o(jo)
      sum_fldo = sum_fldo + area_o(io,jo)*fld_o(io,jo)
    end do
  end do
!
! check for conservation
!
  if ( abs(sum_fldo/sum_fldi-1.) > relerr ) then
    write (6,*) 'map_i error srf => model: srf field not conserved'
    write (6,'(a23,e20.10)') 'global sum model field = ',sum_fldo
    write (6,'(a23,e20.10)') 'global sum srf field   = ',sum_fldi
    call endrun
  end if

  return
end subroutine map_i

subroutine varf2c(flon   ,flat  ,nflon   ,nflat   ,fine   , &
                  clon   ,clat  ,nclon   ,nclat   ,cmean  , &
                  cvar  )

  use shr_kind_mod, only: r8 => shr_kind_r8

!-----------------------------------------------------------------------------
!       Bin going from a fine grid to a coarse grid.
!       A schematic for the coarse and fine grid systems is shown in
!       Figure 1.  This code assumes that each data point is represent
!       it's surrounding area, called a cell.  The first grid data point
!       for both grids is assumed to be located at 0E (GM).  This
!       implies that the 1st cell for both the fine and the coarse grids
!       strattles the Greenwich Meridian (GM).  This code also assumes
!       that there is no data wraparound (last data value is located at
!       360-dx).
!
!       FIGURE 1:  Overview of the coarse (X) and fine (@) grids
!                  longitudinal structure where:
!                  X = location of each coarse grid data point
!                  @ = location of each fine   grid data point
!
!           Greenwich                                     Greenwich
!              0          Coarse cells                       360
!              :          v                                   :
!       clon(1):  clon(2) v clon(3)                clon(nclon):
!         v    :    v     v   v                        v      :
!         xxxxxxxxxxxxxxxxxxxxxxxxxxxx..xxxxxxxxxxxxxxxx      :
!         x         x         x              x         x      :
!         x         x         x              x         x      :
!         x  c(1)   x  c(2)   x              x c(nclon)x      :
!         x    X    x    X    x              x    X    x      :
!         x   ___ ___ ___ ___ ___ ___    ___ ___ ___ ___ ___  :
!         x  |   |   |   |   |   |   |  |   |   |   |   |   | :
!         x  | @ | @ | @ | @ | @ | @ |..| @ | @ | @ | @ | @ | :
!         xxx|___|___|___|___|___|___|  |___|___|___|___|___| :
!              v       v       v                      v   v   :
!          flon(1)   flon(3)   v            flon(nflon-1) flon(nflon)
!              :               v                              :
!              :               Fine cells                     :
!              0                                             360
!
!    The Longitude/Latitude search:
!    ------------------------------
!
!      Given a coarse grid cell with west and east boundaries of cWest
!      and cEast and south and north boundaries of cSouth and cNorth
!      (outlined by "x" in figure 2), find the indices of the fine grid
!      points which are contained within the coarse grid cell. imin and 
!      imax are the indices fine grid points which overlap the western
!      and eastern boundary of the coarse cell.  jmin and jmax are the
!      corresponding indices in the S-N direction.  Bin these overlapping
!      values to generate coarse(n), the coarse grid data values.
!
!        FIGURE 2: Detail of Coarse and Fine cell overlap.
!                   @ = fine   grid data point
!                   X = coarse grid data point
!
!                             cWest             cEast
!                   |       |   x   |       |     x |
!                  -@-------@---x---@-------@-----x-@-
!                   |       |  x*xxxxxxxxxxxxxxxxx*x|xx cNorth
!                   |       |   x   |       |     x |
!                   |       |   x   |       |     x |
!                   @-------@---x---@-------@-----x-@- jmax
!                   |       |   x   |  c(n) |     x |
!                   |   @   |   x   |       |     x |
!                   |       |   x   |       |     x |
!                   @-------@---x---@-------@-----x-@- jmin
!                   |       |   x   |       |     x |
!                   |   @   |  x*xxxxxxx@xxxxxxxxx*x|xx cSouth
!                   |       |   x   |       |     x |
!                  -@-------@---x---@-------@-----x-@-  
!                   |             imin    imax      |
!
!
!      When a cell coarse cell strattles the Greenwich Meridian
!      ---------------------------------------------------------
!
!      The first coarse grid cell strattles the GM, so when the western
!      boundary of the coarse cell is < 0, an additional search is carried out. 
!      It ASSUMES that the easternmost fine grid point overlaps and searches
!      westward from nflon, looking for a grid point west of clon(1)
!      This generates a second set of longitudinal indices, imin1 and imax1.   
!      See Figure 3.
!
!       Figure 3:  Detail of Coarse cell strattling GM:
!       -----------------------------------------------
!
!              Greenwich                                   Greenwich
!                 0                                           360
!          cWest  :  cEast                            cWest    :
!          clon(1):  clon(2)               clon(nclon+1)=clon(1)
!            v    :    v                                v      :
!            xxxxxxxxxxxxxxxxxxxxxxx ... xxxxxxxxxxxxxxxx      :
!            x         x        x            x          x      :
!            x         x        x            x          x      :
!            x  c(1)   x        x            x  c(nclon)x      :
!            x    X    x        x            x     X    x      :
!            x   ___ ___ ___ _                    ___ ___ ___  :
!            x  |   |   |   |                        |   |   | :
!            x  | @ | @ | @ |                      @ | @ | @ | :
!            xxx|___|___|___|_                    ___|___|___| :
!                 ^ : ^   ^                            ^   ^   :
!            flon(1): ^ flon(3)              flon(nflon-1) ^   :
!                 ^ : ^                                ^   ^   :
!                 ^ :flon(2)                           ^ flon(nflon)
!                 ^ : ^                                ^   ^   :
!              imin : imax                         imin1 imax1 :
!                   :                                          :
!
!
!         In this case, imin=1, imax=2, imin1=nflon-1 and imax1=nflon.
!         because the last two cells of the fine grid will have some
!         contribution the the 1st cell of the coarse grid.
!
!-----------------------------------------------------------------------
  implicit none
!-----------------------------Arguments---------------------------------

  integer nflon           ! Input: number of fine longitude points
  integer nflat           ! Input: number of fine latitude points
  integer nclon           ! Input: number of coarse longitude points
  integer nclat           ! Input: number of coarse latitude points

  real(r8) flon(nflon)        ! Input: fine grid lons, centers (deg)
  real(r8) flat(nflat)        ! Input: fine grid lats, centers (deg)
  real(r8) fine(nflon,nflat)  ! Input: Fine grid data array
  real(r8) clon(nclon+1,nclat) ! Input: coarse grid cell lons, west  edge (deg)
  real(r8) clat(nclat+1)      ! Input: coarse grid cell lat,  south edge (deg)
  real(r8) cmean(nclon,nclat) ! Input: mean of fine points over coarse grid cell
  real(r8) cvar (nclon,nclat) ! Output:variance of fine points over coarse cell

!--------------------------Local variables------------------------------

  real(r8) cWest            ! Coarse cell longitude, west edge (deg)
  real(r8) cEast            ! Coarse cell longitude, east edge (deg)
  real(r8) cSouth           ! Coarse cell latitude, south edge (deg)
  real(r8) cNorth           ! Coarse cell latitude, notrh edge (deg)
  real(r8) sum              ! coarse tmp value
      
  integer i,j             ! Indices
  integer imin ,imax      ! Max/Min E-W indices of intersecting fine cell.
  integer imin1,imax1     ! fine E-W indices when coarse cell strattles GM
  integer jmin ,jmax      ! Max/Min N-S indices of intersecting fine cell.
  integer iclon,jclat     ! coarse grid indices
  integer num             ! increment 

!-----------------------------------------------------------------------------

  do jclat= 1,nclat         ! loop over coarse latitudes
    cSouth = clat(jclat)
    cNorth = clat(jclat+1)

    do iclon=1,nclon       ! loop over coarse longitudes
      cWest  = clon(iclon,jclat)
      cEAST  = clon(iclon+1,jclat)

!  1. Normal longitude search:  Find imin and imax

      imin = 0
      imax = 0
      do i=1,nflon-1                     ! loop over fine lons, W -> E
        if (flon(i) .gt. cEast) goto 10 ! fine grid point is E of coarse box
        if (flon(i) .ge. cWest .and. imin.eq.0) imin=i
        imax=i
      enddo

!  2. If cWest < 0, then coarse cell strattles GM.  Hunt westward
!     from the end to find indices of any overlapping fine grid cells:
!     imin1 and imax1.

10    imin1 = 0           ! borders for cWest, cEast
      imax1 = -1          ! borders for cWest, cEast
      if (cWest .lt. 0) then
        cWest = cWest + 360.
        imax1 = nflon
        do i=nflon,1,-1                     ! loop over fine lons, E -> W
          imin1=i
          if (flon(i) .le. cWest) goto 20 ! fine grid point is W of coarse box 
        enddo
      endif

!  3. Do the latitude search S -> N for jmin and jmax
      
20    jmin = 0
      jmax = 0
      do  j=1,nflat                       ! loop over fine lats, S -> N
        if (flat(j) .gt. cNorth) goto 30 ! fine grid point is N of coarse box
        if (flat(j) .ge. cSouth .and. jmin.eq.0) jmin=j
        jmax=j
      enddo
30    continue

!  4. Sdv

      sum = 0.                        ! Initialize coarse data value
      num  = 0

      do j=jmin,jmax                   ! loop over fine lats, S -> N
        do i=imin,imax                ! loop over fine lons, W -> E
          sum = sum + (fine(i,j) - cmean(iclon,jclat))**2
          num  = num + 1
        enddo
        do i=imin1,imax1              ! If coarse cell strattles GM
          sum = sum + (fine(i,j) - cmean(iclon,jclat))**2
          num  = num + 1 
        enddo
      enddo

      if (num .gt. 0) then
        cvar(iclon,jclat) = sum/num
      else
        cvar(iclon,jclat) = 1.e30
      endif
    end do
  end do
  return
end subroutine varf2c

subroutine ao (nlon_i , nlat_i , numlon_i, lon_i  , lat_i  , &
               nlon_o , nlat_o , numlon_o, lon_o  , lat_o  , &
               area_o , re     , mx_ovr  , n_ovr  , i_ovr  , &
               j_ovr  , w_ovr  )

  use shr_kind_mod, only: r8 => shr_kind_r8

! -----------------------------------------------------------------
  implicit none
! ------------------------ code history ---------------------------
! source file:       ao.F
! purpose:           weights and indices for area of overlap between 
!                    input and output grids
! date last revised: March 1996 
! author:            Gordon Bonan
! standardized: 
! reviewed:    
! -----------------------------------------------------------------

! ------------------- input variables -----------------------------
  integer nlon_i              !maximum number of input  longitude points
  integer nlat_i              !number of input  latitude points
  integer numlon_i(nlat_i)    !number of input lon pts for each latitude 
  integer nlon_o              !maximum number of output longitude points
  integer nlat_o              !number of output latitude points
  integer numlon_o(nlat_o)    !number of output lon pts for each latitude 
  integer mx_ovr              !maximum number of overlapping input cells

  real(r8) lon_i(nlon_i+1,nlat_i) !input  grid cell longitude, w. edge (deg)
  real(r8) lon_o(nlon_o+1,nlat_o) !output grid cell longitude, w. edge (deg)
  real(r8) lat_i(nlat_i+1)        !input  grid cell latitude, s. edge (deg)
  real(r8) lat_o(nlat_o+1)        !output grid cell latitude, s. edge (deg)
  real(r8) area_o(nlon_o,nlat_o)  !area of output grid cell
  real(r8) re                     !radius of earth
! -----------------------------------------------------------------

! ------------------- input/output variables ----------------------
  integer n_ovr(nlon_o,nlat_o       ) !number of overlapping input cells
  integer i_ovr(nlon_o,nlat_o,mx_ovr) !lon index, overlapping input cell
  integer j_ovr(nlon_o,nlat_o,mx_ovr) !lat index, overlapping input cell

  real(r8)  w_ovr(nlon_o,nlat_o,mx_ovr) !overlap weights for input cells
! -----------------------------------------------------------------

! ------------------- local variables -----------------------------
  integer io,ii        !output and input grids longitude loop index
  integer jo,ji        !output and input grids latitude  loop index

  real(r8) lonw,lone,dx    !west, east longitudes of overlap and difference
  real(r8) lats,latn,dy    !south, north latitudes of overlap and difference
  real(r8) deg2rad         !pi/180
  real(r8) a_ovr           !area of overlap
  real(r8) zero,one
  parameter (zero=0.0)   ! Needed as arg to "max"
  parameter (one=1.)     ! Needed as arg to "atan"
! -----------------------------------------------------------------

  deg2rad = (4.*atan(one)) / 180.

! -----------------------------------------------------------------
! for each output grid cell: find overlapping input grid cell and area of
! input grid cell that overlaps with output grid cell. cells overlap if:
!
! southern edge of input grid < northern edge of output grid AND
! northern edge of input grid > southern edge of output grid
!
! western edge of input grid < eastern edge of output grid AND
! eastern edge of input grid > western edge of output grid
!
!           lon_o(io,jo)      lon_o(io+1,jo)
!
!              |                   |
!              --------------------- lat_o(jo+1)
!              |                   |
!              |                   |
!    xxxxxxxxxxxxxxx lat_i(ji+1)   |
!    x         |   x               |
!    x  input  |   x   output      |
!    x  cell   |   x    cell       |
!    x  ii,ji  |   x   io,jo       |
!    x         |   x               |
!    x         ----x---------------- lat_o(jo  )
!    x             x
!    xxxxxxxxxxxxxxx lat_i(ji  )
!    x             x
! lon_i(ii,ji) lon_i(ii+1,ji)
! -----------------------------------------------------------------

! note that code does not vectorize but is only called during 
! initialization.

  do jo = 1, nlat_o
    do io = 1, numlon_o(jo)

! loop through all input grid cells to find overlap with output grid.

      do ji = 1, nlat_i                            
        if ( lat_i(ji  ).lt.lat_o(jo+1) .and. &
             lat_i(ji+1).gt.lat_o(jo  ) ) then                !lat ok

          do ii = 1, numlon_i(ji)
            if ( lon_i(ii  ,ji).lt.lon_o(io+1,jo) .and. &
                 lon_i(ii+1,ji).gt.lon_o(io  ,jo) ) then    !lon okay

! increment number of overlapping cells. make sure 0 < n_ovr < mx_ovr

              n_ovr(io,jo) = n_ovr(io,jo) + 1
!             if (n_ovr(io,jo) .gt. mx_ovr) then
!               write (6,*) 'AO error: n_ovr= ',n_ovr(io,jo), &
!                           ' exceeded mx_ovr = ',mx_ovr, &
!                           ' for output lon,lat = ',io,jo
!               call endrun
!             end if

! determine area of overlap

              lone = min(lon_o(io+1,jo),lon_i(ii+1,ji))*deg2rad !e edge
              lonw = max(lon_o(io  ,jo),lon_i(ii  ,ji))*deg2rad !w edge
              dx = max(zero,(lone-lonw))
              latn = min(lat_o(jo+1),lat_i(ji+1))*deg2rad    !n edge
              lats = max(lat_o(jo  ),lat_i(ji  ))*deg2rad    !s edge
              dy = max(zero,(sin(latn)-sin(lats)))
              a_ovr = dx*dy*re*re

! determine indices and weights. re cancels in the division by area

              i_ovr(io,jo,n_ovr(io,jo)) = ii
              j_ovr(io,jo,n_ovr(io,jo)) = ji
              w_ovr(io,jo,n_ovr(io,jo)) = a_ovr/area_o(io,jo)

            end if
          end do

        end if
      end do

    end do
  end do
      
  return
end subroutine ao

      program region

      implicit none
      integer :: i, j, k, recl_factor
      integer, parameter :: imt=NX, jmt=NY
      integer*4, dimension(imt,jmt) :: kmt, mask 
      double precision ulat(imt,jmt)

      integer temp(imt,jmt)

      open (1, file='kmt.da', 
     &      access='direct',
     &      form='unformatted', recl=jmt*imt*4,
     &      status='old')

      open (2, file='grid.pop.da', 
     &      access='direct',
     &      form='unformatted', recl=jmt*imt*8,
     &      status='old')

      open (3, file='region.ieeei4', 
     &      access='direct',
     &      form='unformatted', recl=jmt*imt*4,
     &      status='unknown',
     &      action='write')

c read in topo levels:
      read  (1, rec=1) kmt
c read in grid:
      read  (2, rec=1) ulat
     
      mask = kmt
      do i = 1,imt 
      do j = 1,jmt 
ccthis should work since ulat=0 at eq and has same j as kmt box just north.
       if(ulat(i,j).ge.0.d0.and.kmt(i,j).gt.0) mask(i,j)=1 
       if(ulat(i,j).lt.0.d0.and.kmt(i,j).gt.0) mask(i,j)=2 
c this should work since ulat=0 at eq and has same j as kmt box just south.

c north panthalassa
c        if(ulat(i,j).gt.0.d0.and.kmt(i,j).gt.0) mask(i,j)=1 
c south panthalassa
c        if(ulat(i,j).le.0.d0.and.kmt(i,j).gt.0) mask(i,j)=2 

c tethys
c        if(i.ge.0.and.i.le.57.and.j.ge.50.and.j.le.280.and.
c     &     kmt(i,j).gt.0) mask(i,j)=3
c        if(i.ge.280.and.i.le.320.and.j.ge.75.and.j.le.254.and.
c     &     kmt(i,j).gt.0) mask(i,j)=3

c return some cells to north panthalassa
c        if(i.ge.45.and.i.le.60.and.j.ge.260.and.j.le.284.and.
c     &     kmt(i,j).gt.0) mask(i,j)=1

      enddo
      enddo

      write (unit=3, rec=1)mask
      end

logical function is_special_case (name)

   implicit none

   include 'netcdf.inc'

   ! Input arguments

   character(len=*), intent(in) :: name
   !---------------------------------------------------------------------

   is_special_case = .false.

   ! Hardwire variable names known to be functions of spatial dimensions

   if (name == 'rlon' .or. name == 'nlon'   .or. name == 'wnummax' .or. &
       name == 'hyai' .or. name == 'hybi'   .or. &
       name == 'hyam' .or. name == 'hybm'   .or. &
       name == 'gw'   .or. name == 'w_stag' .or. &
       name == 'lat'  .or. name == 'lon'    .or. &
       name == 'slat' .or. name == 'slon'   .or. &
       name == 'lev'  .or. name == 'ilev') then

      is_special_case = .true.

   end if

end function is_special_case

module mkdomainMod
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: domain1Mod
!
! !DESCRIPTION:
! Module containing 2-d global surface boundary data information
!
! !USES:
  use shr_kind_mod, only : r8 => shr_kind_r8
  use mkvarpar    , only : re
  use nanMod      , only : nan, bigint
!
! !PUBLIC TYPES:
  implicit none
  private
!
  public :: domain_type

  type domain_type
     character*16     :: set        ! flag to check if domain is set
     integer          :: ns         ! global size of domain
     integer          :: ni,nj      ! for 2d domains only
     real(r8)         :: edgen      ! lsmedge north
     real(r8)         :: edgee      ! lsmedge east
     real(r8)         :: edges      ! lsmedge south
     real(r8)         :: edgew      ! lsmedge west
     integer ,pointer :: mask(:)    ! land mask: 1 = land, 0 = ocean
     real(r8),pointer :: frac(:)    ! fractional land
     real(r8),pointer :: latc(:)    ! latitude of grid cell (deg)
     real(r8),pointer :: lonc(:)    ! longitude of grid cell (deg)
     real(r8),pointer :: lats(:)    ! grid cell latitude, S edge (deg)
     real(r8),pointer :: latn(:)    ! grid cell latitude, N edge (deg)
     real(r8),pointer :: lonw(:)    ! grid cell longitude, W edge (deg)
     real(r8),pointer :: lone(:)    ! grid cell longitude, E edge (deg)
     real(r8),pointer :: area(:)    ! grid cell area (km**2) (only used for output grid)
     logical          :: fracset    ! if frac is set
     logical          :: maskset    ! if mask is set
  end type domain_type

!
! !PUBLIC MEMBER FUNCTIONS:
  public domain_clean         
  public domain_check         
  public domain_read 
  public domain_read_map
  public domain_write         
  public domain_checksame
!
!
! !REVISION HISTORY:
! Originally clm_varsur by Mariana Vertenstein
! Migrated from clm_varsur to domainMod by T Craig
!
  character*16,parameter :: set   = 'domain_set      '
  character*16,parameter :: unset = 'NOdomain_unsetNO'

  real(r8) :: flandmin = 0.001            !minimum land frac for land cell
!
! !PRIVATE MEMBER FUNCTIONS:
  private domain_init          
!
!EOP
!------------------------------------------------------------------------------

contains

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: domain_init
!
! !INTERFACE:
  subroutine domain_init(domain,ns)
!
! !DESCRIPTION:
! This subroutine allocates and nans the domain type
!
! !ARGUMENTS:
    implicit none
    type(domain_type) :: domain        ! domain datatype
    integer            :: ns            ! grid size, 2d
!
! !REVISION HISTORY:
!   Created by T Craig
!
!
! !LOCAL VARIABLES:
!EOP
    integer ier
    integer nb,ne
!
!------------------------------------------------------------------------------

    nb = 1
    ne = ns
    
    if (domain%set == set) then
       call domain_clean(domain)
    endif
    
    allocate(domain%mask(ns), &
             domain%frac(ns), &
             domain%latc(ns), &
             domain%lonc(ns), &
             domain%lats(ns), &
             domain%latn(ns), &
             domain%lonw(ns), &
             domain%lone(ns), &
             domain%area(ns), stat=ier)
    if (ier /= 0) then
       write(6,*) 'domain_init ERROR: allocate mask, frac, lat, lon, area '
    endif
    
    domain%ns       = ns
    domain%mask     = -9999
    domain%frac     = -1.0e36
    domain%latc     = nan
    domain%lonc     = nan
    domain%area     = nan
    domain%set      = set
    domain%fracset  = .false.
    domain%maskset  = .false.
    
  end subroutine domain_init

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: domain_clean
!
! !INTERFACE:
  subroutine domain_clean(domain)
!
! !DESCRIPTION:
! This subroutine deallocates the domain type
!
! !ARGUMENTS:
    implicit none
    type(domain_type) :: domain        ! domain datatype
!
! !REVISION HISTORY:
!   Created by T Craig
!
!
! !LOCAL VARIABLES:
!EOP
    integer ier
!
!------------------------------------------------------------------------------

    if (domain%set == set) then
       write(6,*) 'domain_clean: cleaning ',domain%ns
       deallocate(domain%mask, &
                  domain%frac, &
                  domain%latc, &
                  domain%lonc, &
                  domain%lats, &
                  domain%latn, &
                  domain%lonw, &
                  domain%lone, &
                  domain%area, stat=ier)
       if (ier /= 0) then
          write(6,*) 'domain_clean ERROR: deallocate mask, frac, lat, lon, area '
          call abort()
       endif
    else
       write(6,*) 'domain_clean WARN: clean domain unecessary '
    endif

    domain%ns       = bigint
    domain%set      = unset
    domain%fracset  = .false.
    domain%maskset  = .false.

end subroutine domain_clean

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: domain_check
!
! !INTERFACE:
  subroutine domain_check(domain)
!
! !DESCRIPTION:
! This subroutine write domain info
!
! !ARGUMENTS:
    implicit none
    type(domain_type),intent(in)  :: domain        ! domain datatype
!
! !REVISION HISTORY:
!   Created by T Craig
!
!
! !LOCAL VARIABLES:
!
!EOP
!------------------------------------------------------------------------------

    write(6,*) '  domain_check set       = ',trim(domain%set)
    write(6,*) '  domain_check ns        = ',domain%ns
    write(6,*) '  domain_check lonc      = ',minval(domain%lonc),maxval(domain%lonc)
    write(6,*) '  domain_check latc      = ',minval(domain%latc),maxval(domain%latc)
    write(6,*) '  domain_check mask      = ',minval(domain%mask),maxval(domain%mask)
    write(6,*) '  domain_check frac      = ',minval(domain%frac),maxval(domain%frac)
    write(6,*) ' '

end subroutine domain_check

!----------------------------------------------------------------------------
!BOP
!
! !IROUTINE: domain_read_map
!
! !INTERFACE:
  logical function domain_read_map(domain, fname)
!
! !DESCRIPTION:
! Read a grid file
!
! !USES:
    use mkutilsMod, only : convert_latlon
!
! !ARGUMENTS:
    implicit none
    type(domain_type),intent(inout) :: domain
    character(len=*) ,intent(in)     :: fname    ! this assumes a SCRIP mapping file - look at destination grid
!
! !REVISION HISTORY:
! Author: Mariana Vertenstein
!
!
! !LOCAL VARIABLES:
!EOP
    include 'netcdf.inc'
    integer :: i,j,n                           ! indices
    integer :: grid_rank                       ! rank of domain grid 
    integer :: ns                              ! size of domain grid
    integer :: ncid                            ! netCDF file id
    integer :: dimid                           ! netCDF dimension id
    integer :: varid                           ! netCDF variable id
    integer :: ndims                           ! number of dims for variable
    integer :: ier                             ! error status
    real(r8), allocatable :: xv(:,:)           ! local array for corner lons
    real(r8), allocatable :: yv(:,:)           ! local array for corner lats
    integer :: grid_dims(2)
    character(len= 32) :: subname = 'domain_read'
!-----------------------------------------------------------------

    domain_read_map = .true.

    ! Read domain file and compute stuff as needed

    call check_ret(nf_open(fname, 0, ncid), subname)

    ! Assume unstructured grid

    domain%ni = -9999
    domain%nj = -9999

    ier = nf_inq_dimid  (ncid, 'n_b', dimid)
    if ( ier /= NF_NOERR )then
       domain_read_map = .false.
    else
      call check_ret(nf_inq_dimlen (ncid, dimid, domain%ns), subname)
    
      call check_ret(nf_inq_dimid  (ncid, 'dst_grid_rank', dimid), subname)
      call check_ret(nf_inq_dimlen (ncid, dimid, grid_rank), subname)

      if (grid_rank == 2) then
         call check_ret(nf_inq_varid  (ncid, 'dst_grid_dims', varid), subname)
         call check_ret(nf_get_var_int (ncid, varid, grid_dims), subname)
         domain%ni = grid_dims(1)
         domain%nj = grid_dims(2)
      end if

      call domain_init(domain, domain%ns)
      ns = domain%ns

      call check_ret(nf_inq_varid (ncid, 'xc_b', varid), subname)
      call check_ret(nf_get_var_double (ncid, varid, domain%lonc), subname)
      call convert_latlon(ncid, 'xc_b', domain%lonc)

      call check_ret(nf_inq_varid (ncid, 'yc_b', varid), subname)
      call check_ret(nf_get_var_double (ncid, varid, domain%latc), subname)
      call convert_latlon(ncid, 'yc_b', domain%latc)

      if (grid_rank == 2 ) then
         allocate(yv(4,ns), xv(4,ns))
         call check_ret(nf_inq_varid (ncid, 'yv_b', varid), subname)
         call check_ret(nf_get_var_double (ncid, varid, yv), subname)
         call check_ret(nf_inq_varid (ncid, 'xv_b', varid), subname)
         call check_ret(nf_get_var_double (ncid, varid, xv), subname)

         domain%lats(:) = yv(1,:)  
         call convert_latlon(ncid, 'yv_b', domain%lats(:))

         domain%latn(:) = yv(3,:)  
         call convert_latlon(ncid, 'yv_b', domain%latn(:))

         domain%lonw(:) = xv(1,:)
         call convert_latlon(ncid, 'xv_b', domain%lonw(:))

         domain%lone(:) = xv(2,:)
         call convert_latlon(ncid, 'xv_b', domain%lone(:))

         domain%edgen = maxval(domain%latn)
         domain%edgee = maxval(domain%lone)
         domain%edges = minval(domain%lats)
         domain%edgew = minval(domain%lonw)
         deallocate(yv,xv)
      end if
       
      call check_ret(nf_inq_varid (ncid, 'frac_b', varid), subname)
      call check_ret(nf_get_var_double (ncid, varid, domain%frac), subname)

      call check_ret(nf_inq_varid (ncid, 'mask_b', varid), subname)
      call check_ret(nf_get_var_int (ncid, varid, domain%mask), subname)

      call check_ret(nf_inq_varid (ncid, 'area_b', varid), subname)
      call check_ret(nf_get_var_double (ncid, varid, domain%area), subname)
      domain%area = domain%area * re**2
    end if
    domain%maskset = .true.
    domain%fracset = .true.

    call check_ret(nf_close(ncid), subname)

  end function domain_read_map

!----------------------------------------------------------------------------
!BOP
!
! !IROUTINE: domain_read
!
! !INTERFACE:
  subroutine domain_read(domain, fname, readmask)
!
! !DESCRIPTION:
! Read a grid file
!
! !USES:
    use mkutilsMod, only : convert_latlon
!
! !ARGUMENTS:
    implicit none
    type(domain_type),intent(inout) :: domain
    character(len=*) ,intent(in)     :: fname
    logical,optional, intent(in)     :: readmask ! true => read mask instead of landmask for urban parameters
!
! !REVISION HISTORY:
! Author: Mariana Vertenstein
!
!
! !LOCAL VARIABLES:
!EOP
    include 'netcdf.inc'
    integer :: i,j,n
    integer :: nlon,nlat                       ! size
    integer :: ns                              ! size of domain
    real(r8), allocatable :: lon1d(:)          ! local array for 1d lon
    real(r8), allocatable :: lat1d(:)          ! local array for 1d lat
    real(r8), allocatable :: xv(:,:)           ! local array for corner lons
    real(r8), allocatable :: yv(:,:)           ! local array for corner lats
    integer :: ncid                            ! netCDF file id
    integer :: dimid                           ! netCDF dimension id
    integer :: varid                           ! netCDF variable id
    logical :: dimset                          ! local ni,nj
    logical :: edgeNESWset                     ! local EDGE[NESW]
    logical :: lonlatset                       ! local lon(:,:), lat(:,:)
    logical :: llneswset                       ! local lat[ns],lon[we]
    logical :: landfracset                     ! local landfrac
    logical :: maskset                         ! local mask
    integer :: ndims                           ! number of dims for variable
    integer :: ier                             ! error status
    logical :: lreadmask                       ! local readmask
    character(len= 32) :: lonvar               ! name of 2-d longitude variable
    character(len= 32) :: latvar               ! name of 2-d latitude variable
    character(len= 32) :: subname = 'domain_read'
!-----------------------------------------------------------------

    dimset      = .false. 
    lonlatset   = .false. 
    edgeNESWset = .false. 
    llneswset   = .false. 
    landfracset = .false. 
    maskset     = .false. 
    lreadmask   = .false.

    if (present(readmask)) then
       lreadmask = readmask
    end if

    ! Read domain file and compute stuff as needed

    call check_ret(nf_open(fname, 0, ncid), subname)

    ! Assume unstructured grid
    domain%ni = -9999
    domain%nj = -9999

    ! ----- Set lat/lon dimension ------

    ier = nf_inq_dimid (ncid, 'lon', dimid)
    if (ier == NF_NOERR) then
       if (dimset) write(6,*) trim(subname),' WARNING, overwriting dims'
       dimset = .true.
       write(6,*) trim(subname),' read lon and lat dims'
       call check_ret(nf_inq_dimid  (ncid, 'lon', dimid), subname)
       call check_ret(nf_inq_dimlen (ncid, dimid, nlon), subname)
       call check_ret(nf_inq_dimid  (ncid, 'lat', dimid), subname)
       call check_ret(nf_inq_dimlen (ncid, dimid, nlat), subname)
       domain%ni = nlon
       domain%nj = nlat
    endif

    ier = nf_inq_dimid (ncid, 'ni', dimid)
    if (ier == NF_NOERR) then
       if (dimset) write(6,*) trim(subname),' WARNING, overwriting dims'
       dimset = .true.
       write(6,*) trim(subname),' read ni and nj dims'
       call check_ret(nf_inq_dimid  (ncid, 'ni', dimid), subname)
       call check_ret(nf_inq_dimlen (ncid, dimid, nlon), subname)
       call check_ret(nf_inq_dimid  (ncid, 'nj', dimid), subname)
       call check_ret(nf_inq_dimlen (ncid, dimid, nlat), subname)
       domain%ni = nlon
       domain%nj = nlat
    endif

    ier = nf_inq_dimid (ncid, 'lsmlon', dimid)
    if (ier == NF_NOERR) then
       if (dimset) write(6,*) trim(subname),' WARNING, overwriting dims'
       dimset = .true.
       write(6,*) trim(subname),' read lsmlon and lsmlat dims'
       call check_ret(nf_inq_dimid  (ncid, 'lsmlon', dimid), subname)
       call check_ret(nf_inq_dimlen (ncid, dimid, nlon), subname)
       call check_ret(nf_inq_dimid  (ncid, 'lsmlat', dimid), subname)
       call check_ret(nf_inq_dimlen (ncid, dimid, nlat), subname)
       domain%ni = nlon
       domain%nj = nlat
    endif

    if (dimset) then
       write(6,*) trim(subname),' initialized domain'
       call domain_init(domain,nlon*nlat)
    else
       write(6,*) trim(subname),' ERROR: dims not set for domain_init'
       call abort()
    endif
    ns = domain%ns

    ! ----- Set lat/lon variable ------

    lonvar = ' '
    latvar = ' '

    if (.not. lonlatset) then
       ier = nf_inq_varid (ncid, 'LONGXY', varid)
       if (ier == NF_NOERR) then
          lonvar = 'LONGXY'
          latvar = 'LATIXY'
          lonlatset = .true.
       end if
    end if

    if (.not. lonlatset) then
       ier = nf_inq_varid (ncid, 'lon', varid)
       if (ier == NF_NOERR) then
          lonvar = 'lon'
          latvar = 'lat'
          lonlatset = .true.
       end if
    end if

    if (.not. lonlatset) then
       write(6,*)'lon/lat values not set' 
       write(6,*)'currently assume either that lon/lat or LONGXY/LATIXY', &
            ' variables are on input dataset'
       call abort()
    end if

    call check_ret(nf_inq_varid (ncid, lonvar, varid), subname)
    call check_ret(nf_get_var_double (ncid, varid, domain%lonc), subname)
    call convert_latlon(ncid, lonvar, domain%lonc)

    call check_ret(nf_inq_varid (ncid, latvar, varid), subname)
    call check_ret(nf_get_var_double (ncid, varid, domain%latc), subname)
    call convert_latlon(ncid, latvar, domain%latc)

    ! ----- Set landmask/landfrac  ------

    ier = nf_inq_varid (ncid, 'frac', varid)
    if (ier == NF_NOERR) then
       if (landfracset) write(6,*) trim(subname),' WARNING, overwriting frac'
       landfracset = .true.
       write(6,*) trim(subname),' read frac'
       call check_ret(nf_inq_varid (ncid, 'frac', varid), subname)
       call check_ret(nf_get_var_double (ncid, varid, domain%frac), subname)
    endif

    ier = nf_inq_varid (ncid, 'LANDFRAC', varid)
    if (ier == NF_NOERR) then
       if (landfracset) write(6,*) trim(subname),' WARNING, overwriting frac'
       landfracset = .true.
       write(6,*) trim(subname),' read LANDFRAC'
       call check_ret(nf_inq_varid (ncid, 'LANDFRAC', varid), subname)
       call check_ret(nf_get_var_double (ncid, varid, domain%frac), subname)
    endif

    if (lreadmask) then
       ier = nf_inq_varid (ncid, 'mask', varid)
       if (ier == NF_NOERR) then
          if (maskset) write(6,*) trim(subname),' WARNING, overwriting mask'
          maskset = .true.
          write(6,*) trim(subname),' read mask with lreadmask set'
          call check_ret(nf_inq_varid (ncid, 'mask', varid), subname)
          call check_ret(nf_get_var_int (ncid, varid, domain%mask), subname)
       endif
    else
       ier = nf_inq_varid (ncid, 'mask', varid)
       if (ier == NF_NOERR) then
          if (maskset) write(6,*) trim(subname),' WARNING, overwriting mask'
          maskset = .true.
          write(6,*) trim(subname),' read mask'
          call check_ret(nf_inq_varid (ncid, 'mask', varid), subname)
          call check_ret(nf_get_var_int (ncid, varid, domain%mask), subname)
       endif
       ier = nf_inq_varid (ncid, 'LANDMASK', varid)
       if (ier == NF_NOERR) then
          if (maskset) write(6,*) trim(subname),' WARNING, overwriting mask'
          maskset = .true.
          write(6,*) trim(subname),' read LANDMASK'
          call check_ret(nf_inq_varid (ncid, 'LANDMASK', varid), subname)
          call check_ret(nf_get_var_int (ncid, varid, domain%mask), subname)
       endif
    end if

    call check_ret(nf_close(ncid), subname)

    ! ----- set derived variables ----

    if (.not.maskset.and.landfracset) then
       maskset = .true.
       where (domain%frac < flandmin)
          domain%mask = 0     !ocean
       elsewhere
          domain%mask = 1     !land
       endwhere
    endif

    if (.not.landfracset.and.maskset) then
       landfracset = .true.
       do n = 1,ns
          if ( domain%mask(n) == 0 )then
             domain%frac(n) = 0._r8     !ocean
          else
             domain%frac(n) = 1._r8     !land
          end if
       end do
    endif
    domain%maskset = maskset
    domain%fracset = landfracset

  end subroutine domain_read

!----------------------------------------------------------------------------
!BOP
!
! !IROUTINE: domain_write
!
! !INTERFACE:
  subroutine domain_write(domain,fname)
!
! !DESCRIPTION:
! Write a domain to netcdf

! !ARGUMENTS:
    implicit none
    include 'netcdf.inc'
    type(domain_type),intent(inout) :: domain
    character(len=*)  ,intent(in)    :: fname
!
! !REVISION HISTORY:
! Author: T Craig
!
!
! !LOCAL VARIABLES:
!EOP
    integer  :: varid                          !netCDF variable id
    integer  :: ncid                           !netCDF file id
    integer  :: omode                          !netCDF output mode
    character(len= 32) :: subname = 'domain_write'
!-----------------------------------------------------------------

    call check_ret(nf_open(trim(fname), nf_write, ncid), subname)
    ! File will be in define mode. Set fill mode to "no fill" to optimize performance

    call check_ret(nf_set_fill (ncid, nf_nofill, omode), subname)

    ! Write domain fields 

    call check_ret(nf_inq_varid(ncid, 'AREA', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, domain%area), subname)

    call check_ret(nf_inq_varid(ncid, 'LONGXY', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, domain%lonc), subname)

    call check_ret(nf_inq_varid(ncid, 'LATIXY', varid), subname)
    call check_ret(nf_put_var_double(ncid, varid, domain%latc), subname)

    ! Synchronize the disk copy of a netCDF dataset with in-memory buffers

    call check_ret(nf_sync(ncid), subname)

    ! Close grid data dataset

    call check_ret(nf_close(ncid), subname)

  end subroutine domain_write

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: check_ret
!
! !INTERFACE:
  subroutine check_ret(ret, calling)
!
! !DESCRIPTION:
! Check return status from netcdf call
!
! !ARGUMENTS:
    implicit none
    include 'netcdf.inc'
    integer, intent(in) :: ret
    character(len=*)    :: calling
!
! !REVISION HISTORY:
!
!EOP
!-----------------------------------------------------------------------

    if (ret /= NF_NOERR) then
       write(6,*)'netcdf error from ',trim(calling), ' rcode = ', ret, &
                 ' error = ', NF_STRERROR(ret)
       call abort()
    end if

  end subroutine check_ret

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: domain_checksame
!
! !INTERFACE:
  subroutine domain_checksame( srcdomain, dstdomain, tgridmap )
!
! !DESCRIPTION:
! Check that the input domains agree with the input map
!
! USES:
    use mkgridmapMod, only : gridmap_type, gridmap_setptrs
! !ARGUMENTS:
    implicit none
    type(domain_type), intent(in) :: srcdomain ! input domain
    type(domain_type), intent(in) :: dstdomain ! output domain
    type(gridmap_type),intent(in) :: tgridmap  ! grid map
!
! !REVISION HISTORY:
!
!EOP
!-----------------------------------------------------------------------
     integer :: na, nb, ns             ! gridmap sizes
     integer :: n, ni                  ! indices
     real(r8), pointer :: xc_src(:)    ! Source longitude
     real(r8), pointer :: yc_src(:)    ! Source latitude
     real(r8), pointer :: frac_src(:)  ! Source fraction
     integer,  pointer :: mask_src(:)  ! Source mask
     integer,  pointer :: src_indx(:)  ! Source index
     real(r8), pointer :: xc_dst(:)    ! Destination longitude
     real(r8), pointer :: yc_dst(:)    ! Destination latitude
     real(r8), pointer :: frac_dst(:)  ! Destination fraction
     integer,  pointer :: mask_dst(:)  ! Destination mask
     integer,  pointer :: dst_indx(:)  ! Destination index
     character(len= 32) :: subname = 'domain_checksame'

     ! tolerance for checking equality of lat & lon
     ! For a value of order 100 (e.g., lat / lon), machine epsilon is approximately 1e-13
     ! or 1e-14. We'll use 1e-12 to allow for slightly greater rounding errors.
     real(r8), parameter :: eps = 1.e-12_r8


     if (srcdomain%set == unset) then
        write(6,*) trim(subname)//'ERROR: source domain is unset!'
        call abort()
     end if
     if (srcdomain%set == unset) then
        write(6,*) trim(subname)//'ERROR: destination domain is unset!'
        call abort()
     end if

     call gridmap_setptrs( tgridmap, nsrc=na, ndst=nb, ns=ns,    &
                           xc_src=xc_src, yc_src=yc_src,         &
                           xc_dst=xc_dst, yc_dst=yc_dst,         &
                           mask_src=mask_src, mask_dst=mask_dst, &
                           src_indx=src_indx, dst_indx=dst_indx  &
                         )
       
     if (srcdomain%ns /= na) then
        write(6,*) trim(subname)// &
              ' ERROR: input domain size and gridmap source size are not the same size'
        write(6,*)' domain size = ',srcdomain%ns
        write(6,*)' map src size= ',na
        call abort()
     end if
     if (dstdomain%ns /= nb) then
        write(6,*) trim(subname)// &              
           ' ERROR: output domain size and gridmap destination size are not the same size'
        write(6,*)' domain size = ',dstdomain%ns
        write(6,*)' map dst size= ',nb
        call abort()
     end if
     do n = 1,ns
        ni = src_indx(n)
        if ( srcdomain%maskset )then
           if (srcdomain%mask(ni) /= mask_src(ni)) then
              write(6,*) trim(subname)// &              
                 ' ERROR: input domain mask and gridmap mask are not the same at ni = ',ni
              write(6,*)' domain  mask= ',srcdomain%mask(ni)
              write(6,*)' gridmap mask= ',mask_src(ni)
              call abort()
           end if
        end if
        if (abs(srcdomain%lonc(ni) - xc_src(ni)) > eps) then
           write(6,*) trim(subname)// &
               ' ERROR: input domain lon and gridmap lon not the same at ni = ',ni
           write(6,*)' domain  lon= ',srcdomain%lonc(ni)
           write(6,*)' gridmap lon= ',xc_src(ni)
           call abort()
        end if
        if (abs(srcdomain%latc(ni) - yc_src(ni)) > eps) then
           write(6,*) trim(subname)// &               
               ' ERROR: input domain lat and gridmap lat not the same at ni = ',ni
           write(6,*)' domain  lat= ',srcdomain%latc(ni)
           write(6,*)' gridmap lat= ',yc_src(ni)
           call abort()
        end if
     end do
     do n = 1,ns
        ni = dst_indx(n)
        if ( dstdomain%maskset )then
           if (dstdomain%mask(ni) /= mask_dst(ni)) then
              write(6,*) trim(subname)// &                              
                  ' ERROR: output domain mask and gridmap mask are not the same at ni = ',ni
              write(6,*)' domain  mask= ',dstdomain%mask(ni)
              write(6,*)' gridmap mask= ',mask_dst(ni)
              call abort()
           end if
        end if
        if (abs(dstdomain%lonc(ni) - xc_dst(ni)) > eps) then
           write(6,*) trim(subname)// &
               ' ERROR: output domain lon and gridmap lon not the same at ni = ',ni
           write(6,*)' domain  lon= ',dstdomain%lonc(ni)
           write(6,*)' gridmap lon= ',xc_dst(ni)
           call abort()
        end if
        if (abs(dstdomain%latc(ni) - yc_dst(ni)) > eps) then
           write(6,*) trim(subname)// &
                ' ERROR: output domain lat and gridmap lat not the same at ni = ',ni
           write(6,*)' domain  lat= ',dstdomain%latc(ni)
           write(6,*)' gridmap lat= ',yc_dst(ni)
           call abort()
        end if
     end do

  end subroutine domain_checksame

end module mkdomainMod

module mkurbanparAvgMod
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: mkurbanparAvg
!
! !DESCRIPTION:
! Make Urban Parameter data, using an average of input cells
!
! !REVISION HISTORY:
! Author: Keith Oleson, Mariana Vertenstein
! Feb 2012: Bill Sacks: pulled out some functionality to mkurbanparCommonMod
!
!-----------------------------------------------------------------------
! !USES:
  use shr_kind_mod, only : r8 => shr_kind_r8
  use shr_sys_mod , only : shr_sys_flush
  use mkdomainMod , only : domain_checksame
  implicit none

  private

! !PUBLIC MEMBER FUNCTIONS:
  public  :: mkurban       ! Get the urban percentage
  public  :: mkurbanpar    ! Make the urban parameters

!EOP

contains

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkurban
!
! !INTERFACE:
subroutine mkurban(ldomain, mapfname, datfname, ndiag, zero_out, urbn_o)
!
! !DESCRIPTION:
! make percent urban
!
! !USES:
  use mkdomainMod , only : domain_type, domain_clean, domain_read
  use mkgridmapMod
  use mkurbanparCommonMod, only : mkurban_pct, mkurban_pct_diagnostics, MIN_DENS
  use mkvarpar	
  use mkvarctl    
  use mkncdio
!
! !ARGUMENTS:
  implicit none
  type(domain_type), intent(in) :: ldomain
  character(len=*) , intent(in) :: mapfname  ! input mapping file name
  character(len=*) , intent(in) :: datfname  ! input data file name
  integer          , intent(in) :: ndiag     ! unit number for diag out
  logical          , intent(in) :: zero_out  ! if should zero urban out
  real(r8)         , intent(out):: urbn_o(:) ! output grid: %urban
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Mariana Vertenstein
!
!
! !LOCAL VARIABLES:
!EOP
  type(domain_type) :: tdomain               ! local domain
  type(gridmap_type) :: tgridmap              ! local gridmap
  real(r8), allocatable :: urbn_i(:)          ! input grid: percent urbn
  integer  :: no,ns                           ! indices
  integer  :: ncid,dimid,varid                ! input netCDF id's
  integer  :: ier                             ! error status
  character(len=32) :: subname = 'mkurban'
!-----------------------------------------------------------------------

  write (6,*) 'Attempting to make %urban .....'

  ! -----------------------------------------------------------------
  ! Read input file
  ! -----------------------------------------------------------------

  ! Obtain input grid info, read local fields

  call domain_read(tdomain, datfname)

  ns = tdomain%ns
  allocate(urbn_i(ns), stat=ier)
  if (ier/=0) call abort()

  write (6,*) 'Open urban file: ', trim(datfname)
  call check_ret(nf_open(datfname, 0, ncid), subname)
  call check_ret(nf_inq_varid (ncid, 'PCT_URBAN', varid), subname)
  call check_ret(nf_get_var_double (ncid, varid, urbn_i), subname)
  call check_ret(nf_close(ncid), subname)

  ! Compute local fields _o

  if ( all_urban .or. zero_out )then

     do no = 1, ldomain%ns
        if (all_urban )then
           urbn_o(no) = 100.00_r8
        else 
           urbn_o(no) =   0.00_r8
        end if
     enddo

  else

     call gridmap_mapread(tgridmap, mapfname)

     call mkurban_pct(ldomain, tdomain, tgridmap, urbn_i, urbn_o)

     do no = 1, ldomain%ns
        if (urbn_o(no) < MIN_DENS) then
           urbn_o(no) = 0._r8
        end if
     end do

     call mkurban_pct_diagnostics(ldomain, tdomain, tgridmap, urbn_i, urbn_o, ndiag)

     write (6,*) 'Successfully made %urban'
     write (6,*)

  end if

  ! Deallocate dynamic memory

  !  call domain_clean(tdomain)
  if ( .not. all_urban .and. .not. zero_out )then
     call gridmap_clean(tgridmap)
  end if

  deallocate (urbn_i)

end subroutine mkurban

!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkurbanpar
!
! !INTERFACE:
subroutine mkurbanpar(ldomain, mapfname, datfname, ndiag, ncido)
!
! !DESCRIPTION:
! Make Urban Parameter data
!
! !USES:
  use mkdomainMod  , only : domain_type, domain_clean, domain_read
  use mkgridmapMod
  use mkvarpar	
  use mkvarctl    
  use mkncdio
!
! !ARGUMENTS:
  implicit none
  type(domain_type), intent(in) :: ldomain
  character(len=*)  , intent(in) :: mapfname  ! input mapping file name
  character(len=*)  , intent(in) :: datfname  ! input data file name
  integer           , intent(in) :: ndiag     ! unit number for diag out
  integer           , intent(in) :: ncido     ! output netcdf file id
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Mariana Vertenstein
!
!
! !LOCAL VARIABLES:
!EOP
  type(domain_type)    :: tdomain              ! local domain 
  type(domain_type)    :: tdomain_mask         ! local domain that contains "mask"
  type(gridmap_type)    :: tgridmap             ! local gridmap
  real(r8), allocatable :: canyon_hwr_o(:)      ! canyon height to width ratio out
  real(r8), allocatable :: canyon_hwr_i(:)      ! canyon_height to width ratio in
  real(r8), allocatable :: em_improad_o(:)      ! emissivity of impervious road out
  real(r8), allocatable :: em_improad_i(:)      ! emissivity of impervious road in
  real(r8), allocatable :: em_perroad_o(:)      ! emissivity of pervious road out
  real(r8), allocatable :: em_perroad_i(:)      ! emissivity of pervious road in
  real(r8), allocatable :: em_roof_o(:)         ! emissivity of roof out
  real(r8), allocatable :: em_roof_i(:)         ! emissivity of roof in
  real(r8), allocatable :: em_wall_o(:)         ! emissivity of wall out
  real(r8), allocatable :: em_wall_i(:)         ! emissivity of wall in
  real(r8), allocatable :: ht_roof_o(:)         ! height of roof out
  real(r8), allocatable :: ht_roof_i(:)         ! height of roof in
  real(r8), allocatable :: thick_roof_o(:)      ! thickness of roof out
  real(r8), allocatable :: thick_roof_i(:)      ! thickness of roof in
  real(r8), allocatable :: thick_wall_o(:)      ! thickness of wall out
  real(r8), allocatable :: thick_wall_i(:)      ! thickness of wall in
  real(r8), allocatable :: t_building_max_o(:)  ! maximum interior building temperature out
  real(r8), allocatable :: t_building_max_i(:)  ! maximum interior building temperature in
  real(r8), allocatable :: t_building_min_o(:)  ! minimum interior building temperature out
  real(r8), allocatable :: t_building_min_i(:)  ! minimum interior building temperature in
  real(r8), allocatable :: wind_hgt_canyon_o(:) ! height of wind in canyon out
  real(r8), allocatable :: wind_hgt_canyon_i(:) ! height of wind in canyon in
  real(r8), allocatable :: wtlunit_roof_o(:)    ! fraction of roof out
  real(r8), allocatable :: wtlunit_roof_i(:)    ! fraction of roof in
  real(r8), allocatable :: wtroad_perv_o(:)     ! fraction of pervious road out
  real(r8), allocatable :: wtroad_perv_i(:)     ! fraction of pervious road in
  real(r8), allocatable :: alb_improad_o(:,:,:) ! albedo of impervious road out (lon,lat,numrad,numsolar)
  real(r8), allocatable :: alb_improad_i(:,:,:) ! albedo of impervious road in (lon,lat,numrad,numsolar)
  real(r8), allocatable :: alb_perroad_o(:,:,:) ! albedo of pervious road out (lon,lat,numrad,numsolar)
  real(r8), allocatable :: alb_perroad_i(:,:,:) ! albedo of pervious road in (lon,lat,numrad,numsolar)
  real(r8), allocatable :: alb_roof_o(:,:,:)    ! albedo of roof out (lon,lat,numrad,numsolar)
  real(r8), allocatable :: alb_roof_i(:,:,:)    ! albedo of roof in (lon,lat,numrad,numsolar)
  real(r8), allocatable :: alb_wall_o(:,:,:)    ! albedo of wall out (lon,lat,numrad,numsolar)
  real(r8), allocatable :: alb_wall_i(:,:,:)    ! albedo of wall in (lon,lat,numrad,numsolar)
  real(r8), allocatable :: tk_roof_o(:,:)       ! thermal conductivity of roof out (lon,lat,nlevurb)
  real(r8), allocatable :: tk_roof_i(:,:)       ! thermal conductivity of roof in (lon,lat,nlevurb)
  real(r8), allocatable :: tk_wall_o(:,:)       ! thermal conductivity of wall out (lon,lat,nlevurb)
  real(r8), allocatable :: tk_wall_i(:,:)       ! thermal conductivity of wall in (lon,lat,nlevurb)
  real(r8), allocatable :: tk_improad_o(:,:)    ! thermal conductivity of impervious road out (lon,lat,nlevurb)
  real(r8), allocatable :: tk_improad_i(:,:)    ! thermal conductivity of impervious road in (lon,lat,nlevurb)
  real(r8), allocatable :: cv_roof_o(:,:)       ! volumetric heat capacity of roof out (lon,lat,nlevurb)
  real(r8), allocatable :: cv_roof_i(:,:)       ! volumetric heat capacity of roof in (lon,lat,nlevurb)
  real(r8), allocatable :: cv_wall_o(:,:)       ! volumetric heat capacity of wall out (lon,lat,nlevurb)
  real(r8), allocatable :: cv_wall_i(:,:)       ! volumetric heat capacity of wall in (lon,lat,nlevurb)
  real(r8), allocatable :: cv_improad_o(:,:)    ! volumetric heat capacity of impervious road out (lon,lat,nlevurb)
  real(r8), allocatable :: cv_improad_i(:,:)    ! volumetric heat capacity of impervious road in (lon,lat,nlevurb)
  integer,  allocatable :: nlev_improad_o(:)    ! number of impervious road layers out
  real(r8), allocatable :: mask_i(:)            ! input grid: mask (0, 1)
  integer  :: nlevurb_i                         ! input  grid: number of urban vertical levels
  integer  :: numsolar_i                        ! input  grid: number of solar type (DIR/DIF)
  integer  :: numrad_i                          ! input  grid: number of solar bands (VIS/NIR)
  integer  :: ns_i,ns_o                         ! indices
  integer  :: k,l,n,m,ni,no                     ! indices
  integer  :: nsolar,nrad,nurb                  ! indices
  integer  :: ncidi,dimid,varid                 ! input netCDF id's
  integer  :: numlev                            ! number of valid impervious road layers
  integer  :: ier                               ! error status
  real(r8) :: relerr = 0.00001                  ! max error: sum overlap wts ne 1
  character(len=256) :: name                    ! name of attribute
  character(len=256) :: unit                    ! units of attribute
  character(len= 32) :: subname = 'mkurbanpar'
!-----------------------------------------------------------------------

  write (6,*) 'Attempting to make Urban Parameters .....'
  call shr_sys_flush(6)

  ! -----------------------------------------------------------------
  ! Read input file
  ! -----------------------------------------------------------------

  ! Obtain input grid info, read local fields

  !***NOTE - this determines the tdomain mask based on the "mask"
  ! file variable NOT the LANDMASK file variable - and the "mask"
  ! variable is a SUBSET of the LANDMASK variable - so we need
  ! to call the interplation with the mask_src optional argument 

  call domain_read(tdomain     , datfname)
  call domain_read(tdomain_mask, datfname, readmask=.true.)

  write (6,*) 'Open urban parameter file: ', trim(datfname)
  call check_ret(nf_open(datfname, 0, ncidi), subname)
  call check_ret(nf_inq_dimid(ncidi, 'nlevurb', dimid), subname)
  call check_ret(nf_inq_dimlen(ncidi, dimid, nlevurb_i), subname)
  call check_ret(nf_inq_dimid(ncidi, 'numsolar', dimid), subname)
  call check_ret(nf_inq_dimlen(ncidi, dimid, numsolar_i), subname)
  call check_ret(nf_inq_dimid(ncidi, 'numrad', dimid), subname)
  call check_ret(nf_inq_dimlen(ncidi, dimid, numrad_i), subname)

  if (nlevurb_i /= nlevurb) then
     write(6,*)'MKURBANPAR: parameter nlevurb= ',nlevurb, &
          'does not equal input dataset nlevurb= ',nlevurb_i
     stop
  endif
  if (numsolar_i /= numsolar) then
     write(6,*)'MKURBANPAR: parameter numsolar= ',numsolar, &
          'does not equal input dataset numsolar= ',numsolar_i
     stop
  endif
  if (numrad_i /= numrad) then
     write(6,*)'MKURBANPAR: parameter numrad= ',numrad, &
          'does not equal input dataset numrad= ',numrad_i
     stop
  endif

  if (tdomain%ns /= tdomain_mask%ns) then
     write(6,*)'MKURBANPAR: inconsistent sizes for tdomain and tdomain_mask'
     write(6,*)' domain size tdomain     = ',tdomain%ns
     write(6,*)' domain size tdomain_mask= ',tdomain_mask%ns
     stop
  else
     do n = 1,tdomain%ns
        if (tdomain%mask(n) == 0 .and. tdomain_mask%mask(n) == 1) then 
           write(6,*)'tdomain_mask is not a submask tdomain at n= ',n
           stop
        end if
     end do
  end if

  ! Allocation

  ns_i = tdomain%ns
  allocate(canyon_hwr_i(ns_i), &
           em_improad_i(ns_i), &
           em_perroad_i(ns_i), &
           em_roof_i(ns_i), &
           em_wall_i(ns_i), &
           ht_roof_i(ns_i), &
           thick_roof_i(ns_i), &
           thick_wall_i(ns_i), &
           t_building_max_i(ns_i), &
           t_building_min_i(ns_i), &
           wind_hgt_canyon_i(ns_i), &
           wtlunit_roof_i(ns_i), &
           wtroad_perv_i(ns_i), &
           alb_improad_i(ns_i,numrad_i,numsolar_i), &
           alb_perroad_i(ns_i,numrad_i,numsolar_i), &
           alb_roof_i(ns_i,numrad_i,numsolar_i), &
           alb_wall_i(ns_i,numrad_i,numsolar_i), stat=ier)
  if (ier /= 0) then
     write(6,*)'mkurbanpar allocation error'; call abort()
  end if

  ns_o = ldomain%ns
  allocate(canyon_hwr_o(ns_o), &
           em_improad_o(ns_o), &
           em_perroad_o(ns_o), &
           em_roof_o(ns_o), &
           em_wall_o(ns_o), &
           ht_roof_o(ns_o), &
           thick_roof_o(ns_o), &
           thick_wall_o(ns_o), &
           t_building_max_o(ns_o), &
           t_building_min_o(ns_o), &
           wind_hgt_canyon_o(ns_o), &
           wtlunit_roof_o(ns_o), &
           wtroad_perv_o(ns_o), &
           alb_improad_o(ns_o,numrad,numsolar), &
           alb_perroad_o(ns_o,numrad,numsolar), &
           alb_roof_o(ns_o,numrad,numsolar), &
           alb_wall_o(ns_o,numrad,numsolar), stat=ier)
  if (ier /= 0) then
     write(6,*)'mkurbanpar allocation error'; call abort()
  end if

  ! Compute local fields _o
  ! Area average and then deallocate input data

  call gridmap_mapread(tgridmap, mapfname)

  ! Error checks for domain and map consistencies

  call domain_checksame( tdomain, ldomain, tgridmap )
     
  ! Determine urban variables on output grid

  ! IMPORTANT - first create a mask for the mapping that is based on 
  ! tdomain_mask%mask rather than tdomain%mask

  allocate(mask_i(ns_i))
  do n = 1,tgridmap%ns
     ni = tgridmap%src_indx(n)
     if (tdomain_mask%mask(ni) .eq. 0.) then
        mask_i(ni) = 0.
     else
        mask_i(ni) = 1.
     end if
  end do

  call check_ret(nf_inq_varid (ncidi, 'CANYON_HWR', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, canyon_hwr_i), subname)
  call gridmap_areaave(tgridmap,canyon_hwr_i,canyon_hwr_o,mask_src=mask_i)
  deallocate (canyon_hwr_i)

  call check_ret(nf_inq_varid (ncidi, 'EM_IMPROAD', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, em_improad_i), subname)
  call gridmap_areaave(tgridmap,em_improad_i,em_improad_o,mask_src=mask_i)
  deallocate (em_improad_i)

  call check_ret(nf_inq_varid (ncidi, 'EM_PERROAD', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, em_perroad_i), subname)
  call gridmap_areaave(tgridmap,em_perroad_i,em_perroad_o,mask_src=mask_i)
  deallocate (em_perroad_i)

  call check_ret(nf_inq_varid (ncidi, 'EM_ROOF', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, em_roof_i), subname)
  call gridmap_areaave(tgridmap,em_roof_i,em_roof_o,mask_src=mask_i)
  deallocate (em_roof_i)

  call check_ret(nf_inq_varid (ncidi, 'EM_WALL', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, em_wall_i), subname)
  call gridmap_areaave(tgridmap,em_wall_i,em_wall_o,mask_src=mask_i)
  deallocate (em_wall_i)

  call check_ret(nf_inq_varid (ncidi, 'HT_ROOF', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, ht_roof_i), subname)
  call gridmap_areaave(tgridmap,ht_roof_i,ht_roof_o,mask_src=mask_i)
  deallocate (ht_roof_i)

  call check_ret(nf_inq_varid (ncidi, 'THICK_ROOF', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, thick_roof_i), subname)
  call gridmap_areaave(tgridmap,thick_roof_i,thick_roof_o,mask_src=mask_i)
  deallocate (thick_roof_i)

  call check_ret(nf_inq_varid (ncidi, 'THICK_WALL', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, thick_wall_i), subname)
  call gridmap_areaave(tgridmap,thick_wall_i,thick_wall_o,mask_src=mask_i)
  deallocate (thick_wall_i)

  call check_ret(nf_inq_varid (ncidi, 'T_BUILDING_MAX', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, t_building_max_i), subname)
  call gridmap_areaave(tgridmap,t_building_max_i,t_building_max_o,mask_src=mask_i)
  deallocate (t_building_max_i)

  call check_ret(nf_inq_varid (ncidi, 'T_BUILDING_MIN', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, t_building_min_i), subname)
  call gridmap_areaave(tgridmap,t_building_min_i,t_building_min_o,mask_src=mask_i)
  deallocate (t_building_min_i)

  call check_ret(nf_inq_varid (ncidi, 'WIND_HGT_CANYON', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, wind_hgt_canyon_i), subname)
  call gridmap_areaave(tgridmap,wind_hgt_canyon_i,wind_hgt_canyon_o,mask_src=mask_i)
  deallocate (wind_hgt_canyon_i)

  call check_ret(nf_inq_varid (ncidi, 'WTLUNIT_ROOF', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, wtlunit_roof_i), subname)
  call gridmap_areaave(tgridmap,wtlunit_roof_i,wtlunit_roof_o,mask_src=mask_i)
  deallocate (wtlunit_roof_i)

  call check_ret(nf_inq_varid (ncidi, 'WTROAD_PERV', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, wtroad_perv_i), subname)
  call gridmap_areaave(tgridmap,wtroad_perv_i,wtroad_perv_o,mask_src=mask_i)
  deallocate (wtroad_perv_i)

  do n = 1,numrad_i
  do m = 1,numsolar_i     
     call check_ret(nf_inq_varid (ncidi, 'ALB_IMPROAD', varid), subname)
     call check_ret(nf_get_var_double (ncidi, varid, alb_improad_i), subname)
     call gridmap_areaave(tgridmap, alb_improad_i(:,n,m), alb_improad_o(:,n,m),&
          mask_src=mask_i)

     call check_ret(nf_inq_varid (ncidi, 'ALB_PERROAD', varid), subname)
     call check_ret(nf_get_var_double (ncidi, varid, alb_perroad_i), subname)
     call gridmap_areaave(tgridmap,alb_perroad_i(:,n,m),alb_perroad_o(:,n,m),&
          mask_src=mask_i)

     call check_ret(nf_inq_varid (ncidi, 'ALB_ROOF', varid), subname)
     call check_ret(nf_get_var_double (ncidi, varid, alb_roof_i), subname)
     call gridmap_areaave(tgridmap,alb_roof_i(:,n,m),alb_roof_o(:,n,m),&
          mask_src=mask_i)
     
     call check_ret(nf_inq_varid (ncidi, 'ALB_WALL', varid), subname)
     call check_ret(nf_get_var_double (ncidi, varid, alb_wall_i), subname)
     call gridmap_areaave(tgridmap,alb_wall_i(:,n,m),alb_wall_o(:,n,m),&
          mask_src=mask_i)
  end do
  end do
  deallocate (alb_improad_i)
  deallocate (alb_perroad_i)
  deallocate (alb_roof_i)
  deallocate (alb_wall_i)

  ! Now write output data to the file and then deallocate
  call check_ret(nf_inq_varid(ncido, 'CANYON_HWR', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, canyon_hwr_o),subname)
  deallocate (canyon_hwr_o)

  call check_ret(nf_inq_varid(ncido, 'EM_IMPROAD', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, em_improad_o), subname)
  deallocate (em_improad_o)

  call check_ret(nf_inq_varid(ncido, 'EM_PERROAD', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, em_perroad_o), subname)
  deallocate (em_perroad_o)

  call check_ret(nf_inq_varid(ncido, 'EM_ROOF', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, em_roof_o), subname)
  deallocate (em_roof_o)

  call check_ret(nf_inq_varid(ncido, 'EM_WALL', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, em_wall_o), subname)
  deallocate (em_wall_o)

  call check_ret(nf_inq_varid(ncido, 'HT_ROOF', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, ht_roof_o), subname)
  deallocate (ht_roof_o)

  call check_ret(nf_inq_varid(ncido, 'THICK_ROOF', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, thick_roof_o), subname)
  deallocate (thick_roof_o)

  call check_ret(nf_inq_varid(ncido, 'THICK_WALL', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, thick_wall_o), subname)
  deallocate (thick_wall_o)

  call check_ret(nf_inq_varid(ncido, 'T_BUILDING_MAX', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, t_building_max_o), subname)
  deallocate (t_building_max_o)

  call check_ret(nf_inq_varid(ncido, 'T_BUILDING_MIN', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, t_building_min_o), subname)
  deallocate (t_building_min_o)

  call check_ret(nf_inq_varid(ncido, 'WIND_HGT_CANYON', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, wind_hgt_canyon_o), subname)
  deallocate (wind_hgt_canyon_o)

  call check_ret(nf_inq_varid(ncido, 'WTLUNIT_ROOF', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, wtlunit_roof_o), subname)
  deallocate (wtlunit_roof_o)

  call check_ret(nf_inq_varid(ncido, 'WTROAD_PERV', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, wtroad_perv_o), subname)
  deallocate (wtroad_perv_o)

  call check_ret(nf_inq_varid(ncido, 'ALB_IMPROAD', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, alb_improad_o), subname)
  deallocate (alb_improad_o)

  call check_ret(nf_inq_varid(ncido, 'ALB_PERROAD', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, alb_perroad_o), subname)
  deallocate (alb_perroad_o)

  call check_ret(nf_inq_varid(ncido, 'ALB_ROOF', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, alb_roof_o), subname)
  deallocate (alb_roof_o)

  call check_ret(nf_inq_varid(ncido, 'ALB_WALL', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, alb_wall_o), subname)
  deallocate (alb_wall_o)
  !
  ! 3D nlevurb fields
  !
  ! First allocate data
  allocate(cv_improad_i(ns_i,nlevurb), &
           tk_roof_i(ns_i,nlevurb), &
           tk_wall_i(ns_i,nlevurb), &
           tk_improad_i(ns_i,nlevurb), &
           cv_roof_i(ns_i,nlevurb), &
           cv_wall_i(ns_i,nlevurb), stat=ier)
  if (ier /= 0) then
     write(6,*)'mkurbanpar allocation error'; call abort()
  end if
           
  allocate(tk_roof_o(ns_o,nlevurb), &
           tk_wall_o(ns_o,nlevurb), &
           tk_improad_o(ns_o,nlevurb), &
           cv_roof_o(ns_o,nlevurb), &
           cv_wall_o(ns_o,nlevurb), &
           cv_improad_o(ns_o,nlevurb), stat=ier)
  if (ier /= 0) then
     write(6,*)'mkurbanpar allocation error'; call abort()
  end if

  ! Do the areaaveraging and then deallocate input data

  call check_ret(nf_inq_varid (ncidi, 'TK_ROOF', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, tk_roof_i), subname)
  call check_ret(nf_inq_varid (ncidi, 'TK_WALL', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, tk_wall_i), subname)
  call check_ret(nf_inq_varid (ncidi, 'CV_ROOF', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, cv_roof_i), subname)
  call check_ret(nf_inq_varid (ncidi, 'CV_WALL', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, cv_wall_i), subname)

  do n = 1,nlevurb
     call gridmap_areaave(tgridmap,tk_roof_i(:,n),tk_roof_o(:,n),&
          mask_src=mask_i)
     call gridmap_areaave(tgridmap,tk_wall_i(:,n),tk_wall_o(:,n),&
          mask_src=mask_i)
     call gridmap_areaave(tgridmap,cv_roof_i(:,n),cv_roof_o(:,n),&
          mask_src=mask_i)
     call gridmap_areaave(tgridmap,cv_wall_i(:,n),cv_wall_o(:,n),&
          mask_src=mask_i)
  end do

  deallocate (tk_roof_i)
  deallocate (tk_wall_i)
  deallocate (cv_roof_i)
  deallocate (cv_wall_i)
  deallocate (mask_i)

  ! Write output data then deallocate output data
  call check_ret(nf_inq_varid(ncido, 'TK_WALL', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, tk_wall_o), subname)
  deallocate (tk_wall_o)

  call check_ret(nf_inq_varid(ncido, 'TK_ROOF', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, tk_roof_o), subname)
  deallocate (tk_roof_o)

  call check_ret(nf_inq_varid(ncido, 'CV_WALL', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, cv_wall_o), subname)
  deallocate (cv_wall_o)

  call check_ret(nf_inq_varid(ncido, 'CV_ROOF', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, cv_roof_o), subname)
  deallocate (cv_roof_o)

  ! Get fields from input file
  call check_ret(nf_inq_varid (ncidi, 'CV_IMPROAD', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, cv_improad_i), subname)

  call check_ret(nf_inq_varid (ncidi, 'TK_IMPROAD', varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, tk_improad_i), subname)

  ! Impervious road thermal conductivity and heat capacity need to be
  ! handled differently because of varying levels of data.

  allocate(mask_i(ns_i))
  do nurb = 1,nlevurb
      ! Create mask for input data from missing values
      do n = 1,tgridmap%ns
         ni = tgridmap%src_indx(n)
         if (tk_improad_i(ni,nurb) .eq. -999.) then
            mask_i(ni) = 0.
         else
            mask_i(ni) = 1.
         end if
      end do
      call gridmap_areaave(tgridmap, tk_improad_i(:,nurb), tk_improad_o(:,nurb), &
           mask_src=mask_i)
      call gridmap_areaave(tgridmap, cv_improad_i(:,nurb), cv_improad_o(:,nurb), &
           mask_src=mask_i)
  end do
  deallocate(cv_improad_i)
  deallocate(tk_improad_i)
  deallocate(mask_i)

  call check_ret(nf_inq_varid(ncido, 'TK_IMPROAD', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, tk_improad_o), subname)

  call check_ret(nf_inq_varid(ncido, 'CV_IMPROAD', varid), subname)
  call check_ret(nf_put_var_double(ncido, varid, cv_improad_o), subname)

  allocate(nlev_improad_o(ns_o), stat=ier)
  if (ier /= 0) then
     write(6,*)'mkurbanpar allocation error'; call abort()
  end if

  nlev_improad_o(:) = 0
  do no = 1,ns_o
     numlev = 0
     do nurb = 1,nlevurb
        if (tk_improad_o(no,nurb) > 0. .and. cv_improad_o(no,nurb) > 0.) then
           numlev = numlev+1 
        end if
     end do
     nlev_improad_o(no) = numlev
  end do

  call check_ret(nf_inq_varid(ncido, 'NLEV_IMPROAD', varid), subname)
  call check_ret(nf_put_var_int(ncido, varid, nlev_improad_o), subname)

  call check_ret(nf_sync(ncido), subname)
  call check_ret(nf_close(ncidi), subname)

  ! Deallocate dynamic memory

  deallocate (tk_improad_o)
  deallocate (cv_improad_o)
  deallocate (nlev_improad_o)
  call domain_clean(tdomain)
  call domain_clean(tdomain_mask)
  call gridmap_clean(tgridmap)

  write (6,*) 'Successfully made Urban Parameters'
  write (6,*)
  call shr_sys_flush(6)

end subroutine mkurbanpar

!-----------------------------------------------------------------------

end module mkurbanparAvgMod

subroutine ao_i(nlon_i , nlat_i , numlon_i, lon_i , lat_i , &
                nlon_o , nlat_o , numlon_o, lon_o , lat_o , &
                mx_ovr , i_ovr  , j_ovr   , w_ovr , re    , &
                area_o , relerr )

  use shr_kind_mod, only: r8 => shr_kind_r8

! -----------------------------------------------------------------
  implicit none
! ------------------------ code history ---------------------------
! source file:       ao_i.F
! purpose:           area averaging initialization: indices and weights
! date last revised: November 1996 
! author:            Gordon Bonan
! standardized: 
! reviewed:    
! -----------------------------------------------------------------

! ------------------------ notes ----------------------------------
! get indices and weights for area-averaging between input and output grids

! o input grid does not have to be finer resolution than output grid

! o both grids must be oriented south to north, i.e., cell(lat+1)
!   must be north of cell(lat). the southern edge of the first row 
!   must be -90 (south pole) and the northern edge of the last row
!   must be +90 (north pole)

! o both grids must be oriented eastwards, i.e., cell(lon+1) must be
!   east of cell(lon). but the two grids do not have to start at the 
!   same longitude, i.e., one grid can start at dateline and go east;
!   the other grid can start at greenwich and go east. longitudes for
!   the western edge of the cells must increase continuously and span
!   360 degrees. examples
!   dateline            :  -180 to 180         (- longitudes west of greenwich)
!   greenwich           :     0 to 360
!   greenwich (centered): -dx/2 to -dx/2 + 360 (- longitudes west of greenwich)

! for each output grid cell
! o number of input grid cells that overlap with output grid cell (n_ovr)
! o longitude index (1 <= i_ovr <= nlon_i) of the overlapping input grid cell
! o latitude index  (1 <= j_ovr <= nlat_i) of the overlapping input grid cell

! for field values fld_i on an  input grid with dimensions nlon_i and nlat_i
!     field values fld_o on an output grid with dimensions nlon_o and nlat_o are
! fld_o(io,jo) = 
! fld_i(i_ovr(io,jo,     1),j_ovr(io,jo,     1)) * w_ovr(io,jo,     1) +
!                             ... + ... +
! fld_i(i_ovr(io,jo,mx_ovr),j_ovr(io,jo,mx_ovr)) * w_ovr(io,jo,mx_ovr) 

! error check: overlap weights of input cells sum to 1 for each output cell
! -----------------------------------------------------------------

! ------------------- input variables -----------------------------
  integer nlon_i              !input grid max number of input longitude points
  integer nlat_i              !input grid number of input  latitude points
  integer numlon_i(nlat_i)    !input grid number of lon points for each lat
  integer nlon_o              !output grid max number of output lon points
  integer nlat_o              !output grid number of output latitude points
  integer numlon_o(nlat_o)    !output grid number of lon points for each lat
  integer mx_ovr              !max num of input cells that overlap output cell

  real(r8) lon_i(nlon_i+1,nlat_i) !input  grid cell lon, western edge  (degrees)
  real(r8) lon_o(nlon_o+1,nlat_o) !output grid cell lon, western edge  (degrees)
  real(r8) lat_i(nlat_i+1)        !input  grid cell lat,  southern edge (degrees)
  real(r8) lat_o(nlat_o+1)        !output grid cell lat,  southern edge (degrees)
  real(r8) area_o(nlon_o,nlat_o)  !cell area on output grid 
  real(r8) re                     !radius of earth
  real(r8) relerr                 !max error: sum overlap weights ne 1
! -----------------------------------------------------------------

! ------------------- output variables ----------------------------
  integer i_ovr(nlon_o,nlat_o,mx_ovr)  !lon index, overlapping input cell
  integer j_ovr(nlon_o,nlat_o,mx_ovr)  !lat index, overlapping input cell
  real(r8)  w_ovr(nlon_o,nlat_o,mx_ovr)  !overlap weights for input cells
! -----------------------------------------------------------------

! ------------------- local variables -----------------------------
  integer io,ii        !input and output grids longitude loop index
  integer jo,ji        !input and output grids latitude  loop index
  integer n            !overlapping cell index

  real(r8) offset          !used to shift x-grid 360 degrees
  real(r8) f_ovr           !sum of overlap weights for cells on output grid
!
! Dynamic
!
  integer n_ovr(nlon_o,nlat_o) !number of overlapping input cells

! -----------------------------------------------------------------
! initialize overlap weights on output grid to zero for maximum 
! number of overlapping points. set lat and lon indices of overlapping
! input cells to dummy values. set number of overlapping cells to zero
! -----------------------------------------------------------------

  do n = 1, mx_ovr 
    do jo = 1, nlat_o      
      do io = 1, numlon_o(jo)  
        i_ovr(io,jo,n) = 1
        j_ovr(io,jo,n) = 1
        w_ovr(io,jo,n) = 0. 
      end do
    end do
  end do

  do jo = 1, nlat_o      
    do io = 1, numlon_o(jo)  
      n_ovr(io,jo) = 0
    end do
  end do

! -----------------------------------------------------------------
! first pass to find cells that overlap, area of overlap, and weights
! -----------------------------------------------------------------

  call ao (nlon_i , nlat_i , numlon_i, lon_i  , lat_i  , &
           nlon_o , nlat_o , numlon_o, lon_o  , lat_o  , &
           area_o , re     , mx_ovr  , n_ovr  , i_ovr  , &
           j_ovr  , w_ovr  )

! -----------------------------------------------------------------
! second pass to find cells that overlap, area of overlap, and weights
! -----------------------------------------------------------------

! shift x-grid to locate periodic grid intersections
! the following assumes that all lon_i(1,:) have the same value
! independent of latitude and that the same holds for lon_o(1,:)

  if (lon_i(1,1) .lt. lon_o(1,1)) then
    offset = 360.0
  else
    offset = -360.0
  end if

  do ji = 1,nlat_i
    do ii = 1, numlon_i(ji) + 1
      lon_i(ii,ji) = lon_i(ii,ji) + offset
    end do
  end do

! find overlap

  call ao (nlon_i , nlat_i , numlon_i , lon_i , lat_i  , &
           nlon_o , nlat_o , numlon_o , lon_o , lat_o  , &
           area_o , re     , mx_ovr   , n_ovr , i_ovr  , &
           j_ovr  , w_ovr  )

! restore x-grid (un-shift x-grid)

  do ji = 1,nlat_i
    do ii = 1, numlon_i(ji) + 1
      lon_i(ii,ji) = lon_i(ii,ji) - offset
    end do
  end do

! -----------------------------------------------------------------
! error check: overlap weights for input grid cells must sum to 1
! -----------------------------------------------------------------

  do jo = 1, nlat_o
    do io = 1, numlon_o(jo)
      f_ovr = 0.
      
      do n = 1, mx_ovr
        f_ovr = f_ovr + w_ovr(io,jo,n)
      end do

      if (abs(f_ovr-1.) .gt. relerr) then
        write (6,*) 'AO_I error: area not conserved for',' lon,lat = ', io,jo
        write (6,'(a30,e20.10)') '   sum of overlap weights = ', f_ovr
        call endrun
      end if

    end do
  end do

  return
end subroutine ao_i

module mkvocefMod
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: mkvocMod
!
! !DESCRIPTION:
! Make VOC percentage emissions for surface dataset
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!-----------------------------------------------------------------------
! !USES:
  use shr_kind_mod, only : r8 => shr_kind_r8
  use shr_sys_mod , only : shr_sys_flush
  use mkdomainMod , only : domain_checksame

  implicit none
  private

! !PUBLIC MEMBER FUNCTIONS:
  public :: mkvocef  ! Get the percentage emissions for VOC for different
                     ! land cover types
!EOP

contains

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkvocef
!
! !INTERFACE:
subroutine mkvocef(ldomain, mapfname, datfname, ndiag, &
                   ef_btr_o, ef_fet_o, ef_fdt_o, ef_shr_o, ef_grs_o, ef_crp_o)
!
! !DESCRIPTION:
! make volatile organic coumpunds (VOC) emission factors.
!
! !USES:
  use mkdomainMod, only : domain_type, domain_clean, domain_read
  use mkgridmapMod
  use mkvarpar	
  use mkvarctl    
  use mkncdio
!
! !ARGUMENTS:
  implicit none
  type(domain_type) , intent(in) :: ldomain
  character(len=*)  , intent(in) :: mapfname    ! input mapping file name
  character(len=*)  , intent(in) :: datfname    ! input data file name
  integer           , intent(in) :: ndiag       ! unit number for diagnostic output
  real(r8)          , intent(out):: ef_btr_o(:) ! output grid: EFs for broadleaf trees
  real(r8)          , intent(out):: ef_fet_o(:) ! output grid: EFs for fineleaf evergreen
  real(r8)          , intent(out):: ef_fdt_o(:) ! output grid: EFs for fineleaf deciduous
  real(r8)          , intent(out):: ef_shr_o(:) ! output grid: EFs for shrubs
  real(r8)          , intent(out):: ef_grs_o(:) ! output grid: EFs for grasses
  real(r8)          , intent(out):: ef_crp_o(:) ! output grid: EFs for crops
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Colette L. Heald
! 17 Jul 2007 F Vitt -- updated to pftintdat06_clm3_5_05 and corrected indexing of ef_*_i arrarys
!
!EOP
!
! !LOCAL VARIABLES:
  type(gridmap_type)    :: tgridmap
  type(domain_type)     :: tdomain          ! local domain
  real(r8), allocatable :: ef_btr_i(:)      ! input grid: EFs for broadleaf trees
  real(r8), allocatable :: ef_fet_i(:)      ! input grid: EFs for fineleaf evergreen
  real(r8), allocatable :: ef_fdt_i(:)      ! input grid: EFs for fineleaf deciduous
  real(r8), allocatable :: ef_shr_i(:)      ! input grid: EFs for shrubs
  real(r8), allocatable :: ef_grs_i(:)      ! input grid: EFs for grasses
  real(r8), allocatable :: ef_crp_i(:)      ! input grid: EFs for crops
  real(r8) :: sum_fldo                      ! global sum of dummy input fld
  real(r8) :: sum_fldi                      ! global sum of dummy input fld
  integer  :: k,n,no,ni,ns_o,ns_i           ! indices
  integer  :: ncid,dimid,varid              ! input netCDF id's
  integer  :: ier                           ! error status
  real(r8) :: relerr = 0.00001_r8           ! max error: sum overlap wts ne 1
  character(len=32) :: subname = 'mkvocef'
!-----------------------------------------------------------------------

  write (6,*) 'Attempting to make VOC emission factors .....'
  call shr_sys_flush(6)

  ns_o = ldomain%ns

  ! -----------------------------------------------------------------
  ! Read input Emission Factors
  ! -----------------------------------------------------------------

  ! Obtain input grid info, read local fields

  call domain_read(tdomain,datfname)
  ns_i = tdomain%ns
  allocate(ef_btr_i(ns_i), ef_fet_i(ns_i), ef_fdt_i(ns_i), &
           ef_shr_i(ns_i), ef_grs_i(ns_i), ef_crp_i(ns_i), &
           stat=ier)
  if (ier/=0) call abort()

  write (6,*) 'Open VOC file: ', trim(datfname)
  call check_ret(nf_open(datfname, 0, ncid), subname)
  call check_ret(nf_inq_varid (ncid, 'ef_btr', varid), subname)
  call check_ret(nf_get_var_double(ncid, varid, ef_btr_i), subname)
  call check_ret(nf_inq_varid (ncid, 'ef_fet', varid), subname)
  call check_ret(nf_get_var_double(ncid, varid, ef_fet_i), subname)
  call check_ret(nf_inq_varid (ncid, 'ef_fdt', varid), subname)
  call check_ret(nf_get_var_double(ncid, varid, ef_fdt_i), subname)
  call check_ret(nf_inq_varid (ncid, 'ef_shr', varid), subname)
  call check_ret(nf_get_var_double(ncid, varid, ef_shr_i), subname)
  call check_ret(nf_inq_varid (ncid, 'ef_grs', varid), subname)
  call check_ret(nf_get_var_double(ncid, varid, ef_grs_i), subname)
  call check_ret(nf_inq_varid (ncid, 'ef_crp', varid), subname)
  call check_ret(nf_get_var_double(ncid, varid, ef_crp_i), subname)
  call check_ret(nf_close(ncid), subname)

  ! Area-average percent cover on input grid to output grid 
  ! and correct according to land landmask
  ! Note that percent cover is in terms of total grid area.

  call gridmap_mapread(tgridmap, mapfname )

  ! Error checks for domain and map consistencies

  call domain_checksame( tdomain, ldomain, tgridmap )

  ! Do mapping from input to output grid

  call gridmap_areaave(tgridmap, ef_btr_i, ef_btr_o)
  call gridmap_areaave(tgridmap, ef_fet_i, ef_fet_o)
  call gridmap_areaave(tgridmap, ef_fdt_i, ef_fdt_o)
  call gridmap_areaave(tgridmap, ef_shr_i, ef_shr_o)
  call gridmap_areaave(tgridmap, ef_grs_i, ef_grs_o)
  call gridmap_areaave(tgridmap, ef_crp_i, ef_crp_o)

  ! Check for conservation

  do no = 1, ns_o
     if ( ef_btr_o(no) < 0._r8 ) then
        write (6,*) 'MKVOCEF error: EF btr = ',ef_btr_o(no), &
             ' is negative for no = ',no
        call abort()
     end if
     if ( ef_fet_o(no) < 0._r8 ) then
        write (6,*) 'MKVOCEF error: EF fet = ',ef_fet_o(no), &
             ' is negative for no = ',no
        call abort()
     end if
     if ( ef_fdt_o(no) < 0._r8 ) then
        write (6,*) 'MKVOCEF error: EF fdt = ',ef_fdt_o(no), &
             ' is negative for no = ',no
        call abort()
     end if
     if ( ef_shr_o(no) < 0._r8 ) then
        write (6,*) 'MKVOCEF error: EF shr = ',ef_shr_o(no), &
             ' is negative for no = ',no
        call abort()
     end if
     if ( ef_grs_o(no) < 0._r8 ) then
        write (6,*) 'MKVOCEF error: EF grs = ',ef_grs_o(no), &
             ' is negative for no = ',no
        call abort()
     end if
     if ( ef_crp_o(no) < 0._r8 ) then
        write (6,*) 'MKVOCEF error: EF crp = ',ef_crp_o(no), &
             ' is negative for no = ',no
        call abort()
     end if
  enddo

  ! -----------------------------------------------------------------
  ! Error check1
  ! Compare global sum fld_o to global sum fld_i.
  ! -----------------------------------------------------------------

  ! Global sum of output field -- must multiply by fraction of
  ! output grid that is land as determined by input grid

  sum_fldi = 0.0_r8
  do ni = 1,ns_i
     sum_fldi = sum_fldi + tgridmap%area_src(ni) * tgridmap%frac_src(ni)
  enddo

  sum_fldo = 0._r8
  do no = 1,ns_o
     sum_fldo = sum_fldo + tgridmap%area_dst(no) * tgridmap%frac_dst(no)
  end do

  if ( trim(mksrf_gridtype) == 'global') then
     if ( abs(sum_fldo/sum_fldi-1._r8) > relerr ) then
        write (6,*) 'MKVOCEF error: input field not conserved'
        write (6,'(a30,e20.10)') 'global sum output field = ',sum_fldo
        write (6,'(a30,e20.10)') 'global sum input  field = ',sum_fldi
        stop
     end if
  end if

  write (6,*) 'Successfully made VOC Emission Factors'
  write (6,*)
  call shr_sys_flush(6)

  ! Deallocate dynamic memory

  deallocate ( ef_btr_i, ef_fet_i, ef_fdt_i, &
               ef_shr_i, ef_grs_i, ef_crp_i )
  call domain_clean(tdomain)
  call gridmap_clean(tgridmap)

end subroutine mkvocef

!-----------------------------------------------------------------------

end module mkvocefMod

program topo2rdirc

  implicit none
  include 'netcdf.inc'

! -------------------------------------------------------------------
! Notes
! -------------------------------------------------------------------
! Start with topography and end with river directions map.
! Simpler procedure than Graham et al. (1999), because
! we have no idea where the rivers were in the geologic past.
!
! The output consists of two ascii files: fort.10 and fort.11.
! The former is the river directions map in the format required by CLM.
! The latter lists all grid cells involved in infinite river loops.
! The user must redirect rivers in the vicinity of infinite loops.
! Alternatively, the user may start with topography which always slopes to
! the ocean, doesn't have internal basins, and doesn't contain completely
! flat plateaus.
!
! Currently written for Cretaceous topography.
!
! slevis, feb 2003
! -------------------------------------------------------------------
! Variable declarations
! -------------------------------------------------------------------

  integer, parameter :: r8 = selected_real_kind(12)

! IF YOU CHOOSE A DIFFERENT RESOLUTION (nlon, nlat),
! YOU MUST ALSO READ A DIFFERENT INPUT FILE (filei).
! integer, parameter :: nlon = 180        !input grid : longitude points
! integer, parameter :: nlat =  90        !input grid : latitude  points
!  integer, parameter :: nlon = 720        !input grid : longitude points
!  integer, parameter :: nlat = 360        !input grid : latitude  points
 integer, parameter :: nlon = 360        !input grid : longitude points
 integer, parameter :: nlat = 180        !input grid : latitude  points
  integer, parameter :: maxsecpass = 5000 !max # of infinite loops

! input file
  character(len=200) :: filei              !input filename
  integer :: ncid                         !netCDF file id for filei
  integer :: lat_id                       !netCDF latitude id
  integer :: lon_id                       !netCDF longitude id
  integer :: topo_id                      !netCDF topography id

! input variables from filei
  real(r8) :: lon(nlon)                   !longitude dimension array
  real(r8) :: lat(nlat)                   !latitude dimension array
  real(r8) :: topo(nlon,nlat)             !topography array

! output related variables
  integer  :: nowat(maxsecpass,2)         !'now at' index
  integer  :: rdirc(nlon,nlat)            !river directions
  integer  :: intbasin(nlon,nlat)         !internal basins
  integer  :: source(nlon,nlat)           !river sources
  real(r8) :: temp(nlon*nlat,3)           !temporary
  real(r8) :: tempo(maxsecpass,4)         !temporary
  real(r8) :: tmpo(4)                     !temporary
  real(r8) :: tmp(nlon*nlat,5)            !temporary

  logical :: dontcount                    !index related to next variable
  integer :: csecpass                     !count 2nd passes => inf. loops
  integer :: secondpass, ocean, ret       !indices
  integer :: ii, jj, i, j, count, line    !indices
  integer :: sort                         !index and
  integer :: locsmallest                  !variables
  integer, dimension(1) :: minlocarray    !used in the
  real(r8) :: smallest                    !sorting loops
  real(r8) :: topomin(8)     !surrounding topography in ascending order

  integer :: iii
  integer :: jjj
  integer :: isinf(nlon,nlat)
  integer :: mindist,mindir,x,found


! -------------------------------------------------------------------
! Read in netcdf topography file
! -------------------------------------------------------------------

! VARIABLE NAME IS topo_depth.
! This must be changed in script. 
  filei = 'input_topo_data'

! data:   lat (1D -89.75 to 89.75), lon (1D 0.25 to 359.75), topo (2D 360x720)
! OR 2x2: lat (1D -89 to 89),       lon (1D 1 to 359),       topo (2D  90x180)

  ret = nf_open (filei, nf_nowrite, ncid)
  if (ret == nf_noerr) then
    write(6,*)'Successfully opened ',trim(filei)
    call wrap_inq_varid (ncid, 'lat', lat_id)
    call wrap_inq_varid (ncid, 'lon', lon_id)
    call wrap_inq_varid (ncid, 'topo', topo_id)        !filei
    call wrap_get_var8 (ncid, lat_id, lat)
    call wrap_get_var8 (ncid, lon_id, lon)
    call wrap_get_var8 (ncid, topo_id, topo)
    write(*,*)'successfully read netcdf topography file'
  else
    write(6,*)'cannot open netcdf topography file'
    call endrun
  end if
  ret = nf_close (ncid)
  write(*,*)'netcdf topography file read successfully'
  write(*,*)'========================================'

  rdirc    = 0  !initialize
  intbasin = 0  !these
  temp     = 0. !four
  tmp      = 0. !variables
  isinf = 0.0

! take care of the edges

do i = 1,nlon                 ! south and north edges
  if (topo(i,1) > 0.) then    ! land points (Graham et al. 1999)
    rdirc(i,1) = 1            ! point north only
  else                        ! ocean points
    rdirc(i,1) = 0
  end if                      ! land mask

  if (topo(i,nlat) > 0.) then ! land points (Graham et al. 1999)
    rdirc(i,nlat) = 5         ! point south only
  else                        ! ocean points
    rdirc(i,nlat) = 0
  end if                      ! land mask
end do                        ! south and north edges

do j = 2,nlat-1               ! east and west edges
  if (topo(1,j) > 0.) then    ! land points (Graham et al. 1999)
    topomin(1) = topo(1,j+1)
    topomin(2) = topo(2,j+1)
    topomin(3) = topo(2,j)
    topomin(4) = topo(2,j-1)
    topomin(5) = topo(1,j-1)
    topomin(6) = topo(nlon,j-1)
    topomin(7) = topo(nlon,j)
    topomin(8) = topo(nlon,j+1)
    do sort = 1,8
      smallest = minval(topomin(sort:8))
      minlocarray = minloc(topomin(sort:8))
      locsmallest = (sort-1) + minlocarray(1)
      topomin(locsmallest) =topomin(sort)
      topomin(sort) = smallest
    end do
    count = 0
    do while (rdirc(1,j) == 0 .and. count < 9)
      count = count + 1
      if     (topo(1,j+1) == topomin(count)) then
        rdirc(1,j) = 1   ! point N
      elseif (topo(2,j+1) == topomin(count)) then
        rdirc(1,j) = 2   ! point NE
      elseif (topo(2,j) == topomin(count)) then
        rdirc(1,j) = 3   ! point E
      elseif (topo(2,j-1) == topomin(count)) then
        rdirc(1,j) = 4   ! point SE
      elseif (topo(1,j-1) == topomin(count) .and. rdirc(1,j-1) /= 1) then
        rdirc(1,j) = 5   ! point S
      elseif (topo(nlon,j-1) == topomin(count) .and. rdirc(nlon,j-1) /= 2) then
        rdirc(1,j) = 6   ! point SW
      elseif (topo(nlon,j) == topomin(count)) then
        rdirc(1,j) = 7   ! point W
      elseif (topo(nlon,j+1) == topomin(count)) then
        rdirc(1,j) = 8   ! point NW
      end if
    end do
    if (rdirc(1,j) == 0) then
      intbasin(1,j) = 1
      pause 'internal basin2'
    end if
  else                        ! ocean points
    rdirc(1,j) = 0
  end if                      ! land mask for western edge of domain

  if (topo(nlon,j) > 0.) then ! land points (Graham et al. 1999)
    topomin(1) = topo(nlon,j+1)
    topomin(2) = topo(1,j+1)
    topomin(3) = topo(1,j)
    topomin(4) = topo(1,j-1)
    topomin(5) = topo(nlon,j-1)
    topomin(6) = topo(nlon-1,j-1)
    topomin(7) = topo(nlon-1,j)
    topomin(8) = topo(nlon-1,j+1)
    do sort = 1,8
      smallest = minval(topomin(sort:8))
      minlocarray = minloc(topomin(sort:8))
      locsmallest = (sort-1) + minlocarray(1)
      topomin(locsmallest) =topomin(sort)
      topomin(sort) = smallest
    end do
    count = 0;
    do while (rdirc(nlon,j) == 0 .and. count < 9)
      count = count + 1
      if (topo(nlon,j+1) == topomin(count)) then
        rdirc(nlon,j) = 1  ! point N
      elseif (topo(1,j+1) == topomin(count)) then
        rdirc(nlon,j) = 2  ! point NE
      elseif (topo(1,j) == topomin(count) .and. rdirc(1,j) /= 7) then
        rdirc(nlon,j) = 3  ! point E
      elseif (topo(1,j-1) == topomin(count) .and. rdirc(1,j-1) /= 8) then
        rdirc(nlon,j) = 4  ! point SE
      elseif (topo(nlon,j-1) == topomin(count) .and. rdirc(nlon,j-1) /= 1) then
        rdirc(nlon,j) = 5  ! point S
      elseif (topo(nlon-1,j-1) == topomin(count)) then
        rdirc(nlon,j) = 6  ! point SW
      elseif (topo(nlon-1,j) == topomin(count)) then
        rdirc(nlon,j) = 7  ! point W
      elseif (topo(nlon-1,j+1) == topomin(count)) then
        rdirc(nlon,j) = 8  ! point NW
      end if
    end do
    if (rdirc(nlon,j) == 0) then
      intbasin(nlon,j) = 1
      pause 'internal basin3'
    end if
  else                        ! ocean points
    rdirc(nlon,j) = 0
  end if                      ! land mask for eastern edge of domain
end do                        ! east and west edges

! loop through all data except the domain's edges

do i = 2,nlon-1
  do j = 2,nlat-1
    if (topo(i,j) > 0.) then  ! land points (Graham et al. 1999)
      topomin(1) = topo(i,j+1)
      topomin(2) = topo(i+1,j+1)
      topomin(3) = topo(i+1,j)
      topomin(4) = topo(i+1,j-1)
      topomin(5) = topo(i,j-1)
      topomin(6) = topo(i-1,j-1)
      topomin(7) = topo(i-1,j)
      topomin(8) = topo(i-1,j+1)
      do sort = 1,8
        smallest = minval(topomin(sort:8))
        minlocarray = minloc(topomin(sort:8))
        locsmallest = (sort-1) + minlocarray(1)
        topomin(locsmallest) =topomin(sort)
        topomin(sort) = smallest
      end do
      count = 0;
      do while (rdirc(i,j) == 0 .and. count < 9)
        count = count + 1
        if     (topo(i,j+1) == topomin(count)) then
          rdirc(i,j) = 1  ! point N
        elseif (topo(i+1,j+1) == topomin(count)) then
          rdirc(i,j) = 2  ! point NE
        elseif (topo(i+1,j) == topomin(count)) then
          rdirc(i,j) = 3  ! point E
        elseif (topo(i+1,j-1) == topomin(count)) then
          rdirc(i,j) = 4  ! point SE
        elseif (topo(i,j-1) == topomin(count) .and. rdirc(i,j-1) /= 1) then
          rdirc(i,j) = 5  ! point S
        elseif (topo(i-1,j-1) == topomin(count) .and. rdirc(i-1,j-1) /= 2) then
          rdirc(i,j) = 6  ! point SW
        elseif (topo(i-1,j) == topomin(count) .and. rdirc(i-1,j) /= 3) then
          rdirc(i,j) = 7  ! point W
        elseif (topo(i-1,j+1) == topomin(count) .and. rdirc(i-1,j+1) /= 4) then
          rdirc(i,j) = 8  ! point NW
        end if
      end do
      if (rdirc(i,j) == 0) then
        intbasin(i,j) = 1
        pause 'internal basin1'
      end if
    else                ! ocean points
      rdirc(i,j) = 0
    end if              ! land mask
  end do                ! nlat
end do                  ! nlon

write(*,*) 'begin error checks'

! Error checks
! Look for arrows pointing at each other.
! Don't worry about the first and last rows (j=1 and j=360 at half degree),
! because they have been hardwired to point north and south respectively.

do i = 2,nlon-1
  do j = 2,nlat-1
    if     (rdirc(i,j) == 1 .and. rdirc(i,j+1) == 5) then
      pause 'error1'
    elseif (rdirc(i,j) == 2 .and. rdirc(i+1,j+1) == 6) then
      pause 'error2'
    elseif (rdirc(i,j) == 3 .and. rdirc(i+1,j) == 7) then
      print*,i,j
      pause 'error3'
    elseif (rdirc(i,j) == 4 .and. rdirc(i+1,j-1) == 8) then
      pause 'error4'
    elseif (rdirc(i,j) == 5 .and. rdirc(i,j-1) == 1) then
      pause 'error5'
    elseif (rdirc(i,j) == 6 .and. rdirc(i-1,j-1) == 2) then
      pause 'error6'
    elseif (rdirc(i,j) == 7 .and. rdirc(i-1,j) == 3) then
      pause 'error7'
    elseif (rdirc(i,j) == 8 .and. rdirc(i-1,j+1) == 4) then
      pause 'error8'
    end if
  end do
end do

do j = 2,nlat-1
  if    (rdirc(1,j) == 1 .and. rdirc(1,j+1) == 5) then
      pause 'error9'
  elseif (rdirc(1,j) == 2 .and. rdirc(2,j+1) == 6) then
      pause 'error10'
  elseif (rdirc(1,j) == 3 .and. rdirc(2,j) == 7) then
      pause 'error11'
  elseif (rdirc(1,j) == 4 .and. rdirc(2,j-1) == 8) then
      pause 'error12'
  elseif (rdirc(1,j) == 5 .and. rdirc(1,j-1) == 1) then
      pause 'error13'
  elseif (rdirc(1,j) == 6 .and. rdirc(nlon,j-1) == 2) then
      pause 'error14'
  elseif (rdirc(1,j) == 7 .and. rdirc(nlon,j  ) == 3) then
      pause 'error15'
  elseif (rdirc(1,j) == 8 .and. rdirc(nlon,j+1) == 4) then
      pause 'error16'
  end if
  if     (rdirc(nlon,j) == 1 .and. rdirc(nlon,j+1) == 5) then
      pause 'error17'
  elseif (rdirc(nlon,j) == 2 .and. rdirc(1,j+1) == 6) then
      pause 'error18'
  elseif (rdirc(nlon,j) == 3 .and. rdirc(1,j  ) == 7) then
      pause 'error19'
  elseif (rdirc(nlon,j) == 4 .and. rdirc(1,j-1) == 8) then
      pause 'error20'
  elseif (rdirc(nlon,j) == 5 .and. rdirc(nlon,j-1) == 1) then
      pause 'error21'
  elseif (rdirc(nlon,j) == 6 .and. rdirc(nlon-1,j-1) == 2) then
      pause 'error22'
  elseif (rdirc(nlon,j) == 7 .and. rdirc(nlon-1,j  ) == 3) then
      print*,nlon,j
      pause 'error23'
  elseif (rdirc(nlon,j) == 8 .and. rdirc(nlon-1,j+1) == 4) then
      pause 'error24'
  end if
end do

write(*,*) 'end error checks'

! reorder lon from (0 to 360) to (-180 to 180) as required
! for this file by CLM

line = 0
do j = 1,nlat
  do i = nlon/2+1,nlon      ! ie, 361 to 720 at half degree
    line = line + 1
    temp(line,1) = lat(j)
    temp(line,2) = lon(i)-360.
    temp(line,3) = rdirc(i,j)
    write(10,*) temp(line,:)
    if (intbasin(i,j) == 1) then
      tmp(line,1) = float(j)
      tmp(line,2) = float(i)-float(nlon)/2.
      tmp(line,3) = lat(j)
      tmp(line,4) = lon(i)-360.
      tmp(line,5) = rdirc(i,j)
      write(12,*) tmp(line,:)
    end if
  end do
  do i = 1,nlon/2           ! ie, 1 to 360 at half degree
    line = line + 1
    temp(line,1) = lat(j)
    temp(line,2) = lon(i)
    temp(line,3) = rdirc(i,j)
    write(10,*) temp(line,:)
    if (intbasin(i,j) == 1) then
      tmp(line,1) = float(j)
      tmp(line,2) = float(i)+float(nlon)/2.
      tmp(line,3) = lat(j)
      tmp(line,4) = lon(i)
      tmp(line,5) = rdirc(i,j)
      write(12,*) tmp(line,:)
    end if
  end do
end do

! Identify infinite loops in 2D river direction map.
! Then fix them by hand. Haven't thought of a method
! to fix them automatically...
!
! Follow all streams to the ocean.
! If pass through same grid cell twice => infinite loop.
! Start from river sources which are land points with no
! neighbors pointing to them.

source = 0              ! initialize
csecpass = 0            ! variables
                        ! ***           TO ALL USERS                ***
do i = 2,nlon-1         ! *** Pls check manually for infinite loops ***
  do j = 2,nlat-1       ! ***      at the edges of the domain       ***
    if (rdirc(i,j) > 0) then
      if (rdirc(i,j+1) /= 5 .and. rdirc(i+1,j+1) /= 6 .and. &
          rdirc(i+1,j) /= 7 .and. rdirc(i+1,j-1) /= 8 .and. &
          rdirc(i,j-1) /= 1 .and. rdirc(i-1,j-1) /= 2 .and. &
          rdirc(i-1,j) /= 3 .and. rdirc(i-1,j+1) /= 4) then
        source(i,j) = 1 ! river source
      end if
    end if
  end do
end do

write(*,*) 'Found river sources. Now follow rivers to the ocean.'

do i = 2,nlon-1
  do j = 2,nlat-1
!    if (source(i,j) == 1) then
      nowat = 0; jj = j; ii = i; secondpass = 0; ocean = 0; count = 1
      do while (secondpass == 0 .and. ocean == 0)
        if (ii < 1) then
          ii = nlon
        elseif (ii > nlon) then
          ii = 1
        end if
        count = count + 1
        nowat(count,1) = jj
        nowat(count,2) = ii
        if     (rdirc(ii,jj) == 1) then
          jj = jj + 1;
        elseif (rdirc(ii,jj) == 2) then
          jj = jj + 1;
          ii = ii + 1;
        elseif (rdirc(ii,jj) == 3) then
          ii = ii + 1;
        elseif (rdirc(ii,jj) == 4) then
          ii = ii + 1;
          jj = jj - 1;
        elseif (rdirc(ii,jj) == 5) then
          jj = jj - 1;
        elseif (rdirc(ii,jj) == 6) then
          jj = jj - 1;
          ii = ii - 1;
        elseif (rdirc(ii,jj) == 7) then
          ii = ii - 1;
        elseif (rdirc(ii,jj) == 8) then
          jj = jj + 1;
          ii = ii - 1;
        elseif (rdirc(ii,jj) == 0) then
          ocean = 1                       ! reached the ocean
        end if
        do sort = 1,count-1
          if (nowat(sort,1) == nowat(count,1) .and. &
              nowat(sort,2) == nowat(count,2)) then
            secondpass = 1;               ! found an infinite loop
            tmpo(1) = jj
            tmpo(2) = ii
            tmpo(3) = lat(jj)
            tmpo(4) = lon(ii)
            if (csecpass == 0) then       ! first infinite loop to be counted
              tempo(1,1) = 0
              tempo(1,2) = 0
              tempo(1,3) = 0
              tempo(1,4) = 0
            end if
            dontcount = .false.

            do line = 1,maxsecpass
              if (tempo(line,1)==tmpo(1) .and. tempo(line,2)==tmpo(2) .and. &
                  tempo(line,3)==tmpo(3) .and. tempo(line,4)==tmpo(4)) then
                dontcount = .true.        ! avoid double counting
              end if
            enddo

              if (isinf(ii,jj) == 1) then
                dontcount = .true.        ! avoid double counting of loops
              end if
        isinf(ii,jj)=1
        jjj=0
        iii=0
        if     (rdirc(ii,jj) == 1) then
          jjj = 1;
        elseif (rdirc(ii,jj) == 2) then
          jjj = 1;
          iii = 1;
        elseif (rdirc(ii,jj) == 3) then
          iii = 1;
        elseif (rdirc(ii,jj) == 4) then
          iii = 1;
          jjj = -1;
        elseif (rdirc(ii,jj) == 5) then
          jjj = -1;
        elseif (rdirc(ii,jj) == 6) then
          jjj = -1;
          iii = -1;
        elseif (rdirc(ii,jj) == 7) then
          iii = -1;
        elseif (rdirc(ii,jj) == 8) then
          jjj = 1;
          iii = -1;
        endif
        if (isinf(ii+iii,jj+jjj) == 1) then
          dontcount = .true.        ! avoid double counting of loops
        end if
        isinf(ii+iii,jj+jjj)=1

        if (.not. dontcount) then
              csecpass = csecpass + 1;    !count infinite loops
              tempo(csecpass,1) = jj      !NB: I have shifted ii & lon(ii)
              tempo(csecpass,2) = ii      !in fort.10 (not fort.11) to go from
              tempo(csecpass,3) = lat(jj) !-180 to 180 degrees (see comment
              tempo(csecpass,4) = lon(ii) !after 'end error checks')
              write(11,*) tempo(csecpass,:)
            end if
          end if
        end do
      end do                              ! while secondpass = 0 AND ocean = 0
!    end if                                ! source
  end do                                  ! j loop
end do                                    ! i loop


do x=1,csecpass

mindir=1
mindist=10000

!OK, first travel north:
count=1
found=0
do while(found == 0 .and. tempo(x,1)+count.le.nlat )
  if ( rdirc(tempo(x,2),tempo(x,1)+count).eq.0) then    
    found=1
    if (count.lt.mindist) then
      mindist=count
      mindir=1  
    endif
  else
    count=count+1
  endif
enddo

!OK, south:
count=1
found=0
do while(found == 0 .and. tempo(x,1)-count.gt.0 )
  if ( rdirc(tempo(x,2),tempo(x,1)-count).eq.0) then    
    found=1
    if (count.lt.mindist) then
      mindist=count
      mindir=5  
    endif
  else
    count=count+1
  endif
enddo

!OK, west:
count=1
found=0
do while(found == 0 .and. tempo(x,2)-count.gt.0 )
  if ( rdirc(tempo(x,2)-count,tempo(x,1)).eq.0) then    
    found=1
    if (count.lt.mindist) then
      mindist=count
      mindir=7  
    endif
  else
    count=count+1
  endif
enddo

!OK, east:
count=1
found=0
do while(found == 0 .and. tempo(x,2)+count.le.nlon )
  if ( rdirc(tempo(x,2)+count,tempo(x,1)).eq.0) then    
    found=1
    if (count.lt.mindist) then
      mindist=count
      mindir=3  
    endif
  else
    count=count+1
  endif
enddo

if (mindir.eq.1) then
rdirc(tempo(x,2),tempo(x,1):tempo(x,1)+(mindist-1))=mindir
endif

if (mindir.eq.5) then
rdirc(tempo(x,2),tempo(x,1)-(mindist-1):tempo(x,1))=mindir
endif

if (mindir.eq.7) then
rdirc(tempo(x,2)-(mindist-1):tempo(x,2),tempo(x,1))=mindir
endif

if (mindir.eq.3) then
rdirc(tempo(x,2):tempo(x,2)+(mindist-1),tempo(x,1))=mindir
endif

enddo


line = 0
do j = 1,nlat
  do i = nlon/2+1,nlon      ! ie, 361 to 720 at half degree
    line = line + 1
    temp(line,1) = lat(j)
    temp(line,2) = lon(i)-360.
    temp(line,3) = rdirc(i,j)
    write(13,*) temp(line,:)
    if (intbasin(i,j) == 1) then
      tmp(line,1) = float(j)
      tmp(line,2) = float(i)-float(nlon)/2.
      tmp(line,3) = lat(j)
      tmp(line,4) = lon(i)-360.
      tmp(line,5) = rdirc(i,j)
      write(15,*) tmp(line,:)
    end if
  end do
  do i = 1,nlon/2           ! ie, 1 to 360 at half degree
    line = line + 1
    temp(line,1) = lat(j)
    temp(line,2) = lon(i)
    temp(line,3) = rdirc(i,j)
    write(13,*) temp(line,:)
    if (intbasin(i,j) == 1) then
      tmp(line,1) = float(j)
      tmp(line,2) = float(i)+float(nlon)/2.
      tmp(line,3) = lat(j)
      tmp(line,4) = lon(i)
      tmp(line,5) = rdirc(i,j)
      write(15,*) tmp(line,:)
    end if
  end do
end do




end program topo2rdirc

!===============================================================================

subroutine handle_error(ret)
  implicit none
  include 'netcdf.inc'
  integer :: ret
  write(6,*) 'BAILING'
  if (ret .ne. nf_noerr) then
     write(6,*) 'NCDERR: ERROR: ',nf_strerror(ret)
     call abort
  endif
  write(6,*) 'BAILING'
end subroutine handle_error

!==============================================================================

subroutine wrap_inq_varid (nfid, varname, varid)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  character*(*) varname

  integer ret

  ret = nf_inq_varid (nfid, varname, varid)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_inq_varid

!=============================================================================

subroutine wrap_get_var8 (nfid, varid, arr)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  real*8 arr(*)

  integer ret

  ret = nf_get_var_double (nfid, varid, arr)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_get_var8

!==============================================================================

subroutine endrun
  implicit none
  include 'netcdf.inc'

  call abort
  stop 999
end subroutine endrun


!===============================================================================

module mkindexmapMod
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: mkindexmapMod
!
! !DESCRIPTION:
! Module containing subroutines for making maps of index data.
!
! This includes a routine for making a map using the dominant type among the input grid
! cells making up a given output cell, as well as routines for using an index map as
! indices into a lookup table, to essentially paint-by-number some other field, and some
! other related routines
!
! WJS (2-1-12): There is a lookup_2d subroutine, but not a lookup_1d (or any other
! dimensionality). That is simply because I needed lookup_2d, but have not yet needed a
! routine of other dimensionalities. In the future, it would probably be helpful to at
! least have lookup_1d and lookup_1d_netcdf. If this is done, see my notes under the
! lookup_2d_netcdf routine for some thoughts on avoiding duplication.
!
!
! !USES:
   use shr_kind_mod, only : r8 => shr_kind_r8
   use mkncdio, only : nf_max_name

   implicit none
   private

! !PUBLIC TYPES:
!
   ! dim_slice_type: stores information about dimensions that we use for slicing a multi-
   ! dimensional variable
   type dim_slice_type
      character(len=nf_max_name) :: name  ! name of this dimension
      integer                    :: val   ! index to use for the slice
   end type dim_slice_type
   public :: dim_slice_type
!
! !PUBLIC MEMBER FUNCTIONS:
   public :: get_dominant_indices  ! make output map based on dominant type in each grid cell
   public :: filter_same           ! build a filter of overlaps where src_val == dst_val
   public :: lookup_2d             ! create map based on a 2-d lookup table
   public :: lookup_2d_netcdf      ! wrapper to lookup_2d; first read table from netcdf file
   public :: which_max             ! get index of the maximum value in an array
!
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
!EOP
!------------------------------------------------------------------------------
contains

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: get_dominant_indices
!
! !INTERFACE:
subroutine get_dominant_indices(gridmap, src_array, dst_array, minval, maxval, nodata, filter)
!
! !DESCRIPTION:
! Fills an output array on the destination grid (dst_array) whose values are equal to the
! (weighted) dominant value in the source grid cells overlapping a given destination grid
! cell
!
! Ignores all values in src_array that are less than minval or greater than maxval (treats
! those values the same as if they had wt=0).  (Note: for memory-use efficiency, it is
! best if the indices are designed such that most values between minval and maxval are
! actually used, since an array is allocated of size (maxval - minval + 1)*gridmap%nb.)
!
! The filter argument can be used to exclude certain overlaps -- if provided, we only
! consider overlaps where filter is .true. For example, see mkurbanparDomMod, where we
! first determine the dominant density class in each output cell, then determine the
! dominant region, but in the latter only considering overlapping source points whose
! density matches the dominant density in the output cell. If not provided, filter is
! treated as being .true. everywhere.
! 
! Output grid cells with no contributing valid source points are given the nodata value
!
! !USES:
   use mkgridmapMod, only : gridmap_type
!
! !ARGUMENTS:
   implicit none
   type(gridmap_type), intent(in) :: gridmap       ! provides mapping from src -> dst
   integer           , intent(in) :: src_array(:)  ! input values; length gridmap%na
   integer           , intent(out):: dst_array(:)  ! output values; length gridmap%nb
   integer           , intent(in) :: minval        ! minimum valid value in src_array
   integer           , intent(in) :: maxval        ! maximum valid value in src_array
   integer           , intent(in) :: nodata        ! value to assign to dst_array where there are no valid source points

   logical, intent(in), optional :: filter(:)  ! only consider overlaps where filter is .true.; length gridmap%ns
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
!
! !LOCAL VARIABLES:
!EOP
   logical, allocatable  :: lfilter(:)    ! local version of filter
   logical, allocatable  :: hasdata(:)    ! true if an output cell has any valid data;
   real(r8), allocatable :: weights(:,:)  ! summed weight of each index value for each output cell

   integer  :: n, ni, no
   integer  :: k
   integer  :: maxindex
   real(r8) :: wt
   real(r8) :: maxwt

   character(len=*), parameter :: subname = "get_dominant_indices"
!-----------------------------------------------------------------------
   
   ! Error-check inputs and initialize local variables
   
   if (size(src_array) /= gridmap%na .or. &
        size(dst_array) /= gridmap%nb) then
      write(6,*) subname//' ERROR: incorrect sizes of src_array or dst_array'
      write(6,*) 'size(src_array) = ', size(src_array)
      write(6,*) 'gridmap%na      = ', gridmap%na
      write(6,*) 'size(dst_array) = ', size(dst_array)
      write(6,*) 'gridmap%nb      = ', gridmap%nb
      call abort()
   end if

   allocate(lfilter(gridmap%ns))

   if (present(filter)) then
      if (size(filter) /= gridmap%ns) then
         write(6,*) subname//' ERROR: incorrect size of filter'
         write(6,*) 'size(filter) = ', size(filter)
         write(6,*) 'gridmap%ns   = ', gridmap%ns
         call abort()
      end if

      lfilter(:) = filter(:)
   else
      lfilter(:) = .true.
   end if

   allocate(hasdata(gridmap%nb))
   hasdata(:) = .false.
   allocate(weights(minval:maxval, gridmap%nb))
   weights(minval:maxval,:) = 0.

   ! Determine weight of each index value for each output (destination) cell

   do n = 1, gridmap%ns
      if (lfilter(n)) then
         ni = gridmap%src_indx(n)
         no = gridmap%dst_indx(n)
         wt = gridmap%wovr(n)
         k = src_array(ni)
         if (k >= minval .and. k <= maxval) then
            ! Note: if we were doing something like weighted sums, I think we would
            ! want to divide wt by gridmap%frac_dst(no), as is done in
            ! gridmap_areaave_default. But since all we care about is the relative
            ! values of weights for a given destination cell, this is unnecessary
            weights(k,no) = weights(k,no) + wt
            hasdata(no) = .true.
         end if
      end if
   end do

   ! Determine output values
   ! Note: if a given destination cell has no contributing source points (thus
   ! hasdata(no) = false), or the max weight of any index overlapping this destination
   ! cell is <= 0, then the output value there will be nodata.
   ! (I don't think this latter condition -- weight <= 0 -- is possible, but we handle
   ! it anyway)

   dst_array(:) = nodata
   do no = 1, gridmap%nb
      if (hasdata(no)) then
         call which_max(weights(:,no), maxwt, maxindex, lbound=minval)
         if (maxwt > 0.) then
            dst_array(no) = maxindex
         end if
      end if
   end do

   deallocate(lfilter, weights, hasdata)

end subroutine get_dominant_indices
!------------------------------------------------------------------------------
   
!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: filter_same
!
! !INTERFACE:
subroutine filter_same(gridmap, filter, src_array, dst_array, nodata)
!
! !DESCRIPTION:
! Creates a filter of overlaps where src_array == dst_array.
!
! More specifically: given a src_array (of size gridmap%na) and an already-created
! dst_array (of size gridmap%nb):
!
! Creates a logical filter array, of size gridmap%ns (i.e., number of overlaps),
! according to the following rules:
! (1) anywhere where filter was already .false., it will remain .false.
! (2) if nodata is present: for any overlap where the value in dst_array is nodata,
!     filter will be .false.
! (3) for any overlap where the value in the given src_array differs from the value
!     in the given dst_array, filter will be .false.
! (4) anywhere else, filter will be .true.
!
! !USES:
   use mkgridmapMod, only : gridmap_type
!
! !ARGUMENTS:
   implicit none
   type(gridmap_type), intent(in)   :: gridmap      ! provides mapping from src -> dst
   logical           , intent(inout):: filter(:)    ! length gridmap%ns
   integer           , intent(in)   :: src_array(:) ! length gridmap%na
   integer           , intent(in)   :: dst_array(:) ! length gridmap%nb

   integer, intent(in), optional :: nodata  ! wherever dst_array == nodata, filter will be false
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
!
! !LOCAL VARIABLES:
!EOP
   integer :: n, ni, no

   character(len=*), parameter :: subname = "make_filter"
!-----------------------------------------------------------------------
   
   ! Error check inputs
   
   if (size(filter) /= gridmap%ns .or. &
        size(src_array) /= gridmap%na .or. &
        size(dst_array) /= gridmap%nb) then
      write(6,*) subname//' ERROR: incorrect array sizes'
      write(6,*) 'size(src_array) = ', size(src_array)
      write(6,*) 'gridmap%na      = ', gridmap%na
      write(6,*) 'size(dst_array) = ', size(dst_array)
      write(6,*) 'gridmap%nb      = ', gridmap%nb
      write(6,*) 'size(filter)    = ', size(filter)
      write(6,*) 'gridmap%ns      = ', gridmap%ns
      call abort()
   end if

   ! Create the filter

   do n = 1, gridmap%ns
      ni = gridmap%src_indx(n)
      no = gridmap%dst_indx(n)

      if (present(nodata)) then
         if (dst_array(no) == nodata) then
            filter(n) = .false.
         end if
      end if

      if (dst_array(no) /= src_array(ni)) then
         filter(n) = .false.
      end if
   end do

end subroutine filter_same
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: lookup_2d
!
! !INTERFACE:
subroutine lookup_2d(index1, index2, lookup_table, fill_val, data, ierr, &
                     nodata, valid_entries, invalid_okay)
!
! !DESCRIPTION:
! Creates a data array using a paint-by-number approach according to a lookup table
!
! This routine operates on a 2-d lookup table. There are therefore two index arrays
! (index1 and index2); these index arrays are on the same grid as the desired data array
! (thus, index1, index2 and data must all have the same length).  Each output point, n, is
! then generally determined as:
!
! data(n) = lookup_table(index1(n), index2(n))
!      
! fill_val: value to put in data array where either:
! (a) index1 or index2 are equal to nodata (if nodata is given)
!     Note that this condition does NOT result in ierr being set
! (b) valid_entries(index1(n), index2(n)) is false (if valid_entries is given)
!     Note that this condition also results in ierr being set, unless invalid_okay is
!     present and .true.
!     (If valid_entries is not given, it is treated as being .true. everywhere)
! (c) index1 or index2 out of range
!     Note that this condition also results in ierr being set
! 
! ierr: error return code (if non-0, indicates first error encountered):
!    0: no error
!    1: attempt to assign values from the lookup table that are invalid according
!       to valid_entries (note: this is not considered an error if invalid_okay is
!       present and .true.)
!    2: attempt to access an out-of-range index in lookup table
! WJS (2-2-12): My main reason for using ierr rather than aborting in case of error
! is to facilitate unit testing
!
! !ARGUMENTS:
   implicit none
   integer , intent(in) :: index1(:)  ! index into dim 1 of lookup_table
   integer , intent(in) :: index2(:)  ! index into dim 2 of lookup_table
   real(r8), intent(in) :: lookup_table(:,:)
   real(r8), intent(in) :: fill_val   ! value to put in data where we don't have a valid value (see above for details)
   real(r8), intent(out):: data(:)    ! output arary
   integer , intent(out):: ierr       ! error return code (0 = no error)

   ! nodata flag in index1 and index2 (see above for details):
   integer, intent(in), optional :: nodata

   ! which entries are considered valid (see above for details):
   logical, intent(in), optional :: valid_entries(:,:)

   ! invalid_okay: if true, then assigning fill_val because valid_entries is false does
   ! NOT raise an error flag (invalid_okay defaults to false, meaning an error is
   ! raised in this case):
   logical, intent(in), optional :: invalid_okay
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
!
! !LOCAL VARIABLES:
!EOP
   integer :: n
   integer :: i1, i2
   integer :: data_size          ! size of index1, index2 and data arrays
   integer :: table_n1           ! size of dimension 1 of lookup table
   integer :: table_n2           ! size of dimension 2 of lookup table
   logical :: linvalid_okay      ! local version of invalid_okay
   logical, allocatable :: lvalid_entries(:,:)  ! local version of valid_entries

   character(len=*), parameter :: subname = 'lookup_2d'
!-----------------------------------------------------------------------
   
   ierr = 0

   ! Error-check array sizes

   data_size = size(data)
   if (size(index1) /= data_size .or. size(index2) /= data_size) then
      write(6,*) subname//' ERROR: data array sizes do not match'
      write(6,*) 'size(data)   = ', data_size
      write(6,*) 'size(index1) = ', size(index1)
      write(6,*) 'size(index2) = ', size(index2)
      call abort()
   end if

   table_n1 = size(lookup_table,1)
   table_n2 = size(lookup_table,2)
   if (present(valid_entries)) then
      if (size(valid_entries,1) /= table_n1 .or. size(valid_entries,2) /= table_n2) then
         write(6,*) subname//' ERROR: size of valid_entries does not match lookup_table'
         write(6,*) 'size(lookup_table)  = ', table_n1, table_n2
         write(6,*) 'size(valid_entries) = ', size(valid_entries,1), &
              size(valid_entries,2)
         call abort()
      end if
   end if

   ! Set local version of invalid_okay & valid_entries

   if (present(invalid_okay)) then
      linvalid_okay = invalid_okay
   else
      linvalid_okay = .false.
   end if

   allocate(lvalid_entries(table_n1, table_n2))
   if (present(valid_entries)) then
      lvalid_entries(:,:) = valid_entries(:,:)
   else
      lvalid_entries(:,:) = .true.
   end if

   ! Do the lookups

   do n = 1, data_size
      i1 = index1(n)
      i2 = index2(n)

      ! First handle special cases:

      ! index is nodata flag (this is NOT an error)
      if (present(nodata)) then
         if (i1 == nodata .or. i2 == nodata) then
            data(n) = fill_val
            cycle
         end if
      end if

      ! index out of range
      if (i1 <= 0 .or. i1 > table_n1 .or. &
           i2 <= 0 .or. i2 > table_n2) then
         data(n) = fill_val
         if (ierr == 0) ierr = 2
         cycle
      end if

      ! lookup table entry is invalid
      if (.not. lvalid_entries(i1, i2)) then
         data(n) = fill_val
         if (.not. linvalid_okay) then
            if (ierr == 0) ierr = 1
         end if
         cycle
      end if

      ! Finally, the "normal" case, if none of the special cases were triggered:
      data(n) = lookup_table(i1, i2)
   end do

   deallocate(lvalid_entries)

end subroutine lookup_2d
!------------------------------------------------------------------------------
   
!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: lookup_2d_netcdf
!
! !INTERFACE:
subroutine lookup_2d_netcdf(ncid, tablename, lookup_has_invalid, &
                            dimname1, dimname2, n_extra_dims, &
                            index1, index2, fill_val, data, ierr, &
                            extra_dims, nodata, invalid_okay)
!
! !DESCRIPTION:
! Wrapper to lookup_2d that first reads the lookup table from a netcdf file
!
! If lookup_has_invalid is false, then we treat all lookup table entries as valid data
! (i.e., all valid_entries are true in the call to lookup_2d). If lookup_has_invalid is
! true, then we read the _FillValue attribute for the lookup table variable, and consider
! any table entry with value _FillValue to be an invalid entry, thus putting fill_val in
! these data locations (and raising an error flag unless invalid_okay is present and
! true).
!
! The dimension given by dimname1 -- with the associated indices given by index1 -- is the
! fastest-varying dimension in the lookup table. Dimension dimname2 (associated with
! index2) is the second-fastest-varying dimension. Similarly, extra_dims should be ordered
! from faster-varying to slowest-varying dimension.  (The first dimension in extra_dims is
! the third-fastest-varying dimension in the lookup table.)
!
! n_extra_dims gives the number of extra dimensions (in addition to the first two) in the
! lookup table. We take a single 2-d slice of the lookup table, by using a single value of
! each of these other dimensions. If n_extra_dims > 0, then extra_dims must be present,
! with at least n_extra_dims entries. Each entry in extra_dims gives the name of a
! dimension and the dimension index to use for the slice.
!
! If size(extra_dims) > n_extra_dims, then we use the first n_extra_dims entries in
! extra_dims. If n_extra_dims = 0, then extra_dims is ignored.
!
! Note that we ignore any coordinate variables associated with the dimensions of the
! lookup table; we simply treat the lookup table indices as 1,2,3,...
!
! See the lookup_2d documentation for documentation of some other arguments
!
! WJS (2-1-12): Some thoughts on avoiding duplication if we eventually want similar
! routines, lookup_1d_netcdf, lookup_3d_netcdf, etc.:
!
! Much of the code in lookup_2d_netcdf could then be pulled out to a shared subroutine
! (e.g., much of the error-checking code).
!
! Or, maybe better: we could try to make a single lookup_netcdf subroutine that handles
! 1-d, 2-d and any other dimensionality. To do that, we would (1) make a generic interface
! (of which lookup_1d and lookup_2d would be implementations); (2) change the repeated
! arguments in lookup_2d_netcdf (*1 and *2) to arrays -- maybe using an array of a derived
! type containing these arguments; (3) if possible, initially read the lookup table into a
! 1-d array (if the netcdf call allows reading a n-d array into a 1-d array) (if netcdf
! doesn't allow this, then I think we could achieve the same thing by reading 1-d slices
! of the lookup table in a loop, building the full lookup table as a long 1-d array); (4)
! in the call to the generic 'lookup' function, reshape the 1-d lookup table
! appropriately. (Note: I think it would be challenging to combine lookup_1d and lookup_2d
! (etc.)  into a single routine using a similar method.)
!
! !USES:
   use mkncdio
! !ARGUMENTS:
   implicit none
   integer         , intent(in) :: ncid         ! ID of an open netcdf file
   character(len=*), intent(in) :: tablename    ! name of the lookup table variable
   logical         , intent(in) :: lookup_has_invalid ! should we use _FillValue? (see above)
   character(len=*), intent(in) :: dimname1     ! name of the first (fastest-varying) dimension of the lookup table
   character(len=*), intent(in) :: dimname2     ! name of the second dimension of the lookup table
   integer         , intent(in) :: n_extra_dims ! number of extra dimensions in the lookup table
   ! The following arguments are passed directly to lookup_2d:
   integer         , intent(in) :: index1(:)    ! index into dim 1 of lookup table
   integer         , intent(in) :: index2(:)    ! index into dim 2 of lookup table
   real(r8)        , intent(in) :: fill_val     ! value to put in data where we don't have a valid value
   real(r8)        , intent(out):: data(:)      ! output array
   integer         , intent(out):: ierr         ! error return code from the call to lookup_2d

   ! slice to use if lookup table variable has more than 2 dimensions:
   type(dim_slice_type), intent(in), optional :: extra_dims(:)

   ! nodata flag in index1 and index2, passed directly to lookup_2d:
   integer             , intent(in), optional :: nodata

   ! flag for whether trying to use a lookup table value that is equal to the _FillValue
   ! should raise an error flag
   ! (irrelevant if lookup_has_invalid is .false.)
   ! (passed directly to lookup_2d - see the documentation there for more details)
   logical             , intent(in), optional :: invalid_okay
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
!
! !LOCAL VARIABLES:
!EOP
   integer  :: varid           ! netcdf variable id of the lookup table
   integer  :: ndims           ! total number of dimensions of lookup table
   integer  :: ndims_expected  ! value we expect for ndims, for error checking
   integer  :: i
   real(r8) :: table_fillval   ! value of the _FillValue attribute for the lookup table
   character(len=nf_max_name), allocatable :: dimnames(:)  ! dimension names
   integer , allocatable :: dimids(:)  ! dimension ids
   integer , allocatable :: dimlens(:) ! dimension lengths
   integer , allocatable :: starts(:)  ! starting indices for reading lookup table
   integer , allocatable :: counts(:)  ! dimension counts for reading lookup table
   real(r8), allocatable :: lookup_table(:,:)
   logical , allocatable :: valid_entries(:,:)  ! which entries of the lookup table are considered valid

   character(len=*), parameter :: subname = 'lookup_2d_netcdf'
!-----------------------------------------------------------------------
   
   ! Error-check extra_dims
   
   if (n_extra_dims > 0) then
      if (.not. present(extra_dims)) then
         write(6,*) subname//' ERROR: extra_dims must be present for n_extra_dims > 0'
         call abort()
      end if

      if (size(extra_dims) < n_extra_dims) then
         write(6,*) subname//' ERROR: not enough extra dimensions given'
         write(6,*) 'n_extra_dims =     ', n_extra_dims
         write(6,*) 'size(extra_dims) = ', size(extra_dims)
         call abort()
      end if
   end if

   ! Determine number of expected dimensions in the table, and actual number of
   ! dimensions in the netcdf file

   ndims_expected = 2 + n_extra_dims

   call check_ret(nf_inq_varid (ncid, tablename, varid), subname)
   call check_ret(nf_inq_varndims (ncid, varid, ndims), subname)
   if (ndims /= ndims_expected) then
      write(6,*) subname//' ERROR: unexpected number of dimensions in ', &
           trim(tablename)
      write(6,*) 'ndims = ', ndims
      write(6,*) 'expected (based on n_extra_dims): ', ndims_expected
      call abort()
   end if

   ! Get dimension names & sizes, and error-check them

   allocate(dimids(ndims), dimlens(ndims), dimnames(ndims))
   call check_ret(nf_inq_vardimid (ncid, varid, dimids), subname)
   do i = 1, ndims
      call check_ret(nf_inq_dimname (ncid, dimids(i), dimnames(i)), subname)
      call check_ret(nf_inq_dimlen (ncid, dimids(i), dimlens(i)), subname)
   end do

   call check_dimname(dimnames(1), dimname1, 1)
   call check_dimname(dimnames(2), dimname2, 2)
   do i = 1, n_extra_dims
      call check_dimname(dimnames(2+i), extra_dims(i)%name, 2+i)
      call check_dimsize(dimlens(2+i), extra_dims(i)%val, 2+i)
   end do

   ! Read the lookup table; if the given variable has more than 2 dimensions, we read
   ! a single 2-d slice

   allocate(starts(ndims), counts(ndims))
   allocate(lookup_table(dimlens(1), dimlens(2)))
   starts(1:2) = 1
   counts(1:2) = dimlens(1:2)
   do i = 1, n_extra_dims
      starts(2+i) = extra_dims(i)%val
      counts(2+i) = 1
   end do
   call check_ret(nf_get_vara_double (ncid, varid, starts, counts, lookup_table), subname)

   ! Determine which entries are valid

   allocate(valid_entries(size(lookup_table, 1), size(lookup_table, 2)))
   valid_entries(:,:) = .true.
   if (lookup_has_invalid) then
      call check_ret(nf_get_att_double (ncid, varid, '_FillValue', table_fillval), subname)
      where (lookup_table == table_fillval)
         valid_entries = .false.
      end where
   end if

   ! Do the lookups

   call lookup_2d(index1, index2, lookup_table, fill_val, data, ierr, nodata=nodata, &
        valid_entries=valid_entries, invalid_okay=invalid_okay)

   deallocate(valid_entries)
   deallocate(lookup_table)
   deallocate(starts, counts)
   deallocate(dimids, dimlens, dimnames)

contains
!------------------------------------------------------------------------------
   subroutine check_dimname(actual, expected, i)
   ! Make sure names are equal; if not, stop with an error message

      character(len=*), intent(in) :: actual, expected
      integer         , intent(in) :: i  ! dimension number, for output purposes

      if (actual /= expected) then
         write(6,*) subname//' ERROR: unexpected dimension name in ', trim(tablename)
         write(6,*) 'dimension #', i
         write(6,*) 'actual:   ', trim(actual)
         write(6,*) 'expected: ', trim(expected)
         call abort()
      end if
   end subroutine check_dimname

!------------------------------------------------------------------------------
   subroutine check_dimsize(length, index, i)
   ! Make sure dimension length is long enough; if not, stop with an error message

      integer, intent(in) :: length, index
      integer, intent(in) :: i  ! dimension number, for output purposes

      if (index > length) then
         write(6,*) subname//' ERROR: desired index exceeds dimension length in ', &
              trim(tablename)
         write(6,*) 'dimension #', i
         write(6,*) 'index:  ', index
         write(6,*) 'length: ', length
         call abort()
      end if
   end subroutine check_dimsize
      
end subroutine lookup_2d_netcdf
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: which_max
!
! !INTERFACE:
subroutine which_max(arr, maxval, maxindex, lbound)
!
! !DESCRIPTION:
! Returns maximum value in arr along with the index of the maximum value
!
! If multiple values are tied, returns index of the first maximum
!
! !ARGUMENTS:
   implicit none
   real(r8), intent(in) :: arr(:)
   real(r8), intent(out):: maxval   ! maximum value in arr(:)
   integer , intent(out):: maxindex ! first index of maxval

   ! lower bound of indices of arr; if not supplied, assumed to be 1:
   integer , intent(in), optional :: lbound
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
!
! !LOCAL VARIABLES:
!EOP
   integer :: i
!-----------------------------------------------------------------------
   
   maxindex = 1
   maxval = arr(1)

   do i = 2, size(arr)
      if (arr(i) > maxval) then
         maxindex = i
         maxval = arr(i)
      end if
   end do

   if (present(lbound)) then
      maxindex = maxindex + (lbound - 1)
   end if
end subroutine which_max
!------------------------------------------------------------------------------

end module mkindexmapMod

subroutine chkdims (fileid, name, varid, londimid, latdimid, timdimid, verbose)

  implicit none

  include 'netcdf.inc'

  integer fileid, varid, londimid, latdimid
  integer timdimid
  logical verbose
  character*(*) name

  integer ret
  integer ndims, dimids(nf_max_dims)

  ret = nf_inq_varid (fileid, name, varid)

  if (ret.eq.NF_NOERR) then

    dimids(:) = -999
    ret = nf_inq_varndims (fileid, varid, ndims)
    ret = nf_inq_vardimid (fileid, varid, dimids)

    if (ret.ne.NF_NOERR) then
      write(6,*)'NF_INQ_VAR failed for ',name
      call handle_error (ret)
    end if

    if (ndims.eq.3 .and. dimids(3).ne.timdimid) then
      write(6,*)'3rd dim of ', name, ' must be time'
      call endrun
    end if
      
    if (dimids(1).ne.londimid .or. dimids(2).ne.latdimid) then
      write(6,*)'Dims of ', name,' must be lon by lat'
      call endrun
    end if

    if (verbose) write(6,*)'Overwriting existing ',name,' with hi-res topo'

  else

    dimids(1) = londimid
    dimids(2) = latdimid
    dimids(3) = timdimid
    if (verbose) write(6,*)name,' does not exist on netcdf file: Creating.'
    ret = nf_redef (fileid)
    ret = nf_def_var (fileid, name, NF_DOUBLE, 3, dimids, varid)
    if (ret.ne.NF_NOERR) call handle_error (ret)
    ret = nf_enddef (fileid)

  end if
end subroutine chkdims

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!     This module contains the netCDF include file and a netcdf error
!     handling routine.
!
!-----------------------------------------------------------------------
!
!     CVS:$Id: netcdf.f,v 1.2 2000/04/19 21:56:25 pwjones Exp $
!
!     Copyright (c) 1997, 1998 the Regents of the University of 
!       California.
!
!     This software and ancillary information (herein called software) 
!     called SCRIP is made available under the terms described here.  
!     The software has been approved for release with associated 
!     LA-CC Number 98-45.
!
!     Unless otherwise indicated, this software has been authored
!     by an employee or employees of the University of California,
!     operator of the Los Alamos National Laboratory under Contract
!     No. W-7405-ENG-36 with the U.S. Department of Energy.  The U.S.
!     Government has rights to use, reproduce, and distribute this
!     software.  The public may copy and use this software without
!     charge, provided that this Notice and any statement of authorship
!     are reproduced on all copies.  Neither the Government nor the
!     University makes any warranty, express or implied, or assumes
!     any liability or responsibility for the use of this software.
!
!     If software is modified to produce derivative works, such modified
!     software should be clearly marked, so as not to confuse it with 
!     the version available from Los Alamos National Laboratory.
!
!***********************************************************************

      module netcdf_mod

!-----------------------------------------------------------------------

      use kinds_mod
      use constants

      implicit none

      include 'netcdf.inc'

!***********************************************************************

      contains

!***********************************************************************

      subroutine netcdf_error_handler(istat)

!-----------------------------------------------------------------------
!
!     This routine provides a simple interface to netCDF error message
!     routine.
!
!-----------------------------------------------------------------------

      integer (kind=int_kind), intent(in) :: 
     &    istat   ! integer status returned by netCDF function call

!-----------------------------------------------------------------------

      if (istat /= NF_NOERR) then
        print *,'Error in netCDF: ',nf_strerror(istat)
        stop
      endif

!-----------------------------------------------------------------------

      end subroutine netcdf_error_handler

!***********************************************************************

      end module netcdf_mod

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module control

   implicit none
   private

   include 'netcdf.inc'
   

   logical, public :: verbose
   logical, public :: silent
   logical, public :: compute_gauss
   logical, public :: prec_override = .false.
   integer, public :: prec_out

   public :: &
      set_user_skip,    &
      set_user_include, &
      is_user_skip,    &
      is_user_include

   integer, parameter :: fexcl_max = 100
   character(len=nf_max_name) :: fexcl(fexcl_max) = ' '
   integer :: num_fexcl = 0

   integer, parameter :: fincl_max = 100
   character(len=nf_max_name) :: fincl(fincl_max) = ' '
   integer :: num_fincl = 0

!=======================================================================================
contains
!=======================================================================================

subroutine set_user_skip(var_list)

   character(len=*), intent(in) :: var_list

   integer :: i
   integer :: start, str_len, next_comma
   !-------------------------------------------------------------------

   call delimited_string_to_array(var_list, ',', fexcl, num_fexcl)

   if (verbose) write(6,*)'set_user_skip: fexcl:', trim(var_list)

end subroutine set_user_skip

!---------------------------------------------------------------------------------------

subroutine set_user_include(var_list)

   character(len=*), intent(in) :: var_list

   integer :: i
   integer :: start, str_len, next_comma
   !-------------------------------------------------------------------

   call delimited_string_to_array(var_list, ',', fincl, num_fincl)

   if (verbose) write(6,*)'set_user_include: fincl:', trim(var_list)

end subroutine set_user_include

!---------------------------------------------------------------------------------------

logical function is_user_skip(name)

   character(len=*), intent(in) :: name

   integer :: i

   ! look through list of user specified names to skip (i.e.,
   ! don't copy/interpolate these variables on input file to
   ! the output file

   is_user_skip = .false.
   do i = 1, num_fexcl
      if (trim(name) == trim(fexcl(i))) then
         is_user_skip = .true.
         return
      end if
   end do

end function is_user_skip

!---------------------------------------------------------------------------------------

logical function is_user_include(name)

   character(len=*), intent(in) :: name

   integer :: i

   ! look through list of user specified names to include, i.e.,
   ! copy these variables from the template file to the output file.

   is_user_include = .false.
   do i = 1, num_fincl
      if (trim(name) == trim(fincl(i))) then
         is_user_include = .true.
         return
      end if
   end do

end function is_user_include

!---------------------------------------------------------------------------------------

subroutine delimited_string_to_array(delim_str, delim, array, nelem)

   character(len=*), intent(in) :: delim_str  ! string containing delimiter separated tokens
   character(len=1), intent(in) :: delim      ! value of delimiter

   character(len=nf_max_name), intent(out) :: array(:) ! names
   integer,                    intent(out) :: nelem    ! number of tokens

   integer :: i, nelem_max
   integer :: start, str_len, next_delim
   !-------------------------------------------------------------------

   nelem_max = size(array)

   start = 1
   str_len = len_trim(delim_str)
   
   ! check that there's at least one variable specified
   if (str_len == 0) then
      write(6,*) 'delimited_string_to_array: ERROR - input string argument is empty'
      stop
   end if

   do i = 1, nelem_max

      ! scan for delimiter
      next_delim = scan(delim_str(start:str_len), delim)

      ! copy next variable into array
      if (next_delim == 0) then
         ! if scan returns zero there are no delimiters.  So use entire remaining
         ! string as a variable name and we're done
         array(i) = delim_str(start:str_len)
         exit
      else
         array(i) = delim_str(start:start+next_delim-2)
         start = start+next_delim
         if (start > str_len) exit
      end if

   end do

   nelem = i

end subroutine delimited_string_to_array

!---------------------------------------------------------------------------------------

end module control

subroutine lininterp (arrin, nxin, incin, xin, &
                      arrout, nxout, incout, xout, periodic)
  use shr_kind_mod, only: r8 => shr_kind_r8

!-----------------------------------------------------------------------
!
! Do a linear interpolation from input mesh defined by xin to output
! mesh defined by xout.  Where extrapolation is necessary, values will
! be copied from the extreme edge of the input grid.
!
!---------------------------Code history--------------------------------
!
! Original version:  J. Rosinski
!
!-----------------------------------------------------------------------
  implicit none
!-----------------------------------------------------------------------
!
! Arguments
!
  integer nxin, incin
  integer nxout, incout

  real(r8) xin(nxin), xout(nxout)
  real(r8) arrin(incin,nxin)
  real(r8) arrout(incout,nxout)

  logical periodic
!
! Local workspace
!
  integer i, ii                ! input grid indices
  integer im, ip, iiprev       ! input grid indices
  integer icount               ! number of values

  real(r8) extrap                ! percent grid non-overlap
  real(r8) dxinwrap              ! delta-x on input grid for 2-pi
  real(r8) avgdxin               ! avg input delta-x
  real(r8) ratio                 ! compare dxinwrap to avgdxin
!
! Dynamic
!
  integer iim(nxout)           ! interp. indices minus
  integer iip(nxout)           ! interp. indices plus

  real(r8) wgtm(nxout)           ! interp. weight minus
  real(r8) wgtp(nxout)           ! interp. weight plus
!
! Just copy the data and return if input dimensions are 1
!
  if (nxin.eq.1 .and. nxout.eq.1) then
    arrout(1,1) = arrin(1,1)
  else if (nxin.eq.1) then
    write(6,*)'LININTERP: Must have at least 2 input points'
    call abort
  end if
  icount = 0
  do i=1,nxin-1
    if (xin(i).gt.xin(i+1)) icount = icount + 1
  end do
  do i=1,nxout-1
    if (xout(i).gt.xout(i+1)) icount = icount + 1
  end do
  if (icount.gt.0) then
    write(6,*)'LININTERP: Non-monotonic coordinate array(s) found'
    call abort
  end if
!
! Initialize index arrays for later checking
!
  do i=1,nxout
    iim(i) = 0
    iip(i) = 0
  end do
  if (periodic) then
!
! Periodic case: for values which extend beyond boundaries, assume 
! periodicity and interpolate between endpoints.  First check for sane 
! periodicity assumption.
!
    if (xin(1).lt.0. .or. xin(nxin).gt.360.) then
      write(6,*)'LININTERP: For periodic Input x-grid must be between 0 and 360'
      call abort
    end if
    if (xout(1).lt.0. .or. xout(nxout).gt.360.) then
      write(6,*)'Output x-grid must be between 0 and 360'
      call abort
    end if
    dxinwrap = xin(1) + 360. - xin(nxin)
    avgdxin = (xin(nxin)-xin(1))/(nxin-1.)
    ratio = dxinwrap/avgdxin
    if (ratio.lt.0.9 .or. ratio.gt.1.1) then
      write(6,*)'LININTERP: Insane dxinwrap value =',dxinwrap,' avg=', avgdxin
      call abort
    end if
    do im=1,nxout
      if (xout(im).gt.xin(1)) exit
      iim(im) = nxin
      iip(im) = 1
      wgtm(im) = (xin(1)        - xout(im)) /dxinwrap
      wgtp(im) = (xout(im)+360. - xin(nxin))/dxinwrap
    end do
    do ip=nxout,1,-1
      if (xout(ip).le.xin(nxin)) exit
      iim(ip) = nxin
      iip(ip) = 1
      wgtm(ip) = (xin(1)+360. - xout(ip)) /dxinwrap
      wgtp(ip) = (xout(ip)    - xin(nxin))/dxinwrap
    end do
  else
!
! Non-periodic case: for values which extend beyond boundaries, set weights
! such that values will just be copied.
!
    do im=1,nxout
      if (xout(im).gt.xin(1)) exit
      iim(im) = 1
      iip(im) = 1
      wgtm(im) = 1.
      wgtp(im) = 0.
    end do
    do ip=nxout,1,-1
      if (xout(ip).le.xin(nxin)) exit
      iim(ip) = nxin
      iip(ip) = nxin
      wgtm(ip) = 1.
      wgtp(ip) = 0.
    end do
  end if
!
! Loop though output indices finding input indices and weights
!
  iiprev = 1
  do i=im,ip
    do ii=iiprev,nxin-1
      if (xout(i).gt.xin(ii) .and. xout(i).le.xin(ii+1)) then
        iim(i) = ii
        iip(i) = ii + 1
        wgtm(i) = (xin(ii+1)-xout(i))/(xin(ii+1)-xin(ii))
        wgtp(i) = (xout(i)-xin(ii))/(xin(ii+1)-xin(ii))
        goto 30
      end if
    end do
    write(6,*)'LININTERP: Failed to find interp values'
30  iiprev = ii
  end do
!
! Check grid overlap
!
  extrap = 100.*((im - 1.) + (nxout - ip))/nxout
  if (extrap.gt.30.) then
    write(6,*)'********LININTERP WARNING:',extrap,' % of output', &
              ' grid will have to be extrapolated********'
  end if
!
! Check that interp/extrap points have been found for all outputs
!
  icount = 0
  do i=1,nxout
    if (iim(i).eq.0 .or. iip(i).eq.0) icount = icount + 1
  end do
  if (icount.gt.0) then
    write(6,*)'LININTERP: Point found without interp indices'
    call abort
  end if
!
! Do the interpolation
!
  do i=1,nxout
    arrout(1,i) = arrin(1,iim(i))*wgtm(i) + arrin(1,iip(i))*wgtp(i)
  end do
  return
end subroutine lininterp
 

module mksoilMod
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: mksoilMod
!
! !DESCRIPTION:
! Make soil data (texture, color and organic)
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!-----------------------------------------------------------------------
!!USES:
  use shr_kind_mod, only : r8 => shr_kind_r8, r4=>shr_kind_r4
  use shr_sys_mod , only : shr_sys_flush
  use mkdomainMod , only : domain_checksame
  implicit none

  SAVE
  private           ! By default make data private
!
! !PUBLIC MEMBER FUNCTIONS:
!
  public mksoilInit     ! Soil Initialization

  public mksoilAtt      ! Add attributes to output file

  public mksoiltex      ! Set soil texture
  public mkorganic      ! Set organic soil
  public mksoilcol      ! Set soil color
  public mkfmax         ! Make percent fmax
!
! !PUBLIC DATA MEMBERS:
!
  real(r8), public, parameter :: unset = -999.99_r8 ! Flag to signify soil texture override not set
  real(r8), public    :: soil_sand = unset     ! soil texture sand % to override with
  real(r8), public    :: soil_clay = unset     ! soil texture clay % to override with
  real(r8), public    :: soil_fmax = unset     ! soil max saturation frac to override with
  integer , parameter :: unsetcol  = -999      ! flag to indicate soil color NOT set
  integer , public    :: soil_color= unsetcol  ! soil color to override with
!
! !PRIVATE DATA MEMBERS:
!
! !PRIVATE MEMBER FUNCTIONS:
  private :: mkrank
  private :: mksoiltexInit  ! Soil texture Initialization
  private :: mksoilcolInit  ! Soil color Initialization
  private :: mksoilfmaxInit ! Soil fmax Initialization

!EOP
!===============================================================
contains
!===============================================================

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mksoilInit
!
! !INTERFACE:
subroutine mksoilInit( )
!
! !DESCRIPTION:
! Initialize the different soil types
! !USES:
!
! !ARGUMENTS:
  implicit none
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!
! !LOCAL VARIABLES:
!EOP
  character(len=32) :: subname = 'mksoilInit'
!-----------------------------------------------------------------------
  call mksoiltexInit()
  call mksoilcolInit()
  call mksoilfmaxInit()

end subroutine mksoilInit

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mksoiltexInit
!
! !INTERFACE:
subroutine mksoiltexInit( )
!
! !DESCRIPTION:
! Initialize of make soil texture
! !USES:
!
! !ARGUMENTS:
  implicit none
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!
! !LOCAL VARIABLES:
!EOP
  real(r8) :: sumtex
  character(len=32) :: subname = 'mksoiltexInit'
!-----------------------------------------------------------------------
    if ( soil_clay /= unset )then
       write(6,*) 'Replace soil clay % for all points with: ', soil_clay
       if ( soil_sand == unset )then
           write (6,*) subname//':error: soil_clay set, but NOT soil_sand'
           call abort()
       end if
    end if
    if ( soil_sand /= unset )then
       write(6,*) 'Replace soil sand % for all points with: ', soil_sand
       if ( soil_clay == unset )then
           write (6,*) subname//':error: soil_sand set, but NOT soil_clay'
           call abort()
       end if
       sumtex = soil_sand + soil_clay
       if ( sumtex < 0.0_r8 .or. sumtex > 100.0_r8 )then
           write (6,*) subname//':error: soil_sand and soil_clay out of bounds: sand, clay = ', &
                       soil_sand, soil_clay
           call abort()
       end if
    end if

end subroutine mksoiltexInit

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mksoiltex
!
! !INTERFACE:
subroutine mksoiltex(ldomain, mapfname, datfname, ndiag, pctglac_o, sand_o, clay_o)
!
! !DESCRIPTION:
! make %sand and %clay from IGBP soil data, which includes
! igbp soil 'mapunits' and their corresponding textures
!
! !USES:
  use mkdomainMod, only : domain_type, domain_clean, domain_read
  use mkgridmapMod
  use mkvarpar	
  use mkvarctl    
  use mkncdio
!
! !ARGUMENTS:
  implicit none
  type(domain_type), intent(in) :: ldomain
  character(len=*)  , intent(in) :: mapfname      ! input mapping file name
  character(len=*)  , intent(in) :: datfname      ! input data file name
  integer           , intent(in) :: ndiag         ! unit number for diag out
  real(r8)          , intent(in) :: pctglac_o(:)  ! % glac (output grid)
  real(r8)          , intent(out):: sand_o(:,:)   ! % sand (output grid)
  real(r8)          , intent(out):: clay_o(:,:)   ! % clay (output grid)
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Mariana Vertenstein
!
!
! !LOCAL VARIABLES:
!EOP
  type(gridmap_type)    :: tgridmap
  type(domain_type)    :: tdomain          ! local domain
  character(len=38)  :: typ                 ! soil texture based on ...
  integer  :: nlay                          ! number of soil layers
  integer  :: mapunitmax                    ! max value of igbp soil mapunits
  integer  :: mapunittemp                   ! temporary igbp soil mapunit
  integer  :: maxovr
  integer , allocatable :: novr(:)
  integer , allocatable :: kmap(:,:)
  real(r8), allocatable :: kwgt(:,:)
  integer , allocatable :: kmax(:)
  real(r8), allocatable :: wst(:)
  real(r8), allocatable :: sand_i(:,:)      ! input grid: percent sand
  real(r8), allocatable :: clay_i(:,:)      ! input grid: percent clay
  real(r8), allocatable :: mapunit_i(:)     ! input grid: igbp soil mapunits
  integer, parameter :: num=2               ! set soil mapunit number
  integer  :: wsti(num)                     ! index to 1st and 2nd largest wst
  integer, parameter :: nlsm=4              ! number of soil textures 
  character(len=38)  :: soil(0:nlsm)        ! name of each soil texture
  real(r8) :: gast_i(0:nlsm)                ! global area, by texture type
  real(r8) :: gast_o(0:nlsm)                ! global area, by texture type
  real(r8) :: wt                            ! map overlap weight
  real(r8) :: sum_fldi                      ! global sum of dummy input fld
  real(r8) :: sum_fldo                      ! global sum of dummy output fld
  integer  :: l,k,n,m,ni,no,ns_i,ns_o       ! indices
  integer  :: k1,k2                         ! indices
  integer  :: ncid,dimid,varid              ! input netCDF id's
  integer  :: ier                           ! error status
  integer  :: miss = 99999                  ! missing data indicator
  real(r8) :: relerr = 0.00001              ! max error: sum overlap wts ne 1
  logical  :: found                         ! temporary
  integer  :: kmap_max                      ! maximum overlap weights
  integer, parameter :: kmap_max_min   = 90 ! kmap_max mininum value
  integer, parameter :: km_mx_ns_prod = 160000 ! product of kmap_max*ns_o to keep constant
  character(len=32) :: subname = 'mksoiltex'
!-----------------------------------------------------------------------

  write (6,*) 'Attempting to make %sand and %clay .....'
  call shr_sys_flush(6)

  ! -----------------------------------------------------------------
  ! Define the model surface types: 0 to nlsm
  ! -----------------------------------------------------------------

  soil(0) = 'no soil: ocean, glacier, lake, no data'
  soil(1) = 'clays                                 '
  soil(2) = 'sands                                 '
  soil(3) = 'loams                                 '
  soil(4) = 'silts                                 '

  ! -----------------------------------------------------------------
  ! Read input file
  ! -----------------------------------------------------------------

  ! Obtain input grid info, read local fields

  call domain_read(tdomain,datfname)
  ns_i = tdomain%ns
  ns_o = ldomain%ns

  write (6,*) 'Open soil texture file: ', trim(datfname)
  call check_ret(nf_open(datfname, 0, ncid), subname)
  call check_ret(nf_inq_dimid  (ncid, 'number_of_layers', dimid), subname)
  call check_ret(nf_inq_dimlen (ncid, dimid, nlay), subname)

  call check_ret(nf_inq_dimid  (ncid, 'max_value_mapunit', dimid), subname)
  call check_ret(nf_inq_dimlen (ncid, dimid, mapunitmax), subname)

  allocate(sand_i(mapunitmax,nlay), &
           clay_i(mapunitmax,nlay), &
           mapunit_i(ns_i), stat=ier)
  if (ier/=0) call abort()

  call check_ret(nf_inq_varid (ncid, 'MAPUNITS', varid), subname)
  call check_ret(nf_get_var_double (ncid, varid, mapunit_i), subname)

  call check_ret(nf_inq_varid (ncid, 'PCT_SAND', varid), subname)
  call check_ret(nf_get_var_double (ncid, varid, sand_i), subname)

  call check_ret(nf_inq_varid (ncid, 'PCT_CLAY', varid), subname)
  call check_ret(nf_get_var_double (ncid, varid, clay_i), subname)

  call check_ret(nf_close(ncid), subname)

  ! Compute local fields _o
  if (soil_sand==unset .and. soil_clay==unset) then

     call gridmap_mapread(tgridmap, mapfname)

     ! Error checks for domain and map consistencies

     call domain_checksame( tdomain, ldomain, tgridmap )

     ! kmap_max are the maximum number of mapunits that will consider on
     ! any output gridcell - this is set currently above and can be changed
     ! kmap(:) are the mapunit values on the input grid
     ! kwgt(:) are the weights on the input grid

     allocate(novr(ns_o))
     novr(:) = 0
     do n = 1,tgridmap%ns
        ni = tgridmap%src_indx(n)
        no = tgridmap%dst_indx(n)
        wt = tgridmap%wovr(n)
        novr(no) = novr(no) + 1
     end do
     maxovr = maxval(novr(:))
     kmap_max = min(maxovr,max(kmap_max_min,km_mx_ns_prod/ns_o))
     deallocate(novr)

     write(6,*)'kmap_max= ',kmap_max,' maxovr= ',maxovr,' ns_o= ',ns_o,' size= ',(kmap_max+1)*ns_o

     allocate(kmap(0:kmap_max,ns_o), stat=ier)
     if (ier/=0) call abort()
     allocate(kwgt(0:kmap_max,ns_o), stat=ier)
     if (ier/=0) call abort()
     allocate(kmax(ns_o), stat=ier)
     if (ier/=0) call abort()
     allocate(wst(0:kmap_max), stat=ier)
     if (ier/=0) call abort()

     kwgt(:,:) = 0.
     kmap(:,:) = 0
     kmax(:) = 0

     do n = 1,tgridmap%ns
        ni = tgridmap%src_indx(n)
        no = tgridmap%dst_indx(n)
        wt = tgridmap%wovr(n)
        if (tgridmap%frac_src(ni) > 0) then
           k = mapunit_i(ni) 
        else
           k = 0
        end if
        found = .false.
        do l = 0,kmax(no)
           if (k == kmap(l,no)) then
              kwgt(l,no) = kwgt(l,no) + wt
              kmap(l,no) = k
              found = .true.
              exit
           end if
        end do
        if (.not. found) then
           kmax(no) = kmax(no) + 1
           if (kmax(no) > kmap_max) then
              write(6,*)'kmax is > kmap_max= ',kmax(no), 'kmap_max = ', &
                         kmap_max,' for no = ',no
              write(6,*)'reset kmap_max in mksoilMod to a greater value'
              stop
           end if
           kmap(kmax(no),no) = k
           kwgt(kmax(no),no) = wt
        end if
     enddo

  end if

  do no = 1,ns_o

     if (soil_sand==unset .and. soil_clay==unset) then
        wst(:) = 0.
        wst(0:kmax(no)) = kwgt(0:kmax(no),no)

        ! Rank non-zero weights by soil mapunit.
        ! k1 is the most extensive mapunit.
        ! k2 is the second most extensive mapunit.

        if (maxval(wst(:)) > 0) then
           call mkrank (kmax(no)+1, wst(0:kmax(no)), miss, wsti, num)
           k1 = kmap(wsti(1),no)
           if (wsti(2) == miss) then
              k2 = miss
           else
              k2 = kmap(wsti(2),no)
           end if
        else
           k1 = 0
           k2 = 0
        end if

     end if

     ! Set soil texture as follows:
     ! If land grid cell is ocean or 100% glacier: cell has no soil
     ! Otherwise, grid cell needs soil:
     !   a. Use dominant igbp soil mapunit based on area of overlap unless
     !     'no data' is dominant
     !   b. In this case use second most dominant mapunit if it has data
     !   c. If this has no data or if there isn't a second most dominant
     !      mapunit, use loam for soil texture

     if (abs(pctglac_o(no)-100.) < 1.e-06) then    !---glacier
        do l = 1, nlay
           sand_o(no,l) = 0.
           clay_o(no,l) = 0.
        end do
     else                                     !---need soil
        if (soil_sand/=unset .and. soil_clay/=unset) then  !---soil texture is input
           do l = 1, nlay
              sand_o(no,l) = soil_sand
              clay_o(no,l) = soil_clay
           end do
        else if (k1 /= 0) then           !---not 'no data'
           do l = 1, nlay
              sand_o(no,l) = sand_i(k1,l)
              clay_o(no,l) = clay_i(k1,l)
           end do
        else                                  !---if (k1 == 0) then
           if (k2 == 0 .or. k2 == miss) then     !---no data
              do l = 1, nlay
                 sand_o(no,l) = 43.           !---use loam
                 clay_o(no,l) = 18.
              end do
           else                               !---if (k2 /= 0 and /= miss)
              do l = 1, nlay
                 sand_o(no,l) = sand_i(k2,l)
                 clay_o(no,l) = clay_i(k2,l)
              end do
           end if       !---end of k2 if-block
        end if          !---end of k1 if-block
     end if             !---end of land/ocean if-block

  enddo

  if (soil_sand==unset .and. soil_clay==unset) then

     ! Global sum of output field 

     sum_fldi = 0.0_r8
     do ni = 1,ns_i
        sum_fldi = sum_fldi + tgridmap%area_src(ni)*tgridmap%frac_src(ni)*re**2
     enddo

     sum_fldo = 0.
     do no = 1,ns_o
        sum_fldo = sum_fldo + tgridmap%area_dst(no)*tgridmap%frac_dst(no)*re**2
     end do

     ! -----------------------------------------------------------------
     ! Error check1
     ! Compare global sum fld_o to global sum fld_i.
     ! -----------------------------------------------------------------

     if ( trim(mksrf_gridtype) == 'global') then
        if ( abs(sum_fldo/sum_fldi-1.) > relerr ) then
           write (6,*) 'MKSOILTEX error: input field not conserved'
           write (6,'(a30,e20.10)') 'global sum output field = ',sum_fldo
           write (6,'(a30,e20.10)') 'global sum input  field = ',sum_fldi
           stop
        end if
     end if

     ! -----------------------------------------------------------------
     ! Error check2
     ! Compare global area of each soil type on input and output grids
     ! -----------------------------------------------------------------

     ! input grid: global areas by texture class

     gast_i(:) = 0.
     do l = 1, nlay
        do ni = 1,ns_i
           mapunittemp = nint(mapunit_i(ni))
           if (mapunittemp==0) then
              typ = 'no soil: ocean, glacier, lake, no data'
           else if (clay_i(mapunittemp,l) >= 40.) then
              typ = 'clays'
           else if (sand_i(mapunittemp,l) >= 50.) then
              typ = 'sands'
           else if (clay_i(mapunittemp,l)+sand_i(mapunittemp,l) < 50.) then
              if (tdomain%mask(ni) /= 0.) then
                 typ = 'silts'
              else            !if (tdomain%mask(ni) == 0.) then no data
                 typ = 'no soil: ocean, glacier, lake, no data'
              end if
           else
              typ = 'loams'
           end if
           do m = 0, nlsm
              if (typ == soil(m)) go to 101
           end do
           write (6,*) 'MKSOILTEX error: sand = ',sand_i(mapunittemp,l), &
             ' clay = ',clay_i(mapunittemp,l), &
             ' not assigned to soil type for input grid lon,lat,layer = ',ni,l
           call abort()
101        continue
           gast_i(m) = gast_i(m) + tgridmap%area_src(ni)*tgridmap%frac_src(ni)*re**2
        end do
     end do

     ! output grid: global areas by texture class

     gast_o(:) = 0.
     do l = 1, nlay
        do no = 1,ns_o
           if (clay_o(no,l)==0. .and. sand_o(no,l)==0.) then
              typ = 'no soil: ocean, glacier, lake, no data'
           else if (clay_o(no,l) >= 40.) then
              typ = 'clays'
           else if (sand_o(no,l) >= 50.) then
              typ = 'sands'
           else if (clay_o(no,l)+sand_o(no,l) < 50.) then
              typ = 'silts'
           else
              typ = 'loams'
           end if
           do m = 0, nlsm
              if (typ == soil(m)) go to 102
           end do
           write (6,*) 'MKSOILTEX error: sand = ',sand_o(no,l), &
             ' clay = ',clay_o(no,l), &
             ' not assigned to soil type for output grid lon,lat,layer = ',no,l
           call abort()
102        continue
           gast_o(m) = gast_o(m) + tgridmap%area_dst(no)*tgridmap%frac_dst(no)*re**2
        end do
     end do

     ! Diagnostic output

     write (ndiag,*)
     write (ndiag,'(1x,70a1)') ('=',l=1,70)
     write (ndiag,*) 'Soil Texture Output'
     write (ndiag,'(1x,70a1)') ('=',l=1,70)
     write (ndiag,*)

     write (ndiag,*) 'The following table of soil texture classes is for comparison only.'
     write (ndiag,*) 'The actual data is continuous %sand, %silt and %clay not textural classes'
     write (ndiag,*)

     write (ndiag,*)
     write (ndiag,'(1x,70a1)') ('.',l=1,70)
     write (ndiag,1001)
1001 format (1x,'soil texture class',17x,' input grid area output grid area',/ &
             1x,33x,'     10**6 km**2','      10**6 km**2')
     write (ndiag,'(1x,70a1)') ('.',l=1,70)
     write (ndiag,*)

     do l = 0, nlsm
        write (ndiag,1002) soil(l),gast_i(l)*1.e-6,gast_o(l)*1.e-6
1002    format (1x,a38,f16.3,f17.3)
     end do

  end if

  ! Deallocate dynamic memory

  call domain_clean(tdomain)
  if (soil_sand==unset .and. soil_clay==unset) then
     call gridmap_clean(tgridmap)
     deallocate (kmap, kwgt, kmax, wst)
     deallocate (sand_i,clay_i,mapunit_i)
  end if


  write (6,*) 'Successfully made %sand and %clay'
  write (6,*)
  call shr_sys_flush(6)

end subroutine mksoiltex

!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mksoilcolInit
!
! !INTERFACE:
subroutine mksoilcolInit( )
!
! !DESCRIPTION:
! Initialize of make soil color
! !USES:
!
! !ARGUMENTS:
  implicit none
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!
! !LOCAL VARIABLES:
!EOP
  real(r8) :: sumtex
  character(len=32) :: subname = 'mksoilcolInit'
!-----------------------------------------------------------------------

  ! Error check soil_color if it is set
  if ( soil_color /= unsetcol )then
     if ( soil_color < 0 .or. soil_color > 20 )then
        write(6,*)'soil_color is out of range = ', soil_color
        call abort()
     end if
     write(6,*) 'Replace soil color for all points with: ', soil_color
  end if
end subroutine mksoilcolInit


!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mksoilcol
!
! !INTERFACE:
subroutine mksoilcol(ldomain, mapfname, datfname, ndiag, &
                    pctglac_o, soil_color_o, nsoicol)
!
! !DESCRIPTION:
! make %sand and %clay from IGBP soil data, which includes
! igbp soil 'mapunits' and their corresponding textures
!
! !USES:
  use mkdomainMod, only : domain_type, domain_clean, domain_read
  use mkgridmapMod
  use mkvarpar	
  use mkvarctl    
  use mkncdio
!
! !ARGUMENTS:
  implicit none
  type(domain_type), intent(in) :: ldomain
  character(len=*)  , intent(in) :: mapfname           ! input mapping file name
  character(len=*)  , intent(in) :: datfname           ! input data file name
  integer           , intent(in) :: ndiag              ! unit number for diag out
  real(r8)          , intent(in) :: pctglac_o(:)       ! % glac (output grid)
  integer           , intent(out):: soil_color_o(:)    ! soil color classes
  integer           , intent(out):: nsoicol            ! number of soil colors 
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Mariana Vertenstein
!
!
! !LOCAL VARIABLES:
!EOP
  type(gridmap_type)    :: tgridmap
  type(domain_type)    :: tdomain          ! local domain
  integer, parameter :: num=2               ! set soil mapunit number
  integer  :: wsti(num)                     ! index to 1st and 2nd largest wst
  real(r8), allocatable :: wst(:,:)         ! overlap weights, by surface type
  real(r8), allocatable :: gast_i(:)        ! global area, by surface type
  real(r8), allocatable :: gast_o(:)        ! global area, by surface type
  integer , allocatable :: soil_color_i(:)  ! input grid: BATS soil color
  integer , allocatable :: color(:)         ! 0: none; 1: some
  real(r8) :: wt                            ! map overlap weight
  real(r8) :: sum_fldi                      ! global sum of dummy input fld
  real(r8) :: sum_fldo                      ! global sum of dummy output fld
  character(len=35), allocatable :: col(:)  ! name of each color
  integer  :: k,l,n,m,ni,no,ns_i,ns_o       ! indices
  integer  :: ncid,dimid,varid              ! input netCDF id's
  integer  :: ier                           ! error status
  integer  :: miss = 99999                  ! missing data indicator
  real(r8) :: relerr = 0.00001              ! max error: sum overlap wts ne 1
  character(len=32) :: subname = 'mksoilcol'
!-----------------------------------------------------------------------

  write (6,*) 'Attempting to make soil color classes .....'
  call shr_sys_flush(6)

  ! -----------------------------------------------------------------
  ! Read input file
  ! -----------------------------------------------------------------

  ns_o = ldomain%ns

  ! Obtain input grid info, read local fields

  call domain_read(tdomain,datfname)
  ns_i = tdomain%ns
  allocate(soil_color_i(ns_i), stat=ier)
  if (ier/=0) call abort()

  write (6,*) 'Open soil color file: ', trim(datfname)
  call check_ret(nf_open(datfname, 0, ncid), subname)
  call check_ret(nf_inq_varid (ncid, 'SOIL_COLOR', varid), subname)
  call check_ret(nf_get_var_int (ncid, varid, soil_color_i), subname)
  call check_ret(nf_close(ncid), subname)

  nsoicol = maxval(soil_color_i)
  write(6,*)'nsoicol = ',nsoicol
  if (nsoicol > 8 .and. nsoicol <= 20) then
     nsoicol = 20
  end if

  allocate(gast_i(0:nsoicol),gast_o(0:nsoicol),col(0:nsoicol))

  ! -----------------------------------------------------------------
  ! Define the model color classes: 0 to nsoicol
  ! -----------------------------------------------------------------

  if (nsoicol == 20) then
     col(0)  = 'no soil                            '
     col(1)  = 'class 1: light                     '
     col(2)  = 'class 2:                           '
     col(3)  = 'class 3:                           '
     col(4)  = 'class 4:                           '
     col(5)  = 'class 5:                           '
     col(6)  = 'class 6:                           '
     col(7)  = 'class 7:                           '
     col(8)  = 'class 8:                           '
     col(9)  = 'class 9:                           '
     col(10) = 'class 10:                          '
     col(11) = 'class 11:                          '
     col(12) = 'class 12:                          '
     col(13) = 'class 13:                          '
     col(14) = 'class 14:                          '
     col(15) = 'class 15:                          '
     col(16) = 'class 16:                          '
     col(17) = 'class 17:                          '
     col(18) = 'class 18:                          '
     col(19) = 'class 19:                          '
     col(20) = 'class 20: dark                     '
  else if (nsoicol == 8) then
     col(0) = 'no soil                            '
     col(1) = 'class 1: light                     '
     col(2) = 'class 2:                           '
     col(3) = 'class 3:                           '
     col(4) = 'class 4:                           '
     col(5) = 'class 5:                           '
     col(6) = 'class 6:                           '
     col(7) = 'class 7:                           '
     col(8) = 'class 8: dark                      '
  else
     write(6,*)'nsoicol value of ',nsoicol,' is not currently supported'
     call abort()
  end if

  ! Error check soil_color if it is set
  if ( soil_color /= unsetcol )then
     if ( soil_color > nsoicol )then
        write(6,*)'soil_color is out of range = ', soil_color
        call abort()
     end if

     do no = 1,ns_o
        soil_color_o(no) = soil_color
     end do

  else

     call gridmap_mapread(tgridmap, mapfname)

     ! Error checks for domain and map consistencies

     call domain_checksame( tdomain, ldomain, tgridmap )

     ! find area of overlap for each soil color for each no

     allocate(wst(0:nsoicol,ns_o))
     wst(0:nsoicol,:) = 0
     allocate(color(ns_o))
     color(:) = 0
     
     ! TODO: need to do a loop to determine
     ! the maximum number of over lap cells throughout the grid 
     ! first get an array that is novr(ns_o) and fill this in - then set
     ! maxovr - to max(novr) - then allocate the array wst to be size of
     ! maxovr,ns_o or 0:nsoilcol,ns_o

     do n = 1,tgridmap%ns
        ni = tgridmap%src_indx(n)
        no = tgridmap%dst_indx(n)
        wt = tgridmap%wovr(n)
        k  = soil_color_i(ni) * tdomain%mask(ni)
        wst(k,no) = wst(k,no) + wt
        if (k>0 .and. wst(k,no)>0.) then
           color(no) = 1
           wst(0,no) = 0.0
        end if
     enddo

     soil_color_o(:) = 0
     do no = 1,ns_o

        ! Rank non-zero weights by color type. wsti(1) is the most extensive
        ! color type. 

        if (color(no) == 1) then
           call mkrank (nsoicol, wst(0:nsoicol,no), miss, wsti, num)
           soil_color_o(no) = wsti(1)
        end if

        ! If land but no color, set color to 15 (in older dataset generic 
        ! soil color 4)
        
        if (nsoicol == 8) then
           if (soil_color_o(no)==0) soil_color_o(no) = 4
        else if (nsoicol == 20) then
           if (soil_color_o(no)==0) soil_color_o(no) = 15
        end if
        
        ! Set color for grid cells that are 100% glacier to zero. Otherwise,
        ! must have a soil color for the non-glacier portion of grid cell.
        
        if (abs(pctglac_o(no)-100.)<1.e-06) soil_color_o(no)=0

        ! Error checks

        if (soil_color_o(no) < 0 .or. soil_color_o(no) > nsoicol) then
           write (6,*) 'MKSOILCOL error: land model soil color = ', &
                soil_color_o(no),' is not valid for lon,lat = ',no
           call abort()
        end if

     enddo
     deallocate (wst)
     deallocate (color)

     ! Global sum of output field 

     sum_fldi = 0.0_r8
     do ni = 1,ns_i
       sum_fldi = sum_fldi + tgridmap%area_src(ni) * tgridmap%frac_src(ni)
     enddo

     sum_fldo = 0.
     do no = 1,ns_o
        sum_fldo = sum_fldo + tgridmap%area_dst(no) * tgridmap%frac_dst(no)
     end do

     ! -----------------------------------------------------------------
     ! Error check1
     ! Compare global sum fld_o to global sum fld_i.
     ! -----------------------------------------------------------------

     if ( trim(mksrf_gridtype) == 'global') then
        if ( abs(sum_fldo/sum_fldi-1.) > relerr ) then
           write (6,*) 'MKSOILCOL error: input field not conserved'
           write (6,'(a30,e20.10)') 'global sum output field = ',sum_fldo
           write (6,'(a30,e20.10)') 'global sum input  field = ',sum_fldi
           stop
        end if
     end if

     ! -----------------------------------------------------------------
     ! Error check2
     ! Compare global area of each soil color on input and output grids
     ! -----------------------------------------------------------------

     gast_i(:) = 0.
     do ni = 1,ns_i
        k = soil_color_i(ni)
        gast_i(k) = gast_i(k) + tgridmap%area_src(ni)*tgridmap%frac_src(ni)*re**2
     end do

     gast_o(:) = 0.
     do no = 1,ns_o
        k = soil_color_o(no)
        gast_o(k) = gast_o(k) + tgridmap%area_dst(no)*tgridmap%frac_dst(no)*re**2
     end do

     ! area comparison

     write (ndiag,*)
     write (ndiag,'(1x,70a1)') ('=',k=1,70)
     write (ndiag,*) 'Soil Color Output'
     write (ndiag,'(1x,70a1)') ('=',k=1,70)

     write (ndiag,*)
     write (ndiag,'(1x,70a1)') ('.',k=1,70)
     write (ndiag,1001)
1001 format (1x,'soil color type',20x,' input grid area output grid area',/ &
             1x,33x,'     10**6 km**2','      10**6 km**2')
     write (ndiag,'(1x,70a1)') ('.',k=1,70)
     write (ndiag,*)

     do k = 0, nsoicol
        write (ndiag,1002) col(k),gast_i(k)*1.e-6,gast_o(k)*1.e-6
1002    format (1x,a35,f16.3,f17.3)
     end do

  end if

  ! Deallocate dynamic memory

  call domain_clean(tdomain)
  if ( soil_color == unsetcol )then
     call gridmap_clean(tgridmap)
  end if
  deallocate (soil_color_i,gast_i,gast_o,col)

  write (6,*) 'Successfully made soil color classes'
  write (6,*)
  call shr_sys_flush(6)

end subroutine mksoilcol

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkorganic
!
! !INTERFACE:
subroutine mkorganic(ldomain, mapfname, datfname, ndiag, organic_o)
!
! !DESCRIPTION:
! make organic matter dataset
!
! !USES:
  use mkdomainMod, only : domain_type, domain_clean, domain_read
  use mkgridmapMod
  use mkvarpar	
  use mkvarctl    
  use mkncdio
!
! !ARGUMENTS:
  implicit none
  type(domain_type), intent(in) :: ldomain
  character(len=*)  , intent(in) :: mapfname       ! input mapping file name
  character(len=*)  , intent(in) :: datfname       ! input data file name
  integer           , intent(in) :: ndiag          ! unit number for diag out
  real(r8)          , intent(out):: organic_o(:,:) ! output grid:
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! 
! Author: David Lawrence
!
!
! !LOCAL VARIABLES:
!EOP
  type(gridmap_type)    :: tgridmap
  type(domain_type)    :: tdomain         ! local domain
  real(r8), allocatable :: organic_i(:,:)  ! input grid: total column organic matter
  real(r8) :: sum_fldi                     ! global sum of dummy input fld
  real(r8) :: sum_fldo                     ! global sum of dummy output fld
  real(r8) :: gomlev_i                     ! input  grid: global organic on lev
  real(r8) :: garea_i                      ! input  grid: global area
  real(r8) :: gomlev_o                     ! output grid: global organic on lev
  real(r8) :: garea_o                      ! output grid: global area
  integer  :: k,n,m,ni,no,ns_i             ! indices
  integer  :: lev                          ! level index
  integer  :: nlay                         ! number of soil layers
  integer  :: ncid,dimid,varid             ! input netCDF id's
  integer  :: ier                          ! error status
  real(r8) :: relerr = 0.00001             ! max error: sum overlap wts ne 1
  character(len=32) :: subname = 'mkorganic'
!-----------------------------------------------------------------------

  write (6,*) 'Attempting to make organic matter dataset .....'
  call shr_sys_flush(6)

  ! -----------------------------------------------------------------
  ! Read input file
  ! -----------------------------------------------------------------

  ! Obtain input grid info, read local fields

  call domain_read(tdomain,datfname)
  ns_i = tdomain%ns

  write (6,*) 'Open soil organic file: ', trim(datfname)
  call check_ret(nf_open(datfname, 0, ncid), subname)

  call check_ret(nf_inq_dimid  (ncid, 'number_of_layers', dimid), subname)
  call check_ret(nf_inq_dimlen (ncid, dimid, nlay), subname)

  allocate(organic_i(ns_i,nlay),stat=ier)
  if (ier/=0) call abort()
  if (nlay /= nlevsoi) then
     write(6,*)'nlay, nlevsoi= ',nlay,nlevsoi,' do not match'
     stop
  end if

  call check_ret(nf_inq_varid (ncid, 'ORGANIC', varid), subname)
  call check_ret(nf_get_var_double (ncid, varid, organic_i), subname)

  call check_ret(nf_close(ncid), subname)

  ! Area-average percent cover on input grid to output grid 
  ! and correct according to land landmask
  ! Note that percent cover is in terms of total grid area.

  call gridmap_mapread(tgridmap, mapfname )

  call domain_checksame( tdomain, ldomain, tgridmap )

  do lev = 1,nlay
     call gridmap_areaave(tgridmap, organic_i(:,lev), organic_o(:,lev))
  end do

  do lev = 1,nlevsoi

     ! Check for conservation

     do no = 1,ldomain%ns
        if ((organic_o(no,lev)) > 130.000001_r8) then
           write (6,*) 'MKORGANIC error: organic = ',organic_o(no,lev), &
                ' greater than 130.000001 for column, row = ',no
           call shr_sys_flush(6)
           stop
        end if
     enddo

!    ! Diagnostic output

     ! TODO: there is nothing being written out here currently - all zeroes
     ! So for now these are commented out
!!$     write (ndiag,*)
!!$     write (ndiag,'(1x,70a1)') ('.',k=1,70)
!!$     write (ndiag,2001)
!!$2001 format (1x,'surface type   input grid area  output grid area'/ &
!!$             1x,'                 10**6 km**2      10**6 km**2   ')
!!$     write (ndiag,'(1x,70a1)') ('.',k=1,70)
!!$     write (ndiag,*)
!!$     write (ndiag,2002) gomlev_i*1.e-06,gomlev_o*1.e-06
!!$     write (ndiag,2004) garea_i*1.e-06,garea_o*1.e-06
!!$2002 format (1x,'organic    ',f14.3,f17.3)
!!$2004 format (1x,'all surface ',f14.3,f17.3)
!!$
     call shr_sys_flush(ndiag)

     write (6,*) 'Successfully made organic matter, level = ', lev
     call shr_sys_flush(6)

  end do   ! lev

  ! Deallocate dynamic memory

  call domain_clean(tdomain)
  call gridmap_clean(tgridmap)
  deallocate (organic_i)

  write (6,*) 'Successfully made organic matter'
  call shr_sys_flush(6)
  write(6,*)

end subroutine mkorganic

!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: mkrank
!
! !INTERFACE:
subroutine mkrank (n, a, miss, iv, num)
!
! !DESCRIPTION:
! Return indices of largest [num] values in array [a]. Private method
! only used for soil color and soil texture.
!
! !USES:
!
! !ARGUMENTS:
  implicit none
  integer , intent(in) :: n        !array length
  real(r8), intent(in) :: a(0:n)   !array to be ranked
  integer , intent(in) :: miss     !missing data value
  integer , intent(in) :: num      !number of largest values requested
  integer , intent(out):: iv(num)  !index to [num] largest values in array [a]
!
! !CALLED FROM:
! subroutine mksoilcol 
! subroutine mksoiltex
!
! !REVISION HISTORY:
! Author: Gordon Bonan
!
!
! !LOCAL VARIABLES:
!EOP
  real(r8) a_max       !maximum value in array
  integer i            !array index
  real(r8) delmax      !tolerance for finding if larger value
  integer m            !do loop index
  integer k            !do loop index
  logical exclude      !true if data value has already been chosen
!-----------------------------------------------------------------------

  delmax = 1.e-06

  ! Find index of largest non-zero number

  iv(1) = miss
  a_max = -9999.

  do i = 0, n
     if (a(i)>0. .and. (a(i)-a_max)>delmax) then
        a_max = a(i)
        iv(1)  = i
     end if
  end do

  ! iv(1) = miss indicates no values > 0. this is an error

  if (iv(1) == miss) then
     write (6,*) 'MKRANK error: iv(1) = missing'
     call abort()
  end if

  ! Find indices of the next [num]-1 largest non-zero number.
  ! iv(m) = miss if there are no more values > 0

  do m = 2, num
     iv(m) = miss
     a_max = -9999.
     do i = 0, n

        ! exclude if data value has already been chosen

        exclude = .false.
        do k = 1, m-1
           if (i == iv(k)) exclude = .true.
        end do

        ! if not already chosen, see if it is the largest of
        ! the remaining values

        if (.not. exclude) then
           if (a(i)>0. .and. (a(i)-a_max)>delmax) then
              a_max = a(i)
              iv(m)  = i
           end if
        end if
     end do
  end do

end subroutine mkrank

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mksoilfmaxInit
!
! !INTERFACE:
subroutine mksoilfmaxInit( )
!
! !DESCRIPTION:
! Initialize of make soil fmax
! !USES:
!
! !ARGUMENTS:
  implicit none
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!
! !LOCAL VARIABLES:
!EOP
  real(r8) :: sumtex
  character(len=32) :: subname = 'mksoilfmaxInit'
!-----------------------------------------------------------------------

  ! Error check soil_fmax if it is set
  if ( soil_fmax /= unset )then
     if ( soil_fmax < 0.0 .or. soil_fmax > 1.0 )then
        write(6,*)'soil_fmax is out of range = ', soil_fmax
        stop
     end if
     write(6,*) 'Replace soil fmax for all points with: ', soil_fmax
  end if

end subroutine mksoilfmaxInit

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkfmax
!
! !INTERFACE:
subroutine mkfmax(ldomain, mapfname, datfname, ndiag, fmax_o)
!
! !DESCRIPTION:
! make percent fmax
!
! !USES:
  use mkdomainMod, only : domain_type, domain_clean, domain_read
  use mkgridmapMod
  use mkvarpar	
  use mkvarctl    
  use mkncdio
!
! !ARGUMENTS:
  implicit none
  type(domain_type), intent(in) :: ldomain
  character(len=*)  , intent(in) :: mapfname  ! input mapping file name
  character(len=*)  , intent(in) :: datfname  ! input data file name
  integer           , intent(in) :: ndiag     ! unit number for diag out
  real(r8)          , intent(out):: fmax_o(:) ! output grid: %fmax
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Revised: Nan Rosenbloom - used mkglacier.F90 as template.
! Original Author: Mariana Vertenstein
!
!
! !LOCAL VARIABLES:
!EOP
  type(gridmap_type)    :: tgridmap
  type(domain_type)    :: tdomain         ! local domain
  real(r8), allocatable :: fmax_i(:)       ! input grid: percent fmax
  real(r8) :: sum_fldi                     ! global sum of dummy input fld
  real(r8) :: sum_fldo                     ! global sum of dummy output fld
  real(r8) :: gfmax_i                      ! input  grid: global fmax
  real(r8) :: garea_i                      ! input  grid: global area
  real(r8) :: gfmax_o                      ! output grid: global fmax
  real(r8) :: garea_o                      ! output grid: global area
  integer  :: k,n,m,ni,no,ns_i,ns_o        ! indices
  integer  :: ncid,dimid,varid             ! input netCDF id's
  integer  :: ier                          ! error status
  real(r8) :: relerr = 0.00001             ! max error: sum overlap wts ne 1
  character(len=32) :: subname = 'mkfmax'
!-----------------------------------------------------------------------

  write (6,*) 'Attempting to make %fmax .....'
  call shr_sys_flush(6)

  ! -----------------------------------------------------------------
  ! Read input file
  ! -----------------------------------------------------------------

  ! Obtain input grid info, read local fields

  call domain_read(tdomain,datfname)
  ns_i = tdomain%ns
  allocate(fmax_i(ns_i), stat=ier)
  if (ier/=0) call abort()
  ns_o = ldomain%ns

  write (6,*) 'Open soil fmax file: ', trim(datfname)
  call check_ret(nf_open(datfname, 0, ncid), subname)
  call check_ret(nf_inq_varid (ncid, 'FMAX', varid), subname)
  call check_ret(nf_get_var_double (ncid, varid, fmax_i), subname)
  call check_ret(nf_close(ncid), subname)

  ! Area-average percent cover on input grid to output grid 
  ! and correct according to land landmask
  ! Note that percent cover is in terms of total grid area.

  call gridmap_mapread(tgridmap, mapfname )

  ! Error checks for domain and map consistencies

  call domain_checksame( tdomain, ldomain, tgridmap )

  ! Determine fmax_o on output grid
 
  call gridmap_areaave(tgridmap, fmax_i, fmax_o)

  do no = 1,ns_o
     if (fmax_o(no) == 0.0) then
        fmax_o(no) = .365783  ! fmax_o(no) = globalAvg
     end if
     if (fmax_o(no) == -999.99) then
        fmax_o(no) = .365783  ! fmax_o(no) = globalAvg
     end if
  enddo

  ! Check for conservation

  do no = 1, ns_o
     if ((fmax_o(no)) > 1.000001_r8) then
        write (6,*) 'MKFMAX error: fmax = ',fmax_o(no), &
                ' greater than 1.000001 for column, row = ',no
        call shr_sys_flush(6)
        stop
     end if
  enddo

  ! Global sum of output field -- must multiply by fraction of
  ! output grid that is land as determined by input grid

  sum_fldi = 0.0_r8
  do ni = 1,ns_i
    sum_fldi = sum_fldi + tgridmap%area_src(ni) * tgridmap%frac_src(ni)
  enddo

  sum_fldo = 0.
  do no = 1,ns_o
     sum_fldo = sum_fldo + tgridmap%area_dst(no) * tgridmap%frac_dst(no)
  end do

  ! -----------------------------------------------------------------
  ! Error check1
  ! Compare global sum fld_o to global sum fld_i.
  ! -----------------------------------------------------------------

  if ( trim(mksrf_gridtype) == 'global') then
     if ( abs(sum_fldo/sum_fldi-1.) > relerr ) then
        write (6,*) 'MKFMAX error: input field not conserved'
        write (6,'(a30,e20.10)') 'global sum output field = ',sum_fldo
        write (6,'(a30,e20.10)') 'global sum input  field = ',sum_fldi
        stop
     end if
  end if

  ! -----------------------------------------------------------------
  ! Error check2
  ! Compare global areas on input and output grids
  ! -----------------------------------------------------------------

  gfmax_i = 0.
  garea_i = 0.
  do ni = 1,ns_i
     garea_i = garea_i + tgridmap%area_src(ni)*re**2
     gfmax_i = gfmax_i + fmax_i(ni)*(tgridmap%area_src(ni)/100.)* &
                                     tgridmap%frac_src(ni)*re**2
  end do

  gfmax_o = 0.
  garea_o = 0.
  do no = 1,ns_o
     garea_o = garea_o + tgridmap%area_dst(no)*re**2
     gfmax_o = gfmax_o + fmax_o(no)*(tgridmap%area_dst(no)/100.) * &
                                     tgridmap%frac_dst(no)*re**2
     if ((tgridmap%mask_dst(no) > 0)) then 
        if ((tgridmap%frac_dst(no) < 0.0) .or. (tgridmap%frac_dst(no) > 1.0001)) then
           write(6,*) "ERROR:: frac out of range: ", tgridmap%frac_dst(no),no
           stop 
        end if
     end if
  end do

  ! Diagnostic output

  write (ndiag,*)
  write (ndiag,'(1x,70a1)') ('=',k=1,70)
  write (ndiag,*) 'Maximum Fractional Saturated Area Output'
  write (ndiag,'(1x,70a1)') ('=',k=1,70)

  write (ndiag,*)
  write (ndiag,'(1x,70a1)') ('.',k=1,70)
  write (ndiag,2001)
2001 format (1x,'surface type   input grid area  output grid area'/ &
             1x,'                 10**6 km**2      10**6 km**2   ')
  write (ndiag,'(1x,70a1)') ('.',k=1,70)
  write (ndiag,*)
  write (ndiag,2002) gfmax_i*1.e-06,gfmax_o*1.e-06
  write (ndiag,2004) garea_i*1.e-06,garea_o*1.e-06
2002 format (1x,'fmax    ',f14.3,f17.3)
2004 format (1x,'all surface ',f14.3,f17.3)

  write (6,*) 'Successfully made %fmax'
  write (6,*)
  call shr_sys_flush(6)

  ! Deallocate dynamic memory

  call domain_clean(tdomain)
  call gridmap_clean(tgridmap)
  deallocate (fmax_i)

end subroutine mkfmax

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mksoilAtt
!
! !INTERFACE:
subroutine mksoilAtt( ncid, dynlanduse, xtype )
!
! !DESCRIPTION:
! add atttributes to output file regarding the soil module
!
! !USES:
  use fileutils  , only : get_filename
  use mkncdio    , only : check_ret, ncd_defvar
  use mkvarpar   
  use mkvarctl   

! !ARGUMENTS:
  implicit none
  include 'netcdf.inc'
  integer, intent(in) :: ncid         ! NetCDF file ID to write out to
  logical, intent(in) :: dynlanduse   ! if dynamic land-use file
  integer, intent(in) :: xtype        ! external type to output real data as
!
! !CALLED FROM:
! subroutine mkfile in module mkfileMod
!
! !REVISION HISTORY:
! Original Author: Erik Kluzek
!
!
! !LOCAL VARIABLES:
!EOP
  integer :: dimid                ! temporary
  character(len=256) :: str       ! global attribute string
  character(len=32) :: subname = 'mksoilAtt'
!-----------------------------------------------------------------------

  if (.not. dynlanduse) then

     ! Define dimensions unique to soil

     call check_ret(nf_def_dim (ncid, 'nlevsoi',  &
                                       nlevsoi    , dimid), subname)

     ! Add global attributes to file

     if ( soil_clay /= unset .and. soil_sand /= unset )then
        str = 'TRUE'
        call check_ret(nf_put_att_text (ncid, NF_GLOBAL, &
             'soil_clay_override', len_trim(str), trim(str)), subname)
        str = 'TRUE'
        call check_ret(nf_put_att_text (ncid, NF_GLOBAL, &
             'soil_sand_override', len_trim(str), trim(str)), subname)
     else
        str = get_filename(mksrf_fsoitex)
        call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
             'Soil_texture_raw_data_file_name', len_trim(str), trim(str)), subname)
     end if
     if ( soil_color /= unsetcol )then
        str = 'TRUE'
        call check_ret(nf_put_att_text (ncid, NF_GLOBAL, &
             'soil_color_override', len_trim(str), trim(str)), subname)
     else
        str = get_filename(mksrf_fsoicol)
        call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
             'Soil_color_raw_data_file_name', len_trim(str), trim(str)), subname)
     end if
     if ( soil_fmax /= unset )then
        str = 'TRUE'
        call check_ret(nf_put_att_text (ncid, NF_GLOBAL, &
             'soil_fmax_override', len_trim(str), trim(str)), subname)
     else
        str = get_filename(mksrf_fmax)
        call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
             'Fmax_raw_data_file_name', len_trim(str), trim(str)), subname)
     end if
     str = get_filename(mksrf_forganic)
     call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
          'Organic_matter_raw_data_file_name', len_trim(str), trim(str)), subname)
     
     ! Define variables

     call ncd_defvar(ncid=ncid, varname='mxsoil_color', xtype=nf_int, &
          long_name='maximum numbers of soil colors', units='unitless')
     
     if (outnc_1d) then
        call ncd_defvar(ncid=ncid, varname='SOIL_COLOR', xtype=nf_int, &
             dim1name='gridcell',&
             long_name='soil color', units='unitless')
     else
        call ncd_defvar(ncid=ncid, varname='SOIL_COLOR', xtype=nf_int, &
             dim1name='lsmlon', dim2name='lsmlat', &
             long_name='soil color', units='unitless')
     end if

     if (outnc_1d) then
        call ncd_defvar(ncid=ncid, varname='PCT_SAND', xtype=xtype, &
             dim1name='gridcell', dim2name='nlevsoi', &
             long_name='percent sand', units='unitless')
     else
        call ncd_defvar(ncid=ncid, varname='PCT_SAND', xtype=xtype, &
             dim1name='lsmlon', dim2name='lsmlat', dim3name='nlevsoi', &
             long_name='percent sand', units='unitless')
     end if

     if (outnc_1d) then
        call ncd_defvar(ncid=ncid, varname='PCT_CLAY', xtype=xtype, &
             dim1name='gridcell', dim2name='nlevsoi', &
             long_name='percent clay', units='unitless')
     else
        call ncd_defvar(ncid=ncid, varname='PCT_CLAY', xtype=xtype, &
             dim1name='lsmlon', dim2name='lsmlat', dim3name='nlevsoi', &
             long_name='percent clay', units='unitless')
     end if

     if (outnc_1d) then
        call ncd_defvar(ncid=ncid, varname='ORGANIC', xtype=xtype, &
             dim1name='gridcell', dim2name='nlevsoi', &
             long_name='organic matter density at soil levels', &
             units='kg/m3 (assumed carbon content 0.58 gC per gOM)')
     else
        call ncd_defvar(ncid=ncid, varname='ORGANIC', xtype=xtype, &
             dim1name='lsmlon', dim2name='lsmlat', dim3name='nlevsoi', &
             long_name='organic matter density at soil levels', &
             units='kg/m3 (assumed carbon content 0.58 gC per gOM)')
     end if

     if (outnc_1d) then
        call ncd_defvar(ncid=ncid, varname='FMAX', xtype=xtype, &
             dim1name='gridcell', &
             long_name='maximum fractional saturated area', units='unitless')
     else
        call ncd_defvar(ncid=ncid, varname='FMAX', xtype=xtype, &
             dim1name='lsmlon', dim2name='lsmlat', &
             long_name='maximum fractional saturated area', units='unitless')
     end if

  end if

end subroutine mksoilAtt

!-----------------------------------------------------------------------

end module mksoilMod

module dimensions

   use shr_kind_mod, only: r8 => shr_kind_r8
   use control,      only: verbose

   implicit none

   private

   public :: info
   public :: maxdims
   public :: is_ewdim, is_nsdim, is_zdim, add_dim, is_ncoldim
   public :: get_dimlen, get_shape
   public :: ewdim, nsdim, zdim, ncoldim
   public :: ewdimi, nsdimi, zdimi
   public :: ncoldimid

   include 'netcdf.inc'

   integer, parameter :: maxdims = 4
   integer            :: ncoldimid = -1

   type info
      character*(nf_max_name) :: dimname
      integer                 :: dimlen
   end type info

   type(info) :: ewdim(maxdims), nsdim(maxdims), zdim(maxdims), ncoldim(maxdims)
   type(info) :: ewdimi(maxdims), nsdimi(maxdims), zdimi(maxdims)

   logical :: init_done = .false.

   character*(nf_max_name) :: ewnames(maxdims)
   character*(nf_max_name) :: nsnames(maxdims)
   character*(nf_max_name) :: znames(maxdims)
   character*(nf_max_name) :: ncolnames(maxdims)

   integer :: newnames, nnsnames, nznames, nncolnames

contains
!-------------------------------------------------------------------------------

subroutine init_dims

   integer :: n

   ewnames(:) = ' '
   nsnames(:) = ' '
   znames(:)  = ' '
   ncolnames(:)  = ' '

   ewnames(1) = 'lon'
   ewnames(2) = 'slon'
   nsnames(1) = 'lat'
   nsnames(2) = 'slat'
   znames(1)  = 'lev'
   znames(2)  = 'ilev'
   ncolnames(1) = 'ncol'

   do n=1,size (ewnames)
      if (ewnames(n) == ' ') exit
   end do
   newnames = n - 1

   do n=1,size (nsnames)
      if (nsnames(n) == ' ') exit
   end do
   nnsnames = n - 1

   do n=1,size (znames)
      if (znames(n) == ' ') exit
   end do
   nznames = n - 1

   do n=1,size (ncolnames)
      if (ncolnames(n) == ' ') exit
   end do
   nncolnames = n - 1

   ewdim(:)%dimname = ' '
   nsdim(:)%dimname = ' '
   zdim(:)%dimname = ' '
   ncoldim(:)%dimname = ' '

   ewdimi(:)%dimname = ' '
   nsdimi(:)%dimname = ' '
   zdimi(:)%dimname = ' '

   init_done = .true.
    
end subroutine init_dims

!-------------------------------------------------------------------------------

logical function is_ewdim (name)

   character*(*) :: name

   integer :: n

   if (.not. init_done) call init_dims
   is_ewdim = .false.

   do n=1,newnames
      if (name == ewnames(n)) then
         is_ewdim = .true.
      end if
   end do

end function is_ewdim

!-------------------------------------------------------------------------------

logical function is_ncoldim (name)

   character*(*) :: name

   integer :: n

   if (.not. init_done) call init_dims
   is_ncoldim = .false.

   do n=1,nncolnames
      if (name == ncolnames(n)) then
         is_ncoldim = .true.
      end if
   end do

end function is_ncoldim

!-------------------------------------------------------------------------------

logical function is_nsdim (name)

   character*(*) :: name

   integer :: n
    
   if (.not. init_done) call init_dims
   is_nsdim = .false.

   do n=1,nnsnames
      if (name == nsnames(n)) then
         is_nsdim = .true.
      end if
   end do

end function is_nsdim

!-------------------------------------------------------------------------------

logical function is_zdim (name)

   character*(*) :: name

   integer :: n
    
   if (.not. init_done) call init_dims
   is_zdim = .false.

   do n=1,nznames
      if (name == znames(n)) then
         is_zdim = .true.
      end if
   end do

end function is_zdim

!-------------------------------------------------------------------------------

subroutine add_dim (arr, dimname, dimlen)
   
   type(info)              :: arr(:)
   character*(nf_max_name) :: dimname
   integer                 :: dimlen
    
   integer :: n

   n = size (arr,1)
   if (arr(n)%dimname(1:1) /= ' ') then
      call err_exit ('add_dim: not enough space allocated for dimension array')
   end if

   ! Postition array arr at first empty slot.
   ! If dimension name is already in arr then stop with error.
   do n = 1, size(arr, 1)
      if (arr(n)%dimname(1:1) == ' ') then
         exit
      else if (trim(arr(n)%dimname) == trim(dimname)) then
         write(6,*)'add_dim: ', trim(dimname), ' already exists'
         stop 999
      end if
   end do

   ! Add dimension name/size to arr
   arr(n)%dimname = trim(dimname)
   arr(n)%dimlen = dimlen

   if (verbose) then
      write(6,*)'add_dim: ', trim(dimname), dimlen
   end if

end subroutine add_dim

!-------------------------------------------------------------------------------

integer function get_dimlen (arr, dimname)

   type(info) :: arr(:)
   character*(nf_max_name) :: dimname

   integer :: n

   do n=1,size (arr,1)
      if (arr(n)%dimname == dimname) then
         get_dimlen = arr(n)%dimlen
         return
      end if
   end do

   write(6,*) 'WARNING: get_dimlen: dimname ',trim(dimname), ' not found'
   get_dimlen=-1
    
end function get_dimlen

!-------------------------------------------------------------------------------

character*8 function get_shape (ncid, vardids, nvdims, dimnames)

   integer, intent(in) :: ncid
   integer, intent(in) :: vardids(nf_max_var_dims) ! variable dimension id's
   integer, intent(in) :: nvdims

   character*(nf_max_name), intent(out) :: dimnames(4)

   ! If a time dimension is present we assume that it's the last dimension.
   ! In that case the dimension name is returned in dimnames, but the shape
   ! is determined by the leading spatial dimensions.

   dimnames(:) = ' '

   if (nvdims > 0) call wrap_inq_dimname(ncid, vardids(1), dimnames(1))
   if (nvdims > 1) call wrap_inq_dimname(ncid, vardids(2), dimnames(2))
   if (nvdims > 2) call wrap_inq_dimname(ncid, vardids(3), dimnames(3))
   if (nvdims > 3) call wrap_inq_dimname(ncid, vardids(4), dimnames(4))

   get_shape = 'unknown'

   if ( is_ncoldim (dimnames(1) ) ) then
      if(is_zdim (dimnames(2))) then
         get_shape='nz'
      else
         get_shape='n'
      end if
   else if (     is_ewdim (dimnames(1)) .and. is_nsdim (dimnames(2)) .and. &
      .not. is_zdim (dimnames(3))) then

      get_shape = 'xy'

   else if (is_ewdim (dimnames(1)) .and. is_nsdim (dimnames(2)) .and. &
            is_zdim (dimnames(3))) then

      get_shape = 'xyz'

   else if (is_ewdim (dimnames(1)) .and. is_zdim  (dimnames(2)) .and. &
             is_nsdim (dimnames(3))) then

      get_shape = 'xzy'

   end if

end function get_shape

end module dimensions

module mkglcmecMod
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: mkglcmecMod
!
! !DESCRIPTION:
! Make glacier multi-elevation class  data
!
! !REVISION HISTORY:
! Author: Erik Kluzek, Mariana Vertenstein
!
!-----------------------------------------------------------------------
!!USES:
  use shr_kind_mod, only : r8 => shr_kind_r8
  use shr_sys_mod , only : shr_sys_flush
  use mkdomainMod , only : domain_checksame
  implicit none

  private           ! By default make data private
!
! !PUBLIC MEMBER FUNCTIONS:
!
  public mkglcmecInit  ! Initialization
  public mkglcmec      ! Set glacier multi-elevation class
  public mkglacier     ! Set percent glacier
!
! !PUBLIC DATA MEMBERS: 
!
  integer, public       :: nglcec         = 10   ! number of elevation classes for glaciers
  real(r8), pointer     :: elevclass(:)          ! elevation classes
!EOP
!===============================================================
contains
!===============================================================

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkglcmecInit
!
! !INTERFACE:
subroutine mkglcmecInit( elevclass_o )
!
! !DESCRIPTION:
! Initialize of Make glacier multi-elevation class data
! !USES:
!
! !ARGUMENTS:
  implicit none
  real(r8), intent(OUT) :: elevclass_o(:)          ! elevation classes
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!
! !LOCAL VARIABLES:
!EOP
  character(len=32) :: subname = 'mkglcmecInit:: '
!-----------------------------------------------------------------------
  allocate( elevclass(nglcec+1) )

  ! -----------------------------------------------------------------
  ! Define elevation classes, represents lower boundary of each class
  ! -----------------------------------------------------------------

  if (      nglcec == 36 )then
     elevclass(:) = (/ 0.,   200.,   400.,   600.,   800.,  &
                    1000.,  1200.,  1400.,  1600.,  1800.,  &
                    2000.,  2200.,  2400.,  2600.,  2800.,  &
                    3000.,  3200.,  3400.,  3600.,  3800.,  &
                    4000.,  4200.,  4400.,  4600.,  4800.,  &
                    5000.,  5200.,  5400.,  5600.,  5800.,  &
                    6000.,  6200.,  6400.,  6600.,  6800.,  &
                    7000., 10000./)
  else if ( nglcec == 10 )then
     elevclass(1)  =     0.
     elevclass(2)  =   200.
     elevclass(3)  =   400.
     elevclass(4)  =   700.
     elevclass(5)  =  1000.
     elevclass(6)  =  1300.
     elevclass(7)  =  1600.
     elevclass(8)  =  2000.
     elevclass(9)  =  2500.
     elevclass(10) =  3000.
     elevclass(11) = 10000.
  else if ( nglcec == 5  )then
     elevclass(1)  =     0.
     elevclass(2)  =   500.
     elevclass(3)  =  1000.
     elevclass(4)  =  1500.
     elevclass(5)  =  2000.
     elevclass(6)  = 10000.
  else if ( nglcec == 3  )then
     elevclass(1)  =     0.
     elevclass(2)  =  1000.
     elevclass(3)  =  2000.
     elevclass(4)  = 10000.
  else if ( nglcec == 1  )then
     elevclass(1)  =     0.
     elevclass(2)  = 10000.
  else if ( nglcec == 0  )then
     elevclass(1)  = 10000.
  else
     write(6,*) subname//"ERROR:: nglcec must be 0, 1, 3, 5, 10 or 36",&
          " to work with CLM: "
     call abort()
  end if

  elevclass_o(:) = elevclass(:)

end subroutine mkglcmecInit

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkglcmec
!
! !INTERFACE:
subroutine mkglcmec(ldomain, mapfname, &
                    datfname_fglacier, ndiag, &
                    pctglac_o, pctglac_o_uncorrected, &
                    pctglcmec_o, topoglcmec_o, &
                    pctglcmec_gic_o, pctglcmec_icesheet_o, &
                    pctglc_gic_o, pctglc_icesheet_o)
!
! !DESCRIPTION: 
! make percent glacier on multiple elevation classes, mean elevation for each
! elevation class, and associated fields
! 
! Note that the raw glacier data are specified by level, and thus implicitly include the
! necessary topo data for breaking pct glacier into elevation classes. Each level in the
! input data is assigned to an elevation (given by BIN_CENTERS in the input data). Thus,
! all of the input glacier in level 1 is treated as being at the same elevation, and
! likewise for each other level. These elevations are then used in assigning pct_glacier
! to the appropriate elevation class in the output data, as well as determining the mean
! topographic height of each elevation class in the output data.
!
! Does nothing if nglcec==0.
!
! !USES:
  use mkdomainMod, only : domain_type, domain_clean, domain_read
  use mkgridmapMod
  use mkvarpar	
  use mkutilsMod, only : slightly_below, slightly_above
  use mkncdio
!
! !ARGUMENTS:
  implicit none
  type(domain_type) , intent(in) :: ldomain
  character(len=*)  , intent(in) :: mapfname           ! input mapping file name
  character(len=*)  , intent(in) :: datfname_fglacier  ! raw glacier data
  integer           , intent(in) :: ndiag              ! unit number for diag out
  real(r8)          , intent(in) :: pctglac_o(:)       ! % glac on output glacier grid
  real(r8)          , intent(in) :: pctglac_o_uncorrected(:) ! % glac on output glacier grid, before any corrections were done
  real(r8)          , intent(out):: pctglcmec_o (:,:)  ! % for each elevation class on output glacier grid
  real(r8)          , intent(out):: topoglcmec_o(:,:)  ! mean elevation for each elevation classs on output glacier grid
  real(r8)          , intent(out):: pctglcmec_gic_o(:,:)      ! % glc gic on output grid, by elevation class
  real(r8)          , intent(out):: pctglcmec_icesheet_o(:,:) ! % glc ice sheet on output grid, by elevation class
  real(r8)          , intent(out):: pctglc_gic_o(:)           ! % glc gic on output grid, summed across elevation classes
  real(r8)          , intent(out):: pctglc_icesheet_o(:)      ! % glc ice sheet on output grid, summed across elevation classes
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: David Lawrence
! 7/12/11: Bill Sacks: substantial rewrite to use input topo and % glacier at same resolution
! 9/25/12: Bill Sacks: substantial rewrite to use new format of fglacier, which provides
!          percent by elevation bin (thus the separate topo dataset is no longer needed
!          in this routine)
!
!
! !LOCAL VARIABLES:
!EOP
  type(domain_type)     :: tdomain              ! local domain
  type(gridmap_type)    :: tgridmap             ! local gridmap
  real(r8), allocatable :: pctglc_gic_i(:)      ! input GIC percentage for a single level
  real(r8), allocatable :: pctglc_icesheet_i(:) ! input icesheet percentage for a single level
  real(r8), allocatable :: topoglcmec_unnorm_o(:,:) ! same as topoglcmec_o, but unnormalized
  real(r8) :: topoice_i                         ! topographic height of this level
  real(r8) :: pctglc_i                          ! input total pct glacier for a single level & single point
  real(r8) :: wt, frac                          ! weighting factors for remapping
  integer  :: ndims                             ! number of dimensions in input variables
  integer  :: dim_lengths(nf_max_var_dims)      ! lengths of dimensions in input variables
  integer, allocatable :: starts(:), counts(:)  ! start indices & counts for reading variable slices
  integer  :: ni,no,ns_o,nst,lev                ! indices
  integer  :: n,m                               ! indices
  integer  :: ncid,dimid,varid                  ! input netCDF id's
  integer  :: nlev                              ! number of levels in input file
  real(r8) :: glc_sum                           ! temporary
  integer  :: ier                               ! error status
  logical  :: errors                            ! error status
  real(r8), parameter :: minglac = 1.e-6_r8     ! Minimum glacier amount
  character(len=32) :: subname = 'mkglcmec'
!-----------------------------------------------------------------------

  ! Initialize all output fields to zero

  pctglcmec_o(:,:)          = 0.
  topoglcmec_o(:,:)         = 0.
  pctglcmec_gic_o(:,:)      = 0.
  pctglcmec_icesheet_o(:,:) = 0.
  pctglc_gic_o(:)           = 0.
  pctglc_icesheet_o(:)      = 0.

  ! Set number of output points

  ns_o = ldomain%ns

  ! -----------------------------------------------------------------
  ! Exit early, if no glaciers exist
  ! -----------------------------------------------------------------
  if ( all(pctglac_o < minglac ) )then
     write (6,*) 'No glaciers exist, set glcmec to zero as well'
     return
  end if

  if ( nglcec == 0 )then
     write (6,*) 'Number of glacier elevation classes is zero ',&
          '-- set glcmec to zero as well'
     call shr_sys_flush(6)
     return
  end if

  write (6,*) 'Attempting to make percent elevation class ',&
       'and mean elevation for glaciers .....'
  call shr_sys_flush(6)

  ! -----------------------------------------------------------------
  ! Read domain and dimension information from glacier raw data file
  ! -----------------------------------------------------------------

  call domain_read(tdomain,datfname_fglacier)
  nst = tdomain%ns

  ! Read z dimension size
  write (6,*) 'Open glacier file: ', trim(datfname_fglacier)
  call check_ret(nf_open(datfname_fglacier, 0, ncid), subname)
  ier = nf_inq_dimid (ncid, 'z', dimid)
  if (ier /= NF_NOERR) then
     write (6,*) trim(subname), ' ERROR: z dimension not found on glacier file:'
     write (6,*) trim(datfname_fglacier)
     write (6,*) 'Perhaps you are trying to use an old-format glacier file?'
     write (6,*) '(prior to Sept., 2012)'
     call abort()
  end if
  call check_ret(nf_inq_dimlen (ncid, dimid, nlev), subname)

  ! -----------------------------------------------------------------
  ! Read mapping data, check for consistency with domains
  ! -----------------------------------------------------------------

  ! Mapping for raw glacier -> model output grid
  call gridmap_mapread(tgridmap, mapfname )

  ! Error checks for domain and map consistencies
  call domain_checksame( tdomain, ldomain, tgridmap )

  ! -----------------------------------------------------------------
  ! Determine dimension lengths and create start & count arrays
  ! for later reading one level at a time
  ! -----------------------------------------------------------------

  call get_dim_lengths(ncid, 'PCT_GLC_GIC', ndims, dim_lengths)

  allocate(starts(ndims), counts(ndims), stat=ier)
  if (ier/=0) call abort()

  starts(1:ndims) = 1

  ! We assume that the last dimension is the level dimension
  counts(1:ndims-1) = dim_lengths(1:ndims-1)
  counts(ndims) = 1

  ! -------------------------------------------------------------------- 
  ! Compute fields on the output grid
  ! -------------------------------------------------------------------- 

  allocate(pctglc_gic_i(nst), pctglc_icesheet_i(nst), stat=ier)
  if (ier/=0) call abort()

  allocate(topoglcmec_unnorm_o(ns_o,nglcec), stat=ier)
  if (ier/=0) call abort()

  topoglcmec_unnorm_o(:,:) = 0.

  write(6,'(a)',advance='no') 'Level: '
  do lev = 1, nlev
     write(6,'(i4)',advance='no') lev

     ! Read this level's data
     ! We assume that the last dimension is the level dimension
     starts(ndims) = lev
     call check_ret(nf_inq_varid (ncid, 'BIN_CENTERS', varid), subname)
     call check_ret(nf_get_vara_double (ncid, varid, (/lev/), (/1/), topoice_i), subname)
     call check_ret(nf_inq_varid (ncid, 'PCT_GLC_GIC', varid), subname)
     call check_ret(nf_get_vara_double (ncid, varid, starts, counts, pctglc_gic_i), subname)
     call check_ret(nf_inq_varid (ncid, 'PCT_GLC_ICESHEET', varid), subname)
     call check_ret(nf_get_vara_double (ncid, varid, starts, counts, pctglc_icesheet_i), subname)
     
     ! Determine elevation class
     m = get_elevclass(topoice_i)
     if (m < 1 .or. m > nglcec) then 
        call abort()
     end if

     do n = 1,tgridmap%ns
        ni = tgridmap%src_indx(n)
        no = tgridmap%dst_indx(n)
        wt = tgridmap%wovr(n)

        ! fraction of this destination cell that is covered by source cells that are within the source landmask
        frac = tgridmap%frac_dst(no)

        ! We don't bother with the following if pctglac_o(no) <= minglac, because the
        ! pctglcmec_o values will end up being <= minglac.
        ! Also, if frac == 0, then we can't do this, to avoid divide by 0. In this case, the
        ! outputs remain equal to 0 (their initialized value).
        if (pctglac_o(no) > minglac .and. frac > 0) then
           pctglc_i = pctglc_gic_i(ni) + pctglc_icesheet_i(ni)
           pctglcmec_o(no,m)          = pctglcmec_o(no,m)          + wt*pctglc_i / frac
           pctglcmec_gic_o(no,m)      = pctglcmec_gic_o(no,m)      + wt*pctglc_gic_i(ni) / frac
           pctglcmec_icesheet_o(no,m) = pctglcmec_icesheet_o(no,m) + wt*pctglc_icesheet_i(ni) / frac

           ! note that, by weighting the following by pctglc_i, we are getting something
           ! like the average topographic height over glaciated areas - NOT the average
           ! topographic height of the entire grid cell
           topoglcmec_unnorm_o(no,m) = topoglcmec_unnorm_o(no,m) + wt*pctglc_i*topoice_i / frac
        end if
     end do
  end do

  ! advance to next line (needed because of 'advance=no' writes above)
  write(6,*) ' ' 

  ! Close glacier input file
  call check_ret(nf_close(ncid), subname)

  ! Now pctglcmec_o, pctglcmec_gic_o and pctglcmec_icesheet_o are already normalized
  ! appropriately, because for destarea normalization, the sum of the wovr values for a
  ! given destination grid cell should equal frac_dst, so sum(wt/frac) = 1 for each
  ! destination grid cell.
  !
  ! However, we need to normalize topoglcmec_o. To do this, note that pctglcmec_o(n,m) is
  ! equal to the sum of the weights used in doing the weighted average of topoice_i
  ! (weight = wt*pctglc_i/frac); hence pctglcmec_o(n,m) is the correct normalization
  ! factor
  do no = 1,ns_o
     do m = 1,nglcec
        if (pctglcmec_o(no,m) > 0) then
           topoglcmec_o(no,m) = topoglcmec_unnorm_o(no,m) / pctglcmec_o(no,m)
        end if

        ! Correct for rounding errors that put topoglcmec_o(no,m) slightly outside the
        ! allowed bounds for this elevation class
        if (slightly_below(topoglcmec_o(no,m), elevclass(m))) then
           write(6,*) 'Warning: topoglcmec_o was slightly lower than lower bound; setting equal&
                & to lower bound; for: ', no, m, topoglcmec_o(no,m), elevclass(m)
           write(6,*) '(this is informational only, and probably just indicates rounding error)'
           topoglcmec_o(no,m) = elevclass(m)
        else if (slightly_above(topoglcmec_o(no,m), elevclass(m+1))) then
           write(6,*) 'Warning: topoglcmec_o was slightly higher than upper bound; setting equal&
                & to upper bound; for: ', no, m, topoglcmec_o(no,m), elevclass(m+1)
           write(6,*) '(this is informational only, and probably just indicates rounding error)'
           topoglcmec_o(no,m) = elevclass(m+1)
        end if
     end do
  end do

  ! We want the sum of pctglcmec_o across elevation classes to equal pctglac_o for each
  ! grid cell. This should be approximately true at this point, but there have been a
  ! number of adjustments to pctglac_o since its original remapping (e.g., setting values
  ! < 1 to 0, and rescaling all percentages so that the total landcover is equal to
  ! 100%). We need to essentially apply these same adjustments to pctglcmec_o.
  ! 
  ! To do this, we use the stored, uncorrected values of pctglac_o. In theory, we could do
  ! this renormalization without reference to these uncorrected values, since
  ! pctglac_o_uncorrected should equal the sum of pctglcmec_o across elevation classes for
  ! each grid cell. However, pctglac_o_uncorrected is helpful for error checking: it
  ! allows us to verify that the pctglcmec sums are correct (this check is done below).
  ! 
  ! Here we also rescale pctglcmec_gic_o and pctglcmec_icesheet_o similarly, to
  ! achieve the same thing (i.e., we want sums to add up to pct_glacier)
  do no = 1,ns_o
     if (pctglac_o_uncorrected(no) > 0) then
        pctglcmec_o(no,:)          = pctglcmec_o(no,:)          * (pctglac_o(no) / pctglac_o_uncorrected(no))
        pctglcmec_gic_o(no,:)      = pctglcmec_gic_o(no,:)      * (pctglac_o(no) / pctglac_o_uncorrected(no))
        pctglcmec_icesheet_o(no,:) = pctglcmec_icesheet_o(no,:) * (pctglac_o(no) / pctglac_o_uncorrected(no))

     else if (pctglac_o_uncorrected(no) == 0 .and. pctglac_o(no) > 0) then
        ! There isn't a clear way to handle the case when pctglac_o_uncorrected==0 (and
        ! hence pctglcmec_o==0 for all elevation classes) but pctglac_o==0. Fortunately,
        ! this should never happen: the only place where there is a potential for this is
        ! over the south pole, where pctglac_o is set to 100%.

        write(6,*) 'ERROR in ', subname
        write(6,*) 'pctglac_o_uncorrected==0 but pctglac_o > 0'
        write(6,*) 'no = ', no
        write(6,*) 'lon = ', tgridmap%xc_dst(no)
        write(6,*) 'lat = ', tgridmap%yc_dst(no)
        call abort()
     end if

     ! The only other possibility is that (pctglac_o_uncorrected(no) == 0 .and.
     ! pctglac_o(no) == 0); but in this case, all pctglcmec_o(no,:) values should be 0
     ! and can remain 0 (and similarly for pctglc_gic, pctglc_icesheet, etc.)
  end do

  ! Set pctglc_gic_o to sum of pctglcmec_gic_o across elevation classes, and similarly for pctglc_icesheet_o
  pctglc_gic_o      = sum(pctglcmec_gic_o, dim=2)
  pctglc_icesheet_o = sum(pctglcmec_icesheet_o, dim=2)

  ! -------------------------------------------------------------------- 
  ! Perform various sanity checks
  ! -------------------------------------------------------------------- 

  errors = .false.

  ! Check that sum over pctglcmec_o (from 1 to nglcec) is equal to pctglac_o(no)
  !
  ! Note: We use a threshold of 2e-5 rather than 1e-6 or smaller because there is single-
  ! precision roundoff error in the storage of the flat (i.e., non-multi-level)
  ! PCT_GLACIER variable on the input dataset (which is used to compute pctglac_o) (since
  ! the input dataset uses single-precision floats)
  do no = 1,ns_o
     glc_sum = 0.
     do m = 1,nglcec
        glc_sum = glc_sum + pctglcmec_o(no,m)
     end do
     if (abs(glc_sum - pctglac_o(no)) > 2.e-5) then
        write(6,*)'no,pctglc,pctglac= ',no,glc_sum,pctglac_o(no)
        errors = .true.
     end if
  end do

  ! Check that GIC + ICESHEET = total glacier, for variables summed over elevation classes
  !
  ! Note: We use a threshold of 2e-5 rather than 1e-6 or smaller because there is single-
  ! precision roundoff error in the storage of the flat (i.e., non-multi-level)
  ! PCT_GLACIER variable on the input dataset (which is used to compute pctglac_o) (since
  ! the input dataset uses single-precision floats)
  do no = 1,ns_o
     if (abs((pctglc_gic_o(no) + pctglc_icesheet_o(no)) - pctglac_o(no)) > 2.e-5) then
        write(6,*)'no,pctglc_gic,pctglc_icesheet,pctglac,pctglac_uncorrected,lon,lat=',no,pctglc_gic_o(no),&
             pctglc_icesheet_o(no),pctglac_o(no),pctglac_o_uncorrected(no),tgridmap%&
             xc_dst(no),tgridmap%yc_dst(no)
        errors = .true.
     end if
  end do

  ! Check that GIC + ICESHEET = total glacier, for each elevation class
  do m = 1,nglcec
     do no = 1,ns_o
        if (abs((pctglcmec_gic_o(no,m) + pctglcmec_icesheet_o(no,m)) - pctglcmec_o(no,m)) > 1.e-6) then
           write(6,*)'no,m,pctglcmec_gic,pctglcmec_icesheet,pctglcmec,lat,lon=',no,m,&
                pctglcmec_gic_o(no,m),pctglcmec_icesheet_o(no,m),pctglcmec_o(no,m),&
                tgridmap%xc_dst(no),tgridmap%yc_dst(no)
           errors = .true.
        end if
     end do
  end do

  ! Error check: are all elevations within elevation class range
  do no = 1,ns_o
     if (pctglac_o(no) .gt. minglac) then 
        do m = 1,nglcec
           ! WJS (7-12-11): the original check was ((topo outside range) and (topo .ne.
           ! 0)). I think that the second condition is meant to essentially check whether
           ! pctglcmec_o(no,m) > 0. So I think we could just check whether ((topo outside
           ! range) and (pctglcmec_o(no,m) > 0). However, I am keeping a warning message
           ! if ((topo outside range) and (topo .ne. 0)) as well, because I don't want to
           ! get rid of error checks.
           if ( (topoglcmec_o(no,m) .lt. elevclass(m) .or. topoglcmec_o(no,m) .gt. elevclass(m+1)) &
                .and. (pctglcmec_o(no,m) .gt. 0 .or. topoglcmec_o(no,m) .ne. 0)) then
              write(6,*) 'Error: mean elevation does not fall within elevation class '
              write(6,*) elevclass(m),elevclass(m+1),topoglcmec_o(no,m),pctglcmec_o(no,m),m,no
              errors = .true.
           endif
        end do
     end if
  end do

  if (errors) then
     call abort()
  end if

  ! Deallocate dynamic memory

  call domain_clean(tdomain)
  call gridmap_clean(tgridmap)
  deallocate(pctglc_gic_i, pctglc_icesheet_i)
  deallocate(topoglcmec_unnorm_o)
  deallocate(starts, counts)

  write (6,*) 'Successfully made percent elevation class and mean elevation for glaciers'
  write (6,*)
  call shr_sys_flush(6)

end subroutine mkglcmec

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkglacier
!
! !INTERFACE:
subroutine mkglacier(ldomain, mapfname, datfname, ndiag, zero_out, glac_o, glac_uncorrected)
!
! !DESCRIPTION:
! make percent glacier
!
! In contrast to mkglcmec, this uses a "flat" PCT_GLACIER field (not separated by
! elevation class, and not separated into icesheet vs GIC). 
!
! This simpler routine is sufficient for cases when we run without multiple elevation
! classes. This routine is also used when running with multiple elevation classes: we
! first regrid the flat PCT_GLACIER field, then later create the multiple elevation class
! data. This multi-step process makes it easier to do corrections on the total
! PCT_GLACIER, and make sure these corrections apply appropriately to the multi-level
! output. The assumption is that PCT_GLACIER is the sum of both PCT_GLC_GIC and
! PCT_GLC_ICESHEET across all elevation bins.
!
! !USES:
  use mkdomainMod , only : domain_type, domain_clean, domain_read
  use mkgridmapMod
  use mkvarpar	
  use mkvarctl    
  use mkncdio
!
! !ARGUMENTS:
  implicit none
  type(domain_type), intent(in) :: ldomain
  character(len=*)  , intent(in) :: mapfname  ! input mapping file name
  character(len=*)  , intent(in) :: datfname  ! input data file name
  integer           , intent(in) :: ndiag     ! unit number for diag out
  logical           , intent(in) :: zero_out  ! if should zero glacier out
  real(r8)          , intent(out):: glac_o(:) ! output grid: %glacier
  real(r8)          , intent(out):: glac_uncorrected(:) ! output grid: %glacier before any
                                                        ! corrections are done
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Mariana Vertenstein
!
!
! !LOCAL VARIABLES:
!EOP
  type(gridmap_type)   :: tgridmap
  type(domain_type)    :: tdomain            ! local domain
  real(r8), allocatable :: glac_i(:)          ! input grid: percent glac
  real(r8) :: sum_fldi                        ! global sum of dummy input fld
  real(r8) :: sum_fldo                        ! global sum of dummy output fld
  real(r8) :: gglac_i                         ! input  grid: global glac
  real(r8) :: garea_i                         ! input  grid: global area
  real(r8) :: gglac_o                         ! output grid: global glac
  real(r8) :: garea_o                         ! output grid: global area
  integer  :: ni,no,k,n,m,ns                  ! indices
  integer  :: ncid,dimid,varid                ! input netCDF id's
  integer  :: ier                             ! error status
  real(r8) :: relerr = 0.00001                ! max error: sum overlap wts ne 1
  character(len=32) :: subname = 'mkglacier'
!-----------------------------------------------------------------------

  write (6,*) 'Attempting to make %glacier .....'
  call shr_sys_flush(6)

  ! -----------------------------------------------------------------
  ! Read input file
  ! -----------------------------------------------------------------

  ! Obtain input grid info, read local fields

  call domain_read(tdomain,datfname)
  ns = tdomain%ns
  allocate(glac_i(ns), stat=ier)
  if (ier/=0) call abort()

  write (6,*) 'Open glacier file: ', trim(datfname)
  call check_ret(nf_open(datfname, 0, ncid), subname)
  call check_ret(nf_inq_varid (ncid, 'PCT_GLACIER', varid), subname)
  call check_ret(nf_get_var_double (ncid, varid, glac_i), subname)
  call check_ret(nf_close(ncid), subname)

  ! Area-average percent cover on input grid to output grid 
  ! and correct according to land landmask
  ! Note that percent cover is in terms of total grid area.

  if ( zero_out )then

     do no = 1, ldomain%ns
        glac_o(no) = 0.
     enddo

  else

     call gridmap_mapread(tgridmap, mapfname )

     ! Error checks for domain and map consistencies
     call domain_checksame( tdomain, ldomain, tgridmap )
     
     ! Determine glac_o on output grid

     call gridmap_areaave(tgridmap, glac_i, glac_o)
     
     ! Save a copy of glac_o before any corrections are done. This is needed for
     ! normalization in mkglcmec
     glac_uncorrected(:) = glac_o(:)

     do no = 1, ldomain%ns
        if (glac_o(no) < 1.) glac_o(no) = 0.
     enddo
  end if

  ! Check for conservation

  do no = 1, ldomain%ns
     if ((glac_o(no)) > 100.000001_r8) then
        write (6,*) 'MKGLACIER error: glacier = ',glac_o(no), &
                ' greater than 100.000001 for column, row = ',no
        call shr_sys_flush(6)
        stop
     end if
  enddo

  ! Some error checking and writing of global values before and after the regrid

  if ( .not. zero_out )then

     ! Global sum of output field -- must multiply by fraction of
     ! output grid that is land as determined by input grid

     sum_fldi = 0.0_r8
     do ni = 1, tdomain%ns
        sum_fldi = sum_fldi + tgridmap%area_src(ni) * tgridmap%frac_src(ni)
     enddo

     sum_fldo = 0.
     do no = 1, ldomain%ns
        sum_fldo = sum_fldo + tgridmap%area_dst(no) * tgridmap%frac_dst(no)
     end do

     ! -----------------------------------------------------------------
     ! Error check1
     ! Compare global sum fld_o to global sum fld_i.
     ! -----------------------------------------------------------------

     if ( trim(mksrf_gridtype) == 'global') then
        if ( abs(sum_fldo/sum_fldi-1.) > relerr ) then
           write (6,*) 'MKGLACIER error: input field not conserved'
           write (6,'(a30,e20.10)') 'global sum output field = ',sum_fldo
           write (6,'(a30,e20.10)') 'global sum input  field = ',sum_fldi
           stop
        end if
     end if

     ! -----------------------------------------------------------------
     ! Error check2
     ! Compare global areas on input and output grids
     ! -----------------------------------------------------------------

     ! Input grid

     gglac_i = 0.
     garea_i = 0.
     do ni = 1, tdomain%ns
        garea_i = garea_i + tgridmap%area_src(ni)*re**2
        gglac_i = gglac_i + glac_i(ni)*(tgridmap%area_src(ni)/100.)*&
                                        tgridmap%frac_src(ni)*re**2
     end do

     ! Output grid

     gglac_o = 0.
     garea_o = 0.
     do no = 1, ldomain%ns
        garea_o = garea_o + tgridmap%area_dst(no)*re**2
        gglac_o = gglac_o + glac_o(no)*(tgridmap%area_dst(no)/100.)*&
                                        tgridmap%frac_dst(no)*re**2
     end do

     ! Diagnostic output

     write (ndiag,*)
     write (ndiag,'(1x,70a1)') ('=',k=1,70)
     write (ndiag,*) 'Glacier Output'
     write (ndiag,'(1x,70a1)') ('=',k=1,70)

     write (ndiag,*)
     write (ndiag,'(1x,70a1)') ('.',k=1,70)
     write (ndiag,2001)
2001 format (1x,'surface type   input grid area  output grid area'/ &
             1x,'                 10**6 km**2      10**6 km**2   ')
     write (ndiag,'(1x,70a1)') ('.',k=1,70)
     write (ndiag,*)
     write (ndiag,2002) gglac_i*1.e-06,gglac_o*1.e-06
     write (ndiag,2004) garea_i*1.e-06,garea_o*1.e-06
2002 format (1x,'glaciers    ',f14.3,f17.3)
2004 format (1x,'all surface ',f14.3,f17.3)

  end if

  ! Deallocate dynamic memory

  call domain_clean(tdomain) 
  if ( .not. zero_out )then
     call gridmap_clean(tgridmap)
     deallocate (glac_i)
  end if

  write (6,*) 'Successfully made %glacier'
  write (6,*)
  call shr_sys_flush(6)

end subroutine mkglacier

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: get_elevclass
!
! !INTERFACE:
integer function get_elevclass(topo, writewarn)
!
! !DESCRIPTION:
! Returns elevation class index (1..nglcec) given the topographic height.
! If topo is lower than the lowest elevation class, returns 0.
! If topo is higher than the highest elevation class, returns (nglcec+1).
! In either of the two latter cases, the function also writes a warning message, unless
! writewarn is present and false.
!
! !ARGUMENTS:
   implicit none
   real(r8), intent(in) :: topo  ! topographic height (m)
   logical, intent(in), optional :: writewarn  ! should warning messages be written? (default: true)
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
! !LOCAL VARIABLES:
!EOP
   integer :: m
   logical :: my_writewarn
   character(len=32) :: subname = 'mkglcmec'
!-----------------------------------------------------------------------
   
   if (present(writewarn)) then
      my_writewarn = writewarn
   else
      my_writewarn = .true.
   end if

   if (topo < elevclass(1)) then
      if (my_writewarn) then
         write(6,*) 'WARNING in ', trim(subname)
         write(6,*) 'topo out of bounds'
         write(6,*) 'topo = ', topo
         write(6,*) 'elevclass(1) = ', elevclass(1)
      end if
      get_elevclass = 0
      return
   end if
   
   do m = 1, nglcec
      if (topo < elevclass(m+1)) then
         ! note that we already know that topo >= elevclass(m), otherwise we would have
         ! returned earlier
         get_elevclass = m
         return
      end if
   end do

   if (my_writewarn) then
      write(6,*) 'WARNING in ', trim(subname)
      write(6,*) 'topo out of bounds'
      write(6,*) 'topo = ', topo
      write(6,*) 'elevclass(nglcec+1) = ', elevclass(nglcec+1)
   end if
   get_elevclass = nglcec+1

end function get_elevclass
         
!-----------------------------------------------------------------------

end module mkglcmecMod

module mkvarctl

!-----------------------------------------------------------------------
!BOP
!
! !MODULE: mkvarctl
!
! !DESCRIPTION:
! Module containing control variables
!
! !USES:
  use shr_kind_mod, only: r8 => shr_kind_r8
!
! !PUBLIC TYPES:
  implicit none
  private
  save
!
  real(r8), public, parameter :: spval = 1.e36    ! special value

  logical, public    :: outnc_large_files     ! output files in 64-bit format for large files
  logical, public    :: outnc_double          ! output ALL data in files as 64-bit
  integer, public    :: outnc_dims = 2        ! only applicable to lat/lon grids
  logical, public    :: outnc_1d              ! true => output file is 1d  

  character(len= 32), public :: mksrf_gridnm   = ' '  ! name of grid to use on output file
  character(len=256), public :: mksrf_fgrid    = ' '  ! land grid file name to use 
  character(len=256), public :: mksrf_gridtype = ' '  ! land gridtype, global or reg
  character(len=256), public :: mksrf_fvegtyp  = ' '  ! vegetation data file name
  character(len=256), public :: mksrf_fsoitex  = ' '  ! soil texture data file name
  character(len=256), public :: mksrf_forganic = ' '  ! organic matter data file name
  character(len=256), public :: mksrf_fsoicol  = ' '  ! soil color data file name
  character(len=256), public :: mksrf_flakwat  = ' '  ! inland lake data file name
  character(len=256), public :: mksrf_fwetlnd  = ' '  ! inland wetlands data file name
  character(len=256), public :: mksrf_furban   = ' '  ! urban data file name
  character(len=256), public :: mksrf_firrig   = ' '  ! irrigated area data file name
  character(len=256), public :: mksrf_fglacier = ' '  ! glacier data file name
  character(len=256), public :: mksrf_furbtopo = ' '  ! urban topography data file name
  character(len=256), public :: mksrf_flndtopo = ' '  ! land topography data file name
  character(len=256), public :: mksrf_fmax     = ' '  ! fmax data file name
  character(len=256), public :: mksrf_flai     = ' '  ! lai data filename
  character(len=256), public :: mksrf_fdynuse  = ' '  ! ascii file containing names of dynamic land use files
  character(len=256), public :: mksrf_fvocef   = ' '  ! VOC Emission Factor data file name

  integer           , public :: numpft         = 16   ! number of plant types

  character(len=256), public :: map_fpft        = ' ' ! Mapping file for PFT
  character(len=256), public :: map_flakwat     = ' ' ! Mapping file for lake water
  character(len=256), public :: map_fwetlnd     = ' ' ! Mapping file for wetland water
  character(len=256), public :: map_fglacier    = ' ' ! Mapping file for glacier
  character(len=256), public :: map_fsoitex     = ' ' ! Mapping file for soil texture
  character(len=256), public :: map_fsoicol     = ' ' ! Mapping file for soil color
  character(len=256), public :: map_furban      = ' ' ! Mapping file for urban
  character(len=256), public :: map_furbtopo    = ' ' ! Mapping file for urban topography
  character(len=256), public :: map_flndtopo    = ' ' ! Mapping file for land topography
  character(len=256), public :: map_fmax        = ' ' ! Mapping file for soil frac max
  character(len=256), public :: map_forganic    = ' ' ! Mapping file for organic soil
  character(len=256), public :: map_fvocef      = ' ' ! Mapping file for VOC emission factors
  character(len=256), public :: map_flai        = ' ' ! Mapping file for LAI
  character(len=256), public :: map_fharvest    = ' ' ! Mapping file for harvesting
  character(len=256), public :: map_firrig      = ' ' ! Mapping file for irrigation
!
! Variables to override data read in with
! (This is mostly for single-point mode, but could be used for sensitivity studies)
!
  logical,  public   :: all_urban              ! output ALL data as 100% covered in urban
!
! !REVISION HISTORY:
! Created by Mariana Vertenstein 11/04
!
!EOP
!-----------------------------------------------------------------------

end module mkvarctl

module interp

use control, only: verbose

implicit none
save
private

public :: interp_driver

contains

subroutine interp_driver(ncidi, ncido, f_in, f_out, vari, varo, nxi, &
                         nzi, nyi, nxo, nzo, nyo)

   ! first cut -- horizontal interpolation only
   ! Assume COARDS ordering, i.e., xyz

   use shr_kind_mod,     only: r8 => shr_kind_r8
   use fill_positions,   only: varspec_t
   use interpolate_data, only: lininterp, lininterp_init, interp_type, lininterp_finish

   implicit none

   include 'netcdf.inc'

   ! arguments

   integer, intent(in) :: ncidi, ncido
   integer, intent(in) :: nxi, nyi, nzi
   integer, intent(in) :: nxo, nyo, nzo

   type(varspec_t), intent(in) :: vari, varo

   real(r8), target, intent(in)  :: f_in(nxi,nyi,nzi)
   real(r8),         intent(out) :: f_out(nxo,nyo,nzo)

   ! Local workspace
   integer :: i,j,k
   integer :: numxis, numxin
   integer :: numxo
   integer :: jj, jjs, jjn
   integer :: count

   real(r8) :: x_in(nxi), x_out(nxo), y_in(nyi), z_in(nzi), z_out(nzo)
   real(r8), allocatable :: y_out(:)
   integer, parameter :: use_bnd_value_to_extrap = 1
   integer, parameter :: cyclic_bnds = 2
   type(interp_type) :: xwgts, ywgts, zwgts

   logical  :: do_vert_interp, do_horiz_interp
   real(r8), allocatable :: col_in(:), col_out(:)
   real(r8), pointer :: f_z(:,:,:)
   !-----------------------------------------------------------------------------

   ! Check whether vertical interpolation is needed.

   do_vert_interp = .false.

   if (nzi > 1) then

      ! If nzi > 1 then assume a vertical coordinate is present.  And if the input
      ! variable has a vertical coordinate then so does the output, even if its size
      ! is 1.
      call wrap_get_var_double(ncidi, vari%z_vid, z_in)
      call wrap_get_var_double(ncido, varo%z_vid, z_out)

      ! If number of input and output levels is the same, check whether the coordinates
      ! are different.  Otherwise no need to interpolate.
      if (nzi == nzo) then
         do k = 1, nzi
            if ( abs(z_in(k) - z_out(k)) > 1.e-4 ) do_vert_interp = .true.
         end do
      else
         ! If number of levels changes on output the interpolation is required.
         do_vert_interp = .true.
      end if

   end if

   if (do_vert_interp) then

      if (verbose) then
         write(6,*)'  doing vertical interpolation'
      end if

      allocate(f_z(nxi,nyi,nzo))
      allocate(col_in(nzi))
      allocate(col_out(nzo))

      call lininterp_init(z_in, nzi, z_out, nzo, use_bnd_value_to_extrap, zwgts)

      ! interpolate a column at a time
      do j = 1, nyi
         do i = 1, nxi
            do k = 1, nzi
               col_in(k) = f_in(i,j,k)
            end do
            call lininterp(col_in, nzi, col_out, nzo, zwgts)
            do k = 1, nzo
               f_z(i,j,k) = col_out(k)
            end do
         end do
      end do

      deallocate(col_in)
      deallocate(col_out)
   else
      f_z => f_in
   end if

   ! Get x and y coordinates
   call wrap_get_var_double(ncidi, vari%x_vid, x_in)
   call wrap_get_var_double(ncidi, vari%y_vid, y_in)
   call wrap_get_var_double(ncido, varo%x_vid, x_out)

   if (nyo > 1) then
      allocate(y_out(nyo))
   else
      ! This is the unstructured grid mode.  The number of global
      ! columns is nxo
      allocate(y_out(nxo))
   end if
   call wrap_get_var_double(ncido, varo%y_vid, y_out)

   ! Check whether horizontal interpolation is needed

   do_horiz_interp = .false.

   if (nxi == nxo  .and.  nyi == nyo) then

      ! If grids are the same shape then need to check coordinates
      do i = 1, nxi
         if ( abs(x_in(i) - x_out(i)) > 1.e-4 ) do_horiz_interp = .true.
      end do
      do j = 1, nyi
         if ( abs(y_in(j) - y_out(j)) > 1.e-4 ) do_horiz_interp = .true.
      end do

   else
      ! If grids aren't the same shape then interpolation is needed
      do_horiz_interp = .true.
   end if

   if (do_horiz_interp) then

      if (verbose) then
         write(6,*)'  doing horizontal interpolation'
      end if

      call lininterp_init(x_in, nxi, x_out, nxo, cyclic_bnds, xwgts)

      if (nyo > 1) then
         ! Output grid is rectangular.
         call lininterp_init(y_in, nyi, y_out, nyo, use_bnd_value_to_extrap, ywgts)
     
         do k = 1, nzo
            call lininterp(f_z(:,:,k), nxi, nyi, f_out(:,:,k), nxo, nyo, xwgts, ywgts)
         end do
      else	
         ! Output grid is unstructured.
         call lininterp_init(y_in, nyi, y_out, nxo, use_bnd_value_to_extrap, ywgts)

         do k = 1, nzo
            call lininterp(f_z(:,:,k), nxi, nyi, f_out(:,1,k), nxo, xwgts, ywgts)
         end do
      end if

      call lininterp_finish(xwgts)
      call lininterp_finish(ywgts)

   else
      f_out = f_z
   end if

   deallocate(y_out)
   if (do_vert_interp) then
      deallocate(f_z)
   end if

end subroutine interp_driver

end module interp

subroutine wrap_inq_varid (nfid, varname, varid)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  character*(*) varname

  integer ret

  ret = nf_inq_varid (nfid, varname, varid)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_inq_varid

subroutine wrap_inq_dimlen (nfid, dimid, dimlen)
  implicit none
  include 'netcdf.inc'

  integer nfid, dimid, dimlen

  integer ret

  ret = nf_inq_dimlen (nfid, dimid, dimlen)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_inq_dimlen

subroutine wrap_inq_dimid (nfid, dimname, dimid)
  implicit none
  include 'netcdf.inc'

  integer nfid, dimid
  character*(*) dimname

  integer ret

  ret = nf_inq_dimid (nfid, dimname, dimid)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_inq_dimid

subroutine wrap_inq_var (nfid, varid, varname, xtype, ndims, dimids, natts)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid, xtype, ndims, dimids(nf_max_dims), natts
  character*(*) varname

  integer ret

  ret = nf_inq_var (nfid, varid, varname, xtype, ndims, dimids, natts)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_inq_var

subroutine wrap_def_dim (nfid, dimname, len, dimid)
  implicit none
  include 'netcdf.inc'

  integer nfid, len, dimid
  character*(*) dimname

  integer ret

  ret = nf_def_dim (nfid, dimname, len, dimid)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_def_dim

subroutine wrap_get_var8 (nfid, varid, arr)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  real*8 arr(*)

  integer ret

  ret = nf_get_var_double (nfid, varid, arr)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_get_var8

subroutine wrap_put_var8 (nfid, varid, arr)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  real*8 arr(*)

  integer ret
  ret = nf_put_var_double (nfid, varid, arr)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_put_var8

subroutine wrap_get_vara8 (nfid, varid, start, count, arr)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid, start(*), count(*)
  real*8 arr(*)

  integer ret

  ret = nf_get_vara_double (nfid, varid, start, count, arr)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_get_vara8

subroutine wrap_put_vara8 (nfid, varid, start, count, arr)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  integer start(*), count(*)
  real*8 arr(*)

  integer ret
  ret = nf_put_vara_double (nfid, varid, start, count, arr)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_put_vara8

subroutine wrap_put_att_text (nfid, varid, attname, atttext)
  implicit none
  include 'netcdf.inc'

  integer, intent(in):: nfid
  integer, intent(in):: varid
  character*(*), intent(in):: attname
  character*(*), intent(in):: atttext
  
  integer ret      ! NetCDF return code
  integer siz

  siz = len_trim(atttext)
  ret = nf_put_att_text (nfid, varid, attname, siz, atttext)
  if (ret/=NF_NOERR) call handle_error (ret)
end subroutine wrap_put_att_text

subroutine wrap_put_att_double (nfid, varid, name, xtype, len, dvals)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid, xtype, len
  character*(*) name
  real*8 dvals

  integer ret

  ret = nf_put_att_double (nfid, varid, name, xtype, len, dvals)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_put_att_double

module mkurbanparCommonMod
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: mkurbanparCommon
!
! !DESCRIPTION:
! Common routines for making urban parameter data, shared by mkurbanparAvgMod,
! mkurbanparDomMod, etc.
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
!-----------------------------------------------------------------------
! !USES:
   use shr_kind_mod, only : r8 => shr_kind_r8
   use shr_sys_mod , only : shr_sys_flush
   implicit none
   
   private
   
! !PUBLIC MEMBER FUNCTIONS:
   public :: get_urban_format        ! Determine the format of the urban input file
   public :: mkurban_pct             ! Make output urban %, given input urban %
   public :: mkurban_pct_diagnostics ! print diagnostics related to pct urban
   public :: mkelev                  ! Get elevation to reduce urban for high elevation areas
!
! !PUBLIC DATA MEMBERS:
!
   ! constants identifying urban input data format
   integer , parameter :: URBAN_FORMAT_AVG = 1, &  ! format used with averaging
                          URBAN_FORMAT_DOM = 2     ! format used with dominant type approach

   real(r8), parameter :: MIN_DENS = 0.1_r8       ! minimum urban density (% of grid cell) - below this value, urban % is set to 0

   public :: URBAN_FORMAT_AVG, URBAN_FORMAT_DOM
   public :: MIN_DENS
!
!EOP

contains

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: get_urban_format
!
! !INTERFACE:
subroutine get_urban_format(datfname, urban_format)
!
! !DESCRIPTION:
! determine the format of the urban input file
!
! !USES:
   use mkncdio
!
! !ARGUMENTS:
   implicit none
   character(len=*) , intent(in) :: datfname     ! input data file name
   integer          , intent(out):: urban_format ! code for format of data file
!
! !REVISION HISTORY:
! Author: Bill Sacks
!
!
! !LOCAL VARIABLES:
!EOP
   integer :: ncid, dimid    ! input netCDF id's
   integer :: ier            ! error code

   character(len=*), parameter :: subname = 'get_urban_format'
!-----------------------------------------------------------------------

  call check_ret(nf_open(datfname, 0, ncid), subname)
  ier = nf_inq_dimid(ncid, 'density_class', dimid)
  if (ier == NF_NOERR) then
     ! density_class dimension was found on the file
     write(6,*) 'Urban file appears to be dominant-type format'
     urban_format = URBAN_FORMAT_DOM
  else
     write(6,*) 'Urban file appears to be area-average format'
     urban_format = URBAN_FORMAT_AVG
  end if

  call check_ret(nf_close(ncid), subname)

end subroutine get_urban_format
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkurban_pct
!
! !INTERFACE:
subroutine mkurban_pct(ldomain, tdomain, tgridmap, urbn_i, urbn_o)
!
! !DESCRIPTION:
! make percent urban on output grid, given percent urban on input grid
!
! This assumes that we're neither using all_urban or zero_out
!
!
! !USES:
   use mkdomainMod , only : domain_type, domain_checksame
   use mkgridmapMod
   use mkvarctl    , only : mksrf_gridtype
!
! !ARGUMENTS:
   implicit none
   type(domain_type) , intent(in) :: ldomain
   type(domain_type) , intent(in) :: tdomain    ! local domain
   type(gridmap_type), intent(in) :: tgridmap   ! local gridmap
   real(r8)          , intent(in) :: urbn_i(:)  ! input grid: percent urban
   real(r8)          , intent(out):: urbn_o(:)  ! output grid: percent urban
!
! !REVISION HISTORY:
! Author: Bill Sacks
! (Moved from mkurbanparMod Feb, 2012)
!
!
! !LOCAL VARIABLES:
!EOP
   real(r8) :: sum_fldi                        ! global sum of dummy input fld
   real(r8) :: sum_fldo                        ! global sum of dummy output fld
   integer  :: ni,no                           ! indices
   real(r8) :: relerr = 0.00001_r8             ! max error: sum overlap wts ne 1
   character(len=*), parameter :: subname = 'mkurban_pct'
!-----------------------------------------------------------------------

   ! Error checks for array size consistencies

   if (size(urbn_i) /= tdomain%ns .or. &
       size(urbn_o) /= ldomain%ns) then
      write(6,*) subname//' ERROR: array size inconsistencies'
      write(6,*) 'size(urbn_i) = ', size(urbn_i)
      write(6,*) 'tdomain%ns   = ', tdomain%ns
      write(6,*) 'size(urbn_o) = ', size(urbn_o)
      write(6,*) 'ldomain%ns   = ', ldomain%ns
      stop
   end if
   
   ! Error checks for domain and map consistencies
   
   call domain_checksame( tdomain, ldomain, tgridmap )

   ! Determine urbn_o on ouput grid:
   ! Area-average percent cover on input grid to output grid 
   ! and correct according to land landmask
   ! Note that percent cover is in terms of total grid area.   

   call gridmap_areaave(tgridmap, urbn_i, urbn_o)

   ! Check for conservation

   do no = 1, ldomain%ns
      if ((urbn_o(no)) > 100.000001_r8) then
         write (6,*) 'MKURBAN error: urban = ',urbn_o(no), &
              ' greater than 100.000001 for column, row = ',no
         stop
      end if
   enddo

   ! Global sum of output field -- must multiply by fraction of
   ! output grid that is land as determined by input grid

   sum_fldi = 0.0_r8
   do ni = 1,tdomain%ns
      sum_fldi = sum_fldi + tgridmap%area_src(ni) * tgridmap%frac_src(ni)
   enddo

   sum_fldo = 0._r8
   do no = 1, ldomain%ns
      sum_fldo = sum_fldo + tgridmap%area_dst(no) * tgridmap%frac_dst(no)
   end do

   ! -----------------------------------------------------------------
   ! Error check1
   ! Compare global sum fld_o to global sum fld_i.
   ! -----------------------------------------------------------------

   if (trim(mksrf_gridtype) == 'global') then
      if ( abs(sum_fldo/sum_fldi-1._r8) > relerr ) then
         write (6,*) 'MKURBAN error: input field not conserved'
         write (6,'(a30,e20.10)') 'global sum output field = ',sum_fldo
         write (6,'(a30,e20.10)') 'global sum input  field = ',sum_fldi
         stop
      end if
   end if

   ! (Error check2 in mkurban_pct_diagnostics, which should be called separately)

end subroutine mkurban_pct
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkurban_pct_diagnostics
!
! !INTERFACE:
subroutine mkurban_pct_diagnostics(ldomain, tdomain, tgridmap, urbn_i, urbn_o, ndiag, dens_class)
!
! !DESCRIPTION:
! print diagnostics related to pct urban
!
! This is intended to be called after mkurban_pct, but is split out into a separate
! routine so that modifications to urbn_o can be made in between the two calls (e.g.,
! setting urbn_o to 0 wherever it is less than a certain threshold; the rules for doing
! this can't always be applied inline in mkurban_pct).
!
! !USES:
   use mkdomainMod , only : domain_type
   use mkgridmapMod, only : gridmap_type
   use mkvarpar
!
! !ARGUMENTS:
   implicit none
   type(domain_type) , intent(in) :: ldomain
   type(domain_type) , intent(in) :: tdomain    ! local domain
   type(gridmap_type), intent(in) :: tgridmap   ! local gridmap
   real(r8)          , intent(in) :: urbn_i(:)  ! input grid: percent urban
   real(r8)          , intent(in) :: urbn_o(:)  ! output grid: percent urban
   integer           , intent(in) :: ndiag      ! unit number for diag out

   integer , intent(in), optional :: dens_class ! density class
!
! !REVISION HISTORY:
! Author: Bill Sacks
! (Moved from mkurbanparMod Feb, 2012)
!
!
! !LOCAL VARIABLES:
!EOP
   real(r8) :: gurbn_i                         ! input  grid: global urbn
   real(r8) :: garea_i                         ! input  grid: global area
   real(r8) :: gurbn_o                         ! output grid: global urbn
   real(r8) :: garea_o                         ! output grid: global area
   integer  :: ni,no,k                         ! indices
!-----------------------------------------------------------------------

   ! -----------------------------------------------------------------
   ! Error check2
   ! Compare global areas on input and output grids
   ! -----------------------------------------------------------------

   ! Input grid

   gurbn_i = 0._r8
   garea_i = 0._r8

   do ni = 1, tdomain%ns
      garea_i = garea_i + tgridmap%area_src(ni)*re**2
      gurbn_i = gurbn_i + urbn_i(ni)*(tgridmap%area_src(ni)/100._r8)*&
           tgridmap%frac_src(ni)*re**2
   end do

   ! Output grid

   gurbn_o = 0._r8
   garea_o = 0._r8

   do no = 1, ldomain%ns
      garea_o = garea_o + tgridmap%area_dst(no)*re**2
      gurbn_o = gurbn_o + urbn_o(no)* (tgridmap%area_dst(no)/100._r8)*&
           tgridmap%frac_dst(no)*re**2
   end do

   ! Diagnostic output

   write (ndiag,*)
   write (ndiag,'(1x,70a1)') ('=',k=1,70)
   if (present(dens_class)) then
      write (ndiag,'(1x,a,i0)') 'Urban Output -- class ', dens_class
   else
      write (ndiag,'(1x,a)') 'Urban Output'
   end if
   write (ndiag,'(1x,70a1)') ('=',k=1,70)

   write (ndiag,*)
   write (ndiag,'(1x,70a1)') ('.',k=1,70)
   write (ndiag,2001)
2001 format (1x,'surface type   input grid area  output grid area'/ &
        1x,'                 10**6 km**2      10**6 km**2   ')
   write (ndiag,'(1x,70a1)') ('.',k=1,70)
   write (ndiag,*)
   write (ndiag,2003) gurbn_i*1.e-06,gurbn_o*1.e-06
   write (ndiag,2004) garea_i*1.e-06,garea_o*1.e-06
2002 format (1x,'urban       ',f14.3,f17.3)
2003 format (1x,'urban       ',f14.3,f22.8)
2004 format (1x,'all surface ',f14.3,f17.3)

end subroutine mkurban_pct_diagnostics
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkelev
!
! !INTERFACE:
subroutine mkelev(ldomain, mapfname, datfname, varname, ndiag, elev_o)
!
! !DESCRIPTION:
! Make elevation data
!
! !USES:
  use mkdomainMod  , only : domain_type, domain_clean, domain_read, domain_checksame
  use mkgridmapMod
  use mkvarpar	
  use mkvarctl    
  use mkncdio
!
! !ARGUMENTS:
  implicit none
  type(domain_type), intent(in) :: ldomain
  character(len=*)  , intent(in) :: mapfname  ! input mapping file name
  character(len=*)  , intent(in) :: datfname  ! input data file name
  integer           , intent(in) :: ndiag     ! unit number for diag out
  character(len=*)  , intent(in) :: varname   ! topo variable name
  real(r8)          , intent(out):: elev_o(:) ! output elevation data
!
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Keith Oleson
!
!
! !LOCAL VARIABLES:
!EOP
  type(domain_type)     :: tdomain            ! local domain
  type(gridmap_type)    :: tgridmap           ! local gridmap

  real(r8), allocatable :: elev_i(:)          ! canyon_height to width ratio in
  real(r8), allocatable :: mask_i(:)          ! input grid: mask (0, 1)
  integer  :: ns_i,ns_o                       ! indices
  integer  :: k,l,n,m,ni                      ! indices
  integer  :: ncidi,dimid,varid               ! input netCDF id's
  integer  :: ier                             ! error status
  character(len=256) :: name                  ! name of attribute
  character(len=256) :: unit                  ! units of attribute
  character(len= 32) :: subname = 'mkelev'
!-----------------------------------------------------------------------

  write (6,*) 'Attempting to make elevation .....'
  call shr_sys_flush(6)

  ns_o = ldomain%ns

  ! -----------------------------------------------------------------
  ! Read input file
  ! -----------------------------------------------------------------

  ! Obtain input grid info, read local fields

  call domain_read(tdomain,datfname)

  ns_i = tdomain%ns
  allocate(elev_i(ns_i), stat=ier)
  if (ier /= 0) then
     write(6,*)'mkelev allocation error'; call abort()
  end if

  write (6,*) 'Open elevation file: ', trim(datfname)
  call check_ret(nf_open(datfname, 0, ncidi), subname)
  call check_ret(nf_inq_varid (ncidi, trim(varname), varid), subname)
  call check_ret(nf_get_var_double (ncidi, varid, elev_i), subname)
  call check_ret(nf_close(ncidi), subname)

  ! Read topo elev dataset with unit mask everywhere

  call gridmap_mapread(tgridmap, mapfname)

  ! Error checks for domain and map consistencies
  ! Note that the topo dataset has no landmask - so a unit landmask is assumed

  call domain_checksame( tdomain, ldomain, tgridmap )

  ! Determine elev_o on output grid

  elev_o(:) = 0.

  call gridmap_areaave(tgridmap, elev_i, elev_o)

  ! Deallocate dynamic memory

  call domain_clean(tdomain)
  call gridmap_clean(tgridmap)
  deallocate (elev_i)

  write (6,*) 'Successfully made elevation' 
  write (6,*)
  call shr_sys_flush(6)

end subroutine mkelev

!-----------------------------------------------------------------------

end module mkurbanparCommonMod

module clm_varctl

!-----------------------------------------------------------------------
!BOP
!
! !MODULE: clm_varctl
!
! !DESCRIPTION:
! Module containing run control variables
!
! !USES:
  use shr_kind_mod, only: r8 => shr_kind_r8
  use clm_varpar, only: maxpatch_glcmec
!
!
! !PUBLIC MEMBER FUNCTIONS:
  implicit none
  public :: set_clmvarctl     ! Set variables
  public :: clmvarctl_init    ! Initialize and check values after namelist input

  private
  save
!
! !PUBLIC TYPES:
!
  integer, parameter, private ::  iundef = -9999999
  integer, parameter, private ::  rundef = -9999999._r8
!
! Run control variables
!
  character(len=256), public :: caseid  = ' '                            ! case id
  character(len=256), public :: ctitle  = ' '                            ! case title
  integer, public :: nsrest             = iundef                         ! Type of run
  integer, public, parameter :: nsrStartup  = 0                          ! Startup from initial conditions
  integer, public, parameter :: nsrContinue = 1                          ! Continue from restart files
  integer, public, parameter :: nsrBranch   = 2                          ! Branch from restart files
  logical, public :: brnch_retain_casename = .false.                     ! true => allow case name to remain the same for branch run
                                                                         ! by default this is not allowed
  logical, public :: noland = .false.                                    ! true => no valid land points -- do NOT run
  character(len=256), public :: hostname = ' '                           ! Hostname of machine running on
  character(len=256), public :: username = ' '                           ! username of user running program
  character(len=256), public :: source   = "Community Land Model CLM4.0" ! description of this source
  character(len=256), public :: version  = " "                           ! version of program
  character(len=256), public :: conventions = "CF-1.0"                   ! dataset conventions
!
! Unit Numbers
!
  integer, public :: iulog = 6        ! "stdout" log file unit number, default is 6
!
! Output NetCDF files
!
  logical, public :: outnc_large_files = .true.         ! large file support for output NetCDF files
!
! Run input files
!
  character(len=256), public :: finidat    = ' '        ! initial conditions file name
  character(len=256), public :: fsurdat    = ' '        ! surface data file name
  character(len=256), public :: fatmgrid   = ' '        ! atm grid file name
  character(len=256), public :: fatmlndfrc = ' '        ! lnd frac file on atm grid
  character(len=256), public :: fatmtopo   = ' '        ! topography on atm grid
  character(len=256), public :: flndtopo   = ' '        ! topography on lnd grid
  character(len=256), public :: fpftdyn    = ' '        ! dynamic landuse dataset
  character(len=256), public :: fpftcon    = ' '        ! ASCII data file with PFT physiological constants
  character(len=256), public :: nrevsn     = ' '        ! restart data file name for branch run
  character(len=256), public :: fsnowoptics  = ' '      ! snow optical properties file name
  character(len=256), public :: fsnowaging   = ' '      ! snow aging parameters file name
  character(len=256), public :: fglcmask     = ' '      ! glacier mask file name
  logical         ,   public :: downscale               ! true => do downscaling with fine mesh
                                                        ! ASSUMES that all grids are lat/lon
!
! Landunit logic
!
  logical, public :: create_crop_landunit = .false.     ! true => separate crop landunit is not created by default
  logical, public :: allocate_all_vegpfts = .false.     ! true => allocate memory for all possible vegetated pfts on
                                                        ! vegetated landunit if at least one pft has nonzero weight
!
! BGC logic and datasets
!
  character(len=16), public :: co2_type = 'constant'    ! values of 'prognostic','diagnostic','constant'
!
! Physics
!
  logical,  public :: wrtdia       = .false.            ! true => write global average diagnostics to std out
  real(r8), public :: co2_ppmv     = 355._r8            ! atmospheric CO2 molar ratio (by volume) (umol/mol)

! glacier_mec control variables: default values (may be overwritten by namelist)
! NOTE: glc_nec and glc_smb must have the same values for CLM and GLC

  logical, public :: create_glacier_mec_landunit = .false.  ! glacier_mec landunit is not created
  logical, public :: glc_dyntopo = .false.                  ! true => CLM glacier topography changes dynamically
  logical, public :: glc_smb = .false.                      ! if true, pass surface mass balance info to GLC
                                                            ! if false, pass positive-degree-day info to GLC
  integer , public :: glc_nec = 0                           ! number of elevation classes for glacier_mec landunits
  real(r8), public :: glc_topomax(0:maxpatch_glcmec)        ! upper limit of each class (m)
!
! single column control variables
!
  logical,  public :: single_column = .false.           ! true => single column mode
  real(r8), public:: scmlat         = rundef            ! single column lat
  real(r8), public:: scmlon         = rundef            ! single column lon
!
! instance control
!
  integer, public :: inst_index
  character(len=16), public :: inst_name
  character(len=16), public :: inst_suffix
#ifdef RTM
!
! Rtm control variables
!
  character(len=256), public :: frivinp_rtm  = ' '      ! RTM input data file name
  integer,            public :: rtm_nsteps = iundef     ! if > 1, average rtm over rtm_nsteps time steps
  logical,            public :: ice_runoff = .true.     ! true => runoff is split into liquid and ice 
                                                        ! otherwise just liquid
  character(len=256), public :: fmapinp_rtm = ' '       ! mapping file from clm to rtm grid
                                                        ! if blank - then rtm calculates the mapping matrix at runtime
#endif
!
! Decomp control variables
!
  integer, public :: nsegspc = 20                       ! number of segments per clump for decomp
!
! Derived variables (run, history and restart file)
!
  character(len=256), public :: rpntdir = '.'            ! directory name for local restart pointer file
  character(len=256), public :: rpntfil = 'rpointer.lnd' ! file name for local restart pointer file
!
! Error growth perturbation limit
!
  real(r8), public :: pertlim = 0.0_r8                  ! perturbation limit when doing error growth test
!
! !PRIVATE DATA MEMBERS:
!
! !REVISION HISTORY:
! Created by Mariana Vertenstein and Gordon Bonan
! 1 June 2004, Peter Thornton: added fnedpdat for nitrogen deposition data
!
!EOP
!-----------------------------------------------------------------------
  logical, private :: clmvarctl_isset = .false.

!===============================================================
contains
!===============================================================

!---------------------------------------------------------------------------
!BOP
!
! !IROUTINE: set_clmvarctl
!
! !INTERFACE:
  subroutine set_clmvarctl( caseid_in, ctitle_in, brnch_retain_casename_in,    &
                            single_column_in, scmlat_in, scmlon_in, nsrest_in, &
                            version_in, hostname_in, username_in)
!
! !DESCRIPTION:
!      Set input control variables.
!
! !USES:
  use shr_sys_mod, only : shr_sys_abort
!
! !ARGUMENTS:
  character(len=256), optional, intent(IN) :: caseid_in                ! case id
  character(len=256), optional, intent(IN) :: ctitle_in                ! case title
  logical,            optional, intent(IN) :: brnch_retain_casename_in ! true => allow case name to remain the same for branch run
  logical,            optional, intent(IN) :: single_column_in         ! true => single column mode
  real(r8),           optional, intent(IN) :: scmlat_in                ! single column lat
  real(r8),           optional, intent(IN) :: scmlon_in                ! single column lon
  integer,            optional, intent(IN) :: nsrest_in                ! 0: initial run. 1: restart: 3: branch
  character(len=256), optional, intent(IN) :: version_in               ! model version
  character(len=256), optional, intent(IN) :: hostname_in              ! hostname running on
  character(len=256), optional, intent(IN) :: username_in              ! username running job

!
! !LOCAL VARIABLES:
   character(len=32) :: subname = 'set_clmvarctl'  ! subroutine name
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!EOP
!-----------------------------------------------------------------------
    if ( clmvarctl_isset )then
       call shr_sys_abort( subname//' ERROR:: control variables already set -- can not call this subroutine' )
    end if
    if ( present(caseid_in       ) ) caseid        = caseid_in
    if ( present(ctitle_in       ) ) ctitle        = ctitle_in
    if ( present(single_column_in) ) single_column = single_column_in
    if ( present(scmlat_in       ) ) scmlat        = scmlat_in
    if ( present(scmlon_in       ) ) scmlon        = scmlon_in
    if ( present(nsrest_in       ) ) nsrest        = nsrest_in
    if ( present(brnch_retain_casename_in) ) brnch_retain_casename = brnch_retain_casename_in
    if ( present(version_in      ) ) version       = version_in
    if ( present(username_in     ) ) username      = username_in
    if ( present(hostname_in     ) ) hostname      = hostname_in

  end subroutine set_clmvarctl

!---------------------------------------------------------------------------
!BOP
!
! !IROUTINE: clmvarctl_init
!
! !INTERFACE:
  subroutine clmvarctl_init( masterproc, dtime )
!
! !DESCRIPTION:
!      Check that values are correct, and finish setting variables based on other variables.
!
! !USES:
  use shr_sys_mod  , only : shr_sys_abort
  use clm_varpar   , only : maxpatch_pft, numpft
!
! !ARGUMENTS:
  logical, intent(IN) :: masterproc  ! proc 0 logical for printing msgs
  integer, intent(IN) :: dtime       ! timestep in seconds
!
! !LOCAL VARIABLES:
   character(len=32) :: subname = 'clmvarctl_init'  ! subroutine name
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!EOP
!-----------------------------------------------------------------------

    ! landunit generation

    if (maxpatch_pft == numpft+1) then
       allocate_all_vegpfts = .true.
    else
       allocate_all_vegpfts = .false.
#ifdef CROP
       write(iulog,*)'maxpatch_pft = ',maxpatch_pft,' does NOT equal numpft+1 = ', &
                      numpft+1
       call shr_sys_abort( subname//' ERROR:: Can NOT turn CROP on without all PFTs' )
#endif
    end if

    if (masterproc) then

       ! Consistency settings for co2 type

       if (co2_type /= 'constant' .and. co2_type /= 'prognostic' .and. co2_type /= 'diagnostic') then
          write(iulog,*)'co2_type = ',co2_type,' is not supported'
          call shr_sys_abort( subname//' ERROR:: choices are constant, prognostic or diagnostic' )
       end if

       ! Consistency settings for dynamic land use, etc.

       if (fpftdyn /= ' ' .and. create_crop_landunit) &
          call shr_sys_abort( subname//' ERROR:: dynamic landuse is currently not supported with create_crop_landunit option' )
       if (create_crop_landunit .and. .not.allocate_all_vegpfts) &
          call shr_sys_abort( subname//' ERROR:: maxpft<numpft+1 is currently not supported with create_crop_landunit option' )
       if (fpftdyn /= ' ') then
#if (defined CNDV)
          call shr_sys_abort( subname//' ERROR:: dynamic landuse is currently not supported with CNDV option' )
#endif
       end if

       if (create_glacier_mec_landunit) then

#if (defined GLC_NEC_1)
          glc_nec = 1
#elif (defined GLC_NEC_3)
          glc_nec = 3
#elif (defined GLC_NEC_5)
          glc_nec = 5
#elif (defined GLC_NEC_10)
          glc_nec = 10
#else
          call shr_sys_abort( subname//' ERROR:: glc_nec must be 1, 3, 5, or 10 to create glacier_mec landunit')
#endif

       else  ! no glacier_mec landunit

          if (glc_nec /= 0) then
             write(iulog,*) 'glc_nec =', glc_nec
             call shr_sys_abort( subname//' ERROR:: no glacier_mec landunit; must have glc_nec = 0')
          endif
          if (glc_smb ) then
             call shr_sys_abort( subname//' ERROR:: glc_smb true, but create_glacier_mec NOT true')
          endif
          if (glc_dyntopo) then
             call shr_sys_abort( subname//' ERROR:: glc_dyntopo true, but create_glacier_mec NOT true')
          endif

       endif ! create_glacier_mec_landunit

#if (defined RTM)
       ! If rtm_nsteps was not entered in the namelist, give it the following default value

       if (rtm_nsteps == iundef) rtm_nsteps = (3600*3)/dtime ! 3 hours
#endif

       ! Check on run type

       if (nsrest == iundef) call shr_sys_abort( subname//' ERROR:: must set nsrest' )
       if (nsrest == nsrBranch .and. nrevsn == ' ') &
          call shr_sys_abort( subname//' ERROR: need to set restart data file name' )

       ! Model physics

       if ( (co2_ppmv <= 0.0_r8) .or. (co2_ppmv > 3000.0_r8) ) &
          call shr_sys_abort( subname//' ERROR: co2_ppmv is out of a reasonable range' )

       if (nsrest == nsrStartup ) nrevsn = ' '
       if (nsrest == nsrContinue) nrevsn = 'set by restart pointer file file'
       if (nsrest /= nsrStartup .and. nsrest /= nsrContinue .and. nsrest /= nsrBranch ) &
          call shr_sys_abort( subname//' ERROR: nsrest NOT set to a valid value' )

       if ( single_column .and. (scmlat == rundef  .or. scmlon == rundef ) ) &
          call shr_sys_abort( subname//' ERROR:: single column mode on -- but scmlat and scmlon are NOT set' )

    endif   ! end of if-masterproc if-block

    clmvarctl_isset = .true.

  end subroutine clmvarctl_init

end module clm_varctl

!===============================================================================
! SVN $Id: shr_file_mod.F90 22436 2010-04-18 05:32:48Z tcraig $
! SVN $URL: https://svn-ccsm-models.cgd.ucar.edu/csm_share/trunk_tags/share3_110213/shr/shr_file_mod.F90 $
!===============================================================================
!BOP ===========================================================================
!
! !MODULE: shr_file_mod.F90 --- Module to handle various file utilily functions.
!
! !DESCRIPTION:
!
! Miscilaneous methods to handle file and directory utilities as well as FORTRAN
! unit control. Also put/get local files into/from archival location
!
! File utilites used with CCSM Message passing:
!
! shr_file_stdio is the main example here, it changes the working directory, 
!                changes stdin and stdout to a given filename.
!
! This is needed because some implementations of MPI with MPMD so that
! each executable can run in a different working directory and redirect
! output to different files.
!
! File name archival convention, eg.
!    call shr_file_put(rcode,"foo","mss:/USER/foo",rtpd=3650)
! is extensible -- the existence of the option file name prefix, eg. "mss:", 
! and optional arguments, eg. rtpd-3650 can be used to access site-specific 
! storage devices.  Based on CCM (atmosphere) getfile & putfile routines, but
! intended to be a more extensible, shared code.
! 
! !REVISION HISTORY:
!   2006-05-08 E. Kluzek, Add in shr_file_mod and getUnit, freeUnif methods.
!   2000-??-?? B. Kauffman, original version circa 2000
!
! !INTERFACE: ------------------------------------------------------------------

MODULE shr_file_mod

! !USES:

   use shr_kind_mod  ! defines kinds
   use shr_sys_mod   ! system calls
   use shr_log_mod, only: s_loglev  => shr_log_Level
   use shr_log_mod, only: s_logunit => shr_log_Unit
   
   IMPLICIT none

   PRIVATE           ! By default everything is private to this module
   
! !PUBLIC TYPES:               
   
   ! no public types

! !PUBLIC MEMBER FUNCTIONS:

   public :: shr_file_put          ! Put a file to an archive location
   public :: shr_file_get          ! Get a file from an archive location
   public :: shr_file_queryPrefix  ! Get prefix type for a filename
   public :: shr_file_getUnit      ! Get a logical unit for reading or writing
   public :: shr_file_freeUnit     ! Free a logical unit
   public :: shr_file_stdio        ! change dir and stdin and stdout
   public :: shr_file_chDir        ! change current working directory
   public :: shr_file_dirio        ! change stdin and stdout
   public :: shr_file_chStdIn      ! change stdin  (attach to a file)
   public :: shr_file_chStdOut     ! change stdout (attach to a file)
   public :: shr_file_setIO        ! open a log file from namelist
   public :: shr_file_setLogUnit   ! Reset the log unit number
   public :: shr_file_setLogLevel  ! Reset the logging debug level
   public :: shr_file_getLogUnit   ! Get the log unit number
   public :: shr_file_getLogLevel  ! Get the logging debug level

! !PUBLIC DATA MEMBERS:

   ! Integer flags for recognized prefixes on file get/put operations
   integer(SHR_KIND_IN), parameter, public :: shr_file_noPrefix      = 0 ! no recognized prefix
   integer(SHR_KIND_IN), parameter, public :: shr_file_nullPrefix    = 1 ! null:
   integer(SHR_KIND_IN), parameter, public :: shr_file_cpPrefix      = 2 ! cp:
   integer(SHR_KIND_IN), parameter, public :: shr_file_mssPrefix     = 3 ! mss:
   integer(SHR_KIND_IN), parameter, public :: shr_file_hpssPrefix    = 4 ! hpss:

!EOP
   !--- unit numbers, users can ask for unit numbers from 0 to min, but getUnit
   !--- won't give a unit below min, users cannot ask for unit number above max
   !--- for backward compatability.  
   !--- eventually, recommend min as hard lower limit (tcraig, 9/2007)
   integer(SHR_KIND_IN),parameter :: shr_file_minUnit = 10      ! Min unit number to give
   integer(SHR_KIND_IN),parameter :: shr_file_maxUnit = 99      ! Max unit number to give
   logical, save :: UnitTag(0:shr_file_maxUnit) = .false. ! Logical units in use

!===============================================================================
CONTAINS
!===============================================================================

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_file_put -- Put a file to an archival location.
!
! !DESCRIPTION:
!    a generic, extensible put-local-file-into-archive routine
! USAGE:
!    call shr_file_put(rcode,"foo","/home/user/foo")
!    if ( rcode /= 0 ) call shr_sys_abort( "error copying foo" )
!    call shr_file_put(rcode,"foo","cp:/home/user/foo",remove=.true.)
!    if ( rcode /= 0 ) call shr_sys_abort( "error copying foo" )
!    call shr_file_put(rcode,"foo","mss:/USER/foo",rtpd=3650)
!    if ( rcode /= 0 ) call shr_sys_abort( "error archiving foo to MSS" )
!
! !INTERFACE: ------------------------------------------------------------------  

SUBROUTINE shr_file_put(rcode,loc_fn,rem_fn,passwd,rtpd,async,remove)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   integer(SHR_KIND_IN),intent(out)         :: rcode  ! return code (non-zero -- error)
   character(*),        intent(in)          :: loc_fn ! local filename
   character(*),        intent(in)          :: rem_fn ! remote filename
   character(*),        intent(in),optional :: passwd ! password
   integer(SHR_KIND_IN),intent(in),optional :: rtpd   ! MSS retention period
   logical,             intent(in),optional :: async  ! true <=> asynchronous put
   logical,             intent(in),optional :: remove ! true <=> rm after put

!EOP

   !----- local -----  
   integer(SHR_KIND_IN)   :: rtpd2    ! MSS retention period
   logical                :: remove2  ! true <=> rm after put
   logical                :: async2   ! true <=> asynchronous put
   character(SHR_KIND_CL) :: passwd2  ! password
   character(SHR_KIND_CL) :: rfn      ! rem_fn without the destination prefix
   character(SHR_KIND_CL) :: cmd      ! command sent to system call
   integer(SHR_KIND_IN)   :: prefix   ! remote file prefix type

   !----- formats -----
   character(*),parameter :: subName = '(shr_file_put) '
   character(*),parameter :: F00 =   "('(shr_file_put) ',4a)"
   character(*),parameter :: F01 =   "('(shr_file_put) ',a,i3,2a)"
   character(*),parameter :: F02 =   "(a,i4)"

!-------------------------------------------------------------------------------
! Notes: 
! - On some machines the system call will not return a valid error code
! - when things are sent asynchronously, there probably won't be a error code
!   returned.
!-------------------------------------------------------------------------------

   remove2 =.false. ; if ( PRESENT(remove )) remove2 = remove
   async2  =.true.  ; if ( PRESENT(async  )) async2  = async
   passwd2 = " "    ; if ( PRESENT(passwd )) passwd2 = passwd
   rtpd2   = 365    ; if ( PRESENT(rtpd   )) rtpd2   = rtpd
   rcode   = 0

   if ( trim(rem_fn) == trim(loc_fn) ) then
      !------------------------------------------------------
      ! (remote file name) == (local file name) => do nothing
      !------------------------------------------------------
      cmd = 'do nothing: remote file = local file = '//trim(loc_fn)
      rcode = 0
   else if ( prefix == shr_file_cpPrefix .or. prefix == shr_file_noPrefix )then
      !------------------------------------------------------
      ! put via unix cp
      !------------------------------------------------------
      rfn = rem_fn
      if ( rem_fn(1:3) == "cp:") rfn = rem_fn(4:len_trim(rem_fn))
#if defined(CATAMOUNT)
      call shr_jlcp(trim(loc_fn),len_trim(loc_fn),trim(rfn),len_trim(rfn),rcode)
      if (remove2) call unlink(trim(loc_fn))
      if (async2 .and. s_loglev > 0) write(s_logunit,F00) 'Error: asynchronous copy not supported.'
      cmd = 'shr_jlcp -f '//trim(loc_fn)//' '//trim(rfn)
      rcode = 0
#else
      cmd = '/bin/cp -f '//trim(loc_fn)//' '//trim(rfn)
      if (remove2) cmd = trim(cmd)//' && /bin/rm -f '//trim(loc_fn)
      if (async2 ) cmd = trim(cmd)//' & '
      call shr_sys_system(trim(cmd),rcode)
#endif
   else if ( prefix == shr_file_mssPrefix )then
      !------------------------------------------------------
      ! put onto NCAR's MSS
      !------------------------------------------------------
      if (rtpd2 > 9999) rtpd2 = 9999
      write(cmd,F02) '/usr/local/bin/msrcp -period ',rtpd2
      if (async2 .and. (.not. remove2) ) cmd = trim(cmd)//' -async '
      if (len_trim(passwd2) > 0 ) cmd = trim(cmd)//' -wpwd '//trim(passwd)
      cmd = trim(cmd)//' '//trim(loc_fn)//' '//trim(rem_fn)
      if (remove2) cmd = trim(cmd)//' && /bin/rm -f '//trim(loc_fn)
      if (async2 .and. remove2 ) cmd = trim(cmd)//' & '
      call shr_sys_system(trim(cmd),rcode)
   else if ( prefix == shr_file_hpssPrefix )then
      !------------------------------------------------------
      ! put onto LANL's hpss
      !------------------------------------------------------
      rcode = -1
      cmd = 'rem_fn='//trim(rem_fn)//' loc_fn='//trim(loc_fn)
      write(s_logunit,F00) 'ERROR: hpss option not yet implemented'
      call shr_sys_abort( subName//'ERROR: hpss option not yet implemented' )
   else if ( prefix == shr_file_nullPrefix )then
      ! do nothing
      cmd = "null prefix => no file archival, do nothing"
      rcode = 0
   end if

   if (s_loglev > 0) write(s_logunit,F01) 'rcode =',rcode,' cmd = ', trim(cmd)

END SUBROUTINE shr_file_put

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_file_get -- Get a file from archival location.
!
! !DESCRIPTION:
!    a generic, extensible get-local-file-from-archive routine
!
! USAGE:
!    call shr_file_get(rcode,"foo","/home/user/foo")
!    if ( rcode /= 0 ) call shr_sys_abort( "error getting file foo" )
!    call shr_file_get(rcode,"foo","cp:/home/user/foo",remove=.true.)
!    if ( rcode /= 0 ) call shr_sys_abort( "error getting file foo" )
!    call shr_file_get(rcode,"foo","mss:/USER/foo",clobber=.true.)
!    if ( rcode /= 0 ) call shr_sys_abort( "error getting file foo from MSS" )
!
! !INTERFACE: ------------------------------------------------------------------  

SUBROUTINE shr_file_get(rcode,loc_fn,rem_fn,passwd,async,clobber)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   integer(SHR_KIND_IN),intent(out)         :: rcode   ! return code (non-zero means error)
   character(*)        ,intent(in)          :: loc_fn  ! local filename
   character(*)        ,intent(in)          :: rem_fn  ! remote filename
   character(*)        ,intent(in),optional :: passwd  ! password
   logical             ,intent(in),optional :: async   ! true <=> asynchronous get
   logical             ,intent(in),optional :: clobber ! true <=> clobber existing file

!EOP

   !----- local -----
   logical                :: async2   ! true <=> asynchronous get
   logical                :: clobber2 ! true <=> clobber existing file
   logical                :: exists   ! true <=> local file a ready exists
   character(SHR_KIND_CL) :: passwd2  ! password
   character(SHR_KIND_CL) :: rfn      ! rem_fn without the destination prefix
   character(SHR_KIND_CL) :: cmd      ! command sent to system call
   integer(SHR_KIND_IN)   :: prefix   ! remote file prefix type

   !----- formats -----
   character(*),parameter :: subName = '(shr_file_get) '
   character(*),parameter :: F00 =   "('(shr_file_get) ',4a)"
   character(*),parameter :: F01 =   "('(shr_file_get) ',a,i3,2a)"

!-------------------------------------------------------------------------------
! Notes: 
! - On some machines the system call will not return a valid error code
! - When things are sent asynchronously, there probably won't be a error code
!   returned.
!-------------------------------------------------------------------------------

   passwd2  = " "     ; if (PRESENT(passwd )) passwd2  = passwd
   async2   = .false. ; if (PRESENT(async  )) async2   = async
   clobber2 = .false. ; if (PRESENT(clobber)) clobber2 = clobber
   rcode    = 0

   inquire(file=trim(loc_fn),exist=exists)
   prefix = shr_file_queryPrefix( rem_fn )

   if ( exists .and. .not. clobber2 ) then
      !------------------------------------------------------
      ! (file exists) and (don't clobber) => do nothing
      !------------------------------------------------------
      cmd = 'do nothing: file exists & no-clobber for '//trim(loc_fn)
      rcode = 0
   else if ( trim(rem_fn) == trim(loc_fn) ) then
      !------------------------------------------------------
      ! (remote file name) == (local file name) => do nothing
      !------------------------------------------------------
      cmd = 'do nothing: remote file = local file for '//trim(loc_fn)
      rcode = 0
   else if ( prefix == shr_file_cpPrefix .or. prefix == shr_file_noPrefix )then
      !------------------------------------------------------
      ! get via unix cp
      !------------------------------------------------------
      rfn = rem_fn  ! remove prefix from this temp file name
      if (rem_fn(1:3) == "cp:") rfn = rem_fn(4:len_trim(rem_fn))
#if defined(CATAMOUNT)
      call shr_jlcp(trim(rfn),len(trim(rfn)),trim(loc_fn),len(trim(loc_fn)),rcode)
      if (async2.and.s_loglev>0) write(s_logunit,F00) 'Error: asynchronous copy not supported.'
      cmd = 'shr_jlcp -f '//trim(rfn)//' '//trim(loc_fn)
      rcode = 0
#else
      cmd = '/bin/cp -f '//trim(rfn)//' '//trim(loc_fn)
      if (async2) cmd = trim(cmd)//' & '
      call shr_sys_system(trim(cmd),rcode)
#endif
   else if ( prefix == shr_file_mssPrefix )then
      !------------------------------------------------------
      ! get from NCAR's MSS
      !------------------------------------------------------
      cmd = '/usr/local/bin/msrcp '
      if (async2)   cmd = trim(cmd)//' -async '
      cmd = trim(cmd)//' '//trim(rem_fn)//' '//trim(loc_fn)
      call shr_sys_system(trim(cmd),rcode)
   else if ( prefix == shr_file_hpssPrefix )then
      !------------------------------------------------------
      ! get from LANL's hpss
      !------------------------------------------------------
      rcode = -1
      cmd = 'rem_fn='//trim(rem_fn)//' loc_fn='//trim(loc_fn)
      write(s_logunit,F00) 'ERROR: hpss option not yet implemented'
      call shr_sys_abort( subName//'ERROR: hpss option not yet implemented' )
   else if ( prefix == shr_file_nullPrefix )then
      ! do nothing
      cmd = "null prefix => no file retrieval, do nothing"
      rcode = 0
   end if

   if (s_loglev > 0) write(s_logunit,F01) 'rcode =',rcode,' cmd = ', trim(cmd)

END SUBROUTINE shr_file_get

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_file_queryPrefix -- Get the prefix type from a filepath.
!
! !DESCRIPTION:
!    
! !INTERFACE: ------------------------------------------------------------------  

integer(SHR_KIND_IN) FUNCTION shr_file_queryPrefix( filepath, prefix )

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*), intent(in)            :: filepath ! Input filepath
   character(*), intent(out), optional :: prefix   ! Output prefix description

!EOP

   !----- local -----

!-------------------------------------------------------------------------------
! Notes: 
!-------------------------------------------------------------------------------

   if (     filepath(1:5) == "null:" )then
      shr_file_queryPrefix = shr_file_nullPrefix
      if ( present(prefix) ) prefix = "null:"
   else if( filepath(1:3) == "cp:" )then
      shr_file_queryPrefix = shr_file_cpPrefix
      if ( present(prefix) ) prefix = "cp:"
   else if( filepath(1:4) == "mss:" )then
      shr_file_queryPrefix = shr_file_mssPrefix
      if ( present(prefix) ) prefix = "mss:"
   else if( filepath(1:5) == "hpss:" )then
      shr_file_queryPrefix = shr_file_hpssPrefix
      if ( present(prefix) ) prefix = "hpss:"
   else
      shr_file_queryPrefix = shr_file_noPrefix
      if ( present(prefix) ) prefix = ""
   end if

END FUNCTION shr_file_queryPrefix

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_file_getUnit -- Get a free FORTRAN unit number
!
! !DESCRIPTION: Get the next free FORTRAN unit number.
!
! !REVISION HISTORY:
!     2005-Dec-14 - E. Kluzek - creation
!
! !INTERFACE: ------------------------------------------------------------------  

INTEGER FUNCTION shr_file_getUnit ( unit )

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   integer(SHR_KIND_IN),intent(in),optional :: unit ! desired unit number

!EOP

   !----- local -----
   integer(SHR_KIND_IN)   :: n      ! loop index
   logical                :: opened ! If unit opened or not

   !----- formats -----
   character(*),parameter :: subName = '(shr_file_getUnit) '
   character(*),parameter :: F00   = "('(shr_file_getUnit) ',A,I4,A)"

!-------------------------------------------------------------------------------
! Notes:
!-------------------------------------------------------------------------------

   if (present (unit)) then
      inquire( unit, opened=opened )
      if (unit < 0 .or. unit > shr_file_maxUnit) then
         write(s_logunit,F00) 'invalid unit number request:', unit
         call shr_sys_abort( 'ERROR: bad input unit number' )
      else if (opened .or. UnitTag(unit) .or. unit == 0 .or. unit == 5 &
               .or. unit == 6) then
         write(s_logunit,F00) 'unit number ', unit, ' is already in use'
         call shr_sys_abort( 'ERROR: Input unit number already in use' )
      else
         shr_file_getUnit = unit
         UnitTag (unit)   = .true.
         return
      end if

   else
      ! --- Choose first available unit other than 0, 5, or 6  ------
      do n=shr_file_maxUnit, shr_file_minUnit, -1
         inquire( n, opened=opened )
         if (n == 5 .or. n == 6 .or. opened) then
            cycle
         end if
         if ( .not. UnitTag(n) ) then
            shr_file_getUnit = n
            UnitTag(n)       = .true.
            return
         end if
      end do
   end if

   call shr_sys_abort( subName//': Error: no available units found' )

END FUNCTION shr_file_getUnit

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_file_freeUnit -- Free up a FORTRAN unit number
!
! !DESCRIPTION: Free up the given unit number
!
! !REVISION HISTORY:
!     2005-Dec-14 - E. Kluzek - creation
!
! !INTERFACE: ------------------------------------------------------------------  

SUBROUTINE shr_file_freeUnit ( unit)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   integer(SHR_KIND_IN),intent(in) :: unit  ! unit number to be freed

!EOP

   !----- local -----

   !----- formats -----
   character(*), parameter :: subName = '(shr_file_freeUnit) '
   character(*), parameter :: F00 =   "('(shr_file_freeUnit) ',A,I4,A)"

!-------------------------------------------------------------------------------
! Notes:
!-------------------------------------------------------------------------------

   if (unit < 0 .or. unit > shr_file_maxUnit) then
      if (s_loglev > 0) write(s_logunit,F00) 'invalid unit number request:', unit
   else if (unit == 0 .or. unit == 5 .or. unit == 6) then
      call shr_sys_abort( subName//': Error: units 0, 5, and 6 must not be freed' )
   else if (UnitTag(unit)) then
      UnitTag (unit) = .false.
   else
      if (s_loglev > 0) write(s_logunit,F00) 'unit ', unit, ' was not in use'
   end if

   return

END SUBROUTINE shr_file_freeUnit

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_file_stdio -- Change working directory, and redirect stdin/stdout
!
! !DESCRIPTION:
!   1) change the cwd (current working directory) and 
!   2) redirect stdin & stdout (units 5 & 6) to named files,
!   where the desired cwd & files are specified by namelist file.
!
!   Normally this is done to work around limitations in the execution syntax
!   of common MPI implementations.  For example, SGI's mpirun syntax is not 
!   flexible enough to allow MPMD models to select different execution
!   directories or to redirect stdin & stdout on the command line.  
!   Such functionality is highly desireable for CCSM purposes.  
!   ie. mpirun can't handle this:
!   unix> cd /usr/tmp/jdoe/csm/case01/atm ; atm < atm.parm > atm.log &
!   unix> cd /usr/tmp/jdoe/csm/case01/cpl ; cpl < cpl.parm > cpl.log &
!   etc.
!
! ASSUMPTIONS:
! o if the cwd, stdin, or stdout are to be changed, there must be a namelist
!   file in the cwd named <model>_stdio.nml  where <model> is provided via
!   subroutine dummy argument. 
!
! !INTERFACE: ------------------------------------------------------------------  

SUBROUTINE shr_file_stdio(model)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*),intent(in) :: model ! used to construct env varible name

!EOP

   !--- formats ---
   character(*),parameter :: subName = '(shr_file_stdio) '
   character(*),parameter :: F00   = "('(shr_file_stdio) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
!-------------------------------------------------------------------------------

   call shr_file_chdir   (model) ! changes cwd
   call shr_file_chStdOut(model) ! open units 5 & 6 to named files
   call shr_file_chStdIn (model) ! open units 5 & 6 to named files
 
END SUBROUTINE shr_file_stdio

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_file_chdir -- Change working directory.
!
! !DESCRIPTION:
!   change the cwd (current working directory), see shr_file_stdio for notes
!
! !INTERFACE: ------------------------------------------------------------------  

SUBROUTINE shr_file_chdir(model, rcodeOut)

! !USES:

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)        ,intent(in)           :: model    ! used to construct env varible name
   integer(SHR_KIND_IN),intent(out),optional :: rcodeOut ! Return error code

!EOP

   !--- local ---
   character(SHR_KIND_CL) :: dir      ! directory to cd to
   integer  (SHR_KIND_IN) :: rcode    ! Return error code
   character(SHR_KIND_CL) :: filename ! namelist file to read

   !--- formats ---
   character(*),parameter :: subName = '(shr_file_chdir) '
   character(*),parameter :: F00 =   "('(shr_file_chdir) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
!-------------------------------------------------------------------------------

   call shr_file_stdioReadNL( model, filename, dirOut=dir, rcodeOut=rcode )
   if (dir /= "nochange") then
      call shr_sys_chdir(dir ,rcode)
      if (s_loglev > 0) write(s_logunit,F00) "read ",trim(filename),", changed cwd to ",trim(dir)
   else
      if (s_loglev > 0) write(s_logunit,F00) "read ",trim(filename),", cwd has *not* been changed"
      rcode = 1
   endif
   if ( present(rcodeOut) ) rcodeOut = rcode
 
END SUBROUTINE shr_file_chdir

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_file_dirio --- Change stdin and stdout.
!
! !DESCRIPTION:
!   change the stdin & stdout (units 5 & 6), see shr_file_stdio for notes
!
! !INTERFACE: ------------------------------------------------------------------  

SUBROUTINE shr_file_dirio(model)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*),intent(in) :: model ! used to construct env varible name

!EOP

   !--- local ---

   !--- formats ---
   character(*),parameter :: subName = '(shr_file_dirio) '

!-------------------------------------------------------------------------------
! Notes:
!
!-------------------------------------------------------------------------------

   call shr_file_chStdIn (model)
   call shr_file_chStdOut(model)
 
END SUBROUTINE shr_file_dirio

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_file_chStdIn -- Change stdin
!
! !DESCRIPTION:
!   change the stdin (unit 5), see shr_file_stdio for notes
!
! !INTERFACE: ------------------------------------------------------------------  

SUBROUTINE shr_file_chStdIn( model, NLFilename, rcodeOut )

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)          ,intent(in)           :: model      ! used to construct env var name
   character(SHR_KIND_CL),intent(out),optional :: NLFilename ! open unit 5 to this
   integer  (SHR_KIND_IN),intent(out),optional :: rcodeOut   ! return code

!EOP

   !--- local ---
   character(SHR_KIND_CL) :: stdin    ! open unit 5 to this file
   character(SHR_KIND_CL) :: nlfile   ! Namelist filename for model to read from
   character(SHR_KIND_CL) :: filename ! namelist file to read
   integer  (SHR_KIND_IN) :: rcode    ! return code

   !--- formats ---
   character(*),parameter :: subName = '(shr_file_chStdIn) '
   character(*),parameter :: F00   = "('(shr_file_chStdIn) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
!-------------------------------------------------------------------------------

   call shr_file_stdioReadNL( model, filename, stdinOut=stdin, &
                              nlfileOut=nlfile, rcodeOut=rcode )
   if (stdin  /= "nochange") then
      open(unit=5,file=stdin ,status='UNKNOWN',iostat=rcode)
      if ( rcode /= 0 )then
         if (s_loglev > 0) &
            write(s_logunit,F00) "read ",trim(filename),': error opening file as unit 5:', &
                      trim(nlfile)
      else
         if (s_loglev > 0) &
            write(s_logunit,F00) "read ",trim(filename),': unit 5 connected to ', &
                      trim(stdin)
      end if
   else
      if (s_loglev > 0) write(s_logunit,F00) "read ",trim(filename), &
         ': unit 5 has *not* been redirected'
   endif
   if ( len_trim(nlfile) > 0) then
      if (s_loglev > 0) write(s_logunit,F00) "read ",trim(filename), &
         ': read namelist from file:',trim(nlfile)
      if ( .not. present(NLFilename) )then
         if (s_loglev > 0) write(s_logunit,F00) "error: namelist filename NOT present"
         rcode = 7
      end if
   else
      if (s_loglev > 0) write(s_logunit,F00) "read ",trim(filename),", "
      if ( present(NLFilename) )then
         if (s_loglev > 0) write(s_logunit,F00) "error: namelist filename present, but null"
         rcode = 8
      end if
   endif
   if ( present(NLFilename) ) NLFilename = nlfile
   if ( present(rcodeOut)   ) rcodeOut   = rcode
 
END SUBROUTINE shr_file_chStdIn

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_file_stdout -- Change stdout
!
! !DESCRIPTION:
!   change the stdout (unit 6), see shr_file_stdio for notes
!
! !INTERFACE: ------------------------------------------------------------------  

SUBROUTINE shr_file_chStdOut(model,rcodeOut)

   implicit none

! !INPUT/OUTPUT PARAMETERS:
   !--- arguments ---
   character(*)        ,intent(in)           :: model    ! used to construct env varible name
   integer(SHR_KIND_IN),intent(out),optional :: rcodeOut ! Return error code
!EOP

   !--- local ---
   character(SHR_KIND_CL) :: filename ! namelist file to read
   character(SHR_KIND_CL) :: stdout   ! open unit 6 to this file
   integer  (SHR_KIND_IN) :: rcode    ! return code

   !--- formats ---
   character(*),parameter :: subName = '(shr_file_chStdOut) '
   character(*),parameter :: F00   = "('(shr_file_chStdOut) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
!-------------------------------------------------------------------------------

   call shr_file_stdioReadNL( model, filename, stdoutOut=stdout, &
                              rcodeOut=rcode )
   if (stdout /= "nochange") then
      close(6)
      open(unit=6,file=stdout,position='APPEND')
      if (s_loglev > 0) write(s_logunit,F00) "read ",trim(filename),  &
         ': unit 6 connected to ',trim(stdout)
      call shr_sys_flush(s_logunit)
   else
      if (s_loglev > 0) write(s_logunit,F00) "read ",trim(filename),  &
         ': unit 6 has *not* been redirected'
      rcode = 1
   endif
 
   if ( present(rcodeOut)   ) rcodeOut = rcode
 
END SUBROUTINE shr_file_chStdOut

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_file_stdioReadNL -- read in stdio namelist
!
! !DESCRIPTION:
!   Read in the stdio namelist for any given model type. Return any of the
! needed input namelist variables as optional arguments. Return "nochange" in
! dir, stdin, or stdout if shouldn't change.
!
! !INTERFACE: ------------------------------------------------------------------  

SUBROUTINE shr_file_stdioReadNL( model, filename, dirOut, stdinOut, stdoutOut, &
                                 NLFileOut, rcodeOut )

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)          ,intent(in)           :: model     ! used to construct env varible name
   character(SHR_KIND_CL),intent(out)          :: filename  ! nml file to read from unit 5
   character(SHR_KIND_CL),intent(out),optional :: NLFileOut ! open unit 6 to this file
   character(SHR_KIND_CL),intent(out),optional :: dirOut    ! directory to cd to
   character(SHR_KIND_CL),intent(out),optional :: stdinOut  ! open unit 5 to this file
   character(SHR_KIND_CL),intent(out),optional :: stdoutOut ! open unit 6 to this file
   integer  (SHR_KIND_IN),intent(out),optional :: rcodeOut  ! return code

!EOP

   !--- local ---
   logical                :: exists   ! true iff file exists
   character(SHR_KIND_CL) :: dir      ! directory to cd to
   character(SHR_KIND_CL) :: stdin    ! open unit 5 to this file
   character(SHR_KIND_CL) :: stdout   ! open unit 6 to this file
   character(SHR_KIND_CL) :: NLFile   ! namelist file to read seperately
   integer  (SHR_KIND_IN) :: rcode    ! return code
   integer  (SHR_KIND_IN) :: unit     ! Unit to read from

   namelist / stdio / dir,stdin,stdout,NLFile

   !--- formats ---
   character(*),parameter :: subName = '(shr_file_stdioReadNL) '
   character(*),parameter :: F00   = "('(shr_file_stdioReadNL) ',4a)"
   character(*),parameter :: F01   = "('(shr_file_stdioReadNL) ',2a,i6)"

!-------------------------------------------------------------------------------
! Notes:
!
!-------------------------------------------------------------------------------

   rcode  = 0
   dir    = "nochange"
   stdin  = "nochange"
   stdout = "nochange"
   NLFile = " "

   filename = trim(model)//"_stdio.nml"  ! eg. file="cpl_stdio.nml"
   inquire(file=filename,exist=exists)

   if (.not. exists) then
      if (s_loglev > 0) write(s_logunit,F00) "file ",trim(filename),& 
      & " doesn't exist, can not read stdio namelist from it"
      rcode = 9
   else
      unit = shr_file_getUnit()
      open (unit,file=filename,action="READ")
      read (unit,nml=stdio,iostat=rcode)
      close(unit)
      call shr_file_freeUnit( unit )
      if (rcode /= 0) then
         write(s_logunit,F01) 'ERROR: reading ',trim(filename),': iostat=',rcode
         call shr_sys_abort(subName//" ERROR reading "//trim(filename) )
      end if
   endif
   if ( len_trim(NLFile) > 0 .and. trim(stdin) /= "nochange" )then
      write(s_logunit,F00) "Error: input namelist:"
      write(s_logunit,nml=stdio)
      call shr_sys_abort(subName//" ERROR trying to both redirect AND "// &
                         "open namelist filename" )
   end if
   if ( present(NLFileOut) ) NLFileOut = NLFile
   if ( present(dirOut)    ) dirOut    = dir
   if ( present(stdinOut)  ) stdinOut  = stdin
   if ( present(stdoutOut) ) stdoutOut = stdout
   if ( present(rcodeOut)  ) rcodeOut  = rcode
 
END SUBROUTINE shr_file_stdioReadNL

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_file_setIO -- read in stdio namelist
!
! !DESCRIPTION:
!   This opens a namelist file specified as an argument and then opens
!   a log file associated with the unit argument.  This may be extended
!   in the future.
!
! !INTERFACE: ------------------------------------------------------------------  

SUBROUTINE shr_file_setIO( nmlfile, funit)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(len=*)    ,intent(in)  :: nmlfile  ! namelist filename
   integer(SHR_KIND_IN),intent(in)  :: funit    ! unit number for log file

!EOP

   !--- local ---
   logical                :: exists   ! true if file exists
   character(SHR_KIND_CL) :: diri     ! directory to cd to
   character(SHR_KIND_CL) :: diro     ! directory to cd to
   character(SHR_KIND_CL) :: logfile  ! open unit 6 to this file
   integer(SHR_KIND_IN)   :: unit     ! unit number
   integer(SHR_KIND_IN)   :: rcode    ! error code

   namelist / modelio / diri,diro,logfile

   !--- formats ---
   character(*),parameter :: subName = '(shr_file_setIO) '
   character(*),parameter :: F00   = "('(shr_file_setIO) ',4a)"
   character(*),parameter :: F01   = "('(shr_file_setIO) ',2a,i6)"

!-------------------------------------------------------------------------------
! Notes:
!
!-------------------------------------------------------------------------------

   diri = "."
   diro = "."
   logfile = ""

   inquire(file=nmlfile,exist=exists)

   if (.not. exists) then
      if (s_loglev > 0) write(s_logunit,F00) "file ",trim(nmlfile)," non existant"
      return
   else
      unit = shr_file_getUnit()
      open (unit,file=nmlfile,action="READ")
      read (unit,nml=modelio,iostat=rcode)
      close(unit)
      call shr_file_freeUnit( unit )
      if (rcode /= 0) then
         write(s_logunit,F01) 'ERROR: reading ',trim(nmlfile),': iostat=',rcode
         call shr_sys_abort(subName//" ERROR reading "//trim(nmlfile) )
      end if
   endif

   if (len_trim(logfile) > 0) then
      open(funit,file=trim(diro)//"/"//trim(logfile))
   else
      if (s_loglev > 0) write(s_logunit,F00) "logfile not opened"
   endif

END SUBROUTINE shr_file_setIO

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_file_setLogUnit -- Set the Log I/O Unit number
!
! !INTERFACE: ------------------------------------------------------------------  

SUBROUTINE shr_file_setLogUnit(unit)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   integer(SHR_KIND_IN),intent(in) :: unit     ! new unit number

!EOP

   !--- formats ---
   character(*),parameter :: subName = '(shr_file_setLogUnit) '
   character(*),parameter :: F00   = "('(shr_file_setLogUnit) ',4a)"

!-------------------------------------------------------------------------------
! Notes: Caller must be sure it's a valid unit number
!-------------------------------------------------------------------------------

   if (s_loglev > 1 .and. s_logunit-unit /= 0) then
      write(s_logunit,*) subName,': reset log unit number from/to ',s_logunit, unit
      write(     unit,*) subName,': reset log unit number from/to ',s_logunit, unit
   endif

   s_logunit = unit
 
END SUBROUTINE shr_file_setLogUnit

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_file_setLogLevel -- Set the Log I/O Unit number
!
! !INTERFACE: ------------------------------------------------------------------  

SUBROUTINE shr_file_setLogLevel(newlevel)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   integer(SHR_KIND_IN),intent(in) :: newlevel     ! new log level

!EOP

   !--- formats ---
   character(*),parameter :: subName = '(shr_file_setLogLevel) '
   character(*),parameter :: F00   = "('(shr_file_setLogLevel) ',4a)"

!-------------------------------------------------------------------------------
! Notes: 
!-------------------------------------------------------------------------------

   if (s_loglev+newlevel > 2 .and. s_loglev-newlevel /= 0) &
      write(s_logunit,*) subName,': reset log level from/to ',s_loglev, newlevel

   s_loglev = newlevel
 
END SUBROUTINE shr_file_setLogLevel

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_file_getLogUnit -- Set the Log I/O Unit number
!
! !INTERFACE: ------------------------------------------------------------------  

SUBROUTINE shr_file_getLogUnit(unit)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   integer(SHR_KIND_IN),intent(out) :: unit     ! new unit number

!EOP

   !--- formats ---
   character(*),parameter :: subName = '(shr_file_getLogUnit) '
   character(*),parameter :: F00   = "('(shr_file_getLogUnit) ',4a)"

!-------------------------------------------------------------------------------
! Notes: 
!-------------------------------------------------------------------------------

   unit = s_logunit
 
END SUBROUTINE shr_file_getLogUnit

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_file_getLogLevel -- Set the Log I/O Unit number
!
! !INTERFACE: ------------------------------------------------------------------  

SUBROUTINE shr_file_getLogLevel(curlevel)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   integer(SHR_KIND_IN),intent(out) :: curlevel     ! new log level

!EOP

   !--- formats ---
   character(*),parameter :: subName = '(shr_file_getLogLevel) '
   character(*),parameter :: F00   = "('(shr_file_getLogLevel) ',4a)"

!-------------------------------------------------------------------------------
! Notes: 
!-------------------------------------------------------------------------------

   curlevel = s_loglev
 
END SUBROUTINE shr_file_getLogLevel

!===============================================================================
!===============================================================================

END MODULE shr_file_mod

module fileutils

!-----------------------------------------------------------------------
!BOP
!
! !MODULE: fileutils
!
! !DESCRIPTION:
! Module containing file I/O utilities
!
! !USES:
  use clm_varctl,  only : iulog
  use shr_sys_mod, only : shr_sys_abort
!
! !PUBLIC TYPES:
  implicit none
  save
!
! !PUBLIC MEMBER FUNCTIONS:
  public :: get_filename  !Returns filename given full pathname
  public :: opnfil        !Open local unformatted or formatted file
  public :: getfil        !Obtain local copy of file
  public :: relavu        !Close and release Fortran unit no longer in use
  public :: getavu        !Get next available Fortran unit number
!
! !REVISION HISTORY:
! Created by Mariana Vertenstein
!
!
! !PRIVATE MEMBER FUNCTIONS: None
!EOP
!-----------------------------------------------------------------------

contains

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: get_filename
!
! !INTERFACE:
  character(len=256) function get_filename (fulpath)
!
! !DESCRIPTION:
! Returns filename given full pathname
!
! !ARGUMENTS:
    implicit none
    character(len=*), intent(in)  :: fulpath !full pathname
!
! !REVISION HISTORY:
! Created by Mariana Vertenstein
!
!
! !LOCAL VARIABLES:
!EOP
    integer i               !loop index
    integer klen            !length of fulpath character string
!------------------------------------------------------------------------

    klen = len_trim(fulpath)
    do i = klen, 1, -1
       if (fulpath(i:i) == '/') go to 10
    end do
    i = 0
10  get_filename = fulpath(i+1:klen)

    return
  end function get_filename

!------------------------------------------------------------------------
!BOP
!
! !IROUTINE: getfil
!
! !INTERFACE:
   subroutine getfil (fulpath, locfn, iflag)
!
! !DESCRIPTION:
! Obtain local copy of file
! First check current working directory
! Next check full pathname[fulpath] on disk
! 
! !USES:
     use shr_file_mod, only: shr_file_get
! !ARGUMENTS:
     implicit none
     character(len=*), intent(in)  :: fulpath !Archival or permanent disk full pathname
     character(len=*), intent(out) :: locfn   !output local file name
     integer, optional, intent(in) :: iflag   !0=>abort if file not found 1=>do not abort
!
! !REVISION HISTORY:
! Created by Mariana Vertenstein
!
!
! !LOCAL VARIABLES:
!EOP
     integer i               !loop index
     integer klen            !length of fulpath character string
     logical lexist          !true if local file exists
!------------------------------------------------------------------------

     ! get local file name from full name

     locfn = get_filename( fulpath )
     if (len_trim(locfn) == 0) then
	write(iulog,*)'(GETFIL): local filename has zero length'
        call shr_sys_abort
     else
        write(iulog,*)'(GETFIL): attempting to find local file ',  &
             trim(locfn)
     endif

     ! first check if file is in current working directory.

     inquire (file=locfn,exist=lexist)
     if (lexist) then
        write(iulog,*) '(GETFIL): using ',trim(locfn), &
             ' in current working directory'
        RETURN
     endif

     ! second check for full pathname on disk
     locfn = fulpath

     inquire (file=fulpath,exist=lexist)
     if (lexist) then
        write(iulog,*) '(GETFIL): using ',trim(fulpath)
        RETURN
     else
        write(iulog,*)'(GETFIL): failed getting file from full path: ', fulpath
        if (present(iflag) .and. iflag==0) then
           call shr_sys_abort ('GETFIL: FAILED to get '//trim(fulpath))
        else
           RETURN
        endif
     endif

   end subroutine getfil

!------------------------------------------------------------------------
!BOP
!
! !IROUTINE: opnfil
!
! !INTERFACE:
   subroutine opnfil (locfn, iun, form)
!
! !DESCRIPTION:
! Open file locfn in unformatted or formatted form on unit iun
!
! !ARGUMENTS:
!
     implicit none
     character(len=*), intent(in):: locfn  !file name
     integer, intent(in):: iun             !fortran unit number
     character(len=1), intent(in):: form   !file format: u = unformatted,
                                           !f = formatted
!
! !REVISION HISTORY:
! Created by Mariana Vertenstein
!
!
! !LOCAL VARIABLES:
!EOP
     integer ioe             !error return from fortran open
     character(len=11) ft    !format type: formatted. unformatted
!------------------------------------------------------------------------

     if (len_trim(locfn) == 0) then
        write(iulog,*)'(OPNFIL): local filename has zero length'
        call shr_sys_abort
     endif
     if (form=='u' .or. form=='U') then
        ft = 'unformatted'
     else
        ft = 'formatted  '
     end if
     open (unit=iun,file=locfn,status='unknown',form=ft,iostat=ioe)
     if (ioe /= 0) then
        write(iulog,*)'(OPNFIL): failed to open file ',trim(locfn),        &
             &     ' on unit ',iun,' ierr=',ioe
        call shr_sys_abort
     else
        write(iulog,*)'(OPNFIL): Successfully opened file ',trim(locfn),   &
             &     ' on unit= ',iun
     end if

   end subroutine opnfil

!------------------------------------------------------------------------
!BOP
!
! !IROUTINE: getavu
!
! !INTERFACE:
  integer function getavu()
!
! !DESCRIPTION:
! Get next available Fortran unit number.
!
! !USES:
   use shr_file_mod, only : shr_file_getUnit
!
! !ARGUMENTS:
    implicit none
!
! !REVISION HISTORY:
! Created by Gordon Bonan
! Modified for clm2 by Mariana Vertenstein
!
!
! !LOCAL VARIABLES:
!EOP
!------------------------------------------------------------------------

    getavu = shr_file_getunit()

  end function getavu

!------------------------------------------------------------------------
!BOP
!
! !IROUTINE: relavu
!
! !INTERFACE:
  subroutine relavu (iunit)
!
! !DESCRIPTION:
! Close and release Fortran unit no longer in use!
!
! !USES:
   use shr_file_mod, only : shr_file_freeUnit
!
! !ARGUMENTS:
    implicit none
    integer, intent(in) :: iunit    !Fortran unit number
!
! !REVISION HISTORY:
! Created by Gordon Bonan
!
!EOP
!------------------------------------------------------------------------

    close(iunit)
    call shr_file_freeUnit(iunit)

  end subroutine relavu

end module fileutils

! copied from cam3_5_26.  Get rid of some CAM utilities to avoid
! spiralling into the dependency abyss!
! remove use association of cam_abortutils, scamMod, cam_logfile

module interpolate_data
! Description:
!   Routines for interpolation of data in latitude, longitude and time.
!
! Author: Gathered from a number of places and put into the current format by Jim Edwards
!   
! Modules Used:
!
  use shr_kind_mod,   only: r8 => shr_kind_r8
  implicit none
  private
!
! Public Methods:
!

  public :: interp_type, lininterp, vertinterp, bilin, get_timeinterp_factors
  public :: lininterp_init, lininterp_finish
  type interp_type
     private
     real(r8), pointer :: wgts(:)
     real(r8), pointer :: wgtn(:)
     integer, pointer  :: jjm(:)
     integer, pointer  :: jjp(:)
  end type interp_type
  interface lininterp
     module procedure lininterp_original
     module procedure lininterp_full1d
     module procedure lininterp1d
     module procedure lininterp2d2d
     module procedure lininterp2d1d
  end interface
  
  integer, parameter :: iulog = 6

contains
  subroutine lininterp_full1d (arrin, yin, nin, arrout, yout, nout)
    integer, intent(in) :: nin, nout
    real(r8), intent(in) :: arrin(nin), yin(nin), yout(nout)
    real(r8), intent(out) :: arrout(nout)
    type (interp_type) :: interp_wgts

    call lininterp_init(yin, nin, yout, nout, 1, interp_wgts)
    call lininterp1d(arrin, nin, arrout, nout, interp_wgts)
    call lininterp_finish(interp_wgts)

  end subroutine lininterp_full1d

  subroutine lininterp_init(yin, nin, yout, nout, extrap_method, interp_wgts, &
       cyclicmin, cyclicmax)
!
! Description:
!   Initialize a variable of type(interp_type) with weights for linear interpolation.
!       this variable can then be used in calls to lininterp1d and lininterp2d.
!   yin is a 1d array of length nin of locations to interpolate from - this array must 
!       be monotonic but can be increasing or decreasing
!   yout is a 1d array of length nout of locations to interpolate to, this array need
!       not be ordered
!   extrap_method determines how to handle yout points beyond the bounds of yin
!       if 0 set values outside output grid to 0 
!       if 1 set to boundary value
!       if 2 set to cyclic boundaries
!         optional values cyclicmin and cyclicmax can be used to set the bounds of the 
!         cyclic mapping - these default to 0 and 360.
!

    integer, intent(in) :: nin
    integer, intent(in) :: nout
    real(r8), intent(in) :: yin(nin)           ! input mesh
    real(r8), intent(in) :: yout(nout)         ! output mesh
    integer, intent(in) :: extrap_method       ! if 0 set values outside output grid to 0 
                                               ! if 1 set to boundary value
                                               ! if 2 set to cyclic boundaries
    real(r8), intent(in), optional :: cyclicmin, cyclicmax

    type (interp_type), intent(out) :: interp_wgts
    real(r8) :: cmin, cmax
    real(r8) :: extrap
    real(r8) :: dyinwrap
    real(r8) :: ratio
    real(r8) :: avgdyin
    integer :: i, j, icount
    integer :: jj
    real(r8), pointer :: wgts(:)
    real(r8), pointer :: wgtn(:)
    integer, pointer :: jjm(:)
    integer, pointer :: jjp(:)
    logical :: increasing
    !
    ! Check validity of input coordinate arrays: must be monotonically increasing,
    ! and have a total of at least 2 elements
    !
    if (nin.lt.2) then
       call endrun('LININTERP: Must have at least 2 input points for interpolation')
    end if
    if(present(cyclicmin)) then
       cmin=cyclicmin
    else
       cmin=0_r8
    end if
    if(present(cyclicmax)) then
       cmax=cyclicmax
    else
       cmax=360_r8
    end if
    if(cmax<=cmin) then
       call endrun('LININTERP: cyclic min value must be < max value')
    end if
    increasing=.true.
    icount = 0
    do j=1,nin-1
       if (yin(j).gt.yin(j+1)) icount = icount + 1
    end do
    if(icount.eq.nin-1) then
       increasing = .false.
       icount=0
    endif
    if (icount.gt.0) then
       call endrun('LININTERP: Non-monotonic input coordinate array found')
    end if
    allocate(interp_wgts%jjm(nout), &
         interp_wgts%jjp(nout), &
         interp_wgts%wgts(nout), &
         interp_wgts%wgtn(nout))

    jjm => interp_wgts%jjm
    jjp => interp_wgts%jjp
    wgts =>  interp_wgts%wgts
    wgtn =>  interp_wgts%wgtn

    !
    ! Initialize index arrays for later checking
    !
    jjm = 0
    jjp = 0

    extrap = 0.
    if(extrap_method.eq.0) then
       !
       ! For values which extend beyond boundaries, set weights
       ! such that values will be 0.
       !
       do j=1,nout
          if(increasing) then
             if (yout(j).lt.yin(1)) then
                jjm(j) = 1
                jjp(j) = 1
                wgts(j) = 0.
                wgtn(j) = 0.
                extrap = extrap + 1.
             else if (yout(j).gt.yin(nin)) then
                jjm(j) = nin
                jjp(j) = nin
                wgts(j) = 0.
                wgtn(j) = 0.
                extrap = extrap + 1.
             end if
          else
             if (yout(j).gt.yin(1)) then
                jjm(j) = 1
                jjp(j) = 1
                wgts(j) = 0.
                wgtn(j) = 0.
                extrap = extrap + 1.
             else if (yout(j).lt.yin(nin)) then
                jjm(j) = nin
                jjp(j) = nin
                wgts(j) = 0.
                wgtn(j) = 0.
                extrap = extrap + 1.
             end if
          end if
       end do
    else if(extrap_method.eq.1) then
       !
       ! For values which extend beyond boundaries, set weights
       ! such that values will just be copied.
       !
       do j=1,nout
          if(increasing) then
             if (yout(j).le.yin(1)) then
                jjm(j) = 1
                jjp(j) = 1
                wgts(j) = 1.
                wgtn(j) = 0.
                extrap = extrap + 1.
             else if (yout(j).gt.yin(nin)) then
                jjm(j) = nin
                jjp(j) = nin
                wgts(j) = 1.
                wgtn(j) = 0.
                extrap = extrap + 1.
             end if
          else
             if (yout(j).gt.yin(1)) then
                jjm(j) = 1
                jjp(j) = 1
                wgts(j) = 1.
                wgtn(j) = 0.
                extrap = extrap + 1.
             else if (yout(j).le.yin(nin)) then
                jjm(j) = nin
                jjp(j) = nin
                wgts(j) = 1.
                wgtn(j) = 0.
                extrap = extrap + 1.
             end if
          end if
       end do
    else if(extrap_method.eq.2) then
       !
       ! For values which extend beyond boundaries, set weights
       ! for circular boundaries 
       !
       dyinwrap = yin(1) + (cmax-cmin) - yin(nin)
       avgdyin = abs(yin(nin)-yin(1))/(nin-1.)
       ratio = dyinwrap/avgdyin
       if (ratio < 0.9 .or. ratio > 1.1) then
          write(iulog,*) 'Lininterp: Bad dyinwrap value =',dyinwrap,&
               ' avg=', avgdyin, yin(1),yin(nin)
          call endrun('interpolate_data')
       end if

       do j=1,nout
          if(increasing) then
             if (yout(j) <= yin(1)) then
                jjm(j) = nin
                jjp(j) = 1
                wgts(j) = (yin(1)-yout(j))/dyinwrap
                wgtn(j) = (yout(j)+(cmax-cmin) - yin(nin))/dyinwrap
             else if (yout(j) > yin(nin)) then
                jjm(j) = nin
                jjp(j) = 1
                wgts(j) = (yin(1)+(cmax-cmin)-yout(j))/dyinwrap
                wgtn(j) = (yout(j)-yin(nin))/dyinwrap
             end if
          else
             if (yout(j) > yin(1)) then
                jjm(j) = nin
                jjp(j) = 1
                wgts(j) = (yin(1)-yout(j))/dyinwrap
                wgtn(j) = (yout(j)+(cmax-cmin) - yin(nin))/dyinwrap
             else if (yout(j) <= yin(nin)) then
                jjm(j) = nin
                jjp(j) = 1
                wgts(j) = (yin(1)+(cmax-cmin)-yout(j))/dyinwrap
                wgtn(j) = (yout(j)+(cmax-cmin)-yin(nin))/dyinwrap
             end if

          endif
       end do
    end if

    !
    ! Loop though output indices finding input indices and weights
    !
    if(increasing) then
       do j=1,nout
          do jj=1,nin-1
             if (yout(j).gt.yin(jj) .and. yout(j).le.yin(jj+1)) then
                jjm(j) = jj
                jjp(j) = jj + 1
                wgts(j) = (yin(jj+1)-yout(j))/(yin(jj+1)-yin(jj))
                wgtn(j) = (yout(j)-yin(jj))/(yin(jj+1)-yin(jj))
                exit
             end if
          end do
       end do
    else
       do j=1,nout
          do jj=1,nin-1
             if (yout(j).le.yin(jj) .and. yout(j).gt.yin(jj+1)) then
                jjm(j) = jj
                jjp(j) = jj + 1
                wgts(j) = (yin(jj+1)-yout(j))/(yin(jj+1)-yin(jj))
                wgtn(j) = (yout(j)-yin(jj))/(yin(jj+1)-yin(jj))
                exit
             end if
          end do
       end do
    end if

#ifndef SPMD
    !
    ! Check grid overlap
    !
    extrap = 100.*extrap/real(nout,r8)
    if (extrap.gt.50.) then
       write(iulog,*) 'interpolate_data:','yout=',minval(yout),maxval(yout),increasing,nout
       write(iulog,*) 'interpolate_data:','yin=',yin(1),yin(nin)
       write(iulog,*) 'interpolate_data:',extrap,' % of output grid will have to be extrapolated'
       call endrun('interpolate_data: ')
    end if
#endif

    !
    ! Check that interp/extrap points have been found for all outputs
    !
    icount = 0
    do j=1,nout
       if (jjm(j).eq.0 .or. jjp(j).eq.0) icount = icount + 1
       ratio=wgts(j)+wgtn(j)
       if((ratio<0.9.or.ratio>1.1).and.extrap_method.ne.0) then
          write(iulog,*) j, wgts(j),wgtn(j),jjm(j),jjp(j), increasing,extrap_method
          call endrun('Bad weight computed in LININTERP_init')
       end if
    end do
    if (icount.gt.0) then
       call endrun('LININTERP: Point found without interp indices')
    end if

  end subroutine lininterp_init

  subroutine lininterp1d (arrin, n1, arrout, m1, interp_wgts)
    !-----------------------------------------------------------------------
    !
    ! Purpose: Do a linear interpolation from input mesh to output
    !          mesh with weights as set in lininterp_init.
    !
    !
    ! Author: Jim Edwards
    !
    !-----------------------------------------------------------------------
    !-----------------------------------------------------------------------
    implicit none
    !-----------------------------------------------------------------------
    !
    ! Arguments
    !
    integer, intent(in) :: n1                 ! number of input latitudes
    integer, intent(in) :: m1                ! number of output latitudes

    real(r8), intent(in) :: arrin(n1)    ! input array of values to interpolate
    type(interp_type), intent(in) :: interp_wgts
    real(r8), intent(out) :: arrout(m1) ! interpolated array

    !
    ! Local workspace
    !
    integer j                ! latitude indices
    integer, pointer :: jjm(:)
    integer, pointer :: jjp(:)

    real(r8), pointer :: wgts(:)
    real(r8), pointer :: wgtn(:)

    jjm => interp_wgts%jjm
    jjp => interp_wgts%jjp
    wgts =>  interp_wgts%wgts
    wgtn =>  interp_wgts%wgtn

    !
    ! Do the interpolation
    !
    do j=1,m1
      arrout(j) = arrin(jjm(j))*wgts(j) + arrin(jjp(j))*wgtn(j)
    end do

    return
  end subroutine lininterp1d

  subroutine lininterp2d2d(arrin, n1, n2, arrout, m1, m2, wgt1, wgt2)
    implicit none
    !-----------------------------------------------------------------------
    !
    ! Arguments
    !
    integer, intent(in) :: n1, n2, m1, m2
    real(r8), intent(in) :: arrin(n1,n2)    ! input array of values to interpolate
    type(interp_type), intent(in) :: wgt1, wgt2
    real(r8), intent(out) :: arrout(m1,m2) ! interpolated array
    !
    ! locals
    !
    integer i,j                ! indices
    integer, pointer :: iim(:), jjm(:)
    integer, pointer :: iip(:), jjp(:)

    real(r8), pointer :: wgts1(:), wgts2(:)
    real(r8), pointer :: wgtn1(:), wgtn2(:)

    real(r8) :: arrtmp(n1,m2)

    jjm => wgt2%jjm
    jjp => wgt2%jjp
    wgts2 => wgt2%wgts
    wgtn2 => wgt2%wgtn

    iim => wgt1%jjm
    iip => wgt1%jjp
    wgts1 => wgt1%wgts
    wgtn1 => wgt1%wgtn

    do j=1,m2
      do i=1,n1
        arrtmp(i,j) = arrin(i,jjm(j))*wgts2(j) + arrin(i,jjp(j))*wgtn2(j)
      end do
    end do

    do j=1,m2
      do i=1,m1
        arrout(i,j) = arrtmp(iim(i),j)*wgts1(i) + arrtmp(iip(i),j)*wgtn1(i)
      end do
    end do

  end subroutine lininterp2d2d
  subroutine lininterp2d1d(arrin, n1, n2, arrout, m1, wgt1, wgt2)
    implicit none
    !-----------------------------------------------------------------------
    !
    ! Arguments
    !
    integer, intent(in) :: n1, n2, m1
    real(r8), intent(in) :: arrin(n1,n2)    ! input array of values to interpolate
    type(interp_type), intent(in) :: wgt1, wgt2
    real(r8), intent(out) :: arrout(m1) ! interpolated array
    !
    ! locals
    !
    integer i,j                ! indices
    integer, pointer :: iim(:), jjm(:)
    integer, pointer :: iip(:), jjp(:)

    real(r8), pointer :: wgts(:), wgte(:)
    real(r8), pointer :: wgtn(:), wgtw(:)

    real(r8) :: avg


    jjm => wgt2%jjm
    jjp => wgt2%jjp
    wgts => wgt2%wgts
    wgtn => wgt2%wgtn

    iim => wgt1%jjm
    iip => wgt1%jjp
    wgtw => wgt1%wgts
    wgte => wgt1%wgtn

    do i=1,m1
       arrout(i) = arrin(iim(i),jjm(i))*wgtw(i)*wgts(i)+arrin(iip(i),jjm(i))*wgte(i)*wgts(i) + &
                   arrin(iim(i),jjp(i))*wgtw(i)*wgtn(i)+arrin(iip(i),jjp(i))*wgte(i)*wgtn(i)
    end do

  end subroutine lininterp2d1d


  subroutine lininterp_finish(interp_wgts)
    type(interp_type) :: interp_wgts

    deallocate(interp_wgts%jjm, &
         interp_wgts%jjp, &
         interp_wgts%wgts, &
         interp_wgts%wgtn)

    nullify(interp_wgts%jjm, &
         interp_wgts%jjp, &
         interp_wgts%wgts, &
         interp_wgts%wgtn)
  end subroutine lininterp_finish

  subroutine lininterp_original (arrin, yin, nlev, nlatin, arrout, &
       yout, nlatout)
    !----------------------------------------------------------------------- 
    ! 
    ! Purpose: Do a linear interpolation from input mesh defined by yin to output
    !          mesh defined by yout.  Where extrapolation is necessary, values will
    !          be copied from the extreme edge of the input grid.  Vectorization is over
    !          the vertical (nlev) dimension.
    ! 
    ! Method: Check validity of input, then determine weights, then do the N-S interpolation.
    ! 
    ! Author: Jim Rosinski
    ! Modified: Jim Edwards so that there is no requirement of monotonacity on the yout array
    !
    !-----------------------------------------------------------------------
    implicit none
    !-----------------------------------------------------------------------
    !
    ! Arguments
    !
    integer, intent(in) :: nlev                   ! number of vertical levels
    integer, intent(in) :: nlatin                 ! number of input latitudes
    integer, intent(in) :: nlatout                ! number of output latitudes

    real(r8), intent(in) :: arrin(nlev,nlatin)    ! input array of values to interpolate
    real(r8), intent(in) :: yin(nlatin)           ! input mesh
    real(r8), intent(in) :: yout(nlatout)         ! output mesh

    real(r8), intent(out) :: arrout(nlev,nlatout) ! interpolated array
    !
    ! Local workspace
    !
    integer j, jj              ! latitude indices
    integer jjprev             ! latitude indices
    integer k                  ! level index
    integer icount             ! number of values

    real(r8) extrap            ! percent grid non-overlap
    !
    ! Dynamic
    !
    integer :: jjm(nlatout)
    integer :: jjp(nlatout)

    real(r8) :: wgts(nlatout)
    real(r8) :: wgtn(nlatout)
    !
    ! Check validity of input coordinate arrays: must be monotonically increasing,
    ! and have a total of at least 2 elements
    !
    if (nlatin.lt.2) then
       call endrun('LININTERP: Must have at least 2 input points for interpolation')
    end if

    icount = 0
    do j=1,nlatin-1
       if (yin(j).gt.yin(j+1)) icount = icount + 1
    end do


    if (icount.gt.0) then
       call endrun('LININTERP: Non-monotonic coordinate array(s) found')
    end if
    !
    ! Initialize index arrays for later checking
    !
    do j=1,nlatout
       jjm(j) = 0
       jjp(j) = 0
    end do
    !
    ! For values which extend beyond N and S boundaries, set weights
    ! such that values will just be copied.
    !
    extrap = 0.

    do j=1,nlatout
       if (yout(j).le.yin(1)) then
          jjm(j) = 1
          jjp(j) = 1
          wgts(j) = 1.
          wgtn(j) = 0.
          extrap=extrap+1.
       else if (yout(j).gt.yin(nlatin)) then
          jjm(j) = nlatin
          jjp(j) = nlatin
          wgts(j) = 1.
          wgtn(j) = 0.
          extrap=extrap+1.
       endif
    end do

    !
    ! Loop though output indices finding input indices and weights
    !
    do j=1,nlatout
       do jj=1,nlatin-1
          if (yout(j).gt.yin(jj) .and. yout(j).le.yin(jj+1)) then
             jjm(j) = jj
             jjp(j) = jj + 1
             wgts(j) = (yin(jj+1)-yout(j))/(yin(jj+1)-yin(jj))
             wgtn(j) = (yout(j)-yin(jj))/(yin(jj+1)-yin(jj))
             exit
          end if
       end do
    end do
    !
    ! Check that interp/extrap points have been found for all outputs
    !
    icount = 0
    do j=1,nlatout
       if (jjm(j).eq.0 .or. jjp(j).eq.0) then
          icount = icount + 1
       end if
    end do
    if (icount.gt.0) then
       call endrun('LININTERP: Point found without interp indices')
    end if
    !
    ! Do the interpolation
    !
    do j=1,nlatout
       do k=1,nlev
          arrout(k,j) = arrin(k,jjm(j))*wgts(j) + arrin(k,jjp(j))*wgtn(j)
       end do
    end do

    return
  end subroutine lininterp_original


  subroutine bilin (arrin, xin, yin, nlondin, nlonin, &
       nlevdin, nlev, nlatin, arrout, xout, &
       yout, nlondout, nlonout, nlevdout, nlatout)
    !----------------------------------------------------------------------- 
    ! 
    ! Purpose: 
    !
    ! Do a bilinear interpolation from input mesh defined by xin, yin to output
    ! mesh defined by xout, yout.  Circularity is assumed in the x-direction so
    ! input x-grid must be in degrees east and must start from Greenwich.  When
    ! extrapolation is necessary in the N-S direction, values will be copied 
    ! from the extreme edge of the input grid.  Vectorization is over the
    ! longitude dimension.  Input grid is assumed rectangular. Output grid
    ! is assumed ragged, i.e. xout is a 2-d mesh.
    ! 
    ! Method: Interpolate first in longitude, then in latitude.
    ! 
    ! Author: Jim Rosinski
    ! 
    !-----------------------------------------------------------------------
    use shr_kind_mod, only: r8 => shr_kind_r8
    !-----------------------------------------------------------------------
    implicit none
    !-----------------------------------------------------------------------
    !
    ! Input arguments
    !
    integer, intent(in) :: nlondin                        ! longitude dimension of input grid
    integer, intent(in) :: nlonin                         ! number of real longitudes (input)
    integer, intent(in) :: nlevdin                        ! vertical dimension of input grid
    integer, intent(in) :: nlev                           ! number of vertical levels
    integer, intent(in) :: nlatin                         ! number of input latitudes
    integer, intent(in) :: nlatout                        ! number of output latitudes
    integer, intent(in) :: nlondout                       ! longitude dimension of output grid
    integer, intent(in) :: nlonout(nlatout)               ! number of output longitudes per lat
    integer, intent(in) :: nlevdout                       ! vertical dimension of output grid

    real(r8), intent(in) :: arrin(nlondin,nlevdin,nlatin) ! input array of values to interpolate
    real(r8), intent(in) :: xin(nlondin)                  ! input x mesh
    real(r8), intent(in) :: yin(nlatin)                   ! input y mesh
    real(r8), intent(in) :: xout(nlondout,nlatout)        ! output x mesh
    real(r8), intent(in) :: yout(nlatout)                 ! output y mesh
    !
    ! Output arguments
    !
    real(r8), intent(out) :: arrout(nlondout,nlevdout,nlatout) ! interpolated array
    !
    ! Local workspace
    !
    integer :: i, ii, iw, ie, iiprev ! longitude indices
    integer :: j, jj, js, jn, jjprev ! latitude indices
    integer :: k                     ! level index
    integer :: icount                ! number of bad values

    real(r8) :: extrap               ! percent grid non-overlap
    real(r8) :: dxinwrap             ! delta-x on input grid for 2-pi
    real(r8) :: avgdxin              ! avg input delta-x
    real(r8) :: ratio                ! compare dxinwrap to avgdxin
    real(r8) :: sum                  ! sum of weights (used for testing)
    !
    ! Dynamic
    !
    integer :: iim(nlondout)         ! interpolation index to the left
    integer :: iip(nlondout)         ! interpolation index to the right
    integer :: jjm(nlatout)          ! interpolation index to the south
    integer :: jjp(nlatout)          ! interpolation index to the north

    real(r8) :: wgts(nlatout)        ! interpolation weight to the north
    real(r8) :: wgtn(nlatout)        ! interpolation weight to the north
    real(r8) :: wgte(nlondout)       ! interpolation weight to the north
    real(r8) :: wgtw(nlondout)       ! interpolation weight to the north
    real(r8) :: igrid(nlonin)        ! interpolation weight to the north
    !
    ! Check validity of input coordinate arrays: must be monotonically increasing,
    ! and have a total of at least 2 elements
    !
    if (nlonin < 2 .or. nlatin < 2) then
       call endrun ('BILIN: Must have at least 2 input points for interpolation')
    end if

    if (xin(1) < 0._r8 .or. xin(nlonin) > 360._r8) then
       call endrun ('BILIN: Input x-grid must be between 0 and 360')
    end if

    icount = 0
    do i=1,nlonin-1
       if (xin(i) >= xin(i+1)) icount = icount + 1
    end do

    do j=1,nlatin-1
       if (yin(j) >= yin(j+1)) icount = icount + 1
    end do

    do j=1,nlatout-1
       if (yout(j) >= yout(j+1)) icount = icount + 1
    end do

    do j=1,nlatout
       do i=1,nlonout(j)-1
          if (xout(i,j) >= xout(i+1,j)) icount = icount + 1
       end do
    end do

    if (icount > 0) then
       call endrun ('BILIN: Non-monotonic coordinate array(s) found')
    end if

    if (yout(nlatout) <= yin(1) .or. yout(1) >= yin(nlatin)) then
       call endrun ('BILIN: No overlap in y-coordinates')
    end if

    do j=1,nlatout
       if (xout(1,j) < 0._r8 .or. xout(nlonout(j),j) > 360._r8) then
          call endrun ('BILIN: Output x-grid must be between 0 and 360')
       end if

       if (xout(nlonout(j),j) <= xin(1) .or.  &
            xout(1,j)          >= xin(nlonin)) then
          call endrun ('BILIN: No overlap in x-coordinates')
       end if
    end do
    !
    ! Initialize index arrays for later checking
    !
    do j=1,nlatout
       jjm(j) = 0
       jjp(j) = 0
    end do
    !
    ! For values which extend beyond N and S boundaries, set weights
    ! such that values will just be copied.
    !
    do js=1,nlatout
       if (yout(js) > yin(1)) exit
       jjm(js) = 1
       jjp(js) = 1
       wgts(js) = 1._r8
       wgtn(js) = 0._r8
    end do

    do jn=nlatout,1,-1
       if (yout(jn) <= yin(nlatin)) exit
       jjm(jn) = nlatin
       jjp(jn) = nlatin
       wgts(jn) = 1._r8
       wgtn(jn) = 0._r8
    end do
    !
    ! Loop though output indices finding input indices and weights
    !
    jjprev = 1
    do j=js,jn
       do jj=jjprev,nlatin-1
          if (yout(j) > yin(jj) .and. yout(j) <= yin(jj+1)) then
             jjm(j) = jj
             jjp(j) = jj + 1
             wgts(j) = (yin(jj+1) - yout(j)) / (yin(jj+1) - yin(jj))
             wgtn(j) = (yout(j)   - yin(jj)) / (yin(jj+1) - yin(jj))
             goto 30
          end if
       end do
       call endrun ('BILIN: Failed to find interp values')
30     jjprev = jj
    end do

    dxinwrap = xin(1) + 360._r8 - xin(nlonin)
    !
    ! Check for sane dxinwrap values.  Allow to differ no more than 10% from avg
    !
    avgdxin = (xin(nlonin)-xin(1))/(nlonin-1._r8)
    ratio = dxinwrap/avgdxin
    if (ratio < 0.9_r8 .or. ratio > 1.1_r8) then
       write(iulog,*)'BILIN: Insane dxinwrap value =',dxinwrap,' avg=', avgdxin
       call endrun
    end if
    !
    ! Check grid overlap
    ! Do not do on spmd since distributed output grid may be expected to fail this test
#ifndef SPMD
    extrap = 100._r8*((js - 1._r8) + real(nlatout - jn,r8))/nlatout
    if (extrap > 20._r8) then
       write(iulog,*)'BILIN:',extrap,' % of N/S output grid will have to be extrapolated'
    end if
#endif
    !
    ! Check that interp/extrap points have been found for all outputs, and that
    ! they are reasonable (i.e. within 32-bit roundoff)
    !
    icount = 0
    do j=1,nlatout
       if (jjm(j) == 0 .or. jjp(j) == 0) icount = icount + 1
       sum = wgts(j) + wgtn(j)
       if (sum < 0.99999_r8 .or. sum > 1.00001_r8) icount = icount + 1
       if (wgts(j) < 0._r8 .or. wgts(j) > 1._r8) icount = icount + 1
       if (wgtn(j) < 0._r8 .or. wgtn(j) > 1._r8) icount = icount + 1
    end do

    if (icount > 0) then
       call endrun ('BILIN: something bad in latitude indices or weights')
    end if
    !
    ! Do the bilinear interpolation
    !
    do j=1,nlatout
       !
       ! Initialize index arrays for later checking
       !
       do i=1,nlondout
          iim(i) = 0
          iip(i) = 0
       end do
       !
       ! For values which extend beyond E and W boundaries, set weights such that
       ! values will be interpolated between E and W edges of input grid.
       !
       do iw=1,nlonout(j)
          if (xout(iw,j) > xin(1)) exit
          iim(iw) = nlonin
          iip(iw) = 1
          wgtw(iw) = (xin(1)        - xout(iw,j))   /dxinwrap
          wgte(iw) = (xout(iw,j)+360._r8 - xin(nlonin))/dxinwrap
       end do

       do ie=nlonout(j),1,-1
          if (xout(ie,j) <= xin(nlonin)) exit
          iim(ie) = nlonin
          iip(ie) = 1
          wgtw(ie) = (xin(1)+360._r8 - xout(ie,j))   /dxinwrap
          wgte(ie) = (xout(ie,j)    - xin(nlonin))/dxinwrap
       end do
       !
       ! Loop though output indices finding input indices and weights
       !
       iiprev = 1
       do i=iw,ie
          do ii=iiprev,nlonin-1
             if (xout(i,j) > xin(ii) .and. xout(i,j) <= xin(ii+1)) then
                iim(i) = ii
                iip(i) = ii + 1
                wgtw(i) = (xin(ii+1) - xout(i,j)) / (xin(ii+1) - xin(ii))
                wgte(i) = (xout(i,j) - xin(ii))   / (xin(ii+1) - xin(ii))
                goto 60
             end if
          end do
          call endrun ('BILIN: Failed to find interp values')
60        iiprev = ii
       end do

       icount = 0
       do i=1,nlonout(j)
          if (iim(i) == 0 .or. iip(i) == 0) icount = icount + 1
          sum = wgtw(i) + wgte(i)
          if (sum < 0.99999_r8 .or. sum > 1.00001_r8) icount = icount + 1
          if (wgtw(i) < 0._r8 .or. wgtw(i) > 1._r8) icount = icount + 1
          if (wgte(i) < 0._r8 .or. wgte(i) > 1._r8) icount = icount + 1
       end do

       if (icount > 0) then
          write(iulog,*)'BILIN: j=',j,' Something bad in longitude indices or weights'
          call endrun
       end if
       !
       ! Do the interpolation, 1st in longitude then latitude
       !
       do k=1,nlev
          do i=1,nlonin
             igrid(i) = arrin(i,k,jjm(j))*wgts(j) + arrin(i,k,jjp(j))*wgtn(j)
          end do

          do i=1,nlonout(j)
             arrout(i,k,j) = igrid(iim(i))*wgtw(i) + igrid(iip(i))*wgte(i)
          end do
       end do
    end do


    return
  end subroutine bilin

  subroutine vertinterp(ncol, ncold, nlev, pmid, pout, arrin, arrout)

    !----------------------------------------------------------------------- 
    ! 
    ! Purpose: 
    ! Vertically interpolate input array to output pressure level
    ! Copy values at boundaries.  
    ! 
    ! Method: 
    ! 
    ! Author: 
    ! 
    !-----------------------------------------------------------------------

    implicit none

    !------------------------------Arguments--------------------------------
    integer , intent(in)  :: ncol              ! column dimension
    integer , intent(in)  :: ncold             ! declared column dimension
    integer , intent(in)  :: nlev              ! vertical dimension
    real(r8), intent(in)  :: pmid(ncold,nlev)  ! input level pressure levels 
    real(r8), intent(in)  :: pout              ! output pressure level 
    real(r8), intent(in)  :: arrin(ncold,nlev) ! input  array
    real(r8), intent(out) :: arrout(ncold)     ! output array (interpolated)
    !--------------------------------------------------------------------------

    !---------------------------Local variables-----------------------------
    integer i,k               ! indices
    integer kupper(ncold)     ! Level indices for interpolation
    real(r8) dpu              ! upper level pressure difference
    real(r8) dpl              ! lower level pressure difference
    logical found(ncold)      ! true if input levels found
    logical error             ! error flag 
    !-----------------------------------------------------------------
    !
    ! Initialize index array and logical flags
    !
    do i=1,ncol
       found(i)  = .false.
       kupper(i) = 1
    end do
    error = .false.
    !     
    ! Store level indices for interpolation. 
    ! If all indices for this level have been found, 
    ! do the interpolation 
    !     
    do k=1,nlev-1
       do i=1,ncol
          if ((.not. found(i)) .and. pmid(i,k)<pout .and. pout<=pmid(i,k+1)) then
             found(i) = .true.
             kupper(i) = k
          end if
       end do
    end do
    !
    ! If we've fallen through the k=1,nlev-1 loop, we cannot interpolate and
    ! must extrapolate from the bottom or top data level for at least some
    ! of the longitude points.
    !
    do i=1,ncol
       if (pout <= pmid(i,1)) then
          arrout(i) = arrin(i,1)
       else if (pout >= pmid(i,nlev)) then
          arrout(i) = arrin(i,nlev)
       else if (found(i)) then
          dpu = pout - pmid(i,kupper(i))
          dpl = pmid(i,kupper(i)+1) - pout
          arrout(i) = (arrin(i,kupper(i)  )*dpl + arrin(i,kupper(i)+1)*dpu)/(dpl + dpu)
       else
          error = .true.
       end if
    end do
    !     
    ! Error check
    !
    if (error) then
       call endrun ('VERTINTERP: ERROR FLAG')
    end if

    return
  end subroutine vertinterp

  subroutine get_timeinterp_factors (cycflag, np1, cdayminus, cdayplus, cday, &
       fact1, fact2, str)
    !---------------------------------------------------------------------------
    !
    ! Purpose: Determine time interpolation factors (normally for a boundary dataset)
    !          for linear interpolation.
    !
    ! Method:  Assume 365 days per year.  Output variable fact1 will be the weight to
    !          apply to data at calendar time "cdayminus", and fact2 the weight to apply
    !          to data at time "cdayplus".  Combining these values will produce a result 
    !          valid at time "cday".  Output arguments fact1 and fact2 will be between 
    !          0 and 1, and fact1 + fact2 = 1 to roundoff.
    !
    ! Author:  Jim Rosinski
    !
    !--------------------------------------------------------------------------- 
    implicit none
    !
    ! Arguments
    !
    logical, intent(in) :: cycflag             ! flag indicates whether dataset is being cycled yearly

    integer, intent(in) :: np1                 ! index points to forward time slice matching cdayplus

    real(r8), intent(in) :: cdayminus          ! calendar day of rearward time slice
    real(r8), intent(in) :: cdayplus           ! calendar day of forward time slice
    real(r8), intent(in) :: cday               ! calenar day to be interpolated to
    real(r8), intent(out) :: fact1             ! time interpolation factor to apply to rearward time slice
    real(r8), intent(out) :: fact2             ! time interpolation factor to apply to forward time slice

    character(len=*), intent(in) :: str        ! string to be added to print in case of error (normally the callers name)
    !
    ! Local workspace
    !
    real(r8) :: deltat                         ! time difference (days) between cdayminus and cdayplus
    real(r8), parameter :: daysperyear = 365.  ! number of days in a year
    !
    ! Initial sanity checks
    !
    if (np1 == 1 .and. .not. cycflag) then
       call endrun ('GETFACTORS:'//str//' cycflag false and forward month index = Jan. not allowed')
    end if

    if (np1 < 1) then
       call endrun ('GETFACTORS:'//str//' input arg np1 must be > 0')
    end if

    if (cycflag) then
       if ((cday < 1.) .or. (cday > (daysperyear+1.))) then
          write(iulog,*) 'GETFACTORS:', str, ' bad cday=',cday
          call endrun ()
       end if
    else
       if (cday < 1.) then
          write(iulog,*) 'GETFACTORS:', str, ' bad cday=',cday
          call endrun ()
       end if
    end if
    !
    ! Determine time interpolation factors.  Account for December-January 
    ! interpolation if dataset is being cycled yearly.
    !
    if (cycflag .and. np1 == 1) then                     ! Dec-Jan interpolation
       deltat = cdayplus + daysperyear - cdayminus
       if (cday > cdayplus) then                         ! We are in December
          fact1 = (cdayplus + daysperyear - cday)/deltat
          fact2 = (cday - cdayminus)/deltat
       else                                              ! We are in January
          fact1 = (cdayplus - cday)/deltat
          fact2 = (cday + daysperyear - cdayminus)/deltat
       end if
    else
       deltat = cdayplus - cdayminus
       fact1 = (cdayplus - cday)/deltat
       fact2 = (cday - cdayminus)/deltat
    end if

    if (.not. valid_timeinterp_factors (fact1, fact2)) then
       write(iulog,*) 'GETFACTORS: ', str, ' bad fact1 and/or fact2=', fact1, fact2
       call endrun ()
    end if

    return
  end subroutine get_timeinterp_factors

  logical function valid_timeinterp_factors (fact1, fact2)
    !---------------------------------------------------------------------------
    !
    ! Purpose: check sanity of time interpolation factors to within 32-bit roundoff
    !
    !---------------------------------------------------------------------------
    implicit none

    real(r8), intent(in) :: fact1, fact2           ! time interpolation factors

    valid_timeinterp_factors = .true.

    ! The fact1 .ne. fact1 and fact2 .ne. fact2 comparisons are to detect NaNs.
    if (abs(fact1+fact2-1.) > 1.e-6 .or. &
         fact1 > 1.000001 .or. fact1 < -1.e-6 .or. &
         fact2 > 1.000001 .or. fact2 < -1.e-6 .or. &
         fact1 .ne. fact1 .or. fact2 .ne. fact2) then

       valid_timeinterp_factors = .false.
    end if

    return
  end function valid_timeinterp_factors

!---------------------------------------------------------------------------

subroutine endrun(msg)

   character(len=*), intent(in), optional :: msg    ! string to be printed

   if (present (msg)) then
      write(iulog,*)'ENDRUN:', msg
   else
      write(iulog,*)'ENDRUN: called without a message string'
   end if

   stop

end subroutine endrun

end module interpolate_data

module mkharvestMod
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: mkharvest
!
! !DESCRIPTION:
! Make harvest and grazing data to add to the dynamic PFT file.
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!-----------------------------------------------------------------------
! !USES:
  use shr_kind_mod , only : r8 => shr_kind_r8, CL => shr_kind_CL
  use shr_sys_mod  , only : shr_sys_flush
  use mkdomainMod  , only : domain_checksame

  implicit none

  private

! !PUBLIC MEMBER FUNCTIONS:
  public mkharvest_init        ! Initialization
  public mkharvest             ! Calculate the harvest values on output grid
  public mkharvest_fieldname   ! Field name
  public mkharvest_longname    ! Long name
  public mkharvest_numtypes    ! Number of harvest types
  public mkharvest_parse_oride ! Parse the over-ride string

! !PRIVATE DATA MEMBERS:

  integer, parameter :: numharv = 6   ! number of harvest and grazing fields
  integer, parameter :: harlen  = 12  ! length of strings for harvest fieldnames
  character(len=harlen), parameter  :: harvest_fieldnames(numharv) = (/ &
                                                        'HARVEST_VH1',  &
                                                        'HARVEST_VH2',  &
                                                        'HARVEST_SH1',  &
                                                        'HARVEST_SH2',  &
                                                        'HARVEST_SH3',  &
                                                        'GRAZING    '   &
                                                      /)
  character(len=CL), parameter :: string_undef = 'STRING_UNDEFINED'
  real(r8),          parameter :: real_undef   = -999.99
  character(len=CL), save :: harvest_longnames(numharv) = string_undef
  real(r8),  pointer     :: oride_harv(:)        ! array that can override harvesting


!EOP
!-----------------------------------------------------------------------
contains
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkharvest_init
!
! !INTERFACE:
  subroutine mkharvest_init( ns_o, init_val, harvest, fharvest )
!
! !DESCRIPTION:
!              Initialization of mkharvest module.
!
! !USES:
    use mkncdio 
    implicit none
!
! !ARGUMENTS:
    integer         , intent(in) :: ns_o          ! clm output grid resolution
    real(r8)        , intent(in) :: init_val      ! initial value to set to
    real(r8)        , pointer    :: harvest(:,:)  ! output grid: normalized harvesting
    character(len=*), intent(in) :: fharvest      ! input harvest dataset file name
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!
! !LOCAL VARIABLES:
    character(len=*), parameter :: subname = 'mkharvest_init'
    integer  :: ncid,varid                      ! input netCDF id's
    integer  :: ifld                            ! indices
!EOP
!-----------------------------------------------------------------------

    allocate(harvest(ns_o,numharv))
    harvest(:,:) = init_val

    call check_ret(nf_open(fharvest, 0, ncid), subname)
    do ifld = 1, numharv
       call check_ret(nf_inq_varid (   ncid, mkharvest_fieldname(ifld), varid),            subname)
       call check_ret(nf_get_att_text( ncid, varid, 'long_name', harvest_longnames(ifld)), subname)
    end do

    call check_ret(nf_close(ncid), subname)

    allocate( oride_harv(numharv) )
    oride_harv(:) = real_undef

  end subroutine mkharvest_init

!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkharvest_fieldname
!
! !INTERFACE:
  character(len=harlen) function mkharvest_fieldname( nfield )
!
! !DESCRIPTION:
!              Return harvest fieldname of input field number.
!
! !USES:
    implicit none
!
! !ARGUMENTS:
    integer, intent(in) :: nfield
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!
! !LOCAL VARIABLES:
    character(len=*), parameter :: subname = 'mkharvest_fieldname'
!EOP
!-----------------------------------------------------------------------

      if (      nfield < 1       )then
         write(6,*) subname, ' error nfield < 1'
         call abort()
      else if ( nfield > numharv )then
         write(6,*) subname, ' error nfield > max fields'
         call abort()
      else
         mkharvest_fieldname = harvest_fieldnames(nfield)
      end if

  end function mkharvest_fieldname

!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkharvest_longname
!
! !INTERFACE:
  character(len=CL) function mkharvest_longname( nfield )
!
! !DESCRIPTION:
!              Return longname description of given input field number.
!
! !USES:
    implicit none
!
! !ARGUMENTS:
    integer, intent(in) :: nfield
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!
! !LOCAL VARIABLES:
    character(len=*), parameter :: subname = 'mkharvest_longname'
!EOP
!-----------------------------------------------------------------------

      if (      nfield < 1       )then
         write(6,*) subname, ' error nfield < 1'
         call abort()
      else if ( nfield > numharv )then
         write(6,*) subname, ' error nfield > max fields'
         call abort()
      else
         if ( trim(harvest_longnames(nfield)) .eq. trim(string_undef) )then
            write(6,*) subname, ' error harvest_longnames not set yet'
            call abort()
         end if
         mkharvest_longname = harvest_longnames(nfield)
      end if

  end function mkharvest_longname

!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkharvest_numtypes
!
! !INTERFACE:
  integer function mkharvest_numtypes( )
!
! !DESCRIPTION:
!              Return number of different harvest field types.
!
! !USES:
    implicit none
!
! !ARGUMENTS:
    character(len=*), parameter :: subname = 'mkharvest_numtypes'
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!
! !LOCAL VARIABLES:
!EOP
!-----------------------------------------------------------------------
      mkharvest_numtypes = numharv

  end function mkharvest_numtypes

!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkharvest
!
! !INTERFACE:
subroutine mkharvest(ldomain, mapfname, datfname, ndiag, harv_o)
!
! !DESCRIPTION:
! Make harvest data for the dynamic PFT dataset.
! This dataset consists of the normalized harvest or grazing fraction (0-1) of
! the model.
!
! !USES:
  use mkdomainMod, only : domain_type, domain_clean, domain_read
  use mkgridmapMod
  use mkvarpar	
  use mkvarctl    
  use mkncdio
!
! !ARGUMENTS:
  implicit none
  type(domain_type), intent(in) :: ldomain
  character(len=*)  , intent(in) :: mapfname    ! input mapping file name
  character(len=*)  , intent(in) :: datfname    ! input data file name
  integer           , intent(in) :: ndiag       ! unit number for diag out
  real(r8)          , intent(out):: harv_o(:,:) ! output grid: normalized harvesting
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!
! !LOCAL VARIABLES:
!EOP
  type(gridmap_type)    :: tgridmap
  type(domain_type)     :: tdomain            ! local domain
  real(r8), allocatable :: harv_i(:,:)        ! input grid: harvest/grazing percent
  real(r8), allocatable :: pctlnd_o(:)        ! output grid: percent land 
  real(r8) :: gharv_o(numharv)                ! output grid: global area harvesting
  real(r8) :: garea_o                         ! output grid: global area
  real(r8) :: gharv_i(numharv)                ! input grid: global area harvesting
  real(r8) :: garea_i                         ! input grid: global area
  integer  :: ifld                            ! indices
  integer  :: k,n,m,ni,no,ns_i,ns_o           ! indices
  integer  :: ncid,varid                      ! input netCDF id's
  integer  :: ier                             ! error status

  character(len=*), parameter :: unit = '10**6 km**2' ! Output units
  real(r8), parameter :: fac = 1.e-06_r8              ! Output factor
  real(r8), parameter :: rat = fac/100._r8            ! Output factor divided by 100%
  character(len=*), parameter :: subname = 'mkharvest'
!-----------------------------------------------------------------------

  write (6,*) 'Attempting to make harvest fields .....'
  call shr_sys_flush(6)

  ! -----------------------------------------------------------------
  ! Normally read in the harvesting file, and then regrid to output grid
  ! -----------------------------------------------------------------
  
  if ( all(oride_harv == real_undef ) )then

     ! -----------------------------------------------------------------
     ! Read input harvesting file
     ! -----------------------------------------------------------------

     ! Obtain input grid info, read HARVEST_VH1, HARVEST_VH2, ... GRAZING etc.

     call domain_read(tdomain,datfname)
     ns_i = tdomain%ns
     allocate(harv_i(ns_i,1:numharv), stat=ier)
     if (ier/=0) call abort()
     ns_o = ldomain%ns

     write (6,*) 'Open harvest file: ', trim(datfname)
     call check_ret(nf_open(datfname, 0, ncid), subname)
     do ifld = 1, numharv
        call check_ret(nf_inq_varid(ncid, mkharvest_fieldname(ifld), varid), subname)
        call check_ret(nf_get_var_double (ncid, varid, harv_i(:,ifld)), subname)
     end do
     call check_ret(nf_close(ncid), subname)

     ! Area-average normalized harvest on input grid [harv_i] to output grid [harv_o]

     call gridmap_mapread(tgridmap, mapfname )

     ! Error checks for domain and map consistencies
     
     call domain_checksame( tdomain, ldomain, tgridmap )

     ! Determine harv_o on output grid

     do ifld = 1,numharv
        call gridmap_areaave(tgridmap, harv_i(:,ifld), harv_o(:,ifld))
     end do

     ! -----------------------------------------------------------------
     ! Error check
     ! Compare global areas on input and output grids
     ! -----------------------------------------------------------------

     gharv_i(:) = 0.
     garea_i = 0.
     do ni = 1, ns_i
        garea_i = garea_i + tgridmap%area_src(ni)*re**2
        do m = 1, numharv
           gharv_i(m) = gharv_i(m) + harv_i(ni,m)*tgridmap%area_src(ni)* &
                                                  tgridmap%frac_src(ni)*re**2
        end do
     end do

     gharv_o(:) = 0.
     garea_o = 0.
     do no = 1,ns_o
        garea_o = garea_o + tgridmap%area_dst(no)*re**2
        do m = 1, numharv
           gharv_o(m) = gharv_o(m) + harv_o(no,m)*tgridmap%area_dst(no)* &
                                                  tgridmap%frac_dst(no)*re**2
        end do
     end do

     ! Write out to diagnostic output file
     !

     write (ndiag,*)
     write (ndiag,'(1x,70a1)') ('=',k=1,70)
     write (ndiag,*) 'Harvesting Output'
     write (ndiag,'(1x,70a1)') ('=',k=1,70)

     write (ndiag,*)
     write (ndiag,'(1x,70a1)') ('.',k=1,70)
     write (ndiag,1001) unit, unit
1001 format (1x,'harvest type   ',20x,' input grid area',' output grid area',/ &
             1x,33x,'     ',A,'      ',A)
     write (ndiag,'(1x,70a1)') ('.',k=1,70)
     write (ndiag,*)
     do m = 1, numharv
        write (ndiag,1002) mkharvest_fieldname(m), gharv_i(m)*rat,gharv_o(m)*rat
     end do
1002 format (1x,a35,f16.3,f17.3)

     ! Deallocate dynamic memory

     call domain_clean(tdomain) 
     call gridmap_clean(tgridmap)
     deallocate (harv_i)

  else

     ! -----------------------------------------------------------------
     ! Otherwise override the harvesting with the input harvest values
     ! -----------------------------------------------------------------
  
     if ( any(oride_harv == real_undef ) )then
         write(6,*) subname, ' error some override harvesting fields set ', &
                    'and others are not = ', oride_harv
         call abort()
     end if
     do m = 1, numharv
        if ( oride_harv(m) < 0.0_r8 .or. oride_harv(m) > 100.0_r8 )then
            write(6,*) subname, ' error override harvesting field out of range', &
                       oride_harv(m), ' field = ', mkharvest_fieldname(m)
            call abort()
        end if
     end do
     do no = 1,ns_o
        do m = 1, numharv
           harv_o(no,m) = oride_harv(m)
        end do
     end do

  end if

  write (6,*) 'Successfully made harvest and grazing'
  write (6,*)

end subroutine mkharvest

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkharvest_parse_oride
!
! !INTERFACE:
subroutine mkharvest_parse_oride( string )
!
! !DESCRIPTION:
! Parse the string with harvest and grazing information on it, to override
! the file with this information rather than reading from a file.
!
! !USES:
   use shr_string_mod, only: shr_string_betweenTags
! !ARGUMENTS:
   character(len=256), intent(IN) :: string  ! String to parse with harvest and grazing data
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!
! !LOCAL VARIABLES:
!EOP
  integer :: rc                         ! error return code
  character(len=256) :: substring       ! substring between tags
  character(len=*), parameter :: harv_start = "<harv>"
  character(len=*), parameter :: harv_end   = "</harv>"
  character(len=*), parameter :: graz_start = "<graz>"
  character(len=*), parameter :: graz_end   = "</graz>"
  character(len=*), parameter :: subname = 'mkharvest_parse_oride'
!-----------------------------------------------------------------------
  call shr_string_betweenTags( string, harv_start, harv_end, substring, rc )
  if ( rc /= 0 )then
     write(6,*) subname//'Trouble finding harvest start end tags'
     call abort()
  end if
  read(substring,*) oride_harv(1:numharv-1)
  call shr_string_betweenTags( string, graz_start, graz_end, substring, rc )
  if ( rc /= 0 )then
     write(6,*) subname//'Trouble finding grazing start end tags'
     call abort()
  end if
  read(substring,*) oride_harv(numharv)
  if ( harvest_fieldnames(numharv) /= 'GRAZING' )then
     write(6,*) subname, ' grazing is NOT last field as was expected'
     call abort()
  end if

!-----------------------------------------------------------------------

end subroutine mkharvest_parse_oride

!-----------------------------------------------------------------------

end module mkharvestMod

module mklaiMod
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: mklai
!
! !DESCRIPTION:
! Make LAI/SAI/height data
!
! !REVISION HISTORY:
! Author: Sam Levis
!
!EOP
!-----------------------------------------------------------------------
  use shr_kind_mod, only : r8 => shr_kind_r8
  use shr_sys_mod , only : shr_sys_flush
  use mkdomainMod , only : domain_checksame
  use mkvarctl    

  implicit none

  private

  public  :: mklai
  private :: pft_laicheck

contains

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mklai
!
! !INTERFACE:
subroutine mklai(ldomain, mapfname, datfname, firrig, ndiag, ncido)
!
! !DESCRIPTION:
! Make LAI/SAI/height data
! Portions of this code could be moved out of the month loop
! for improved efficiency
!
! !USES:
  use mkdomainMod, only : domain_type, domain_clean, domain_read
  use mkgridmapMod
  use mkvarpar    , only : numstdpft, re
  use mkvarctl    
  use mkncdio
  use mkpftMod    , only : nonIrrigIdx, IrrigIdx
!
! !ARGUMENTS:
  implicit none
  type(domain_type), intent(in) :: ldomain
  character(len=*)  , intent(in) :: mapfname     ! input mapping file name
  character(len=*)  , intent(in) :: datfname     ! input data file name
  character(len=*)  , intent(in) :: firrig       ! %irrigated area filename
  integer           , intent(in) :: ndiag        ! unit number for diag out
  integer           , intent(in) :: ncido        ! output netcdf file id
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Mariana Vertenstein
!
!
! !LOCAL VARIABLES:
!EOP
  type(gridmap_type)    :: tgridmap
  type(domain_type)    :: tdomain          ! local domain
  integer  :: numpft_i                      ! number of plant types on input
  real(r8) :: glai_o(0:numpft)              ! output grid: global area pfts
  real(r8) :: gsai_o(0:numpft)              ! output grid: global area pfts
  real(r8) :: ghgtt_o(0:numpft)             ! output grid: global area pfts
  real(r8) :: ghgtb_o(0:numpft)             ! output grid: global area pfts
  real(r8) :: glai_i(0:numpft)              ! input grid: global area pfts
  real(r8) :: gsai_i(0:numpft)              ! input grid: global area pfts
  real(r8) :: ghgtt_i(0:numpft)             ! input grid: global area pfts
  real(r8) :: ghgtb_i(0:numpft)             ! input grid: global area pfts

  real(r8), allocatable :: mlai_o(:,:)      ! monthly lai
  real(r8), allocatable :: msai_o(:,:)      ! monthly sai
  real(r8), allocatable :: mhgtt_o(:,:)     ! monthly height (top)
  real(r8), allocatable :: mhgtb_o(:,:)     ! monthly height (bottom)
  real(r8), allocatable :: mlai_max(:,:)    ! monthly lai
  real(r8), allocatable :: msai_max(:,:)    ! monthly sai
  real(r8), allocatable :: mhgtt_max(:,:)   ! monthly height (top)
  real(r8), allocatable :: mhgtb_max(:,:)   ! monthly height (bottom)
  real(r8), allocatable :: mlai_i(:,:)      ! monthly lai in
  real(r8), allocatable :: msai_i(:,:)      ! monthly sai in
  real(r8), allocatable :: mhgtt_i(:,:)     ! monthly height (top) in
  real(r8), allocatable :: mhgtb_i(:,:)     ! monthly height (bottom) in
  real(r8), allocatable :: mask_src(:)      ! input grid: mask (0, 1)
  integer,  pointer     :: laimask(:,:)     ! lai+sai output mask for each plant function type
  real(r8) :: garea_i                       ! input  grid: global area
  real(r8) :: garea_o                       ! output grid: global area
  integer  :: mwts                          ! number of weights
  integer  :: ni,no,ns_i,ns_o               ! indices
  integer  :: k,l,n,m                       ! indices
  integer  :: ncidi,dimid,varid             ! input netCDF id's
  integer  :: ndimsi,ndimso                 ! netCDF dimension sizes 
  integer  :: dimids(4)                     ! netCDF dimension ids
  integer  :: bego(4),leno(4)               ! netCDF bounds
  integer  :: begi(4),leni(4)               ! netCDF bounds 
  integer  :: ntim                          ! number of input time samples
  integer  :: ier                           ! error status
  real(r8) :: relerr = 0.00001              ! max error: sum overlap wts ne 1
  character(len=256) :: name                ! name of attribute
  character(len=256) :: unit                ! units of attribute
  character(len= 32) :: subname = 'mklai'
!-----------------------------------------------------------------------

  write (6,*) 'Attempting to make LAIs/SAIs/heights .....'
  call shr_sys_flush(6)

  ! -----------------------------------------------------------------
  ! Read input file
  ! -----------------------------------------------------------------

  ! Obtain input grid info, read local fields

  ns_o = ldomain%ns

  call domain_read(tdomain,datfname)
  ns_i = tdomain%ns

  write (6,*) 'Open LAI file: ', trim(datfname)
  call check_ret(nf_open(datfname, 0, ncidi), subname)
  call check_ret(nf_inq_dimid(ncidi, 'pft', dimid), subname)
  call check_ret(nf_inq_dimlen(ncidi, dimid, numpft_i), subname)
  call check_ret(nf_inq_dimid(ncidi, 'time', dimid), subname)
  call check_ret(nf_inq_dimlen(ncidi, dimid, ntim), subname)

  if (numpft_i /= numpft+1) then
     write(6,*)'MKLAI: parameter numpft+1= ',numpft+1, &
          'does not equal input dataset numpft= ',numpft_i
     stop
  endif
  if (ntim /= 12) then
     write(6,*)'MKLAI: must have 12 time samples on input data'
     call abort()
  endif

  ! NOTE - close data set at bottom of routine

  ! Dynamic allocation of variables

  allocate(mlai_i(ns_i,0:numpft),  &
           msai_i(ns_i,0:numpft),  &
           mhgtt_i(ns_i,0:numpft), &
           mhgtb_i(ns_i,0:numpft), &
           mask_src(ns_i),         &
           mlai_o(ns_o,0:numpft),  &
           msai_o(ns_o,0:numpft),  &
           mhgtt_o(ns_o,0:numpft), &
           mhgtb_o(ns_o,0:numpft), &
           laimask(ns_i,0:numpft), stat=ier )
  if (ier /= 0) then
     write(6,*)'mklai allocation error'; call abort()
  end if

  ! Determine mapping weights and map

  call gridmap_mapread(tgridmap, mapfname)

  ! Error checks for domain and map consistencies

  call domain_checksame( tdomain, ldomain, tgridmap )

  ! Determine number of dimensions in input by querying MONTHLY_LAI

  call check_ret(nf_inq_varid(ncidi, 'MONTHLY_LAI', varid), subname)
  call check_ret(nf_inq_vardimid(ncidi, varid, dimids), subname)
  call check_ret(nf_inq_varndims(ncidi, varid, ndimsi), subname)
  if (ndimsi ==4) then
     begi(1) = 1
     begi(2) = 1
     begi(3) = 1
     leni(4) = 1
     call check_ret(nf_inq_dimlen(ncidi, dimids(1), leni(1)), subname)
     call check_ret(nf_inq_dimlen(ncidi, dimids(2), leni(2)), subname)
     call check_ret(nf_inq_dimlen(ncidi, dimids(3), leni(3)), subname)
  else if (ndimsi== 3) then
     begi(1) = 1
     begi(2) = 1
     leni(3) = 1
     call check_ret(nf_inq_dimlen(ncidi, dimids(1), leni(1)), subname)
     call check_ret(nf_inq_dimlen(ncidi, dimids(2), leni(2)), subname)
  end if

  ! Determine number of dimensions in output by querying MONTHLY_LAI

  call check_ret(nf_inq_varid(ncido, 'MONTHLY_LAI', varid), subname)
  call check_ret(nf_inq_varndims(ncido, varid, ndimso), subname)
  call check_ret(nf_inq_vardimid(ncido, varid, dimids), subname)
  if (ndimso ==4) then
     bego(1) = 1
     bego(2) = 1
     bego(3) = 1
     leno(4) = 1
     call check_ret(nf_inq_dimlen(ncido, dimids(1), leno(1)), subname)
     call check_ret(nf_inq_dimlen(ncido, dimids(2), leno(2)), subname)
     call check_ret(nf_inq_dimlen(ncido, dimids(3), leno(3)), subname)
  else if (ndimso== 3) then
     bego(1) = 1
     bego(2) = 1
     leno(3) = 1
     call check_ret(nf_inq_dimlen(ncido, dimids(1), leno(1)), subname)
     call check_ret(nf_inq_dimlen(ncido, dimids(2), leno(2)), subname)
  end if

  ! Loop over months 

  do m = 1, ntim

     if (ndimsi == 4) begi(4)=m
     if (ndimsi == 3) begi(3)=m
     
     call check_ret(nf_inq_varid (ncidi, 'MONTHLY_LAI', varid), subname)
     call check_ret(nf_get_vara_double (ncidi, varid, begi(1:ndimsi), leni(1:ndimsi), &
          mlai_i), subname)

     call check_ret(nf_inq_varid (ncidi, 'MONTHLY_SAI', varid), subname)
     call check_ret(nf_get_vara_double (ncidi, varid, begi(1:ndimsi), leni(1:ndimsi), &
          msai_i(:,0:numpft)), subname)

     call check_ret(nf_inq_varid (ncidi, 'MONTHLY_HEIGHT_TOP', varid), subname)
     call check_ret(nf_get_vara_double (ncidi, varid, begi(1:ndimsi), leni(1:ndimsi), &
          mhgtt_i), subname)

     call check_ret(nf_inq_varid (ncidi, 'MONTHLY_HEIGHT_BOT', varid), subname)
     call check_ret(nf_get_vara_double (ncidi, varid, begi(1:ndimsi), leni(1:ndimsi), &
          mhgtb_i), subname)

     mlai_o(:,:)  = 0.
     msai_o(:,:)  = 0.
     mhgtt_o(:,:) = 0.
     mhgtb_o(:,:) = 0.
  
     ! Loop over pft types to do mapping

     do l = 0,numpft
        mask_src(:) = 1._r8 
        call gridmap_areaave(tgridmap, mlai_i(:,l) , mlai_o(:,l) , mask_src)
        call gridmap_areaave(tgridmap, msai_i(:,l) , msai_o(:,l) , mask_src)
        call gridmap_areaave(tgridmap, mhgtt_i(:,l), mhgtt_o(:,l), mask_src)
        call gridmap_areaave(tgridmap, mhgtb_i(:,l), mhgtb_o(:,l), mask_src)
     enddo

     ! Determine laimask
     
     laimask(:,:) = 0
     
     ! if irrigation dataset present, copy LAI,SAI,Heights from non-irrigated 
     ! into irrigated
     if (firrig /= ' ') then      
        write(6,*) 'Irrigation dataset present; Copying crop ', &
             ' LAI, SAI, and heights into irrigated crop '
        mlai_o(:,nonIrrigIdx)  = mlai_o(:,IrrigIdx)
        msai_o(:,nonIrrigIdx)  = msai_o(:,IrrigIdx)
        mhgtt_o(:,nonIrrigIdx) = mhgtt_o(:,IrrigIdx)
        mhgtb_o(:,nonIrrigIdx) = mhgtb_o(:,IrrigIdx)
     endif

     ! -----------------------------------------------------------------
     ! Output model resolution LAI/SAI/HEIGHT data
     ! -----------------------------------------------------------------

     ! Now write out all variables

     if (ndimso == 4) bego(4)=m
     if (ndimso == 3) bego(3)=m

     call check_ret(nf_inq_varid(ncido, 'MONTHLY_LAI', varid), subname)
     call check_ret(nf_put_vara_double(ncido, varid, bego, leno, mlai_o), subname)
     
     call check_ret(nf_inq_varid(ncido, 'MONTHLY_SAI', varid), subname)
     call check_ret(nf_put_vara_double(ncido, varid, bego, leno, msai_o), subname)
     
     call check_ret(nf_inq_varid(ncido, 'MONTHLY_HEIGHT_TOP', varid), subname)
     call check_ret(nf_put_vara_double(ncido, varid, bego, leno, mhgtt_o), subname)
     
     call check_ret(nf_inq_varid(ncido, 'MONTHLY_HEIGHT_BOT', varid), subname)
     call check_ret(nf_put_vara_double(ncido, varid, bego, leno, mhgtb_o), subname)

     call check_ret(nf_inq_varid(ncido, 'time', varid), subname)
     call check_ret(nf_put_vara_int(ncido, varid, bego(ndimso), leno(ndimso), m), subname)

     call check_ret(nf_sync(ncido), subname)


     ! -----------------------------------------------------------------
     ! Error check2
     ! Compare global areas on input and output grids
     ! -----------------------------------------------------------------

     ! Input grid global area

     garea_i    = 0.
     do ni = 1,ns_i
        garea_i = garea_i + tgridmap%area_src(ni)
     end do

     glai_i(:)  = 0.
     gsai_i(:)  = 0.
     ghgtt_i(:) = 0.
     ghgtb_i(:) = 0.
     do l  = 0, numpft
     do ni = 1, ns_i
        glai_i(l)  = glai_i(l) + mlai_i(ni,l) *tgridmap%area_src(ni)*&
             tgridmap%frac_src(ni)*re**2
        gsai_i(l)  = gsai_i(l) + msai_i(ni,l) *tgridmap%area_src(ni)*&
             tgridmap%frac_src(ni)*re**2
        ghgtt_i(l) = ghgtt_i(l)+ mhgtt_i(ni,l)*tgridmap%area_src(ni)*&
             tgridmap%frac_src(ni)*re**2
        ghgtb_i(l) = ghgtb_i(l)+ mhgtb_i(ni,l)*tgridmap%area_src(ni)*&
             tgridmap%frac_src(ni)*re**2
     end do
     end do

     ! Output grid global area

     garea_o    = 0.
     do no = 1,ns_o
        garea_o = garea_o + tgridmap%area_dst(no)
     end do

     glai_o(:)  = 0.
     gsai_o(:)  = 0.
     ghgtt_o(:) = 0.
     ghgtb_o(:) = 0.
     do l  = 0, numpft
     do no = 1,ns_o
        glai_o(l)  = glai_o(l) + mlai_o(no,l)*tgridmap%area_dst(no)* &
             tgridmap%frac_dst(no)*re**2
        gsai_o(l)  = gsai_o(l) + msai_o(no,l)*tgridmap%area_dst(no)* &
             tgridmap%frac_dst(no)*re**2
        ghgtt_o(l) = ghgtt_o(l)+ mhgtt_o(no,l)*tgridmap%area_dst(no)* &
             tgridmap%frac_dst(no)*re**2
        ghgtb_o(l) = ghgtb_o(l)+ mhgtb_o(no,l)*tgridmap%area_dst(no)* &
             tgridmap%frac_dst(no)*re**2
     end do
     end do

     ! Comparison

     write (ndiag,*)
     write (ndiag,'(1x,70a1)') ('=',k=1,70)
     write (ndiag,*) 'LAI Output for month ',m
     write (ndiag,'(1x,70a1)') ('=',k=1,70)

     write (ndiag,*)
     write (ndiag,'(1x,70a1)') ('.',k=1,70)
     write (ndiag,1001)
1001 format (1x,'PFT input grid area output grid area',/ &
             1x,3x,'     10**6 km**2','      10**6 km**2')
     write (ndiag,'(1x,70a1)') ('.',k=1,70)
     write (ndiag,*)
     do l = 0, numpft
        write (ndiag,1002) l, glai_i(l)*1.e-06*1.e-02,glai_o(l)*1.e-06*1.e-02
1002    format (1x,i3,f16.3,f17.3)
     end do

     write (6,*) 'Successfully made LAIs/SAIs/heights for month ', m
     call shr_sys_flush(6)

  enddo
  write (6,*)

  ! Close input file
  call check_ret(nf_close(ncidi), subname)

  ! consistency check that PFT and LAI+SAI make sense
  !call pft_laicheck( ni_s, pft_i, laimask )

  ! Deallocate dynamic memory

  deallocate(mlai_i,msai_i,mhgtt_i,mhgtb_i,&
             mask_src,mlai_o,msai_o,mhgtt_o,mhgtb_o,laimask)
  call gridmap_clean(tgridmap)
  call domain_clean(tdomain) 

end subroutine mklai

!-----------------------------------------------------------------------
!BOP
!
! !INTERFACE:
subroutine pft_laicheck( ni_s, pctpft_i, laimask )

! !USES:
!
! !DESCRIPTION:
!
! consistency check that PFT and LAI+SAI make sense
!
! !ARGUMENTS:
  implicit none
  integer , intent(in) :: ni_s          ! input PFT grid resolution
  real(r8), pointer    :: pctpft_i(:,:)  ! % plant function types
  integer,  pointer    :: laimask(:,:)   ! mask where LAI+SAI > 0
!EOP

  character(len=*), parameter :: subName="pft_laicheck"
  integer :: ni,l,n,nc      ! Indices
!-----------------------------------------------------------------------

  do l  = 0, numpft
     n  = 0
     nc = 0
     do ni = 1,ni_s
        if ( pctpft_i(ni,l) > 0.0_r8 ) nc = nc + 1
        if ( (pctpft_i(ni,l) > 0.0_r8) .and. (laimask(ni,l) /= 1) )then
           write (6,*) subName//' :: warning: pft and LAI+SAI mask not consistent!'
           write (6,*) 'ni,l   = ', ni, l
           write (6,*) 'pctpft_i  = ',pctpft_i(ni,l)
           write (6,*) 'laimask   = ', laimask(ni,l)
           n = n + 1
        end if
     end do
     if ( n > max(4,nc/4) ) then
        write (6,*) subName//' :: pft/LAI+SAI inconsistency over more than 25% land-cover'
        write (6,*) '# inconsistent points, total PFT pts, total LAI+SAI pts = ', &
                     n, nc, sum(laimask(:,l))
        stop
     end if
  end do

end subroutine pft_laicheck

!-----------------------------------------------------------------------
  
end module mklaiMod

subroutine max_ovr (nlon_i, nlat_i, numlon_i, nlon_o, nlat_o, numlon_o, &
                    lon_i , lat_i , lon_o   , lat_o , novr_max)

  use shr_kind_mod, only: r8 => shr_kind_r8

! -----------------------------------------------------------------
  implicit none      
! ------------------------ code history ---------------------------
! source file:       max_ovr
! purpose:           determine maximum number of overlapping cells 
!                    input and output grids
! date last revised: March 1997 
! author:            Mariana Vertenstein
! standardized: 
! reviewed:    
! -----------------------------------------------------------------

! ------------------- input variables -----------------------------
  integer, intent(in)  :: nlon_i                 !number of input  longitude points
  integer, intent(in)  :: nlat_i                 !number of input  latitude points
  integer, intent(in)  :: numlon_i(nlat_i)       !number of longitude points for each input grid cell latitude
  integer, intent(in)  :: nlon_o                 !number of output longitude points
  integer, intent(in)  :: nlat_o                 !number of output latitude points
  integer, intent(in)  :: numlon_o(nlat_o)       !number of longitude points for each output grid cell latitude 
  real(r8), intent(in) :: lon_i(nlon_i+1,nlat_i) !input grid cell longitude, western edge
  real(r8), intent(in) :: lat_i(nlat_i+1)        !input grid cell latitude, southern edge
  real(r8), intent(in) :: lon_o(nlon_o+1,nlat_o) !output grid cell longitude, western edge
  real(r8), intent(in) :: lat_o(nlat_o+1)        !output grid cell latitude , southern edge
  integer , intent(out):: novr_max               !maximum number of overlapping input cells
! -----------------------------------------------------------------

! ------------------- local variables -----------------------------
  integer novr                !number of overlapping input cells
  integer io,ii               !output and input grids longitude loop index
  integer jo,ji               !output and input grids latitude  loop index
! -----------------------------------------------------------------


! -----------------------------------------------------------------
! for each output grid cell: find overlapping input grid cell and area of
! input grid cell that overlaps with output grid cell. cells overlap if:
!
! southern edge of input grid < northern edge of output grid AND
! northern edge of input grid > southern edge of output grid
!
! western edge of input grid < eastern edge of output grid AND
! eastern edge of input grid > western edge of output grid
!
!           lon_o(io,jo)       lon_o(io+1,jo)
!
!              |                   |
!              --------------------- lat_o(jo+1)
!              |                   |
!              |                   |
!    xxxxxxxxxxxxxxx lat_i(ji+1)   |
!    x         |   x               |
!    x  input  |   x   output      |
!    x  cell   |   x    cell       |
!    x  ii,ji  |   x   io,jo       |
!    x         |   x               |
!    x         ----x---------------- lat_o(jo  )
!    x             x
!    xxxxxxxxxxxxxxx lat_i(ji  )
!    x             x
! lon_i(ii,ji) lon_i(ii+1,ji)
! -----------------------------------------------------------------

!
! determine maximum number of overlapping cells
! loop through all input grid cells to find overlap with output grid.
! code does not vectorize but is only called during initialization.
!
  novr_max = 0
  do jo = 1, nlat_o
    do io = 1, numlon_o(jo)
      novr = 0
      do ji = 1, nlat_i                            
        if (lat_i(ji  ).lt.lat_o(jo+1) .and. &
            lat_i(ji+1).gt.lat_o(jo  )) then  !lat ok
          do ii = 1, numlon_i(ji)
            if (lon_i(ii  ,ji).lt.lon_o(io+1,jo) .and. &
                lon_i(ii+1,ji).gt.lon_o(io  ,jo)) then !lon okay
              novr = novr + 1    ! increment number of ovrlap cells for io,jo
            end if
          end do
        end if
      end do
      if (novr .gt. novr_max) novr_max = novr
    end do
  end do

  return
end subroutine max_ovr

module mkvarpar

!-----------------------------------------------------------------------
!BOP
!
! !MODULE: clm_varpar
!
! !DESCRIPTION:
! Module containing CLM parameters
!
! !USES:
  use shr_kind_mod, only: r8 => shr_kind_r8
  use shr_const_mod, only: SHR_CONST_REARTH
!
! !PUBLIC TYPES:
  implicit none
  save
!
  integer, parameter :: nlevsoi = 10  ! number of soil layers
  integer, parameter :: numstdpft = 16! number of standard PFT types
  integer, parameter :: noveg   = 0   ! value for non-vegetated pft
  integer, parameter :: nlevurb = 15  ! number of urban layers
  integer, parameter :: numsolar = 2  ! number of solar types (Direct,Diffuse)
  integer, parameter :: numrad = 2    ! number of solar bands (VIS,NIR)
  real(r8),parameter :: elev_thresh  = 2040._r8   ! elevation threshold for screening urban areas
  real(r8),parameter :: re = SHR_CONST_REARTH*0.001

!
!EOP
!-----------------------------------------------------------------------

end module mkvarpar

subroutine cell_area (nlat, nlon, numlon, lon_w, lat_s, re, area)

  use shr_kind_mod, only: r8 => shr_kind_r8

  implicit none
! ------------------------ code history ---------------------------
! source file:       cell_area.F
! purpose:           area of grid cells
! date last revised: March 1996
! author:            Gordon Bonan
! standardized:
! reviewed:
! -----------------------------------------------------------------

! ------------------- input variables -----------------------------
  integer nlat            !number of latitude points
  integer nlon            !maximum number of longitude points
  integer numlon(nlat)    !number of longitude points for each latitude 
  real(r8) lon_w(nlon+1,nlat) !grid cell longitude, western edge (degrees)
  real(r8) lat_s(nlat+1)      !grid cell latitude, southern edge (degrees)
! -----------------------------------------------------------------

! ------------------- output variables ----------------------------
  real(r8) re              !radius of earth (km)
  real(r8) area(nlon,nlat) !cell area (km**2)
! -----------------------------------------------------------------

! ------------------- local variables -----------------------------
  integer i            !longitude index
  integer j            !latitude index

  real(r8) dx            !cell width
  real(r8) dy            !cell length
  real(r8) deg2rad       !pi/180
  real(r8) one
  parameter (one=1.)   ! Argument to atan
! -----------------------------------------------------------------

  deg2rad = (4.*atan(one)) / 180.
  re = 6371.227709

  do j = 1, nlat
    do i = 1, numlon(j)
      dx = (lon_w(i+1,j)-lon_w(i,j)) * deg2rad
      dy = sin(lat_s(j+1)*deg2rad) - sin(lat_s(j)*deg2rad)
      area(i,j) = dx*dy*re*re
    end do
  end do

  return
end subroutine cell_area

module fill_positions

use shr_kind_mod, only: r8 => shr_kind_r8
use control,      only: verbose
   
implicit none
private

include 'netcdf.inc'

public :: varspec_t, fillvar

type varspec_t
   character*(nf_max_name) :: name
   character*8 :: vshape

   integer :: varid
   integer :: totsiz
   integer :: xtype
   integer :: nx, ny, nz
   integer :: tpos
   integer :: count(nf_max_var_dims)

   integer :: x_vid
   integer :: y_vid
   integer :: z_vid
end type varspec_t

!-------------------------------------------------------------------------------
contains
!-------------------------------------------------------------------------------

subroutine fillvar(ncid, name, xtype, vshape, dimnames, &
                   varid, nvdims, vardids, varspec)

   ! arguments

   integer,                 intent(in) :: ncid
   character*(*),           intent(in) :: name
   integer,                 intent(in) :: xtype
   character*8,             intent(in) :: vshape
   character*(nf_max_name), intent(in) :: dimnames(nvdims)
   integer,                 intent(in) :: varid
   integer,                 intent(in) :: nvdims
   integer,                 intent(in) :: vardids(nvdims)

   type(varspec_t),         intent(out) :: varspec

   ! Local workspace

   integer :: nx, ny, nz
   integer :: dimlen
   integer :: n
   integer :: unlimdimid
   character(len=*), parameter :: sub = 'fillvar: '
   !-------------------------------------------------------------------------------

   varspec%name   = name
   varspec%xtype  = xtype
   varspec%vshape = vshape
   varspec%varid  = varid
 
   varspec%totsiz   = 1
   varspec%tpos     = 1
   varspec%count(:) = 1

   nx    = 1 
   ny    = 1 
   nz    = 1

   ! Get dimension lengths.

   ! Identify the dimension ID of the unlimited dimension if there is one.
   if (nf_inq_unlimdim(ncid, unlimdimid) /= nf_noerr) then
      write(6,*) sub//'ERROR return from nf_inq_unlimdim'
   end if

   do n = 1, nvdims

      ! If the dimension ID is the unlimited one, assume that it's time
      ! and set the count to 1 since will work with 1 record at a time.
      if (vardids(n) == unlimdimid) then
         varspec%tpos     = n
         varspec%count(n) = 1
      else

         ! If the dimension ID isn't the unlimited one, get the corresponding size and
         ! increment the total size of the variable.
         if (nf_inq_dimlen(ncid, vardids(n), dimlen) == nf_noerr) then
            varspec%count(n) = dimlen
            varspec%totsiz   = varspec%totsiz * dimlen
         else
            write(6,*) sub//'ERROR return from nf_inq_dimlen for dimension '//trim(dimnames(n))
            stop
         end if
      end if
   end do

   ! Now get the IDs of the variables that contain the coordinate information for
   ! each spatial dimension

   if (vshape == 'xy') then

      varspec%nx = varspec%count(1)
      varspec%ny = varspec%count(2)
      varspec%nz = 1

      call fill_xpos(ncid,  dimnames(1), varspec%x_vid)
      call fill_yzpos(ncid, dimnames(2), varspec%y_vid)

   else if (vshape == 'xyz') then

      varspec%nx = varspec%count(1)
      varspec%ny = varspec%count(2)
      varspec%nz = varspec%count(3)

      call fill_xpos(ncid,  dimnames(1), varspec%x_vid)
      call fill_yzpos(ncid, dimnames(2), varspec%y_vid)
      call fill_yzpos(ncid, dimnames(3), varspec%z_vid)

   else if (vshape == 'xzy') then

      varspec%nx = varspec%count(1)
      varspec%ny = varspec%count(3)
      varspec%nz = varspec%count(2)

      call fill_xpos(ncid,  dimnames(1), varspec%x_vid)
      call fill_yzpos(ncid, dimnames(3), varspec%y_vid)
      call fill_yzpos(ncid, dimnames(2), varspec%z_vid)

   else if (vshape == 'nz') then

      varspec%nx = varspec%count(1)
      varspec%ny = 1
      varspec%nz = varspec%count(2)

      call fill_xpos(ncid,  dimnames(1), varspec%x_vid)
      call fill_yzpos(ncid, dimnames(1), varspec%y_vid)
      call fill_yzpos(ncid, dimnames(2), varspec%z_vid)

   else if (vshape == 'n') then

      varspec%nx = varspec%count(1)
      varspec%ny = 1
      varspec%nz = 1

      call fill_xpos(ncid,  dimnames(1), varspec%x_vid)
      call fill_yzpos(ncid, dimnames(1), varspec%y_vid)

   end if

   if (verbose) then
      if (nvdims == 1) then
         print*,'fillvar: ',trim(name),'(',trim(dimnames(1)),'=',varspec%count(1),')'
      else if (nvdims == 2) then
         print*,'fillvar: ',trim(name),'(',trim(dimnames(1)),'=',varspec%count(1),trim(dimnames(2)),'=',varspec%count(2),')'
      else if (nvdims == 3) then
         print*,'fillvar: ',trim(name),'(',trim(dimnames(1)),'=',varspec%count(1),trim(dimnames(2)),'=',varspec%count(2),&
                                           trim(dimnames(3)),'=',varspec%count(3),')'
      else if (nvdims == 4) then
         print*,'fillvar: ',trim(name),'(',trim(dimnames(1)),'=',varspec%count(1),trim(dimnames(2)),'=',varspec%count(2),&
                                           trim(dimnames(3)),'=',varspec%count(3),trim(dimnames(4)),'=',varspec%count(4),')'
      end if
   end if

end subroutine fillvar

!-------------------------------------------------------------------------------

subroutine fill_xpos(ncid, dimname, x_vid)

   ! arguments
   integer,                    intent(in) :: ncid
   character(len=nf_max_name), intent(in) :: dimname

   integer,                    intent(out) :: x_vid
   !-------------------------------------------------------------

   if (dimname == 'ncol') then
      call wrap_inq_varid(ncid, 'lon', x_vid)
   else
      call wrap_inq_varid(ncid, dimname, x_vid)
   end if

end subroutine fill_xpos

!-------------------------------------------------------------------------------

subroutine fill_yzpos(ncid, dimname, yz_vid)

   ! arguments
   integer,                    intent(in) :: ncid
   character(len=nf_max_name), intent(in) :: dimname

   integer,                    intent(out) :: yz_vid
   !-------------------------------------------------------------

   if (dimname == 'ncol') then
      call wrap_inq_varid(ncid, 'lat', yz_vid)
   else
      call wrap_inq_varid(ncid, dimname, yz_vid)
   end if

end subroutine fill_yzpos

!-------------------------------------------------------------------------------
end module fill_positions

subroutine sm121 (a, plon, nlat, nlon)

  use shr_kind_mod, only: r8 => shr_kind_r8

!      
! perform 1-2-1 smoothing using data array a.  On reduced grid, linearly
! interpolate to a rectangular grid (nlon(j),3) before interpolating
!
!-----------------------------------------------------------------------
  implicit none
!-----------------------------Arguments---------------------------------

  integer plon             ! Input:  Lon dim
  integer nlat             ! Input:  Lat dim
  integer nlon(nlat)       ! Number of longitudes per latitude
  real(r8)  a(plon,nlat)     ! I/O:    Array to be smoothed

!--------------------------Local variables------------------------------

  integer i,j              ! Indices
  integer imin,imax        ! Indices
  integer jmax,jmin        ! Indices
!
! Dynamic
!
  real(r8) xin(plon,nlat)
  real(r8) xout(plon)
  real(r8) temp(plon,nlat)   ! Temp array
  real(r8) tempjmin(plon)    ! Temp array
  real(r8) tempjmax(plon)    ! Temp array
!
!-----------------------------------------------------------------------
!     
  temp(:,:) = a(:,:)
!
! first do the S and N boundaries.
!
  do i=1,nlon(1)
    imin = i - 1
    imax = i + 1
    if( imin .lt.   1 )    imin = imin + nlon(1)
    if( imax .gt. nlon(1)) imax = imax - nlon(1)
    a(i,1) =    (temp(imin,1)  + 3.*temp(i,1)   +temp(imax,1))/5.
  end do

  do i=1,nlon(nlat)
    imin = i - 1
    imax = i + 1
    if( imin .lt.   1 )       imin = imin + nlon(nlat)
    if( imax .gt. nlon(nlat)) imax = imax - nlon(nlat)
    a(i,nlat) = (temp(imin,nlat)+3.*temp(i,nlat)+temp(imax,nlat))/5.
  end do
!
! Define xin array for each latitude
!
  do j=1,nlat
    do i=1,nlon(j)
      xin(i,j) = (i-1)*360./nlon(j)
    end do
  end do
!
! Linearly interpolate data N and S of each target latitude to the longitudes
! of each target latitude before applying 1-2-1 filter
!
  do j=2,nlat-1
    jmin = j - 1
    jmax = j + 1
    xout(:) = xin(:,j)
    call lininterp (temp(1,jmin), nlon(jmin), 1, xin(1,jmin), &
                    tempjmin, nlon(j), 1, xout, .true.)
    call lininterp (temp(1,jmax), nlon(jmax), 1, xin(1,jmax), &
                    tempjmax, nlon(j), 1, xout, .true.)

    do i=1,nlon(j)
      imin = i - 1
      imax = i + 1
      if( imin .lt.   1 )    imin = imin + nlon(j)
      if( imax .gt. nlon(j)) imax = imax - nlon(j)
      a(i,j) =            (tempjmin(i)  + &
          temp(imin,j) + 4.*temp(i,j)  + temp(imax,j) + &
                           tempjmax(i)  ) / 8.
    enddo
  enddo
!
  return
end subroutine sm121

program fmain

   use control,    only: verbose, silent, prec_override, prec_out, &
                         set_user_skip, set_user_include
   use dimensions, only: is_ewdim, is_nsdim, is_zdim, is_ncoldim, ncoldimid

   implicit none

   include 'netcdf.inc'

   ! Local workspace

   character(len=256)  :: arg, file1, file2, template
   character(len=256)  :: exclude = ' ', inc_template = ' '
   character(len=1024) :: cmdline
   character(len=nf_max_name) :: name, namei
   character(len=nf_max_name) :: attname

   integer :: attlen
   integer :: ncidi, ncido, ncidt
   integer :: ndims, ndimsi
   integer :: unlimdimid, unlimdimidi
   integer :: dimlen
   integer :: dimid
   integer :: nvars, nvarsi
   integer :: ngatts, ngattsi
   integer :: ret
   integer :: n
   integer :: ntime = 1
   integer :: nargs
   integer :: nprec

   integer iargc
   external iargc

   ! Default settings before parsing argument list

   file1 = ' '
   file2 = ' '
   template = ' '
   verbose = .false.
   silent = .false.

   nargs = iargc()
   n = 1
   cmdline = 'interpic '
   do while (n .le. nargs)
      arg = ' '
      call getarg(n, arg)
      n = n + 1

      select case (arg)
      case ('-e')
         call getarg(n, arg)
         n = n + 1
         exclude = arg
         cmdline = trim(cmdline) // ' -e ' // trim(arg)
      case ('-i')
         call getarg(n, arg)
         n = n + 1
         inc_template = arg
         cmdline = trim(cmdline) // ' -i ' // trim(arg)
      case ('-p')
         prec_override = .true.
         call getarg(n, arg)
         n = n + 1
         read(arg,'(i1)') nprec
         cmdline = trim(cmdline) // ' -p ' // trim(arg)
      case ('-s')
         silent = .true.
         cmdline = trim(cmdline) // ' -s'
      case ('-t')
         call getarg(n, arg)
         n = n + 1
         template = arg
         cmdline = trim(cmdline) // ' -t ' // trim(template)
      case ('-v')
         verbose = .true.
         cmdline = trim(cmdline) // ' -v'
      case default
         if (file1 .eq. ' ') then
            file1 = arg
         else if (file2 .eq. ' ') then
            file2 = arg
         else
            write (6,*) 'Argument ', arg,' is not known'
            call usage_exit(' ')
         end if
         cmdline = trim(cmdline) // ' ' // trim(arg)
      end select
   end do
  
   if (file1 .eq. ' '  .or.  file2 .eq. ' ') then
      call usage_exit('Must enter an input file and an output file')
   else if (silent .and. verbose) then
      call usage_exit('-s cannot be specified with -v')
   end if

   if (len_trim(exclude) > 0) then
      call set_user_skip(exclude)
   end if

   if (len_trim(inc_template) > 0) then
      call set_user_include(inc_template)
   end if

   if (prec_override) then
      if (nprec == 4) then
         prec_out = NF_FLOAT
      else if (nprec == 8) then
         prec_out = NF_DOUBLE
      else
         call usage_exit('-p can only be set to 4 or 8')
      end if
   end if

   ! Open input and output netcdf files
   call wrap_open(file1, NF_NOWRITE, ncidi)
   call wrap_open(template, NF_NOWRITE, ncidt)
   call wrap_create (file2, IOR(NF_CLOBBER,NF_64BIT_OFFSET), ncido)

   ! Determine space dimensions of output file from template file.
   ! Currently all spatial dimensions of the output file must exist
   ! on the template file.
   call wrap_inq(ncidt, ndims, nvars, ngatts, unlimdimid)

   do n=1,ndims

      call wrap_inq_dim(ncidt, n, name, dimlen)
    
      if (is_ncoldim(name) .or. is_ewdim(name) .or. &
          is_nsdim(name) .or. is_zdim (name) ) then

         if (nf_def_dim(ncido, name, dimlen, dimid) /= NF_NOERR) then
            print *, 'fmain: ERROR return from nf_def_dim: failed to define '//trim(name)
         end if

         if (verbose) then
            print *, 'define dim from template file: '//trim(name)//' len=',dimlen
         end if

         if (is_ncoldim(name)) ncoldimid = dimid

      end if

   end do

   ! Determine all non-spatial dimensions from the input file
   call wrap_inq(ncidi, ndimsi, nvarsi, ngattsi, unlimdimidi)

   do n=1,ndimsi

      call wrap_inq_dim(ncidi, n, name, dimlen)

      if (.not. is_ncoldim(name) .and. .not. is_ewdim(name) .and. &
          .not. is_nsdim(name) .and. .not. is_zdim (name) ) then

         ! check for time dimension
         if (trim(name) == 'time') then
            ntime = dimlen

            ! Reset dimlen for unlimited dimension
            ! make sure time is marked UNLIMITED.  netcdf3, 64bit, only allows
            ! 4GB variables.  if time is UNLIMITED, each timeslice limited to 4GB
            ! otherwise, entire variable must be < 4GB
            dimlen = NF_UNLIMITED
            if (n /= unlimdimidi) then
               print *, 'fmain: INFO: change the time dimension from fixed length to unlimited'
            end if

         end if

         if (nf_def_dim(ncido, name, dimlen, dimid) /= NF_NOERR) then
            print *, 'fmain: ERROR return from nf_def_dim: failed to define '//trim(name)
         end if

         if (verbose) then
            print *, 'define dim from input file: '//trim(name)//' len=',dimlen
         end if

      end if
     
   end do

   ! Copy global attributes from input to output file
   do n=1,ngattsi

      call wrap_inq_attname(ncidi, NF_GLOBAL, n, attname)

      if (verbose) then
         write(6,*) 'copy '//trim(attname)
      end if

      call wrap_copy_att(ncidi, NF_GLOBAL, attname, ncido, NF_GLOBAL)

   end do

   ! Add global attributes for interpic
   call addglobal(ncido, cmdline)

   ! Special cases: spatial coordinate variables and variables that depend on spatial
   ! dimensions will be copied from the template file to output file
   if (verbose) then
      write(6,*) 'handle_special_cases from template file:'
   end if
   call handle_special_cases(ncidt, ncido)

   ! Copying spatial coordinate variables and variables that depend on spatial
   ! dimensions from the input file to output is currently disabled.
   !
   !if (verbose) then
   !   write(6,*) 'handle_special_cases from input file:'
   !end if
   !call handle_special_cases(ncidi, ncido)

   ! Call driver code to do the interpolations and/or copies
   call driver(ncidi, ncido, ncidt, ntime)

   if (nf_close(ncido) /= nf_noerr) then
      call err_exit('error from nf_close')
   end if
   if (verbose) then
      write(6,*) 'Finished.'
   end if

end program fmain

subroutine usage_exit (arg)
   implicit none
   character*(*) arg

   if (arg.ne.' ') write (6,*) arg
   write (6,*) 'Usage: interpic [-e "var1,...,varn"] [-i "var1,...,varn"] &
        &[-p (4 or 8)] [-s] [-v]'
   write (6,*) '                -t template infile outfile'
   write (6,*) 'OPTIONS:'
   write (6,*) '-e   comma separated list of variables to exclude when &
        &copying from input file to output file'
   write (6,*) '-i   comma separated list of variables to include when &
        &copying from template file to output file'
   write (6,*) '-p   set precision of data variables in output file'
   write (6,*) '-s   set silent mode'
   write (6,*) '-v   set verbose mode'
   stop 999
end subroutine usage_exit

! Terrain Filter
! 
! Contributed by S.J. Lin.
!
! Added to the definesurf program by G. Grant, 30 June 2000.
! Updated with latest version from S.J. by B. Eaton, 23 August 2001
!
! Notes from S.J.:
!
! "I compute the unsmoothed mean height and the variance
! exactly the same as the standard CCM utility. The only difference
! is the grid being uniformly spaced from North pole to South pole.
! The filter is applied to the mean height and the sqaure root of 
! the variance (the standard deviation).
!
! For the 2x2.5 deg resolution 
!
!      mlon = 144
!      mlat = 91
!
! Assuming the mean height is Z(mlon,mlat), and the standard deviation
! (the sqaure root of the variance) is SD(moln,mlat), the filter 
! algorithm goes like this:
!
!       call sm2(mlon, mlat,  Z, itmax_Z,  0.25D0)
!       call sm2(mlon, mlat, SD, itmax_SD, 0.25D0)
!
! where 0.25D0 is the dimensionless filter coefficient, and 
!
!       itmax_Z  = 2*mlat
!       itmax_SD = mlon
!
! [As discussed elsewhere] the above filtering is a bit too strong.
! But it is the filter I used up to now.
! I am currently testing the following setting 
!
!       itmax_Z  = mlat/2
!       itmax_SD = mlon/4
! "


      subroutine sm2(im, jm, ht, itmax, c)
!
! Del-2 diffusion on the sphere
!
      implicit none

! Input:
      integer im               ! e-w dimension (eg, 144 for 2.5 deg resolution)
      integer jm               ! n-s doemsnion (eg, 91 for 2 deg resolution)
      integer itmax            ! iteration count
      real*8  c                ! filter coefficient

! Input/Output
      real*8 ht(im,jm)         ! array to be filtered

! Local
      real*8 dg(im,jm)   ! del2 of h
      real*8 cose(jm), cosp(jm), sinp(jm), sine(jm)
      real*8 dl
      real*8 dp
      real*8 fmin, fmax
      integer jm1
      integer mnk, mxk
      integer ndeg
      integer it, i, j
      real*8 s1, s2

      jm1 = jm-1

      call setrig(im, jm, dp, DL, cosp, cose, sinp, sine)

      call pmnx(ht, im, jm, fmin, fmax, mnk, mxk)
      write(6,*) 'hmax=', fmax,' at j= ',mxk
      write(6,*) 'hmin=', fmin,' at j= ',mnk

      ndeg = 60                    ! starting latitude for the monotonicity
                                   ! preserving polar filter

      call pmnx(ht,im,jm,fmin,fmax,mnk,mxk)
      write(6,*) 'hmax=', fmax,' at j= ',mxk
      write(6,*) 'hmin=', fmin,' at j= ',mnk

! Apply Monotonicity preserving polar filter
      call plft2d(im, jm, ht, 2, jm1, ndeg)
      call avgp2(ht, sine, im, jm)

      do it=1,itmax
	call del2(ht, im, jm, dg, cosp, cose, sine, DL, dp, ndeg)
        call plft2d(im, jm, dg, 2, jm1, ndeg)

	do j=1,jm
	   do i=1,im
             ht(i,j) = ht(i,j) + c*dg(i,j)
           enddo
        enddo
      enddo

! Final polar filter
      call plft2d(im, jm, ht, 2, jm1, ndeg)

      return
      end

      subroutine del2(h, im, jm, dg, cosp, cose, sine, dL, dp, ndeg)
      implicit none

! AE = 1  (unit radius)
! Input:
        integer im
        integer jm
        integer ndeg
! Input-output

	real*8 h(im,jm)
	real*8 dg(im,jm)              ! del2 of h
	real*8 cose(jm),cosp(jm)
	real*8 sine(jm)
	real*8 PI, ycrit, coszc, CD
	real*8 DL, dp

! Local
	real*8 fx(im,jm)   ! e-w fluxes
	real*8 fy(im,jm)   ! n-s fluxes
        integer i, j
 
	call grad(h, im, jm, fx, fy, cosp, dl, dp)

        PI = 4. * ATAN(1.)
        ycrit = float(ndeg)*PI/180.
        coszc = cos(ycrit)

 	CD = 0.25*DL*DP*coszc**2
!	CD = 0.25*DL*DP*cosp(2)**2

        do j=2,jm-1
           do i=1,im
              fx(i,j) = fx(i,j) * CD
           enddo
        enddo

        do j=2,jm
	   do i=1,im
	      fy(i,j) = fy(i,j) * CD
           enddo
        enddo

	call divg(im,jm,fx,fy,DG,cosp,cose,sine, dl, dp)

	return
	end

      subroutine divg(im, jm, fx, fy, dg, cosp, cose, sine, dl, dp)
      implicit none

      integer im
      integer jm
      real*8 fx(im,jm)   ! e-w fluxes
      real*8 fy(im,jm)   ! n-s fluxes
      real*8 DG(im,jm)   ! del2 of h
      real*8 wk(im,jm)
      real*8 cosp(jm),  cose(jm), sine(jm)
      real*8 rdx
      real*8 dl, dp, CDP, sum1, sum2
      integer i,j

	do j=2,jm-1

	rdx = 1./ (cosp(j)*DL)

           do i=1,im-1
              DG(i,j) = (fx(i+1,j) - fx(i,j)) * rdx
           enddo
              DG(im,j) = (fx(1,j) - fx(im,j)) * rdx
        enddo

	do j=2,jm
           do i=1,im
              wk(i,j) = fy(i,j) * cose(j)
           enddo
        enddo

	do j=2,jm-1
           CDP = 1./ (DP*cosp(j))
           do i=1,im
              DG(i,j) = DG(i,j) + (wk(i,j+1) - wk(i,j)) * CDP
           enddo
	enddo

! Poles;

	sum1 = wk(im, 2)
	sum2 = wk(im,jm)

	do i=1,im-1
           sum1 = sum1 + wk(i, 2)
           sum2 = sum2 + wk(i,jm)
	enddo

	sum1 =  sum1 / ( float(im)*(1.+sine(2)) )
	sum2 = -sum2 / ( float(im)*(1.+sine(2)) )

	do i=1,im
           DG(i, 1) =  sum1
           DG(i,jm) =  sum2
	enddo

	return
	end

      subroutine grad(h, im, jm, fx, fy, cosp, DL, DP)
      implicit none
      integer im
      integer jm
      real*8 h(im,jm)
      real*8 fx(im,jm)   ! e-w fluxes
      real*8 fy(im,jm)   ! n-s fluxes
      real*8 cosp(jm)
      real*8 RDP, DL, DP, rdx
      integer i, j

	RDP = 1./ DP

      do j=2,jm
         do i=1,im
            fy(i,j) = (h(i,j) - h(i,j-1)) * RDP
         enddo
      enddo

      do j=2,jm-1

	rdx = 1./ (cosp(j)*DL)
        fx(1,j) = (h(1,j) - h(im,j)) * rdx
        do i=2,im
           fx(i,j) = (h(i,j) - h(i-1,j)) * rdx
        enddo
      enddo

      return
      end

      subroutine avgp2(p, sine, im, jm)
      implicit none
      integer im, jm
      real*8 p(im,jm)
      real*8 sine(jm)
      real*8 sum1, sum2
      real*8 sum3, sum4
      real*8 rim
      integer i
      integer j
      integer jm1

      jm1 = jm-1
      rim = 1./ float(im)

      call sump2(p(1,1),p(1,jm),IM,sum1,sum2)
      sum1 = sum1*(1.+sine(2))
      sum2 = sum2*(1.+sine(2))

      call sump2(p(1,2),p(1,jm1),IM,sum3,sum4)
      sum1 = rim * ( sum1 + sum3*(sine(3)-sine(2)) ) / (1.+sine(3))
      sum2 = rim * ( sum2 + sum4*(sine(3)-sine(2)) ) / (1.+sine(3))

      do i=1,im
      P(i,  1) = sum1
      P(i,  2) = sum1
      P(i,jm1) = sum2
      P(i, jm) = sum2
      enddo
      return
      end

      subroutine sump2(p1,p2,im,s1,s2)
      implicit none
      integer im,i
      real*8 s1,s2
      real*8 p1(*),p2(*)
 
         s1 =  p1(im)
         s2 =  p2(im)
 
      do i=1,im-1
         s1 =  s1 + p1(i)
         s2 =  s2 + p2(i)
      enddo
      return
      end

      subroutine pmnx(a,nx,ny,fmin,fmax,mnk,mxk)
      implicit none
      integer nx
      integer ny
      integer mnk
      integer mxk
      real*8 a(nx,*)
      real*8 fmax, fmin, temp
      integer i,j

      fmax = a(1,1)
      fmin = a(1,1)
      mnk = 1
      mxk = 1

      do j=1,ny
        do i=1,nx
           temp = a(i,j)
           if(temp.gt.fmax) then
              fmax = temp
              mxk = j
           elseif(temp .lt. fmin) then
              fmin = temp
              mnk = j
           endif
        enddo
      enddo

      return
      end

subroutine compare_var(vari, varo)

   use fill_positions, only: varspec_t

   implicit none

   include 'netcdf.inc'

   ! Input arguments
   type(varspec_t), intent(in) :: vari
   type(varspec_t), intent(in) :: varo

   ! Local workspace
   logical isfloatingi
   logical isfloatingo
   !------------------------------------------------------------------------------

   if (vari%name /= varo%name) then
      write(6,*)'compare_var: names do not match: ', trim(vari%name), trim(varo%name)
      stop 999
   end if

   isfloatingi = vari%xtype == nf_float .or. vari%xtype == nf_double
   isfloatingo = varo%xtype == nf_float .or. varo%xtype == nf_double

   if (vari%xtype /= varo%xtype .and. .not. (isfloatingi .and. isfloatingo)) then
      write(6,*)'compare_var: types are incompatible for: ', &
                trim(vari%name), ' ', trim(varo%name)
      stop 999
   end if

end subroutine compare_var

subroutine wrap_create (path, cmode, ncid)
  implicit none
  include 'netcdf.inc'
      
  character*(*) path
  integer cmode, ncid

  integer ret

  ret =      nf_create (path, cmode, ncid)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine

subroutine wrap_open (path, omode, ncid)
  implicit none
  include 'netcdf.inc'

  character*(*) path
  integer omode
  integer ncid
  integer ret
  
  ret =      nf_open (path, omode, ncid)
  if (ret.ne.NF_NOERR) then
    write(6,*)'WRAP_OPEN: nf_open failed for file ',path
    call handle_error (ret)
  end if
end subroutine

subroutine wrap_inq_varid (nfid, varname, varid)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  character*(*) varname

  integer ret

  ret = nf_inq_varid (nfid, varname, varid)
  if (ret.ne.NF_NOERR) then
    write(6,*)'nf_inq_varid: ',trim(varname),' not found'
    call handle_error (ret)
  end if
end subroutine wrap_inq_varid

subroutine wrap_inq_dimname (nfid, dimid, dimname)
  implicit none
  include 'netcdf.inc'
  
  integer nfid, dimid
  character*(*) dimname
  
  integer ret
  
  ret =      nf_inq_dimname (nfid, dimid, dimname)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine

subroutine wrap_inq_dimlen (nfid, dimid, dimlen)
  implicit none
  include 'netcdf.inc'

  integer nfid, dimid, dimlen

  integer ret

  ret = nf_inq_dimlen (nfid, dimid, dimlen)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_inq_dimlen

subroutine wrap_inq_dimid (nfid, dimname, dimid)
  implicit none
  include 'netcdf.inc'

  integer nfid, dimid
  character*(*) dimname

  integer ret

  ret = nf_inq_dimid (nfid, dimname, dimid)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_inq_dimid

subroutine wrap_inq_var (nfid, varid, varname, xtype, ndims, dimids, natts)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid, xtype, ndims, dimids(nf_max_dims), natts
  character*(*) varname

  integer ret

  ret = nf_inq_var (nfid, varid, varname, xtype, ndims, dimids, natts)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_inq_var

subroutine wrap_def_dim (nfid, dimname, len, dimid)
  implicit none
  include 'netcdf.inc'

  integer nfid, len, dimid
  character*(*) dimname

  integer ret

  ret = nf_def_dim (nfid, dimname, len, dimid)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_def_dim

subroutine wrap_def_var (nfid, name, xtype, nvdims, vdims, varid)
  implicit none
  include 'netcdf.inc'

  integer nfid, xtype, nvdims, varid
  integer vdims(nvdims)
  character*(*) name
  
  integer ret

  ret =      nf_def_var (nfid, name, xtype, nvdims, vdims, varid)
!      write(6,*)'WRAP_DEF_VAR: ',name,' has varid ',varid,nvdims,
!     $'dimensions of ids ',(vdims(i),i=1,nvdims)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine

subroutine wrap_get_var_double (nfid, varid, arr)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  real*8 arr(*)

  integer ret

  ret = nf_get_var_double (nfid, varid, arr)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_get_var_double

subroutine wrap_get_var_int (nfid, varid, arr)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  integer arr(*)

  integer ret

  ret = nf_get_var_int (nfid, varid, arr)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_get_var_int

subroutine wrap_get_vara_double (nfid, varid, start, count, arr)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid, start(nf_max_dims), count(nf_max_dims)
  real*8 arr(*)

  integer ret

  ret = nf_get_vara_double (nfid, varid, start, count, arr)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_get_vara_double

subroutine wrap_get_vara_int (nfid, varid, start, count, arr)
  use shr_kind_mod, only: r8 => shr_kind_r8
  implicit none
  include 'netcdf.inc'

  integer nfid, varid, start(*), count(*)
  integer arr(*)

  integer ret

  ret =      nf_get_vara_int (nfid, varid, start, count, arr)
  if (ret.ne.NF_NOERR) then
    write(6,*)'WRAP_GET_VARA8: error reading varid =', varid
    call handle_error (ret)
  end if
end subroutine

subroutine wrap_put_vara_text (nfid, varid, start, count, text)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  integer start(*), count(*)
  character text(*)

  integer ret

  ret =      nf_put_vara_text (nfid, varid, start, count, text)
  if (ret.ne.NF_NOERR) then
    write(6,*)'WRAP_PUT_VARA_TEXT: error writing varid =', varid
    call handle_error (ret)
  end if
end subroutine

!------------------------------------------------------------------------------

subroutine wrap_get_vara_text (nfid, varid, start, count, text)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  integer start(*), count(*)
  character text(*)

  integer ret

  ret =      nf_get_vara_text (nfid, varid, start, count, text)
  if (ret.ne.NF_NOERR) then
    write(6,*)'WRAP_GET_VARA_TEXT: error writing varid =', varid
    call handle_error (ret)
  end if
end subroutine

subroutine wrap_put_var8 (nfid, varid, arr)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  real*8 arr(*)

  integer ret
  ret = nf_put_var_double (nfid, varid, arr)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_put_var8

subroutine wrap_put_vara_double (nfid, varid, start, count, arr)
  use shr_kind_mod, only: r8 => shr_kind_r8
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  integer start(*), count(*)
  real(r8) arr(*)
  
  integer ret
  ret =      nf_put_vara_double (nfid, varid, start, count, arr)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine

subroutine handle_error (ret)
  implicit none
  include 'netcdf.inc'

  integer ret

  write(6,*) nf_strerror (ret)
  call abort
end subroutine handle_error

subroutine wrap_put_vara_int (nfid, varid, start, count, arr)
  use shr_kind_mod, only: r8 => shr_kind_r8
  implicit none
  include 'netcdf.inc'

  integer nfid, varid, start(*), count(*)
  integer arr(*)

  integer ret
  ret =      nf_put_vara_int (nfid, varid, start, count, arr)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine

subroutine wrap_inq (nfid, ndims, nvars, ngatts, unlimdimid)
  implicit none
  include 'netcdf.inc'
  
  integer nfid, ndims, nvars, ngatts, unlimdimid
  
  integer ret

  ret =      nf_inq (nfid, ndims, nvars, ngatts, unlimdimid)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine

subroutine wrap_inq_dim (nfid, dimid, name, length)
  implicit none
  include 'netcdf.inc'
  
  integer nfid, dimid, length
  character*(*) name
  
  integer ret

  ret =      nf_inq_dim (nfid, dimid, name, length)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine

subroutine wrap_inq_attname (nfid, varid, num, attname)
  implicit none
      
  include 'netcdf.inc'

  integer nfid, varid, num
  character*(*) attname

  integer ret

  ret =      nf_inq_attname (nfid, varid, num, attname)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine

subroutine wrap_get_att_text (nfid, varid, attname, atttext)
  implicit none
      
  include 'netcdf.inc'

  integer nfid, varid
  character*(*) attname, atttext

  integer ret

  ret =      nf_get_att_text (nfid, varid, attname, atttext)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine

subroutine wrap_copy_att (nfid, varid, attname, nfido, varido)
  implicit none
      
  include 'netcdf.inc'

  integer nfid, varid, nfido, varido
  character*(*) attname

  integer ret

  ret =      nf_copy_att (nfid, varid, attname, nfido, varido)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine

module clm_varpar

!-----------------------------------------------------------------------
!BOP
!
! !MODULE: clm_varpar
!
! !DESCRIPTION:
! Module containing CLM parameters
!
! !USES:
  use shr_kind_mod, only: r8 => shr_kind_r8
!
! !PUBLIC TYPES:
  implicit none
  save
!
! Define land surface 2-d grid. The model resolution is read in from the surface dataset
!
  integer             :: lsmlon              ! maximum number of longitude points on lsm grid
  integer             :: lsmlat              ! number of latitude points on lsm grid

! Define number of levels

  integer, parameter :: nlevsoi     =  10     ! number of hydrologically active soil layers
  integer, parameter :: nlevgrnd    =  15     ! number of ground layers (includes lower layers that are hydrologically inactive)
  integer, parameter :: nlevurb     = nlevgrnd! number of urban layers (must equal nlevgrnd right now)
  integer, parameter :: nlevlak     =  10     ! number of lake layers
  integer, parameter :: nlevsno     =   5     ! maximum number of snow layers

! Define miscellaneous parameters

  integer, parameter :: numwat      =   5   ! number of water types (soil, ice, 2 lakes, wetland)
  integer, parameter :: numrad      =   2   ! number of solar radiation bands: vis, nir
  integer, parameter :: ivis        =   1   ! index for visible band
  integer, parameter :: inir        =   2   ! index for near-infrared band
  integer, parameter :: numsolar    =   2   ! number of solar type bands: direct, diffuse
  integer, parameter :: ndst        =   4   ! number of dust size classes (BGC only)
  integer, parameter :: dst_src_nbr =   3   ! number of size distns in src soil (BGC only)
  integer, parameter :: sz_nbr      = 200   ! number of sub-grid bins in large bin of dust size distribution (BGC only)
  integer, parameter :: nvoc        =   5   ! number of voc categories

! Define parameters for RTM river routing model

  integer            :: rtmlon        !number of rtm longitudes
  integer            :: rtmlat        !number of rtm latitudes

! Define indices used in surface file read
! maxpatch_pft     = max number of plant functional types in naturally vegetated landunit
! maxpatch_urb     = max number of urban pfts (columns) in urban landunit
! maxpatch_wet     = max number of wetland pfts (columns) in wetland landunit
! maxpatch_lake    = max number of lake pfts (columns) in lake landunit
! maxpatch_glacier = max number of glacier pfts (columns) in glacier landunit
! maxpatch_glcmec  = max number of glacier_mec pfts (columns) in glacier_mec landunit

  integer, parameter :: mxpft          = 20     ! maximum number of PFT's for any mode
  integer, parameter :: numveg         = 16     ! number of veg types (without specific crop)
#if (defined CROP)
  integer, parameter :: numpft         = mxpft  ! actual # of pfts (without bare)
  integer, parameter :: numcft         =  6     ! actual # of crops
#else
  integer, parameter :: numpft         = numveg ! actual # of pfts (without bare)
  integer, parameter :: numcft         =  2     ! actual # of crops
#endif
  integer, parameter :: maxpatch_urb   = 5
  integer            :: maxpatch_pft
#if defined(GLC_NEC_10)
  integer, parameter :: maxpatch_glcmec = 10
#elif defined(GLC_NEC_5)
  integer, parameter :: maxpatch_glcmec = 5
#elif defined(GLC_NEC_3)
  integer, parameter :: maxpatch_glcmec = 3
#elif defined(GLC_NEC_1)
  integer, parameter :: maxpatch_glcmec = 1
#else
  integer, parameter :: maxpatch_glcmec = 0
#endif
  integer            :: npatch_urban
  integer            :: npatch_lake 
  integer            :: npatch_wet  
  integer            :: npatch_glacier
  integer            :: npatch_glacier_mec
  integer            :: maxpatch    

! clm_varpar_init seems to do something similar; less prone to error to move
! these three lines there? (slevis)
#if (defined CROP)
  integer, parameter :: max_pft_per_gcell = numpft+1 + 3 + maxpatch_urb + maxpatch_glcmec
#else
  integer, parameter :: max_pft_per_gcell = numpft+1 + 3 + maxpatch_urb + numcft + maxpatch_glcmec
#endif
  integer, parameter :: max_pft_per_lu    = max(numpft+1, numcft, maxpatch_urb)
  integer, parameter :: max_pft_per_col   = max(numpft+1, numcft, maxpatch_urb)

! !PUBLIC MEMBER FUNCTIONS:
  public clm_varpar_init          ! set parameters

! !REVISION HISTORY:
! Created by Mariana Vertenstein

!EOP
!-----------------------------------------------------------------------
contains

!------------------------------------------------------------------------------
!BOP
!
! !IROUTINE: clm_varpar_init
!
! !INTERFACE:
  subroutine clm_varpar_init()
!
! !DESCRIPTION:
! This subroutine initializes parameters in clm_varpar
!
! !USES:
!
! !ARGUMENTS:
    implicit none
!
! !REVISION HISTORY:
!   Created by T Craig
!
!
! !LOCAL VARIABLES:
!
!EOP
!------------------------------------------------------------------------------

  lsmlon         = 1
  lsmlat         = 1
  rtmlon         = 1
  rtmlat         = 1
  maxpatch_pft   = MAXPATCH_PFT
  npatch_urban   = maxpatch_pft + 1
  npatch_lake    = npatch_urban + maxpatch_urb
  npatch_wet     = npatch_lake  + 1
  npatch_glacier = npatch_wet   + 1
  npatch_glacier_mec = npatch_glacier + maxpatch_glcmec
  maxpatch       = npatch_glacier_mec

  end subroutine clm_varpar_init

!------------------------------------------------------------------------------
end module clm_varpar

module mkpftMod

!-----------------------------------------------------------------------
!BOP
!
! !MODULE: mkpft
!
! !DESCRIPTION:
! Make PFT data
!
! !REVISION HISTORY:
! Author: Mariana Vertenstein
!
!-----------------------------------------------------------------------
!!USES:
  use shr_kind_mod, only : r8 => shr_kind_r8
  use shr_sys_mod , only : shr_sys_flush
  use mkvarctl    , only : numpft
  use mkdomainMod , only : domain_checksame

  implicit none

  private           ! By default make data private
!
! !PUBLIC MEMBER FUNCTIONS:
!
  public mkpftInit         ! Initialization
  public mkpft             ! Set PFT
  public mkpft_parse_oride ! Parse the string with PFT fraction/index info to override
  public mkirrig           ! Set irrigation
  public mkpftAtt          ! Write out attributes to output file on pft
!
! !PUBLIC DATA MEMBERS: 
!

  !
  ! When pft_idx and pft_frc are set, they must be set together, and they will cause the
  ! entire area to be covered with vegetation and zero out other landunits.
  ! The sum of pft_frc must = 100%, and each pft_idx point in the array corresponds to
  ! the fraction in pft_frc. Only the first few points are used until pft_frc = 0.0.
  !
  integer            :: m                     ! index
  integer, parameter :: maxpft = 20           ! maximum # of PFT
  integer, public    :: pft_idx(0:maxpft) = & ! PFT vegetation index to override with
                             (/ ( -1,  m = 0, maxpft )   /)
  real(r8), public   :: pft_frc(0:maxpft) = & ! PFT vegetation fraction to override with
                             (/ ( 0.0, m = 0, maxpft ) /)
  integer, public :: nonIrrigIdx = 15
  integer, public :: IrrigIdx    = 16
!
! !PRIVATE DATA MEMBERS:
!
  logical, private :: zero_out      = .false. ! Flag to zero out PFT
  logical, private :: use_input_pft = .false. ! Flag to override PFT with input values
  integer, private :: nzero                   ! index of first zero fraction
!
! !PRIVATE MEMBER FUNCTIONS:
!
  private :: mkpft_check_oride  ! Check the pft_frc and pft_idx values for correctness
!EOP
!===============================================================
contains
!===============================================================

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkpftInit
!
! !INTERFACE:
subroutine mkpftInit( zero_out_l, all_veg )
!
! !DESCRIPTION:
! Initialize of Make PFT data
! !USES:
!
! !ARGUMENTS:
  implicit none
  logical, intent(IN)  :: zero_out_l ! If veg should be zero'ed out
  logical, intent(OUT) :: all_veg    ! If should zero out other fractions so that
                                     ! all land-cover is vegetation
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!
! !LOCAL VARIABLES:
!EOP
  real(r8), parameter :: hndrd = 100.0_r8  ! A hundred percent
  character(len=32) :: subname = 'mkpftInit:: '
!-----------------------------------------------------------------------

  call mkpft_check_oride( )
  if ( use_input_pft ) then
     if ( maxpft < numpft ) then
        write(6,*) subname//'number PFT is > max allowed!'
        call abort()
     end if
     write(6,*) 'Set PFT fraction to : ', pft_frc(0:nzero-1)
     write(6,*) 'With PFT index      : ', pft_idx(0:nzero-1)
  end if

  all_veg = use_input_pft

  if ( zero_out_l .and. all_veg )then
     write(6,*) subname//'zeroing out vegetation and setting vegetation to 100% is a contradiction!'
     call abort()
  end if

  ! Copy local zero out to module data version
  zero_out = zero_out_l

end subroutine mkpftInit

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkpft
!
! !INTERFACE:
subroutine mkpft(ldomain, mapfname, fpft, firrig, ndiag, &
     pctlnd_o, pctirr_o, pctpft_o)
!
! !DESCRIPTION:
! Make PFT data
! This dataset consists of the %cover of the [numpft]+1 PFTs used by
! the model. The input %cover pertains to the "vegetated" portion of the
! grid cell and sums to 100. The real portion of each grid cell
! covered by each PFT is the PFT cover times the fraction of the
! grid cell that is land. This is the quantity preserved when
! area-averaging from the input (1/2 degree) grid to the models grid.
!
! !USES:
  use mkdomainMod, only : domain_type, domain_clean, domain_read
  use mkgridmapMod
  use mkvarpar	
  use mkvarctl    
  use mkncdio
!
! !ARGUMENTS:
  implicit none
  type(domain_type), intent(inout) :: ldomain
  character(len=*)  , intent(in) :: mapfname              ! input mapping file name
  character(len=*)  , intent(in) :: fpft                  ! input pft dataset file name
  character(len=*)  , intent(in) :: firrig                ! input irrigation dataset file name
  integer           , intent(in) :: ndiag                 ! unit number for diag out
  real(r8)          , intent(in) :: pctirr_o(:)           ! % irrigated area (output grid)
  real(r8)          , intent(out):: pctlnd_o(:)           ! output grid:%land/gridcell
  real(r8)          , pointer    :: pctpft_o(:,:)         ! PFT cover (% of vegetated area)
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Mariana Vertenstein
!
!
! !LOCAL VARIABLES:
!EOP
  type(domain_type)    :: tdomain            ! local domain
  type(gridmap_type)    :: tgridmap           ! local gridmap
  real(r8), allocatable :: pctpft_i(:,:)      ! input grid: PFT percent
  integer  :: numpft_i                        ! num of plant types input data
  real(r8) :: sum_fldo                        ! global sum of dummy output fld
  real(r8) :: sum_fldi                        ! global sum of dummy input fld
  real(r8) :: wst(0:numpft)                   ! as pft_o at specific no
  real(r8) :: wst_sum                         ! sum of %pft
  real(r8) :: gpft_o(0:numpft)                ! output grid: global area pfts
  real(r8) :: garea_o                         ! output grid: global area
  real(r8) :: gpft_i(0:numpft)                ! input grid: global area pfts
  real(r8) :: garea_i                         ! input grid: global area
  integer  :: k,n,m,ni,no,ns_i,ns_o           ! indices
  integer  :: ncid,dimid,varid                ! input netCDF id's
  integer  :: ier                             ! error status
  integer  :: indxcrop                        ! input grid index for crop
  real(r8) :: relerr = 0.00001                ! max error: sum overlap wts ne 1

  character(len=35)  veg(0:numpft)            ! vegetation types
  character(len=32) :: subname = 'mkpft'
!-----------------------------------------------------------------------

  write (6,*)
  write (6,*) 'Attempting to make PFTs .....'
  call shr_sys_flush(6)

  ! -----------------------------------------------------------------
  ! Set the vegetation types
  ! -----------------------------------------------------------------
  if ( numpft >= numstdpft )then
     veg(0:numstdpft) = (/                                &
                   'not vegetated                      ', &
                   'needleleaf evergreen temperate tree', &
                   'needleleaf evergreen boreal tree   ', &
                   'needleleaf deciduous boreal tree   ', &
                   'broadleaf evergreen tropical tree  ', &
                   'broadleaf evergreen temperate tree ', &
                   'broadleaf deciduous tropical tree  ', &
                   'broadleaf deciduous temperate tree ', &
                   'broadleaf deciduous boreal tree    ', &
                   'broadleaf evergreen shrub          ', &
                   'broadleaf deciduous temperate shrub', &
                   'broadleaf deciduous boreal shrub   ', &
                   'c3 arctic grass                    ', &
                   'c3 non-arctic grass                ', &
                   'c4 grass                           ', &
                   'c3_crop                            ', &
                   'c4_crop                            ' /)
     indxcrop = 15   ! c3_crop is active generic crop type
  end if
  if (      numpft == numstdpft )then
     write(6,*)'Creating surface datasets with the standard # of PFTs =', numpft
  else if ( numpft > numstdpft )then
     write(6,*)'Creating surface datasets with extra types for crops; total pfts =', numpft
  else
     write(6,*) subname//': parameter numpft is NOT set to a known value (should be 16 or more) =',numpft
     call abort()
  end if

  ! -----------------------------------------------------------------
  ! Read input PFT file
  ! -----------------------------------------------------------------

  ns_o = ldomain%ns

  if ( .not. use_input_pft ) then
     ! Obtain input grid info, read PCT_PFT

     call domain_read(tdomain,fpft)
     ns_i = tdomain%ns

     write (6,*) 'Open PFT file: ', trim(fpft)
     call check_ret(nf_open(fpft, 0, ncid), subname)

     call check_ret(nf_inq_dimid  (ncid, 'pft', dimid), subname)
     call check_ret(nf_inq_dimlen (ncid, dimid, numpft_i), subname)

     if (numpft_i .ne. numpft+1) then
        write(6,*) subname//': parameter numpft+1= ',numpft+1, &
             'does not equal input dataset numpft= ',numpft_i
        call abort()
     endif

     allocate(pctpft_i(ns_i,0:numpft), stat=ier)
     if (ier/=0) call abort()

     call check_ret(nf_inq_varid (ncid, 'PCT_PFT', varid), subname)
     call check_ret(nf_get_var_double (ncid, varid, pctpft_i), subname)

     call check_ret(nf_close(ncid), subname)

  else
     ns_i = 1
  end if

  ! Determine pctpft_o on output grid

  if ( zero_out ) then

     pctpft_o(:,:) = 0._r8
     pctlnd_o(:)   = 100._r8

  else if ( use_input_pft ) then

     call mkpft_check_oride( )

     ! set PFT based on input pft_frc and pft_idx
     pctpft_o(:,:) = 0._r8
     pctlnd_o(:)   = 100._r8
     do m = 0, numpft
        ! Once reach a PFT where fraction goes to zero -- exit
        if ( pft_frc(m) .eq. 0.0_r8 ) exit
        do no = 1,ns_o
           pctpft_o(no,pft_idx(m)) = pft_frc(m)
        end do
     end do

  else

     ! Compute pctlnd_o, pctpft_o

     call gridmap_mapread(tgridmap, mapfname)

     ! Error checks for domain and map consistencies

     call domain_checksame( tdomain, ldomain, tgridmap )
     ! Area-average percent cover on input grid [pctpft_i] to output grid 
     ! [pctpft_o] and correct [pctpft_o] according to land landmask
     ! Note that percent cover is in terms of total grid area.

     do no = 1,ns_o
        pctlnd_o(no)     = tgridmap%frac_dst(no) * 100._r8
        ldomain%frac(no) = tgridmap%frac_dst(no) 
     end do

     do m = 0,numpft
        call gridmap_areaave(tgridmap, pctpft_i(:,m), pctpft_o(:,m))
        do no = 1,ns_o
           if (pctlnd_o(no) < 1.0e-6) then
              if (m == 0) then
                 pctpft_o(no,m) = 100._r8
              else
                 pctpft_o(no,m) = 0._r8
              endif
           end if
        enddo
     enddo

     ! if irrigation dataset present, split into irrigated and 
     ! non-irrigated crop area
     if (firrig /= ' ') then
        write(6,*) 'Irrigation dataset present; splitting crop PFT into irrigated ',&
                   'and non-irrigated fractions'
        do no = 1,ns_o
           pctpft_o(no,IrrigIdx)    = min(pctpft_o(no,nonIrrigIdx),pctirr_o(no))
           pctpft_o(no,nonIrrigIdx) = pctpft_o(no,nonIrrigIdx) - pctpft_o(no,IrrigIdx)
        enddo
     endif

  end if

  ! Error check: percents should sum to 100 for land grid cells

  if ( .not. zero_out) then
     do no = 1,ns_o
        wst_sum = 0.
        do m = 0,numpft
           wst_sum = wst_sum + pctpft_o(no,m)
        enddo
        if (abs(wst_sum-100._r8) > 0.00001_r8) then
           write (6,*) subname//'error: pft = ', &
                (pctpft_o(no,m), m = 0, numpft), &
                ' do not sum to 100. at no = ',no,' but to ', wst_sum
           stop
        end if
     end do
  end if

  ! -----------------------------------------------------------------
  ! Error check
  ! Compare global areas on input and output grids
  ! -----------------------------------------------------------------

  if ( .not. (zero_out .or. use_input_pft) ) then

     ! input grid

     gpft_i(:) = 0.
     garea_i   = 0.
     do ni = 1,ns_i
        garea_i = garea_i + tgridmap%area_src(ni)*re**2
        do m = 0, numpft
           gpft_i(m) = gpft_i(m) + pctpft_i(ni,m)*tgridmap%area_src(ni)*&
                                                  tgridmap%frac_src(ni)*re**2
        end do
     end do
     if ( allocated(pctpft_i) ) deallocate (pctpft_i)

     ! output grid

     gpft_o(:) = 0.
     garea_o   = 0.
     do no = 1,ns_o
        garea_o = garea_o + tgridmap%area_dst(no)*re**2
        do m = 0, numpft
           gpft_o(m) = gpft_o(m) + pctpft_o(no,m)*tgridmap%area_dst(no)*&
                                                  tgridmap%frac_dst(no)*re**2
        end do
     end do

     ! comparison

     write (ndiag,*)
     write (ndiag,'(1x,70a1)') ('=',k=1,70)
     write (ndiag,*) 'PFTs Output'
     write (ndiag,'(1x,70a1)') ('=',k=1,70)

     write (ndiag,*)
     write (ndiag,'(1x,70a1)') ('.',k=1,70)
     write (ndiag,1001)
1001 format (1x,'plant type     ',20x,' input grid area',' output grid area',/ &
             1x,33x,'     10**6 km**2','      10**6 km**2')
     write (ndiag,'(1x,70a1)') ('.',k=1,70)
     write (ndiag,*)
     do m = 0, numpft
        write (ndiag,1002) veg(m), gpft_i(m)*1.e-06/100.,gpft_o(m)*1.e-06/100.
     end do
1002 format (1x,a35,f16.3,f17.3)
     call shr_sys_flush(ndiag)

  end if

  ! Deallocate dynamic memory

  call domain_clean(tdomain) 
  if ( .not. zero_out .and. .not. use_input_pft ) then
     call gridmap_clean(tgridmap)
  end if

  write (6,*) 'Successfully made PFTs'
  write (6,*)


end subroutine mkpft

!-----------------------------------------------------------------------
 
!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkpft_parse_oride
!
! !INTERFACE:
subroutine mkpft_parse_oride( string )
!
! !DESCRIPTION:
! Parse the string with pft fraction and index information on it, to override
! the file with this information rather than reading from a file.
!
! !USES:
   use shr_string_mod, only: shr_string_betweenTags, shr_string_countChar
! !ARGUMENTS:
   character(len=256), intent(IN) :: string  ! String to parse with PFT fraction 
                                             ! and index data
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!
! !LOCAL VARIABLES:
!EOP
  integer :: rc                         ! error return code
  integer :: num_elms                   ! number of elements
  character(len=256) :: substring       ! string between tags
  character(len=*), parameter :: frc_start = "<pft_f>"
  character(len=*), parameter :: frc_end   = "</pft_f>"
  character(len=*), parameter :: idx_start = "<pft_i>"
  character(len=*), parameter :: idx_end   = "</pft_i>"
  character(len=*), parameter :: subname = 'mkpft_parse_oride'
!-----------------------------------------------------------------------
  call shr_string_betweenTags( string, frc_start, frc_end, substring, rc )
  if ( rc /= 0 )then
     write(6,*) subname//'Trouble finding pft_frac start end tags'
     call abort()
  end if
  num_elms = shr_string_countChar( substring, ",", rc )
  read(substring,*) pft_frc(0:num_elms)
  call shr_string_betweenTags( string, idx_start, idx_end, substring, rc )
  if ( rc /= 0 )then
     write(6,*) subname//'Trouble finding pft_index start end tags'
     call abort()
  end if
  if ( num_elms /= shr_string_countChar( substring, ",", rc ) )then
     write(6,*) subname//'number of elements different between frc and idx fields'
     call abort()
  end if
  read(substring,*) pft_idx(0:num_elms)
!-----------------------------------------------------------------------

end subroutine mkpft_parse_oride

!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkpft_check_oride
!
! !INTERFACE:
subroutine mkpft_check_oride( )
!
! !DESCRIPTION:
! Check that the pft override values are valid
! !USES:
!
! !ARGUMENTS:
  implicit none
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!
! !LOCAL VARIABLES:
!EOP
  integer  :: i, j                         ! indices
  real(r8) :: sumpft                       ! Sum of pft_frc
  real(r8), parameter :: hndrd = 100.0_r8  ! A hundred percent
  character(len=32) :: subname = 'mkpft_check_oride:: '
!-----------------------------------------------------------------------

  sumpft = sum(pft_frc)
  if (          sumpft == 0.0 )then
    ! PFT fraction is NOT used
    use_input_pft = .false.
  else if ( abs(sumpft - hndrd) > 1.e-6 )then
    write(6,*) subname//'Sum of PFT fraction is NOT equal to 100% =', sumpft
    call abort()
  else
    use_input_pft = .true.
    nzero = 0
    do i = 0, numpft
       if ( pft_frc(i) == 0.0_r8 )then
          nzero = i
          exit
       end if
    end do
    ! PFT fraction IS used, and sum is OK, now check details
    do i = 0, nzero -1
      if ( pft_frc(i) < 0.0_r8 .or. pft_frc(i) > hndrd )then
         write(6,*) subname//'PFT fraction is out of range: pft_frc=', pft_frc(i)
         call abort()
      else if ( pft_frc(i) > 0.0_r8 .and. pft_idx(i) == -1 )then
         write(6,*) subname//'PFT fraction > zero, but index NOT set: pft_idx=', pft_idx(i)
         call abort()
      end if
      ! PFT index out of range
      if ( pft_idx(i) < 0 .or. pft_idx(i) > numpft )then
         write(6,*) subname//'PFT index is out of range: ', pft_idx(i)
         call abort()
      end if
      ! Make sure index values NOT used twice
      do j = 0, i-1
         if ( pft_idx(i) == pft_idx(j) )then
            write(6,*) subname//'Same PFT index is used twice: ', pft_idx(i)
            call abort()
         end if
      end do
    end do
    ! Make sure the rest of the fraction is zero and index are not set as well
    do i = nzero, numpft
      if ( pft_frc(i) /= 0.0_r8 .or. pft_idx(i) /= -1 )then
         write(6,*) subname//'After PFT fraction is zeroed out, fraction is non zero, or index set'
         call abort()
      end if
    end do
  end if

end subroutine mkpft_check_oride

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkirrig
!
! !INTERFACE:
subroutine mkirrig(ldomain, mapfname, datfname, ndiag, irrig_o)
!
! !DESCRIPTION:
! make percent irrigated area
!
! !USES:
  use mkdomainMod, only : domain_type, domain_clean, domain_read
  use mkgridmapMod
  use mkvarpar	
  use mkvarctl    
  use mkncdio
!
! !ARGUMENTS:
  implicit none
  type(domain_type), intent(in) :: ldomain
  character(len=*)  , intent(in) :: mapfname       ! input mapping file name
  character(len=*)  , intent(in) :: datfname       ! input dataset file name
  integer           , intent(in) :: ndiag          ! unit number for diag out
  real(r8)          , intent(out):: irrig_o(:)     ! output grid: %irrigated area
!
! !CALLED FROM:
! subroutine mksrfdat in module mksrfdatMod
!
! !REVISION HISTORY:
! Author: David Lawrence
!
!
! !LOCAL VARIABLES:
!EOP
  type(domain_type)    :: tdomain            ! local domain
  type(gridmap_type)    :: tgridmap           ! local gridmap
  real(r8), allocatable :: irrig_i(:)         ! input grid: percent irrig
  real(r8) :: sum_fldi                        ! global sum of dummy input fld
  real(r8) :: sum_fldo                        ! global sum of dummy output fld
  real(r8) :: girrig_i                        ! input  grid: global irrig
  real(r8) :: garea_i                         ! input  grid: global area
  real(r8) :: girrig_o                        ! output grid: global irrig
  real(r8) :: garea_o                         ! output grid: global area
  integer  :: k,n,m,ni,no,ns_o,ns_i           ! indices
  integer  :: ncid,dimid,varid                ! input netCDF id's
  integer  :: ier                             ! error status
  real(r8) :: relerr = 0.00001                ! max error: sum overlap wts ne 1
  character(len=32) :: subname = 'mkirrig'
!-----------------------------------------------------------------------

  write (6,*)
  write (6,*) 'Attempting to make %irrigated area .....'
  call shr_sys_flush(6)

  ns_o = ldomain%ns

  ! -----------------------------------------------------------------
  ! Read input file
  ! -----------------------------------------------------------------

  ! Obtain input grid info, read local fields

  call domain_read(tdomain, datfname)
  ns_i = tdomain%ns

  write (6,*) 'Open irrigation file: ', trim(datfname)
  call check_ret(nf_open(datfname, 0, ncid), subname)

  allocate(irrig_i(ns_i), stat=ier)
  if (ier/=0) call abort()

  call check_ret(nf_inq_varid (ncid, 'PCT_IRRIG', varid), subname)
  call check_ret(nf_get_var_double (ncid, varid, irrig_i), subname)

  call check_ret(nf_close(ncid), subname)

  ! Area-average percent cover on input grid to output grid 
  ! and correct according to land landmask
  ! Note that percent cover is in terms of total grid area.

  call gridmap_mapread(tgridmap, mapfname)

  ! Error checks for domain and map consistencies

  call domain_checksame( tdomain, ldomain, tgridmap )

  ! Do mapping from input to output grid

  call gridmap_areaave(tgridmap, irrig_i, irrig_o)

  do no = 1, ns_o
     if (irrig_o(no) < 1.) irrig_o(no) = 0.
  enddo

  ! Check for conservation

  do no = 1, ns_o
     if ((irrig_o(no)) > 100.000001_r8) then
        write (6,*) 'MKIRRIG error: irrigated area = ',irrig_o(no), &
                ' greater than 100.000001 for column, row = ',no
        call shr_sys_flush(6)
        stop
     end if
  enddo

  ! Global sum of output field -- must multiply by fraction of
  ! output grid that is land as determined by input grid

  sum_fldi = 0.
  do ni = 1, ns_i
     sum_fldi = sum_fldi + tgridmap%area_src(ni) * tgridmap%frac_src(ni)
  enddo

  sum_fldo = 0.
  do no = 1, ns_o
     sum_fldo = sum_fldo + tgridmap%area_dst(no) * tgridmap%frac_dst(no)
  end do

  ! -----------------------------------------------------------------
  ! Error check1
  ! Compare global sum fld_o to global sum fld_i.
  ! -----------------------------------------------------------------

  if ( trim(mksrf_gridtype) == 'global') then
     if ( abs(sum_fldo/sum_fldi-1.) > relerr ) then
        write (6,*) 'MKIRRIG error: input field not conserved'
        write (6,'(a30,e20.10)') 'global sum output field = ',sum_fldo
        write (6,'(a30,e20.10)') 'global sum input  field = ',sum_fldi
        stop
     end if
  end if

  ! -----------------------------------------------------------------
  ! Error check2
  ! Compare global areas on input and output grids
  ! -----------------------------------------------------------------

  ! Input grid

  girrig_i = 0.
  garea_i = 0.

  do ni = 1,ns_i
     garea_i = garea_i + tgridmap%area_src(ni)
     girrig_i = girrig_i + irrig_i(ni)*(tgridmap%area_src(ni)/100.)*&
                                        tgridmap%frac_src(ni)*re**2
  end do

  ! Output grid

  girrig_o = 0.
  garea_o = 0.

  do no = 1,ns_o
     garea_o = garea_o + tgridmap%area_dst(no)
     girrig_o = girrig_o + irrig_o(no)*(tgridmap%area_dst(no)/100.)*&
                                        tgridmap%frac_dst(no)*re**2
  end do

  ! Diagnostic output

  write (ndiag,*)
  write (ndiag,'(1x,70a1)') ('=',k=1,70)
  write (ndiag,*) 'Irrigated area Output'
  write (ndiag,'(1x,70a1)') ('=',k=1,70)

  write (ndiag,*)
  write (ndiag,'(1x,70a1)') ('.',k=1,70)
  write (ndiag,2001)
2001 format (1x,'surface type   input grid area  output grid area'/ &
             1x,'                 10**6 km**2      10**6 km**2   ')
  write (ndiag,'(1x,70a1)') ('.',k=1,70)
  write (ndiag,*)
  write (ndiag,2002) girrig_i*1.e-06,girrig_o*1.e-06
  write (ndiag,2004) garea_i*1.e-06,garea_o*1.e-06
2002 format (1x,'irrigated area    ',f14.3,f17.3)
2004 format (1x,'all surface ',f14.3,f17.3)
  call shr_sys_flush(ndiag)

  ! Deallocate dynamic memory

  call domain_clean(tdomain)
  call gridmap_clean(tgridmap)
  deallocate (irrig_i)

  write (6,*) 'Successfully made %irrigated area'
  write (6,*)
  call shr_sys_flush(6)

end subroutine mkirrig

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: mkpftAtt
!
! !INTERFACE:
subroutine mkpftAtt( ncid, dynlanduse, xtype )
!
! !DESCRIPTION:
! make PFT attributes on the output file
!
  use mkncdio    , only : check_ret, ncd_defvar
  use fileutils  , only : get_filename
  use mkvarctl   , only : mksrf_fvegtyp, mksrf_firrig, mksrf_flai, outnc_1d
  use mkvarpar   

! !ARGUMENTS:
  implicit none
  include 'netcdf.inc'
  integer, intent(in) :: ncid         ! NetCDF file ID to write out to
  logical, intent(in) :: dynlanduse   ! if dynamic land-use file
  integer, intent(in) :: xtype        ! external type to output real data as
!
! !CALLED FROM:
! subroutine mkfile in module mkfileMod
!
! !REVISION HISTORY:
! Author: Erik Kluzek
!
!
! !LOCAL VARIABLES:
!EOP
  integer :: pftsize              ! size of lsmpft dimension
  integer :: dimid                ! input netCDF id's
  character(len=256) :: str       ! global attribute string
  character(len=32) :: subname = 'mkpftAtt'

  ! Define dimensions
  call check_ret(nf_def_dim (ncid, 'time'   , nf_unlimited, dimid), subname)

  pftsize = numpft + 1
  call check_ret(nf_def_dim (ncid, 'lsmpft' , pftsize     , dimid), subname)

  ! Add global attributes

  str = get_filename(mksrf_firrig)
  call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
       'Irrig_raw_data_file_name', len_trim(str), trim(str)), subname)

  if (.not. dynlanduse) then
     str = get_filename(mksrf_flai)
     call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
            'Lai_raw_data_file_name', len_trim(str), trim(str)), subname)
  end if

  if ( use_input_pft ) then
     str = 'TRUE'
     call check_ret(nf_put_att_text (ncid, NF_GLOBAL, &
          'pft_override', len_trim(str), trim(str)), subname)
  else if ( zero_out )then
     str = 'TRUE'
     call check_ret(nf_put_att_text (ncid, NF_GLOBAL, &
          'zero_out_pft_override', len_trim(str), trim(str)), subname)
  else
     str = get_filename(mksrf_fvegtyp)
     call check_ret(nf_put_att_text(ncid, NF_GLOBAL, &
       'Vegetation_type_raw_data_filename', len_trim(str), trim(str)), subname)
  end if

  ! Define variables

  ! PCT_IRRIG
  if (mksrf_firrig /= ' ') then
     if (outnc_1d) then
        call ncd_defvar(ncid=ncid, varname='PCT_IRRIG', xtype=xtype, &
             dim1name='gridcell',&
             long_name='percent irrigated area', units='unitless')
     else
        call ncd_defvar(ncid=ncid, varname='PCT_IRRIG', xtype=xtype, &
             dim1name='lsmlon', dim2name='lsmlat', &
             long_name='percent irrigated area', units='unitless')
     end if
  endif

  ! LANDFRAC_PFT
  if (outnc_1d) then
     call ncd_defvar(ncid=ncid, varname='LANDFRAC_PFT', xtype=nf_double, &
          dim1name='gridcell',&
          long_name='land fraction from pft dataset', units='unitless')
  else
     call ncd_defvar(ncid=ncid, varname='LANDFRAC_PFT', xtype=nf_double, &
          dim1name='lsmlon', dim2name='lsmlat', &
          long_name='land fraction from pft dataset', units='unitless')
  end if
  
  ! PFTDATA_MASK
  if (outnc_1d) then
     call ncd_defvar(ncid=ncid, varname='PFTDATA_MASK', xtype=nf_int, &
          dim1name='gridcell',&
          long_name='land mask from pft dataset, indicative of real/fake points', units='unitless')
  else
     call ncd_defvar(ncid=ncid, varname='PFTDATA_MASK', xtype=nf_int, &
          dim1name='lsmlon', dim2name='lsmlat', &
          long_name='land mask from pft dataset, indicative of real/fake points', units='unitless')
  end if
  
  ! PCT_PFT
  if (.not. dynlanduse) then
     if (outnc_1d) then
        call ncd_defvar(ncid=ncid, varname='PCT_PFT', xtype=xtype, &
             dim1name='gridcell', dim2name='lsmpft', &
             long_name='percent plant functional type of gridcell', units='unitless')
     else
        call ncd_defvar(ncid=ncid, varname='PCT_PFT', xtype=xtype, &
             dim1name='lsmlon', dim2name='lsmlat', dim3name='lsmpft', &
             long_name='percent plant functional type of gridcell', units='unitless')
     end if
  else
     if (outnc_1d) then
        call ncd_defvar(ncid=ncid, varname='PCT_PFT', xtype=xtype, &
             dim1name='gridcell', dim2name='lsmpft', dim3name='time', &
             long_name='percent plant functional type of gridcell', units='unitless')
     else
        call ncd_defvar(ncid=ncid, varname='PCT_PFT', xtype=xtype, &
             dim1name='lsmlon', dim2name='lsmlat', dim3name='lsmpft', dim4name='time', &
             long_name='percent plant functional type of gridcell', units='unitless')
     end if
  end if

  ! LAI,SAI,HTOP,HBOT
  if (.not. dynlanduse) then
     if (outnc_1d) then
        call ncd_defvar(ncid=ncid, varname='MONTHLY_LAI', xtype=xtype,  &
             dim1name='gridcell', dim2name='lsmpft', dim3name='time', &
             long_name='monthly leaf area index', units='unitless')
     else
        call ncd_defvar(ncid=ncid, varname='MONTHLY_LAI', xtype=xtype,  &
             dim1name='lsmlon', dim2name='lsmlat', dim3name='lsmpft', dim4name='time', &
             long_name='monthly leaf area index', units='unitless')
     end if

     if (outnc_1d) then
        call ncd_defvar(ncid=ncid, varname='MONTHLY_SAI', xtype=xtype,  &
             dim1name='gridcell', dim2name='lsmpft', dim3name='time', &
             long_name='monthly stem area index', units='unitless')
     else
        call ncd_defvar(ncid=ncid, varname='MONTHLY_SAI', xtype=xtype,  &
             dim1name='lsmlon', dim2name='lsmlat', dim3name='lsmpft', dim4name='time', &
             long_name='monthly stem area index', units='unitless')
     end if

     if (outnc_1d) then
        call ncd_defvar(ncid=ncid, varname='MONTHLY_HEIGHT_TOP', xtype=xtype,  &
             dim1name='gridcell', dim2name='lsmpft', dim3name='time', &
             long_name='monthly height top', units='meters')
     else
        call ncd_defvar(ncid=ncid, varname='MONTHLY_HEIGHT_TOP', xtype=xtype,  &
             dim1name='lsmlon', dim2name='lsmlat', dim3name='lsmpft', dim4name='time', &
             long_name='monthly height top', units='meters')
     end if

     if (outnc_1d) then
        call ncd_defvar(ncid=ncid, varname='MONTHLY_HEIGHT_BOT', xtype=xtype,  &
             dim1name='gridcell', dim2name='lsmpft', dim3name='time', &
             long_name='monthly height bottom', units='meters')
     else
        call ncd_defvar(ncid=ncid, varname='MONTHLY_HEIGHT_BOT', xtype=xtype,  &
             dim1name='lsmlon', dim2name='lsmlat', dim3name='lsmpft', dim4name='time', &
             long_name='monthly height bottom', units='meters')
     end if

  end if

  ! OTHER
  if (dynlanduse) then
     call ncd_defvar(ncid=ncid, varname='YEAR', xtype=nf_int,  &
            dim1name='time', &
            long_name='Year of PFT data', units='unitless')
     call ncd_defvar(ncid=ncid, varname='time', xtype=nf_int,  &
            dim1name='time', &
            long_name='year', units='unitless')
     call ncd_defvar(ncid=ncid, varname='input_pftdata_filename', xtype=nf_char,  &
            dim1name='nchar', &
            dim2name='time',  &
            long_name='Input filepath for PFT values for this year', units='unitless')
  else
     call ncd_defvar(ncid=ncid, varname='time', xtype=nf_int,  &
            dim1name='time', &
            long_name='Calendar month', units='month')
  end if

end subroutine mkpftAtt

!-----------------------------------------------------------------------

end module mkpftMod

subroutine sghphis (plon, plat, numlons, mlatcnts, mloncnts, & 
                    topofile, verbose, sgh, sgh30, have_sgh30, phis, fland )

!-----------------------------------------------------------------------
!
! Read high resolution topo dataset and calculate values of phis and sgh
! for the model resolution this model
!
!-----------------------------------------------------------------------

   use shr_kind_mod, only: r8 => shr_kind_r8

   implicit none
   include 'netcdf.inc'
!
!-----------------------------------------------------------------------
!
! parameters
!
   integer , parameter :: ntopolon = 2160
   integer , parameter :: ntopolat = 1080
   integer , parameter :: n2x2lon  = 180
   integer , parameter :: n2x2lat  = 90
   integer , parameter :: n3x3lon  = 120
   integer , parameter :: n3x3lat  = 60
   real(r8), parameter :: r8_360   = 360. ! For argument compatibility to mod
!
! arguments
!
   integer , intent(in) :: plon                ! maximum number of model longitudes
   integer , intent(in) :: plat                ! number of model latitudes
   integer , intent(in) :: numlons(plat)       ! number of model longitudes per latitude
   real(r8), intent(in) :: mlatcnts(plat)      ! model cell center latitudes 
   real(r8), intent(in) :: mloncnts(plon,plat) ! model cell ceneter longitudes
   logical , intent(in) :: verbose             ! true => verbose output 
   character(len=*), intent(in) :: topofile    ! high resolution topo file    
   real(r8), intent(out):: phis(plon,plat)     ! model geopotention height 
   real(r8), intent(out):: sgh(plon,plat)      ! model standard dev of geopotential height above 10min
   real(r8), intent(out):: sgh30(plon,plat)    ! model standard dev of geopotential height from 30s to 10m
   logical , intent(out):: have_sgh30          ! true => variance is on topofile, sgh30 will be output
   real(r8), intent(out):: fland(plon,plat)    ! model fractional land
!
! Local workspace : note that anything with plon or plat in its dimension is dynamic
!
   real(r8) wt                          ! weight for area averaging
   real(r8) dx,dy                       ! increments for definition of intermed grid   

! high resolution topo grid 

   integer lonid_topo, latid_topo       ! input topo file vars
   integer htopoid,ftopoid,ret,varianceid ! input topo file vars
   real(r8) tloncnts(ntopolon)          ! topo cell center lon boundaries
   real(r8) tlatcnts(ntopolat)          ! topo cell center lat boundaries
   real(r8) tlons(ntopolon+1,ntopolat)  ! topo cell W lon boundaries
   real(r8) tlats(ntopolat+1)           ! topo cell N lat boundaries
   real(r8) ftopo(ntopolon,ntopolat)    ! Land fraction array 
   real(r8) htopo(ntopolon,ntopolat)    ! Topographic heights
   real(r8) variance(ntopolon,ntopolat)    ! Variance of elev at 30sec

! intermediate grid

   real(r8) lons3x3(n3x3lon+1,n3x3lat)  ! list of topo cell W lon boundaries
   real(r8) lats3x3(n3x3lat+1)          ! list of topo cell N lat boundaries
   integer num3x3lons(n3x3lat)          ! number if longitudes per latitude
   real(r8) mnhgt3x3(n3x3lon,n3x3lat)   ! intermediate topo height 
   real(r8) varhgt3x3(n3x3lon,n3x3lat)  ! intermediate topovariance

! model grid

   real(r8) mlons(plon+1,plat)          ! model cell W lon boundaries
   real(r8) mlats(plat+1)               ! model cell N lat boundaries
   real(r8) mnhgt(plon,plat)            ! model topographic height
   real(r8) varhgt(plon,plat)           ! model topographic variance
   real(r8) summn, sumvar              ! use only for pole point calculations

! other vars

   real(r8) xmax                       ! temporary variable 
   real(r8), parameter :: eps = 1.e-6  ! eps criterion for pole point
   integer imax, jmax                  ! indices
   integer i,j,ii,ji,io,jo,n           ! indices     
   integer ncid_topo                   ! topographic netcdf id
   integer ioe
   integer mxovr ! max number of fine grid points used in area calculation of model grid point
!
! Space needed in 3 dimensions to store the initial data. This space is
! required because the input data file does not have a predetermined 
! ordering of the latitude records. A  specific order is imposed in the 
! transforms so that the results will be reproducible.
!
! Dynamic
!
   integer , allocatable :: iovr(:,:,:) ! lon index of overlap input cell
   integer , allocatable :: jovr(:,:,:) ! lat index of overlap input cell
   real(r8), allocatable :: wovr(:,:,:) ! weight of overlap input cell
!
!-----------------------------------------------------------------------
!
!----------------------------------------------------------------------------
! Read in navy topo cell locations and determine cell edges (Uniform grid)
!----------------------------------------------------------------------------
!
   ret = nf_open (topofile, nf_nowrite, ncid_topo)
   if (ret == nf_noerr) then
      if (verbose) write(6,*)'Successfully opened netcdf topofile ',trim(topofile)
      ret = nf_inq_varid (ncid_topo, 'variance', varianceid)
      if (ret == NF_NOERR) then
         if (verbose) write(6,*)'Found a new style topofile.'
         call wrap_get_var8 (ncid_topo, varianceid, variance  )
         call wrap_inq_varid (ncid_topo, 'landfract', ftopoid   )
         have_sgh30 = .true.
      else
         if (verbose) write(6,*)'Found an old style topofile.'
         call wrap_inq_varid (ncid_topo, 'ftopo', ftopoid   )
         have_sgh30 = .false.
      end if
      call wrap_get_var8 (ncid_topo, ftopoid, ftopo)
      call wrap_inq_varid (ncid_topo, 'htopo', htopoid   )
      call wrap_get_var8 (ncid_topo, htopoid, htopo)
   else
      write(6,*)'cannot open topo file successfully'
      call endrun
   endif

   call wrap_inq_varid (ncid_topo, 'lon', lonid_topo)
   call wrap_inq_varid (ncid_topo, 'lat', latid_topo)
   
   call wrap_get_var8 (ncid_topo, latid_topo, tlatcnts)
   call wrap_get_var8 (ncid_topo, lonid_topo, tloncnts)
   ret = nf_close (ncid_topo)
 
   tloncnts(:) = mod(tloncnts(:)+r8_360,r8_360) 

   tlats(:) = 1.e36
   tlats(1) = -90.                                    ! south pole
   do j = 2, ntopolat                               
      tlats(j) = (tlatcnts(j-1) + tlatcnts(j)) / 2.   ! southern edges
   end do
   tlats(ntopolat+1) = 90.                            ! north pole

   tlons(:,:) = 1.e36
   do j = 1,ntopolat
      dx = 360./ntopolon
      tlons(1,j) = tloncnts(1) - dx/2.
      do i = 2, ntopolon
         tlons(i,j) = tloncnts(i) - dx/2.
      end do
      tlons(ntopolon+1,j) = tloncnts(ntopolon) + dx/2.
   end do
!
!----------------------------------------------------------------------------
! Determine model cell edges
!----------------------------------------------------------------------------
!
   mlats(:) = 1.e36
   mlats(1) = -90.                                    ! south pole
   do j = 2,plat                               
      mlats(j) = (mlatcnts(j-1) + mlatcnts(j)) / 2.   ! southern edges
   end do
   mlats(plat+1) = 90.                                ! north pole

   do j = 1,plat
      dx = 360./(numlons(j))
      do i = 1,plon+1
         mlons(i,j) = -dx/2. + (i-1)*dx
      end do
   end do

!
!----------------------------------------------------------------------------
! Calculate fractional land
!----------------------------------------------------------------------------
!
   call binf2c(tloncnts ,tlatcnts  ,ntopolon  ,ntopolat ,ftopo, &
               mlons    ,mlats     ,plon      ,plat     ,fland)
!
!----------------------------------------------------------------------------
! Calculate standard deviation of elevation from 30sec to 10min
!----------------------------------------------------------------------------

   if (have_sgh30) then
      call binf2c(tloncnts ,tlatcnts  ,ntopolon  ,ntopolat ,variance, &
           mlons    ,mlats     ,plon      ,plat     ,sgh30)
   else
      sgh30 = -1
   endif
!-------------------------------------------------------------------------
! Calculate determine mean and variance of topographic height, plon >=128 
!-------------------------------------------------------------------------
!
   if (plon >= 128) then
      call binf2c(tloncnts ,tlatcnts  ,ntopolon  ,ntopolat ,htopo, &
                  mlons    ,mlats     ,plon      ,plat     ,mnhgt)

      call varf2c(tloncnts ,tlatcnts  ,ntopolon  ,ntopolat ,htopo  , &
                  mlons   ,mlats     ,plon      ,plat     ,mnhgt  , &
                  varhgt  )
   end if

!-------------------------------------------------------------------------
! Calculate determine mean and variance of topographic height, plon < 128 
!-------------------------------------------------------------------------

   if (plon < 128) then
!
! bin to uniform 3x3 deg grid then area avg to output grid
! get 3x3 cell boundaries for binning routine
!
      dy = 180./n3x3lat
      do j = 1, n3x3lat+1
         lats3x3(j) = -90.0 + (j-1)*dy
      end do

      num3x3lons(:) = n3x3lon
      do j = 1,n3x3lat
         dx = 360./(num3x3lons(j))
         do i = 1, num3x3lons(j)+1
            lons3x3(i,j) =  0. + (i-1)*dx
         end do
      end do
!
! bin mean height to intermed grid
!
      call binf2c (tloncnts, tlatcnts, ntopolon, ntopolat, htopo,  &
                   lons3x3 , lats3x3 , n3x3lon , n3x3lat , mnhgt3x3)
!
! get variation of topography mean height over the intermed grid
!
      call varf2c (tloncnts, tlatcnts, ntopolon, ntopolat, htopo   , &
                   lons3x3 , lats3x3 , n3x3lon , n3x3lat , mnhgt3x3, &
                   varhgt3x3 )
!
! get maximum number of 3x3 cells which will to be used in area average
! for each model cell
!
      call max_ovr (n3x3lon, n3x3lat, num3x3lons, plon  , plat, numlons, &
                    lons3x3, lats3x3, mlons     , mlats , mxovr   )
!
! do area average from intermediate regular grid to gauss grid
! get memory for pointer based arrays
!
      allocate(iovr(plon,plat,mxovr))
      allocate(jovr(plon,plat,mxovr))
      allocate(wovr(plon,plat,mxovr))

      call map_i (n3x3lon, n3x3lat, num3x3lons, lons3x3, lats3x3, &
                  plon   , plat   , numlons   , mlons  , mlats  , &
                  mxovr  , iovr   , jovr      , wovr   )

      do jo = 1, plat
         do io = 1, numlons(jo)
            mnhgt(io,jo)  = 0.
            varhgt(io,jo) = 0.
            do n = 1, mxovr             ! overlap cell index
               ii = iovr(io,jo,n)       ! lon index (input grid) of overlap cell
               ji = jovr(io,jo,n)       ! lat index (input grid) of overlap cell
               wt = wovr(io,jo,n)       ! overlap weight
               mnhgt(io,jo)  = mnhgt(io,jo)  + mnhgt3x3(ii,ji)  * wt
               varhgt(io,jo) = varhgt(io,jo) + varhgt3x3(ii,ji) * wt
            end do
         end do
      end do
    
! If model grid contains pole points, then overwrite above values of phis and sgh at the
! poles with average of values of nearest 2x2 band - this is a fair approximation and
! is done so that above mapping routines do not have to be rewritten to correctly evaulte
! the area average of the pole points

      if (mlatcnts(1)-eps < -90.0 .and. mlatcnts(plat)+eps > 90.0) then
         write(6,*)' determining sgh and phis at poles'
         summn = 0
         sumvar = 0
         do io = 1,numlons(2)
            summn  = summn + mnhgt(io,2)
            sumvar = sumvar + varhgt(io,2)
         end do
         do io = 1,numlons(1)
            mnhgt(io,1)  = summn/numlons(2)
            varhgt(io,1) = sumvar/numlons(2)
         end do
         summn = 0
         sumvar = 0
         do io = 1,numlons(plat-1)
            summn  = summn + mnhgt(io,plat-1)
            sumvar = sumvar + varhgt(io,plat-1)
         end do
         do io = 1,numlons(plat)
            mnhgt(io,plat)  = summn/numlons(plat-1)
            varhgt(io,plat) = sumvar/numlons(plat-1)
         end do
      endif
     
      deallocate(iovr)
      deallocate(jovr)
      deallocate(wovr)

   end if

! 1-2-1 smoothing for variation height

   call sm121(varhgt,plon,plat,numlons)
   call sm121(varhgt,plon,plat,numlons)
   if (have_sgh30) then
      call sm121(sgh30,plon,plat,numlons)
      call sm121(sgh30,plon,plat,numlons)
   end if
!
! get standard deviation for smoothed height field
!
! determine geopotential height field.  The multiplication by 9.80616 
! causes phis to be only accurate to 32-bit roundoff on some machines
!
   xmax = -1.d99
   do jo=1,plat
      do io=1,numlons(jo)
         if (varhgt(io,jo) < 0.5) then
            sgh(io,jo) = 0.
         else
            sgh(io,jo) = sqrt(varhgt(io,jo))
         end if
         if (have_sgh30) then
            if (sgh30(io,jo) < 0.5) then
               sgh30(io,jo) = 0.
            else
               sgh30(io,jo) = sqrt(sgh30(io,jo))
            end if
         end if
         if (sgh(io,jo) > xmax) then
            xmax = sgh(io,jo)
            imax = io
            jmax = jo
         end if
         phis(io,jo) = mnhgt(io,jo) * 9.80616
      end do
   end do
   
   if (verbose) write(6,*)'Max SGH =',xmax,' at i,j=', imax, jmax
  
   return
end subroutine sghphis

program paleo_mkraw_ccsm4

  implicit none
  include 'netcdf.inc'

!----------------------------------------------------------------- 
!
! make raw datasets for Paleo CCSM simulation
! input data: (2x2 nc) LSM vegetation types from desired period
!	    : make sure lat/lon in netcdf is compatible with 2dlatlon
!	      definition below (see code)  
!           : (mksrf_soitex.10level.nc) IGBP soil texture for 0k
!	    : zonally averaged model organic soil density distribution
!	    : 2x2 topography/bathymetry file (topo_depth) file 
!
! output data: raw data files necessary to create surface-data file
!              at model runtime: mksrf_glacier.nc
!			       : mksrf_urban.nc
!			       : mksrf_lanwat.nc
!			       : mksrf_soicol_clm2.nc 
!			       : mksrf_lai.nc
!			       : mksrf_soitex.10level_paleo.nc
! updates for ccsm4
!                              : mksrf_organic_paleo.nc
!                              : mksrf_fmax_paleo.nc
!                              : mksrf_landuse_paleo.nc (replaces mksrf_pft_paleo.nc)
!                              : mksrf_topo_paleo.nc
!                              : mksrf_vocef_paleo.nc
!
!            : output file names specifed below
!
! from 2x2 LSM veg type data, this program will create pfts, glacier,
! urban, lanwat, soilcol, lai  fields. the soil texture fields will
! place soil profiles on
! the paleo grid. color will be assigned to a value of 15. (similar to ccsm3 soilcolor=4).
! glacier,urban,and lakes will all be set to zero. 
!
! ccsm4 updates:
! --------------
! ccsm4 updates include an updated pft file which includes pft harvest and grazing
! variables, organic soil density, max saturated areas for hydrology, topography
! placeholders for eventual land-ice model, and tree emmissions factors for atmos
! chemistry.
!
! currently we set harvest, grazing, and tree emissions to zero. 
! if using waccm (atmo chem), and want to specify emissions factors,
! you will need to develop an equivalence algorithm to modern values (see default
! mksrf_vocef file in inputdata) and create your own code.  also assuming
! assuming harvest and grazing to be zero for deep time. if not, develop personal
! code.  placeholders exist in below subroutines.
!
! organic soil density is assumed to approximate zonally averaged modern values
! max saturation areas (proxy for wetlands and used in the hydrology) is
! currently given a global number (like soil color) obtained by global avg
! modern value. 
!
! this program is designed to provide a framework to create the
! raw data files. any modifications to the aligorthims in this code
! can be applied by the user appropriate for the time period. 
!
! also note that ccsm4 has 17 (0 to 16) pfts as opposed to 16 (0 to 15) 
! for ccsm3. however, the new pft is crop2 and will NOT be used for 
! paleo. therefore, no modifcations to this code are necessary.  
!
! after paleo_mkraw datasets have been created, run mksurfdata clm tool to
! create surface_dataset offline.
! 
! cshields, slevis,  feb 2003, may 2010
!-----------------------------------------------------------------


  integer, parameter :: r8 = selected_real_kind(12)

  integer, parameter :: nlon = 180        !input grid : longitude points
  integer, parameter :: nlat =  90        !input grid : latitude  points
  integer, parameter :: numpft = 16       !number of plant types
  integer, parameter :: time   = 12       !number of months in year 
  integer, parameter :: nlay = 10         !input grid : number of soil layers
 
  integer, parameter :: nlon_st = 4320      !soil input grid : longitude points
  integer, parameter :: nlat_st = 2160      !soil input grid : latitude  points
  integer, parameter :: nmapunits = 4931 !soil input grid : # of igbp soil 'mapunits'
  integer, parameter :: mapunitmax = 6998!soil input grid : max value of 'mapunits'

  integer, parameter :: nlat_org =  360      !organics input grid : latitude points

  real(r8) :: lon(nlon)                   !longitude dimension array (1d)
  real(r8) :: lat(nlat)                   !latitude dimension array (1d) 
  real(r8) :: longxy(nlon,nlat)           !longitude dimension array (2d)  
  real(r8) :: latixy(nlon,nlat)           !longitude dimension array (2d)
  real(r8) :: edge(4)                     !N,E,S,W edges of grid
  real(r8) :: dx,dy                       !grid increments


  real(r8) :: landmask(nlon,nlat)         !fraction of land

  real(r8) :: dzsoi(10), zsoi(10)        !soil layer thickness and depth
  real(r8) :: pct_sand0(nlay,mapunitmax)    !original percent sand 
  real(r8) :: pct_clay0(nlay,mapunitmax)    !original percent clay 
  real(r8) :: mapunits0(nlon_st,nlat_st)     !mapunits 

  real(r8) :: pct_pft(nlon,nlat,0:numpft) !percent pft 
  real(r8) :: pct_glacier(nlon,nlat)      !percent glacier
  real(r8) :: pct_urban(nlon,nlat)        !percent urban 
  real(r8) :: pct_wetland(nlon,nlat)      !percent wetland 
  real(r8) :: pct_lake(nlon,nlat)         !percent lake 
  real(r8) :: sumpctland(nlon,nlat)       !percent lake 

!cas additions for ccsm4 stuff

  real(r8) :: organic(nlon,nlat,nlay)     !organic soil density
  real(r8) :: fmax(nlon,nlat)             !maximum fractional saturated area
  real(r8) :: harvest_vh1(nlon,nlat)      !harvest from primary forest
  real(r8) :: harvest_vh2(nlon,nlat)      !harvest from primary non-forest 
  real(r8) :: harvest_sh1(nlon,nlat)      !harvest from secondary mature forest 
  real(r8) :: harvest_sh2(nlon,nlat)      !harvest from secondary young forest 
  real(r8) :: harvest_sh3(nlon,nlat)      !harvest from secondary non-forest 
  real(r8) :: grazing(nlon,nlat)          !grazing of herbacous pfts 
  real(r8) :: topo_bedrock(nlon,nlat)     !topography height (m) 
  real(r8) :: topo_ice(nlon,nlat)         !topography height  +  land ice (m)) 
  real(r8) :: ef_btr(nlon,nlat)           !micrograms isoprene (m-2h-1); broadleaf tree emission factor
  real(r8) :: ef_fet(nlon,nlat)           !""; fineleaf evergreen tree emission factor
  real(r8) :: ef_fdt(nlon,nlat)           !""; fineleaf deciduous tree emission factor
  real(r8) :: ef_shr(nlon,nlat)           !""; shrub emission factor
  real(r8) :: ef_grs(nlon,nlat)           !""; grass, non-vascular plants and other ground cover em 
  real(r8) :: ef_crp(nlon,nlat)           !""; crop emission factor 

  real(r8) :: topoin(nlon,nlat)	          !input topo veg array  
  real(r8) :: z_organic(nlat_org,nlay)	  !input zonal organic array  
  real(r8) :: zorg_lat(nlat_org)          !lats for organic soil density input


  integer :: i,j,m,ret,cnt                !indices
  integer :: ncid_soitex_i                !netCDF file id for soitex input
  integer :: ncid_sur_i                   !netCDF file id for surf type input"
  integer :: ncid_top_i                   !netCDF file id for topo input "
  integer :: ncid_zorg_i                  !netCDF file id for zonal organics input "
  integer :: ncid_glacier                 !netCDF file id for glacier output
  integer :: ncid_urban                   !netCDF file id for urban " 
  integer :: ncid_lanwat                  !netCDF file id for lanwat "
  integer :: ncid_lai                     !netCDF file id for lai "
  integer :: ncid_pft                     !netCDF file id for pft  "
  integer :: ncid_soicol                  !netCDF file id for soicol " 
  integer :: ncid_soitex                  !netCDF file id for soitex "
  integer :: ncid_organic                 !netCDF file id for organic "
  integer :: ncid_fmax                    !netCDF file id for fmax "
  integer :: ncid_vocef                   !netCDF file id for vocef "
  integer :: ncid_topo                    !netCDF file id for topo "

  integer :: dzsoi_id		          !dzsoi id
  integer :: zsoi_id		          !zsoi id
  integer :: pct_clay0_id	          !pct_clay0 id
  integer :: pct_sand0_id                 !pct_sand0 id
  integer :: mapunits0_id                 !mapunits id
  integer :: sur_id                       !surface type id
  integer :: top_id                       !input topo id
  integer :: z_organic_id                 !zonal organic id
  integer :: zorg_lat_id                  !zonal lat id

  integer :: veg(nlon,nlat)	          !input lsm veg array  


  character(len=80) :: filei_lsmveg,filei_soitex,filei_org,filei_topo  ! input filenames
  character(len=80) :: fileo_glacier              !output filenames
  character(len=80) :: fileo_urban                !output filenames
  character(len=80) :: fileo_lanwat               !output filenames
  character(len=80) :: fileo_lai                  !output filenames
  character(len=80) :: fileo_pft                  !output filenames
  character(len=80) :: fileo_soicol               !output filenames
  character(len=80) :: fileo_soitex               !output filenames
  character(len=80) :: fileo_organic              !output filenames
  character(len=80) :: fileo_fmax                 !output filenames
  character(len=80) :: fileo_vocef                !output filenames
  character(len=80) :: fileo_topo                 !output filenames
 
  character(len=78) :: char_string        !character string for ascii file


!-----------------------------------------------------------------

! Determine input and output file names

  filei_lsmveg =  'input_lsm_data'
  filei_topo   =  'input_top_data'
  filei_org    =  'input_org_data'
  filei_soitex =  'input_soi_data'

  fileo_glacier= 'output_glacier'
  fileo_urban  = 'output_urban' 
  fileo_lanwat = 'output_lanwat'
  fileo_lai    = 'output_lai'
  fileo_pft    = 'output_pft'
  fileo_soicol = 'output_soicol'
  fileo_soitex = 'output_soitex'
  fileo_organic= 'output_organic'
  fileo_fmax   = 'output_fmax'
  fileo_topo   = 'output_topo'
  fileo_vocef  = 'output_vocef'

  print *,'Output file names defined '


! -------------------------------------------------------------------
! Read in netcdf 2x2 land surface file
! note: data starts from north, need to flip lats...see below code
! -------------------------------------------------------------------
!
  ret = nf_open (filei_lsmveg, nf_nowrite, ncid_sur_i)
  if (ret == nf_noerr) then
    write(6,*)'Successfully opened netcdf surf ',trim(filei_lsmveg)
    call wrap_inq_varid (ncid_sur_i, 'SUR', sur_id   )
    call wrap_get_var_int (ncid_sur_i, sur_id, veg)
  else
    write(6,*)'cannot open surface type file successfully'
    call endrun
  endif
  ret = nf_close (ncid_sur_i)
  print *, 'Netcdf 2x2 Surface Type file read '

! -------------------------------------------------------------------
! Read in netcdf 2x2 topo file
! -------------------------------------------------------------------
!
  ret = nf_open (filei_topo, nf_nowrite, ncid_top_i)
  if (ret == nf_noerr) then
    write(6,*)'Successfully opened netcdf topo ',trim(filei_topo)
    call wrap_inq_varid (ncid_top_i, 'topo', top_id   )
    call wrap_get_var_int (ncid_top_i, top_id, topoin)
  else
    write(6,*)'cannot open topo type file successfully'
    call endrun
  endif
  ret = nf_close (ncid_top_i)
  print *, 'Netcdf 2x2 topo_depth file read '


! --------------------------------------------------------
! Define landmask
! --------------------------------------------------------

  do j = 1,nlat
  do i = 1,nlon
   if (veg(i,j)/=0) landmask(i,j) = 1.
  end do
  end do

! -------------------------------------------------------
! Define lat/lon 2d arrays
! -------------------------------------------------------
! Define North, West, South, East edges of grid
! nan + danlunt fall 2013

 edge(1) =   90.
 edge(2) =  360.
 edge(3) =  -90.
 edge(4) =    0.

! CCSM3/CLM3.5
! edge(1) =   90.
! edge(2) =  180.
! edge(3) =  -90.
! edge(4) = -180.

! Make latitudes and longitudes at center of grid cell

  dx = (edge(2)-edge(4)) / nlon
  dy = (edge(1)-edge(3)) / nlat

  do j = 1, nlat
     do i = 1, nlon
        latixy(i,j) = (edge(3)+dy/2.) + (j-1)*dy
        longxy(i,j) = (edge(4)+dx/2.) + (i-1)*dx
       end do
  end do

  lat(:) = latixy(1,:)
  lon(:) = longxy(:,1)

  print *, 'LAT= ',lat
  print *, 'LON= ',lon

  print *, 'Lat and Lon arrays defined '

! -------------------------------------------------------------------
! Read in netcdf soil texture file
! -------------------------------------------------------------------
!
  ret = nf_open (filei_soitex, nf_nowrite, ncid_soitex_i)
  if (ret == nf_noerr) then
    write(6,*)'Successfully opened netcdf soitex ',trim(filei_soitex)
    call wrap_inq_varid (ncid_soitex_i, 'DZSOI', dzsoi_id   )
    call wrap_inq_varid (ncid_soitex_i, 'ZSOI', zsoi_id   )
    call wrap_inq_varid (ncid_soitex_i, 'PCT_CLAY', pct_clay0_id   )
    call wrap_inq_varid (ncid_soitex_i, 'PCT_SAND', pct_sand0_id   )
    call wrap_inq_varid (ncid_soitex_i, 'MAPUNITS', mapunits0_id   )
    call wrap_get_var8 (ncid_soitex_i, dzsoi_id, dzsoi) 
    call wrap_get_var8 (ncid_soitex_i, zsoi_id, zsoi)
    call wrap_get_var8 (ncid_soitex_i, pct_clay0_id, pct_clay0)
    call wrap_get_var8 (ncid_soitex_i, pct_sand0_id, pct_sand0)
    call wrap_get_var8 (ncid_soitex_i, mapunits0_id, mapunits0)
  else
    write(6,*)'cannot open soil texture file successfully'
    call endrun
  endif
  ret = nf_close (ncid_soitex_i)
  print *, 'Netcdf IGBC Soil Texture file read '

! -------------------------------------------------------------------
! Read in netcdf zonal organic file
! -------------------------------------------------------------------
!
  ret = nf_open (filei_org, nf_nowrite, ncid_organic)
  if (ret == nf_noerr) then
    write(6,*)'Successfully opened netcdf zon organic ',trim(filei_org)
    call wrap_inq_varid (ncid_organic, 'z_ORGANIC', z_organic_id   )
    call wrap_inq_varid (ncid_organic, 'LAT', zorg_lat_id   )
    call wrap_get_var8 (ncid_organic, z_organic_id, z_organic)
    call wrap_get_var8 (ncid_organic, zorg_lat_id, zorg_lat)
  else
    write(6,*)'cannot open organic soil density file successfully'
    call endrun
  endif
  ret = nf_close (ncid_organic)
  print *, 'Netcdf zonal organic soil density file read '


! -------------------------------------------------------------------
! Call subroutines to create each raw data file
! --------------------------------------------------------------------

  call create_mksrf_glacier(veg,landmask,                         &
      		            nlon,nlat,lon,longxy,lat,latixy,edge, &
		            fileo_glacier,ncid_glacier,	          &
		            pct_glacier)
  print *, 'Netcdf File mksfr_glacier_paleo created'

  call create_mksrf_urban(veg,landmask,			          &
	 		  nlon,nlat,lon,longxy,lat,latixy,edge,   &
	                  fileo_urban,ncid_urban,		  &
		          pct_urban)
  print *, 'Netcdf File mksfr_urban_paleo created'

  call create_mksrf_lanwat(veg,landmask,		          &
	             	   nlon,nlat,lon,longxy,lat,latixy,edge,  &
  		           fileo_lanwat,ncid_lanwat,		  &
			   pct_wetland,pct_lake)
  print *, 'Netcdf File mksfr_lanwat_paleo created'

  call create_mksrf_pft(veg,landmask,numpft,			  &
	               nlon,nlat,lon,longxy,lat,latixy,edge,      &
                       pct_pft,harvest_vh1,harvest_vh2,harvest_sh1, &
                       harvest_sh2,harvest_sh3,grazing,          &
                       fileo_pft,ncid_pft) 
  print *, 'Netcdf File mksfr_pft_paleo created'

  call create_mksrf_lai(veg,landmask,numpft,		 	  &
                        nlon,nlat,lon,longxy,lat,latixy,edge,     &
 			fileo_lai,ncid_lai,                       &
                        pct_pft) 
  print *, 'Netcdf File mksfr_lai_paleo created'

  call create_mksrf_soicol(veg,landmask,			  &
			   nlon,nlat,lon,longxy,lat,latixy,edge , &
		           fileo_soicol,ncid_soicol)
  print *, 'Netcdf File mksfr_soicol_paleo created'

  call create_mksrf_soitex(veg,landmask,            	             &
		           dzsoi,zsoi,mapunits0,pct_clay0,pct_sand0, &
			   nlay,nlon_st,nlat_st,nmapunits,mapunitmax,&
		           nlon,nlat,lon,longxy,lat,latixy,edge,     &
                           fileo_soitex,ncid_soitex)
  print *, 'Netcdf File mksfr_soitex_paleo created'

  call create_mksrf_organic(veg,landmask,nlay,			  &
			   dzsoi,zsoi,z_organic,zorg_lat,nlat_org,&
			   nlon,nlat,lon,longxy,lat,latixy,edge , &
		           fileo_organic,ncid_organic)
  print *, 'Netcdf File mksfr_organic_paleo created'

  call create_mksrf_fmax(veg,landmask,			  &
			   nlon,nlat,lon,longxy,lat,latixy,edge , &
		           fileo_fmax,ncid_fmax)
  print *, 'Netcdf File mksfr_fmax_paleo created'

  call create_mksrf_topo(landmask,topoin,                               &
                               nlon,nlat,lon,longxy,lat,latixy,edge,     &
                               fileo_topo,ncid_topo)
  print *, 'Netcdf File mksfr_topo_paleo created'

  call create_mksrf_vocef(veg,landmask,		  &
			   nlon,nlat,lon,longxy,lat,latixy,edge , &
		           fileo_vocef,ncid_vocef)
  print *, 'Netcdf File mksfr_vocef_paleo created'

! error check 
! pct_glacier+pct_lake+pct_wetland+pct_urban and checks .le. 100.
  sumpctland = pct_glacier+pct_lake+pct_wetland+pct_urban 
  do j = 1, nlat
    do i = 1, nlon
      if (landmask(i,j)==1 .and. sumpctland(i,j)>100.) then
        write(*,*) 'ERROR: sumpctland (glacier+urban+wetland+lake)= ',&
	            sumpctland(i,j),i,j
      end if
    end do
  end do

  print *, 'End program' 

end program paleo_mkraw_ccsm4




!===============================================================================
subroutine create_mksrf_glacier(veg,landmask,			      &
		                nlon,nlat,lon,longxy,lat,latixy,edge, &
			        fileo,ncid)

  implicit none
  include 'netcdf.inc'


! ---------------------------------------------------------------------
! Global variables
!-----------------------------------------------------------------------

  integer, parameter :: r8 = selected_real_kind(12)

  integer  :: veg(nlon,nlat)	          !lsm veg array  (input)
  real(r8) :: landmask(nlon,nlat)	  !landmask array  (input)
  real(r8) :: lon(nlon)                   !longitude dimension array (1d)
  real(r8) :: lat(nlat)                   !latitude dimension array (1d) 
  real(r8) :: longxy(nlon,nlat)           !longitude dimension array (2d)  
  real(r8) :: latixy(nlon,nlat)           !longitude dimension array (2d)
  real(r8) :: edge(4)                     !N,E,S,W edges of grid

  integer :: nlon,nlat,ncid              !number lats/lons, nc fileo id 
  character(len=80) :: fileo             !output filenames

! ------------------------------------------------------------------
! Define local variables
! ------------------------------------------------------------------

  real(r8) :: pct_glacier(nlon,nlat)      !percent glacier

  integer :: dimlon_id                    !netCDF dimension id
  integer :: dimlat_id                    !netCDF dimension id

  integer :: lon_id                       !1d longitude array id
  integer :: lat_id                       !1d latitude array id
  integer :: longxy_id                    !2d longitude array id
  integer :: latixy_id                    !2d latitude array id
  integer :: edgen_id                     !northern edge of grid (edge(1)) id
  integer :: edgee_id                     !eastern  edge of grid (edge(2)) id
  integer :: edges_id                     !southern edge of grid (edge(3)) id
  integer :: edgew_id                     !western  edge of grid (edge(4)) id
  integer :: pct_glacier_id               !pct_glacier id
  integer :: landmask_id                  !landmask id

  integer :: i,j                          !indices
  integer :: dim1_id(1)                   !netCDF dimension id for 1-d variables
  integer :: dim2_id(2)                   !netCDF dimension id for 2-d variables
  integer :: status                       !status

  character(len=256) :: name,unit            !netCDF attributes


! ------------------------------------------------------------
! Create skeleton netcdf
! --------------------------------------------------------------

! Define global attributes

  call wrap_create (fileo, nf_clobber, ncid)
  call wrap_put_att_text (ncid, nf_global, 'data_type', 'pct_glacier_data')

! Define dimensions

  call wrap_def_dim (ncid, 'lon' , nlon, dimlon_id)
  call wrap_def_dim (ncid, 'lat' , nlat, dimlat_id)

! Define grid variables

  name = 'lon'
  unit = 'degrees east'
  dim1_id(1) = dimlon_id
  call wrap_def_var (ncid,'lon', nf_float, 1, dim1_id, lon_id)
  call wrap_put_att_text (ncid, lon_id, 'long_name', name)
  call wrap_put_att_text (ncid, lon_id, 'units'    , unit)

  name = 'lat'
  unit = 'degrees north'
  dim1_id(1) = dimlat_id
  call wrap_def_var (ncid,'lat', nf_float, 1, dim1_id, lat_id)
  call wrap_put_att_text (ncid, lat_id, 'long_name', name)
  call wrap_put_att_text (ncid, lat_id, 'units'    , unit)

  name = 'longitude-2d'
  unit = 'degrees east'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LONGXY', nf_float, 2, dim2_id, longxy_id)
  call wrap_put_att_text (ncid, longxy_id, 'long_name', name)
  call wrap_put_att_text (ncid, longxy_id, 'units'    , unit)

  name = 'latitude-2d'
  unit = 'degrees north'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LATIXY', nf_float, 2, dim2_id, latixy_id)
  call wrap_put_att_text (ncid, latixy_id, 'long_name', name)
  call wrap_put_att_text (ncid, latixy_id, 'units'    , unit)

  name = 'northern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGEN', nf_float, 0, 0, edgen_id)
  call wrap_put_att_text (ncid, edgen_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgen_id, 'units'    , unit)

  name = 'eastern edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEE', nf_float, 0, 0, edgee_id)
  call wrap_put_att_text (ncid, edgee_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgee_id, 'units'    , unit)

  name = 'southern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGES', nf_float, 0, 0, edges_id)
  call wrap_put_att_text (ncid, edges_id, 'long_name', name)
  call wrap_put_att_text (ncid, edges_id, 'units'    , unit)

  name = 'western edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEW', nf_float, 0, 0, edgew_id)
  call wrap_put_att_text (ncid, edgew_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgew_id, 'units'    , unit)

! Define input file specific variables

  name = 'percent glacier'
  unit = 'unitless'
  dim2_id(1) = lon_id
  dim2_id(2) = lat_id
  call wrap_def_var (ncid ,'PCT_GLACIER' ,nf_float, 2, dim2_id, pct_glacier_id)
  call wrap_put_att_text (ncid, pct_glacier_id, 'long_name', name)
  call wrap_put_att_text (ncid, pct_glacier_id, 'units'    , unit)

  name = 'land mask'
  unit = 'unitless'
  call wrap_def_var (ncid ,'LANDMASK' ,nf_float, 2, dim2_id, landmask_id)
  call wrap_put_att_text (ncid, landmask_id, 'long_name', name)
  call wrap_put_att_text (ncid, landmask_id, 'units'    , unit)

! End of definition

  status = nf_enddef(ncid)

! -----------------------------------------------------------------------
! Create pct_glacier from LSM vegtypes 
! -----------------------------------------------------------------------

  do j = 1, nlat
    do i = 1, nlon
      if (veg(i,j).eq.1) then
        pct_glacier(i,j) = 100._r8
      else
        pct_glacier(i,j) = 0._r8
      end if
    end do
  end do

! --------------------------------------------------------------------------
! Write variables
! --------------------------------------------------------------------------

  call wrap_put_var_realx (ncid, lon_id        , lon)
  call wrap_put_var_realx (ncid, lat_id        , lat)
  call wrap_put_var_realx (ncid, longxy_id     , longxy)
  call wrap_put_var_realx (ncid, latixy_id     , latixy)
  call wrap_put_var_realx (ncid, edgen_id      , edge(1))
  call wrap_put_var_realx (ncid, edgee_id      , edge(2))
  call wrap_put_var_realx (ncid, edges_id      , edge(3))
  call wrap_put_var_realx (ncid, edgew_id      , edge(4))
  call wrap_put_var_realx (ncid, pct_glacier_id, pct_glacier)
  call wrap_put_var_realx (ncid, landmask_id   , landmask)

  call wrap_close(ncid)

end subroutine create_mksrf_glacier



!========================================================================
subroutine create_mksrf_urban(veg,landmask,      	            &
			      nlon,nlat,lon,longxy,lat,latixy,edge, &
			      fileo,ncid) 

  implicit none
  include 'netcdf.inc'

! ---------------------------------------------------------------------
! Global variables
!-----------------------------------------------------------------------

  integer, parameter :: r8 = selected_real_kind(12)

  integer  :: veg(nlon,nlat)	          !lsm veg array  (input)
  real(r8) :: landmask(nlon,nlat)	  !landmask array  (input)
  real(r8) :: lon(nlon)                   !longitude dimension array (1d)
  real(r8) :: lat(nlat)                   !latitude dimension array (1d) 
  real(r8) :: longxy(nlon,nlat)           !longitude dimension array (2d)  
  real(r8) :: latixy(nlon,nlat)           !longitude dimension array (2d)
  real(r8) :: edge(4)                     !N,E,S,W edges of grid

  integer :: nlon,nlat,ncid              !number lats/lons, nc fileo id 
  character(len=80) :: fileo             !output filenames

! ------------------------------------------------------------------
! Define local variables
! ------------------------------------------------------------------

  real(r8) :: pct_urban(nlon,nlat)        !pct urban

  integer :: dimlon_id                    !netCDF dimension id
  integer :: dimlat_id                    !netCDF dimension id

  integer :: lon_id                       !1d longitude array id
  integer :: lat_id                       !1d latitude array id
  integer :: longxy_id                    !2d longitude array id
  integer :: latixy_id                    !2d latitude array id
  integer :: edgen_id                     !northern edge of grid (edge(1)) id
  integer :: edgee_id                     !eastern  edge of grid (edge(2)) id
  integer :: edges_id                     !southern edge of grid (edge(3)) id
  integer :: edgew_id                     !western  edge of grid (edge(4)) id
  integer :: pct_urban_id                 !percent urban id
  integer :: landmask_id                  !landmask id

  integer :: i,j                          !indices
  integer :: dim1_id(1)                   !netCDF dimension id for 1-d variables
  integer :: dim2_id(2)                   !netCDF dimension id for 2-d variables
  integer :: status                       !status

  character(len=256) :: name,unit         !netCDF attributes

! ------------------------------------------------------------
! Create skeleton netcdf
! --------------------------------------------------------------

! Define global attributes

  call wrap_create (fileo, nf_clobber, ncid)
  call wrap_put_att_text (ncid, nf_global, 'data_type', 'pct_urban_data')

! Define dimensions

  call wrap_def_dim (ncid, 'lon' , nlon, dimlon_id)
  call wrap_def_dim (ncid, 'lat' , nlat, dimlat_id)

! Define input file independent variables 

  name = 'lon'
  unit = 'degrees east'
  dim1_id(1) = dimlon_id
  call wrap_def_var (ncid,'lon', nf_float, 1, dim1_id, lon_id)
  call wrap_put_att_text (ncid, lon_id, 'long_name', name)
  call wrap_put_att_text (ncid, lon_id, 'units'    , unit)

  name = 'lat'
  unit = 'degrees north'
  dim1_id(1) = dimlat_id
  call wrap_def_var (ncid,'lat', nf_float, 1, dim1_id, lat_id)
  call wrap_put_att_text (ncid, lat_id, 'long_name', name)
  call wrap_put_att_text (ncid, lat_id, 'units'    , unit)

  name = 'longitude-2d'
  unit = 'degrees east'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LONGXY', nf_float, 2, dim2_id, longxy_id)
  call wrap_put_att_text (ncid, longxy_id, 'long_name', name)
  call wrap_put_att_text (ncid, longxy_id, 'units'    , unit)

  name = 'latitude-2d'
  unit = 'degrees north'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LATIXY', nf_float, 2, dim2_id, latixy_id)
  call wrap_put_att_text (ncid, latixy_id, 'long_name', name)
  call wrap_put_att_text (ncid, latixy_id, 'units'    , unit)

  name = 'northern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGEN', nf_float, 0, 0, edgen_id)
  call wrap_put_att_text (ncid, edgen_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgen_id, 'units'    , unit)

  name = 'eastern edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEE', nf_float, 0, 0, edgee_id)
  call wrap_put_att_text (ncid, edgee_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgee_id, 'units'    , unit)

  name = 'southern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGES', nf_float, 0, 0, edges_id)
  call wrap_put_att_text (ncid, edges_id, 'long_name', name)
  call wrap_put_att_text (ncid, edges_id, 'units'    , unit)

  name = 'western edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEW', nf_float, 0, 0, edgew_id)
  call wrap_put_att_text (ncid, edgew_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgew_id, 'units'    , unit)

! Define input file specific variables

  name = 'percent urban'
  unit = 'unitless'
  dim2_id(1) = lon_id
  dim2_id(2) = lat_id
  call wrap_def_var (ncid ,'PCT_URBAN' ,nf_float, 2, dim2_id, pct_urban_id)
  call wrap_put_att_text (ncid, pct_urban_id, 'long_name', name)
  call wrap_put_att_text (ncid, pct_urban_id, 'units'    , unit)

  name = 'land mask'
  unit = 'unitless'
  call wrap_def_var (ncid ,'LANDMASK' ,nf_float, 2, dim2_id, landmask_id)
  call wrap_put_att_text (ncid, landmask_id, 'long_name', name)
  call wrap_put_att_text (ncid, landmask_id, 'units'    , unit)

! End of definition

  status = nf_enddef(ncid)


! -----------------------------------------------------------------------
! Create pct_urban from LSM vegtypes
! -----------------------------------------------------------------------

  pct_urban = 0.

! --------------------------------------------------------------------------
! Write variables
! ----------------------------------------------------------------------

  call wrap_put_var_realx (ncid, lon_id      , lon)
  call wrap_put_var_realx (ncid, lat_id      , lat)
  call wrap_put_var_realx (ncid, longxy_id   , longxy)
  call wrap_put_var_realx (ncid, latixy_id   , latixy)
  call wrap_put_var_realx (ncid, edgen_id    , edge(1))
  call wrap_put_var_realx (ncid, edgee_id    , edge(2))
  call wrap_put_var_realx (ncid, edges_id    , edge(3))
  call wrap_put_var_realx (ncid, edgew_id    , edge(4))
  call wrap_put_var_realx (ncid, pct_urban_id, pct_urban)
  call wrap_put_var_realx (ncid, landmask_id, landmask)

  call wrap_close(ncid)

end subroutine create_mksrf_urban



!===========================================================================
subroutine create_mksrf_lanwat(veg,landmask,			     &
			       nlon,nlat,lon,longxy,lat,latixy,edge, &
                               fileo,ncid)
 

  implicit none
  include 'netcdf.inc'

! ---------------------------------------------------------------------
! Global variables
!-----------------------------------------------------------------------

  integer, parameter :: r8 = selected_real_kind(12)

  integer  :: veg(nlon,nlat)	          !lsm veg array  (input)
  real(r8) :: landmask(nlon,nlat)	  !landmask array  (input)
  real(r8) :: lon(nlon)                   !longitude dimension array (1d)
  real(r8) :: lat(nlat)                   !latitude dimension array (1d) 
  real(r8) :: longxy(nlon,nlat)           !longitude dimension array (2d)  
  real(r8) :: latixy(nlon,nlat)           !longitude dimension array (2d)
  real(r8) :: edge(4)                     !N,E,S,W edges of grid

  integer :: nlon,nlat,ncid              !number lats/lons, nc fileo id 
  character(len=80) :: fileo             !output filenames

! ------------------------------------------------------------------
! Define local variables
! ------------------------------------------------------------------


  real(r8) :: pct_lake(nlon,nlat)         !pct lake
  real(r8) :: pct_wetland(nlon,nlat)      !pct wetland

  integer :: dimlon_id                    !netCDF dimension id
  integer :: dimlat_id                    !netCDF dimension id

  integer :: lon_id                       !1d longitude array id
  integer :: lat_id                       !1d latitude array id
  integer :: longxy_id                    !2d longitude array id
  integer :: latixy_id                    !2d latitude array id
  integer :: edgen_id                     !northern edge of grid (edge(1)) id
  integer :: edgee_id                     !eastern  edge of grid (edge(2)) id
  integer :: edges_id                     !southern edge of grid (edge(3)) id
  integer :: edgew_id                     !western  edge of grid (edge(4)) id
  integer :: pct_lake_id                  !pct_lake id
  integer :: pct_wetland_id               !pct_wetland id
  integer :: landmask_id                  !landmask id

  integer :: i,j                          !indices
  integer :: dim1_id(1)                   !netCDF dimension id for 1-d variables
  integer :: dim2_id(2)                   !netCDF dimension id for 2-d variables
  integer :: status                       !status

  character(len=256) :: name,unit         !netCDF attributes


! ------------------------------------------------------------
! Create skeleton netcdf
! --------------------------------------------------------------

! Define global attributes

  call wrap_create (fileo, nf_clobber, ncid)
  call wrap_put_att_text (ncid, nf_global, 'data_type', 'lanwat_data')

! Define dimensions

  call wrap_def_dim (ncid, 'lon' , nlon, dimlon_id)
  call wrap_def_dim (ncid, 'lat' , nlat, dimlat_id)

! Define input file independent variables 

  name = 'lon'
  unit = 'degrees east'
  dim1_id(1) = dimlon_id
  call wrap_def_var (ncid,'lon', nf_float, 1, dim1_id, lon_id)
  call wrap_put_att_text (ncid, lon_id, 'long_name', name)
  call wrap_put_att_text (ncid, lon_id, 'units'    , unit)

  name = 'lat'
  unit = 'degrees north'
  dim1_id(1) = dimlat_id
  call wrap_def_var (ncid,'lat', nf_float, 1, dim1_id, lat_id)
  call wrap_put_att_text (ncid, lat_id, 'long_name', name)
  call wrap_put_att_text (ncid, lat_id, 'units'    , unit)

  name = 'longitude-2d'
  unit = 'degrees east'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LONGXY', nf_float, 2, dim2_id, longxy_id)
  call wrap_put_att_text (ncid, longxy_id, 'long_name', name)
  call wrap_put_att_text (ncid, longxy_id, 'units'    , unit)

  name = 'latitude-2d'
  unit = 'degrees north'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LATIXY', nf_float, 2, dim2_id, latixy_id)
  call wrap_put_att_text (ncid, latixy_id, 'long_name', name)
  call wrap_put_att_text (ncid, latixy_id, 'units'    , unit)

  name = 'northern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGEN', nf_float, 0, 0, edgen_id)
  call wrap_put_att_text (ncid, edgen_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgen_id, 'units'    , unit)

  name = 'eastern edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEE', nf_float, 0, 0, edgee_id)
  call wrap_put_att_text (ncid, edgee_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgee_id, 'units'    , unit)

  name = 'southern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGES', nf_float, 0, 0, edges_id)
  call wrap_put_att_text (ncid, edges_id, 'long_name', name)
  call wrap_put_att_text (ncid, edges_id, 'units'    , unit)

  name = 'western edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEW', nf_float, 0, 0, edgew_id)
  call wrap_put_att_text (ncid, edgew_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgew_id, 'units'    , unit)

! Define percent lake and wetland variables

  name = 'percent lake'
  unit = 'unitless'
  dim2_id(1) = lon_id
  dim2_id(2) = lat_id
  call wrap_def_var (ncid ,'PCT_LAKE' ,nf_float, 2, dim2_id, pct_lake_id)
  call wrap_put_att_text (ncid, pct_lake_id, 'long_name', name)
  call wrap_put_att_text (ncid, pct_lake_id, 'units'    , unit)

  name = 'percent wetland'
  unit = 'unitless'
  dim2_id(1) = lon_id
  dim2_id(2) = lat_id
  call wrap_def_var (ncid ,'PCT_WETLAND' ,nf_float, 2, dim2_id, pct_wetland_id)
  call wrap_put_att_text (ncid, pct_wetland_id, 'long_name', name)
  call wrap_put_att_text (ncid, pct_wetland_id, 'units'    , unit)

  name = 'land mask'
  unit = 'unitless'
  call wrap_def_var (ncid ,'LANDMASK' ,nf_float, 2, dim2_id, landmask_id)
  call wrap_put_att_text (ncid, landmask_id, 'long_name', name)
  call wrap_put_att_text (ncid, landmask_id, 'units'    , unit)

! End of definition

  status = nf_enddef(ncid)


! -----------------------------------------------------------------------
! Create pct_lake and pct_wetland from LSM vegtypes 
! -----------------------------------------------------------------------

 pct_lake = 0.

 do j = 1, nlat
   do i = 1, nlon
     if (veg(i,j).eq.27) then
       pct_wetland(i,j) = 20._r8
     elseif (veg(i,j).eq.28) then
       pct_wetland(i,j) = 100._r8
     else
       pct_wetland(i,j) = 0._r8
     end if
   end do
 end do

! --------------------------------------------------------------------------
! Write variables
! --------------------------------------------------------------------------


  call wrap_put_var_realx (ncid, lon_id        , lon)
  call wrap_put_var_realx (ncid, lat_id        , lat)
  call wrap_put_var_realx (ncid, longxy_id     , longxy)
  call wrap_put_var_realx (ncid, latixy_id     , latixy)
  call wrap_put_var_realx (ncid, edgen_id      , edge(1))
  call wrap_put_var_realx (ncid, edgee_id      , edge(2))
  call wrap_put_var_realx (ncid, edges_id      , edge(3))
  call wrap_put_var_realx (ncid, edgew_id      , edge(4))
  call wrap_put_var_realx (ncid, pct_lake_id   , pct_lake)
  call wrap_put_var_realx (ncid, pct_wetland_id, pct_wetland)
  call wrap_put_var_realx (ncid, landmask_id   , landmask)

  call wrap_close(ncid)

end subroutine create_mksrf_lanwat



!=============================================================================
subroutine create_mksrf_pft(veg,landmask,numpft,		  &
			    nlon,nlat,lon,longxy,lat,latixy,edge, &
                      pct_pft,harvest_vh1,harvest_vh2,harvest_sh1, &
                       harvest_sh2,harvest_sh3,grazing,            &
		       fileo,ncid)

  implicit none
  include 'netcdf.inc'

! ---------------------------------------------------------------------
! Global variables
!-----------------------------------------------------------------------

  integer, parameter :: r8 = selected_real_kind(12)

  integer  :: veg(nlon,nlat)	          !lsm veg array  (input)
  real(r8) :: landmask(nlon,nlat)	  !landmask array  (input)
  real(r8) :: lon(nlon)                   !longitude dimension array (1d)
  real(r8) :: lat(nlat)                   !latitude dimension array (1d) 
  real(r8) :: longxy(nlon,nlat)           !longitude dimension array (2d)  
  real(r8) :: latixy(nlon,nlat)           !longitude dimension array (2d)
  real(r8) :: edge(4)                     !N,E,S,W edges of grid

  integer :: nlon,nlat,numpft,ncid       !number lats/lons/pfts, nc fileo id 
  character(len=80) :: fileo             !output filenames

  real(r8) :: pct_pft(nlon,nlat,0:numpft) !percent pft 
  real(r8) :: harvest_vh1(nlon,nlat) !harvest from primary forest 
  real(r8) :: harvest_vh2(nlon,nlat) !harvest from primary non-forest 
  real(r8) :: harvest_sh1(nlon,nlat) !harvest from secondary mature forest 
  real(r8) :: harvest_sh2(nlon,nlat) !harvest from secondary young forest 
  real(r8) :: harvest_sh3(nlon,nlat) !harvest from secondary non-forest 
  real(r8) :: grazing(nlon,nlat)  !grazing of herbacous pfts 

! ------------------------------------------------------------------
! Define local variables
! ------------------------------------------------------------------

  real(r8) :: sumpctpft(nlon,nlat)        
  integer :: dimlon_id                    !netCDF dimension id
  integer :: dimlat_id                    !netCDF dimension id
  integer :: dimpft_id                    !netCDF dimension id

  integer :: lon_id                       !1d longitude array id
  integer :: lat_id                       !1d latitude array id
  integer :: longxy_id                    !2d longitude array id
  integer :: latixy_id                    !2d latitude array id
  integer :: edgen_id                     !northern edge of grid (edge(1)) id
  integer :: edgee_id                     !eastern  edge of grid (edge(2)) id
  integer :: edges_id                     !southern edge of grid (edge(3)) id
  integer :: edgew_id                     !western  edge of grid (edge(4)) id
  integer :: landmask_id                  !landmask id
  integer :: pct_pft_id                   !pct_pft id
  integer :: harvest_vh1_id              !harvest id 
  integer :: harvest_vh2_id              !harvest id 
  integer :: harvest_sh1_id              !harvest id 
  integer :: harvest_sh2_id              !harvest id 
  integer :: harvest_sh3_id              !harvest id 
  integer :: grazing_id                   !grazing id 

  integer :: i,j                          !indices
  integer :: dim1_id(1)                   !netCDF dimension id for 1-d variables
  integer :: dim2_id(2)                   !netCDF dimension id for 2-d variables
  integer :: dim3_id(3)                   !netCDF dimension id for 3-d variables
  integer :: status                       !status

  character(len=256) :: name,unit         !netCDF attributes
  
! ------------------------------------------------------------
! Create skeleton netcdf
! --------------------------------------------------------------

! Define global attributes

  call wrap_create (fileo, nf_clobber, ncid)
  call wrap_put_att_text (ncid, nf_global, 'data_type', 'pft_data')

! Define dimensions

  call wrap_def_dim (ncid, 'lon', nlon    , dimlon_id)
  call wrap_def_dim (ncid, 'lat', nlat    , dimlat_id)
  call wrap_def_dim (ncid, 'pft', numpft+1, dimpft_id)

! Define grid variables

  name = 'lon'
  unit = 'degrees east'
  dim1_id(1) = dimlon_id
  call wrap_def_var (ncid,'lon', nf_float, 1, dim1_id, lon_id)
  call wrap_put_att_text (ncid, lon_id, 'long_name', name)
  call wrap_put_att_text (ncid, lon_id, 'units'    , unit)

  name = 'lat'
  unit = 'degrees north'
  dim1_id(1) = dimlat_id
  call wrap_def_var (ncid,'lat', nf_float, 1, dim1_id, lat_id)
  call wrap_put_att_text (ncid, lat_id, 'long_name', name)
  call wrap_put_att_text (ncid, lat_id, 'units'    , unit)

  name = 'longitude-2d'
  unit = 'degrees east'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LONGXY', nf_float, 2, dim2_id, longxy_id)
  call wrap_put_att_text (ncid, longxy_id, 'long_name', name)
  call wrap_put_att_text (ncid, longxy_id, 'units'    , unit)

  name = 'latitude-2d'
  unit = 'degrees north'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LATIXY', nf_float, 2, dim2_id, latixy_id)
  call wrap_put_att_text (ncid, latixy_id, 'long_name', name)
  call wrap_put_att_text (ncid, latixy_id, 'units'    , unit)

  name = 'northern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGEN', nf_float, 0, 0, edgen_id)
  call wrap_put_att_text (ncid, edgen_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgen_id, 'units'    , unit)

  name = 'eastern edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEE', nf_float, 0, 0, edgee_id)
  call wrap_put_att_text (ncid, edgee_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgee_id, 'units'    , unit)

  name = 'southern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGES', nf_float, 0, 0, edges_id)
  call wrap_put_att_text (ncid, edges_id, 'long_name', name)
  call wrap_put_att_text (ncid, edges_id, 'units'    , unit)

  
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEW', nf_float, 0, 0, edgew_id)
  call wrap_put_att_text (ncid, edgew_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgew_id, 'units'    , unit)

! Define pft variables

  name = 'land mask'
  unit = 'unitless'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid ,'LANDMASK' ,nf_float, 2, dim2_id, landmask_id)
  call wrap_put_att_text (ncid, landmask_id, 'long_name', name)
  call wrap_put_att_text (ncid, landmask_id, 'units'    , unit)

  name = 'percent pft'
  unit = 'unitless'
  dim3_id(1) = dimlon_id
  dim3_id(2) = dimlat_id
  dim3_id(3) = dimpft_id
  call wrap_def_var (ncid ,'PCT_PFT' ,nf_float, 3, dim3_id, pct_pft_id)
  call wrap_put_att_text (ncid, pct_pft_id, 'long_name', name)
  call wrap_put_att_text (ncid, pct_pft_id, 'units'    , unit)

  name = 'harvest from primary forest'
  unit = 'unitless'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid ,'HARVEST_VH1' ,nf_float, 2, dim2_id, harvest_vh1_id)
  call wrap_put_att_text (ncid, harvest_vh1_id, 'long_name', name)
  call wrap_put_att_text (ncid, harvest_vh1_id, 'units'    , unit)

  name = 'harvest from primary non-forest'
  unit = 'unitless'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid ,'HARVEST_VH2' ,nf_float, 2, dim2_id, harvest_vh2_id)
  call wrap_put_att_text (ncid, harvest_vh2_id, 'long_name', name)
  call wrap_put_att_text (ncid, harvest_vh2_id, 'units'    , unit)

  name = 'harvest from secondary marture-forest'
  unit = 'unitless'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid ,'HARVEST_SH1' ,nf_float, 2, dim2_id, harvest_sh1_id)
  call wrap_put_att_text (ncid, harvest_sh1_id, 'long_name', name)
  call wrap_put_att_text (ncid, harvest_sh1_id, 'units'    , unit)

  name = 'harvest from secondary young-forest'
  unit = 'unitless'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid ,'HARVEST_SH2' ,nf_float, 2, dim2_id, harvest_sh2_id)
  call wrap_put_att_text (ncid, harvest_sh2_id, 'long_name', name)
  call wrap_put_att_text (ncid, harvest_sh2_id, 'units'    , unit)

  name = 'harvest from secondary non-forest'
  unit = 'unitless'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid ,'HARVEST_SH3' ,nf_float, 2, dim2_id, harvest_sh3_id)
  call wrap_put_att_text (ncid, harvest_sh3_id, 'long_name', name)
  call wrap_put_att_text (ncid, harvest_sh3_id, 'units'    , unit)

  name = 'grazing of herbacous pfts'
  unit = 'unitless'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid ,'GRAZING' ,nf_float, 2, dim2_id, grazing_id)
  call wrap_put_att_text (ncid, grazing_id, 'long_name', name)
  call wrap_put_att_text (ncid, grazing_id, 'units'    , unit)

! End of definitions

  status = nf_enddef(ncid)

! -----------------------------------------------------------------------
! Create pfts from LSM vegtypes 
! -----------------------------------------------------------------------

  print *, 'inside pft'
  pct_pft = 0.                        !initialize
  do j = 1, nlat
    do i = 1, nlon
      if (veg(i,j).eq.1) then         !land ice
        pct_pft(i,j,0) = 100._r8      !is bare
        pct_pft(i,j,1:numpft) = 0._r8
      elseif (veg(i,j).eq.2) then     !desert
        pct_pft(i,j,0) = 100._r8      !is bare
      elseif (veg(i,j).eq.3) then     !cool needleleaf evergreen forest
        pct_pft(i,j,0) = 25._r8       !includes bare ground and
        pct_pft(i,j,2) = 75._r8       !needleleaf evergreen boreal tree
      elseif (veg(i,j).eq.4) then     !cool needleleaf deciduous forest
        pct_pft(i,j,0) = 50._r8       !includes bare ground and
        pct_pft(i,j,3) = 50._r8       !needleleaf deciduous boreal tree
      elseif (veg(i,j).eq.5) then     !cool broadleaf deciduous forest
        pct_pft(i,j,0) = 25._r8       !includes bare ground and
        pct_pft(i,j,8) = 75._r8       !broadleaf deciduous boreal tree
      elseif (veg(i,j).eq.6) then     !cool mixed forest
        pct_pft(i,j,0) = 26._r8       !includes bare ground and
        pct_pft(i,j,2) = 37._r8       !needleleaf evergreen boreal tree
        pct_pft(i,j,8) = 37._r8       !broadleaf deciduous boreal tree
      elseif (veg(i,j).eq.7) then     !warm needleleaf evergreen forest
        pct_pft(i,j,0) = 25._r8       !includes bare ground and
        pct_pft(i,j,1) = 75._r8       !needleleaf evergreen temperate tree
      elseif (veg(i,j).eq.8) then     !warm broadleaf deciduous forest
        pct_pft(i,j,0) = 25._r8       !includes bare ground and
        pct_pft(i,j,7) = 75._r8       !broadleaf deciduous temperate tree
      elseif (veg(i,j).eq.9) then     !warm mixed forest
        pct_pft(i,j,0) = 26._r8       !includes bare ground and
        pct_pft(i,j,1) = 37._r8       !needleleaf evergreen temperate tree
        pct_pft(i,j,7) = 37._r8       !broadleaf deciduous temperate tree
      elseif (veg(i,j).eq.10) then    !tropical broadleaf evergreen forest
        pct_pft(i,j,0) =  5._r8       !includes bare ground and
        pct_pft(i,j,4) = 95._r8       !broadleaf evergreen tropical tree
      elseif (veg(i,j).eq.11) then    !tropical seasonal deciduous forest
        pct_pft(i,j,0) = 25._r8       !includes bare ground and
        pct_pft(i,j,6) = 75._r8       !broadleaf deciduous tropical tree
      elseif (veg(i,j).eq.12) then    !savanna
        pct_pft(i,j,14) = 70._r8      !includes warm c4 grass and
        pct_pft(i,j,6) = 30._r8       !broadleaf deciduous tropical tree
      elseif (veg(i,j).eq.13) then    !evergreen forest tundra
        pct_pft(i,j,0) = 50._r8       !includes bare ground and
        pct_pft(i,j,2) = 25._r8       !needleleaf evergreen boreal tree
        pct_pft(i,j,12) = 25._r8      !arctic c3 grass
      elseif (veg(i,j).eq.14) then    !deciduous forest tundra
        pct_pft(i,j,0) = 50._r8       !includes bare ground and
        pct_pft(i,j,3) = 25._r8       !needleleaf deciduous boreal tree
        pct_pft(i,j,12) = 25._r8      !arctic c3 grass
      elseif (veg(i,j).eq.15) then    !cool forest crop
        pct_pft(i,j,15) = 40._r8      !crop
        pct_pft(i,j,2) = 30._r8       !needleleaf evergreen boreal tree
        pct_pft(i,j,8) = 30._r8       !broadleaf deciduous boreal tree
      elseif (veg(i,j).eq.16) then    !warm forest crop
        pct_pft(i,j,15) = 40._r8      !crop
        pct_pft(i,j,1) = 30._r8       !needleleaf evergreen temperate tree
        pct_pft(i,j,7) = 30._r8       !broadleaf deciduous temperate tree
      elseif (veg(i,j).eq.17) then    !cool grassland
        pct_pft(i,j,0) = 20._r8       !includes bare ground and
        pct_pft(i,j,13) = 60._r8      !cool c3 grass
        pct_pft(i,j,14) = 20._r8      !warm c4 grass
      elseif (veg(i,j).eq.18) then    !warm grassland
        pct_pft(i,j,0) = 20._r8       !includes bare ground and
        pct_pft(i,j,13) = 20._r8      !cool c3 grass
        pct_pft(i,j,14) = 60._r8      !warm c4 grass
      elseif (veg(i,j).eq.19) then    !tundra
        pct_pft(i,j,0) = 40._r8       !includes bare ground and
        pct_pft(i,j,11) = 30._r8      !broadleaf deciduous boreal shrub
        pct_pft(i,j,12) = 30._r8      !arctic c3 grass
      elseif (veg(i,j).eq.20) then    !evergreen shrubland
        pct_pft(i,j,0) = 20._r8       !includes bare ground and
        pct_pft(i,j,9) = 80._r8       !broadleaf evergreen temperate shrub
      elseif (veg(i,j).eq.21) then    !deciduous shrubland
        pct_pft(i,j,0) = 20._r8       !includes bare ground and
        pct_pft(i,j,10) = 80._r8      !broadleaf deciduous temperate shrub
      elseif (veg(i,j).eq.22) then    !semi-desert
        pct_pft(i,j,0) = 90._r8       !includes bare ground and
        pct_pft(i,j,10) = 10._r8      !broadleaf deciduous temperate shrub
      elseif (veg(i,j).eq.23) then    !cool irrigated crop
        pct_pft(i,j,0) = 15._r8       !includes bare ground and
        pct_pft(i,j,15) = 85._r8      !crop
      elseif (veg(i,j).eq.24) then    !cool crop
        pct_pft(i,j,0) = 15._r8       !includes bare ground and
        pct_pft(i,j,15) = 85._r8      !crop
      elseif (veg(i,j).eq.25) then    !warm irrigated crop
        pct_pft(i,j,0) = 15._r8       !includes bare ground and
        pct_pft(i,j,15) = 85._r8      !crop
      elseif (veg(i,j).eq.26) then    !warm crop
        pct_pft(i,j,0) = 15._r8       !includes bare ground and
        pct_pft(i,j,15) = 85._r8      !crop
      elseif (veg(i,j).eq.27) then    !forest wetland
        pct_pft(i,j,0) = 20._r8       !includes bare ground and
        pct_pft(i,j,5) = 80._r8       !broadleaf evergreen temperate tree
      elseif (veg(i,j).eq.28) then    !non-forest wetland
        pct_pft(i,j,0) = 100._r8      !is bare
      elseif (veg(i,j).eq.29) then    !according to Nick Herold's new veg data
        pct_pft(i,j,0) = 25._r8       !includes bare ground and
        pct_pft(i,j,5) = 75._r8       !broadleaf evergreen temperate tree
      elseif (veg(i,j) < 0 .or. veg(i,j) > 29) then
        write(*,*) 'ERROR mapping veg to pct_pft: veg < 0 OR veg > 29',veg(i,j),i,j
      end if
    end do
  end do

! error check
  sumpctpft = sum(pct_pft, dim=3) !sum of %pft for every grid cell
  do j = 1, nlat
    do i = 1, nlon
      if (landmask(i,j)==1 .and. sumpctpft(i,j)/=100.) then
        write(*,*) 'ERROR: sumpctpft =',sumpctpft(i,j),i,j
      end if
    end do
  end do

!---------------------------------------------------------------------------
! for deep time assign harvest and grazing to zero
! change code here if this is not desired
!---------------------------------------------------------------------------

  do j = 1,nlon
  do i = 1,nlat
   if(landmask(j,i) == 1.) harvest_vh1(j,i) = 0._r8
   if(landmask(j,i) == 1.) harvest_vh2(j,i) = 0._r8
   if(landmask(j,i) == 1.) harvest_sh1(j,i) = 0._r8
   if(landmask(j,i) == 1.) harvest_sh2(j,i) = 0._r8
   if(landmask(j,i) == 1.) harvest_sh3(j,i) = 0._r8
   if(landmask(j,i) == 1.) grazing(j,i) = 0._r8
  enddo
  enddo
  print *, 'Harvest sample at point (1,1)',harvest_vh1(1,1)


! -------------------------------------------------------------------------- 
! Write variables
! --------------------------------------------------------------------------

  call wrap_put_var_realx (ncid, lon_id     , lon)
  call wrap_put_var_realx (ncid, lat_id     , lat)
  call wrap_put_var_realx (ncid, longxy_id  , longxy)
  call wrap_put_var_realx (ncid, latixy_id  , latixy)
  call wrap_put_var_realx (ncid, edgen_id   , edge(1))
  call wrap_put_var_realx (ncid, edgee_id   , edge(2))
  call wrap_put_var_realx (ncid, edges_id   , edge(3))
  call wrap_put_var_realx (ncid, edgew_id   , edge(4))
  call wrap_put_var_realx (ncid, landmask_id, landmask)
  call wrap_put_var_realx (ncid, pct_pft_id , pct_pft)
  call wrap_put_var_realx (ncid, harvest_vh1_id , harvest_vh1)
  call wrap_put_var_realx (ncid, harvest_vh2_id , harvest_vh2)
  call wrap_put_var_realx (ncid, harvest_sh1_id , harvest_sh1)
  call wrap_put_var_realx (ncid, harvest_sh2_id , harvest_sh2)
  call wrap_put_var_realx (ncid, harvest_sh3_id , harvest_sh3)
  call wrap_put_var_realx (ncid, grazing_id , grazing)

  call wrap_close(ncid)

end subroutine create_mksrf_pft



!============================================================================
subroutine create_mksrf_lai(veg,landmask,numpft,		  &
			    nlon,nlat,lon,longxy,lat,latixy,edge, &
                            fileo,ncid,                           &
                            pct_pft) 


  implicit none
  include 'netcdf.inc'

! ---------------------------------------------------------------------
! Global variables
!-----------------------------------------------------------------------

  integer, parameter :: r8 = selected_real_kind(12)

  integer  :: veg(nlon,nlat)	          !lsm veg array  (input)
  real(r8) :: landmask(nlon,nlat)	  !landmask array  (input)
  real(r8) :: lon(nlon)                   !longitude dimension array (1d)
  real(r8) :: lat(nlat)                   !latitude dimension array (1d) 
  real(r8) :: longxy(nlon,nlat)           !longitude dimension array (2d)  
  real(r8) :: latixy(nlon,nlat)           !longitude dimension array (2d)
  real(r8) :: edge(4)                     !N,E,S,W edges of grid


  integer :: nlon,nlat,numpft,ncid       !number lats/lons/pfts, nc fileo id 
  character(len=80) :: fileo             !output filenames

  real(r8) :: pct_pft(nlon,nlat,0:numpft) !percent pft 

! ------------------------------------------------------------------
! Define local variables
! ------------------------------------------------------------------

  real(r8) mlai (nlon,nlat,0:numpft) !monthly lai in
  real(r8) msai (nlon,nlat,0:numpft) !monthly sai in
  real(r8) mhgtt(nlon,nlat,0:numpft) !monthly height (top) in
  real(r8) mhgtb(nlon,nlat,0:numpft) !monthly height (bottom) in

  integer :: dimlon_id               !netCDF dimension id
  integer :: dimlat_id               !netCDF dimension id
  integer :: dimpft_id               !netCDF dimension id
  integer :: dimtim_id               !netCDF dimension id

  integer :: lon_id                  !1d longitude array id
  integer :: lat_id                  !1d latitude array id
  integer :: longxy_id               !2d longitude array id
  integer :: latixy_id               !2d latitude array id
  integer :: edgen_id                !northern edge of grid (edge(1)) id
  integer :: edgee_id                !eastern  edge of grid (edge(2)) id
  integer :: edges_id                !southern edge of grid (edge(3)) id
  integer :: edgew_id                !western  edge of grid (edge(4)) id
  integer :: landmask_id             !landmask id
  integer :: mlai_id                 !monthly mlai id
  integer :: msai_id                 !monthly msai id  
  integer :: mhgtt_id                !monthly mghtt id
  integer :: mhgtb_id                !monthly mhgtb id 
 
  integer :: ntim                    !month time index
  integer :: i,j,l                   !indices
  integer :: beg4d(4),len4d(4)       !netCDF edge
  integer :: dim1_id(1)              !netCDF dimension id for 1-d variables
  integer :: dim2_id(2)              !netCDF dimension id for 2-d variables
  integer :: dim4_id(4)              !netCDF dimension id for 4-d variables
  integer :: status                  !status

  character(len=80) :: name,unit     !netCDF attributes

  integer :: month
  real(r8) gai(14,12)      !leaf area index (one sided)      |taken from LSM's
  real(r8) tai(14,12)      !leaf+stem area index (one sided) |subroutine
  real(r8) hvt(14)         !top of canopy (m)                |vegconi.F
  real(r8) hvb(14)         !bottom of canopy (m)             

  data (tai(1,i),i=1,12)  /4.5,4.7,5.0,5.1,5.3,5.5,5.3,5.3,5.2,4.9,4.6,4.5/
  data (tai(2,i),i=1,12)  /0.3,0.3,0.3,1.0,1.6,2.4,4.3,2.9,2.0,1.3,0.8,0.5/
  data (tai(3,i),i=1,12)  /5.0,5.0,5.0,5.0,5.0,5.0,5.0,5.0,5.0,5.0,5.0,5.0/
  data (tai(4,i),i=1,12)  /0.4,0.4,0.7,1.6,3.5,5.1,5.4,4.8,3.8,1.7,0.6,0.4/
  data (tai(5,i),i=1,12)  /1.2,1.0,0.9,0.8,0.8,1.0,2.0,3.7,3.2,2.7,1.9,1.2/
  data (tai(6,i),i=1,12)  /0.7,0.8,0.9,1.0,1.5,3.4,4.3,3.8,1.8,1.0,0.9,0.8/
  data (tai(7,i),i=1,12)  /1.3,1.3,1.3,1.3,1.3,1.3,1.3,1.3,1.3,1.3,1.3,1.3/
  data (tai(8,i),i=1,12)  /1.0,1.0,0.8,0.3,0.6,0.0,0.1,0.3,0.5,0.6,0.7,0.9/
  data (tai(9,i),i=1,12)  /0.1,0.1,0.1,0.1,0.1,0.3,1.5,1.7,1.4,0.1,0.1,0.1/
  data (tai(10,i),i=1,12) /0.7,0.8,0.9,1.0,1.5,3.4,4.3,3.8,1.8,1.0,0.9,0.8/
  data (tai(11,i),i=1,12) /0.0,0.0,0.0,0.0,1.0,2.0,3.0,3.0,1.5,0.0,0.0,0.0/
  data (tai(12,i),i=1,12) /0.0,0.0,0.0,0.0,1.0,2.0,3.0,3.0,1.5,0.0,0.0,0.0/
  data (tai(13,i),i=1,12) /0.7,0.8,0.9,1.0,1.5,3.4,4.3,3.8,1.8,1.0,0.9,0.8/
  data (tai(14,i),i=1,12) /0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/

  data (gai(1,i),i=1,12)  /4.1,4.2,4.6,4.8,4.9,5.0,4.8,4.7,4.6,4.2,4.0,4.0/
  data (gai(2,i),i=1,12)  /0.0,0.0,0.0,0.6,1.2,2.0,2.6,1.7,1.0,0.5,0.2,0.0/
  data (gai(3,i),i=1,12)  /4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5/
  data (gai(4,i),i=1,12)  /0.0,0.0,0.3,1.2,3.0,4.7,4.5,3.4,1.2,0.3,0.0,0.0/
  data (gai(5,i),i=1,12)  /0.8,0.7,0.4,0.5,0.5,0.7,1.7,3.0,2.5,1.6,1.0,1.0/
  data (gai(6,i),i=1,12)  /0.4,0.5,0.6,0.7,1.2,3.0,3.5,1.5,0.7,0.6,0.5,0.4/
  data (gai(7,i),i=1,12)  /1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0/
  data (gai(8,i),i=1,12)  /0.9,0.8,0.2,0.2,0.0,0.0,0.0,0.2,0.4,0.5,0.6,0.8/
  data (gai(9,i),i=1,12)  /0.0,0.0,0.0,0.0,0.0,0.2,1.4,1.2,0.0,0.0,0.0,0.0/
  data (gai(10,i),i=1,12) /0.4,0.5,0.6,0.7,1.2,3.0,3.5,1.5,0.7,0.6,0.5,0.4/
  data (gai(11,i),i=1,12) /0.0,0.0,0.0,0.0,1.0,2.0,3.0,3.0,1.5,0.0,0.0,0.0/
  data (gai(12,i),i=1,12) /0.0,0.0,0.0,0.0,1.0,2.0,3.0,3.0,1.5,0.0,0.0,0.0/
  data (gai(13,i),i=1,12) /0.4,0.5,0.6,0.7,1.2,3.0,3.5,1.5,0.7,0.6,0.5,0.4/
  data (gai(14,i),i=1,12) /0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/

  data hvt /17.0,14.0,35.0,20.0,18.0, 0.5, 0.5, &
             0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.0/

  data hvb / 8.50, 7.00, 1.00,11.50,10.00, 0.01, 0.10, &
             0.10, 0.10, 0.01, 0.01, 0.01, 0.01, 0.00/

! ------------------------------------------------------------
! Create skeleton netcdf
! --------------------------------------------------------------

! Define global attributes
 
  call wrap_create (fileo, nf_clobber, ncid)
  call wrap_put_att_text (ncid, nf_global, 'data_type', 'lai_sai_data')
  
! Define dimensions
  
  call wrap_def_dim (ncid, 'lon' , nlon        , dimlon_id)
  call wrap_def_dim (ncid, 'lat' , nlat        , dimlat_id)
  call wrap_def_dim (ncid, 'pft' , numpft+1    , dimpft_id)
  call wrap_def_dim (ncid, 'time', nf_unlimited, dimtim_id)
  
! Define input file independent variables 
  
  name = 'lon'
  unit = 'degrees east'
  dim1_id(1) = dimlon_id
  call wrap_def_var (ncid,'lon', nf_float, 1, dim1_id, lon_id)
  call wrap_put_att_text (ncid, lon_id, 'long_name', name)
  call wrap_put_att_text (ncid, lon_id, 'units'    , unit)
  
  name = 'lat'
  unit = 'degrees north'
  dim1_id(1) = dimlat_id
  call wrap_def_var (ncid,'lat', nf_float, 1, dim1_id, lat_id)
  call wrap_put_att_text (ncid, lat_id, 'long_name', name)
  call wrap_put_att_text (ncid, lat_id, 'units'    , unit)
  
  name = 'longitude-2d'
  unit = 'degrees east'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LONGXY', nf_float, 2, dim2_id, longxy_id)
  call wrap_put_att_text (ncid, longxy_id, 'long_name', name)
  call wrap_put_att_text (ncid, longxy_id, 'units'    , unit)

  name = 'latitude-2d'
  unit = 'degrees north'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LATIXY', nf_float, 2, dim2_id, latixy_id)
  call wrap_put_att_text (ncid, latixy_id, 'long_name', name)
  call wrap_put_att_text (ncid, latixy_id, 'units'    , unit)

  name = 'northern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGEN', nf_float, 0, 0, edgen_id)
  call wrap_put_att_text (ncid, edgen_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgen_id, 'units'    , unit)
  
  name = 'eastern edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEE', nf_float, 0, 0, edgee_id)
  call wrap_put_att_text (ncid, edgee_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgee_id, 'units'    , unit)
  
  name = 'southern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGES', nf_float, 0, 0, edges_id)
  call wrap_put_att_text (ncid, edges_id, 'long_name', name)
  call wrap_put_att_text (ncid, edges_id, 'units'    , unit)
  
  name = 'western edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEW', nf_float, 0, 0, edgew_id)
  call wrap_put_att_text (ncid, edgew_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgew_id, 'units'    , unit)
     
! Define input file specific variables
  
  name = 'land mask'
  unit = 'unitless'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LANDMASK', nf_float, 2, dim2_id, landmask_id)
  call wrap_put_att_text (ncid, landmask_id, 'long_name', name)
  call wrap_put_att_text (ncid, landmask_id, 'units'    , unit)

  dim4_id(1) = dimlon_id
  dim4_id(2) = dimlat_id
  dim4_id(3) = dimpft_id
  dim4_id(4) = dimtim_id

  name = 'monthly leaf area index'
  unit = 'unitless'
  call wrap_def_var (ncid ,'MONTHLY_LAI', nf_float, 4, dim4_id, mlai_id)
  call wrap_put_att_text (ncid, mlai_id, 'long_name', name)
  call wrap_put_att_text (ncid, mlai_id, 'units'    , unit)
     
  name = 'monthly stem area index'
  unit = 'unitless'
  call wrap_def_var (ncid ,'MONTHLY_SAI', nf_float, 4, dim4_id, msai_id)
  call wrap_put_att_text (ncid, msai_id, 'long_name', name)
  call wrap_put_att_text (ncid, msai_id, 'units'    , unit)
     
  name = 'monthly height top'
  unit = 'meters'
  call wrap_def_var (ncid ,'MONTHLY_HEIGHT_TOP', nf_float, 4, dim4_id, mhgtt_id)
  call wrap_put_att_text (ncid, mhgtt_id, 'long_name', name)
  call wrap_put_att_text (ncid, mhgtt_id, 'units'    , unit)
  
  name = 'monthly height bottom'
  unit = 'meters'
  call wrap_def_var (ncid ,'MONTHLY_HEIGHT_BOT', nf_float, 4, dim4_id, mhgtb_id)
  call wrap_put_att_text (ncid, mhgtb_id, 'long_name', name)
  call wrap_put_att_text (ncid, mhgtb_id, 'units'    , unit)
     
  status = nf_enddef(ncid)

! -----------------------------------------------------------------------
! Create monthly_lai, monthly_sai, monthly_height_top, monthly_height_bot
! from LSM vegtypes, and LSM annual cycle lookup table. LSM subroutine
! vegconi.F contains lookup tables for the variables gai, tai, hvt, hvb:
! 
! dimensioned 14 LSM pfts by 12 months
! ------------------------------------
! gai is LAI
! tai is LAI+SAI, so SAI=tai-gai
! 
! dimensioned 14 LSM pfts (constant in time)
! ------------------------------------------
! hvt: height at top of canopy
! hvb: height at bottom of canopy 
! -----------------------------------------------------------------------

  mlai = 0. !initialize four variables globally
  msai = 0. !these values will be used for ocean and for bare ground
  mhgtt = 0.
  mhgtb = 0.

! --------------------------------------------------------------------------
! Write variables
! --------------------------------------------------------------------------

  call wrap_put_var_realx (ncid, lon_id     , lon)
  call wrap_put_var_realx (ncid, lat_id     , lat)
  call wrap_put_var_realx (ncid, longxy_id  , longxy)
  call wrap_put_var_realx (ncid, latixy_id  , latixy)
  call wrap_put_var_realx (ncid, edgen_id   , edge(1))
  call wrap_put_var_realx (ncid, edgee_id   , edge(2))
  call wrap_put_var_realx (ncid, edges_id   , edge(3))
  call wrap_put_var_realx (ncid, edgew_id   , edge(4))


! write out landmask

  call wrap_put_var_realx (ncid, landmask_id, landmask)

! now enter time loop

  do ntim = 1,12

  do j = 1,nlat !this loop written by slevis
    if (j <= nlat/2 .and. ntim <= 6) then
      month = ntim + 6
    else if (j <= nlat/2 .and. ntim > 6) then
      month = ntim - 6
    else
      month = ntim
    end if
    do i = 1, nlon
      if (pct_pft(i,j,1) > 0) then
        mlai(i,j,1) = gai(1,month)
        msai(i,j,1) = tai(1,month)-gai(1,month)
        mhgtt(i,j,1) = hvt(1)
        mhgtb(i,j,1) = hvb(1)
      end if
      if (pct_pft(i,j,2) > 0) then
        mlai(i,j,2) = gai(1,month)
        msai(i,j,2) = tai(1,month)-gai(1,month)
        mhgtt(i,j,2) = hvt(1)
        mhgtb(i,j,2) = hvb(1)
      end if
      if (pct_pft(i,j,3) > 0) then
        mlai(i,j,3) = gai(2,month)
        msai(i,j,3) = tai(2,month)-gai(2,month)
        mhgtt(i,j,3) = hvt(2)
        mhgtb(i,j,3) = hvb(2)
      end if
      if (pct_pft(i,j,4) > 0) then
        mlai(i,j,4) = gai(3,month)
        msai(i,j,4) = tai(3,month)-gai(3,month)
        mhgtt(i,j,4) = hvt(3)
        mhgtb(i,j,4) = hvb(3)
      end if
      if (pct_pft(i,j,5) > 0) then
        mlai(i,j,5) = gai(3,month)
        msai(i,j,5) = tai(3,month)-gai(3,month)
        mhgtt(i,j,5) = hvt(3)
        mhgtb(i,j,5) = hvb(3)
      end if
      if (pct_pft(i,j,6) > 0) then
        mlai(i,j,6) = gai(5,month)
        msai(i,j,6) = tai(5,month)-gai(5,month)
        mhgtt(i,j,6) = hvt(5)
        mhgtb(i,j,6) = hvb(5)
      end if
      if (pct_pft(i,j,7) > 0) then
        mlai(i,j,7) = gai(4,month)
        msai(i,j,7) = tai(4,month)-gai(4,month)
        mhgtt(i,j,7) = hvt(4)
        mhgtb(i,j,7) = hvb(4)
      end if
      if (pct_pft(i,j,8) > 0) then
        mlai(i,j,8) = gai(4,month)
        msai(i,j,8) = tai(4,month)-gai(4,month)
        mhgtt(i,j,8) = hvt(4)
        mhgtb(i,j,8) = hvb(4)
      end if
      if (pct_pft(i,j,9) > 0) then
        mlai(i,j,9) = gai(7,month)
        msai(i,j,9) = tai(7,month)-gai(7,month)
        mhgtt(i,j,9) = hvt(7)
        mhgtb(i,j,9) = hvb(7)
      end if
      if (pct_pft(i,j,10) > 0) then
        mlai(i,j,10) = gai(8,month)
        msai(i,j,10) = tai(8,month)-gai(8,month)
        mhgtt(i,j,10) = hvt(8)
        mhgtb(i,j,10) = hvb(8)
      end if
      if (pct_pft(i,j,11) > 0) then
        mlai(i,j,11) = gai(9,month)
        msai(i,j,11) = tai(9,month)-gai(9,month)
        mhgtt(i,j,11) = hvt(9)
        mhgtb(i,j,11) = hvb(9)
      end if
      if (pct_pft(i,j,12) > 0) then
        mlai(i,j,12) = gai(10,month)
        msai(i,j,12) = tai(10,month)-gai(10,month)
        mhgtt(i,j,12) = hvt(10)
        mhgtb(i,j,12) = hvb(10)
      end if
      if (pct_pft(i,j,13) > 0) then
        mlai(i,j,13) = gai(6,month)
        msai(i,j,13) = tai(6,month)-gai(6,month)
        mhgtt(i,j,13) = hvt(6)
        mhgtb(i,j,13) = hvb(6)
      end if
      if (pct_pft(i,j,14) > 0) then
        mlai(i,j,14) = gai(13,month)
        msai(i,j,14) = tai(13,month)-gai(13,month)
        mhgtt(i,j,14) = hvt(13)
        mhgtb(i,j,14) = hvb(13)
      end if
      if (pct_pft(i,j,15) > 0) then
        mlai(i,j,15) = gai(11,month)
        msai(i,j,15) = tai(11,month)-gai(11,month)
        mhgtt(i,j,15) = hvt(11)
        mhgtb(i,j,15) = hvb(11)
      end if
    end do
  end do !end slevis loops

  beg4d(1) = 1     ; len4d(1) = nlon
  beg4d(2) = 1     ; len4d(2) = nlat
  beg4d(3) = 1     ; len4d(3) = numpft+1
  beg4d(4) = ntim  ; len4d(4) = 1
     
  call wrap_put_vara_realx (ncid, mlai_id , beg4d, len4d, mlai )
  call wrap_put_vara_realx (ncid, msai_id , beg4d, len4d, msai )
  call wrap_put_vara_realx (ncid, mhgtt_id, beg4d, len4d, mhgtt)
  call wrap_put_vara_realx (ncid, mhgtb_id, beg4d, len4d, mhgtb)

  end do   

  ! Close output file

  call wrap_close(ncid)

end subroutine create_mksrf_lai


!=================================================================================
subroutine create_mksrf_soicol(veg,landmask,			     &
			       nlon,nlat,lon,longxy,lat,latixy,edge, &
                               fileo,ncid)


  implicit none
  include 'netcdf.inc'

! ---------------------------------------------------------------------
! Global variables
!-----------------------------------------------------------------------

  integer, parameter :: r8 = selected_real_kind(12)

  integer  :: veg(nlon,nlat)	          !lsm veg array  (input)
  real(r8) :: landmask(nlon,nlat)	  !landmask array  (input)
  real(r8) :: lon(nlon)                   !longitude dimension array (1d)
  real(r8) :: lat(nlat)                   !latitude dimension array (1d) 
  real(r8) :: longxy(nlon,nlat)           !longitude dimension array (2d)  
  real(r8) :: latixy(nlon,nlat)           !longitude dimension array (2d)
  real(r8) :: edge(4)                     !N,E,S,W edges of grid

  integer :: nlon,nlat,ncid              !number lats/lons, nc fileo id 
  character(len=80) :: fileo             !output filenames


! ------------------------------------------------------------------
! Define local variables
! ------------------------------------------------------------------

  real(r8) :: soil_color(nlon,nlat)       !lsm soil color

  integer :: dimlon_id                    !netCDF dimension id
  integer :: dimlat_id                    !netCDF dimension id

  integer :: lon_id                       !1d longitude array id
  integer :: lat_id                       !1d latitude array id
  integer :: longxy_id                    !2d longitude array id
  integer :: latixy_id                    !2d latitude array id
  integer :: edgen_id                     !northern edge of grid (edge(1)) id
  integer :: edgee_id                     !eastern  edge of grid (edge(2)) id
  integer :: edges_id                     !southern edge of grid (edge(3)) id
  integer :: edgew_id                     !western  edge of grid (edge(4)) id
  integer :: soil_color_id                !soil color id
  integer :: landmask_id                  !landmask id

  integer :: i,j                          !indices
  integer :: dim1_id(1)                   !netCDF dimension id for 1-d variables
  integer :: dim2_id(2)                   !netCDF dimension id for 2-d variables
  integer :: status                       !status

  character(len=256) :: name,unit         !netCDF attributes


! ------------------------------------------------------------
! Create skeleton netcdf
! --------------------------------------------------------------

! Define global attributes

  call wrap_create (fileo, nf_clobber, ncid)
  call wrap_put_att_text (ncid, nf_global, 'data_type', 'soil_color_data')

! Define dimensions

  call wrap_def_dim (ncid, 'lon' , nlon, dimlon_id)
  call wrap_def_dim (ncid, 'lat' , nlat, dimlat_id)

! Define input file independent variables 

  name = 'lon'
  unit = 'degrees east'
  dim1_id(1) = dimlon_id
  call wrap_def_var (ncid,'lon', nf_float, 1, dim1_id, lon_id)
  call wrap_put_att_text (ncid, lon_id, 'long_name', name)
  call wrap_put_att_text (ncid, lon_id, 'units'    , unit)

  name = 'lat'
  unit = 'degrees north'
  dim1_id(1) = dimlat_id
  call wrap_def_var (ncid,'lat', nf_float, 1, dim1_id, lat_id)
  call wrap_put_att_text (ncid, lat_id, 'long_name', name)
  call wrap_put_att_text (ncid, lat_id, 'units'    , unit)

  name = 'longitude-2d'
  unit = 'degrees east'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LONGXY', nf_float, 2, dim2_id, longxy_id)
  call wrap_put_att_text (ncid, longxy_id, 'long_name', name)
  call wrap_put_att_text (ncid, longxy_id, 'units'    , unit)

  name = 'latitude-2d'
  unit = 'degrees north'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LATIXY', nf_float, 2, dim2_id, latixy_id)
  call wrap_put_att_text (ncid, latixy_id, 'long_name', name)
  call wrap_put_att_text (ncid, latixy_id, 'units'    , unit)

  name = 'northern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGEN', nf_float, 0, 0, edgen_id)
  call wrap_put_att_text (ncid, edgen_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgen_id, 'units'    , unit)

  name = 'eastern edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEE', nf_float, 0, 0, edgee_id)
  call wrap_put_att_text (ncid, edgee_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgee_id, 'units'    , unit)

  name = 'southern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGES', nf_float, 0, 0, edges_id)
  call wrap_put_att_text (ncid, edges_id, 'long_name', name)
  call wrap_put_att_text (ncid, edges_id, 'units'    , unit)

  name = 'western edge of surface grid'
  
  call wrap_def_var (ncid, 'EDGEW', nf_float, 0, 0, edgew_id)
  call wrap_put_att_text (ncid, edgew_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgew_id, 'units'    , unit)

! Define input file specific variables

  name = 'soil color'
  unit = 'unitless'
  dim2_id(1) = lon_id
  dim2_id(2) = lat_id
  call wrap_def_var (ncid ,'SOIL_COLOR' ,nf_float, 2, dim2_id, soil_color_id)
  call wrap_put_att_text (ncid, soil_color_id, 'long_name', name)
  call wrap_put_att_text (ncid, soil_color_id, 'units'    , unit)

  name = 'land mask'
  unit = 'unitless'
  call wrap_def_var (ncid ,'LANDMASK' ,nf_float, 2, dim2_id, landmask_id)
  call wrap_put_att_text (ncid, landmask_id, 'long_name', name)
  call wrap_put_att_text (ncid, landmask_id, 'units'    , unit)

! End of definition

  status = nf_enddef(ncid)

! -----------------------------------------------------------------------
! Create soil_color from LSM vegtypes (if user so desires)
! -----------------------------------------------------------------------

  do j = 1,nlon
  do i = 1,nlat
   soil_color(j,i) = 10._r8
   !if(landmask(j,i) == 1.) soil_color(j,i) = 10._r8   ! see Table 3.3. in CLM4 doc to choose your colr
						      ! http://www.cesm.ucar.edu/models/cesm1.0/clm/CLM4_Tech_Note.pdf
						      ! or add code here to modify soil color by geography 
   if(landmask(j,i) == 1.) soil_color(j,i) = 15._r8   ! used to be 4 for ccsm3
  enddo
  enddo
  print *, 'Soil Color sample at point (1,1)',soil_color(1,1)

! --------------------------------------------------------------------------
! Write variables
! --------------------------------------------------------------------------

  call wrap_put_var_realx (ncid, lon_id       , lon)
  call wrap_put_var_realx (ncid, lat_id       , lat)
  call wrap_put_var_realx (ncid, longxy_id    , longxy)
  call wrap_put_var_realx (ncid, latixy_id    , latixy)
  call wrap_put_var_realx (ncid, edgen_id     , edge(1))
  call wrap_put_var_realx (ncid, edgee_id     , edge(2))
  call wrap_put_var_realx (ncid, edges_id     , edge(3))
  call wrap_put_var_realx (ncid, edgew_id     , edge(4))
  call wrap_put_var_realx (ncid, landmask_id  , landmask)
  call wrap_put_var_realx (ncid, soil_color_id, soil_color)

! Close output file

  call wrap_close(ncid)

end subroutine create_mksrf_soicol



!===============================================================================
subroutine create_mksrf_soitex(veg,landmask,     		         &
			       dzsoi,zsoi,mapunits0,pct_clay0,pct_sand0, &
		               nlay,nlon_st,nlat_st,nmapunits,mapunitmax,&
		               nlon,nlat,lon,longxy,lat,latixy,edge,     &
                               fileo,ncid)


  implicit none
  include 'netcdf.inc'

! ---------------------------------------------------------------------
! Global variables
!-----------------------------------------------------------------------

  integer, parameter :: r8 = selected_real_kind(12)

  integer  :: veg(nlon,nlat)	          !lsm veg array  (input)
  real(r8) :: landmask(nlon,nlat)	  !landmask array  (input)
  real(r8) :: lon(nlon)                   !longitude dimension array (1d)
  real(r8) :: lat(nlat)                   !latitude dimension array (1d) 
  real(r8) :: longxy(nlon,nlat)           !longitude dimension array (2d)  
  real(r8) :: latixy(nlon,nlat)           !longitude dimension array (2d)
  real(r8) :: edge(4)                     !N,E,S,W edges of grid

  real(r8) :: dzsoi(10), zsoi(10)        !soil layer thickness and depth
  real(r8) :: pct_sand0(nlay,mapunitmax)    !original percent sand 
  real(r8) :: pct_clay0(nlay,mapunitmax)    !original percent clay 
  real(r8) :: mapunits0(nlon_st,nlat_st)    !mapunits 
  

  integer :: nlon_st,nlat_st,nlay	 !original soil tex dims
  integer :: nmapunits,mapunitmax        !# igbp mapunits, max value mu 
  integer :: nlon,nlat,ncid 		 !number lats/lons, nc fileo id 
  character(len=80) :: fileo             !output filenames


! ------------------------------------------------------------------
! Define local variables
! ------------------------------------------------------------------


  integer  :: countloam                   !layers of loam per mapunit
  integer  :: mu                          !current mapunit
  real(r8) :: pct_sand(mapunitmax,nlay)   !pct sand 
  real(r8) :: pct_clay(mapunitmax,nlay)   !pct clay
  real(r8) :: mapunits(nlon,nlat)         !new mapunits

  integer :: dimlon_id                    !netCDF dimension id
  integer :: dimlat_id                    !netCDF dimension id
  integer :: dimlay_id                    !netCDF dimension id
  integer :: dimmapunits_id               !netCDF dimension id
  integer :: dimmapunitmax_id             !netCDF dimension id

  integer :: dzsoi_id                     !soil thickness by layer
  integer :: zsoi_id                      !soil depth by layer
  integer :: lon_id                       !1d longitude array id
  integer :: lat_id                       !1d latitude array id
  integer :: lay_id                       !1d layer array id
  integer :: mapunit_id                   !2d mapunits array id
  integer :: longxy_id                    !2d longitude array id
  integer :: latixy_id                    !2d latitude array id
  integer :: edgen_id                     !northern edge of grid (edge(1)) id
  integer :: edgee_id                     !eastern  edge of grid (edge(2)) id
  integer :: edges_id                     !southern edge of grid (edge(3)) id
  integer :: edgew_id                     !western  edge of grid (edge(4)) id
  integer :: pct_sand_id                  !sand id
  integer :: pct_clay_id                  !clay id
  integer :: landmask_id                  !landmask id

  integer :: i,j,k                        !indices
  integer :: dim1_id(1)                   !netCDF dimension id for 1-d variables
  integer :: dim2_id(2)                   !netCDF dimension id for 2-d variables
  integer :: status                       !status

  character(len=256) :: name,unit         !netCDF attributes


! ------------------------------------------------------------
! Create skeleton netcdf
! --------------------------------------------------------------

! Define global attributes

  call wrap_create (fileo, nf_clobber, ncid)
  call wrap_put_att_text (ncid, nf_global, 'data_type', 'igbp_soil_texture_data')

! Define dimensions

  call wrap_def_dim (ncid, 'lon' , nlon, dimlon_id)
  call wrap_def_dim (ncid, 'lat' , nlat, dimlat_id)
  call wrap_def_dim (ncid, 'number_of_layers'   , nlay      , dimlay_id)
  call wrap_def_dim (ncid, 'number_of_mapunits' , nmapunits , dimmapunits_id)
  call wrap_def_dim (ncid, 'max_value_mapunit'  , mapunitmax, dimmapunitmax_id)

! Define input file independent variables 

  name = 'lon'
  unit = 'degrees east'
  dim1_id(1) = dimlon_id
  call wrap_def_var (ncid,'lon', nf_float, 1, dim1_id, lon_id)
  call wrap_put_att_text (ncid, lon_id, 'long_name', name)
  call wrap_put_att_text (ncid, lon_id, 'units'    , unit)

  name = 'lat'
  unit = 'degrees north'
  dim1_id(1) = dimlat_id
  call wrap_def_var (ncid,'lat', nf_float, 1, dim1_id, lat_id)
  call wrap_put_att_text (ncid, lat_id, 'long_name', name)
  call wrap_put_att_text (ncid, lat_id, 'units'    , unit)

  name = 'longitude-2d'
  unit = 'degrees east'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LONGXY', nf_float, 2, dim2_id, longxy_id)
  call wrap_put_att_text (ncid, longxy_id, 'long_name', name)
  call wrap_put_att_text (ncid, longxy_id, 'units'    , unit)

  name = 'latitude-2d'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'LATIXY', nf_float, 2, dim2_id, latixy_id)
  call wrap_put_att_text (ncid, latixy_id, 'long_name', name)
  call wrap_put_att_text (ncid, latixy_id, 'units'    , unit)

  name = 'land mask'
  unit = 'unitless'
  call wrap_def_var (ncid ,'LANDMASK' ,nf_float, 2, dim2_id, landmask_id)
  call wrap_put_att_text (ncid, landmask_id, 'long_name', name)
  call wrap_put_att_text (ncid, landmask_id, 'units'    , unit)

! to possibly replace the next two variables
! find out about dimensioned variables
! (eg, see how pressure levels are treated)

  name = 'soil layer thickness'
  unit = 'm'
  dim1_id(1) = dimlay_id
  call wrap_def_var (ncid,'DZSOI', nf_float, 1, dim1_id, dzsoi_id)
  call wrap_put_att_text (ncid, dzsoi_id, 'long_name', name)
  call wrap_put_att_text (ncid, dzsoi_id, 'units'    , unit)

  name = 'soil layer depth'
  unit = 'm'
  dim1_id(1) = dimlay_id
  call wrap_def_var (ncid,'ZSOI', nf_float, 1, dim1_id, zsoi_id)
  call wrap_put_att_text (ncid, zsoi_id, 'long_name', name)
  call wrap_put_att_text (ncid, zsoi_id, 'units'    , unit)

  name = 'northern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGEN', nf_float, 0, 0, edgen_id)
  call wrap_put_att_text (ncid, edgen_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgen_id, 'units'    , unit)

  name = 'eastern edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEE', nf_float, 0, 0, edgee_id)
  call wrap_put_att_text (ncid, edgee_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgee_id, 'units'    , unit)

  name = 'southern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGES', nf_float, 0, 0, edges_id)
  call wrap_put_att_text (ncid, edges_id, 'long_name', name)
  call wrap_put_att_text (ncid, edges_id, 'units'    , unit)

  name = 'western edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEW', nf_float, 0, 0, edgew_id)
  call wrap_put_att_text (ncid, edgew_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgew_id, 'units'    , unit)

! Define soil type and soil texture variables

  name = 'igbp soil mapunit'
  unit = 'unitless'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid ,'MAPUNITS' ,nf_float, 2, dim2_id, mapunit_id)
  call wrap_put_att_text (ncid, mapunit_id, 'long_name', name)
  call wrap_put_att_text (ncid, mapunit_id, 'units'    , unit)

  name = 'percent sand'
  unit = 'unitless'
  dim2_id(1) = dimmapunitmax_id
  dim2_id(2) = dimlay_id
  call wrap_def_var (ncid ,'PCT_SAND' ,nf_float, 2, dim2_id, pct_sand_id)
  call wrap_put_att_text (ncid, pct_sand_id, 'long_name', name)
  call wrap_put_att_text (ncid, pct_sand_id, 'units'    , unit)

  name = 'percent clay'
  unit = 'unitless'
  call wrap_def_var (ncid ,'PCT_CLAY' ,nf_float, 2, dim2_id, pct_clay_id)
  call wrap_put_att_text (ncid, pct_clay_id, 'long_name', name)
  call wrap_put_att_text (ncid, pct_clay_id, 'units'    , unit)

! End of definition

  status = nf_enddef(ncid)


! -----------------------------------------------------------------------
! pct_clay and pct_sand data 
! Think of mapunits as soil profiles. Each profile corresponds to a unique
! set of %sand and %clay values from the surface layer to the deepest one.
!
! Here we look for the mapunit that corresponds to a loam (an average soil)
! for all layers. We assign that mapunit to all land points.
! Users with more extensive knowledge of the soil texture for the period
! of their interest, should expand this code accordingly.
! -----------------------------------------------------------------------

  pct_sand = 0.  !initialize
  pct_clay = 0.  !three
  mapunits = 0.  !output variables

  do mu = 1,mapunitmax
    countloam = 0
    do k = 1,nlay
      if (pct_sand0(k,mu) > 39 .and. pct_sand0(k,mu) < 47 .and. &
          pct_clay0(k,mu) > 14 .and. pct_clay0(k,mu) < 22) then
        countloam = countloam + 1
      end if
      if (countloam == 10) then  !all layers are loam
        write(*,*) 'Found loam to be mapunit:',mu
        do j = 1,nlat
          do i = 1,nlon
            if (landmask(i,j) == 1) then
              mapunits(i,j) = mu !set mapunits globally to current mu (loam)
            end if
          end do !lon loop
        end do   !lat loop
      end if
      pct_sand(mu,k) = pct_sand0(k,mu) !the mapping from mapunit to %sand
      pct_clay(mu,k) = pct_clay0(k,mu) !and %clay remains the same
    end do       !loop through soil layers
  end do         !loop through mapunits

! --------------------------------------------------------------------------
! Write variables
! --------------------------------------------------------------------------

  call wrap_put_var_realx (ncid, lon_id     , lon)
  call wrap_put_var_realx (ncid, lat_id     , lat)
  call wrap_put_var_realx (ncid, longxy_id  , longxy)
  call wrap_put_var_realx (ncid, latixy_id  , latixy)
  call wrap_put_var_realx (ncid, landmask_id, landmask)
  call wrap_put_var_realx (ncid, edgen_id   , edge(1))
  call wrap_put_var_realx (ncid, edgee_id   , edge(2))
  call wrap_put_var_realx (ncid, edges_id   , edge(3))
  call wrap_put_var_realx (ncid, edgew_id   , edge(4))
  call wrap_put_var_realx (ncid, dzsoi_id   , dzsoi)
  call wrap_put_var_realx (ncid, zsoi_id    , zsoi)
  call wrap_put_var_realx (ncid, mapunit_id , mapunits)
  call wrap_put_var_realx (ncid, pct_sand_id, pct_sand)
  call wrap_put_var_realx (ncid, pct_clay_id, pct_clay)

  call wrap_close(ncid)

end subroutine create_mksrf_soitex 


!===============================================================================
subroutine create_mksrf_organic(veg,landmask,nlay,                       &
                               dzsoi,zsoi,z_organic,zorg_lat,nlat_org,	 &
                               nlon,nlat,lon,longxy,lat,latixy,edge,     &
                               fileo,ncid)


  implicit none
  include 'netcdf.inc'

! ---------------------------------------------------------------------
! Global variables
!-----------------------------------------------------------------------

  integer, parameter :: r8 = selected_real_kind(12)

  integer  :: veg(nlon,nlat)	          !lsm veg array  (input)
  real(r8) :: landmask(nlon,nlat)	  !landmask array  (input)
  real(r8) :: lon(nlon)                   !longitude dimension array (1d)
  real(r8) :: lat(nlat)                   !latitude dimension array (1d) 
  real(r8) :: longxy(nlon,nlat)           !longitude dimension array (2d)  
  real(r8) :: latixy(nlon,nlat)           !longitude dimension array (2d)
  real(r8) :: edge(4)                     !N,E,S,W edges of grid

  real(r8) :: dzsoi(10), zsoi(10)        !soil layer thickness and depth
  real(r8) :: z_organic(nlat_org,10)     !zonal organic soil density values 
  real(r8) :: zorg_lat(nlat_org)         !lat for zonal file

  integer :: nlon,nlat,nlat_org,nlay,ncid  !number lats/lons, nc fileo id 
  character(len=80) :: fileo             !output filenames


! ------------------------------------------------------------------
! Define local variables
! ------------------------------------------------------------------


  real(r8) :: organic(nlon,nlat,10) 	  !organic soil density
  real(r8) :: sum80,sum70,sum60,sum50,sum40,sum30,sum20,sum10,sum0
  real(r8) :: summ0,summ10,summ20,summ30,summ40,summ50,summ60,summ70,summ80,summ90
  real(r8) :: cnt80,cnt70,cnt60,cnt50,cnt40,cnt30,cnt20,cnt10,cnt0,cntm0,cntm10
  real(r8) :: cntm20,cntm30,cntm40,cntm50,cntm60,cntm70,cntm80,cntm90

  integer :: dimlon_id                    !netCDF dimension id
  integer :: dimlat_id                    !netCDF dimension id
  integer :: dimlay_id                    !netCDF dimension id

  integer :: dzsoi_id                     !soil thickness by layer
  integer :: zsoi_id                      !soil depth by layer
  integer :: lon_id                       !1d longitude array id
  integer :: lat_id                       !1d latitude array id
  integer :: lay_id                       !1d layer array id
  integer :: longxy_id                    !2d longitude array id
  integer :: latixy_id                    !2d latitude array id
  integer :: edgen_id                     !northern edge of grid (edge(1)) id
  integer :: edgee_id                     !eastern  edge of grid (edge(2)) id
  integer :: edges_id                     !southern edge of grid (edge(3)) id
  integer :: edgew_id                     !western  edge of grid (edge(4)) id
  integer :: organic_id                   !organic id
  integer :: landmask_id                  !landmask id

  integer :: i,j,k,jj                     !indices
  integer :: dim1_id(1)                   !netCDF dimension id for 1-d variables
  integer :: dim2_id(2)                   !netCDF dimension id for 2-d variables
  integer :: dim3_id(3)                   !netCDF dimension id for 2-d variables
  integer :: status                       !status

  character(len=256) :: name,unit         !netCDF attributes


! ------------------------------------------------------------
! Create skeleton netcdf
! --------------------------------------------------------------

! Define global attributes

  call wrap_create (fileo, nf_clobber, ncid)
  call wrap_put_att_text (ncid, nf_global, 'data_type', 'organic_soil_density')

! Define dimensions

  call wrap_def_dim (ncid, 'lon' , nlon, dimlon_id)
  call wrap_def_dim (ncid, 'lat' , nlat, dimlat_id)
  call wrap_def_dim (ncid, 'number_of_layers'   , nlay      , dimlay_id)

! Define input file independent variables 

  name = 'lon'
  unit = 'degrees east'
  dim1_id(1) = dimlon_id
  call wrap_def_var (ncid,'lon', nf_float, 1, dim1_id, lon_id)
  call wrap_put_att_text (ncid, lon_id, 'long_name', name)
  call wrap_put_att_text (ncid, lon_id, 'units'    , unit)

  name = 'lat'
  unit = 'degrees north'
  dim1_id(1) = dimlat_id
  call wrap_def_var (ncid,'lat', nf_float, 1, dim1_id, lat_id)
  call wrap_put_att_text (ncid, lat_id, 'long_name', name)
  call wrap_put_att_text (ncid, lat_id, 'units'    , unit)

  name = 'longitude-2d'
  unit = 'degrees east'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LONGXY', nf_float, 2, dim2_id, longxy_id)
  call wrap_put_att_text (ncid, longxy_id, 'long_name', name)
  call wrap_put_att_text (ncid, longxy_id, 'units'    , unit)

  name = 'latitude-2d'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'LATIXY', nf_float, 2, dim2_id, latixy_id)
  call wrap_put_att_text (ncid, latixy_id, 'long_name', name)
  call wrap_put_att_text (ncid, latixy_id, 'units'    , unit)

  name = 'land mask'
  unit = 'unitless'
  call wrap_def_var (ncid ,'LANDMASK' ,nf_float, 2, dim2_id, landmask_id)
  call wrap_put_att_text (ncid, landmask_id, 'long_name', name)
  call wrap_put_att_text (ncid, landmask_id, 'units'    , unit)

  name = 'soil layer thickness'
  unit = 'm'
  dim1_id(1) = dimlay_id
  call wrap_def_var (ncid,'DZSOI', nf_float, 1, dim1_id, dzsoi_id)
  call wrap_put_att_text (ncid, dzsoi_id, 'long_name', name)
  call wrap_put_att_text (ncid, dzsoi_id, 'units'    , unit)

  name = 'soil layer depth'
  unit = 'm'
  dim1_id(1) = dimlay_id
  call wrap_def_var (ncid,'ZSOI', nf_float, 1, dim1_id, zsoi_id)
  call wrap_put_att_text (ncid, zsoi_id, 'long_name', name)
  call wrap_put_att_text (ncid, zsoi_id, 'units'    , unit)

  name = 'northern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGEN', nf_float, 0, 0, edgen_id)
  call wrap_put_att_text (ncid, edgen_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgen_id, 'units'    , unit)

  name = 'eastern edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEE', nf_float, 0, 0, edgee_id)
  call wrap_put_att_text (ncid, edgee_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgee_id, 'units'    , unit)

  name = 'southern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGES', nf_float, 0, 0, edges_id)
  call wrap_put_att_text (ncid, edges_id, 'long_name', name)
  call wrap_put_att_text (ncid, edges_id, 'units'    , unit)

  name = 'western edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEW', nf_float, 0, 0, edgew_id)
  call wrap_put_att_text (ncid, edgew_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgew_id, 'units'    , unit)

  name = 'Organic soil density at soil levels'
  unit = 'kg/m3 (assumed carbon content 0.58 gC per gOM)'
  dim3_id(1) = dimlon_id
  dim3_id(2) = dimlat_id
  dim3_id(3) = dimlay_id
  call wrap_def_var (ncid ,'ORGANIC' ,nf_float, 3, dim3_id, organic_id)
  call wrap_put_att_text (ncid, organic_id, 'long_name', name)
  call wrap_put_att_text (ncid, organic_id, 'units'    , unit)

! End of definition

  status = nf_enddef(ncid)


! -----------------------------------------------------------------------
! As a first guess for any deep time case, we assume the organic soil
! density to approximate the zonal average modern values. Essentially,
! this assumes the latitudinal structure of organic soils, i.e. pole to
! equator stays the same.  If this is not desirable, change code here.
! -----------------------------------------------------------------------

 organic = 0.  ! initialize all point to zero

! clunky...feel free to change
    ! do k = 1,nlay
      sum80 = 0.
      sum70 = 0.
      sum60 = 0.
      sum50 = 0.
      sum40 = 0.
      sum30 = 0.
      sum20 = 0.
      sum10 = 0.
      sum0 = 0.
      summ10 = 0.
      summ20 = 0.
      summ30 = 0.
      summ40 = 0.
      summ50 = 0.
      summ60 = 0.
      summ70 = 0.
      summ80 = 0.
      summ90 = 0.
	cnt80 = 0.
	cnt70 = 0.
	cnt60 = 0.
	cnt50 = 0.
	cnt40 = 0.
	cnt30 = 0.
	cnt20 = 0.
	cnt10 = 0.
	cnt0 = 0.
	cntm10 = 0.
	cntm20 = 0.
	cntm30 = 0.
	cntm40 = 0.
	cntm50 = 0.
	cntm60 = 0.
	cntm70 = 0.
	cntm80 = 0.
	cntm90 = 0.
        do j = 1,nlat
          do i = 1,nlon
            if (landmask(i,j) == 1) then
		do jj = 1,nlat_org
 		 if(lat(j).ge.80.and.zorg_lat(jj).ge.80)then
                   sum80 = z_organic(jj,k) + sum80 
                   cnt80 = cnt80 + 1.
                 elseif (lat(j).ge.70.and.lat(j).lt.80.and.zorg_lat(jj).ge.70.and.zorg_lat(jj).lt.80)then
                   sum70 = z_organic(jj,k) + sum70 
                   cnt70 = cnt70 + 1.
                 elseif (lat(j).ge.60.and.lat(j).lt.70.and.zorg_lat(jj).ge.60.and.zorg_lat(jj).lt.70)then
                   sum60 = z_organic(jj,k) + sum60 
                   cnt60 = cnt60 + 1.
                 elseif (lat(j).ge.50.and.lat(j).lt.60.and.zorg_lat(jj).ge.50.and.zorg_lat(jj).lt.60)then
                   sum50 = z_organic(jj,k) + sum50 
                   cnt50 = cnt50 + 1.
                 elseif (lat(j).ge.40.and.lat(j).lt.50.and.zorg_lat(jj).ge.40.and.zorg_lat(jj).lt.50)then
                   sum40 = z_organic(jj,k) + sum40 
                   cnt40 = cnt40 + 1.
                 elseif (lat(j).ge.30.and.lat(j).lt.40.and.zorg_lat(jj).ge.30.and.zorg_lat(jj).lt.40)then
                   sum30 = z_organic(jj,k) + sum30 
                   cnt30 = cnt30 + 1.
                 elseif (lat(j).ge.20.and.lat(j).lt.30.and.zorg_lat(jj).ge.20.and.zorg_lat(jj).lt.30)then
                   sum20 = z_organic(jj,k) + sum20 
                   cnt20 = cnt20 + 1.
                 elseif (lat(j).ge.10.and.lat(j).lt.20.and.zorg_lat(jj).ge.10.and.zorg_lat(jj).lt.20)then
                   sum10 = z_organic(jj,k) + sum10 
                   cnt10 = cnt10 + 1.
                 elseif (lat(j).ge.0.and.lat(j).lt.10.and.zorg_lat(jj).ge.0.and.zorg_lat(jj).lt.10)then
                   sum0 = z_organic(jj,k) + sum0 
                   cnt0 = cnt0 + 1.
                 elseif (lat(j).ge.-10.and.lat(j).lt.0.and.zorg_lat(jj).ge.-10.and.zorg_lat(jj).lt.0)then
                   summ10 = z_organic(jj,k) + summ10 
                   cntm10 = cntm10 + 1.
                 elseif (lat(j).ge.-20.and.lat(j).lt.-10.and.zorg_lat(jj).ge.-20.and.zorg_lat(jj).lt.-10)then
                   summ20 = z_organic(jj,k) + summ20 
                   cntm20 = cntm20 + 1.
                 elseif (lat(j).ge.-30.and.lat(j).lt.-20.and.zorg_lat(jj).ge.-30.and.zorg_lat(jj).lt.-20)then
                   summ30 = z_organic(jj,k) + summ30 
                   cntm30 = cntm30 + 1.
                 elseif (lat(j).ge.-40.and.lat(j).lt.-30.and.zorg_lat(jj).ge.-40.and.zorg_lat(jj).lt.-30)then
                   summ40 = z_organic(jj,k) + summ40 
                   cntm40 = cntm40 + 1.
                 elseif (lat(j).ge.-50.and.lat(j).lt.-40.and.zorg_lat(jj).ge.-50.and.zorg_lat(jj).lt.-40)then
                   summ50 = z_organic(jj,k) + summ50 
                   cntm50 = cntm50 + 1.
                 elseif (lat(j).ge.-60.and.lat(j).lt.-50.and.zorg_lat(jj).ge.-60.and.zorg_lat(jj).lt.-50)then
                   summ60 = z_organic(jj,k) + summ60 
                   cntm60 = cntm60 + 1.
                 elseif (lat(j).ge.-70.and.lat(j).lt.-60.and.zorg_lat(jj).ge.-70.and.zorg_lat(jj).lt.-60)then
                   summ70 = z_organic(jj,k) + summ70 
                   cntm70 = cntm70 + 1.
                 elseif (lat(j).ge.-80.and.lat(j).lt.-70.and.zorg_lat(jj).ge.-80.and.zorg_lat(jj).lt.-70)then
                   summ80 = z_organic(jj,k) + summ80 
                   cntm80 = cntm80 + 1.
                 elseif (lat(j).ge.-90.and.lat(j).lt.-80.and.zorg_lat(jj).ge.-90.and.zorg_lat(jj).lt.-80)then
                   summ90 = z_organic(jj,k) + summ90 
                   cntm90 = cntm90 + 1.
	         end if
	       end do
	    end if 
	 end do
	end do
        sum80 = sum80/cnt80     
        sum70 = sum70/cnt70     
        sum60 = sum60/cnt60     
        sum50 = sum50/cnt50     
        sum40 = sum40/cnt40     
        sum30 = sum30/cnt30     
        sum20 = sum20/cnt20     
        sum10 = sum10/cnt10     
        sum0 = sum0/cnt0     
        summ10 = summ10/cntm10     
        summ20 = summ20/cntm20     
        summ30 = summ30/cntm30     
        summ40 = summ40/cntm40     
        summ50 = summ50/cntm50     
        summ60 = summ60/cntm60     
        summ70 = summ70/cntm70     
        summ80 = summ80/cntm80     
        summ90 = summ90/cntm90     
        do j = 1,nlat
          do i = 1,nlon
            if (landmask(i,j) == 1) then
 		 if(lat(j).ge.80)then
		  organic(i,j,k) = sum80
                 elseif (lat(j).ge.70.and.lat(j).lt.80)then
		  organic(i,j,k) = sum70
                 elseif (lat(j).ge.60.and.lat(j).lt.70)then
		  organic(i,j,k) = sum60
                 elseif (lat(j).ge.50.and.lat(j).lt.60)then
		  organic(i,j,k) = sum50
                 elseif (lat(j).ge.40.and.lat(j).lt.50)then
		  organic(i,j,k) = sum40
                 elseif (lat(j).ge.30.and.lat(j).lt.40)then
		  organic(i,j,k) = sum30
                 elseif (lat(j).ge.20.and.lat(j).lt.30)then
		  organic(i,j,k) = sum20
                 elseif (lat(j).ge.10.and.lat(j).lt.20)then
		  organic(i,j,k) = sum10
                 elseif (lat(j).ge.0.and.lat(j).lt.10)then
		  organic(i,j,k) = sum0
                 elseif (lat(j).ge.-10.and.lat(j).lt.0)then
		  organic(i,j,k) = summ10
                 elseif (lat(j).ge.-20.and.lat(j).lt.-10)then
		  organic(i,j,k) = summ20
                 elseif (lat(j).ge.-30.and.lat(j).lt.-20)then
		  organic(i,j,k) = summ30
                 elseif (lat(j).ge.-40.and.lat(j).lt.-30)then
		  organic(i,j,k) = summ40
                 elseif (lat(j).ge.-50.and.lat(j).lt.-40)then
		  organic(i,j,k) = summ50
                 elseif (lat(j).ge.-60.and.lat(j).lt.-50)then
		  organic(i,j,k) = summ60
                 elseif (lat(j).ge.-70.and.lat(j).lt.-60)then
		  organic(i,j,k) = summ70
                 elseif (lat(j).ge.-80.and.lat(j).lt.-70)then
		  organic(i,j,k) = summ80
                 elseif (lat(j).ge.-90.and.lat(j).lt.-80)then
		  organic(i,j,k) = summ90
	        endif
               endif
	     enddo
	  enddo
        print *,' k =  ', k
   	print *, 'sum80 = ', sum80
   	print *, 'sum70 = ', sum70
   	print *, 'sum60 = ', sum60
   	print *, 'sum50 = ', sum50
   	print *, 'sum40 = ', sum40
   	print *, 'sum30 = ', sum30
   	print *, 'sum20 = ', sum20
   	print *, 'sum10 = ', sum10
   	print *, 'sum0 = ', sum0
   	print *, 'summ10 = ', summ10
   	print *, 'summ20 = ', summ20
   	print *, 'summ30 = ', summ30
   	print *, 'summ40 = ', summ40
   	print *, 'summ50 = ', summ50
   	print *, 'summ60 = ', summ60
   	print *, 'summ70 = ', summ70
   	print *, 'summ80 = ', summ80
   	print *, 'summ90 = ', summ90


! --------------------------------------------------------------------------
! Write variables
! --------------------------------------------------------------------------

  call wrap_put_var_realx (ncid, lon_id     , lon)
  call wrap_put_var_realx (ncid, lat_id     , lat)
  call wrap_put_var_realx (ncid, longxy_id  , longxy)
  call wrap_put_var_realx (ncid, latixy_id  , latixy)
  call wrap_put_var_realx (ncid, landmask_id, landmask)
  call wrap_put_var_realx (ncid, edgen_id   , edge(1))
  call wrap_put_var_realx (ncid, edgee_id   , edge(2))
  call wrap_put_var_realx (ncid, edges_id   , edge(3))
  call wrap_put_var_realx (ncid, edgew_id   , edge(4))
  call wrap_put_var_realx (ncid, dzsoi_id   , dzsoi)
  call wrap_put_var_realx (ncid, zsoi_id    , zsoi)
  call wrap_put_var_realx (ncid, organic_id, organic)

  call wrap_close(ncid)


! ---------------------------------------------------------------------

end subroutine create_mksrf_organic



!===============================================================================
subroutine create_mksrf_fmax(veg,landmask,                               &
                               nlon,nlat,lon,longxy,lat,latixy,edge,     &
                               fileo,ncid)


  implicit none
  include 'netcdf.inc'

! ---------------------------------------------------------------------
! Global variables
!-----------------------------------------------------------------------

  integer, parameter :: r8 = selected_real_kind(12)

  integer  :: veg(nlon,nlat)	          !lsm veg array  (input)
  real(r8) :: landmask(nlon,nlat)	  !landmask array  (input)
  real(r8) :: lon(nlon)                   !longitude dimension array (1d)
  real(r8) :: lat(nlat)                   !latitude dimension array (1d) 
  real(r8) :: longxy(nlon,nlat)           !longitude dimension array (2d)  
  real(r8) :: latixy(nlon,nlat)           !longitude dimension array (2d)
  real(r8) :: edge(4)                     !N,E,S,W edges of grid

  integer :: nlon,nlat,ncid              !number lats/lons, nc fileo id 
  character(len=80) :: fileo             !output filenames


! ------------------------------------------------------------------
! Define local variables
! ------------------------------------------------------------------

  real(r8) :: fmax(nlon,nlat)       !maximum fractiona sat area
  real(r8) :: global_avg            !global value of fmax

  integer :: dimlon_id                    !netCDF dimension id
  integer :: dimlat_id                    !netCDF dimension id

  integer :: lon_id                       !1d longitude array id
  integer :: lat_id                       !1d latitude array id
  integer :: longxy_id                    !2d longitude array id
  integer :: latixy_id                    !2d latitude array id
  integer :: edgen_id                     !northern edge of grid (edge(1)) id
  integer :: edgee_id                     !eastern  edge of grid (edge(2)) id
  integer :: edges_id                     !southern edge of grid (edge(3)) id
  integer :: edgew_id                     !western  edge of grid (edge(4)) id
  integer :: gfmax_id                     ! array id
  integer :: fmax_id                      !fmax id
  integer :: landmask_id                  !landmask id

  integer :: i,j                          !indices
  integer :: dim1_id(1)                   !netCDF dimension id for 1-d variables
  integer :: dim2_id(2)                   !netCDF dimension id for 2-d variables
  integer :: status                       !status

  character(len=256) :: name,unit         !netCDF attributes


! ------------------------------------------------------------
! Create skeleton netcdf
! --------------------------------------------------------------

! Define global attributes

  call wrap_create (fileo, nf_clobber, ncid)
  call wrap_put_att_text (ncid, nf_global, 'data_type', 'fmax_data')

! Define dimensions

  call wrap_def_dim (ncid, 'lon' , nlon, dimlon_id)
  call wrap_def_dim (ncid, 'lat' , nlat, dimlat_id)

! Define input file independent variables 

  name = 'lon'
  unit = 'degrees east'
  dim1_id(1) = dimlon_id
  call wrap_def_var (ncid,'lon', nf_float, 1, dim1_id, lon_id)
  call wrap_put_att_text (ncid, lon_id, 'long_name', name)
  call wrap_put_att_text (ncid, lon_id, 'units'    , unit)

  name = 'lat'
  unit = 'degrees north'
  dim1_id(1) = dimlat_id
  call wrap_def_var (ncid,'lat', nf_float, 1, dim1_id, lat_id)
  call wrap_put_att_text (ncid, lat_id, 'long_name', name)
  call wrap_put_att_text (ncid, lat_id, 'units'    , unit)

  name = 'longitude-2d'
  unit = 'degrees east'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LONGXY', nf_float, 2, dim2_id, longxy_id)
  call wrap_put_att_text (ncid, longxy_id, 'long_name', name)
  call wrap_put_att_text (ncid, longxy_id, 'units'    , unit)

  name = 'latitude-2d'
  unit = 'degrees north'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LATIXY', nf_float, 2, dim2_id, latixy_id)
  call wrap_put_att_text (ncid, latixy_id, 'long_name', name)
  call wrap_put_att_text (ncid, latixy_id, 'units'    , unit)

  name = 'northern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGEN', nf_float, 0, 0, edgen_id)
  call wrap_put_att_text (ncid, edgen_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgen_id, 'units'    , unit)

  name = 'eastern edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEE', nf_float, 0, 0, edgee_id)
  call wrap_put_att_text (ncid, edgee_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgee_id, 'units'    , unit)

  name = 'southern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGES', nf_float, 0, 0, edges_id)
  call wrap_put_att_text (ncid, edges_id, 'long_name', name)
  call wrap_put_att_text (ncid, edges_id, 'units'    , unit)

  name = 'western edge of surface grid'
  
  call wrap_def_var (ncid, 'EDGEW', nf_float, 0, 0, edgew_id)
  call wrap_put_att_text (ncid, edgew_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgew_id, 'units'    , unit)

! Define input file specific variables

  name = 'global average FMAX'
  unit = 'fraction [0-1]'
  call wrap_def_var (ncid,'global_avg', nf_float, 0, 0, gfmax_id)
  call wrap_put_att_text (ncid, gfmax_id, 'long_name', name)
  call wrap_put_att_text (ncid, gfmax_id, 'units'    , unit)

  name = 'Maximum Fractional Saturated Area'
  unit = 'fraction [0-1]'
  dim2_id(1) = lon_id
  dim2_id(2) = lat_id
  call wrap_def_var (ncid ,'FMAX' ,nf_float, 2, dim2_id, fmax_id)
  call wrap_put_att_text (ncid, fmax_id, 'long_name', name)
  call wrap_put_att_text (ncid, fmax_id, 'units'    , unit)

  name = 'land mask'
  unit = 'unitless'
  call wrap_def_var (ncid ,'LANDMASK' ,nf_float, 2, dim2_id, landmask_id)
  call wrap_put_att_text (ncid, landmask_id, 'long_name', name)
  call wrap_put_att_text (ncid, landmask_id, 'units'    , unit)

! End of definition

  status = nf_enddef(ncid)

! -----------------------------------------------------------------------
! Create fmax from LSM vegtypes (if user so desires)
! currently setting number to global value 
! global value computed as global weighted average value over
! land from default file: mksrf_fmax.070406.nc
! 0.370548  mk_deeptime_frommod.ncl 
! -----------------------------------------------------------------------


  fmax = -999.99  
  do j = 1,nlon
  do i = 1,nlat
   if(landmask(j,i) == 1.) fmax(j,i) =  0.370548 
  enddo
  enddo
  global_avg =  0.370548
  print *, 'FMAX sample at point (20,40)',fmax(20,40)


! --------------------------------------------------------------------------
! Write variables
! --------------------------------------------------------------------------

  call wrap_put_var_realx (ncid, lon_id       , lon)
  call wrap_put_var_realx (ncid, lat_id       , lat)
  call wrap_put_var_realx (ncid, longxy_id    , longxy)
  call wrap_put_var_realx (ncid, latixy_id    , latixy)
  call wrap_put_var_realx (ncid, edgen_id     , edge(1))
  call wrap_put_var_realx (ncid, edgee_id     , edge(2))
  call wrap_put_var_realx (ncid, edges_id     , edge(3))
  call wrap_put_var_realx (ncid, edgew_id     , edge(4))
  call wrap_put_var_realx (ncid, landmask_id  , landmask)
  call wrap_put_var_realx (ncid, fmax_id     , fmax)
  call wrap_put_var_realx (ncid, gfmax_id     ,global_avg)

! Close output file

  call wrap_close(ncid)

end subroutine create_mksrf_fmax


!===============================================================================
subroutine create_mksrf_topo(landmask,topoin,                               &
                             nlon,nlat,lon,longxy,lat,latixy,edge,          &
                             fileo,ncid)


  implicit none
  include 'netcdf.inc'

! ---------------------------------------------------------------------
! Global variables
!-----------------------------------------------------------------------

  integer, parameter :: r8 = selected_real_kind(12)

  integer  :: topoin(nlon,nlat)	          !topo array  (input)
  real(r8) :: landmask(nlon,nlat)	  !landmask array  (input)
  real(r8) :: lon(nlon)                   !longitude dimension array (1d)
  real(r8) :: lat(nlat)                   !latitude dimension array (1d) 
  real(r8) :: longxy(nlon,nlat)           !longitude dimension array (2d)  
  real(r8) :: latixy(nlon,nlat)           !longitude dimension array (2d)
  real(r8) :: edge(4)                     !N,E,S,W edges of grid

  integer :: nlon,nlat,ncid              !number lats/lons, nc fileo id 
  character(len=80) :: fileo             !output filenames


! ------------------------------------------------------------------
! Define local variables
! ------------------------------------------------------------------

  real(r8) :: topo_bedrock(nlon,nlat)       !topographical heights (m)
  real(r8) :: topo_ice(nlon,nlat)           !topographical heights + ice sheet hgt (m)
  integer  :: numlon(nlat)                  !number of lons per lat

  integer :: dimlsmlon_id                    !netCDF dimension id
  integer :: dimlsmlat_id                    !netCDF dimension id

  integer :: dimlon_id                    !netCDF dimension id
  integer :: dimlat_id                    !netCDF dimension id

  integer :: numlon_id                    !1d numlon array id
  integer :: lon_id                       !1d longitude array id
  integer :: lat_id                       !1d latitude array id
  integer :: longxy_id                    !2d longitude array id
  integer :: latixy_id                    !2d latitude array id
  integer :: edgen_id                     !northern edge of grid (edge(1)) id
  integer :: edgee_id                     !eastern  edge of grid (edge(2)) id
  integer :: edges_id                     !southern edge of grid (edge(3)) id
  integer :: edgew_id                     !western  edge of grid (edge(4)) id
  integer :: topobed_id                   ! array id
  integer :: topoice_id                   !fmax id
  integer :: landmask_id                  !landmask id

  integer :: i,j                          !indices
  integer :: dim1_id(1)                   !netCDF dimension id for 1-d variables
  integer :: dim2_id(2)                   !netCDF dimension id for 2-d variables
  integer :: status                       !status

  character(len=256) :: name,unit         !netCDF attributes


! ------------------------------------------------------------
! Create skeleton netcdf
! --------------------------------------------------------------

! Define global attributes

  call wrap_create (fileo, nf_clobber, ncid)
  call wrap_put_att_text (ncid, nf_global, 'data_type', 'topoice_data')

! Define dimensions

  call wrap_def_dim (ncid, 'lon' , nlon, dimlon_id)
  call wrap_def_dim (ncid, 'lat' , nlat, dimlat_id)

! Define input file independent variables 

  name = 'lon'
  unit = 'degrees east'
  dim1_id(1) = dimlon_id
  call wrap_def_var (ncid,'lon', nf_float, 1, dim1_id, lon_id)
  call wrap_put_att_text (ncid, lon_id, 'long_name', name)
  call wrap_put_att_text (ncid, lon_id, 'units'    , unit)

  name = 'lat'
  unit = 'degrees north'
  dim1_id(1) = dimlat_id
  call wrap_def_var (ncid,'lat', nf_float, 1, dim1_id, lat_id)
  call wrap_put_att_text (ncid, lat_id, 'long_name', name)
  call wrap_put_att_text (ncid, lat_id, 'units'    , unit)

  name = 'longitude-2d'
  unit = 'degrees east'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LONGXY', nf_float, 2, dim2_id, longxy_id)
  call wrap_put_att_text (ncid, longxy_id, 'long_name', name)
  call wrap_put_att_text (ncid, longxy_id, 'units'    , unit)

  name = 'latitude-2d'
  unit = 'degrees north'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LATIXY', nf_float, 2, dim2_id, latixy_id)
  call wrap_put_att_text (ncid, latixy_id, 'long_name', name)
  call wrap_put_att_text (ncid, latixy_id, 'units'    , unit)

  name = 'northern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGEN', nf_float, 0, 0, edgen_id)
  call wrap_put_att_text (ncid, edgen_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgen_id, 'units'    , unit)

  name = 'eastern edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEE', nf_float, 0, 0, edgee_id)
  call wrap_put_att_text (ncid, edgee_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgee_id, 'units'    , unit)

  name = 'southern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGES', nf_float, 0, 0, edges_id)
  call wrap_put_att_text (ncid, edges_id, 'long_name', name)
  call wrap_put_att_text (ncid, edges_id, 'units'    , unit)

  name = 'western edge of surface grid'
  
  call wrap_def_var (ncid, 'EDGEW', nf_float, 0, 0, edgew_id)
  call wrap_put_att_text (ncid, edgew_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgew_id, 'units'    , unit)

! Define input file specific variables

  name = 'number of grid cells at each latitude'
  unit = 'unitless'
  dim1_id(1) = dimlat_id
  call wrap_def_var (ncid,'NUMLON', nf_float, 1, dim1_id, numlon_id)
  call wrap_put_att_text (ncid, numlon_id, 'long_name', name)
  call wrap_put_att_text (ncid, numlon_id, 'units'    , unit)

  name = 'topographical height'
  unit = 'm'
  dim2_id(1) = lon_id
  dim2_id(2) = lat_id
  call wrap_def_var (ncid,'TOPO', nf_float, 2, dim2_id, topobed_id)
  !! call wrap_def_var (ncid,'TOPO_BEDROCK', nf_float, 2, dim2_id, topobed_id)
  call wrap_put_att_text (ncid, topobed_id, 'long_name', name)
  call wrap_put_att_text (ncid, topobed_id, 'units'    , unit)

  name = 'topographical height + ice'
  unit = 'm'
  dim2_id(1) = lon_id
  dim2_id(2) = lat_id
  call wrap_def_var (ncid ,'TOPO_ICE' ,nf_float, 2, dim2_id, topoice_id)
  call wrap_put_att_text (ncid, topoice_id, 'long_name', name)
  call wrap_put_att_text (ncid, topoice_id, 'units'    , unit)

! End of definition

  status = nf_enddef(ncid)

! -----------------------------------------------------------------------
! read topo from topo_depth file
! add code to specify ice sheet if so desired
! if you wish to read in a seperaete ice sheet topofile, 
! you will need to modify the code
! -----------------------------------------------------------------------

  do i = 1,nlat
   numlon(i) =  nlon
  end do 
 print *, numlon

 topo_ice = topoin
 topo_bedrock = topoin
 
! elevation values are for land only, replace bathymetry values with 0.
  do j = 1,nlon
  do i = 1,nlat
   if(landmask(j,i) == 0.) topo_ice(j,i) =  0. 
   if(landmask(j,i) == 0.) topo_bedrock(j,i) =  0. 
  end do
  end do

! ---- add ice mods here
!

! --------------------------------------------------------------------------
! Write variables
! --------------------------------------------------------------------------

  call wrap_put_var_int (ncid, numlon_id    , numlon)
  call wrap_put_var_realx (ncid, lon_id        , lon)
  call wrap_put_var_realx (ncid, lat_id        , lat)
  call wrap_put_var_realx (ncid, longxy_id    , longxy)
  call wrap_put_var_realx (ncid, latixy_id    , latixy)
  call wrap_put_var_realx (ncid, edgen_id     , edge(1))
  call wrap_put_var_realx (ncid, edgee_id     , edge(2))
  call wrap_put_var_realx (ncid, edges_id     , edge(3))
  call wrap_put_var_realx (ncid, edgew_id     , edge(4))
  call wrap_put_var_realx (ncid, topobed_id, topo_bedrock)
  call wrap_put_var_realx (ncid, topoice_id, topo_ice)

! Close output file

  call wrap_close(ncid)

! ---------------------------------------------------------------------

end subroutine create_mksrf_topo

!===============================================================================
subroutine create_mksrf_vocef(veg,landmask,                              &
                               nlon,nlat,lon,longxy,lat,latixy,edge,     &
                               fileo,ncid)

  implicit none
  include 'netcdf.inc'

! ---------------------------------------------------------------------
! Global variables
!-----------------------------------------------------------------------

  integer, parameter :: r8 = selected_real_kind(12)

  integer  :: veg(nlon,nlat)	          !lsm veg array  (input)
  real(r8) :: landmask(nlon,nlat)	  !landmask array  (input)
  real(r8) :: lon(nlon)                   !longitude dimension array (1d)
  real(r8) :: lat(nlat)                   !latitude dimension array (1d) 
  real(r8) :: longxy(nlon,nlat)           !longitude dimension array (2d)  
  real(r8) :: latixy(nlon,nlat)           !longitude dimension array (2d)
  real(r8) :: edge(4)                     !N,E,S,W edges of grid

  integer :: nlon,nlat,ncid              !number lats/lons, nc fileo id 
  character(len=80) :: fileo             !output filenames


! ------------------------------------------------------------------
! Define local variables
! ------------------------------------------------------------------
					 
  real(r8) :: ef_btr(nlon,nlat)          !broadleaf tree emission factor
  real(r8) :: ef_fet(nlon,nlat)          !Fineleaf evergreen tree tree emission factor
  real(r8) :: ef_fdt(nlon,nlat)          !Fineleaf deciduous tree emission factor
  real(r8) :: ef_shr(nlon,nlat)          !shrub emission factor
  real(r8) :: ef_grs(nlon,nlat)          !grass, non-vascular plants and other ground cover emission factor
  real(r8) :: ef_crp(nlon,nlat)          !crop emission factor

  integer :: dimlon_id                    !netCDF dimension id
  integer :: dimlat_id                    !netCDF dimension id

  integer :: lon_id                       !1d longitude array id
  integer :: lat_id                       !1d latitude array id
  integer :: longxy_id                    !2d longitude array id
  integer :: latixy_id                    !2d latitude array id
  integer :: edgen_id                     !northern edge of grid (edge(1)) id
  integer :: edgee_id                     !eastern  edge of grid (edge(2)) id
  integer :: edges_id                     !southern edge of grid (edge(3)) id
  integer :: edgew_id                     !western  edge of grid (edge(4)) id
  integer :: ef_btr_id                    !ef_btr id
  integer :: ef_fet_id                    !ef_fet id
  integer :: ef_fdt_id                    !ef_fdt id
  integer :: ef_shr_id                    !ef_shr id
  integer :: ef_grs_id                    !ef_grs id
  integer :: ef_crp_id                    !ef_crp id
  integer :: landmask_id                  !landmask id

  integer :: i,j                          !indices
  integer :: dim1_id(1)                   !netCDF dimension id for 1-d variables
  integer :: dim2_id(2)                   !netCDF dimension id for 2-d variables
  integer :: status                       !status

  character(len=256) :: name,unit         !netCDF attributes


! ------------------------------------------------------------
! Create skeleton netcdf
! --------------------------------------------------------------

! Define global attributes

  call wrap_create (fileo, nf_clobber, ncid)
  call wrap_put_att_text (ncid, nf_global, 'data_type', 'vocef_data')

! Define dimensions

  call wrap_def_dim (ncid, 'lon' , nlon, dimlon_id)
  call wrap_def_dim (ncid, 'lat' , nlat, dimlat_id)

! Define input file independent variables 

  name = 'lon'
  unit = 'degrees east'
  dim1_id(1) = dimlon_id
  call wrap_def_var (ncid,'lon', nf_float, 1, dim1_id, lon_id)
  call wrap_put_att_text (ncid, lon_id, 'long_name', name)
  call wrap_put_att_text (ncid, lon_id, 'units'    , unit)

  name = 'lat'
  unit = 'degrees north'
  dim1_id(1) = dimlat_id
  call wrap_def_var (ncid,'lat', nf_float, 1, dim1_id, lat_id)
  call wrap_put_att_text (ncid, lat_id, 'long_name', name)
  call wrap_put_att_text (ncid, lat_id, 'units'    , unit)

  name = 'longitude-2d'
  unit = 'degrees east'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LONGXY', nf_float, 2, dim2_id, longxy_id)
  call wrap_put_att_text (ncid, longxy_id, 'long_name', name)
  call wrap_put_att_text (ncid, longxy_id, 'units'    , unit)

  name = 'latitude-2d'
  unit = 'degrees north'
  dim2_id(1) = dimlon_id
  dim2_id(2) = dimlat_id
  call wrap_def_var (ncid, 'LATIXY', nf_float, 2, dim2_id, latixy_id)
  call wrap_put_att_text (ncid, latixy_id, 'long_name', name)
  call wrap_put_att_text (ncid, latixy_id, 'units'    , unit)

  name = 'northern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGEN', nf_float, 0, 0, edgen_id)
  call wrap_put_att_text (ncid, edgen_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgen_id, 'units'    , unit)

  name = 'eastern edge of surface grid'
  unit = 'degrees east'
  call wrap_def_var (ncid, 'EDGEE', nf_float, 0, 0, edgee_id)
  call wrap_put_att_text (ncid, edgee_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgee_id, 'units'    , unit)

  name = 'southern edge of surface grid'
  unit = 'degrees north'
  call wrap_def_var (ncid, 'EDGES', nf_float, 0, 0, edges_id)
  call wrap_put_att_text (ncid, edges_id, 'long_name', name)
  call wrap_put_att_text (ncid, edges_id, 'units'    , unit)

  name = 'western edge of surface grid'
  
  call wrap_def_var (ncid, 'EDGEW', nf_float, 0, 0, edgew_id)
  call wrap_put_att_text (ncid, edgew_id, 'long_name', name)
  call wrap_put_att_text (ncid, edgew_id, 'units'    , unit)

! Define input file specific variables

  name = 'broadleaf tree emission factor'
  unit = 'micrograms isoprene m-2 h-1'
  dim2_id(1) = lon_id
  dim2_id(2) = lat_id
  call wrap_def_var (ncid ,'ef_btr' ,nf_float, 2, dim2_id, ef_btr_id)
  call wrap_put_att_text (ncid, ef_btr_id, 'long_name', name)
  call wrap_put_att_text (ncid, ef_btr_id, 'units'    , unit)

  name = 'Fineleaf evergreen tree tree emission factor'
  unit = 'micrograms isoprene m-2 h-1'
  dim2_id(1) = lon_id
  dim2_id(2) = lat_id
  call wrap_def_var (ncid ,'ef_fet' ,nf_float, 2, dim2_id, ef_fet_id)
  call wrap_put_att_text (ncid, ef_fet_id, 'long_name', name)
  call wrap_put_att_text (ncid, ef_fet_id, 'units'    , unit)

  name = 'Fineleaf deciduous tree emission factor'
  unit = 'micrograms isoprene m-2 h-1'
  dim2_id(1) = lon_id
  dim2_id(2) = lat_id
  call wrap_def_var (ncid ,'ef_fdt' ,nf_float, 2, dim2_id, ef_fdt_id)
  call wrap_put_att_text (ncid, ef_fdt_id, 'long_name', name)
  call wrap_put_att_text (ncid, ef_fdt_id, 'units'    , unit)

  name = 'shrub tree emission factor'
  unit = 'micrograms isoprene m-2 h-1'
  dim2_id(1) = lon_id
  dim2_id(2) = lat_id
  call wrap_def_var (ncid ,'ef_shr' ,nf_float, 2, dim2_id, ef_shr_id)
  call wrap_put_att_text (ncid, ef_shr_id, 'long_name', name)
  call wrap_put_att_text (ncid, ef_shr_id, 'units'    , unit)

  name = 'grass, non-vascular plants and other ground cover emission factor'
  unit = 'micrograms isoprene m-2 h-1'
  dim2_id(1) = lon_id
  dim2_id(2) = lat_id
  call wrap_def_var (ncid ,'ef_grs' ,nf_float, 2, dim2_id, ef_grs_id)
  call wrap_put_att_text (ncid, ef_grs_id, 'long_name', name)
  call wrap_put_att_text (ncid, ef_grs_id, 'units'    , unit)

  name = 'crop emission factor'
  unit = 'micrograms isoprene m-2 h-1'
  dim2_id(1) = lon_id
  dim2_id(2) = lat_id
  call wrap_def_var (ncid ,'ef_crp' ,nf_float, 2, dim2_id, ef_crp_id)
  call wrap_put_att_text (ncid, ef_crp_id, 'long_name', name)
  call wrap_put_att_text (ncid, ef_crp_id, 'units'    , unit)

  name = 'land mask'
  unit = 'unitless'
  call wrap_def_var (ncid ,'LANDMASK' ,nf_float, 2, dim2_id, landmask_id)
  call wrap_put_att_text (ncid, landmask_id, 'long_name', name)
  call wrap_put_att_text (ncid, landmask_id, 'units'    , unit)

! End of definition

  status = nf_enddef(ncid)

! -----------------------------------------------------------------------
! set all emission factors to zero, i.e. this will set isoprene emissions 
! due to vegetation in model to zero. 
!
! don't add factors unless you are using atm chemistry and know what you
! are doing. thought needs to be put into how to define emissions factors for
! paleo. for present day reference, see default modern file... a starting
! place would be to develop an equivalence between modern definitions 
! and what you expect from your paleo world. 
! -----------------------------------------------------------------------

  ef_btr = 0.
  ef_fet = 0.
  ef_fdt = 0.
  ef_shr = 0.
  ef_grs = 0.
  ef_crp = 0.

! --------------------------------------------------------------------------
! Write variables
! --------------------------------------------------------------------------

  call wrap_put_var_realx (ncid, lon_id       , lon)
  call wrap_put_var_realx (ncid, lat_id       , lat)
  call wrap_put_var_realx (ncid, longxy_id    , longxy)
  call wrap_put_var_realx (ncid, latixy_id    , latixy)
  call wrap_put_var_realx (ncid, edgen_id     , edge(1))
  call wrap_put_var_realx (ncid, edgee_id     , edge(2))
  call wrap_put_var_realx (ncid, edges_id     , edge(3))
  call wrap_put_var_realx (ncid, edgew_id     , edge(4))
  call wrap_put_var_realx (ncid, landmask_id  , landmask)
  call wrap_put_var_realx (ncid, ef_btr_id, ef_btr)
  call wrap_put_var_realx (ncid, ef_fet_id, ef_fet)
  call wrap_put_var_realx (ncid, ef_fdt_id, ef_fdt)
  call wrap_put_var_realx (ncid, ef_shr_id, ef_shr)
  call wrap_put_var_realx (ncid, ef_grs_id, ef_grs)
  call wrap_put_var_realx (ncid, ef_crp_id, ef_crp)

! Close output file

  call wrap_close(ncid)


end subroutine create_mksrf_vocef



!================================================================================
!================================================================================

subroutine wrap_create (path, cmode, ncid)
  implicit none
  include 'netcdf.inc'
  integer, parameter :: r8 = selected_real_kind(12)
  character(len=*) path
  integer cmode, ncid, ret
  ret = nf_create (path, cmode, ncid)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_create

!===============================================================================

subroutine wrap_def_dim (nfid, dimname, len, dimid)
  implicit none
  include 'netcdf.inc'
  integer, parameter :: r8 = selected_real_kind(12)
  integer :: nfid, len, dimid
  character(len=*) :: dimname
  integer ret
  ret = nf_def_dim (nfid, dimname, len, dimid)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_def_dim

!===============================================================================

subroutine wrap_def_var (nfid, name, xtype, nvdims, vdims, varid)
  implicit none
  include 'netcdf.inc'
  integer, parameter :: r8 = selected_real_kind(12)
  integer :: nfid, xtype, nvdims, varid
  integer :: vdims(nvdims)
  character(len=*) :: name
  integer ret
  ret = nf_def_var (nfid, name, xtype, nvdims, vdims, varid)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_def_var

!===============================================================================

subroutine wrap_put_att_text (nfid, varid, attname, atttext)
  implicit none
  include 'netcdf.inc'
  integer, parameter :: r8 = selected_real_kind(12)
  integer :: nfid, varid
  character(len=*) :: attname, atttext
  integer :: ret, siz
  siz = len_trim(atttext)
  ret = nf_put_att_text (nfid, varid, attname, siz, atttext)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_put_att_text

!===============================================================================

subroutine wrap_put_var_realx (nfid, varid, arr)
  implicit none
  include 'netcdf.inc'
  integer, parameter :: r8 = selected_real_kind(12)
  integer :: nfid, varid
  real(r8) :: arr(*)
  integer :: ret
#ifdef CRAY
  ret = nf_put_var_real (nfid, varid, arr)
#else
  ret = nf_put_var_double (nfid, varid, arr)
#endif
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_put_var_realx

!===============================================================================

subroutine wrap_put_var_int (nfid, varid, arr)
  implicit none
  include 'netcdf.inc'
  integer, parameter :: r8 = selected_real_kind(12)
  integer :: nfid, varid
  integer :: arr(*)
  integer :: ret
  ret = nf_put_var_int (nfid, varid, arr)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_put_var_int

!===============================================================================

subroutine wrap_put_vara_realx (nfid, varid, start, count, arr)
  implicit none
  include 'netcdf.inc'
  integer, parameter :: r8 = selected_real_kind(12)
  integer :: nfid, varid
  integer :: start(*), count(*)
  real(r8) arr(*)
  integer ret
#ifdef CRAY
  ret = nf_put_vara_real (nfid, varid, start, count, arr)
#else
  ret = nf_put_vara_double (nfid, varid, start, count, arr)
#endif
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_put_vara_realx

  
!===============================================================================

subroutine wrap_close (ncid)
  implicit none
  include 'netcdf.inc'
  integer, parameter :: r8 = selected_real_kind(12)
  integer :: ncid
  integer :: ret
  ret = nf_close (ncid)
  if (ret.ne.NF_NOERR) then
     write(6,*)'WRAP_CLOSE: nf_close failed for id ',ncid
     call handle_error (ret)
  end if
end subroutine wrap_close

!===============================================================================

subroutine handle_error(ret)
  implicit none
  include 'netcdf.inc'
  integer :: ret
  if (ret .ne. nf_noerr) then
     write(6,*) 'NCDERR: ERROR: ',nf_strerror(ret)
     call abort
  endif
end subroutine handle_error

!==============================================================================

subroutine wrap_inq_varid (nfid, varname, varid)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  character*(*) varname

  integer ret

  ret = nf_inq_varid (nfid, varname, varid)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_inq_varid

!=============================================================================

subroutine wrap_get_var8 (nfid, varid, arr)
  implicit none
  include 'netcdf.inc'

  integer nfid, varid
  real*8 arr(*)

  integer ret

  ret = nf_get_var_double (nfid, varid, arr)
  if (ret.ne.NF_NOERR) call handle_error (ret)
end subroutine wrap_get_var8

!==============================================================================

   subroutine wrap_get_var_int (nfid, varid, arr)
   implicit none
   include 'netcdf.inc'

   integer, intent(in):: nfid
   integer, intent(in):: varid
   integer, intent(out):: arr(*)

   integer ret      ! NetCDF return code

   ret = nf_get_var_int (nfid, varid, arr)
   if (ret/=NF_NOERR) then
     write(6,*)'WRAP_GET_VAR_INT: error reading varid =', varid
     call handle_error (ret)
   end if
   end subroutine wrap_get_var_int

!=============================================================================

subroutine endrun
  implicit none
  include 'netcdf.inc'

  call abort
  stop 999
end subroutine endrun


!===============================================================================

!===============================================================================
! SVN $Id: shr_string_mod.F90 25247 2010-10-20 22:43:21Z tcraig $
! SVN $URL: https://svn-ccsm-models.cgd.ucar.edu/csm_share/trunk_tags/share3_101231/shr/shr_string_mod.F90 $
!===============================================================================
!===============================================================================
!BOP ===========================================================================
!
! !MODULE: shr_string_mod -- string and list methods
!
! !DESCRIPTION:
!    General string and specific list method.  A list is a single string
!    that is delimited by a character forming multiple fields, ie,
!    character(len=*) :: mylist = "t:s:u1:v1:u2:v2:taux:tauy"
!    The delimiter is called listDel in this module, is default ":",
!    but can be set by a call to shr_string_listSetDel.
!
! !REVISION HISTORY:
!     2005-Apr-28 - T. Craig - first version
!
! !INTERFACE: ------------------------------------------------------------------

module shr_string_mod

! !USES:

   use shr_kind_mod   ! F90 kinds
   use shr_sys_mod    ! shared system calls
   use shr_timer_mod, only : shr_timer_get, shr_timer_start, shr_timer_stop
   use shr_log_mod,   only : s_loglev  => shr_log_Level
   use shr_log_mod,   only : s_logunit => shr_log_Unit

   implicit none
   private

! !PUBLIC TYPES:

   ! no public types

! !PUBLIC MEMBER FUNCTIONS:

   public :: shr_string_countChar       ! Count number of char in string, fn
   public :: shr_string_toUpper         ! Convert string to upper-case
   public :: shr_string_toLower         ! Convert string to lower-case
   public :: shr_string_getParentDir    ! For a pathname get the parent directory name
   public :: shr_string_lastIndex       ! Index of last substr in str
   public :: shr_string_endIndex        ! Index of end of substr in str
   public :: shr_string_leftAlign       ! remove leading white space
   public :: shr_string_alphanum        ! remove all non alpha-numeric characters
   public :: shr_string_betweenTags     ! get the substring between the two tags
   public :: shr_string_parseCFtunit    ! parse CF time units
   public :: shr_string_clean           ! Set string to all white space

   public :: shr_string_listIsValid     ! test for a valid "list"
   public :: shr_string_listGetNum      ! Get number of fields in list, fn
   public :: shr_string_listGetIndex    ! Get index of field
   public :: shr_string_listGetIndexF   ! function version of listGetIndex
   public :: shr_string_listGetName     ! get k-th field name
   public :: shr_string_listIntersect   ! get intersection of two field lists
   public :: shr_string_listUnion       ! get union of two field lists
   public :: shr_string_listMerge       ! merge two lists to form third
   public :: shr_string_listAppend      ! append list at end of another
   public :: shr_string_listPrepend     ! prepend list in front of another
   public :: shr_string_listSetDel      ! Set field delimeter in lists
   public :: shr_string_listGetDel      ! Get field delimeter in lists

   public :: shr_string_setAbort        ! set local abort flag
   public :: shr_string_setDebug        ! set local debug flag

! !PUBLIC DATA MEMBERS:

   ! no public data members

!EOP

   character(len=1)    ,save :: listDel  = ":"    ! note single exec implications
   character(len=2)    ,save :: listDel2 = "::"   ! note single exec implications
   logical             ,save :: doabort  = .true.
   integer(SHR_KIND_IN),save :: debug    = 0

!===============================================================================
contains
!===============================================================================

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_countChar -- Count number of occurances of a character
!
! !DESCRIPTION:
!  count number of occurances of a single character in a string
!     \newline
!     n = shr\_string\_countChar(string,character)
!
! !REVISION HISTORY:
!     2005-Feb-28 - First version from dshr_bundle
!
! !INTERFACE: ------------------------------------------------------------------

integer function shr_string_countChar(str,char,rc)


   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)        ,intent(in)           :: str   ! string to search
   character(1)        ,intent(in)           :: char  ! char to search for
   integer(SHR_KIND_IN),intent(out),optional :: rc    ! return code

!EOP

   !----- local -----
   integer(SHR_KIND_IN) :: count    ! counts occurances of char
   integer(SHR_KIND_IN) :: n        ! generic index
   integer(SHR_KIND_IN) :: t01 = 0  ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_countChar) "
   character(*),parameter :: F00     = "('(shr_string_countChar) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   count = 0
   do n = 1, len_trim(str)
      if (str(n:n) == char) count = count + 1
   end do
   shr_string_countChar = count

   if (present(rc)) rc = 0

   if (debug>1) call shr_timer_stop (t01)

end function shr_string_countChar

!===============================================================================
!BOP ===========================================================================
! !IROUTINE: shr_string_toUpper -- Convert string to upper case
!
! !DESCRIPTION:
!     Convert the input string to upper-case.
!     Use achar and iachar intrinsics to ensure use of ascii collating sequence.
!
! !REVISION HISTORY:
!     2005-Dec-20 - Move CAM version over to shared code.
!
! !INTERFACE: ------------------------------------------------------------------

function shr_string_toUpper(str)

   implicit none

! !INPUT/OUTPUT PARAMETERS:
   character(len=*), intent(in) :: str      ! String to convert to upper case
   character(len=len(str))      :: shr_string_toUpper

   !----- local -----
   integer(SHR_KIND_IN) :: i             ! Index
   integer(SHR_KIND_IN) :: aseq          ! ascii collating sequence
   integer(SHR_KIND_IN) :: LowerToUpper  ! integer to convert case
   character(len=1)     :: ctmp          ! Character temporary
   integer(SHR_KIND_IN) :: t01 = 0       ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_toUpper) "
   character(*),parameter :: F00     = "('(shr_string_toUpper) ',4a)"

!-------------------------------------------------------------------------------
!
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   LowerToUpper = iachar("A") - iachar("a")

   do i = 1, len(str)
      ctmp = str(i:i)
      aseq = iachar(ctmp)
      if ( aseq >= iachar("a") .and. aseq <= iachar("z") ) &
           ctmp = achar(aseq + LowertoUpper)
      shr_string_toUpper(i:i) = ctmp
   end do

   if (debug>1) call shr_timer_stop (t01)

end function shr_string_toUpper

!===============================================================================
!BOP ===========================================================================
! !IROUTINE: shr_string_toLower -- Convert string to lower case
!
! !DESCRIPTION:
!     Convert the input string to lower-case.
!     Use achar and iachar intrinsics to ensure use of ascii collating sequence.
!
! !REVISION HISTORY:
!     2006-Apr-20 - Creation
!
! !INTERFACE: ------------------------------------------------------------------
function shr_string_toLower(str)

   implicit none

! !INPUT/OUTPUT PARAMETERS:
   character(len=*), intent(in) :: str      ! String to convert to lower case
   character(len=len(str))      :: shr_string_toLower

   !----- local -----
   integer(SHR_KIND_IN) :: i            ! Index
   integer(SHR_KIND_IN) :: aseq         ! ascii collating sequence
   integer(SHR_KIND_IN) :: UpperToLower ! integer to convert case
   character(len=1)     :: ctmp         ! Character temporary
   integer(SHR_KIND_IN) :: t01 = 0      ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_toLower) "
   character(*),parameter :: F00     = "('(shr_string_toLower) ',4a)"

!-------------------------------------------------------------------------------
!
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   UpperToLower = iachar("a") - iachar("A")

   do i = 1, len(str)
      ctmp = str(i:i)
      aseq = iachar(ctmp)
      if ( aseq >= iachar("A") .and. aseq <= iachar("Z") ) &
           ctmp = achar(aseq + UpperToLower)
      shr_string_toLower(i:i) = ctmp
   end do

   if (debug>1) call shr_timer_stop (t01)

end function shr_string_toLower

!===============================================================================
!BOP ===========================================================================
! !IROUTINE: shr_string_getParentDir -- For pathname get the parent directory name
!
! !DESCRIPTION:
!     Get the parent directory name for a pathname.
!
! !REVISION HISTORY:
!     2006-May-09 - Creation
!
! !INTERFACE: ------------------------------------------------------------------

function shr_string_getParentDir(str)

   implicit none

! !INPUT/OUTPUT PARAMETERS:
   character(len=*), intent(in) :: str      ! String to convert to lower case
   character(len=len(str))      :: shr_string_getParentDir

   !----- local -----
   integer(SHR_KIND_IN) :: i       ! Index
   integer(SHR_KIND_IN) :: nlen    ! Length of string
   integer(SHR_KIND_IN) :: t01 = 0 ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_getParentDir) "
   character(*),parameter :: F00     = "('(shr_string_getParentDir) ',4a)"

!-------------------------------------------------------------------------------
!
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   nlen = len_trim(str)
   if ( str(nlen:nlen) == "/" ) nlen = nlen - 1
   i = index( str(1:nlen), "/", back=.true. )
   if ( i == 0 )then
      shr_string_getParentDir = str
   else
      shr_string_getParentDir = str(1:i-1)
   end if
   
   if (debug>1) call shr_timer_stop (t01)

end function shr_string_getParentDir

!===============================================================================
!BOP ===========================================================================
!
!
! !IROUTINE: shr_string_lastIndex -- Get index of last substr within string
!
! !DESCRIPTION:
!  Get index of last substr within string
!     \newline
!     n = shr\_string\_lastIndex(string,substring)
!
! !REVISION HISTORY:
!     2005-Feb-28 - First version from dshr_domain
!
! !INTERFACE: ------------------------------------------------------------------

integer function shr_string_lastIndex(string,substr,rc)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)        ,intent(in)           :: string ! string to search
   character(*)        ,intent(in)           :: substr ! sub-string to search for
   integer(SHR_KIND_IN),intent(out),optional :: rc     ! return code

!EOP

   !--- local ---
   integer(SHR_KIND_IN) :: t01 = 0 ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_lastIndex) "
   character(*),parameter :: F00     = "('(shr_string_lastIndex) ',4a)"

!-------------------------------------------------------------------------------
! Note: 
! - "new" F90 back option to index function makes this home-grown solution obsolete
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   shr_string_lastIndex = index(string,substr,.true.)

   if (present(rc)) rc = 0

   if (debug>1) call shr_timer_stop (t01)

end function shr_string_lastIndex

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_endIndex -- Get the ending index of substr within string
!
! !DESCRIPTION:
!  Get the ending index of substr within string
!     \newline
!     n = shr\_string\_endIndex(string,substring)
!
! !REVISION HISTORY:
!     2005-May-10 - B. Kauffman, first version.
!
! !INTERFACE: ------------------------------------------------------------------

integer function shr_string_endIndex(string,substr,rc)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)        ,intent(in)           :: string ! string to search
   character(*)        ,intent(in)           :: substr ! sub-string to search for
   integer(SHR_KIND_IN),intent(out),optional :: rc     ! return code

!EOP

   !--- local ---
   integer(SHR_KIND_IN)   :: i       ! generic index
   integer(SHR_KIND_IN)       :: t01 = 0 ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_endIndex) "
   character(*),parameter :: F00     = "('(shr_string_endIndex) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
! * returns zero if substring not found, uses len_trim() intrinsic
! * very similar to: i = index(str,substr,back=.true.) 
! * do we need this function?
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   i = index(trim(string),trim(substr))
   if ( i == 0 ) then
      shr_string_endIndex = 0  ! substr is not in string
   else
      shr_string_endIndex = i + len_trim(substr) - 1
   end if

!  -------------------------------------------------------------------
!  i = index(trim(string),trim(substr),back=.true.)
!  if (i == len(string)+1) i = 0
!  shr_string_endIndex = i
!  -------------------------------------------------------------------

   if (present(rc)) rc = 0

   if (debug>1) call shr_timer_stop (t01)

end function shr_string_endIndex

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_leftAlign -- remove leading white space
!
! !DESCRIPTION:
!    Remove leading white space
!     \newline
!     call shr\_string\_leftAlign(string)
!
! !REVISION HISTORY:
!     2005-Apr-28 - B. Kauffman - First version
!
! !INTERFACE: ------------------------------------------------------------------

subroutine shr_string_leftAlign(str,rc)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)        ,intent(inout)          :: str
   integer(SHR_KIND_IN),intent(out)  ,optional :: rc   ! return code

!EOP

   !----- local ----
   integer(SHR_KIND_IN) :: rCode ! return code
   integer(SHR_KIND_IN) :: t01 = 0 ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_leftAlign) "
   character(*),parameter :: F00     = "('(shr_string_leftAlign) ',4a)"

!-------------------------------------------------------------------------------
! note: 
! * ?? this routine isn't needed, use the intrisic adjustL instead ??
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

!  -------------------------------------------------------------------
!  --- I used this until I discovered the intrinsic function below - BK
!  do while (len_trim(str) > 0 ) 
!     if (str(1:1) /= ' ') exit
!     str = str(2:len_trim(str))
!  end do
!  rCode = 0
!  !! (len_trim(str) == 0 ) rCode = 1  ! ?? appropriate ??
!  -------------------------------------------------------------------

   str = adjustL(str)
   if (present(rc)) rc = 0

   if (debug>1) call shr_timer_stop (t01)

end subroutine shr_string_leftAlign

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_alphanum -- remove non alpha numeric characters
!
! !DESCRIPTION:
!    Remove all non alpha numeric characters from string
!     \newline
!     call shr\_string\_alphanum(string)
!
! !REVISION HISTORY:
!     2005-Aug-01 - T. Craig - First version
!
! !INTERFACE: ------------------------------------------------------------------

subroutine shr_string_alphanum(str,rc)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)        ,intent(inout)          :: str
   integer(SHR_KIND_IN),intent(out)  ,optional :: rc   ! return code

!EOP

   !----- local ----
   integer(SHR_KIND_IN) :: rCode  ! return code
   integer(SHR_KIND_IN) :: n,icnt ! counters
   integer(SHR_KIND_IN) :: t01 = 0 ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_alphaNum) "
   character(*),parameter :: F00     = "('(shr_string_alphaNum) ',4a)"

!-------------------------------------------------------------------------------
!
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   icnt = 0
   do n=1,len_trim(str)
     if ((str(n:n) >= 'a' .and. str(n:n) <= 'z') .or.  &
         (str(n:n) >= 'A' .and. str(n:n) <= 'Z') .or.  &
         (str(n:n) >= '0' .and. str(n:n) <= '9')) then
       icnt = icnt + 1
       str(icnt:icnt) = str(n:n)
     endif
   enddo
   do n=icnt+1,len(str)
     str(n:n) = ' '
   enddo

   if (present(rc)) rc = 0

   if (debug>1) call shr_timer_stop (t01)

end subroutine shr_string_alphanum

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_betweenTags -- Get the substring between the two tags.
!
! !DESCRIPTION:
!    Get the substring found between the start and end tags.
!    \newline
!    call shr\_string\_betweenTags(string,startTag,endTag,substring,rc)
!
! !REVISION HISTORY:
!     2005-May-11 - B. Kauffman, first version
!
! !INTERFACE: ------------------------------------------------------------------

subroutine shr_string_betweenTags(string,startTag,endTag,substr,rc)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)        ,intent(in)  :: string      ! string to search
   character(*)        ,intent(in)  :: startTag    ! start tag
   character(*)        ,intent(in)  :: endTag      ! end tag
   character(*)        ,intent(out) :: substr      ! sub-string between tags
   integer(SHR_KIND_IN),intent(out),optional :: rc ! retrun code

!EOP

   !--- local ---
   integer(SHR_KIND_IN)   :: iStart  ! substring start index
   integer(SHR_KIND_IN)   :: iEnd    ! substring end   index
   integer(SHR_KIND_IN)   :: rCode   ! return code
   integer(SHR_KIND_IN)       :: t01 = 0 ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_betweenTags) "
   character(*),parameter :: F00     = "('(shr_string_betweenTags) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
! * assumes the leading/trailing white space is not part of start & end tags
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   iStart = shr_string_endIndex(string,trim(adjustL(startTag))) ! end of start tag
   iEnd   =               index(string,trim(adjustL(endTag  ))) ! start of end tag

   rCode = 0
   substr = ""

   if (iStart < 1) then
      if (s_loglev > 0) then
         write(s_logunit,F00) "ERROR: can't find start tag in string"
         write(s_logunit,F00) "ERROR: start tag = ",trim(startTag)
         write(s_logunit,F00) "ERROR: string    = ",trim(string)
      endif
      rCode = 1
   else if (iEnd < 1) then
      if (s_loglev > 0) then
         write(s_logunit,F00) "ERROR: can't find end tag in string"
         write(s_logunit,F00) "ERROR: end   tag = ",trim(  endTag)
         write(s_logunit,F00) "ERROR: string    = ",trim(string)
      endif
      rCode = 2
   else if ( iEnd <= iStart) then
      if (s_loglev > 0) then
         write(s_logunit,F00) "ERROR: start tag not before end tag"
         write(s_logunit,F00) "ERROR: start tag = ",trim(startTag)
         write(s_logunit,F00) "ERROR: end   tag = ",trim(  endTag)
         write(s_logunit,F00) "ERROR: string    = ",trim(string)
      endif
      rCode = 3
   else if ( iStart+1 == iEnd ) then
      substr = ""
      if (s_loglev > 0) write(s_logunit,F00) "WARNING: zero-length substring found in ",trim(string)
   else
      substr = string(iStart+1:iEnd-1)
      if (len_trim(substr) == 0 .and. s_loglev > 0) &
         & write(s_logunit,F00) "WARNING: white-space substring found in ",trim(string)
   end if

   if (present(rc)) rc = rCode

   if (debug>1) call shr_timer_stop (t01)

end subroutine shr_string_betweenTags

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_parseCFtunit -- Parse CF time unit
!
! !DESCRIPTION:
!  Parse CF time unit into a delta string name and a base time in yyyymmdd
!  and seconds (nearest integer actually).
!     \newline
!     call shr\_string\_parseCFtunit(string,substring)
!     \newline
!  Input string is like "days since 0001-06-15 15:20:45.5 -6:00"
!    - recognizes "days", "hours", "minutes", "seconds"
!    - must have at least yyyy-mm-dd, hh:mm:ss.s is optional
!    - expects a "since" in the string
!    - ignores time zone part
!
! !REVISION HISTORY:
!     2005-May-15 - T. Craig - first version
!
! !INTERFACE: ------------------------------------------------------------------

subroutine shr_string_parseCFtunit(string,unit,bdate,bsec,rc)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)        ,intent(in)           :: string ! string to search
   character(*)        ,intent(out)          :: unit   ! delta time unit
   integer(SHR_KIND_IN),intent(out)          :: bdate  ! base date yyyymmdd
   real(SHR_KIND_R8)   ,intent(out)          :: bsec   ! base seconds
   integer(SHR_KIND_IN),intent(out),optional :: rc     ! return code

!EOP

   !--- local ---
   integer(SHR_KIND_IN)   :: i,i1,i2          ! generic index
   character(SHR_KIND_CL) :: tbase            ! baseline time
   character(SHR_KIND_CL) :: lstr             ! local string
   integer(SHR_KIND_IN)   :: yr,mo,da,hr,min  ! time stuff
   real(SHR_KIND_R8)      :: sec              ! time stuff
   integer(SHR_KIND_IN) :: t01 = 0 ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_parseCFtunit) "
   character(*),parameter :: F00     = "('(shr_string_parseCFtunit) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
! o assume length of CF-1.0 time attribute char string  < SHR_KIND_CL
!   This is a reasonable assumption.
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   unit = 'none'
   bdate = 0
   bsec = 0.0_SHR_KIND_R8

   i = shr_string_lastIndex(string,'days ')
   if (i > 0) unit = 'days'
   i = shr_string_lastIndex(string,'hours ')
   if (i > 0) unit = 'hours'
   i = shr_string_lastIndex(string,'minutes ')
   if (i > 0) unit = 'minutes'
   i = shr_string_lastIndex(string,'seconds ')
   if (i > 0) unit = 'seconds'

   if (trim(unit) == 'none') then
     write(s_logunit,F00) ' ERROR time unit unknown'
     call shr_string_abort(subName//' time unit unknown')
   endif

   i = shr_string_lastIndex(string,' since ')
   if (i < 1) then
     write(s_logunit,F00) ' ERROR since does not appear in unit attribute for time '
     call shr_string_abort(subName//' no since in attr name')
   endif
   tbase = trim(string(i+6:))
   call shr_string_leftAlign(tbase)

   if (debug > 0 .and. s_logunit > 0) then
     write(s_logunit,*) trim(subName)//' '//'unit '//trim(unit)
     write(s_logunit,*) trim(subName)//' '//'tbase '//trim(tbase)
   endif

   yr=0; mo=0; da=0; hr=0; min=0; sec=0
   i1 = 1

   i2 = index(tbase,'-') - 1
   lstr = tbase(i1:i2)
   read(lstr,*,ERR=200,END=200) yr
   tbase = tbase(i2+2:)
   call shr_string_leftAlign(tbase)

   i2 = index(tbase,'-') - 1
   lstr = tbase(i1:i2)
   read(lstr,*,ERR=200,END=200) mo
   tbase = tbase(i2+2:)
   call shr_string_leftAlign(tbase)

   i2 = index(tbase,' ') - 1
   lstr = tbase(i1:i2)
   read(lstr,*,ERR=200,END=200) da
   tbase = tbase(i2+2:)
   call shr_string_leftAlign(tbase)

   i2 = index(tbase,':') - 1
   lstr = tbase(i1:i2)
   read(lstr,*,ERR=200,END=100) hr
   tbase = tbase(i2+2:)
   call shr_string_leftAlign(tbase)

   i2 = index(tbase,':') - 1
   lstr = tbase(i1:i2)
   read(lstr,*,ERR=200,END=100) min
   tbase = tbase(i2+2:)
   call shr_string_leftAlign(tbase)

   i2 = index(tbase,' ') - 1
   lstr = tbase(i1:i2)
   read(lstr,*,ERR=200,END=100) sec

100  continue

   if (debug > 0 .and. s_loglev > 0) write(s_logunit,*) trim(subName),'ymdhms:',yr,mo,da,hr,min,sec

   bdate = abs(yr)*10000 + mo*100 + da
   if (yr < 0) bdate = -bdate
   bsec = real(hr*3600 + min*60,SHR_KIND_R8) + sec

   if (present(rc)) rc = 0

   if (debug>1) call shr_timer_stop (t01)
   return

200  continue
   write(s_logunit,F00) 'ERROR 200 on char num read '
   call shr_string_abort(subName//' ERROR on char num read')
   if (debug>1) call shr_timer_stop (t01)
   return

end subroutine shr_string_parseCFtunit

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_clean -- Clean a string, set it to "blank"
!
! !DESCRIPTION:
!     Clean a string, set it to blank
!     \newline
!     call shr\_string\_clean(string,rc)
!
! !REVISION HISTORY:
!     2005-May-05 - T. Craig
!
! !INTERFACE: ------------------------------------------------------------------

subroutine shr_string_clean(string,rc)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)                 ,intent(inout) :: string  ! list/string
   integer(SHR_KIND_IN),optional,intent(out)   :: rc      ! return code

!EOP

   !----- local -----
   integer(SHR_KIND_IN)   :: n       ! counter
   integer(SHR_KIND_IN)   :: rCode   ! return code
   integer(SHR_KIND_IN) :: t01 = 0 ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_clean) "
   character(*),parameter :: F00     = "('(shr_string_clean) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   rCode = 0
   string = '       '
   if (present(rc)) rc = rCode
   if (debug>1) call shr_timer_stop (t01)

end subroutine shr_string_clean

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_listIsValid -- determine whether string is a valid list
!
! !DESCRIPTION:
!     Determine whether string is a valid list
!     \newline
!     logical_var = shr\_string\_listIsValid(list,rc)
!
! !REVISION HISTORY:
!     2005-May-05 - B. Kauffman
!
! !INTERFACE: ------------------------------------------------------------------

logical function shr_string_listIsValid(list,rc)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)                 ,intent(in)  :: list    ! list/string
   integer(SHR_KIND_IN),optional,intent(out) :: rc      ! return code

!EOP

   !----- local -----
   integer  (SHR_KIND_IN) :: nChar   ! lenth of list
   integer  (SHR_KIND_IN) :: rCode   ! return code
   integer  (SHR_KIND_IN) :: t01 = 0 ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_listIsValid) "
   character(*),parameter :: F00     = "('(shr_string_listIsValid) ',4a)"

!-------------------------------------------------------------------------------
! check that the list conforms to the list format
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   rCode = 0
   shr_string_listIsValid = .true.

   nChar = len_trim(list)
   if (nChar < 1) then                           ! list is an empty string
      rCode = 1
   else if (    list(1:1)     == listDel  ) then ! first char is delimiter
      rCode = 2 
   else if (list(nChar:nChar) == listDel  ) then ! last  char is delimiter
      rCode = 3
   else if (index(trim(list)," " )     > 0) then ! white-space in a field name
      rCode = 4
   else if (index(trim(list),listDel2) > 0) then ! found zero length field
      rCode = 5
   end if
   
   if (rCode /= 0) then
      shr_string_listIsValid = .false.
      if (s_loglev > 0) write(s_logunit,F00) "WARNING: invalid list = ",trim(list)
   endif

   if (present(rc)) rc = rCode
   if (debug>1) call shr_timer_stop (t01)

end function shr_string_listIsValid

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_listGetName -- Get name of k-th field in list
!
! !DESCRIPTION:
!     Get name of k-th field in list
!     \newline
!     call shr\_string\_listGetName(list,k,name,rc)
!
! !REVISION HISTORY:
!     2005-May-05 - B. Kauffman
!
! !INTERFACE: ------------------------------------------------------------------

subroutine shr_string_listGetName(list,k,name,rc)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)                 ,intent(in)  :: list    ! list/string
   integer(SHR_KIND_IN)         ,intent(in)  :: k       ! index of field
   character(*)                 ,intent(out) :: name    ! k-th name in list
   integer(SHR_KIND_IN),optional,intent(out) :: rc      ! return code

!EOP

   !----- local -----
   integer(SHR_KIND_IN)   :: i,j,n   ! generic indecies
   integer(SHR_KIND_IN)   :: kFlds   ! number of fields in list
   integer(SHR_KIND_IN)   :: i0,i1   ! name = list(i0:i1)
   integer(SHR_KIND_IN)   :: rCode   ! return code
   integer(SHR_KIND_IN)   :: t01 = 0 ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_listGetName) "
   character(*),parameter :: F00     = "('(shr_string_listGetName) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   rCode = 0

   !--- check that this is a valid list ---
   if (.not. shr_string_listIsValid(list,rCode) ) then
      write(s_logunit,F00) "ERROR: invalid list = ",trim(list)
      call shr_string_abort(subName//" ERROR: invalid list = "//trim(list))
   end if

   !--- check that this is a valid index ---
   kFlds = shr_string_listGetNum(list)
   if (k<1 .or. kFlds<k) then
      write(s_logunit,*) subName,"ERROR: invalid index = ",k
      write(s_logunit,*) subName,"ERROR:          list = ",trim(list)
      call shr_string_abort(subName//" ERROR: invalid index")
   end if

   !--- start with whole list, then remove fields before and after desired field ---
   i0 = 1
   i1 = len_trim(list)

   !--- remove field names before desired field ---
   do n=2,k
      i = index(list(i0:i1),listDel)
      i0 = i0 + i
   end do

   !--- remove field names after desired field ---
   if ( k < kFlds ) then
      i = index(list(i0:i1),listDel)
      i1 = i0 + i - 2
   end if

   !--- copy result into output variable ---
   name = list(i0:i1)//"   "

   if (present(rc)) rc = rCode
   if (debug>1) call shr_timer_stop (t01)

end subroutine shr_string_listGetName

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_listIntersect -- Get intersection of two field lists
!
! !DESCRIPTION:
!     Get intersection of two fields lists, write into third list
!     \newline
!     call shr\_string\_listIntersect(list1,list2,listout)
!
! !REVISION HISTORY:
!     2005-May-05 - T. Craig
!
! !INTERFACE: ------------------------------------------------------------------

subroutine shr_string_listIntersect(list1,list2,listout,rc)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)                 ,intent(in)  :: list1   ! list/string
   character(*)                 ,intent(in)  :: list2   ! list/string
   character(*)                 ,intent(out) :: listout ! list/string
   integer(SHR_KIND_IN),optional,intent(out) :: rc      ! return code

!EOP

   !----- local -----
   integer(SHR_KIND_IN)   :: nf,n1,n2 ! counters
   character(SHR_KIND_CS) :: name     ! field name
   integer(SHR_KIND_IN)   :: rCode    ! return code
   integer(SHR_KIND_IN)   :: t01 = 0  ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_listIntersect) "
   character(*),parameter :: F00     = "('(shr_string_listIntersect) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   rCode = 0

   nf = shr_string_listGetNum(list1)
   call shr_string_clean(listout)
   do n1 = 1,nf
     call shr_string_listGetName(list1,n1,name,rCode)
     n2 = shr_string_listGetIndexF(list2,name)
     if (n2 > 0) then
       call shr_string_listAppend(listout,name)
     endif
   enddo

   if (present(rc)) rc = rCode
   if (debug>1) call shr_timer_stop (t01)

end subroutine shr_string_listIntersect

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_listUnion -- Get union of two field lists
!
! !DESCRIPTION:
!     Get union of two fields lists, write into third list
!     \newline
!     call shr\_string\_listUnion(list1,list2,listout)
!
! !REVISION HISTORY:
!     2005-May-05 - T. Craig
!
! !INTERFACE: ------------------------------------------------------------------

subroutine shr_string_listUnion(list1,list2,listout,rc)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)                 ,intent(in)  :: list1   ! list/string
   character(*)                 ,intent(in)  :: list2   ! list/string
   character(*)                 ,intent(out) :: listout ! list/string
   integer(SHR_KIND_IN),optional,intent(out) :: rc      ! return code

!EOP

   !----- local -----
   integer(SHR_KIND_IN)   :: nf,n1,n2 ! counters
   character(SHR_KIND_CS) :: name     ! field name
   integer(SHR_KIND_IN)   :: rCode    ! return code
   integer(SHR_KIND_IN) :: t01 = 0 ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_listUnion) "
   character(*),parameter :: F00     = "('(shr_string_listUnion) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)
   rCode = 0

   call shr_string_clean(listout)

   nf = shr_string_listGetNum(list1)
   do n1 = 1,nf
     call shr_string_listGetName(list1,n1,name,rCode)
     n2 = shr_string_listGetIndexF(listout,name)
     if (n2 < 1) then
       call shr_string_listAppend(listout,name)
     endif
   enddo

   nf = shr_string_listGetNum(list2)
   do n1 = 1,nf
     call shr_string_listGetName(list2,n1,name,rCode)
     n2 = shr_string_listGetIndexF(listout,name)
     if (n2 < 1) then
       call shr_string_listAppend(listout,name)
     endif
   enddo

   if (present(rc)) rc = rCode
   if (debug>1) call shr_timer_stop (t01)

end subroutine shr_string_listUnion

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_listMerge -- Merge lists two list to third
!
! !DESCRIPTION:
!     Merge two list to third
!     \newline
!     call shr\_string\_listMerge(list1,list2,listout)
!     call shr\_string\_listMerge(list1,list2,list1)
!
! !REVISION HISTORY:
!     2005-May-05 - T. Craig
!
! !INTERFACE: ------------------------------------------------------------------

subroutine shr_string_listMerge(list1,list2,listout,rc)

   implicit none
! !INPUT/OUTPUT PARAMETERS:

   character(*)                 ,intent(in)  :: list1   ! list/string
   character(*)                 ,intent(in)  :: list2   ! list/string
   character(*)                 ,intent(out) :: listout ! list/string
   integer(SHR_KIND_IN),optional,intent(out) :: rc      ! return code

!EOP

   !----- local -----
   character(SHR_KIND_CX) :: l1,l2   ! local char strings
   integer(SHR_KIND_IN)   :: rCode   ! return code
   integer(SHR_KIND_IN)   :: t01 = 0 ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_listMerge) "
   character(*),parameter :: F00     = "('(shr_string_listMerge) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
! - no input or output string should be longer than SHR_KIND_CX
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)
   rCode = 0

   !--- make sure temp strings are large enough ---
   if ( (len(l1) < len_trim(list1)) .or. (len(l2) < len_trim(list2))) then
      call shr_string_abort(subName//'ERROR: temp string not large enough')
   end if

   call shr_string_clean(l1)
   call shr_string_clean(l2)
   call shr_string_clean(listout)
   l1 = trim(list1)
   l2 = trim(list2)
   call shr_string_leftAlign(l1,rCode)
   call shr_string_leftAlign(l2,rCode)
   if (len_trim(l1)+len_trim(l2)+1 > len(listout)) &
      call shr_string_abort(subName//'ERROR: output list string not large enough')
   if (len_trim(l1) == 0) then
     listout = trim(l2)
   else
     listout = trim(l1)//":"//trim(l2)
   endif

   if (present(rc)) rc = rCode
   if (debug>1) call shr_timer_stop (t01)

end subroutine shr_string_listMerge

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_listAppend -- Append one list to another
!
! !DESCRIPTION:
!     Append one list to another
!     \newline
!     call shr\_string\_listAppend(list,listadd)
!
! !REVISION HISTORY:
!     2005-May-05 - T. Craig
!
! !INTERFACE: ------------------------------------------------------------------

subroutine shr_string_listAppend(list,listadd,rc)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)                 ,intent(inout) :: list   ! list/string
   character(*)                 ,intent(in)    :: listadd ! list/string
   integer(SHR_KIND_IN),optional,intent(out)   :: rc      ! return code

!EOP

   !----- local -----
   character(SHR_KIND_CX) :: l1      ! local string
   integer(SHR_KIND_IN)   :: rCode   ! return code
   integer(SHR_KIND_IN)   :: t01 = 0 ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_listAppend) "
   character(*),parameter :: F00     = "('(shr_string_listAppend) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
! - no input or output string should be longer than SHR_KIND_CX
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)
   rCode = 0

   !--- make sure temp string is large enough ---
   if (len(l1) < len_trim(listAdd)) then
      call shr_string_abort(subName//'ERROR: temp string not large enough')
   end if

   call shr_string_clean(l1)
   l1 = trim(listadd)
   call shr_string_leftAlign(l1,rCode)
   if (len_trim(list)+len_trim(l1)+1 > len(list)) &
      call shr_string_abort(subName//'ERROR: output list string not large enough')
   if (len_trim(list) == 0) then
     list = trim(l1)
   else
     list = trim(list)//":"//trim(l1)
   endif

   if (present(rc)) rc = rCode
   if (debug>1) call shr_timer_stop (t01)

end subroutine shr_string_listAppend

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_listPrepend -- Prepend one list to another
!
! !DESCRIPTION:
!     Prepend one list to another
!     \newline
!     call shr\_string\_listPrepend(listadd,list)
!     \newline
!     results in listadd:list
!
! !REVISION HISTORY:
!     2005-May-05 - T. Craig
!
! !INTERFACE: ------------------------------------------------------------------

subroutine shr_string_listPrepend(listadd,list,rc)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)                 ,intent(in)    :: listadd ! list/string
   character(*)                 ,intent(inout) :: list   ! list/string
   integer(SHR_KIND_IN),optional,intent(out)   :: rc      ! return code

!EOP

   !----- local -----
   character(SHR_KIND_CX) :: l1      ! local string
   integer(SHR_KIND_IN)   :: rCode   ! return code
   integer(SHR_KIND_IN)   :: t01 = 0 ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_listPrepend) "
   character(*),parameter :: F00     = "('(shr_string_listPrepend) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
! - no input or output string should be longer than SHR_KIND_CX
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)
   rCode = 0

   !--- make sure temp string is large enough ---
   if (len(l1) < len_trim(listAdd)) then
      call shr_string_abort(subName//'ERROR: temp string not large enough')
   end if

   call shr_string_clean(l1)
   l1 = trim(listadd)
   call shr_string_leftAlign(l1,rCode)
   call shr_string_leftAlign(list,rCode)
   if (len_trim(list)+len_trim(l1)+1 > len(list)) &
      call shr_string_abort(subName//'ERROR: output list string not large enough')
   if (len_trim(l1) == 0) then
     list = trim(list)
   else
     list = trim(l1)//":"//trim(list)
   endif

   if (present(rc)) rc = rCode
   if (debug>1) call shr_timer_stop (t01)

end subroutine shr_string_listPrepend

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_listGetIndexF -- Get index of field in string
!
! !DESCRIPTION:
!     Get index of field in string
!     \newline
!     k = shr\_string\_listGetIndex(str,"taux")
!
! !REVISION HISTORY:
!     2005-Feb-28 - B. Kauffman and J. Schramm - first version
!
! !INTERFACE: ------------------------------------------------------------------

integer function shr_string_listGetIndexF(string,fldStr)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*),intent(in) :: string   ! string
   character(*),intent(in) :: fldStr   ! name of field

!EOP

   !----- local -----
   integer(SHR_KIND_IN)    :: k        ! local index variable
   integer(SHR_KIND_IN)    :: rc       ! error code
   integer(SHR_KIND_IN) :: t01 = 0 ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_listGetIndexF) "
   character(*),parameter :: F00     = "('(shr_string_listGetIndexF) ',4a)"

!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   call shr_string_listGetIndex(string,fldStr,k,print=.false.,rc=rc)
   shr_string_listGetIndexF = k

   if (debug>1) call shr_timer_stop (t01)

end function shr_string_listGetIndexF

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_listGetIndex -- Get index of field in string
!
! !DESCRIPTION:
!     Get index of field in string
!     \newline
!     call shr\_string\_listGetIndex(str,"taux",k,rc)
!
! !REVISION HISTORY:
!     2005-Feb-28 - B. Kauffman and J. Schramm - first version
!
! !INTERFACE: ------------------------------------------------------------------

subroutine shr_string_listGetIndex(string,fldStr,kFld,print,rc)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*)        ,intent(in)           :: string  ! string
   character(*)        ,intent(in)           :: fldStr  ! name of field
   integer(SHR_KIND_IN),intent(out)          :: kFld    ! index of field
   logical             ,intent(in) ,optional :: print   ! print switch
   integer(SHR_KIND_IN),intent(out),optional :: rc      ! return code

!EOP

   !----- local -----
   integer(SHR_KIND_IN)   :: n                ! index for colon position
   integer(SHR_KIND_IN)   :: k                ! index for field name position
   integer(SHR_KIND_IN)   :: nFields          ! number of fields in a string
   integer(SHR_KIND_IN)   :: i0,i1            ! fldStr == string(i0,i1) ??
   integer(SHR_KIND_IN)   :: j0,j1            ! fldStr == string(j0,j1) ??
   logical                :: found            ! T => field found in fieldNames
   logical                :: lprint           ! local print flag
   integer(SHR_KIND_IN)   :: t01 = 0          ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_listGetIndex) "
   character(*),parameter :: F00     = "('(shr_string_listGetIndex) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
! - searching from both ends of the list at the same time seems to be 20% faster
!   but I'm not sure why (B. Kauffman, Feb 2007)
! - I commented out sanity check to a little gain speed (B. Kauffman, Mar 2007)
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)
   if (present(rc)) rc = 0

   lprint = .false.
   if (present(print)) lprint = print

   !--- confirm proper size of input data ---
   if (len_trim(fldStr) < 1) then
      if (lprint) write(s_logunit,F00) "ERROR: input field name has 0 length"
      call shr_string_abort(subName//"invalid field name")
   end if

   !--- search for field name in string's list of fields ---
   found   = .false.
   kFld    = 0
   i0      =  1  ! ?? fldStr == string(i0:i1) ??
   i1      = -1
   j0      = -1  ! ?? fldStr == string(j0:j1) ??
   j1      =  len_trim(string)
   nFields = shr_string_listGetNum(string)
   do k = 1,nFields
      !--------------------------------------------------------
      ! search from end of list to end of list
      !--------------------------------------------------------
      !--- get end index of of field number k ---
      n = index(string(i0:len_trim(string)),listDel)
      if (n > 0) then   
         i1 = i0 + n - 2       ! *not*  the  last field name in fieldNames
      else               
         i1 = len_trim(string) ! this is the last field name in fieldNames
      endif
      !--- sanity check ---
   !  if ((k <nFields .and. n<1) .or. (k==nFields .and. n>0)) then
   !     call shr_string_abort(subName//"ERROR: wrong string%nf ?")
   !  end if
      !--- is it a match? ---
      if (trim(fldStr) == string(i0:i1)) then
         found = .true.
         kFld = k
         exit
      endif
      i0 = i1 + 2 ! start index for next iteration
      !--------------------------------------------------------
      ! search from end of list to start of list
      !--------------------------------------------------------
      !--- get start index of field number (nFields + 1 - k ) ---
      n = index(string(1:j1),listDel,back=.true.)
      j0 = n + 1 ! n==0 => the first field name in fieldNames
      !--- sanity check ---
   !  if ((k <nFields .and. n<1) .or. (k==nFields .and. n>0)) then
   !     call shr_string_abort(subName//"ERROR: wrong string%nf ?")
   !  end if
      !--- is it a match? ---
      if (trim(fldStr) == string(j0:j1)) then
         found = .true.
         kFld = nFields + 1 - k
         exit
      endif
      j1 = j0 - 2 ! end index for next iteration
      !--------------------------------------------------------
      ! exit if all field names have been checked
      !--------------------------------------------------------
      if (2*k >= nFields) exit
   end do

   !--- not finding a field is not a fatal error ---
   if (.not. found) then
      kFld = 0
      if (lprint .and. s_loglev > 0) write(s_logunit,F00) "FYI: field ",trim(fldStr)," not found in list ",trim(string)
      if (present(rc)) rc = 1
   end if

   if (debug>1) call shr_timer_stop (t01)

end subroutine shr_string_listGetIndex

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_listGetNum -- get number of fields in a string list
!
! !DESCRIPTION:
!  return number of fields in string list
!
! !REVISION HISTORY:
!     2005-Apr-28 - T. Craig - First version
!
! !INTERFACE: ------------------------------------------------------------------

integer function shr_string_listGetNum(str)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*),intent(in) :: str   ! string to search

!EOP

   !----- local -----
   integer(SHR_KIND_IN) :: count    ! counts occurances of char
   integer(SHR_KIND_IN) :: t01 = 0 ! timer

   !----- formats -----
   character(*),parameter :: subName =   "(shr_string_listGetNum) "
   character(*),parameter :: F00     = "('(shr_string_listGetNum) ',4a)"

!-------------------------------------------------------------------------------
! Notes:
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   shr_string_listGetNum = 0

   if (len_trim(str) > 0) then
      count = shr_string_countChar(str,listDel)
      shr_string_listGetNum = count + 1
   endif

   if (debug>1) call shr_timer_stop (t01)

end function shr_string_listGetNum

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_listSetDel -- Set list delimeter character
!
! !DESCRIPTION:
!     Set field delimeter character in lists
!     \newline
!     call shr\_string\_listSetDel(":")
!
! !REVISION HISTORY:
!     2005-Apr-30  - T. Craig - first prototype
!
! !INTERFACE: ------------------------------------------------------------------

subroutine shr_string_listSetDel(cflag)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(len=1),intent(in) :: cflag

!EOP

   integer(SHR_KIND_IN) :: t01 = 0 ! timer

   !--- formats ---
   character(*),parameter :: subName =   "(shr_string_listSetDel) "
   character(*),parameter :: F00     = "('(shr_string_listSetDel) ',a) "

!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   if (debug > 0 .and. s_loglev > 0) write(s_logunit,F00) 'changing listDel from '//trim(listDel)//' to '//trim(cflag)
   listDel = trim(cflag)
   listDel2 = listDel//listDel

   if (debug>1) call shr_timer_stop (t01)

end subroutine shr_string_listSetDel

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_listGetDel -- Get list delimeter character
!
! !DESCRIPTION:
!     Get field delimeter character in lists
!     \newline
!     call shr\_string\_listGetDel(del)
!
! !REVISION HISTORY:
!     2005-May-15  - T. Craig - first prototype
!
! !INTERFACE: ------------------------------------------------------------------

subroutine shr_string_listGetDel(del)

  implicit none

! !INPUT/OUTPUT PARAMETERS:

  character(*),intent(out) :: del

!EOP

   integer(SHR_KIND_IN) :: t01 = 0 ! timer

   !--- formats ---
   character(*),parameter :: subName =   "(shr_string_listGetDel) "
   character(*),parameter :: F00     = "('(shr_string_listGetDel) ',a) "

!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   del = trim(listDel)

   if (debug>1) call shr_timer_stop (t01)

end subroutine shr_string_listGetDel

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_setAbort -- Set local shr_string abort flag
!
! !DESCRIPTION:
!     Set local shr_string abort flag, true = abort, false = print and continue
!     \newline
!     call shr\_string\_setAbort(.false.)
!
! !REVISION HISTORY:
!     2005-Apr-30  - T. Craig - first prototype
!
! !INTERFACE: ------------------------------------------------------------------

subroutine shr_string_setAbort(flag)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

  logical,intent(in) :: flag

!EOP

   integer(SHR_KIND_IN) :: t01 = 0 ! timer

   !--- formats ---
   character(*),parameter :: subName =   "(shr_string_setAbort) "
   character(*),parameter :: F00     = "('(shr_string_setAbort) ',a) "

!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   if (debug > 0 .and. s_loglev > 0) then
      if (flag) then
         write(s_logunit,F00) 'setting abort to true'
      else
         write(s_logunit,F00) 'setting abort to false'
      endif
   endif

   doabort = flag

   if (debug>1) call shr_timer_stop (t01)

end subroutine shr_string_setAbort

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_string_setDebug -- Set local shr_string debug level
!
! !DESCRIPTION:
!     Set local shr_string debug level, 0 = production
!     \newline
!     call shr\_string\_setDebug(2)
!
! !REVISION HISTORY:
!     2005-Apr-30  - T. Craig - first prototype
!
! !INTERFACE: ------------------------------------------------------------------

subroutine shr_string_setDebug(iFlag)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   integer(SHR_KIND_IN),intent(in) :: iFlag ! requested debug level

!EOP

   !--- local ---
   integer(SHR_KIND_IN) :: t01 = 0 ! timer

   !--- formats ---
   character(*),parameter :: subName =   "(shr_string_setDebug) "
   character(*),parameter :: F00     = "('(shr_string_setDebug) ',a) "
   character(*),parameter :: F01     = "('(shr_string_setDebug) ',a,i3,a,i3) "

!-------------------------------------------------------------------------------
! NTOE: write statement can be expensive if called many times.
!-------------------------------------------------------------------------------

   if (iFlag>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (iFlag>1) call shr_timer_start(t01)

!   if (s_loglev > 0) write(s_logunit,F01) 'changing debug level from ',debug,' to ',iflag
   debug = iFlag

   if (iFlag>1) call shr_timer_stop (t01)

end subroutine shr_string_setDebug

!===============================================================================
!===============================================================================

subroutine shr_string_abort(string)

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   character(*),optional,intent(in) :: string

!EOP

   integer(SHR_KIND_IN)  :: t01 = 0 ! timer

   !--- local ---
   character(SHR_KIND_CX) :: lstring
   character(*),parameter :: subName =   "(shr_string_abort)"
   character(*),parameter :: F00     = "('(shr_string_abort) ',a)"

!-------------------------------------------------------------------------------
! NOTE:
! - no input or output string should be longer than SHR_KIND_CX
!-------------------------------------------------------------------------------

   if (debug>1 .and. t01<1) call shr_timer_get(t01,subName)
   if (debug>1) call shr_timer_start(t01)

   lstring = ''
   if (present(string)) lstring = string

   if (doabort) then
      call shr_sys_abort(trim(lstring))
   else
      write(s_logunit,F00) ' no abort:'//trim(lstring)
   endif

   if (debug>1) call shr_timer_stop (t01)

end subroutine shr_string_abort

!===============================================================================
!===============================================================================

end module shr_string_mod

subroutine inimland (plon, nlat, nlon_reduced, mlatcnts, mloncnts, topofile, &
                     verbose, make_ross, landm_reduced) 
  use shr_kind_mod, only: r8 => shr_kind_r8

  implicit none
!
! Input arguments
!
  integer , intent(in) :: plon                ! number of longitudes
  integer , intent(in) :: nlat                ! number of latitudes
  integer , intent(in) :: nlon_reduced(nlat)  ! number of reduced latitudes
  real(r8), intent(in) :: mlatcnts(nlat)      ! latitude at center of grid cell
  real(r8), intent(in) :: mloncnts(plon,nlat) ! model cell ceneter longitudes
  character(len=*), intent(in) :: topofile    ! high res topo file
  logical, intent(in) :: verbose              ! verbose output  
  logical, intent(in) :: make_ross            ! flag to make Ross ice shelf
!
! Output arguments
!
  real(r8), intent(out) :: landm_reduced(plon,nlat) ! landm on reduced grid

! Local variables

  real(r8) landm(plon,nlat)       ! landm on full grid
  real(r8) clon(plon)
  real(r8) clon_reduced(plon,nlat)
  real(r8) cont(plon,nlat)
  real(r8) temp(plon,nlat)
  real(r8) dmax
  real(r8) arad
  real(r8) dist
  real(r8) sum
  real(r8) cs(nlat)
  real(r8) ss(nlat)
  real(r8) c1
  real(r8) s1
  real(r8) c2
  real(r8) s2
  real(r8) dx
  real(r8) dy
  real(r8) term
  real(r8) pi
  real(r8) sgh(plon,nlat)    ! required by SGHPHIS (unused locally)
  real(r8) phis(plon,nlat)   ! required by SGHPHIS (unused locally)
  real(r8) oro(plon,nlat)    ! land/ocean flag 
  real(r8) fland(plon,nlat)  ! land fraction output from SGHPHIS
  real(r8) mloncnts_full(plon,nlat) ! longitudes for rectangular grid

  integer i
  integer j
  integer ii
  integer jj
  integer iplm1
  integer jof
  integer iof
  integer itmp
  integer jmin, jmax
  integer nlon(nlat)
  integer latid

  pi = acos(-1.d0)
!
! Define longitudes for a rectangular grid: index nlat/2+1 will be a latitude
! closest to the equator, i.e. with the most points in a reduced grid.
!
  nlon(:) = plon
  do j=1,nlat
    mloncnts_full(:,j) = mloncnts(:,nlat/2+1)
  end do

  call sghphis (plon, nlat, nlon, mlatcnts, mloncnts_full, topofile, &
                verbose, sgh, phis, fland)
!
! Define land mask.  Set all non-land points to ocean (i.e. not sea ice).
!
  where (fland(:,:) >= 0.5)
    oro(:,:) = 1.
  elsewhere
    oro(:,:) = 0.
  endwhere
!
! Overwrite ORO flag as land for Ross ice shelf: note that the ORO field
! defined in this routine is only used locally.
!
  do j=1,nlat
    if (make_ross .and. mlatcnts(j) < -79.) then
      do i=1,plon
        oro(i,j) = 1.
      end do
    end if
  end do
!
! Code lifted directly from cldwat.F
!
  dmax = 2.e6 ! distance to carry the mask
  arad = 6.37e6
  do i = 1,plon
    clon(i) = 2.*(i-1)*pi/plon
  end do
!
! first isolate the contenents 
! as land points not surrounded by ocean or ice
!
  do j = 1,nlat
    cs(j) = cos(mlatcnts(j)*pi/180.)
    ss(J) = sin(mlatcnts(j)*pi/180.)
    do i = 1,plon
      cont(i,j) = 0.
      if (nint(oro(i,j)) .eq. 1) then
        cont(i,j) = 1.
      endif
    end do
    temp(1,j) = cont(1,j)
    temp(plon,j) = cont(plon,j)
  end do

  do i = 1,plon
    temp(i,1) = cont(i,1)
    temp(i,nlat) = cont(i,nlat)
  end do
!
! get rid of one and two point islands
!
  do j = 2,nlat-1
    do i = 2,plon-1
      sum =  cont(i  ,j+1) + cont(i  ,j-1) &
           + cont(i+1,j+1) + cont(i+1,j-1) &
           + cont(i-1,j+1) + cont(i-1,j-1) &
           + cont(i+1,j  ) + cont(i-1,j) &
           + cont(i  ,j  )
      if (sum.le.2.) then
        temp(i,j) = 0.
      else
        temp(i,j) = 1.
      endif
    enddo
  end do

  do j = 1,nlat
    do i = 1,plon
      cont(i,j) = temp(i,j)
    end do
  end do
!
! construct a function which is one over land, 
! zero over ocean points beyond dmax from land
!
  iplm1 = 2*plon - 1
  dy = pi*arad/nlat
  jof = dmax/dy + 1
!      write (6,*) ' lat bands to check ', 2*jof+1
  do j = 1,nlat
    c1 = cs(j)
    s1 = ss(j)
    dx = 2*pi*arad*cs(j)/plon
!
! if dx is too small, int(dmax/dx) may exceed the maximum size
! of an integer, especially on Suns, causing a core dump. Test
! to avoid that.
!
    if (dx .lt. 1. .and. dmax .gt. 10000.) then
      iof = plon
    else
      iof = min(int(dmax/dx) + 1, plon)
    end if
    do i = 1,plon
      temp(i,j) = 0.
      landm(i,j) = 0.
      jmin = max(1,j-jof)
      jmax = min(nlat,j+jof)
      do jj = jmin, jmax
        s2 = ss(jj)
        c2 = cs(jj)
        do itmp = -iof,iof
          ii = mod(i+itmp+iplm1,plon)+1
          term = s1*s2 + c1*c2*cos(clon(ii)-clon(i))
          if (term.gt.0.9999999) term = 1.
          dist = arad*acos(term)
          landm(i,j) = max(landm(i,j), (1.-dist/dmax)*cont(ii,jj))
!          if (dist.lt.dmax .and. cont(ii,jj).eq.1) then
!            landm(i,j) = max(landm(i,j), 1.-dist/dmax)
!          endif
        end do
      end do
    end do
  end do
!
! Interpolate to reduced grid.  Redefine clon in terms of degrees for interpolation
!
  do i = 1,plon
    clon(i) = (i-1)*360./plon
  end do
  do j=1,nlat
    do i=1,nlon_reduced(j)
      clon_reduced(i,j) = (i-1)*360./nlon_reduced(j)
    end do
  end do

  do j=1,nlat
    call lininterp (landm(1,j), plon, 1, clon, &
                    landm_reduced(1,j), nlon_reduced(j), 1, clon_reduced(1,j), .true.)
  end do

  return
  end

subroutine handle_special_cases(ncidt, ncido)

   use shr_kind_mod, only: r8 => shr_kind_r8
   use control,      only: verbose, is_user_include

   implicit none

   include 'netcdf.inc'

   ! arguments
   integer, intent(in) :: ncidt
   integer, intent(in) :: ncido

   ! Local workspace
   integer :: ndims
   integer :: nvars
   integer :: ngatts
   integer :: unlimdimid

   character*(nf_max_name) :: name
   integer :: xtype
   integer :: nvdims
   integer :: vardids(nf_max_var_dims) ! variable dimension ids
   integer :: natts

   integer :: n
   integer :: vt, vo
   character*(nf_max_name) :: dim_name
   integer :: dimlen
   integer :: totsiz
   integer :: vardids_o(nf_max_var_dims)
   integer :: start(nf_max_var_dims)
   integer :: count(nf_max_var_dims)
   integer :: ret

   character*(nf_max_name) :: attname

   logical :: is_special_case

   ! Copy all the special case variables from template to output
   ! Probably should have separate "define" and "put" loops to optimize redef/enddef
   !
   ! ***N.B.*** This routine assumes that the required dimensions have already
   !            been defined.

   call wrap_inq(ncidt, ndims, nvars, ngatts, unlimdimid)

   start(:) = 1

   do vt = 1, nvars

      call wrap_inq_var(ncidt, vt, name, xtype, nvdims, vardids, natts)

      if (is_special_case(name) .or. is_user_include(name)) then

         totsiz = 1

         ! The dimension IDs from the template file need to be translated
         ! to the appropriate ID for the output file.
         ! ***N.B.*** Assume that the dimension names are the same on
         !            the template and output files
         do n = 1, nvdims

            ! Get dimension name and length from the template file
            if (nf_inq_dim(ncidt, vardids(n), dim_name, dimlen) /= NF_NOERR) then
               write(6,*)'handle_special_cases: ERROR from nf_inq_dim for variable='//&
                  trim(name)//', dimID=',vardids(n)
            end if

            ! Get dimension ID from the output file
            if (nf_inq_dimid(ncido, dim_name, vardids_o(n)) /= NF_NOERR) then
               write(6,*)'handle_special_cases: ERROR from nf_inq_dimid for dimension='//&
                  trim(dim_name)
            end if

            count(n) = dimlen
            totsiz = totsiz * dimlen

         end do

         ! special variables that have previously been defined won't be overwritten
         ! because this define request will fail.
         if( nf_def_var(ncido, name, xtype, nvdims, vardids_o, vo) == NF_NOERR) then

            ! Copy attributes from input to output, then the variable itself
            do n = 1, natts
               call wrap_inq_attname(ncidt, vt, n, attname)
               call wrap_copy_att(ncidt, vt, attname, ncido, vo)
            end do
           
            ! leave define mode
            if (nf_enddef(ncido) /= NF_NOERR) stop 999

            if(verbose) print *, "Copying special var ", trim(name)
                          
            call cpvar(ncidt, ncido, vt, vo, name, &
                       totsiz, xtype, start, count )

            ! return to define mode
            ret = nf_redef(ncido)
         else
            if(verbose) print *, "Cannot define special var ", trim(name)
         end if

      end if ! is special case

   end do ! loop over variables on input file

end subroutine handle_special_cases

      subroutine map2f(im, jm, qm, iord, jord, pfilter) 
!
! This is a stand alone 2-Grid-Wave filter for filtering the terrain for
! the finite-volume dynamical core 
! Developed and coded by S.-J. Lin
! Data Assimilation Office, NASA/GSFC
!
      implicit none
! Input
      integer, intent(in):: im          ! E-W diimension (e.g., 144 for 2.5 deg)
      integer, intent(in):: jm          ! N-S dimension (S pole to N pole; 91 for 2 deg)
      integer, intent(in):: iord        ! Mapping accuracy for E-W; recommended value=7
      integer, intent(in):: jord        ! Mapping accuracy for N-S; recommended value=3
      logical, intent(in):: pfilter     ! Polar filter (set to .T. for normal application)

! Input/Output
      real*8, intent(inout):: qm(im,jm) ! array to be filtered

! Local
      integer im2, jm2
      integer ndeg
      real*8, allocatable::  q2(:,:)
      real*8, allocatable::  lon1(:)
      real*8, allocatable::  lon2(:)
      real*8, allocatable::  sin1(:)
      real*8, allocatable::  sin2(:)
      real*8, allocatable::  qt1(:,:), qt2(:,:)

      real*8 dx1, dx2
      real*8 dy1, dy2

      integer i, j
      real*8 pi

      ndeg = 45              ! starting latitude for polar filter
      pi = 4.d0 * datan(1.d0)

      im2 = im / 2
      if (im2*2 /= im) then
          write(*,*) 'Stop in map2f; im=', im
          stop
      endif

      jm2 = (jm-1) / 2 + 1

      allocate ( qt1(im2,jm) )
      allocate ( qt2(im2,jm2) )

      allocate ( q2(im2,jm2) )
      allocate ( lon1(im+1)  )
      allocate ( lon2(im2+1) )
      allocate ( sin1(jm+1)  )
      allocate ( sin2(jm2+1) )

      dx1 = 360./im
      dx2 = 360./im2

      dy1 = pi/(jm-1)
      dy2 = pi/(jm2-1)

      do i=1,im+1
         lon1(i) = dx1 * (-0.5 + (i-1) )
      enddo

      do i=1,im2+1
         lon2(i) = dx2 * (-0.5 + (i-1) )
      enddo

         sin1(1) = -1.
         sin2(1) = -1.

         sin1(jm +1) =  1.
         sin2(jm2+1) =  1.

      do j=2,jm
         sin1(j) = dsin( -0.5*pi + dy1*(-0.5+(j-1)) )
      enddo

      do j=2,jm2
         sin2(j) = dsin( -0.5*pi + dy2*(-0.5+(j-1)) )
      enddo

      call polavg(qm, im, jm, 1, jm)
      if( pfilter ) call plft2d(im, jm, qm, 2, jm-1, ndeg)

!==============================
! From full --> half resolution
!==============================

      call xmap(iord, im, jm, sin1, lon1, qm, im2, lon2, qt1 )
      call ymap(im2, jm, sin1, qt1, jm2, sin2, qt2, 0, jord)

!==============================
! From half --> full resolution
!==============================

      call ymap(im2, jm2, sin2, qt2, jm, sin1, qt1, 0, jord)
      call xmap(iord, im2, jm, sin1, lon2, qt1, im, lon1, qm )

! Apply Monotonicity preserving polar filter
      if( pfilter ) call plft2d(im, jm, qm, 2, jm-1, ndeg)
      call polavg(qm, im, jm, 1, jm)

      deallocate ( q2 )
      deallocate ( lon1 )
      deallocate ( lon2 )
      deallocate ( sin1 )
      deallocate ( sin2 )

      deallocate ( qt1 )
      deallocate ( qt2 )

      return
      end

      subroutine polavg(p, im, jm, jfirst, jlast)

      implicit none

      integer im, jm, jfirst, jlast
      real*8 p(im,jfirst:jlast)
      real*8 sum1
      integer i

      if ( jfirst == 1 ) then 
          sum1 = 0.
        do i=1,im
          sum1 = sum1 + p(i,1)
        enddo
          sum1 = sum1/im

        do i=1,im
          p(i,1) = sum1
        enddo
      endif

      if ( jlast == jm ) then
          sum1 = 0.
        do i=1,im
          sum1 = sum1 + p(i,jm)
        enddo
          sum1 = sum1/im

        do i=1,im
          p(i,jm) = sum1
        enddo
      endif

      return
      end

      subroutine setrig(im, jm, dp, dl, cosp, cose, sinp, sine)

      implicit none

      integer im, jm
      integer j, jm1
      real*8 sine(jm),cosp(jm),sinp(jm),cose(jm)
      real*8 dp, dl
      real*8 pi, ph5

      jm1 = jm - 1
      pi  = 4.d0 * datan(1.d0)
      dl  = (pi+pi)/dble(im)
      dp  = pi/dble(jm1)

      do 10 j=2,jm
         ph5  = -0.5d0*pi + (dble(j-1)-0.5d0)*(pi/dble(jm1))
10    sine(j) = dsin(ph5)

      cosp( 1) =  0.
      cosp(jm) =  0.

      do 80 j=2,jm1
80    cosp(j) = (sine(j+1)-sine(j)) / dp

! Define cosine at edges..

      do 90 j=2,jm
90    cose(j) = 0.5 * (cosp(j-1) + cosp(j))
      cose(1) = cose(2)

      sinp( 1) = -1.
      sinp(jm) =  1.

      do 100 j=2,jm1
100   sinp(j) = 0.5 * (sine(j) + sine(j+1))

      return
      end

      subroutine ymap(im, jm, sin1, q1, jn, sin2, q2, iv, jord)

! Routine to perform area preserving mapping in N-S from an arbitrary
! resolution to another.
!
! sin1 (1) = -1 must be south pole; sin1(jm+1)=1 must be N pole.
!
! sin1(1) < sin1(2) < sin1(3) < ... < sin1(jm) < sin1(jm+1)
! sin2(1) < sin2(2) < sin2(3) < ... < sin2(jn) < sin2(jn+1)
!
! Developer: S.-J. Lin
! First version: piece-wise constant mapping
! Apr 1, 2000
! Last modified:

      implicit none

! Input
      integer im              ! original E-W dimension
      integer jm              ! original N-S dimension
      integer jn              ! Target N-S dimension
      integer jord
      integer iv              ! iv=0 scalar; iv=1: vector
      real*8  sin1(jm+1)      ! original southern edge of the cell
                              ! sin(lat1)
      real*8  sin2(jn+1)      ! Target cell's southern edge
      real*8  q1(im,jm)       ! original data at center of the cell
                              ! sin(lat2)
! Output
      real*8  q2(im,jn)       ! Mapped data at the target resolution

! Local
      integer i, j0, m, mm
      integer j

! PPM related arrays
      real*8 al(im,jm)
      real*8 ar(im,jm)
      real*8 a6(im,jm)
      real*8 dy1(jm)

      real*8 r3, r23
      parameter ( r3 = 1./3., r23 = 2./3. )
      real*8 pl, pr, qsum, esl
      real*8 dy, sum

      do j=1,jm
         dy1(j) = sin1(j+1) - sin1(j)
      enddo

! ***********************
! Area preserving mapping
! ***********************

! Construct subgrid PP distribution
      if ( jord == 1 ) then

      do j=1,jm
         do i=1,im
            a6(i,j) = 0.
            ar(i,j) = q1(i,j)
            al(i,j) = q1(i,j)
         enddo
      enddo

      else

      call ppm_lat(im, jm, q1, al, ar, a6, jord, iv)
      do i=1,im
! SP
         a6(i, 1) = 0.
         ar(i, 1) = q1(i,1)
         al(i, 1) = q1(i,1)
! NP
         a6(i,jm) = 0.
         ar(i,jm) = q1(i,jm)
         al(i,jm) = q1(i,jm)
      enddo
      endif

      do 1000 i=1,im
         j0 = 1
      do 555 j=1,jn
      do 100 m=j0,jm
!
! locate the southern edge: sin2(i)
!
      if(sin2(j) .ge. sin1(m) .and. sin2(j) .le. sin1(m+1)) then
         pl = (sin2(j)-sin1(m)) / dy1(m)
         if(sin2(j+1) .le. sin1(m+1)) then
! entire new cell is within the original cell
            pr = (sin2(j+1)-sin1(m)) / dy1(m)
            q2(i,j) = al(i,m) + 0.5*(a6(i,m)+ar(i,m)-al(i,m)) &
                          *(pr+pl)-a6(i,m)*r3*(pr*(pr+pl)+pl**2)
               j0 = m
               goto 555
          else
! South most fractional area
            qsum = (sin1(m+1)-sin2(j))*(al(i,m)+0.5*(a6(i,m)+ &
                    ar(i,m)-al(i,m))*(1.+pl)-a6(i,m)* &
                     (r3*(1.+pl*(1.+pl))))
              do mm=m+1,jm
! locate the eastern edge: sin2(j+1)
                 if(sin2(j+1) .gt. sin1(mm+1) ) then
! Whole layer
                     qsum = qsum + dy1(mm)*q1(i,mm)
                 else
! North most fractional area
                     dy = sin2(j+1)-sin1(mm)
                    esl = dy / dy1(mm)
                   qsum = qsum + dy*(al(i,mm)+0.5*esl*  &
                         (ar(i,mm)-al(i,mm)+a6(i,mm)*(1.-r23*esl)))
                     j0 = mm
                     goto 123
                 endif
              enddo
              goto 123
           endif
      endif
100   continue
123   q2(i,j) = qsum / ( sin2(j+1) - sin2(j) )
555   continue
1000  continue

! Final processing for poles

      if ( iv == 0 ) then

! South pole
           sum = 0.
         do i=1,im
           sum = sum + q2(i,1)
         enddo

           sum = sum / im
         do i=1,im
           q2(i,1) = sum
         enddo

! North pole:
           sum = 0.
         do i=1,im
           sum = sum + q2(i,jn)
         enddo

           sum = sum / im
         do i=1,im
           q2(i,jn) = sum
         enddo

      endif

      return
      end

      subroutine ppm_lat(im, jm, q, al, ar, a6, jord, iv)
      implicit none

!INPUT
      integer im, jm                      !  Dimensions
      real*8  q(im,jm)
      real*8 al(im,jm)
      real*8 ar(im,jm)
      real*8 a6(im,jm)
      integer jord
      integer iv                             ! iv=0 scalar
                                             ! iv=1 vector
! Local
      real*8 dm(im,jm)
      real*8    r3
      parameter ( r3 = 1./3. )
      integer i, j, im2, iop, jm1
      real*8 tmp, qmax, qmin
      real*8 qop

! Compute dm: linear slope

      do j=2,jm-1
         do i=1,im
            dm(i,j) = 0.25*(q(i,j+1) - q(i,j-1))
            qmax = max(q(i,j-1),q(i,j),q(i,j+1)) - q(i,j)
            qmin = q(i,j) - min(q(i,j-1),q(i,j),q(i,j+1))
            dm(i,j) = sign(min(abs(dm(i,j)),qmin,qmax),dm(i,j))
         enddo
      enddo

      im2 = im/2
      jm1 = jm - 1

!Poles:
      if (iv == 1 ) then
! SP
          do i=1,im
              if( i .le. im2) then
                  qop = -q(i+im2,2)
              else
                  qop = -q(i-im2,2)
              endif
              tmp = 0.25*(q(i,2) - qop)
              qmax = max(q(i,2),q(i,1), qop) - q(i,1)
              qmin = q(i,1) - min(q(i,2),q(i,1), qop)
              dm(i,1) = sign(min(abs(tmp),qmax,qmin),tmp)
           enddo
! NP
           do i=1,im
              if( i .le. im2) then
                  qop = -q(i+im2,jm1)
              else
                  qop = -q(i-im2,jm1)
              endif
              tmp = 0.25*(qop - q(i,jm1))
              qmax = max(qop,q(i,jm), q(i,jm1)) - q(i,jm)
              qmin = q(i,jm) - min(qop,q(i,jm), q(i,jm1))
              dm(i,jm) = sign(min(abs(tmp),qmax,qmin),tmp)
           enddo
      else
!
!*********
! Scalar:
!*********
! SP
          do i=1,im2
            tmp = 0.25*(q(i,2)-q(i+im2,2))
            qmax = max(q(i,2),q(i,1), q(i+im2,2)) - q(i,1)
            qmin = q(i,1) - min(q(i,2),q(i,1), q(i+im2,2))
            dm(i,1) = sign(min(abs(tmp),qmax,qmin),tmp)
          enddo

          do i=im2+1,im
            dm(i, 1) =  - dm(i-im2, 1)
          enddo
! NP
          do i=1,im2
            tmp = 0.25*(q(i+im2,jm1)-q(i,jm1))
            qmax = max(q(i+im2,jm1),q(i,jm), q(i,jm1)) - q(i,jm)
            qmin = q(i,jm) - min(q(i+im2,jm1),q(i,jm), q(i,jm1))
            dm(i,jm) = sign(min(abs(tmp),qmax,qmin),tmp)
          enddo

          do i=im2+1,im
            dm(i,jm) =  - dm(i-im2,jm)
          enddo
      endif

      do j=2,jm
        do i=1,im
          al(i,j) = 0.5*(q(i,j-1)+q(i,j)) + r3*(dm(i,j-1) - dm(i,j))
        enddo
      enddo

      do j=1,jm-1
        do i=1,im
          ar(i,j) = al(i,j+1)
        enddo
      enddo

      do j=2,jm-1
         do i=1,im
            a6(i,j) = 3.*(q(i,j)+q(i,j) - (al(i,j)+ar(i,j)))
         enddo

        call lmppm(dm(1,j), a6(1,j), ar(1,j),  &
                   al(1,j),  q(1,j), im, jord-3)
      enddo

      return
      end

      subroutine xmap(iord, im, jm, sin1, lon1, q1, in, lon2, q2)

! Routine to perform area preserving mapping in E-W from an arbitrary
! resolution to another.
! Periodic domain will be assumed, i.e., the eastern wall bounding cell
! im is lon1(im+1) = lon1(1); Note the equal sign is true geographysically.
!
! lon1(1) < lon1(2) < lon1(3) < ... < lon1(im) < lon1(im+1)
! lon2(1) < lon2(2) < lon2(3) < ... < lon2(in) < lon2(in+1)
!
! Developer: S.-J. Lin
! First version: piece-wise constant mapping
! Apr 1, 2000
! Last modified:

      implicit none

! Input
      integer iord
      integer im              ! original E-W dimension
      integer in              ! Target E-W dimension
      integer jm              ! original N-S dimension
      real*8    lon1(im+1)      ! original western edge of the cell
      real*8    sin1(jm+1)
      real*8    q1(im,jm)       ! original data at center of the cell
      real*8    lon2(in+1)      ! Target cell's western edge

! Output
      real*8    q2(in,jm)       ! Mapped data at the target resolution

! Local
      integer i1, i2
      integer i, i0, m, mm
      integer j
      integer ird

! PPM related arrays
      real*8 qtmp(-im:im+im)
      real*8   al(-im:im+im)
      real*8   ar(-im:im+im)
      real*8   a6(-im:im+im)
      real*8   x1(-im:im+im+1)
      real*8  dx1(-im:im+im)
      real*8  r3, r23
      parameter ( r3 = 1./3., r23 = 2./3. )
      real*8 pl, pr, qsum, esl
      real*8 dx
      logical found

      do i=1,im+1
         x1(i) = lon1(i)
      enddo

      do i=1,im
         dx1(i) = x1(i+1) - x1(i)
      enddo

! check to see if ghosting is necessary

!**************
! Western edge:
!**************
          found = .false.
          i1 = 1
      do while ( .not. found )
         if( lon2(1) .ge. x1(i1) ) then
             found = .true.
         else
                  i1 = i1 - 1
             if (i1 .lt. -im) then
                 write(6,*) 'failed in xmap'
                 stop
             else
                 x1(i1) = x1(i1+1) - dx1(im+i1)
                dx1(i1) = dx1(im+i1)
             endif
         endif
      enddo

!**************
! Eastern edge:
!**************
          found = .false.
          i2 = im+1
      do while ( .not. found )
         if( lon2(in+1) .le. x1(i2) ) then
             found = .true.
         else
                  i2 = i2 + 1
             if (i2 .gt. 2*im) then
                 write(6,*) 'failed in xmap'
                 stop
             else
                dx1(i2-1) = dx1(i2-1-im)
                 x1(i2) = x1(i2-1) + dx1(i2-1)
             endif
         endif
      enddo

      do 1000 j=1,jm

! ***********************
! Area preserving mapping
! ***********************

! Construct subgrid PP distribution
      if ( abs(sin1(j)+sin1(j+1)) > 1.5 ) then
           ird = 3
      elseif ( abs(sin1(j)+sin1(j+1)) < 1.0 ) then
           ird = 8
      else
           ird = iord
      endif

      if ( iord == 1 ) then
           do i=1,im
              qtmp(i) = q1(i,j)
                al(i) = q1(i,j)
                ar(i) = q1(i,j)
                a6(i) = 0.
           enddo
              qtmp(0   ) = q1(im,j)
              qtmp(im+1) = q1(1, j)
      else
      call ppm_cycle(im, q1(1,j), al(1), ar(1), a6(1), qtmp, ird)
      endif

! check to see if ghosting is necessary

! Western edge
          if ( i1 .le. 0 ) then
               do i=i1,0
                  qtmp(i) = qtmp(im+i)
                    al(i) = al(im+i)
                    ar(i) = ar(im+i)
                    a6(i) = a6(im+i)
               enddo
          endif

! Eastern edge:
          if ( i2 .gt. im+1 ) then
             do i=im+1,i2-1
                qtmp(i) = qtmp(i-im)
                  al(i) =   al(i-im)
                  ar(i) =   ar(i-im)
                  a6(i) =   a6(i-im)
             enddo
          endif

         i0 = i1

      do 555 i=1,in
      do 100 m=i0,i2-1
!
! locate the western edge: lon2(i)
!
      if(lon2(i) .ge. x1(m) .and. lon2(i) .le. x1(m+1)) then
         pl = (lon2(i)-x1(m)) / dx1(m)
         if(lon2(i+1) .le. x1(m+1)) then
! entire new grid is within the original grid
            pr = (lon2(i+1)-x1(m)) / dx1(m)
            q2(i,j) = al(m) + 0.5*(a6(m)+ar(m)-al(m))  &
                          *(pr+pl)-a6(m)*r3*(pr*(pr+pl)+pl**2)
               i0 = m
               goto 555
          else
! Left most fractional area
            qsum = (x1(m+1)-lon2(i))*(al(m)+0.5*(a6(m)+ &
                    ar(m)-al(m))*(1.+pl)-a6(m)*         &
                     (r3*(1.+pl*(1.+pl))))
              do mm=m+1,i2-1
! locate the eastern edge: lon2(i+1)
                 if(lon2(i+1) .gt. x1(mm+1) ) then
! Whole layer
                     qsum = qsum + dx1(mm)*qtmp(mm)
                 else
! Right most fractional area
                     dx = lon2(i+1)-x1(mm)
                    esl = dx / dx1(mm)
                   qsum = qsum + dx*(al(mm)+0.5*esl*  &
                         (ar(mm)-al(mm)+a6(mm)*(1.-r23*esl)))
                     i0 = mm
                     goto 123
                 endif
              enddo
              goto 123
           endif
      endif
100   continue
123   q2(i,j) = qsum / ( lon2(i+1) - lon2(i) )
555   continue
1000  continue

      return
      end

      subroutine ppm_cycle(im, q, al, ar, a6, p, iord)
      implicit none

      real*8 r3
      parameter ( r3 = 1./3. )

! Input 
      integer im, iord
      real*8  q(1)
! Output
      real*8 al(1)
      real*8 ar(1)
      real*8 a6(1)
      real*8 p(-im:im+im)

! local
      real*8  dm(0:im)
      integer i, lmt
      real*8 tmp, qmax, qmin

         p(0) = q(im)
      do i=1,im
         p(i) = q(i)
      enddo
         p(im+1) = q(1)

! 2nd order slope
      do i=1,im
         tmp = 0.25*(p(i+1) - p(i-1))
         qmax = max(p(i-1), p(i), p(i+1)) - p(i)
         qmin = p(i) - min(p(i-1), p(i), p(i+1))
         dm(i) = sign(min(abs(tmp),qmax,qmin), tmp)
      enddo
         dm(0) = dm(im)

      do i=1,im
         al(i) = 0.5*(p(i-1)+p(i)) + (dm(i-1) - dm(i))*r3
      enddo

      do i=1,im-1
         ar(i) = al(i+1)
      enddo
         ar(im) = al(1)

         do i=1,im
            a6(i) = 3.*(p(i)+p(i)  - (al(i)+ar(i)))
         enddo

      if(iord <= 6) then
         lmt = iord - 3
         if(lmt <= 2) call lmppm(dm(1),a6(1),ar(1),al(1),p(1),im,lmt)
      else
         call huynh(im, ar(1), al(1), p(1), a6(1), dm(1))
         call lmppm(dm(1),a6(1),ar(1),al(1),p(1),im,2)
      endif

      return
      end

      subroutine lmppm(dm, a6, ar, al, p, im, lmt)
      implicit none
      real*8 r12
      parameter ( r12 = 1./12. )

      integer im, lmt
      integer i
      real*8 a6(im),ar(im),al(im),p(im),dm(im)
      real*8 da1, da2, fmin, a6da

! LMT = 0: full monotonicity
! LMT = 1: semi-monotonic constraint (no undershoot)
! LMT = 2: positive-definite constraint

      if(lmt.eq.0) then

! Full constraint
      do 100 i=1,im
      if(dm(i) .eq. 0.) then
         ar(i) = p(i)
         al(i) = p(i)
         a6(i) = 0.
      else
         da1  = ar(i) - al(i)
         da2  = da1**2
         a6da = a6(i)*da1
         if(a6da .lt. -da2) then
            a6(i) = 3.*(al(i)-p(i))
            ar(i) = al(i) - a6(i)
         elseif(a6da .gt. da2) then
            a6(i) = 3.*(ar(i)-p(i))
            al(i) = ar(i) - a6(i)
         endif
      endif
100   continue

      elseif(lmt == 1) then
! Semi-monotonic constraint
      do 150 i=1,im
      if(abs(ar(i)-al(i)) .ge. -a6(i)) go to 150
      if(p(i).lt.ar(i) .and. p(i).lt.al(i)) then
            ar(i) = p(i)
            al(i) = p(i)
            a6(i) = 0.
      elseif(ar(i) .gt. al(i)) then
            a6(i) = 3.*(al(i)-p(i))
            ar(i) = al(i) - a6(i)
      else
            a6(i) = 3.*(ar(i)-p(i))
            al(i) = ar(i) - a6(i)
      endif
150   continue
      elseif(lmt == 2) then
! Positive definite constraint
      do 250 i=1,im
      if(abs(ar(i)-al(i)) >= -a6(i)) go to 250
      fmin = p(i) + 0.25*(ar(i)-al(i))**2/a6(i) + a6(i)*r12
      if(fmin >= 0.) go to 250
      if(p(i).lt.ar(i) .and. p(i).lt.al(i)) then
            ar(i) = p(i)
            al(i) = p(i)
            a6(i) = 0.
      elseif(ar(i) .gt. al(i)) then
            a6(i) = 3.*(al(i)-p(i))
            ar(i) = al(i) - a6(i)
      else
            a6(i) = 3.*(ar(i)-p(i))
            al(i) = ar(i) - a6(i)
      endif
250   continue
      endif
      return
      end

      subroutine huynh(im, ar, al, p, d2, d1)

! Enforce Huynh's 2nd constraint in 1D periodic domain

      implicit none
      integer im, i
      real*8 ar(im)
      real*8 al(im)
      real*8  p(im)
      real*8 d2(im)
      real*8 d1(im)

! Local scalars:
      real*8 pmp
      real*8 lac
      real*8 pmin
      real*8 pmax

! Compute d1 and d2
         d1(1) = p(1) - p(im)
      do i=2,im
         d1(i) = p(i) - p(i-1)
      enddo

      do i=1,im-1
         d2(i) = d1(i+1) - d1(i)
      enddo
         d2(im) = d1(1) - d1(im)

! Constraint for AR
!            i = 1
         pmp   = p(1) + 2.0 * d1(1)
         lac   = p(1) + 0.5 * (d1(1)+d2(im)) + d2(im) 
         pmin  = min(p(1), pmp, lac)
         pmax  = max(p(1), pmp, lac)
         ar(1) = min(pmax, max(ar(1), pmin))

      do i=2, im
         pmp   = p(i) + 2.0*d1(i)
         lac   = p(i) + 0.5*(d1(i)+d2(i-1)) + d2(i-1)
         pmin  = min(p(i), pmp, lac)
         pmax  = max(p(i), pmp, lac)
         ar(i) = min(pmax, max(ar(i), pmin))
      enddo

! Constraint for AL
      do i=1, im-1
         pmp   = p(i) - 2.0*d1(i+1)
         lac   = p(i) + 0.5*(d2(i+1)-d1(i+1)) + d2(i+1)
         pmin  = min(p(i), pmp, lac)
         pmax  = max(p(i), pmp, lac)
         al(i) = min(pmax, max(al(i), pmin))
      enddo

! i=im
         i = im
         pmp    = p(im) - 2.0*d1(1)
         lac    = p(im) + 0.5*(d2(1)-d1(1)) + d2(1)
         pmin   = min(p(im), pmp, lac)
         pmax   = max(p(im), pmp, lac)
         al(im) = min(pmax, max(al(im), pmin))

! compute A6 (d2)
      do i=1, im
         d2(i) = 3.*(p(i)+p(i)  - (al(i)+ar(i)))
      enddo
      return
      end

 subroutine plft2d(im, jm, p, JS, JN, ndeg)
!
! This is a weak LOCAL polar filter.
! Developer: Shian-Jiann Lin

      implicit none

      integer im
      integer jm
      integer js, jn, ndeg
      real*8 p(im,jm)

      integer i, j, n, ideg, jj, jc
      real*8 cosp(jm),cose(jm)
      real*8 a(0:im/2+1)

      real*8 sine(jm),sinp(jm)
      real*8, allocatable, save :: se(:), sc(:)

      real*8 pi, dp, dl, e0, ycrit, coszc, smax, rn, rn2, esl, tmp

      data IDEG /0/

      if(IDEG .ne. ndeg) then
	IDEG = ndeg
!  (e0 = 2.6)
      e0 = 0.5 * sqrt(27.)
      PI = 4. * ATAN(1.)

      allocate( sc(jm), se(jm))

      call setrig(im, jm, dp, dl, cosp, cose, sinp, sine)

      ycrit = IDEG*PI/180.
      coszc = cos(ycrit)

      smax = (jm-1)/2
      write(6,*) 'Critical latitude in local pft = ',ndeg

         a(0) = 1.
      do n=1,im/2+1
         rn = n
         rn2 = 2*n
         a(n) = sqrt(rn2+1.) * ((rn2+1.)/rn2)**rn
      enddo

      do j=2,jm-1
      sc(j) = coszc / cosp(j)

      IF(sc(j) > 1. .and. sc(j) <= 1.5 ) THEN
         esl = 1./ sc(j)
         sc(j) =  1. +  (1.-esl) / (1.+esl)
      ELSEIF(sc(j) > 1.5 .and. sc(j) <= e0 ) THEN
         esl = 1./ sc(j)
         sc(j) =  1. + 2./ (27.*esl**2 - 2.)
      ELSEIF(sc(j) > e0) THEN
! Search
      do jj=1,im/2
      if(sc(j) <= a(jj)) then
      jc = jj
!     write(*,*) 'jc=', jc
      goto 111
      endif
      enddo
      jc = im/2 + 1
111   continue

      tmp = ((sc(j) - a(jc-1))/(a(jc) - a(jc-1)))**0.25
      sc(j) =  jc + min(1., tmp)
!     sc(j) =  min(smax,sc(j))
      ENDIF
      enddo
! ====================================================
      do j=2,jm
      se(j) = coszc / cose(j)
      IF(se(j) > 1. .and. se(j) <= 1.5 ) THEN
         esl = 1./ se(j)
         se(j) =  1. + (1.-esl) / (1.+esl)
      ELSEIF(se(j) > 1.5 .and. se(j) <= e0 ) THEN
         esl = 1./ se(j)
         se(j) =  1. + 2./ (27.*esl**2 - 2.)
      ELSEIF(se(j) > e0) THEN
! Search
      do jj=1,im/2
      if(se(j) <= a(jj)) then
      jc = jj
      goto 222
      endif
      enddo

      jc = im/2 + 1
222   continue
      tmp = ((se(j) - a(jc-1))/(a(jc) - a(jc-1)))**0.25
      se(j) =  jc + min(1., tmp)
!     se(j) =  min(smax,se(j))
      ENDIF
      enddo

      do i=1,im
        se( 2) = sc(2)
        se(jm) = sc(jm-1)
      enddo

      do j=2,jm-1
!        write(*,*) j,sc(j)
      enddo
      ENDIF

      if( JN == (jm-1) ) then
! Cell-centered variables
         call lpft(im, jm, p, 2, jm-1, Sc)
      else
! Cell-edge variables
         call lpft(im, jm, p, 2, jm, Se)
      endif
      return
 end


 subroutine lpft(im, jm, p, j1, j2, s)
      implicit none

      integer im, jm, j1, j2
      real*8  p(im,jm)
      real*8  s(jm)

! Local
      integer i, j, n, nt

      real*8 ptmp(0:im+1)
      real*8 q(0:im+1)
      real*8 frac, rsc, bt

      do 2500 j=j1,j2
      if(s(j) > 1.02) then

        NT  = INT(S(j))
        frac = S(j) - NT
        NT = NT-1

        rsc = 1. / (1.+frac)
        bt = 0.5 * frac

        do i=1,im
           ptmp(i) = p(i,j)
        enddo

        ptmp(0)    = p(im,j)
        ptmp(im+1) = p(1 ,j)

        if( NT < 1 ) then
          do i=1,im
             p(i,j) = rsc * (ptmp(i) + bt*(ptmp(i-1)+ptmp(i+1)))
          enddo
        else
          do i=1,im
             q(i) = rsc * (ptmp(i) + bt*(ptmp(i-1)+ptmp(i+1)))
          enddo

           do 500 N=1,NT
              q(0) = q(im)
              do i=1,im
                 ptmp(i) = q(i) + q(i-1)
              enddo
                 ptmp(im+1) = ptmp(1)

             if ( n == nt ) then
               do i=1,im
                  p(i,j) = 0.25*(ptmp(i) + ptmp(i+1))
               enddo
             else
               do i=1,im
                  q(i) = 0.25*(ptmp(i) + ptmp(i+1))
               enddo
             endif
500        continue
        endif
      endif
2500  continue

      return
 end

subroutine addglobal (ncid, cmdline)
  implicit none

  include 'netcdf.inc'
!
! Input arguments
!
  integer ncid
  character*(*) cmdline
!
! Local workspace
!
  integer ret
  integer numchars
  integer values(8)
  integer hnum
  integer hlen

  character*8 date
  character*10 time
  character*5 zone
  character*18 datetime
  character*16 logname
  character*16 hostname
  character*1500 :: hist

  call date_and_time (date, time, zone, values)

  datetime(1:8) =        date(5:6) // '/' // date(7:8) // '/' // date(3:4)
  datetime(9:)  = ' ' // time(1:2) // ':' // time(3:4) // ':' // time(5:6) // ' '

  call getenv ('LOGNAME', logname)
  call getenv ('HOST', hostname)

  hlen = 0
  hist = ' '
  if (nf_inq_attid (ncid, nf_global, 'history', hnum) == nf_noerr) then
    ret = nf_inq_attlen (ncid, nf_global, 'history', hlen)
    call wrap_get_att_text (ncid, nf_global, 'history', hist)
  end if

  hist = trim (hist) // char(10) // datetime // trim (logname) // ':' // &
         trim (hostname) // ':' // trim (cmdline)
!
! Add 3 to account for 1st newline and colons between each of 2 trimmed strings
!
  hlen = hlen + len(datetime) + len_trim(logname) + len_trim(hostname) + &
                len_trim(cmdline) + 3

  if (hlen > len (hist)) then
    write(6,*)'Warning: history attribute too long: truncating'
    hlen = len (hist)
  end if

  numchars = len_trim (hist)
  ret = nf_put_att_text (ncid, nf_global, 'history', numchars, hist)

  return
end subroutine addglobal
  
 

#!/bin/csh -f
# set echo
# set verbose
#----------------------- paleo_mkraw_cesm1.csh --------------------------------------
#
# all work is done in directory where script and code resides 
#
# this cshell script runs the program paleo_mkraw_cesm1.F90 
#
# see code for details (comments)
# input:  
# input data: (2x2) LSM vegetation types from desired period
#           : (mksrf_soitex.10level.nc) IGBP soil texture for 0k
#           : zonally averaged model organic soil density distribution **
#           : 2x2 topography/bathymetry file (topo_depth) file 
#
# output data: raw data files necessary to create surface-data file
#              at model runtime: mksrf_glacier_paleo.nc
#                              : mksrf_urban_paleo.nc
#                              : mksrf_lanwat_paleo.nc
#                              : mksrf_soicol_paleo.nc
#                              : mksrf_lai_paleo.nc
#                              : mksrf_soitex_paleo.nc
#CAS
# updates for cesm1/ccsm4 includes 
#			       : mksrf_organic_paleo.nc
#			       : mksrf_fmax_paleo.nc
#                              : mksrf_landuse_paleo.nc (replaces mksrf_pft_paleo.nc)
#                              : mksrf_topo_paleo.nc
#			       : mksrf_vocef_paleo.nc
#
#
#  mkrsf_* files created here can be used for offline cesm1/ccsm4 tool, mksurfdata,
#  to create the surface_data set for cesm1/ccsm4
#
#  original:  cesm1/ccsm4 code base:  models/lnd/clm/tools/mksurfdata
#
#-----------------------------------------------------------------
# YOU NEED  : Makefile,paleo_mkraw_cesm1_sed.F90,paleo_mkraw_cesm1.csh,input data
# TO RUN    : paleo_mkraw_cesm1.csh
# NOTE      : make sure "limits" on your machine are set appropriately
#           : if not set large enough, the program may not have enough
#             space/memory to run
#-----------------------------------------------------------------
#
#----------------------------------------------------------------------------
# specify input/output pathnames with enviromental variables set in this script 
#----------------------------------------------------------------------------

setenv CASE  <casename>
set DATE  = "`date +%y%m%d`"
set INFILE_FORMAT = netcdf              # [netcdf, ascii]

# ----------------
#  -- INPUT FILES
# ----------------
# Paleo veg and topo (2 degree)
set INPUT_LSM_DATA = <lsm_file>
set INPUT_TOP_DATA = <topo-bath_file>

# Soil texture (use present day)
set INPUT_SOI_DATA = /glade/p/cesmdata/cseg/inputdata/lnd/clm2/rawdata/mksrf_soitex.10level.c010119.nc 
set INPUT_ORG_DATA = mksrf_zon_organic.10level.nc 

# ----------------
# -- OUTPUT files
# ----------------
set OUTPUT_GLACIER = mksrf_glacier_$CASE.c$DATE.nc
set OUTPUT_URBAN   = mksrf_urban_$CASE.c$DATE.nc
set OUTPUT_LANWAT  = mksrf_lanwat_$CASE.c$DATE.nc
set OUTPUT_SOICOL  = mksrf_soicol_$CASE.c$DATE.nc
set OUTPUT_PFT     = mksrf_landuse_$CASE.c$DATE.nc
set OUTPUT_LAI     = mksrf_lai_$CASE.c$DATE.nc
set OUTPUT_SOITEX  = mksrf_soitex_$CASE.c$DATE.nc
set OUTPUT_ORGANIC = mksrf_organic_$CASE.c$DATE.nc
set OUTPUT_FMAX    = mksrf_fmax_$CASE.c$DATE.nc
set OUTPUT_TOPO    = mksrf_topo_$CASE.c$DATE.nc
set OUTPUT_VOCEF   = mksrf_vocef_$CASE.c$DATE.nc

#----------------------------------------------------------------------------
# use "sed" to insert pathnames into fortran code 
#----------------------------------------------------------------------------

cat >! pathnames.sed << EOF
s#input_lsm_data#$INPUT_LSM_DATA#
s#input_top_data#$INPUT_TOP_DATA#
s#input_soi_data#$INPUT_SOI_DATA#
s#input_org_data#$INPUT_ORG_DATA#
s#output_glacier#$OUTPUT_GLACIER#
s#output_urban#$OUTPUT_URBAN#
s#output_lanwat#$OUTPUT_LANWAT#
s#output_soicol#$OUTPUT_SOICOL#
s#output_pft#$OUTPUT_PFT#
s#output_lai#$OUTPUT_LAI#
s#output_soitex#$OUTPUT_SOITEX#
s#output_organic#$OUTPUT_ORGANIC#
s#output_fmax#$OUTPUT_FMAX#
s#output_topo#$OUTPUT_TOPO#
s#output_vocef#$OUTPUT_VOCEF#
EOF
sed -f pathnames.sed paleo_mkraw_cesm1_sed.F90 >! paleo_mkraw_cesm1.F90

#----------------------------------------------------------------------------
#  compile and run 
#----------------------------------------------------------------------------
make EXENAME=paleo_mkraw_cesm1
./paleo_mkraw_cesm1


exit

#! /bin/csh -f

set echo 
set verbose

#---------------------------------------------------------------------------
# Make the input_template directory and input_template files for ocn and ice
#---------------------------------------------------------------------------

# ----------------------------------------
# - User defined -------------------------
# ----------------------------------------
setenv CASE <casename>
setenv GRID grid.<iter>.pop.da
setenv KMT kmt.<iter>.da

set    NX = 320
set    NY = 384

# ----------------------------------------
# - End User defined -------------------------
# ----------------------------------------
#Set up for making regionmask file:
setenv GRIDFILE   ./$GRID
setenv KMTFILE    ./$KMT

#get files for input:
 cp $GRIDFILE grid.pop.da
 cp $KMTFILE  kmt.da

#get region code, edit, compile and run:
cat >! commands.sed << EOF
s#NX#${NX}#
s#NY#${NY}#
EOF

 sed -f commands.sed modregmsk_edit.f >! modregmsk.f 

 ifort -convert big_endian -o modregmsk.be modregmsk.f
#ifort -convert big_endian -o modregmsk.le modregmsk.f

 ./modregmsk.be
 mv region.ieeei4 region.$CASE.be.ieeei4
 # ./modregmsk.le					!! to prove that kmt.da and grid.da are BigEndian
 # 	mv region.ieeei4 region.$CASE.le.ieeei4		!! to prove that kmt.da and grid.da are BigEndian


##########################################################################

#Create new input files:
#Create region_ids
# Note: for negative valued region_ids (i.e. marginal seas), 
# you need to set a lat, lon location and area for the
# redistribution of net freshwater from the marginal sea
# (when marginal sea balance is turned on.)
# The example below has these set to zero.
# See user's guide for more info on how to set this.
   
cat >! region_ids_$CASE << EOF
   1  'Southern Hemisphere '        0.0   0.0      0.0
   2  'Northern Hemisphere '        0.0   0.0      0.0
EOF

#cat >! region_ids_$CASE <<EOF
# EOF
#   1  'Arctic Ocean        '        0.0   0.0      0.0
#   2  'North Tethys Ocean  '        0.0   0.0      0.0
#   3  'North Atlantic Ocean'        0.0   0.0      0.0
#   4  'Southern Ocean      '        0.0   0.0      0.0
#   5  'South Atlantic Ocean'        0.0   0.0      0.0
#   6  'South Tethys Ocean  '        0.0   0.0      0.0
#   7  'Indian Ocean        '        0.0   0.0      0.0
#   8  'Pacific Ocean       '        0.0   0.0      0.0
#EOF

#Create transport_contents:
# This file is for diagnostic calculation of section transports.
# First line tells how many sections to integrate.
# Next lines are i,j,k limits of sections, whether
# section is meridional or zonal {(merid,zonal)} and a section name.
# Transport output appears in dt files.
# 

#imin imax jmin jmax kmin kmax sect   Name - NOTE:  Spacing is EXACT!
cat >! transport_contents_$CASE << EOF
2
  30   36  215  215    1   60 zonal  Equatorial bay
 195  195  100  125    1   60 merid  Mid-ocean ridge
EOF

# cat >! transport_contents << EOF
# 3
# 33   33    3   11    1   25 merid  Drake Passage
# 95   95   20   41    1   25 merid  Indonesian Throughflow
# 75   92   57   57    1   25 zonal  Tethys Seaway

# 10   10   55   65    1   25 merid  TESTM
# 45   55   10   10    1   25 zonal  TESTZ

# 64   64    1  128    1   20 zonal  sample zonal section
#  1  192   64   64    1   10 merid  sample meridional section

#EOF

#END OF USER EDITING...


exit(0)

#!/usr/bin/env bash
#===============================================================================
# SVN $Id: create_ESMF_map.sh 60836 2014-06-03 23:13:57Z mlevy@ucar.edu $
# SVN $URL: https://svn-ccsm-models.cgd.ucar.edu/tools/mapping/release_tags/mapping_140603/gen_mapping_files/gen_ESMF_mapping_file/create_ESMF_map.sh $
#
# Create needed mapping files for gen_domain and coupler mapping
# Currently supported on cheyenne only
# 
#===============================================================================
echo $0
date
SDIR=`dirname $0`

#===============================================================================
# Usage subroutine
#===============================================================================
usage() {
  echo ''
  echo '**********************************************************'
  echo 'usage:'
  echo './create_ESMF_map.sh  '
  echo ' A wrapper for the ESMF mapping tool that creates a mapping file'
  echo ' from the source grid to the destination grid. Specify what type'
  echo ' of mapping to use with the -maptype flag (aave, blin, bilin,patc,'
  echo ' nearestdtos, or neareststod)'
  echo ''
  echo 'create_ESMF_map.sh '
  echo '  --filesrc|-fsrc  input source grid_filename (required) '
  echo '  --filedst|-fdst  input destination grid_filename (required)'
  echo '  --namesrc|-nsrc  output source name in mapping file (required)' 
  echo '  --namedst|-ndst  output destination name in mapping file (required)'
  echo '  --maptype|-map   type of mapping [aave|blin|bilin|patc|nearestdtos|neareststod] (required)'
  echo '  [ --typesrc|tsrc ] [regional|global]'
  echo '  [ --typedst|tdst ] [regional|global]'
  echo '  [ --pass2esmf ]    ["options"]'
  echo '  [ --batch|-b ]'
  echo '  [ --clm_name ]'
  echo '  [ --serial ]'
  echo '  [ -mach|--machine ] [machine_name]'
  echo '  [ --large_file|-big ]'
  echo '  [ --help|-h ]'
  echo '  [ -v ]'
  echo ' '
  echo 'where '
  echo ' --filesrc (or -fsrc)'
  echo '   SCRIP grid format source filename (full pathname)'
  echo ' --filedst (or -fdst)'
  echo '   SCRIP grid format destination filename (full pathname)'
  echo ' --namesrc (or -nsrc) and --namesrc (or -nsrc) will result in the '
  echo '   following mapping files'
  echo '     namesrc_TO_namedst_maptype.cdate.nc'
  echo ''
  echo ' --typesrc (or -tsrc)'
  echo '   source grid type,  valid values are regional or global'
  echo '   default is global'
  echo ' --typedst (or -tdst)'
  echo '   destination grid type, valid values are regional or global'
  echo '   default is global'
  echo ' --pass2esmf'
  echo '   pass options directly to the ESMF tool.'
  echo ' --batch (or -b)'
  echo '   Toggles batch mode usage. If you want to run in batch mode'
  echo '   you need to have a separate batch script for a supported machine'
  echo '   that calls this script interactively - you cannot submit this'
  echo '   script directly to the batch system'
  echo ' --clm_name'
  echo '   Use the CLM naming convention'
  echo ' --serial'
  echo '   For cheyenne batch jobs only! Load the serial ESMF tools rather'
  echo '   than the parallel tools (necessary for mapping grids with a single'
  echo '   point).'
  echo ' --machine (or -mach)'
  echo '   Name of the machine you are running on. Currently supports cheyenne only. Note that this script will determines the'
  echo '   machine name automatically from the hostfile command.'
  echo ' -d'
  echo '   toggle debug-only '
  echo ' --help or -h  '
  echo '   displays this help message'
  echo ''
  echo 'You can also set the following env variables:'
  echo '  ESMFBIN_PATH - Path to ESMF binaries '
  echo '                 (Leave unset on cheyenne and the tool'
  echo '                 will be loaded from modules)'
  echo '  MPIEXEC ------ Name of mpirun executable'
  echo '                 (default is mpirun.lsf on cheyenne; if'
  echo '                 you run interactively on cheyenne, mpi is not used)'
  echo '**********************************************************'
}

#===============================================================================
# runcmd subroutine
#===============================================================================
runcmd() {
  cmd=$@
  if [ -z "$cmd" ]; then
    echo "No command given to the runcmd function"
    exit 3
  fi

  if [ "$verbose" = "YES" ]; then
    echo "$cmd"
  fi

  if [ "$debug" != "YES" ]; then
    ${cmd}
    rc=$?
  else
    rc=0
  fi

  if [ $rc != 0 ]; then
    echo "Error status returned from create_ESMF_map script"
    exit 4
    undo
   fi

   return 0
}

#===============================================================================
# Main program
#===============================================================================

#-------------------------------------------------------------------------------
# Process input arguments
#-------------------------------------------------------------------------------

interactive="YES"
debug="no"
verbose="no"
type_src="global"
type_dst="global"
pass_thru=""
CLMNAME="FALSE"
serial="FALSE"
MACH="UNSET"
use_large="false"
CheckMapsFlag=""
use_rtm=0

while [ $# -gt 0 ]; do
  case $1 in
    -v )
      verbose="YES"
    ;;
    -b|--batch )
      interactive="NO"
    ;;
    --clm_name )
      CLMNAME="TRUE"
    ;;
    --serial )
      serial="TRUE"
    ;;
    -mach|--machine )
      MACH=$2
      shift
    ;;
    -big|--large_file )
      use_large="true"
    ;;
    -fsrc|--filesrc )
      fsrc=$2
      shift
    ;;
    -fdst|--filedst )
      fdst=$2
      shift
    ;;
    -nsrc|--namesrc )
      nsrc=$2
      shift
    ;;
    -ndst|--namedst )
      ndst=$2
      shift
    ;;
    -map|--maptype )
      map_type=$2
      echo "map_type is $map_type"
      shift
    ;;
    -tsrc|--typesrc )
      type_src=$2
      echo "type_src is $type_src"
      shift
    ;;
      -tdst|--typedst )
      type_dst=$2
      echo "type_dst is $type_dst"
      shift
    ;;
    --pass2esmf )
      pass_thru=$2
      echo "Sending ESMF_RegridWeightGen $pass_thru"
      shift
    ;;
    -h|--help )
      usage
      exit 0
    ;;
    * )
      echo "****************************"
      echo "ERROR:: invalid argument $1"
      echo "****************************"
      usage
      exit 1
    ;;
  esac

  shift 
done

#-------------------------------------------------------------------------------
# Determine machine to run on
#-------------------------------------------------------------------------------

if [ $MACH == "UNSET" ]; then
  hostname=`hostname`
  case $hostname in
    ch* )
      MACH="cheyenne"
    ;;
    de* )
      MACH="derecho"
    ;;
    *)
      echo "Machine $hostname NOT recognized"
    ;;   
  esac
fi

# Machine specific settings:
# 1) can not run in parallel interactively on cheyenne
if [ $MACH == "cheyenne" ] && [ $interactive == "YES" ]; then
  serial="TRUE"
fi

# check for required arguments
echo "fsrc is $fsrc"
echo "fdst is $fdst"
if [ -z "$fsrc" ]; then
  echo "Must specfiy -fsrc or --filesrc argument "
  echo "Invoke create_ESMF_map.sh -h for usage"
  exit 1
fi

if [ -z "$fdst" ]; then
  echo "Must specfiy -fdst or --filedst argument "
  echo "Invoke create_ESMF_map.sh -h for usage"
  exit 2
fi

if [ -z "$nsrc" ]; then
  echo "Must specfiy -nsrc or --namesrc argument "
  echo "Invoke create_ESMF_map.sh -h for usage"
  exit 3
fi

if [ -z "$ndst" ]; then
  echo "Must specfiy -ndst or --namedst argument "
  echo "Invoke create_ESMF_map.sh -h for usage"
  exit 4
fi

if [ -z "$map_type" ]; then
  echo "Must specfiy -map or --maptype argument "
  echo "Invoke create_ESMF_map.sh -h for usage"
  exit 5
fi

# check for existence of files
if [ ! -f "${fsrc}" ]; then
  echo "Source grid file does NOT exist: $fsrc}"
  exit 6
fi

if [ ! -f "${fdst}" ]; then
  echo "Destination grid file does NOT exist: $fdst"
  exit 7
fi

# check for type of map
if [ $map_type != "aave" ] && [ $map_type != "blin" ] && [ $map_type != "bilin" ] && [ $map_type != "nearestdtos" ] && [ $map_type != "neareststod" ] && [ $map_type != "patc" ]; then
  echo "ERROR: $map_type is not a valid type of mapping."
  echo "(must be aave, blin, bilin, patc, nearestdtos, or neareststod)"
  exit 8
fi

#-------------------------------------------------------------------------------
# Machine specific env stuff
#-------------------------------------------------------------------------------
 
case $MACH in
  ## cheyenne
  "cheyenne" )
    # From tcsh, script will not find module command
    # So check to see if module works, otherwise source an init file
    module list > /dev/null 2>&1 || source /etc/profile.d/modules.sh
    module purge
    module load intel/19.0.2
    module load nco
    module load esmf_libs/7.1.0r

    if [ $serial == "TRUE" ]; then
      module load esmf-7.1.0r-ncdfio-uni-O
      if [ -z "$MPIEXEC" ]; then
        MPIEXEC=""
      fi
    else
      module load esmf-6.3.0r-ncdfio-mpi-O
      if [ -z "$MPIEXEC" ]; then
        MPIEXEC="mpirun.lsf"
      fi
    fi
  ;;
  "derecho" )
    # From tcsh, script will not find module command
    # So check to see if module works, otherwise source an init file
    module list > /dev/null 2>&1 || source $LMOD_ROOT/lmod/init/zsh
    module --force purge
    module load ncarenv/23.06
    module load intel-oneapi/2023.0.0
    module load intel-mpi/2021.8.0
    module load esmf/8.4.2
    module load nco
    MPIEXEC=""
  ;;
  *)
    echo "Machine $MACH NOT recognized"
  ;;   
esac

#-------------------------------------------------------------------------------
# run ESMF_RegridWeightGen
#-------------------------------------------------------------------------------

# Resolve interactive or batch mode command
# NOTE - if you want to run in batch mode - you need to have a separate
# batch file that calls this script interactively - you cannot submit
# this script to the batch system

if [ "$interactive" = "YES" ]; then
  echo "Running interactively"
else
  echo "Running in batch mode"
fi

if [ ! -z $ESMFBIN_PATH ]; then
  ESMF_REGRID="$ESMFBIN_PATH/ESMF_RegridWeightGen"
else
  ESMF_REGRID="ESMF_RegridWeightGen"
fi

# Make sure $ESMF_REGRID is a valid command
command -v $ESMF_REGRID >/dev/null 2>&1 || { echo "Can not find ESMF_RegridWeightGen, make sure it is in your \$PATH or that you specify \$ESMFBIN_PATH." && exit 1; }

# Remove previous log files
rm -f PET*.Log

# Set output map name and create it
cdate=`date +%y%m%d`
if [ $CLMNAME == "TRUE" ]; then
  mapname=${nsrc}_to_${ndst}_${map_type}_da_c
else
  mapname=${nsrc}_TO_${ndst}_${map_type}.
fi
fmap=map_${mapname}${cdate}.nc

echo ""
echo "Creating $fmap..."

mapping="NULL"
case $map_type in
  "aave")
    mapping="conserve"
  ;;
  "blin" | "bilin")
    mapping="bilinear"
  ;;
  "patc")
    mapping="patch -p all"
  ;;
  "nearestdtos")
    mapping="nearestdtos"
  ;;
  "neareststod")
    mapping="neareststod"
  ;;
esac

if [ "$mapping" == "NULL" ]; then
  echo "ERROR: $map_type is not a valid option for --maptype"
  exit 9
fi
cmd="$MPIEXEC $ESMF_REGRID --ignore_unmapped -m $mapping -w $fmap -s $fsrc -d $fdst $pass_thru"

if [ $use_large == "true" ]; then
  cmd="$cmd --64bit_offset"
fi

if [ $type_src == "regional" ]; then
    cmd="$cmd --src_regional"
    echo "regional source"
fi
if [ $type_dst == "regional" ]; then
    cmd="$cmd --dst_regional"
    echo "regional destination"
fi
echo "cmd is $cmd"
if [ $serial == "TRUE" ]; then
  ESMF_RegridWeightGen --version | grep ESMF_VERSION_STRING
fi
echo ""
runcmd $cmd
if [ "$debug" != "YES" ] && [ ! -f "$fmap" ]; then
   echo "Output mapping file $fmap was NOT created: $fmap"
   exit 4
fi
HIST="$cmd"
HOST=`hostname`
ESMF_VER=`$MPIEXEC $ESMF_REGRID --version | grep VERSION_STRING | tr -d ' ' | sed s/:/": "/g`
if [ -z "$ESMF_VER" ]; then
  ESMF_VER="Version number unavailable, if CVS_revision att exists it contains version"
fi
ncatted -h -a creation_date,global,a,c,"`date`" -a created_by,global,a,c,"$LOGNAME" -a run_command,global,a,c,"$HIST" -a ESMF_ver,global,a,c,"$ESMF_VER" -a hostname,global,a,c,"$HOST" $fmap > /dev/null 2>&1 || { echo "WARNING: after creating $fmap, an error was encountered in ncatted. The map was generated correctly but its global attributes were not updated."; exit 0; }

echo "Successfully created mapping file $fmap "

#!/bin/bash
#===============================================================================
# Create needed mapping files for gen_domain and coupler mapping
# Currently supported on cheyenne, geyser, caldera, and prognhorn
#===============================================================================
echo $0
date
SDIR=`dirname $0`

#===============================================================================
# Usage subroutine
#===============================================================================
usage() {
  echo ''
  echo '**********************************************************'
  echo 'usage:'
  echo './gen_cesm_maps.sh'
  echo ' Create a suite of mapping files to use in CESM. Depending on the'
  echo ' grid files specified, the result will be a subset of the following'
  echo ' mapping files:'
  echo ' * atm -> ocn: conservative, bilinear, patch'
  echo ' * ocn -> atm: conservative, bilinear'
  echo ' * atm -> lnd: conservative, bilinear'
  echo ' * lnd -> atm: conservative'
  echo ' * ocn -> lnd: conservative'
  echo ' * lnd -> rtm: conservative'
  echo ' * rtm -> lnd: conservative'
  echo ' * lnd -> glc: conservative, bilinear'
  echo ' * glc -> lnd: conservative, bilinear'
  echo ''
  echo 'gen_cesm_maps.sh'
  echo '  --fileatm|-fatm  input atm_grid_filename'
  echo '  --fileocn|-focn  input ocn_grid_filename'
  echo '  --filelnd|-flnd  input lnd_grid_filename'
  echo '  --filertm|-frtm  input rtm_grid_filename'
  echo '  --fileglc|-fglc  input glc_grid_filename'
  echo '  --nameocn|-nocn  output ocn_name in mapping file'
  echo '  --nameatm|-natm  output atm_name in mapping file'
  echo '  --namelnd|-nlnd  output lnd_name in mapping file'
  echo '  --namertm|-nrtm  output rtm_name in mapping file'
  echo '  --nameglc|-nglc  output glc_name in mapping file'
  echo '  [ --typeocn|tocn ] [regional|global]'
  echo '  [ --typeatm|tatm ] [regional|global]'
  echo '  [ --nogridcheck ]'
  echo '  [ --batch|-b ]'
  echo '  [ --help|-h ]'
  echo '  [ -v ]'
  echo ''
  echo 'where'
  echo ' --fileatm (or -fatm)'
  echo '   SCRIP grid format atmosphere filename (full pathname)'
  echo ' --fileocn (or -focn)'
  echo '   SCRIP grid format ocean filename (full pathname)'
  echo ' --filelnd (or -flnd)'
  echo '   SCRIP grid format land filename (full pathname), must be global'
  echo ' --filertm (or -frtm)'
  echo '   SCRIP grid format runoff filename (full pathname)'
  echo ' --fileglc (or -fglc)'
  echo '   SCRIP grid format glc filename (full pathname), assumed to be regional'
  echo ' --nameatm (or -natm)'
  echo '   Shortname to use for atm in mapping filename'
  echo ' --nameocn (or -nocn)'
  echo '   Shortname to use for ocn in mapping filename'
  echo ' --namelnd (or -nlnd)'
  echo '   Shortname to use for lnd in mapping filename'
  echo ' --namertm (or -nrtm)'
  echo '   Shortname to use for rtm in mapping filename'
  echo ' --nameglc (or -nglc)'
  echo '   Shortname to use for glc in mapping filename'
  echo ' --typeocn (or -tocn)'
  echo '   ocean grid type,  valid values are regional or global'
  echo '   default is global'
  echo ' --typeatm (or -tatm)'
  echo '   atm grid type, valid values are regional or global'
  echo '   default is global'
  echo '   value must be global if -frtm and -nrtm are specified'
  echo ' --nogridcheck'
  echo '   By default, script will run consistency check on new'
  echo '   maps; this flag disables these checks'
  echo ' --serial'
  echo '   Run the ESMF tools in serial rather than parallel'
  echo ' -rc'
  echo '   Pass the "--recompile" flag to the ESMF tool'
  echo '   (Only necessary if nothing has been built in ../check_maps/)'
  echo ' --help or -h'
  echo '   displays this help message'
  echo ''
  echo 'Note: if rtm or glc are specified and lnd is not, then this tool will'
  echo '      assume lnd and atm are on the same grid.'
  echo ''
  echo 'You can also set the following env variables:'
  echo '  ESMFBIN_PATH - Path to ESMF binaries'
  echo '                 (Known machines will load tools from modules)'
  echo '  MPIEXEC ------ Name of mpirun executable'
  echo '                 (currently tools only run in serial due to module issues)'
  echo '**********************************************************'
}

#===============================================================================
# make_map subroutine
#===============================================================================
make_map() {
  make_map_exe=$SDIR/create_ESMF_map.sh
  fsrc=$1
  nsrc=$2
  fdst=$3
  ndst=$4
  tsrc=$5
  tdst=$6
  map=$7
  if [ "$serial" == "TRUE" ]; then
    run_serial="--serial"
  else
    run_serial=""
  fi
  export NCPUS=36
  $make_map_exe -fsrc $fsrc -nsrc $nsrc -fdst $fdst -ndst $ndst  \
                -tsrc $tsrc -tdst $tdst -map $map $run_serial   || exit $?
}

#===============================================================================
# runcmd subroutine
#===============================================================================
runcmd() {
   cmd=$@
   if [ -z "$cmd" ]; then
       echo "No command given to the runcmd function"
       exit 3
   fi
   if [ "$verbose" = "YES" ]; then
       echo "$cmd"
   fi
   ${cmd}
   rc=$?
   if [ $rc != 0 ]; then
       echo "Error status $rc returned from gen_cesm_maps script"
       exit $rc
   fi
   return 0
}

#===============================================================================
# Main program
#===============================================================================

#-------------------------------------------------------------------------------
# Process input arguments
#-------------------------------------------------------------------------------

verbose="no"
type_atm="global"
type_ocn="global"
CheckMapsFlag=""
atm_ocn=0
atm_lnd=0
lnd_rtm=0
ocn_lnd=0
lnd_glc=0
serial="FALSE"


while [ $# -gt 0 ]; do
   case $1 in
     -v)
	     verbose="YES"
	   ;;
     -focn|--fileocn )
	     focn=$2
	     shift
	   ;;
     -fatm|--fileatm )
  	   fatm=$2
  	   shift
	   ;;
     -flnd|--filelnd )
  	   flnd=$2
  	   shift
	   ;;
     -frtm|--filertm )
  	   frtm=$2
  	   shift
	   ;;
     -fglc|--fileglc )
  	   fglc=$2
  	   shift
	   ;;
     -nocn|--nameocn )
  	   nocn=$2
  	   shift
	   ;;
     -natm|--nameatm )
  	   natm=$2
  	   shift
	   ;;
     -nlnd|--namelnd )
  	   nlnd=$2
  	   shift
	   ;;
     -nrtm|--namertm )
  	   nrtm=$2
  	   shift
	   ;;
     -nglc|--nameglc )
  	   nglc=$2
  	   shift
	   ;;
     -tocn|--typeocn )
  	   type_ocn=$2
  	   shift
	   ;;
     --serial )
       serial=TRUE
     ;;
     --recompile|-rc )
  	   CheckMapsFlag=-rc
  	   echo "Will recompile ESMF gridcheck tool"
	   ;;
     --nogridcheck )
  	   SkipGridCheck=TRUE
  	   echo "Will not check quality of maps!"
	   ;;
     -tatm|--typeatm )
  	   type_atm=$2
  	   shift
	   ;;
     -h|--help )
  	   usage
  	   exit 0
	   ;;
     * )
  	   echo "****************************"
  	   echo "ERROR:: invalid argument $1"
  	   echo "****************************"
  	   usage
  	   exit 1
	   ;;
   esac
   shift
done

# Make file and name are specified for all desired grids
# (And that the files exist)
if [ ! -z "$fatm" ]; then
  if [ -z "$natm" ]; then
    echo "If you specify atm grid (-fatm), you must"\
         "also provide atm short name (-natm)."
    echo "Invoke gen_cesm_maps.sh -h for usage"
    exit 1
  fi
  if [ ! -f "${fatm}" ]; then
    echo "Atmosphere grid file does NOT exist: $fatm"
    exit 2
  fi
fi
if [ ! -z "$focn" ]; then
  if [ -z "$nocn" ]; then
    echo "If you specify ocn grid (-focn), you must"\
         "also provide ocn short name (-nocn)."
    echo "Invoke gen_cesm_maps.sh -h for usage"
    exit 3
  fi
  if [ ! -f "${focn}" ]; then
    echo "Ocean grid file does NOT exist: $focn"
    exit 4
  fi
fi
if [ ! -z "$flnd" ]; then
  if [ -z "$nlnd" ]; then
    echo "If you specify lnd grid (-flnd), you must"\
         "also provide lnd short name (-nlnd)."
    echo "Invoke gen_cesm_maps.sh -h for usage"
    exit 5
  fi
  if [ ! -f "${flnd}" ]; then
    echo "Land grid file does NOT exist: $flnd"
    exit 6
  fi
fi
if [ ! -z "$frtm" ]; then
  if [ -z "$nrtm" ]; then
    echo "If you specify rtm grid (-frtm), you must"\
         "also provide rtm short name (-nrtm)."
    echo "Invoke gen_cesm_maps.sh -h for usage"
    exit 7
  fi
  if [ ! -f "${frtm}" ]; then
    echo "Runoff grid file does NOT exist: $frtm"
    exit 8
  fi
fi
if [ ! -z "$fglc" ]; then
  if [ -z "$nglc" ]; then
    echo "If you specify glc grid (-fglc), you must"\
         "also provide glc short name (-nglc)."
    echo "Invoke gen_cesm_maps.sh -h for usage"
    exit 5
  fi
  if [ ! -f "${fglc}" ]; then
    echo "GLC grid file does NOT exist: $fglc"
    exit 6
  fi
fi

# Determine what maps to make
if [ ! -z "$fatm" ] && [ ! -z "$focn" ]; then
  atm_ocn=1
fi

if [ ! -z "$fatm" ] && [ ! -z "$flnd" ]; then
  atm_lnd=1
fi

if [ ! -z "$frtm" ]; then
  if [ ! -z "$flnd" ] || [ ! -z "$fatm" ]; then
    lnd_rtm=1
  fi
  if [ -z "$flnd" ]; then
    if [ "${type_atm}" == "regional" ]; then
      echo "WARNING: Can not use regional atmosphere to create atm2rtm map!"
      lnd_rtm=0
    else
      echo "Assuming atmosphere and land grid are identical, generating"\
           "atm2rof and rof2atm maps"
      nlnd=$natm
      flnd=$fatm
    fi
  fi
fi

if [ ! -z "$fglc" ]; then
  if [ ! -z "$flnd" ] || [ ! -z "$fatm" ]; then
    lnd_glc=1
  fi
  if [ -z "$flnd" ]; then
    if [ "${type_atm}" == "regional" ]; then
      echo "WARNING: Can not use regional atmosphere to create atm2glc map!"
      lnd_glc=0
    else
      echo "Assuming atmosphere and land grid are identical, generating"\
           "atm2glc and glc2atm maps"
      nlnd=$natm
      flnd=$fatm
    fi
  fi
fi

if [ ! -z "$focn" ] && [ ! -z "$flnd" ]; then
  ocn_lnd=1
fi

# See if any maps are being made
if [ $((atm_ocn+atm_lnd+lnd_rtm+lnd_glc+ocn_lnd)) == 0 ]; then
  echo "ERROR: can not generate any maps based on given input!"
  echo "Invoke gen_cesm_maps.sh -h for usage"
  exit 9
fi

#-------------------------------------------------------------------------------
# run ESMF_RegridWeightGen
#-------------------------------------------------------------------------------

cdate=`date +%y%m%d`
file_list=""

#-------------------------------------------------------------------------------
# Make Maps
#-------------------------------------------------------------------------------

if [ ${atm_ocn} == 1 ]; then
  #--- ocn to atm conservative (area avg?) -------------------------------------
  make_map "$focn" "$nocn" "$fatm" "$natm" "$type_ocn" "$type_atm" "aave"
  file_list="$file_list map_${nocn}_TO_${natm}_aave.$cdate.nc"

  #--- ocn to atm bilinear (non-conservative) ----------------------------------
  echo ""
  echo "----------------------------------------------------------"
  echo ""
  make_map "$focn" "$nocn" "$fatm" "$natm" "$type_ocn" "$type_atm" "blin"
  file_list="$file_list map_${nocn}_TO_${natm}_blin.$cdate.nc"

  #--- atm to ocn conservative (area avg?) -------------------------------------
  echo ""
  echo "----------------------------------------------------------"
  echo ""
  make_map "$fatm" "$natm" "$focn" "$nocn" "$type_atm" "$type_ocn" "aave"
  file_list="$file_list map_${natm}_TO_${nocn}_aave.$cdate.nc"

  #--- atm to ocn bilinear (non-conservative) ----------------------------------
  echo ""
  echo "----------------------------------------------------------"
  echo ""
  make_map "$fatm" "$natm" "$focn" "$nocn" "$type_atm" "$type_ocn" "blin"
  file_list="$file_list map_${natm}_TO_${nocn}_blin.$cdate.nc"

  #--- atm to ocn patch mapping (non-conservative) -------------------------------
  echo ""
  echo "----------------------------------------------------------"
  echo ""
  make_map "$fatm" "$natm" "$focn" "$nocn" "$type_atm" "$type_ocn" "patc"
  file_list="$file_list map_${natm}_TO_${nocn}_patc.$cdate.nc"
fi

if [ $atm_lnd == 1 ]; then
  #--- atm to lnd conservative (area avg?) -------------------------------------
  if [ ! -z "$file_list" ]; then
    echo ""
    echo "----------------------------------------------------------"
    echo ""
  fi
  make_map "$fatm" "$natm" "$flnd" "$nlnd" "$type_atm" "global" "aave"
  file_list="$file_list map_${natm}_TO_${nlnd}_aave.$cdate.nc"

  #--- atm to lnd bilinear (non-conservative) ----------------------------------
  echo ""
  echo "----------------------------------------------------------"
  echo ""
  make_map "$fatm" "$natm" "$flnd" "$nlnd" "$type_atm" "global" "blin"
  file_list="$file_list map_${natm}_TO_${nlnd}_blin.$cdate.nc"

  #--- lnd to atm conservative (area avg?) -------------------------------------
  echo ""
  echo "----------------------------------------------------------"
  echo ""
  make_map "$flnd" "$nlnd" "$fatm" "$natm" "global" "$type_atm" "aave"
  file_list="$file_list map_${nlnd}_TO_${natm}_aave.$cdate.nc"

fi

if [ $ocn_lnd == 1 ]; then
  #--- ocn to lnd conservative (area avg) -------------------------------------
  if [ ! -z "$file_list" ]; then
    echo ""
    echo "----------------------------------------------------------"
    echo ""
  fi
  make_map "$focn" "$nocn" "$flnd" "$nlnd" "$type_ocn" "global" "aave"
  file_list="$file_list map_${nocn}_TO_${nlnd}_aave.$cdate.nc"
fi

if [ $lnd_rtm == 1 ]; then
  #--- lnd to rtm conservative (area avg) -------------------------------------
  if [ ! -z "$file_list" ]; then
    echo ""
    echo "----------------------------------------------------------"
    echo ""
  fi
  make_map "$flnd" "$nlnd" "$frtm" "$nrtm" "global" "global" "aave"
  file_list="$file_list map_${nlnd}_TO_${nrtm}_aave.$cdate.nc"

  #--- rtm to lnd conservative (area avg) -------------------------------------
  echo ""
  echo "----------------------------------------------------------"
  echo ""
  make_map "$frtm" "$nrtm" "$flnd" "$nlnd" "global" "global" "aave"
  file_list="$file_list map_${nrtm}_TO_${nlnd}_aave.$cdate.nc"

fi

if [ $lnd_glc == 1 ]; then
  #--- glc to lnd conservative (area avg?) -------------------------------------
  if [ ! -z "$file_list" ]; then
    echo ""
    echo "----------------------------------------------------------"
    echo ""
  fi
  make_map "$fglc" "$nglc" "$flnd" "$nlnd" "regional" "global" "aave"
  file_list="$file_list map_${nglc}_TO_${nlnd}_aave.$cdate.nc"

  #--- lnd to glc conservative (area avg?) -------------------------------------
  echo ""
  echo "----------------------------------------------------------"
  echo ""
  make_map "$flnd" "$nlnd" "$fglc" "$nglc" "global" "regional" "aave"
  file_list="$file_list map_${nlnd}_TO_${nglc}_aave.$cdate.nc"

  #--- lnd to glc bilinear (non-conservative) ----------------------------------
  echo ""
  echo "----------------------------------------------------------"
  echo ""
  make_map "$flnd" "$nlnd" "$fglc" "$nglc" "global" "regional" "blin"
  file_list="$file_list map_${nlnd}_TO_${nglc}_blin.$cdate.nc"

fi

# Run ESMF Regrid Weight Check tool
if [ ! -z "$SkipGridCheck" ]; then
	echo "Skipping the consistency check"
	rm -f hostfile
	exit 0
fi
echo ""
echo "----------------------------------------------------------"
echo ""

CHECK_MAP="$SDIR/../check_maps/check_map.sh ${CheckMapsFlag}"

echo "Running ESMF Regrid Weight Check tool for each generated map"
echo CHECK_MAP = ${CHECK_MAP}
echo file_list = ${file_list}
echo ""
runcmd "${CHECK_MAP} ${file_list}"

rm -f hostfile

if [ ! -z "$MP_EUIDEVICE_tmp" ]; then
	# Re-enable MP_EUIDEVICE (if previously defined)
	export MP_EUIDEVICE=$MP_EUIDEVICE_tmp
fi

if [ ! -z "$MP_INSTANCES_tmp" ]; then
	# Re-enable MP_EUIDEVICE (if previously defined)
	export MP_INSTANCES=$MP_INSTANCES_tmp
fi

exit 0

#===============================================================================

# create a series of regional maps
for pt in sp np q1 q2 q3 q4 ; do

ocnres=<ocnres>    #ie gx1PETM
date=<date>        #yymmdd

# space = 20 : fast, defines how many gridcells are plotted
ncl 'space=20' 'type="reg"' 'expt="'${ocnres}'"' 'plot_type="'${pt}'"' 'date="'${date}'"' plot_global_all.ncl

done

#!/bin/bash
#
#
# Batch script to submit to create mapping files for all standard
# resolutions.  If you provide a single resolution via "$RES", only
# that resolution will be used. In that case: If it is a regional or
# single point resolution, you should set 'BSUB -n' to 1, and be sure
# that '-t regional' is specified in cmdargs.
#
# Currently only setup to run on yellowstone/caldera/geyser. Note that
# geyser is needed for very high resolution files (e.g., 1 km) because
# of its large memory per node, so that is set as the default.
# However, for coarser resolutions, you may get better performance on
# caldera or yellowstone.
# 

# cheyenne specific batch commands:
#PBS -A #########
#PBS -N regridbatch_paleo
#PBS -q regular
#PBS -l select=8:ncpus=36:mpiprocs=36:ompthreads=1
#PBS -l walltime=01:00:00
#PBS -j oe
#PBS -S /bin/csh -V


#----------------------------------------------------------------------
# Set parameters
#----------------------------------------------------------------------
# Which version of CLM to generate mapping files for
# Can be clm4_0 or clm4_5
phys="clm4_0"
#phys="clm4_5"

# hardcode paleo model resolution for output grid
# e.g. "1.9x2.5", "0.9x1.25"
resols="<output_resolution>"
echo "Run for paleo  $resols resolution"

#----------------------------------------------------------------------
# Begin main script
#----------------------------------------------------------------------

# if [ -z "$RES" ]; then
   # echo "Run for all valid resolutions"
   # resols=`../../../bld/queryDefaultNamelist.pl -res list -silent -phys $phys`
# else
   # resols="$RES"
# fi
# echo "Create mapping files for this list of resolutions: $resols"


#----------------------------------------------------------------------

for res in $resols; do
   echo "Create mapping files for: $res"
#----------------------------------------------------------------------
   cmdargs="--phys $phys -r $res -b"

   # For single-point and regional resolutions, tell mkmapdata that
   # output type is regional
   if [[ `echo "$res" | grep -c "1x1_"` -gt 0 || `echo "$res" | grep -c "5x5_"` -gt 0 ]]; then
       res_type="regional"
   else
       res_type="global"
   fi

   cmdargs="$cmdargs -t $res_type"

   if [ $res_type = "regional" ]; then
       # For regional and (especially) single-point grids, we can get
       # errors when trying to use multiple processors - so just use 1.
       # We also do NOT set batch mode in this case, because some
       # machines (e.g., yellowstone) do not listen to REGRID_PROC, so to
       # get a single processor, we need to run mkmapdata.sh in
       # interactive mode.
       regrid_num_proc=1
   else
       regrid_num_proc=8
       if [ ! -z $LSF_PJL_TYPE ]; then
	   cmdargs="$cmdargs -b"
       fi
   fi

   csmsrc="<directory_with_model_code>"   
   time env CSMSRC=$csmsrc REGRID_PROC=$regrid_num_proc ./mkmapdata_paleo.sh $cmdargs
done

#!/bin/csh -fv 

set echo
# set verbose
###################################################################
# Required input file:  
# topography/bathymetry file at 0.5,1 or 2deg (others not tested)
# variable in topo/bath file is assumed to be named "topo"
###################################################################
#Define global variables:

set CASE  = <casename>
set ITER   = 1   			# iteration 
set topopath = <path_to_topo_file>
set topofile  = <topo-bath_file>
set vrtgridpath = <path_to_vrtgrid_file>
set vrtgrid = <vertical_grid_file>
set DATE  = "`date +%y%m%d`"

if ( (! -e $topopath/$topofile) ) then
	echo ''
	echo 'FATAL ERROR: topo file does not exist',$topopath/$topofile
	exit
   endif
endif
if ( (! -e $vrtgridpath/$vrtgrid) ) then
	echo ''
	echo 'FATAL ERROR: vertical grid file does not exist',$vrtgridpath/$vrtgrid
	exit
   endif
endif

###################################################################
# User changes:  For each new horizontal grid you must edit the following parameters:
###################################################################

# Change for your continent distribution 
# ncview your topo_0.5x0.5 map to see where to place the poles over land.
# NOTES:  latitude and  longitude must be btwn -180 : 180
set lonnp   =   50.  		# longitude of North Pole (must be btwn -180 : 180)
set latnp   =   75.   		# latitude  of North Pole
set lonsp   =   50.   		# longitude of South Pole (must be btwn -180 : 180)
set latsp   =  -69.   		# latitude  of South Pole

# change iteratively after you look at your grid.
# Use these to adjust gridcell distribution so you don't have big
# cells in the N. Hem and small cells in the S. Hem, for example.
set nlatn   = 205   		# number of j grid lines in NH
set nlats   = 179   		# number of j grid lines in SH

set nx      = 320  		# number of i grid lines
set nz      = 60		# number of vertical grid levels (gx1v6 = 60)
set dyeq    = .26   		# dy in degrees at Equator 	        (roughly equal to modern TLAT)
set dsig    = 23.  		# Gaussian efold-scale at equator
set jcon    = 11    		# jcon = # rows of constant dy at poles


# Don't change
set popgrid = grid.$ITER.pop.da	# binary grid file
set pltgrid = grid.$ITER.plot.da	# binary grid file
set cdfgrid = gridkmt.$ITER.nc		# netcdf grid file
set depgrid = h.$ITER.da		# binary depth array
set kmtgrid = kmt.$ITER.da		# binary kmt file
set minz     = 5.		# min z in meters (Don't lower!!!)
set mink     = 3		# minimum allowed km value (Don't lower!!!)
@ ny      = $nlatn + $nlats  	# number of j grid lines

# not used
set iocean   = 50		# ocean (i,j) point used to define
set jocean   = 60		#	contiguous ocean.

# !!!SET PLOTTING VIEWPOINTS BELOW!!!

#################################
# SET HERE FILE INPUT
#################################

cat >! input.$ITER.ns_dipole << EOF
$nx $nlatn $nlats
$lonnp $latnp
$lonsp $latsp
$dyeq $dsig $jcon
1
$pltgrid
1
$popgrid
EOF

cat >! input.$ITER.paleotopo << EOF
$nx $ny $nz
$pltgrid
$vrtgrid
$topofile
1
$depgrid
$minz
1
0
$mink
1
$kmtgrid
EOF

cat >! input.$ITER.grid_bin2nc << EOF
$nx
$ny
$cdfgrid
$vrtgrid
$kmtgrid
$pltgrid
$popgrid
EOF

#################################
#get input data:
ln -s $topopath/$topofile .
ln -s $vrtgridpath/$vrtgrid .

#################################
# RUN GRID ROUTINES
# This must have been compiled. 
#################################
./ns_dipole < input.$ITER.ns_dipole  >! output.$ITER.ns_dipole
./paleotopo < input.$ITER.paleotopo  >! output.$ITER.paleotopo
./grid_bin2nc < input.$ITER.grid_bin2nc >! output.$ITER.bin2nc

#################################
# CLEAN UP
#################################
#/usr/bin/rm -f input.ns_dipole input.paleotopo input.display_hgrid_land

exit(0)

#!/bin/csh

# Notes:
# - will build the CCSM runoff correcting/smoothing code in ./obj
# - must specify location of src code, Makefile, Macros file, dependancy generator 
#===============================================================================

setenv SRCDIR `pwd`/src
setenv TOOLDIR `pwd`/tools

echo source dir: $SRCDIR

if !(-d obj) mkdir obj
cd obj

cc -o makdep $TOOLDIR/makdep.c

echo $SRCDIR  >! Filepath

gmake VPFILE=Filepath THREAD=TRUE -f $SRCDIR/Makefile MACFILE=$SRCDIR/Macros.cheyenne || exit -1

cd ..
rm              runoff_map
ln -s obj/a.out runoff_map

#!/bin/bash
#----------------------------------------------------------------------
#
# mkmapdata.sh
#
# Create needed mapping files for mksurfdata_map and CLM.
# 
# Example to run for an output resolution of 4x5
#
# mkmapdata.sh -r 4x5
#
# valid arguments: 
# -f <scripfilename> Input grid filename 
# -t <type>          Output type, supported values are [regional, global]
# -r <res>           Output resolution
# -p <CLM-version>   CLM version to use (clm4_0 or clm4_5) (defaults to clm4_5)
# -b                 use batch mode (not default)
# -l                 list mapping files required (so can use check_input_data to get them)
# -d                 debug usage -- display mkmapdata that will be run but don't execute them
# -v                 verbose usage -- log more information on what is happening
# -h                 displays this help message
#
# You can also set the following env variables:
#
# ESMFBIN_PATH - Path to ESMF binaries
# CSMDATA ------ Path to CESM input data
# MPIEXEC ------ Name of mpirun executable
# REGRID_PROC -- Number of MPI processors to use
#
#----------------------------------------------------------------------
echo $0
dir=${0%/*}
if [ "$dir" = "$0" ];then
  dir="."
fi
outfilelist="clm.input_data_list"
default_res="1.9x2.5"		# output resolution

#----------------------------------------------------------------------
# SET SOME DEFAULTS -- if not set via env variables outside

if [ -z "$CSMDATA" ]; then
   CSMDATA=/glade/p/cesm/cseg/inputdata
fi
if [ -z "$REGRID_PROC" ]; then
   REGRID_PROC=8
fi
#----------------------------------------------------------------------
# Usage subroutine
usage() {
  echo ""
  echo "**********************"
  echo "usage on yellowstone:"
  echo "./mkmapdata_paleo.sh"
  echo ""
  echo "valid arguments: "
  echo "[-f|--gridfile <gridname>] "
  echo "     Full pathname of model SCRIP grid file to use "
  echo "     This variable should be set if this is not a supported grid" 
  echo "     This variable will override the automatic generation of the"
  echo "     filename generated from the -res argument "
  echo "     the filename is generated ASSUMING that this is a supported "
  echo "     grid that has entries in the file namelist_defaults_clm.xml"
  echo "     the -r|--res argument MUST be specied if this argument is specified" 
  echo "[-r|--res <res>]"
  echo "     Model output resolution (default is $default_res)"
  echo "[-t|--gridtype <type>]"
  echo "     Model output grid type"
  echo "     supported values are [regional,global], (default is global)"
  echo "[-p|--phys <CLM-version>]"
  echo "     Whether to generate mapping files for clm4_0 or clm4_5"
  echo "     supported values are [clm4_0,clm4_5], (default is clm4_5)"
  echo "[-b|--batch]"
  echo "     Toggles batch mode usage. If you want to run in batch mode"
  echo "     you need to have a separate batch script for a supported machine"
  echo "     that calls this script interactively - you cannot submit this"
  echo "     script directory to the batch system"
  echo "[-l|--list]"
  echo "     List mapping files required (use check_input_data to get them)"
  echo "     also writes data to $outfilelist"
  echo "[-d|--debug]"
  echo "     Toggles debug-only (don't actually run mkmapdata just echo what would happen)"
  echo "[-h|--help]  "
  echo "     Displays this help message"
  echo "[-v|--verbose]"
  echo "     Toggle verbose usage -- log more information on what is happening "
  echo ""
  echo " You can also set the following env variables:"
  echo "  ESMFBIN_PATH - Path to ESMF binaries "
  echo "                 (default is /contrib/esmf-5.3.0-64-O/bin)"
  echo "  CSMDATA ------ Path to CESM input data"
  echo "                 (default is /glade/p/cesm/cseg/inputdata)"
  echo "  MPIEXEC ------ Name of mpirun executable"
  echo "                 (default is mpirun.lsf)"
  echo "  REGRID_PROC -- Number of MPI processors to use"
  echo "                 (default is 8)"
  echo ""
  echo "**pass environment variables by preceding above commands "
  echo "  with 'env var1=setting var2=setting '"
  echo "**********************"
}
#----------------------------------------------------------------------
# runcmd subroutine
#----------------------------------------------------------------------

runcmd() {
   cmd=$@
   if [ -z "$cmd" ]; then
       echo "No command given to the runcmd function"
       exit 3
   fi
   if [ "$verbose" = "YES" ]; then
       echo "$cmd"
   fi
   if [ "$debug" != "YES" ]; then
       ${cmd}
       rc=$?
   else
       rc=0
   fi
   if [ $rc != 0 ]; then
       echo "Error status returned from mkmapdata script"
       exit 4
undo
   fi
   return 0
}

#----------------------------------------------------------------------
# Process input arguments
#----------------------------------------------------------------------

interactive="YES"
debug="no"
res="default"
type="global"
phys="clm4_5"
verbose="no"
list="no"
outgrid=""
gridfile="default"

while [ $# -gt 0 ]; do
   case $1 in
       -v|-V)
	   verbose="YES"
	   ;;
       -b|--batch) 
	      interactive="NO"
	      ;;
       -d|--debug)
	   debug="YES"
	   ;;
       -l|--list)
	   debug="YES"
	   list="YES"
	   ;;
       -r|--res)
	   res=$2
	   shift
	   ;;
       -f|--gridfile)
	   gridfile=$2
	   shift
	   ;;
       -t|--gridtype)
	   type=$2
	   shift
	   ;;
       -p|--phys)
	   phys=$2
	   shift
	   ;;
       -h|--help )
	   usage
	   exit 0
	   ;;
       * )
	   echo "ERROR:: invalid argument sent in: $2"
	   usage
	   exit 1
	   ;;
   esac
   shift
done

echo "Script to create mapping files required by mksurfdata_map"

#----------------------------------------------------------------------
# Determine output scrip grid file
#----------------------------------------------------------------------

# Set general query command used below
QUERY="$CSMSRC/models/lnd/clm/bld/queryDefaultNamelist.pl -silent -namelist clmexp -phys $phys "
QUERY="$QUERY -justvalue -options sim_year=2000 -csmdata $CSMDATA"
echo "query command is $QUERY"

echo ""
DST_EXTRA_ARGS=""
if [ "$gridfile" != "default" ]; then
    GRIDFILE=$gridfile
    echo "Using user specified scrip grid file: $GRIDFILE" 
    if [ "$res" = "default" ]; then
       echo "When user specified grid file is given you MUST set the resolution (as the name of your grid)\n";
       exit 1
    fi
    
    # For now, make some assumptions about user-specified grids --
    # that they are SCRIP format, and small enough to not require
    # large file support for the output mapping file. In the future,
    # we may want to provide command-line options to allow the user to
    # override these defaults.
    DST_LRGFIL="none"
    DST_TYPE="SCRIP"
else
    if [ "$res" = "default" ]; then
       res=$default_res
    fi

    QUERYARGS="-res $res -options lmask=nomask"

    # Find the output grid file for this resolution using the XML database
    QUERYFIL="$QUERY -var scripgriddata $QUERYARGS -onlyfiles"
    if [ "$verbose" = "YES" ]; then
	echo $QUERYFIL
    fi
    GRIDFILE=`$QUERYFIL`
    echo "Using default scrip grid file: $GRIDFILE" 

    # Determine extra information about the destination grid file
    DST_LRGFIL=`$QUERY -var scripgriddata_lrgfile_needed $QUERYARGS`
    DST_TYPE=`$QUERY -var scripgriddata_type $QUERYARGS`
    if [ "$DST_TYPE" = "UGRID" ]; then
        # For UGRID, we need extra information: the meshname variable
	dst_meshname=`$QUERY -var scripgriddata_meshname $QUERYARGS`
	DST_EXTRA_ARGS="$DST_EXTRA_ARGS --dst_meshname $dst_meshname"
    fi
fi

if [ "$type" = "global" ] && [ `echo "$res" | grep -c "1x1_"` = 1 ]; then
   echo "This is a regional resolution and yet it is being run as global, set type with '-t' option\n";
   exit 1
fi
echo "Output grid resolution is $res"
if [ -z "$GRIDFILE" ]; then
   echo "Output grid file was NOT found for this resolution: $res\n";
   exit 1
fi

if [ "$list" = "YES" ]; then
   echo "outgrid = $GRIDFILE"
   echo "outgrid = $GRIDFILE" > $outfilelist
elif [ ! -f "$GRIDFILE" ]; then
   echo "Input SCRIP grid file does NOT exist: $GRIDFILE\n";
   echo "Make sure CSMDATA environment variable is set correctly"
   exit 1
fi

#----------------------------------------------------------------------
# Determine all input grid files and output file names 
#----------------------------------------------------------------------

if [ "$phys" = "clm4_0" ]; then
    grids=(                    \
	   "<res>_<casename>" )		# +nanr : Change me

elif [ "$phys" = "clm4_5" ]; then
    grids=(                    \
           "0.5x0.5_AVHRR"     \
           "0.5x0.5_MODIS"     \
           "3x3min_LandScan2004" \
           "3x3min_MODIS"      \
           "3x3min_USGS"       \
           "5x5min_nomask"     \
           "5x5min_IGBP-GSDP"  \
           "5x5min_ISRIC-WISE" \
           "10x10min_nomask"   \
           "10x10min_IGBPmergeICESatGIS" \
           "3x3min_GLOBE-Gardner" \
           "3x3min_GLOBE-Gardner-mergeGIS" \
           "0.9x1.25_GRDC" \
           "360x720cru_cruncep" \
           "1km-merge-10min_HYDRO1K-merge-nomask" )

else
    echo "ERROR: Unknown value for phys: $phys"
    exit 1
fi

# Set timestamp for names below 
CDATE="c"`date +%y%m%d`

# Set name of each output mapping file
# First determine the name of the input scrip grid file  
# for each of the above grids
declare -i nfile=1
for gridmask in ${grids[*]}
do
   grid=${gridmask%_*}
   lmask=${gridmask#*_}

   QUERYARGS="-res $grid -options lmask=$lmask,glc_nec=10 "

   #  QUERYFIL="$QUERY -var scripgriddata $QUERYARGS -onlyfiles"		
   # if [ "$verbose" = "YES" ]; then
   #    echo $QUERYFIL
   # fi
   # INGRID[nfile]=`$QUERYFIL`
   INGRID[nfile]="./<scripgrid_file>"	# +nanr : Change me
   if [ "$list" = "YES" ]; then
      echo "ingrid = ${INGRID[nfile]}"
      echo "ingrid = ${INGRID[nfile]}" >> $outfilelist
   fi

   OUTFILE[nfile]=map_${grid}_${lmask}_to_${res}_nomask_aave_da_$CDATE.nc

   # Determine extra information about the source grid file
   # SRC_EXTRA_ARGS[nfile]=""
   # SRC_LRGFIL[nfile]=`$QUERY -var scripgriddata_lrgfile_needed $QUERYARGS`
   # SRC_TYPE[nfile]=`$QUERY -var scripgriddata_type $QUERYARGS`
   SRC_TYPE[nfile]="SCRIP"
   # if [ "${SRC_TYPE[nfile]}" = "UGRID" ]; then
       # For UGRID, we need extra information: the meshname variable
       # src_meshname=`$QUERY -var scripgriddata_meshname $QUERYARGS`
       # SRC_EXTRA_ARGS[nfile]="${SRC_EXTRA_ARGS[nfile]} --src_meshname $src_meshname"
   # fi

   nfile=nfile+1
done

#----------------------------------------------------------------------
# Determine supported machine specific stuff
#----------------------------------------------------------------------

hostname=`hostname`
case $hostname in
  ##cheyenne
  chey* | r* )
  module load intel/17.0.1
  module load esmf_libs/7.0.0
  module load esmf-7.0.0-ncdfio-mpi-O
  module load nco
  ESMFBIN_PATH=/glade/u/apps/ch/opt/esmf/7.0.0-ncdfio-mpi/intel/17.0.1/bin/binO/Linux.intel.64.mpi.default
  MPIEXEC="mpiexec_mpt"
  ;;


  ##jaguarpf
  ## NOTE that for jaguarpf there is no batch script for now
  jaguarpf* )
  if [ -z "$ESMFBIN_PATH" ]; then
     module load esmf/5.2.0-p1_with-netcdf_g
     ESMFBIN_PATH=$ESMF_BINDIR
  fi
  if [ -z "$MPIEXEC" ]; then
    MPIEXEC="aprun -n $REGRID_PROC"
  fi
  ;;

  ##no other machine currently supported    
  *)
  echo "Machine $hostname NOT recognized"
  ;;

esac

# Error checks
if [ ! -d "$ESMFBIN_PATH" ]; then
    echo "Path to ESMF binary directory does NOT exist: $ESMFBIN_PATH"
    echo "Set the environment variable: ESMFBIN_PATH"
    exit 1
fi

#----------------------------------------------------------------------
# Generate the mapping files needed for surface dataset generation
#----------------------------------------------------------------------
 
# Resolve interactive or batch mode command
# NOTE - if you want to run in batch mode - you need to have a separate
# batch file that calls this script interactively - you cannot submit
# this script to the batch system

if [ "$interactive" = "NO" ]; then
   echo "Running in batch mode using MPI"
   if [ -z "$MPIEXEC" ]; then
      echo "Name of MPI exec to use was NOT set"
      echo "Set the environment variable: MPIEXEC"
      exit 1
   fi
   if [ ! -x `which $MPIEXEC` ]; then
      echo "The MPIEXEC pathname given is NOT an executable: $MPIEXEC"
      echo "Set the environment variable: MPIEXEC or run in interactive mode without MPI"
      exit 1
   fi
   mpirun=$MPIEXEC
   echo "Running in batch mode"
else
   mpirun=""
fi
  
ESMF_REGRID=`which ESMF_RegridWeightGen` 
if [ ! -x "$ESMF_REGRID" ]; then
    echo "ESMF_RegridWeightGen does NOT exist in ESMF binary directory: $ESMFBIN_PATH\n"
    echo "Upgrade to a newer version of ESMF with this utility included"
    echo "Set the environment variable: ESMFBIN_PATH"
    exit 1
fi

# Remove previous log files
rm PET*.Log

#
# Now run the mapping for each file, checking that input files exist
# and then afterwards that the output mapping file exists
#
declare -i nfile=1
until ((nfile>${#INGRID[*]})); do
   echo "Creating mapping file: ${OUTFILE[nfile]}"
   echo "From input grid: ${INGRID[nfile]}"
   echo "For output grid: $GRIDFILE"
   echo " "
   if [ -z "${INGRID[nfile]}" ] || [ -z "$GRIDFILE" ] || [ -z "${OUTFILE[nfile]}" ]; then
      echo "Either input or output grid or output mapping file is NOT set"
      exit 3
   fi
   if [ ! -f "${INGRID[nfile]}" ]; then
      echo "Input grid file does NOT exist: ${INGRID[nfile]}"
      if [ ! "$list" = "YES" ]; then
         exit 2
      fi
   fi
   if [ ! -f "$GRIDFILE" ]; then
      echo "Output grid file does NOT exist: $GRIDFILE"
      exit 3
   fi

   # Determine what (if any) large file support is needed. Use the
   # most extreme large file support needed by either the source file
   # or the destination file.
   # if [ "$DST_LRGFIL" = "netcdf4" ] || [ "${SRC_LRGFIL[nfile]}" = "netcdf4" ]; then		# nanr
   #   lrgfil="--netcdf4"
   # elif [ "$DST_LRGFIL" = "64bit_offset" ] || [ "${SRC_LRGFIL[nfile]}" = "64bit_offset" ]; then
   #   lrgfil="--64bit_offset"
   # elif [ "$DST_LRGFIL" = "none" ] && [ "${SRC_LRGFIL[nfile]}" = "none" ]; then
   #   lrgfil=""
   # else
   #   echo "Unknown LRGFIL type:"
   #   echo "DST_LRGFIL = $DST_LRGFIL"
   #   echo "SRC_LRGFIL = ${SRC_LRGFIL[nfile]}"
   #   exit 4
   # fi

   # WJS (4-11-13): The current release version of the ESMF regridding
   # tool doesn't handle netcdf4 output, and doesn't (properly?)
   # handle UGRID format. Thus, for now we need this kludge to use a
   # different version if we need either of those features.
   MY_ESMF_REGRID=$ESMF_REGRID
   if [ "$lrgfil" = "--netcdf4" ] || [ ${SRC_TYPE[nfile]} = "UGRID" ] || [ $DST_TYPE = "UGRID" ]; then
       case $hostname in
	   ys* | caldera* | geyser* )
	       if [ $mpitype = "mpiuni" ]; then
		   MY_ESMF_REGRID=/glade/p/work/svasquez/ESMF620bs18-mpiuni/bin/ESMF_RegridWeightGen
	       else
		   MY_ESMF_REGRID=/glade/p/work/svasquez/ESMF620bs18/bin/ESMF_RegridWeightGen
	       fi
	       ;;
	   *)
	       echo "No support for --netcdf4 or UGRID on machines other than yellowstone/caldera/geyser"
	       exit 5
	       ;;
       esac
   fi

   # Skip if file already exists
   if [ -f "${OUTFILE[nfile]}" ]; then
      echo "Skipping creation of ${OUTFILE[nfile]} as already exists"
   else

      cmd="$mpirun $MY_ESMF_REGRID --ignore_unmapped -s ${INGRID[nfile]} "
      cmd="$cmd -d $GRIDFILE -m conserve -w ${OUTFILE[nfile]}"
      if [ $type = "regional" ]; then
        cmd="$cmd --dst_regional"
      fi

      cmd="$cmd --src_type ${SRC_TYPE[nfile]} ${SRC_EXTRA_ARGS[nfile]} --dst_type $DST_TYPE $DST_EXTRA_ARGS"
      cmd="$cmd $lrgfil"

      runcmd $cmd

      if [ "$debug" != "YES" ] && [ ! -f "${OUTFILE[nfile]}" ]; then
         echo "Output mapping file was NOT created: ${OUTFILE[nfile]}"
         exit 6
      fi
      # add some metadata to the file
      HOST=`hostname`
      history="$MY_ESMF_REGRID"
      runcmd "ncatted -a history,global,a,c,"$history"  ${OUTFILE[nfile]}"
      runcmd "ncatted -a hostname,global,a,c,$HOST   -h ${OUTFILE[nfile]}"
      runcmd "ncatted -a logname,global,a,c,$LOGNAME -h ${OUTFILE[nfile]}"

   fi

   nfile=nfile+1
done

echo "Successffully created needed mapping files for $res"

exit 0

#!/bin/csh -f
# set echo
# set verbose
#----------------------- rdirc.csh --------------------------------------
# Revised - July 2013 - nanr
# -------------------------------------------------------------------
#
# this cshell script runs the program topo2rdirc.F90 
#
# -------------------------------------------------------------------
# Notes
# -------------------------------------------------------------------
# Start with topography and end with river directions map.
# Simpler procedure than Graham et al. (1999), because
# we have no idea where the rivers were in the geologic past.
#
# The output consists of two ascii files: fort.10 and fort.11.
# The former is the river directions map in the format required by CLM.
# The latter lists all grid cells involved in infinite river loops.
# The user must redirect rivers in the vicinity of infinite loops.
# Alternatively, the user may start with topography which always slopes to
# the ocean, doesn't have internal basins, and doesn't contain completely
# flat plateaus.
#
# Currently written for Cretaceous topography.
#
# slevis, feb 2003
#
#-----------------------------------------------------------------
# YOU NEED  : Makefile,topo2rdirc_sed.F90,rdirc.csh
# TO RUN    : rdirc.csh
# NOTE      : make sure "limits" on your machine are set appropriately
#           : if not set large enough, the program may not have enough
#             space/memory to run
#-----------------------------------------------------------------
#
#----------------------------------------------------------------------------
# specify input/output pathnames with enviromental variables set in this script 
#----------------------------------------------------------------------------

set INFILE  = <path/topography-bathymetry_file>
set CASE   = <casename>

#----------------------------------------------------------------------------
# use "sed" to insert pathnames into fortran code 
#----------------------------------------------------------------------------

cat >! pathname.sed << EOF
s#input_topo_data#$INFILE#
EOF
cp  topo2rdirc_sed.F90 topo2rdirc.F90 
sed -f pathname.sed topo2rdirc_sed.F90 >! topo2rdirc.F90

#----------------------------------------------------------------------------
#  compile and run 
#----------------------------------------------------------------------------
cp  $INFILE . 
make topo2rdirc
echo '' > fort.10
echo '' > fort.11
echo '' > fort.12
echo '' > fort.13
echo '' > fort.14
echo '' > fort.15
./topo2rdirc

#---------------------------------------------------------------
# output fort.10 and fort.11 will in working directory 
# cp fort.10 to original file to save 
mv fort.10 fort.10_$CASE # original direction file
mv fort.11 fort.11_$CASE # original loops file
mv fort.12 fort.12_$CASE # original internal basin file
mv fort.14 fort.14_$CASE # modified direction file
mv fort.13 fort.13_$CASE # modified direction file
mv fort.15 fort.15_$CASE # modified internal basin file

#----------------------------------------------------------------
#----------------------------------------------------------------------------


exit
